;; CBM.INC

; il file puo' essere incluso solo all'interno di GLOBAL.INC
.IFNDEF		_GLOBAL_INC_
.EXIT		"ERROR: This file cannot be included."
.ENDIF

.IFDEF	_CBM_INC_

CINIT		.EQU	$FF81		; initialize screen editor 
IOINIT		.EQU	$FF84		; (NO OP) initialize I/O devices
RAMTAS		.EQU	$FF87		; initialize RAM
RESTOR		.EQU	$FF8A		; (NO OP) restore default I/O vectors
VECTOR		.EQU	$FF8D		; (NO OP) read/set I/O vector table
SETMSG		.EQU	$FF90		; set Kernal message control flag
SECOND		.EQU	$FF93		; (NO OP) send secondary address after LISTEN
TKSA		.EQU	$FF96		; (NO OP) send secondary address after TALK
MEMTOP		.EQU	$FF99		; read/set top of memory pointer
MEMBOT		.EQU	$FF9C		; read/set bottom of memory pointer
SCNKEY		.EQU	$FF9F		; scan the keyboard
SETTMO		.EQU	$FFA2		; (NO OP) set time-out flag for serial bus
ACPTR		.EQU	$FFA5		; input byte from serial bus
CIOUT		.EQU	$FFA8		; output byte to serial bus
UNTLK		.EQU	$FFAB		; (NO OP) 'un-talk' command to serial bus
UNLSN		.EQU	$FFAE		; (NO OP) 'un-listen' command to serial bus
LISTEN		.EQU	$FFB1		; (NO OP) 'listen' command to serial bus
TALK		.EQU	$FFB4		; (NO OP) 'talk' command to serial bus
READST		.EQU	$FFB7		; read I/O status word
SETLFS		.EQU	$FFBA		; set logical file parameters
SETNAM		.EQU	$FFBD		; set filename parameters
FOPEN		.EQU	$FFC0		; open a logical file
FCLOSE		.EQU	$FFC3		; close a logical file
FSETIN		.EQU	$FFC6		; set file for input
FSETOUT		.EQU	$FFC9		; set file for output
FCLRCH		.EQU	$FFCC		; restore default devices
FCHRIN		.EQU	$FFCF		; input a character
FCHROUT		.EQU	$FFD2		; output a character
FLOAD		.EQU	$FFD5		; load file from device
FSAVE		.EQU	$FFD8		; save file to device
SETTIM		.EQU	$FFDB		; set software clock
RDTIM		.EQU	$FFDE		; fet software clock
CHKSTOP		.EQU	$FFE1		; check CTRL BREAK key
FGETIN		.EQU	$FFE4		; get a character
FCLALL		.EQU	$FFE7		; brute close all files
UDTIM		.EQU	$FFEA		; (NO OP) update the software clock
SCRORG		.EQU	$FFED		; get screen organitation
SCRPLOT		.EQU	$FFF0		; get/set current cursor position
GETIOBASE	.EQU	$FFF3		; get base address of I/O devices

;; non standard
IKEYBUF		.EQU	$FFF6		; insert codes into keyboard buffer
GOMON		.EQU	$FFF9

.ENDIF
