;;
;; Copyright (c) 2016 Marco Granati <mg@unet.bz>
;;
;; Permission to use, copy, modify, and distribute this software for any
;; purpose with or without fee is hereby granted, provided that the above
;; copyright notice and this permission notice appear in all copies.
;;
;; THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
;; WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
;; MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
;; ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
;; WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
;; ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
;; OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
;;

;; name: dpfpu.inc	
;; rev.: 2016/03/30
;; o.s. 65C816 version v1.0

.LIST on

; direct page for flotaing point unit
_DPFPU:	.SECTION page0, common, ref_only, offset 0	;FPU D.P.

MNTBITS		.EQU	(16*8)	; significand bits + guard bits
MANTSIZ		.EQU	16
FPSIZ		.EQU	12
FREGSIZ		.EQU	20

fpres		.DS	16	; temp. partial result
wftmp		.DW		; temp. word
stickyb		.DB		; sticky byte
sgncmp		.DB		; sign comparison: fac vs. arg

; floating Point accumulator (fac)
facm		.DS	16	; guard bits (32 bits)+significand (80 bits)
facexp		.DW		; fac biased exponent
facsgn		.DB		; fac mantissa sign
facst		.DB		; fac status
				; <7>: 1 if fac is invalid (nan or inf)
				; <6>: 1 if fac=inf (with <7>=1)   
				;      0 if fac=nan (with <7>=1)   
				; <6>: 1 if fac=0   (with <7>=0)

fexph		.DW		; fac unbiased exponent sign extension

; floating point operand (arg)
argm		.DS	14	; guard bits (32 bits)+significand (80 bits)
argexp		.DW		; arg biased exponent
argsgn		.DB		; arg mantissa sign
argst		.DB		; arg status
				; <7>: 1 if arg is invalid (nan or inf)
				; <6>: 1 if arg=inf (with <7>=1)   
				;      0 if arg=nan (with <7>=1)   
				; <6>: 1 if arg=0   (with <7>=0)
aexph		.DW		; arg unbiased exponent sign extension

mlp		LP
fptmp1		.DB
scexp		.DW
scsgn		.DB
		.DB
		
fpstr		.DS	32
tfl0		.EQU	fpstr
tfl1		.EQU	tfl0+16
tfl2		.EQU	tfl1+16
tfl3		.EQU	tfl2+16

	.ENDS
.LIST off
