
.LIST on
; ACIA page 0 local var's 
SERDP:	.SECTION page0, ref_only, offset aciap0
SERDP_START	.EQU	$

; acia 1 var's
aisr		.DB		; interrupt status register
acsr		.DB		; control status register
afr		.DB		; format register
aout		.DB		; XON/XOFF sending flag

; acia 2 var's
		.DS	4

;----------------------------------------------------------------------------

; acia 1 flag's
ahsk		.DB		; handshake flag
				; <7>: handshake on
				; <6>: hardware handshake (RTS,CTS)

apause		.DB		; local/remote pause flag		
				; <7>: remote pause (XOFF/RTS=1)
				; <6>: local pause (XON/CTS=1)

arxe		.DB		; rx data error flag		
				; <7>: rx error (data discarded)
				; <6>: rx buffer overflow
				; <5>: remote disconnession
				; <2>: framing error
				; <1>: parity error
				; <0>: overrun error

arem		.DB		; format register or'ing for remote pause

; acia 2 flag's
		.DS	4

;----------------------------------------------------------------------------

; acia 1 control line
adsrt		.DB		; DSR,DCD,CTS transition status
				; <7>: DSRT, <6>: CTST, <5>: DCDT

adsrl		.DB		; DSR,DCD,CTS level status
				; <7>: DSRL, <6>: CTSL, <5>: DCDL
				
amask		.DB		; and mask for check remote disconnession
				; <7>: check DSR line - <5>: check DCD line

aptr		.DB		; save acia pointer while ISR

; acia 2 control line
		.DS	3
		.DB
	
;----------------------------------------------------------------------------

; buffer pointers
rxptr		.DW		; pointer to rx buffer
txptr		.DW		; pointer to tx buffer
rxptr2		.DW
txptr2		.DW

;----------------------------------------------------------------------------

; tail pointers
aicnt		.DW		; size of input tail queue 
aitail		.DW		; pointer to input tail queue

SERDP_SIZ	.EQU	($-FSTMP_START)
	.ENDS
.LIST off
