;----------------------------------------------------------
; DIRP02.ASM
; PROGETTO: B1601
;
; Variabili in Direct Page $01
;----------------------------------------------------------

; sezione COMMON -- questo permette di includere il file in piu' file


.LIST on

KBDBUFLEN	.EQU	96		; dimensione buffer di tastiera

DIRP01:	.SECTION page0, ref_only, common	;Direct-Page 01

	.ABSOLUTE		;; inizia sempre da $00
	.ORG		0x00

	
KbdBuf		.DS	KBDBUFLEN	; buffer della tastiera
KbdITail	.DB			; coda buffer tastiera
KbdIHead	.DB			; testa buffer tastiera
KbdCnt		.DB			; numero bytes nel buffer
KbdShift	.DB
KbdFlag		.DB
KbdToggle	.DB
KbdSt		.DB			; status tastiera dopo reset
PS2Ctl		.DB			; flag controller PS2 keyboard

LCDFlag		.DB
LCDTmp		.DB
LCDVal		.DW

VBBFlag		.DB		; flag video board
VBBRam		.DB		; flag video RAM

ScnLinTmp	.DB
ScnChBase	.DB		; base video ram VDC
ScnAttBase	.DB		; base ram attributi VDC
ScnCursMode	.DB		; VDC cursore default
ScnSaveAttr	.DB
ScnInsert	.DB
ScnAutoIns	.DB		; bit 7 -> autoins - bit 6 -> modo input
ScnScroll	.DB
ScnMaxRow	.DB		; max. righe finestra (-1)
ScnMaxCols	.DB		; max. colonne finestra (-1)

ScnMapTabs1	.DS	10
ScnMapTabs2	.DS	4
	
ScnPtr		.DW		; puntatore video ram linea corrente
		.DB

ScnFiltLen	.DB		; lunghezza set caratteri filtro

ScnAtPtr	.DW		; puntatore attributi ram linea corrente
		.DB

ScnTmpx		.DB		; temporaneo: durante put char
		
ScnTop		.DB		; riga superiore finestra
ScnLeft		.DB		; colonna sinistra finestra
ScnBottom	.DB		; riga inferiore finestra
ScnRight	.DB		; colonna destra finestra
ScnAttr		.DB		; attributo default
ScnAttr2	.DB		; attributo alternativo
ScnRow		.DB		; riga cursore
ScnCol		.DB		; colonna cursore
ScnRowStart	.DB		; riga di start input 
ScnInput	.DB		; riga di fine input 
ScnColStart	.DB		; colonna di start input 
ScnSaveX	.DB
ScnSaveY	.DB
ScnTmpL		.DB
ScnTmpH		.DB
ScnSaveRow	.DB
ScnSaveCol	.DB
ScnCurChr	.DB
ScnLstChr	.DB
ScnCR		.DB
ScnPrm		.DW		; puntatore long utilizzato da print imm
		.DB		; banco puntatore ScnPrm
ScnMode		.DB		; flag modo schermo

ScnPtr1		LP

ScnDefCol	.DB		; default foreground color

ScnPtr2		LP

ScnDefBkgCol	.DB		; default background color
ScnInpRow	.DB		; modo input line: riga start input
ScnInpCol	.DB		; modo input line: colonna start input
ScnLstRow	.DB		; modo input line: riga stop input
ScnLstCol	.DB		; modo input line: colonna stop input
ScnFlag		.DB		; Bit 7: input line - Bit 6: input riga unica
ScnMask		.DB		; flag tasti funzione editor di linea
ScnFilt		.DB		; filtro tasti editor di linea
ScnCntrl	.DB		; flag ASCII/CONTROL
;DflTxtIn	.DB		; device di default text input 
;DflTxtOut	.DB		; device di default text output
	
SCNCLRLEN	.EQU	($ - ScnLinTmp - 1)

;SCNCLRLEN	.EQU	(DflTxtOut - ScnLinTmp)

; variabili monitor
SMAddrL		.DB	; address low/high
SMAddrH		.DB
SMAddrK		.DB	; address bank
SMFlag32	.DB	; flag parametro 32 bit
SMTmpL		.DB	; temp. low/high
SMTmpH		.DB
SMTmpK		.DB	; temp. bank
SMTmpKK		.DB	; high byte param. 32 bit
SMSizeL		.DB	; size low/high
SMSizeH		.DB
SMSizeK		.DB	; size bank
SMXAddrL	.DB	; address low/high XM
SMXAddrH	.DB
SMXAddrK	.DB	; address bank XM
SMbndx		.DB	; indice input buffer
SMnprm		.DB	; numero parametri riga di comando
SMdumb		.DB
SMkr		.DB
SMpc		.DW
SMsr		.DB
SMbr		.DB
SMdp		.DW
SMac		.DW
SMxr		.DW
SMyr		.DW
SMsp		.DW

SMAuxL		.DB
SMAuxH		.DB

asmlong		.DB	; flag for CPU in 16 mode
			; <7> -> A/M in 16 bit mode
			; <6> -> X/Y in 16 bit mode
asmcpu		.DB	; <7> -> 8 bit family
			; <6> -> 65C02 cmos version

SMctx		.DB	; context (if = $00 no quit command)
SMrsm		LP	; long pointer to resume caller context

rtcadr		.DB	; rtc internal ram address
rtcbnk		.DB	; RTC internal bank ram
cmdlin		.DB	;
SMesc		.DB

SMXTmp:		.DS	26	; 26 bytes tmp

SMTmp2		.EQU	SMXTmp
SMTmp3		.EQU	SMXTmp+2
SMdwTmp1	.EQU	SMXTmp+4
SMdwTmp2	.EQU	SMXTmp+8
SMFsrc		.EQU	SMXTmp+12	; source bank for flash update
SMFflag		.EQU	SMXTmp+13	; flag file for flash update
SMXPos2		.EQU	SMXTmp+14
SMYPos2		.EQU	SMXTmp+15
SMXPos3		.EQU	SMXTmp+16
SMYPos3		.EQU	SMXTmp+17
;SMAuxL		.EQU	SMXTmp+18
;SMAuxH		.EQU	SMXTmp+19
SMXPos		.EQU	SMXTmp+20
SMYPos		.EQU	SMXTmp+21
SMdwTmp3	.EQU	SMXTmp+22

atcmd		.EQU	SMXTmp		; save @ command
atnum		.EQU	SMXTmp+1	; @ command index
atflag		.EQU	SMXTmp+2	; @ L,S,V,R,W start address flag
atbnk		.EQU	SMXTmp+3	; @ L,S,V,R,W bank
atstr		.EQU	SMXTmp+4	; @ command string start (word)
atstart		.EQU	SMXTmp+6	; @ L,S,V,R,W start address (word)
atend		.EQU	SMXTmp+8	; @ S,W end address (word)
atbuf		.EQU	SMXTmp+10	; @ local buffer pointer (word)
atipb		.EQU	SMXTmp+12	; @ bank of input buffer
atdir		.EQU	SMXTmp+13	; @ load dir flag
atptr		.EQU	SMXTmp+14	; @ load dir pointer (word)
atsiz		.EQU	SMXTmp+16	; @ buffer size (word) 
atlp		.EQU	SMXTmp+19	; @ long pointer
atsa		.EQU	SMXTmp+22	; @ sa

btmpx		.EQU	SMXTmp		; asc2bin conversion
brtcsec		.EQU	SMXTmp+1
brtcmin		.EQU	SMXTmp+2
brtchour	.EQU	SMXTmp+3
brtcday		.EQU	SMXTmp+4
brtcmonth	.EQU	SMXTmp+5
brtcyear	.EQU	SMXTmp+6
brtcct		.EQU	SMXTmp+7


	.RELATIVE

	.ENDS

.LIST off
