;;
;; Copyright (c) 2016 Marco Granati <mg@unet.bz>
;;
;; Permission to use, copy, modify, and distribute this software for any
;; purpose with or without fee is hereby granted, provided that the above
;; copyright notice and this permission notice appear in all copies.
;;
;; THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
;; WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
;; MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
;; ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
;; WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
;; ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
;; OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
;;

;; name: dpfpu.inc	
;; rev.: 2016/03/30
;; o.s. 65C816 version v1.0

;; floating point unit implementation

	.INCLUDE inc\global.inc	
	.INCLUDE inc\dpfpu.inc
	
.LIST on

EBIAS		.EQU	$3FFF		; exponent bias
INFEXP		.EQU	$7FFF		; inf/nan biased exponent
INFSND		.EQU	$8000		; inf high word significand
NANSND		.EQU	$C000		; nan high word significand
MAXEXP		.EQU	$7FFE		; max. biased exponent
MINEXP		.EQU	$0001		; min. biased exponent

;BIASBYTE	.EQU 	(EXPBIAS + 7)	; bias BYTE (8 bit)
;BIASWORD	.EQU 	(BIASBYTE + 8)	; bias WORD (16 bit)
;BIASDWORD	.EQU 	(BIASWORD + 16)	; bias DWORD (32 bit)
;BIASQWORD	.EQU 	(BIASDWORD + 32); bias QWORD (64 bit)
;MAXPEXP		.EQU	EXPBIAS		; massimo esponente positivo
;MINNEXP		.EQU	-(EXPBIAS)	; minimo esponente negativo
;LOG2H		.EQU	19728		; LG(2) * $10000
;EXP10LIM	.EQU	4999		; limite esponente in FStr2Float
;MAXDIGITS	.EQU	19		; max. numero cifre decimali
;MAXINTDGTS	.EQU	20		; max. cifre unsigned int
;MAXDECSTR	.EQU	127
;MAXFEXP		.EQU	7		; max. esp. dec. negativo formato G/F
;MAXFDEC		.EQU	36		; max. esp. decimale positivo form. F

MAXBSHIFT	.EQU	-MNTBITS + 1	; max. shift mant.

;---------------------------------------------------------------------------
; code segment -- bank $F8
;---------------------------------------------------------------------------

	.CODEF8
	.PUBLIC fpmult, fpdiv, ldfac, ldarg, fround
	
	.LONGA	off
	.LONGI	off

	;.CODEF8
	.EXTERN _UI2Str, _iSMult16, Byte2Hex

fptest:
	
	phd
	pea	#P0FPU
	pld
	ACC16
	pha
	ACC08
	jmp	?x1
	;lda	#<fce0
	;ldy	#>fce0
	
	;lda	#<?200
	;ldy	#>?200
	lda	#<?b10
	ldy	#>?b10
	jsr	mvc2a
	lda	#<?220
	ldy	#>?220
	lda	#<?b20
	ldy	#>?b20
	jsr	mvc2f
	jsr	fpmult

	lda	#<fce0
	ldy	#>fce0
	jsr	mvc2f
	lda	#<?b40
	ldy	#>?b40
	jsr	mvc2a
	jsr	fpsub
	
?x1:
	ACC16
	pla
	ACC08
	;jsr	scale10
	jsr	testq2
	;jsr	testcr
	pld
	brk

?b10:	.DB	$00,$00,$b7,$00,$00,$00,$00,$00,$0F,$00,$00,$E0,$ff,$3f	; 3.3645199532e-4951
?b20:	.DB	$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$3f ; 3.36210314311209350500e-4932
;?b10:	.DB	$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$3f ; 3.36210314311209350500e-4932
?b30:	.DB	$88,$0A,$68,$31,$97,$A5,$B4,$36,$41,$5F,$70,$89,$E1,$3F	; 1e-9
?b40:	.DB	$5C,$96,$D2,$DA,$04,$7D,$C1,$25,$02,$00,$00,$80,$FF,$3F	; 1+1e-9
	
	lda	#$EA
	ldx	#$1F
?00:	sta	fpstr,x
	dex
	bpl	?00
	jsr	int2dec
	bra	?20
	
	ldx	#10
?02:	lda	>?110,x
	sta	facm,x
	dex
	bpl	?02
	stz	facm+10
	stz	facm+11
	lda	#$50
	sta	$ff
	lda	#$FF
	sta	$fe
?04:	jsr	?80
	jsr	?60
	bit	$fe
	bpl	?06
	jsr	?70
	stz	$fe
	bra	?10
?06:	lda	#$ff
	sta	$fe
?10:	ldx	#0
	ldy	$ff
?12:	lda	argm,x
	sta	$3f00,y
	iny
	inx
	cpx	#11
	bcc	?12
	iny
	iny
	iny
	iny
	iny
	sty	$ff
	cpy	#$B0
	bcc	?04
?20:	pld
	brk	

?60:	ACC16
	lda	facm
	sta	argm
	lda	facm+2
	sta	argm+2
	lda	facm+4
	sta	argm+4
	lda	facm+6
	sta	argm+6
	lda	facm+8
	sta	argm+8
	lda	facm+10
	sta	argm+10
	ACC08
	rts
?70:	ACC16
	sec
	ldx	#0
	txa
	sbc	argm
	sta	argm
	txa
	sbc	argm+2
	sta	argm+2
	txa
	sbc	argm+4
	sta	argm+4
	txa
	sbc	argm+6
	sta	argm+6
	txa
	sbc	argm+8
	sta	argm+8
	txa
	sbc	argm+10
	sta	argm+10
	ACC08
	rts
?80:	ACC16	
	lda	facm
	sta	fpres
	lda	facm+2
	sta	fpres+2
	lda	facm+4
	sta	fpres+4
	lda	facm+6
	sta	fpres+6
	lda	facm+8
	sta	fpres+8
	jsr	?90
	jsr	?90		; x 4
	clc
	lda	facm
	adc	fpres
	sta	fpres
	lda	facm+2
	adc	fpres+2
	sta	fpres+2
	lda	facm+4
	adc	fpres+4
	sta	fpres+4
	lda	facm+6
	adc	fpres+6
	sta	fpres+6
	lda	facm+8
	adc	fpres+8
	sta	fpres+8
	jsr	?90
	lda	fpres
	sta	facm
	lda	fpres+2
	sta	facm+2
	lda	fpres+4
	sta	facm+4
	lda	fpres+6
	sta	facm+6
	lda	fpres+8
	sta	facm+8
	stz	facm+10
	ACC08
	rts
?90:	asl	fpres
	rol	fpres+2
	rol	fpres+4
	rol	fpres+6
	rol	fpres+8
	rts
	
?100:	.DB	$00,$00,$00,$00,$00,$00,$00,$04,$BF,$C9,$1B,$8E,$34,$40 ; 1E16
?110:	.DB	$00, $00, $64, $A7, $B3, $B6, $E0, $0D, $00, $00, $00, $00	; +1E18	

?200:	.DB	$cc,$cc,$cc,$cc,$cc,$cc,$cc,$cc,$cc,$cc,$cc,$0c,$01,$00 ; 3.36210314311209350500e-4942
?210:	.DB	$00,$00,$00,$00,$01,$00,$00,$00,$00,$00,$00,$00,$01,$00	; 3.3645199532e-4951
?220:	.DB	$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$7f,$01,$00 ; 3.36210314311209350500e-4932

fcqc:	.DB	$7E,$52,$EE,$88,$16,$E1,$24,$10,$61,$CA,$C8,$88,$00,$40	; 2.1372552822 (c)
fcqb:	.DB	$E0,$A6,$89,$F6,$6D,$D3,$A3,$DA,$FC,$07,$CD,$9A,$01,$40	; 4.8375282229 (b)
fcqa:	.DB	$19,$49,$14,$F8,$D0,$67,$43,$E3,$69,$37,$AA,$A2,$00,$40	; 2.5416391882 (a)

fcca:	.DB	$00,$00,$00,$00,$37,$DE,$1C,$F4,$85,$85,$1C,$BD,$FF,$3F	; A=1.4774329094
fccb:	.DB	$00,$00,$00,$00,$39,$FC,$90,$A4,$54,$1C,$68,$D7,$FE,$3F	; B=0.8414323527
fccc:	.DB	$00,$00,$00,$00,$31,$3F,$0F,$23,$78,$8B,$1D,$BD,$FE,$3F	; C=0.7387320679

fccn:	.DB	$00,$00,$00,$00,$D1,$83,$D3,$9D,$32,$F3,$04,$B5,$04,$40	; A4=45.2548339756803022511987494
	.DB	$00,$00,$00,$00,$98,$00,$B7,$08,$63,$A3,$47,$C0,$06,$40	; A3=192.2798368355061050458134625
	.DB	$00,$00,$00,$00,$65,$9F,$70,$E5,$1C,$BA,$54,$EE,$05,$40	; A2=119.1654824285581628956914143
	.DB	$00,$00,$00,$00,$20,$00,$A8,$13,$94,$86,$EB,$D6,$02,$40	; A1=13.43250139086239872172837314
	.DB	$00,$00,$00,$00,$6D,$69,$E9,$AA,$1F,$FC,$8A,$A7,$FC,$3F	; A0=0.1636161226585754240958355063

fccd:	.DB	$00,$00,$00,$00,$4A,$05,$D9,$76,$30,$03,$F1,$EC,$02,$40	; B4=14.80884093219134573786480845
	.DB	$00,$00,$00,$00,$C8,$A8,$C0,$42,$01,$AE,$F8,$97,$06,$40	; B3=151.9714051044435648658557668
	.DB	$00,$00,$00,$00,$85,$73,$96,$08,$54,$83,$86,$A8,$06,$40	; B2=168.5254414101568283957668343
	.DB	$00,$00,$00,$00,$F7,$A7,$1B,$16,$4F,$5E,$F6,$87,$04,$40	; B1=33.9905941350215598754191872
	.DB	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$80,$FF,$3F	; B0=1

fc01:	.DB	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$98,$FE,$3F	; 0.59375
fc02:	.DB	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$D8,$FE,$3F	; 0.84375 0,84375
fc03:	.DB	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$80,$FC,$3F	; 0.125
fc04:	.DB	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$9C,$FE,$3F	; 0.609375
fc05:	.DB	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$80,$FE,$3F	; 0.5
fc06:	.DB	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$80,$FD,$3F	; 0.25
fc07:	.DB	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$C0,$FE,$3F	; 0.75

fcqa1:	.DB	$00,$00,$00,$00,$F8,$6F,$60,$5B,$7C,$8C,$BA,$AF,$FD,$3F	; A1=0.343220129185
fcqa0:	.DB	$00,$00,$00,$00,$B3,$76,$6E,$E6,$E6,$13,$52,$E6,$FE,$3F	; A0=0.899689906952
fcqb0:	.DB	$00,$00,$00,$00,$81,$17,$23,$D0,$C7,$70,$63,$BA,$FD,$3F	; B =0.364039921180
fcqc0:	.DB	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$80,$FE,$3F	; C =0.5

; D64D51E0DB1C5BB8 4B259E4B2788

; 2.1372552822 (c) 119194C22049C22D F1DCA4FCBC39 88EE527E5E1C
; 4.8375282229     359A0FF9B547A6DB ED134DC17D2E F689A6E0BE97
; 2.5416391882     45546ED3C686CFA1 F0289232818E F814491940C7
; sqrt(2)          6A09E667F3BCC908 B2FB1366EA95  3FFF B504F333F9DE6484 597D89B3754A
;                  B2133770C88D5BAD 5ACAEF098B5F
;                  BB67AE8584CAA73B 25742D7078E0
;0.84780286075354169048866768149865 cbrt(0.609375)
; 0.86602540378443864676372317075294 (sqrt(0.75)
; approx: a - (b/(x+c)) ( 0.5<=x<1) 
testq:
	lda	#<fc05
	ldy	#>fc05
	jsr	mvc2f

	jsr	mvf2t1		; to temp 1
	lda	#<fcqc		; c
	ldy	#>fcqc
	jsr	mvc2a
	jsr	fpadd		; x+c
	lda	#<fcqb		; b
	ldy	#>fcqb
	jsr	mvc2a
	jsr	fpdiv		; b/(x+c)
	lda	#<fcqa		; a
	ldy	#>fcqa
	jsr	mvc2a
	jsr	fpsub		; a-b/(x+c) circa 12 bit
	
	jsr	mvf2t
	jsr	mvt12a		; 1 iterazione circa 24 bit
	jsr	fpdiv
	jsr	mvt2a
	jsr	fpadd
	dec	facexp

	jsr	mvf2t
	jsr	mvt12a		; 2 iterazione 48 bit
	jsr	fpdiv
	jsr	mvt2a
	jsr	fpadd
	dec	facexp

	jsr	mvf2t
	jsr	mvt12a		; 3 iterazione 96 bits
				; sufficiente 3 it
	jsr	fpdiv
	jsr	mvt2a
	jsr	fpadd
	dec	facexp
	
	rts


; approx: a1*x +a0 - (b0/(x+c0)) ( 0.25<=x<1) 
testq2:
	lda	#<fc07
	ldy	#>fc07
	jsr	mvc2f

	jsr	starttm
	
	jsr	mvf2t1		; to temp 2
	lda	#<fcqc0		; c0
	ldy	#>fcqc0
	jsr	mvc2a
	jsr	fpadd		; x+c
	lda	#<fcqb0		; b0
	ldy	#>fcqb0
	jsr	mvc2a
	jsr	fpdiv		; b/(x+c)
	lda	#<fcqa0		; a0
	ldy	#>fcqa0
	jsr	mvc2a
	jsr	fpsub		; a-b/(x+c)
	jsr	mvf2t
	jsr	mvt12a
	lda	#<fcqa1		; a1
	ldy	#>fcqa1
	jsr	mvc2f
	jsr	fpmult
	jsr	mvt2a
	nop
	nop
	jsr	fpadd		; 13 bit 6ms
	
	jsr	sqrtnew
	jsr	sqrtnew
	jsr	sqrtnew		; 96 bit 17ms
	
	jsr	rdtm
	
	rts

; newton iteration for sqrt
sqrtnew:
	jsr	mvf2t
	jsr	mvt12a
	jsr	fpdiv
	jsr	mvt2a
	jsr	fpadd
	dec	facexp
	rts
	
; approx: a - (b/(x+c)) ( 1/8<=x<1) 
testcr:
	lda	#<fc04
	ldy	#>fc04
	jsr	mvc2f
	jsr	mvf2t1		; temp 1=x0

	jsr	starttm
	;bra	?10
	
	; metodo rational 4+4
	lda	#<fccn
	ldy	#>fccn
	jsr	poly
	jsr	mvf2t2		; temp 2 = num
	lda	#<fccd
	ldy	#>fccd
	jsr	poly		; fac=den
	jsr	mvt22a		; arg=num
	jsr	fpdiv		; 24ms (21/23 bit)

	jsr	cbrnew
	jsr	cbrnew		; total 40ms
	
	jsr	rdtm
	rts

?10:	; CONVIENE QUESTA
	; rational 1+1	
	jsr	mvf2t1		; to temp 1
	lda	#<fccc		; c
	ldy	#>fccc
	jsr	mvc2a
	jsr	fpadd		; x+c
	lda	#<fccb		; b
	ldy	#>fccb
	jsr	mvc2a
	jsr	fpdiv		; b/(x+c)
	lda	#<fcca		; a
	ldy	#>fcca
	jsr	mvc2a
	jsr	fpsub		; a-b/(x+c) circa 8 bit

	jsr	cbrnew

	; halley 1: 21 bit
	jsr	halley	
	; halley 2: 64 bit
	jsr	halley
	; newton: 128 bit	; total 36ms
	;jsr	cbrnew
	jsr	rdtm
	rts
	
	; 1 iterazione circa 16 bit
	jsr	cbrnew
	; 2 iterazione circa 32 bit
	jsr	cbrnew
	; 3 iterazione circa 64 bit
	jsr	cbrnew
	; 4 iterazione circa 128 bit ; total 27ms 
	jsr	cbrnew

	jsr	rdtm
	rts

cbrnew:
	jsr	mvf2t		; to temp 0
	jsr	mvftoa		; to arg
	jsr	fpmult		; x*x
	jsr	mvt12a
	jsr	fpdiv
	jsr	mvt2a		; arg=x
	inc	argexp		; x*2
	jsr	fpadd
	jsr	mvftoa		; arg=x
	ACC16
	lda	#$4000		; fac=3
	sta	facexp
	lda	#$C000
	sta	facm+10
	stz	facm+8
	stz	facm+6
	stz	facm+4
	stz	facm+2
	stz	facm
	stz	facsgn
	ACC08
	jmp	fpdiv		; x/3

halley:
	jsr	mvf2t		; to temp 0
	jsr	mvftoa		; to arg
	jsr	fpmult		; x*x
	jsr	mvt2a
	jsr	fpmult		; x*x*x
	jsr	mvf2t2		; temp2 = X^3
	inc	facexp		; 2x^3
	jsr	mvt12a		; x0
	jsr	fpadd
	jsr	mvf2t3		; temp3
	jsr	mvt22f		; x^3
	jsr	mvt12a		; x0
	inc	argexp		; x0*2
	jsr	fpadd
	jsr	mvftoa		; to arg
	jsr	mvt32f
	jsr	fpdiv
	jsr	mvt2a
	jmp	fpmult

poly:
	jsr	mvc2f
	jsr	poly1
	jsr	poly1
	jsr	poly1
poly1:
	jsr	mvt12a		; arg=x0
	jsr	fpmult
	ACC16CLC
	lda	mlp
	adc	#FREGSIZ-2
	sta	mlp
	ACC08
	jsr	_mvc2a
	jmp	fpadd
	
starttm:
	lda	#$20		; T2 count PHI2 pulses
	tsb	VIA0+VIAACR
	lda	#$FF
	sta	VIA0+VIAT2CL
	sta	VIA0+VIAT2CH
	rts

rdtm:
	ldx	#0
	lda	VIA0+VIAIFR
	bit	#T2IFRB
	beq	?10
	dex
?10:	lda	VIA0+VIAT2CH
	xba
	lda	VIA0+VIAT2CL
	ACC16
	eor 	#$FFFF
	inc	a
	ACC08
	rts

testdp:
	lda	#<fce1
	ldy	#>fce1
	jsr	mvc2f
	ACC16
	lda	facm+5
	sta	fpres
	lda	facm+7
	sta	fpres+2
	lda	facm+9
	sta	fpres+4
	lda	facm+11
	sta	fpres+6
	ACC08
	ldx	#fpres
	ldy	#$FD
	jsr	shrbit
	ACC16
	lda	fpres+6
	and	#$000F
	sta	fpres+6
	lda	facexp
	sec
	sbc	#EBIAS
	clc
	adc	#$03FF
	asl	a
	asl	a
	asl	a
	asl	a
	ora	fpres+6
	sta	fpres+6
	ACC08
	ldy	#$FF
	ldx	#fpres
	jsr	shrbit
	lda	#$80
	trb	fpres+7
	ACC16
	sec
	lda	#$30DA
	sbc	fpres
	sta	fpres
	lda	#$E7DE
	sbc	fpres+2
	sta	fpres+2
	lda	#$EC85
	sbc	fpres+4
	sta	fpres+4
	lda	#$5FE6
	sbc	fpres+6
	sta	fpres+6
	ACC08
	rts
	
;---------------------------------------------------------------------------
; addition & subtraction implementation
;---------------------------------------------------------------------------

;	the smallest number will be aligned shifting to right the mantissa and
;	incrementing the exponent until is equal to exponent of the greatest
;	number. The smallest number will be subtracted to the greatest, and 

; fpsub: subtract fac from arg and store result in fac
;
;	fac = arg - fac
;
; implementation note:
;	change sign to fac and execute addition
;-----
fpsub:
;-----
	lda	facsgn		; change sign to fac and execute addition
	eor	#$FF
	sta	facsgn
	
; fpadd: add fac to arg and store result in fac
;
;	fac = arg + fac
;
; implementation note:
;	change sign to fac and execute addition
;-----
fpadd:
;-----
	jsr	addtst
	ldx	#argm		; pointer to arg mantissa
	ldy	#0
	ACC16
	sec
	lda	argexp		; now compute right shift count's to...
	sbc	facexp		; ...align mantissa's
	beq	?30		; already aligned (same exponent)
	bcc	?10		; arg < fac so shift right arg mantissa...
				; ...and result have same exp&sign of fac...
	
	; fac > arg so shift right fac mantissa - here CF=1, Y=0
	sta	wftmp		; positive shift's count
	lda	argexp		; result have same exp of arg...
	sta	facexp
	ldx	argsgn		; ...and same sign of arg
	stx	facsgn
	tya			; remember here CF=1
	sbc	wftmp		; negative shift's count
	ldx	#facm		; pointer to fac mantissa

?10:	; right shift mantissa pointed by X - here C=negative shift's count
	cmp	#MAXBSHIFT	; shift out whole significand + guard bits?
	bcs	?15		; no
	stz	<0,x		; clear mantissa and guard bits
	stz	<2,x
	stz	<4,x
	stz	<6,x
	stz	<8,x
	stz	<10,x
	bra	?30		; go to add/sub
	
?15:	ACC08			; A=negative shift's count
	cmp	#$F9		; N=1,CF=0 if $79<=A<$F9, CF=1 if A>=$F9
	bpl	?20		; less of 8 bit to shift
	jsr	shrm		; shift right byte at byte (CF=0)
	bra	?25		; go to add/sub
?20:	tay			; Y=negative shift's count
	jsr	shrbit		; shift right bit at bit (CF=1)
?25:	ACC16

	; add/sub aligned mantissa's
?30:	ldy	sgncmp		; fac & arg have same sign?
	bpl	?40		; yes, so add mantissa's

; subm - subtract fac mantissa from arg mantissa or vice versa	
;
; on entry: X=mantissa pointer (pssibly to shifted operand)
;
; note:
;	always subtract the smallest operand from the greatest one,
;	except in the case that none of the operands has been shifted

	ldy	#facm
	cpx	#argm
	beq	?35		; mantissa_fac - mantissa_arg
	ldy	#argm		; mantissa_arg - mantissa_fac
?35:	sec
	lda	P0FPU,y
	sbc	<0,x
	sta	facm
	lda	P0FPU+2,y
	sbc	<2,x
	sta	facm+2
	lda	P0FPU+4,y
	sbc	<4,x
	sta	facm+4
	lda	P0FPU+6,y
	sbc	<6,x
	sta	facm+6
	lda	P0FPU+8,y
	sbc	<8,x
	sta	facm+8
	lda	P0FPU+10,y
	sbc	<10,x
	sta	facm+10
	ACC08
	bcs	normfac		; no borrow -- normalize fac
	
	; a borrow mean that result change sign so we should negate fac
	; this can happen just when operands have same exponent
	; the subtraction above never can give both CF=0 and a null result
	; so negation never can return ZF=1 (carry from msb)
	jsr	negfac		; negate fac because result change sign
	bra	normfac		; normalize fac because  
	
?40:	clc			; add fac & arg mantissa's with guard bits
	ACC16
	lda	facm
	adc	argm
	sta	facm
	lda	facm+2
	adc	argm+2
	sta	facm+2
	lda	facm+4
	adc	argm+4
	sta	facm+4
	lda	facm+6
	adc	argm+6
	sta	facm+6
	lda	facm+8
	adc	argm+8
	sta	facm+8
	lda	facm+10
	adc	argm+10
	sta	facm+10
	bcc	normfac
	
	; the sum generate a carry	

; addcf - add carry to fac
;-----
addcf:
;-----
	ACC16
	lda	facexp
	inc	a		; increment exponent
	cmp	#INFEXP
	bcs	fldinf		; set fac=inf
	sta	facexp
	sec			; msb=1
	ror	facm+10		; shift right mantissa
	ror	facm+8
	ror	facm+6
	ror	facm+4
	ror	facm+2
	ror	facm	
	ACC08
	;bcc	?10
	ror	stickyb
	clc
?10:	rts

fldnan:
	ACC16
	lda	#NANSND
	ldx	#$80		; nan flag
	bra	fldinf1
fldinf:
	ACC16
	lda	#INFSND
	ldx	#$C0		; inf flag
fldinf1:
	sta	facm+10
	lda	#INFEXP
	sta	facexp
	stz	facm+8
	stz	facm+6
	stz	facm+4
	stz	facm+2
	stz	facm
	ACC08
	stz	stickyb
	stx	facst
	sec			; invalid result
	rts

normfac:
	ACC16
	lda	facexp
	beq	?70		; fac=0
	dec	a		; exp=exp-1
	beq	?60		; fac have minimum biased exponent (1)
	sec
	ldy	#MANTSIZ
?10:	ldx	facm+11
	bne	?40
	sbc	#8
	bcc	?20
	ldx	facm+10
	stx	facm+11	
	ldx	facm+9
	stx	facm+10
	ldx	facm+8
	stx	facm+9
	ldx	facm+7
	stx	facm+8
	ldx	facm+6
	stx	facm+7
	ldx	facm+5
	stx	facm+6
	ldx	facm+4
	stx	facm+5
	ldx	facm+3
	stx	facm+4
	ldx	facm+2
	stx	facm+3
	ldx	facm+1
	stx	facm+2
	ldx	facm
	stx	facm+1
	ldx	#0
	stx	facm
	dey
	bne	?10
	stz	facexp
	bra	?65
?20:	adc	#8
	inc	a
?30:	dec	a
	beq	?50		; can't shift more
	asl	facm
	rol	facm+2
	rol	facm+4
	rol	facm+6
	rol	facm+8
	rol	facm+10
?40:	;nop	
	bpl	?30
?50:	inc	a
	sta	facexp
	cmp	#INFEXP
	bcs	?80
?60:	lda	facm
	ora	facm+2
	ora	facm+4
	ora	facm+6
	ora	facm+8
	ora	facm+10
	bne	?70
	sta	facexp
?65:	ldx	#$40
	stx	facst
?70:	ACC08
	clc
	rts

?80:	ACC08
	jmp	fldinf

; scale to a power of 10
; C=signed integer
scale10:
	sec
	bit	facst		; valid fac?
	bmi	?25		; no
	bvs	?20		; fac=0
	ACC16
	cmp	#0
	beq	?18		; scaling exponent=0 so exit
	sta	scexp		; scaling exponent
	ldx	#0
	ldy	scexp+1		; test sign
	bpl	?05		; positive exponent
	txa			; change sign
	dex
	sec
	sbc	scexp
	sta	scexp
?05:	stx	scsgn		; store sign
?08:	cmp	#4096		; max. scale factor
	ACC08
	bcc	?30
	lda	#<fce4096
	ldy	#>fce4096
	bit	scsgn
	bmi	?10
	jsr	fcmult
	bcs	?25
	bcc	?15
?10:	jsr	fcdiv
	bcs	?25
	bit	facst		; if fac=0 exit
	bvs	?25
?15:	ACC16
	sec
	lda	scexp
	sbc	#4096
	sta	scexp
	bne	?08
?18:	ACC08
?20:	clc
?25:	rts
?30:	jsr	mvf2t
	lda	scexp
	and	#7
	asl	a
	tax
	lda	>fcaddr+1,x
	tay
	lda	>fcaddr,x
	jsr	mvc2f
	CPU16
	lda	#!fce8
	sta	mlp
	lda	scexp
	lsr	a
	lsr	a
	lsr	a
	beq	?45
?35:	lsr	a
	bcc	?40
	sta	scexp
	CPU08
	jsr	fcmultp
	bcc	?38
	bit	scsgn
	bpl	?25		; inf
	jmp	fldz		; 0
	;bcs	?25
?38:	CPU16
	lda	scexp
?40:	tax	
	lda	mlp
	adc	#FCSIZ
	sta	mlp
	txa
	bne	?35
?45:	CPU08
	jsr	mvt2a
	bit	scsgn
	bmi	fpdiv
	bra	fpmult

; mult with costant at address AY
fcmult:
	jsr	mvc2a		; load arg
	bra	fpmult

; mult with costant at address mlp
fcmultp:
	jsr	_mvc2a

fpmult:
	;jsr	multst
	clc
	jsr	adjexp
	ACC16
	stz	fpres
	stz	fpres+2
	stz	fpres+4
	stz	fpres+6
	stz	fpres+8
	stz	fpres+10
	ACC08
	jsr	mult
	lda	stickyb
	sta	$b0
	bra	movfpr

; reverse division fac/const (address AY)
fcdiv:
	xba			; save A
	jsr	mvftoa
	xba			; restore A
	jsr	mvc2f

fpdiv:
	jsr	divtst
	;jsr	fround		; ???
	sec
	jsr	adjexp
	jsr	div
	
; move result to fac	
movfpr:
	ACC16
	lda	fpres
	sta	facm
	lda	fpres+2
	sta	facm+2
	lda	fpres+4
	sta	facm+4
	lda	fpres+6
	sta	facm+6
	lda	fpres+8
	sta	facm+8
	lda	fpres+10
	sta	facm+10
	ACC08
	lda	fexph		; operation involved subnormal?
	bne	?10		; yes
	jmp	normfac		; normalize fac
?10:	ldx	#facm		; now should shift to right fac because subn.
	cmp	#$F9		; N=1,CF=0 if $79<=A<$F9, CF=1 if A>=$F9
	bpl	?20		; less of 8 bit to shift
	jsr	shrm		; shift right byte at byte (CF=0)
	bra	?30
?20:	tay			; Y=negative shift's count
	jsr	shrbit		; shift right bit at bit (CF=1)
?30:	ACC16
	lda	facm		; underflow test
	ora	facm+2
	ora	facm+4
	ora	facm+6
	ora	facm+8
	ora	facm+10
	bne	?40		; fac is subnormal
	sta	facexp
	ldx	#$40
	stx	facst
?40:	ACC08
	clc
	rts

; CF=0 if mult
adjexp:
	php
	ACC16
	stz	fexph
	stz	aexph
	ACC08
	lda	facm+11
	bmi	?05		; fac is norml
	ldx	#facm
	jsr	shlm		; normalize subnormal fac
	lda	wftmp
	sta	fexph
	lda	wftmp+1
	sta	fexph+1
?05:	lda	argm+11
	bmi	?10		; arg is norml
	ldx	#argm
	jsr	shlm		; normalize subnormal arg
	lda	wftmp
	sta	aexph
	lda	wftmp+1
	sta	aexph+1
?10:	plp	
	CPU16
	lda	argexp
	bcs	?15		; subtract exponent for division
	adc	facexp
	tax
	lda	aexph
	adc	fexph
	tay
	sec
	txa
	sbc	#EBIAS-1
	tax
	tya
	sbc	#0
	bra	?20
?15:	sbc	facexp
	tax
	lda	aexph
	sbc	fexph
	tay
	clc
	txa
	adc	#EBIAS
	tax
	tya
	adc	#0
?20:	bmi	?25		; negative exponent so result is subnormal
	txa
	beq	?25		; null exponent so result is subnormal
	sta	facexp		; exp >= 1 so result is normal
	stz	fexph
	bra	?30
?25:	dex			; count of right shift
	cpx	#MAXBSHIFT-1
	bcc	?40		; underflow: fac=0
	stx	fexph
	lda	#1
	sta	facexp
?30:	CPU08
	rts
?40:	CPU08
	pla
	pla
	jmp	fldz

div:
	ldx	#MANTSIZ	; loop for all bytes of mantissa
	lda	#$01		; 8 bits loop
?10:	INDEX16			; compare A vs. F
	ldy	argm+10
	cpy	facm+10
	bne	?15
	ldy	argm+8
	cpy	facm+8
	bne	?15
	ldy	argm+6
	cpy	facm+6
	bne	?15
	ldy	argm+4
	cpy	facm+4
	bne	?15
	ldy	argm+2
	cpy	facm+2
	bne	?15
	ldy	argm
	cpy	facm
?15:	INDEX08
?20:	php			; save carry (CF=1 if A>=F)
	rol	a		; shift in CF (result of comparing) into lsb
	bcc	?30		; bits loop...stop when CF=1
	dex			; index of partial result array
	bmi	?50		; end of division
	sta	fpres,x		; store this byte of quotient...
	bne	?25		; ...and restart another 8 bits loop if not 0
	lda	#$40		; 2 bits loop if last partial quotient=0
	bra	?30
?25:	lda	#$01		; 8 bits loop
?30:	plp			; restore CF from comparing A vs. F
	ACC16
	bcc	?40		; A<F so shift the dividend (A)
	tay			; save bits counter&partial quotient (CF=1)
	lda	argm		; get the remainder of A...
	sbc	facm		; ...subtracting the divisor (F)
	sta	argm
	lda	argm+2
	sbc	facm+2
	sta	argm+2
	lda	argm+4
	sbc	facm+4
	sta	argm+4
	lda	argm+6
	sbc	facm+6
	sta	argm+6
	lda	argm+8
	sbc	facm+8
	sta	argm+8
	lda	argm+10
	sbc	facm+10
	sta	argm+10
	tya			; restore partial quotient
?40:	asl	argm		; now shift A to left
	rol	argm+2
	rol	argm+4
	rol	argm+6
	rol	argm+8
	rol	argm+10
	ACC08
	bcs	?20		; A>=F, CF=1
	bmi	?10		; should compare again A vs. F
	bpl	?20		; A<F, CF=0
?50:	plp
	sta	stickyb		; store last partial quotient (trunc)
	lsr	a
	lsr	a
	rts
	
mult:
	sec			; CF=1 for shrfp...
	lda	facm		; multiply any byte of facm and argm
	jsr	?10		; return always CF=1
	lda	facm+1
	jsr	?10
	lda	facm+2
	jsr	?10
	lda	facm+3
	jsr	?10
	lda	facm+4
	jsr	?10
	lda	facm+5
	jsr	?10
	lda	facm+6
	jsr	?10
	lda	facm+7
	jsr	?10
	lda	facm+8
	jsr	?10
	lda	facm+9
	jsr	?10
	lda	facm+10
	jsr	?10
	lda	facm+11		; multiply msb that never is null
	bra	?20
?10:	beq	shrfp		; if null shift 8 bits right partial result
?20:	ldx	#$FF	
	lsr	a		; multiplicator bit
	ora	#$80		; bit for stop iteration (8 cycles)
?30:	tay
	ACC16
	bcc	?40		; multiplicator=0 so shift result to right
	clc
	lda	fpres		; add multiplicand to partial result
	adc	argm
	sta	fpres
	lda	fpres+2
	adc	argm+2
	sta	fpres+2
	lda	fpres+4
	adc	argm+4
	sta	fpres+4
	lda	fpres+6
	adc	argm+6
	sta	fpres+6
	lda	fpres+8
	adc	argm+8
	sta	fpres+8
	lda	fpres+10
	adc	argm+10
	sta	fpres+10
?40:	ror	fpres+10	; shift any carry into partial result
	ror	fpres+8
	ror	fpres+6
	ror	fpres+4
	ror	fpres+2
	ror	fpres
	ACC08
	;bcc	?50
	;stx	stickyb		; set sticky byte if any 1 was shifted out
	ror	stickyb
?50:	tya
	lsr	a		; end of loop when null
	bne	?30
	rts			; always return CF=1
	
shrfp:
	ldx	#fpres

; shrbyte - shift right mantissa pointed by X byte at byte
;
;	entry:	A=negative shift's count
;		X=mantissa pointer
;
; note:
;	A,X and CF unaffected
;
;-------
shrbyte:
;-------
	ldy	<0,x		; set sticky byte
	;beq	?10
	sty	stickyb
?10:	ldy	<1,x
	sty	<0,x
	ldy	<2,x
	sty	<1,x
	ldy	<3,x
	sty	<2,x
	ldy	<4,x
	sty	<3,x
	ldy	<5,x
	sty	<4,x
	ldy	<6,x
	sty	<5,x
	ldy	<7,x
	sty	<6,x
	ldy	<8,x
	sty	<7,x
	ldy	<9,x
	sty	<8,x
	ldy	<10,x
	sty	<9,x
	ldy	<11,x
	sty	<10,x
	ldy	#0
	sty	<11,x

	; now shift residual count of bits (if any)

; shrm - shift mantissa pointed by X to right
;
;	entry:	A=negative shift's count
;		X=mantissa pointer
;		CF=0 (at first call)
; 
; note
;	if shift's count less than 8 shift bit at bit, otherwise shift byte
;	at byte
;	stricky byte will be affected by shifted '1' 
;
;----
shrm:
;----
	adc	#$08		; residual count
	bmi	shrbyte		; N=1,CF=0 - byte shift (8 bit)
	beq	shrbyte		; N=0,CF=1 - byte shift (8 bit)
	sbc	#$08		; restore count (here CF=0 if A=F9..FF)	
	bcs	shrx		; end of shift
	tay

; shrbit - shift mantissa pointed by X to right bit at bit (less of 8 bits)
;
;	entry:	Y=negative shift's count
;		X=mantissa pointer
;
;------
shrbit:
;------
	lda	stickyb
	xba
	lda	#0	
	ACC16
	;lda	#0
?10:	lsr	<10,x		; msb=0
	ror	<8,x
	ror	<6,x
	ror	<4,x
	ror	<2,x
	ror	<0,x
	ror	a		; B=sticky byte
	iny
	bne	?10
	ACC08
	xba
	;tsb	stickyb		; affect sticky byte
	sta	stickyb
shrx:	rts

shlm:
	sec
	ACC16
	lda	<12,x
?10:	ldy	<11,x
	bne	?40
	sbc	#8
	ldy	<10,x
	sty	<11,x	
	ldy	<9,x
	sty	<10,x
	ldy	<8,x
	sty	<9,x
	ldy	<7,x
	sty	<8,x
	ldy	<6,x
	sty	<7,x
	ldy	<5,x
	sty	<6,x
	ldy	<4,x
	sty	<5,x
	ldy	<3,x
	sty	<4,x
	ldy	<2,x
	sty	<3,x
	ldy	<1,x
	sty	<2,x
	ldy	<0,x
	sty	<1,x
	ldy	#0
	sty	<0,x
	cmp	#MAXBSHIFT
	beq	?50
	bcs	?10
	bra	?50
?30:	dec	a
	asl	<0,x
	rol	<2,x
	rol	<4,x
	rol	<6,x
	rol	<8,x
	rol	<10,x
?40:	bpl	?30
?50:	sta	<12,x
	stz	wftmp
	bit	<12,x
	bpl	?60
	dec	wftmp
?60:	ACC08
	rts

; negfac - negate fac (2's complement)
;
;------
negfac:
;------
	lda	facsgn		; change fac sign
	eor	#$FF
	sta	facsgn
	CPU16
	ldx	#$FFFF
	txa
	eor	facm
	sta	facm
	txa
	eor	facm+2
	sta	facm+2
	txa
	eor	facm+4
	sta	facm+4
	txa
	eor	facm+6
	sta	facm+6
	txa
	eor	facm+8
	sta	facm+8
	txa
	eor	facm+10
	sta	facm+10
	inc	facm		; increment guard bits
	bne	ifx		; no update of high order bits
	
; incfacs - increment fac significand
;
; on exit Z=1 if all bytes of mantissa was cleared (carry)
;
;-------
incfacs:
;-------
	CPU16
	inc	facm+2
	bne	ifx
	inc	facm+4
	bne	ifx
	inc	facm+6
	bne	ifx
	inc	facm+8
	bne	ifx
	inc	facm+10
ifx:	CPU08
	rts

; fround - round fac significand 
;
; the rounding method is: round to nearest tie even
;
; let G = guard bits, S = sticky byte and L = lsb significand:
;
;	if G < $8000 then round down
;	if G > $8000 then round up
;	if G = $8000 and S = 0 then round up
;	if G = $8000 and S = 1 then 'tie even':
;		if L = 0 then round down
;		         else round up
;
; if significand=$FFFFFFFFFFFFFFFFFFFF and exp=$7FFE no round up takes place
;
;------
fround:
;------
	ACC16
	lda	facexp		; we check exponent for possible overflow
	cmp	#MAXEXP
	bcc	?05		; ok, no overflow after rounding
	lda	#$FFFF		; check if significand=$FFFFFFFFFFFFFFFFFFFF
	cmp	facm+2
	bne	?05
	cmp	facm+4
	bne	?05
	cmp	facm+6
	bne	?05
	cmp	facm+8
	bne	?05
	cmp	facm+10
	beq	?20		; no round is possible	
?05:	lda	facm		; check guard bits
	cmp	#$8000
	bcc	?20		; G < $8000 so round down
	bne	?10		; G > $8000 so round up
	ldy	stickyb		; G = $8000 so check sticky byte
	bne	?10		; S=1 so round up
	lda	facm+2		; check now L (lsb significand)
	lsr	a		; if L=1 round up
	bcc	?20		; round down -- nothing to do
?10:	ACC08			; here CF=1 if round up
	jsr	incfacs		; increment fac significand
	bne	?15		; no carry -- fac already normalized
	jsr	addcf		; add msb to significand, no overflow possible
?15:	ACC16
?20:	stz	facm		; clear guard bits
	ACC08
	stz	stickyb
	rts

;------
addtst:
;------
	lda	facsgn		; compare sign
	eor	argsgn
	sta	sgncmp
	sec			; invalid result flag
	bit	facst		; test fac
	bpl	?10		; fac is valid
	bvc	?20		; fac=nan so result=nan (fac sign)
	bit	argst		; fac=inf so check arg
	bpl	?20		; fac=inf & arg=y so result=inf (fac sign)
	bvc	?15		; fac=inf & arg=nan so result=nan (arg sign)
	bit	sgncmp		; fac=inf & arg=inf so check sign comparison
	bpl	?20		; same sign so result=inf (fac sign)
	jsr	fldnan		; mismatch signs so result=nan (fac sign)
	bra	?20		; skip resturn & exit with CF=1
?10:	bit	argst		; fac is valid, so now check arg
	bmi	?15		; arg=inf/nan so result=inf/nan (arg sign)
	clc			; now result is valid
	bvs	?20		; arg=0 so result=fac
	bit	facst		; fac=0?
	bvc	?25		; no, return to add/sub operation
?15:	jsr	mvatof		; move arg to fac (preserve CF)
?20:	pla			; skip return address
	pla
?25:	rts

;------
multst:
;------
	lda	facsgn		; compare sign
	eor	argsgn
	sta	facsgn		; set result sign
	sta	argsgn
	sec			; invalid result flag
	bit	facst		; test fac
	bpl	?10		; fac is valid
	bvc	?20		; fac=nan so result=nan
	bit	argst		; fac=inf so check arg
	bpl	?05		; fac=inf & arg=y so check if arg=0
	bvc	?15		; fac=inf & arg=nan so result=nan
	bra	?20		; fac=inf & arg=inf so result=inf
?05:	bvc	?20		; fac=inf & arg not null so result=inf
	bra	?12		; fac=inf & arg=0 so result=nan
?10:	bit	argst		; fac is valid, so now check arg
	bpl	?13		; arg too is valid
	bvc	?15		; fac=x & arg=nan so result=nan
	bit	facst		; fac=x & arg=inf so check if fac=0
	bvc	?15		; fac not null & arg=inf so result=inf
?12:	jsr	fldnan		; fac=0 & arg=inf so result=nan
	bra	?20		; skip resturn & exit with CF=1
?13:	clc			; now result is valid
	bvs	?15		; arg=0 so result=0
	bit	facst		; fac=0?
	bvc	?25		; no, return to mult operation
	jsr	fldz		; result=0 (with CF=0)
	bra	?20
?15:	jsr	mvatof		; move arg to fac (preserve CF)
?20:	pla			; skip return address
	pla
?25:	rts

;------
divtst:
;------
	lda	facsgn		; compare sign
	eor	argsgn
	sta	facsgn		; set result sign
	sta	argsgn
	sec			; invalid result flag
	bit	facst		; test fac
	bpl	?05		; fac is valid
	bvc	?20		; fac=nan so result=nan
	bit	argst		; fac=inf so check arg
	bmi	?10		; fac=inf & arg=inf/nan so result=nan
	bra	?08		; fac=inf & arg=y so result=0	
?05:	lda	argst		; fac is valid, so now check arg
	bmi	?15		; fac=x & arg=nan/inf so result=nan/inf
	and	facst
	asl	a		; both null?
	bmi	?10		; yes so result=nan
	bit	facst
	bvs	?12
	bit	argst
	bvc	?25
?08:	jsr	fldz		; result=0 (with CF=0)
	bra	?20
?10:	jsr	fldnan		; fac=0 & arg=0 so result=nan
	bra	?20		; skip resturn & exit with CF=1	
?12:	jsr	fldinf
	bra	?20
?15:	jsr	mvatof		; move arg to fac (preserve CF)
?20:	pla			; skip return address
	pla
?25:	rts
	
fldz:
	lda	#$40
	sta	facst
	ACC16
	stz	facm
	stz	facm+2
	stz	facm+4
	stz	facm+6
	stz	facm+8
	stz	facm+10
	stz	facexp
	ACC08
	stz	stickyb
	clc
	rts
	
mvatof:
	ldx	#FREGSIZ-1
?10:	lda	argm,x
	sta	facm,x
	dex
	bpl	?10
	rts

mvftoa:
	ldx	#FREGSIZ-1
?10:	lda	facm,x
	sta	argm,x
	dex
	bpl	?10
	rts

; fac to temp 0
mvf2t:
	ldx	#FREGSIZ-1
?10:	lda	facm,x
	sta	tfl0,x
	dex
	bpl	?10
	rts

; fac to temp 1
mvf2t1:
	ldx	#FREGSIZ-1
?10:	lda	facm,x
	sta	tfl1,x
	dex
	bpl	?10
	rts

; fac to temp 2
mvf2t2:
	ldx	#FREGSIZ-1
?10:	lda	facm,x
	sta	tfl2,x
	dex
	bpl	?10
	rts

; temp 2 to fac
mvt22f:
	ldx	#FREGSIZ-1
?10:	lda	tfl2,x
	sta	facm,x
	dex
	bpl	?10
	rts

; fac to temp 3
mvf2t3:
	ldx	#FREGSIZ-1
?10:	lda	facm,x
	sta	tfl3,x
	dex
	bpl	?10
	rts

; temp 2 to fac
mvt32f:
	ldx	#FREGSIZ-1
?10:	lda	tfl3,x
	sta	facm,x
	dex
	bpl	?10
	rts

; temp 1 to arg
mvt12a:
	ldx	#FREGSIZ-1
?10:	lda	tfl1,x
	sta	argm,x
	dex
	bpl	?10
	rts

; temp 0 to arg
mvt2a:
	ldx	#FREGSIZ-1
?10:	lda	tfl0,x
	sta	argm,x
	dex
	bpl	?10
	rts

; temp 2 to arg
mvt22a:
	ldx	#FREGSIZ-1
?10:	lda	tfl2,x
	sta	argm,x
	dex
	bpl	?10
	rts

; move fp costant to fac (A=low, Y=high)
mvc2f:
	sta	mlp
	sty	mlp+1
_mvc2f:
	lda	#.SEG.mvc2f
	sta	mlp+2
	ldx	#FCSIZ-2
	txy
	ACC16
?10:	lda	[mlp],y
	sta	facm,x
	dey
	dey
	dex
	dex
	bpl	?10
	ACC08
	inx			; X=$FF
	stz	facst
	stz	stickyb
	lda	#$80
	trb	facexp+1	; test bit 7 and reset it
	bne	?20		; bit 7=1 so negative sign
	inx			; bit 7=0 so positive sign
?20:	stx	facsgn
	rts
	
; move fp costant to arg (A=low, Y=high)
mvc2a:
	sta	mlp
	sty	mlp+1
_mvc2a:
	lda	#.SEG.mvc2f
	sta	mlp+2
	ldx	#FCSIZ-2
	txy
	ACC16
?10:	lda	[mlp],y
	sta	argm,x
	dey
	dey
	dex
	dex
	bpl	?10
	ACC08
	inx			; X=$FF
	stz	argst
	lda	#$80
	trb	argexp+1	; test bit 7 and reset it
	bne	?20		; bit 7=1 so negative sign
	inx			; bit 7=0 so positive sign
?20:	stx	argsgn
	rts
	
ldfac2:
	ldx	#facm
	bra	ldfp2

ldarg2:
	ldx	#argm
	bra	ldfp2
	
; A=low, Y=high (load costant 14 bytes)
ldfac:
	ldx	#facm
	bra	ldfp
ldarg:
	ldx	#argm
ldfp:
	sta	mlp
	sty	mlp+1
ldfp2:
	lda	#.SEG.ldfp
	sta	mlp+2
	ldy	#0
	ACC16
	lda	[mlp],y
	sta	<0,x
	iny
	iny
	lda	[mlp],y
	sta	<2,x
	iny
	iny
	lda	[mlp],y
	sta	<4,x
	iny
	iny
	lda	[mlp],y
	sta	<6,x
	iny
	iny
	lda	[mlp],y
	sta	<8,x
	iny
	iny
	lda	[mlp],y
	sta	<10,x
	iny
	iny
	lda	[mlp],y
	xba
	tay
	sty	<14,x
	ldy	#$40
	xba
	and	#$7FFF
	sta	<12,x
	beq	?10
	ldy	#$00
	cmp	#INFEXP
	bcc	?10
	ldy	#$C0
	lda	<10,x
	cmp	#INFSND
	beq	?10
	ldy	#$80
?10:	sty	<15,x
	;stz	<0,x
	ACC08
	cpx	#facm
	bne	?20
	stz	stickyb
?20:	rts

; 25 digits
int2dec:
	phb			; save dbr
	phk
	plb			; set current dbr=pbr
	ldx	#0
	stx	fpres+10	; msb=0 (extension to 12 bytes)
	stx	fpres+11
	stx	wftmp+1
	ldy	#$80		; partial quotient (alternate positive/neg.)
?10:	ACC16
?20:	lda	fpres		; repeated subtraction
	sec
	sbc	!dectbl1,x	; low bytes 
	sta	fpres
	lda	fpres+2
	sbc	!dectbl1+2,x
	sta	fpres+2
	lda	fpres+4
	sbc	!dectbl1+4,x
	sta	fpres+4
	lda	fpres+6
	sbc	!dectbl2,x	; high bytes
	sta	fpres+6
	lda	fpres+8
	sbc	!dectbl2+2,x
	sta	fpres+8
	lda	fpres+10
	sbc	!dectbl2+4,x
	sta	fpres+10
	iny			; increment partial quotient
	bcs	?30		; remainder is positive
	bpl	?20		; quot. positive so repeat if rem. negative
	bmi	?40		; quot. negative so store digit if rem. pos.
?30:	bmi	?20		; quot. negative so repeat if rem. negative
?40:	ACC08	
	tya
	bcc	?50		; quotient is positive
	eor	#$FF		; complement
	adc	#10
?50:	adc	#'0'-1
	tay
	stx	wftmp
	ldx	wftmp+1
	and	#$7F
	sta	fpstr,x
	inx
	stx	wftmp+1
	tya
	eor	#$FF
	and	#$80
	tay
	lda	wftmp
	clc
	adc	#DROWSIZ
	tax
	cpx	#DTBLSIZ
	bcc	?10
	ldx	wftmp+1
	stz	fpstr,x
	plb
	rts


dectbl1:	
	.DB	$00, $00, $00, $A1, $ED, $CC	; +1E24
DROWSIZ	.EQU	$-dectbl1
	.DB	$00, $00, $80, $09, $B5, $1E	; -1E23
	.DB	$00, $00, $40, $B2, $BA, $C9	; +1E22
	.DB	$00, $00, $60, $21, $3A, $52	; -1E21
	.DB	$00, $00, $10, $63, $2D, $5E	; +1E20
	.DB	$00, $00, $18, $76, $FB, $DC	; -1E19
	.DB	$00, $00, $64, $A7, $B3, $B6	; +1E18
	.DB	$00, $00, $76, $A2, $87, $BA	; -1E17	
	.DB	$00, $00, $C1, $6F, $F2, $86	; +1E16
	.DB	$00, $80, $39, $5B, $81, $72	; -1E15
	.DB	$00, $40, $7A, $10, $F3, $5A	; +1E14
	.DB	$00, $60, $8D, $B1, $E7, $F6	; -1E13
	.DB	$00, $10, $A5, $D4, $E8, $00	; +1E12 
	.DB	$00, $18, $89, $B7, $E8, $FF	; -1E11
	.DB	$00, $E4, $0B, $54, $02, $00	; +1E10
	.DB	$00, $36, $65, $C4, $FF, $FF	; -1E9	
	.DB	$00, $E1, $F5, $05, $00, $00	; +1E8
	.DB	$80, $69, $67, $FF, $FF, $FF	; -1E7
	.DB	$40, $42, $0F, $00, $00, $00	; +1E6
	.DB	$60, $79, $FE, $FF, $FF, $FF	; -1E5
	.DB	$10, $27, $00, $00, $00, $00	; +1E4
	.DB	$18, $FC, $FF, $FF, $FF, $FF	; -1E3
	.DB	$64, $00, $00, $00, $00, $00	; +1E2	
	.DB	$F6, $FF, $FF, $FF, $FF, $FF	; -1E1
	.DB	$01, $00, $00, $00, $00, $00	; +1E0

dectbl2:	
	.DB	$CE, $1B, $C2, $D3, $00, $00	; +1E24
	.DB	$38, $FD, $D2, $EA, $FF, $FF	; -1E23
	.DB	$E0, $19, $1E, $02, $00, $00	; +1E22
	.DB	$36, $CA, $C9, $FF, $FF, $FF	; -1E21
	.DB	$C7, $6B, $05, $00, $00, $00	; +1E20
	.DB	$38, $75, $FF, $FF, $FF, $FF	; -1E19
	.DB	$E0, $0D, $00, $00, $00, $00	; +1E18
	.DB	$9C, $FE, $FF, $FF, $FF, $FF	; -1E17	
	.DB	$23, $00, $00, $00, $00, $00	; +1E16
	.DB	$FC, $FF, $FF, $FF, $FF, $FF	; -1E15
	.DB	$00, $00, $00, $00, $00, $00	; +1E14
	.DB	$FF, $FF, $FF, $FF, $FF, $FF	; -1E13
	.DB	$00, $00, $00, $00, $00, $00	; +1E12 
	.DB	$FF, $FF, $FF, $FF, $FF, $FF	; -1E11
	.DB	$00, $00, $00, $00, $00, $00	; +1E10
	.DB	$FF, $FF, $FF, $FF, $FF, $FF	; -1E9	
	.DB	$00, $00, $00, $00, $00, $00	; +1E8
	.DB	$FF, $FF, $FF, $FF, $FF, $FF	; -1E7
	.DB	$00, $00, $00, $00, $00, $00	; +1E6
	.DB	$FF, $FF, $FF, $FF, $FF, $FF	; -1E5
	.DB	$00, $00, $00, $00, $00, $00	; +1E4
	.DB	$FF, $FF, $FF, $FF, $FF, $FF	; -1E3
	.DB	$00, $00, $00, $00, $00, $00	; +1E2	
	.DB	$FF, $FF, $FF, $FF, $FF, $FF	; -1E1
	.DB	$00, $00, $00, $00, $00, $00	; +1E0

DTBLSIZ	.EQU	$-dectbl2

;; not rounded
fce0:	.DB	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$80,$FF,$3F	; 1
fce1:	.DB	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$A0,$02,$40	; 10
fce2:	.DB	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$C8,$05,$40	; 100
fce3:	.DB	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$FA,$08,$40 ; 1E3
fce4:	.DB	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$40,$9C,$0C,$40	; 1E4
fce5:	.DB	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$50,$C3,$0F,$40	; 1E5
fce6:	.DB	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$24,$F4,$12,$40	; 1E6
fce7:	.DB	$00,$00,$00,$00,$00,$00,$00,$00,$00,$80,$96,$98,$16,$40	; 1E7

fce8:	
	.DB	$00,$00,$00,$00,$00,$00,$00,$00,$00,$20,$BC,$BE,$19,$40	; 1E8
	.DB	$00,$00,$00,$00,$00,$00,$00,$04,$BF,$C9,$1B,$8E,$34,$40	; 1E16
	.DB	$00,$00,$20,$F0,$9D,$B5,$70,$2B,$A8,$AD,$C5,$9D,$69,$40	; 1E32	
	.DB	$70,$6B,$BF,$3C,$D5,$A6,$CF,$FF,$49,$1F,$78,$C2,$D3,$40	; 1E64
	.DB	$69,$33,$6F,$C6,$DF,$8C,$E9,$80,$C9,$47,$BA,$93,$A8,$41	; 1E128
	.DB	$14,$90,$BB,$DD,$8D,$DE,$F9,$9D,$FB,$EB,$7E,$AA,$51,$43	; 1E256
	.DB	$40,$5C,$65,$CC,$C6,$91,$0E,$A6,$AE,$A0,$19,$E3,$A3,$46	; 1E512
	.DB	$04,$3D,$0D,$65,$17,$0C,$75,$81,$86,$75,$76,$C9,$48,$4D	; 1E1024
	.DB	$94,$28,$4D,$A7,$E4,$5D,$3D,$C5,$5D,$3B,$8B,$9E,$92,$5A	; 1E2048
fce4096:
	.DB	$AE,$14,$4C,$C9,$9A,$97,$20,$8A,$02,$52,$60,$C4,$25,$75	; 1E4096

FCSIZ	.EQU	$-fce4096

fcaddr:	
	.DW	fce0, fce1, fce2, fce3, fce4, fce5, fce6, fce7
