;----------------------------------------------------------
; FPUEMU.ASM
; PROGETTO: B1601
;
; Floating Point Unit - emulazione operazioni base
;----------------------------------------------------------

	.INCLUDE inc\global.inc

;----------------------------------------------------------
; variabili in Direct-Page 02
;----------------------------------------------------------	
	
	.INCLUDE inc\dirp02.inc
	
;----------------------------------------------------------
; segmento codice banco $F8
;----------------------------------------------------------

	.CODEF8
	.EXTERN _UI2Str, _iSMult16, Byte2Hex
	.GLOBAL _Str2Fl, _MovRndF2A, _feMUL, _MovRF2Mem, _MovMem2A, _feDIV
	.GLOBAL _feSUB, _feADD, _feFAC2S, _MovMem2Fa

EXPBIAS		.EQU	$3FFF		; bias esponente
EXPINF		.EQU	$7FFF		; esponente INF e NAN
MANTINF		.EQU	$8000		; mantissa INF
MANTNAN		.EQU	$FF00		; mantissa NAN
BIASBYTE	.EQU 	(EXPBIAS + 7)	; bias BYTE (8 bit)
BIASWORD	.EQU 	(BIASBYTE + 8)	; bias WORD (16 bit)
BIASDWORD	.EQU 	(BIASWORD + 16)	; bias DWORD (32 bit)
BIASQWORD	.EQU 	(BIASDWORD + 32); bias QWORD (64 bit)
MAXPEXP		.EQU	EXPBIAS		; massimo esponente positivo
MINNEXP		.EQU	-(EXPBIAS)	; minimo esponente negativo
LOG2H		.EQU	19728		; LG(2) * $10000
EXP10LIM	.EQU	4999		; limite esponente in FStr2Float
MAXDIGITS	.EQU	19		; max. numero cifre decimali
MAXINTDGTS	.EQU	20		; max. cifre unsigned int
MAXDECSTR	.EQU	127
MAXFEXP		.EQU	7		; max. esp. dec. negativo formato G/F
MAXFDEC		.EQU	36		; max. esp. decimale positivo form. F

	.LONGA	off
	.LONGI	off


_test1:	
	.EXTERN fpmult, fpdiv, ldfac, ldarg, fround
	
	phb			; salva DBR
	phd			; salva DPR
	pea	#DP02ADDR	; imposta DPR a pag 2
	pld
	ldy	#0
	phy
	plb			; imposta DBR su banco 0

	ldy	#^?510		; ARG = 1.0
	lda	#>?510
	xba
	lda	#<?510	
	jsr	_MovMem2F
	ldy	#^?500		; ARG = 1.0
	lda	#>?510
	xba
	lda	#<?500	
	jsr	_MovMem2A
	jsr	_feDIV		; FAC=ARG/FAC
	jsr	_Round
	
	phd
	pea	#$3f00
	pld
	ldy	#^?610		; ARG = 1.0
	lda	#>?610
	xba
	lda	#<?610	
	jsr	ldfac
	ldy	#^?600		; ARG = 1.0
	lda	#>?600
	xba
	lda	#<?600	
	jsr	ldarg
	jsr	fpmult		; FAC=ARG/FAC
	jsr	fround
	pld
	pld
	plb
	brk

	phk
	pea	#?400
	phk
	pea	#?210
	lda	#7
	pha
	BPRINTF
	phk
	pea	#?410
	phk
	pea	#?210
	lda	#7
	pha
	BPRINTF

	lda	#>?100		; 1.0
	xba
	lda	#<?100
	ldx	#^?100
	jsr	_Str2Fl
	ldy	#$20
	lda	#0
	xba
	lda	#0
	jsr	_MovRF2Mem
	
	lda	#>?105		; 1.0001
	xba
	lda	#<?105
	ldx	#^?105
	jsr	_Str2Fl
	ldy	#$20
	lda	#0
	xba
	lda	#$10
	jsr	_MovRF2Mem

	lda	#>?110		; 0.9999
	xba
	lda	#<?110
	ldx	#^?110
	jsr	_Str2Fl
	ldy	#$20
	lda	#0
	xba
	lda	#$20
	jsr	_MovRF2Mem

	lda	#>?115		; 0.0001
	xba
	lda	#<?115
	ldx	#^?115
	jsr	_Str2Fl
	ldy	#$20
	lda	#0
	xba
	lda	#$30
	jsr	_MovRF2Mem	

	ldy	#$20		; ARG = 1.0
	lda	#0
	xba
	lda	#0
	jsr	_MovMem2A

	ldy	#$20		; FAC = .0001
	lda	#0
	xba
	lda	#$30
	jsr	_MovMem2F
	jsr	_feDIV		; FAC=ARG/FAC
	brk

	ldy	#$20		; ARG = 1.0001
	lda	#0
	xba
	lda	#$10
	jsr	_MovMem2A
	jsr	_feSUB		; FAC=ARG-FAC
	ldy	#$20
	lda	#0
	xba
	lda	#$40
	jsr	_MovRF2Mem

	ldy	#$20		; FAC = 0.9999
	lda	#0
	xba
	lda	#$20
	jsr	_MovMem2F
	
	ldy	#$20		; ARG = 1.0
	lda	#0
	xba
	lda	#$00
	jsr	_MovMem2A
	jsr	_feSUB		; FAC=ARG-FAC
	ldy	#$20
	lda	#0
	xba
	lda	#$50
	jsr	_MovRF2Mem

	ldy	#$20		; FAC = 1.0
	lda	#0
	xba
	lda	#0
	jsr	_MovMem2F
	
	ldy	#$20		; ARG = 0.0001
	lda	#0
	xba
	lda	#$30
	jsr	_MovMem2A
	jsr	_feADD		; FAC=ARG+FAC
	ldy	#$20
	lda	#0
	xba
	lda	#$60
	jsr	_MovRF2Mem

	lda	#>?120		; 0.0001
	xba
	lda	#<?120
	ldx	#^?120
	jsr	_Str2Fl
	ldy	#$20
	lda	#0
	xba
	lda	#$70
	jsr	_MovRF2Mem

	ldy	#$20		; FAC = 1.0
	lda	#0
	xba
	lda	#0
	jsr	_MovMem2F	
	ldy	#$20		; ARG = 1.0001
	lda	#0
	xba
	lda	#$10
	jsr	_MovMem2A
	jsr	_feADD		; FAC=ARG+FAC
	ldy	#$20
	lda	#0
	xba
	lda	#$80
	jsr	_MovRF2Mem

	lda	#$20
	pha
	pea	#$0030
	phk
	pea	#?200
	lda	#7
	pha
	BPRINTF
	lda	#$20
	pha
	pea	#$0040
	phk
	pea	#?200
	lda	#7
	pha
	BPRINTF
	lda	#$20
	pha
	pea	#$0050
	phk
	pea	#?200
	lda	#7
	pha
	BPRINTF

	lda	#$20
	pha
	pea	#$0030
	phk
	pea	#?210
	lda	#7
	pha
	BPRINTF
	lda	#$20
	pha
	pea	#$0040
	phk
	pea	#?210
	lda	#7
	pha
	BPRINTF
	lda	#$20
	pha
	pea	#$0050
	phk
	pea	#?210
	lda	#7
	pha
	BPRINTF

	lda	#>?305
	xba
	lda	#<?305
	ldx	#^?305
	jsr	_Str2Fl
	ldy	#$20
	lda	#0
	xba
	lda	#$90
	jsr	_MovRF2Mem

	lda	#>?300
	xba
	lda	#<?300
	ldx	#^?300
	jsr	_Str2Fl
	ldy	#$20
	lda	#0
	xba
	lda	#$A0
	jsr	_MovRF2Mem
	ldy	#$20
	lda	#0
	xba
	lda	#$90
	jsr	_feDIVRM
	ldy	#$20
	lda	#0
	xba
	lda	#$B0
	jsr	_MovRF2Mem
	lda	#$20
	pha
	pea	#$00B0
	phk
	pea	#?210
	lda	#7
	pha
	BPRINTF

	lda	#>?310
	xba
	lda	#<?310
	ldx	#^?310
	jsr	_Str2Fl
	ldy	#$20
	lda	#0
	xba
	lda	#$D0
	jsr	_MovRF2Mem
	ldy	#$20		; ARG = 1.0
	lda	#0
	xba
	lda	#$00
	jsr	_MovMem2A
	jsr	_feSUB		; FAC=ARG-FAC
	ldy	#$20
	lda	#0
	xba
	lda	#$C0
	jsr	_MovRF2Mem
	lda	#$20
	pha
	pea	#$00C0
	phk
	pea	#?210
	lda	#7
	pha
	BPRINTF

	lda	#>?320
	xba
	lda	#<?320
	ldx	#^?320
	jsr	_Str2Fl
	ldy	#$20
	lda	#0
	xba
	lda	#$E0
	jsr	_MovRF2Mem
	lda	#>?325
	xba
	lda	#<?325
	ldx	#^?325
	jsr	_Str2Fl
	ldy	#$20
	lda	#0
	xba
	lda	#$F0
	jsr	_MovRF2Mem
	ldy	#$20		; ARG = 1.0
	lda	#0
	xba
	lda	#$E0
	jsr	_MovMem2A
	jsr	_feADD
	ldy	#$20
	lda	#1
	xba
	lda	#$00
	jsr	_MovRF2Mem

	phk
	pea	#?420
	phk
	pea	#?210
	lda	#7
	pha
	BPRINTF

	phk
	pea	#?425
	phk
	pea	#?210
	lda	#7
	pha
	BPRINTF

	phk
	pea	#?430
	phk
	pea	#?210
	lda	#7
	pha
	BPRINTF
	
	pld
	plb
	brk
	
?100:	.DB	'1.0', 0
;?105:	.DB	'1.0001', 0
;?110:	.DB	'0.9999', 0
;?115:	.DB	'0.0001', 0

?105:	.DB	'1.0000001', 0
?110:	.DB	'0.9999999', 0
?115:	.DB	'0.0000001', 0

?120:	.DB	'2.0001', 0
?200:	.DB	13, '%2.16f', 0
?210:	.DB	13, '%1.20e', 0

?300:	.DB	'845.782345177785467',0
?305:	.DB	'17.171779',0
?310:	.DB	'1.0e-17',0

;?320:	.DB	'3.645e-4951',0
?325:	.DB	'3.645e-4941',0
?320:	.DB	'3.362e-4932',0

?400:	.DB	$BD, $7F, $18, $F6, $d1, $8e, $7d, $94, $e4, $0a
?410:	.DB	$76, $cb, $e2, $7b, $c2, $5e, $1e, $ff, $ff, $4a
?420:	.DB	$ff, $ff, $ff, $ff, $ff, $ff, $ff, $7f, $01, $00
?425:	.DB	$00, $00, $00, $00, $00, $00, $00, $80, $ff, $00
?430:	.DB	$ff, $ff, $ff, $00, $00, $00, $00, $00, $01, $00
?510:	.DB	$00, $00, $00, $00, $00, $00, $00, $88, $ff, $3f
;?510:	.DB	$ff, $ff, $ff, $ff, $00, $ff, $ff, $ff, $ff, $3f
?500:	.DB	$00, $00, $00, $00, $00, $00, $00, $E0, $ff, $3f

;?610:	.DB	$00, $00, $00, $00, $00, $00, $00, $00, $00, $88, $ff, $3f
;?600:	.DB	$00, $00, $00, $00, $00, $00, $00, $00, $00, $E0, $ff, $3f

;?610:	.DB	$00, $00, $00,$00,$00,$04,$BF,$C9,$1B,$8E,$34,$40 ; 1E16

?600:	.DB	$00,$00,$00,$B4,$57,$0A,$3F,$16,$68,$A9,$4B,$40	; 1E23
?610:	.DB	$00,$00,$00,$00,$00,$00,$00,$00,$00,$A0,$02,$40


;; $00,$00,$00,$A1,$ED,$CC,$CE,$1B,$C2,$D3,$4E,$40	; 1E24
;; $00,$00,$00,$B4,$57,$0A,$3F,$16,$68,$A9,$4B,$40	; 1E23

;; rounded
;; $20,$F0,$9D,$B5,$70,$2B,$A8,$AD,$C5,$9D,$69,$40	; 1E32
;; $BF,$3C,$D5,$A6,$CF,$FF,$49,$1F,$78,$C2,$D3,$40	; 1E64
;; $6F,$C6,$DF,$8C,$E9,$80,$C9,$47,$BA,$93,$A8,$41	; 1E128
;; $BB,$DD,$8D,$DE,$F9,$9D,$FB,$EB,$7E,$AA,$51,$43	; 1E256
;; $64,$CC,$C6,$91,$0E,$A6,$AE,$A0,$19,$E3,$A3,$46	; 1E512
;; $0B,$65,$17,$0C,$75,$81,$86,$75,$76,$C9,$48,$4D	; 1E1024
;; $4A,$A7,$E4,$5D,$3D,$C5,$5D,$3B,$8B,$9E,$92,$5A	; 1E2048
;; $44,$C9,$9A,$97,$20,$8A,$02,$52,$60,$C4,$25,$75	; 1E4096

;; not rounded
;; $00,$00,$20,$F0,$9D,$B5,$70,$2B,$A8,$AD,$C5,$9D,$69,$40	; 1E32
;; $70,$6B,$BF,$3C,$D5,$A6,$CF,$FF,$49,$1F,$78,$C2,$D3,$40	; 1E64
;; $69,$33,$6F,$C6,$DF,$8C,$E9,$80,$C9,$47,$BA,$93,$A8,$41	; 1E128
;; $14,$90,$BB,$DD,$8D,$DE,$F9,$9D,$FB,$EB,$7E,$AA,$51,$43	; 1E256
;; $40,$5C,$65,$CC,$C6,$91,$0E,$A6,$AE,$A0,$19,$E3,$A3,$46	; 1E512
;; $04,$3D,$0D,$65,$17,$0C,$75,$81,$86,$75,$76,$C9,$48,$4D	; 1E1024
;; $94,$28,$4D,$A7,$E4,$5D,$3D,$C5,$5D,$3B,$8B,$9E,$92,$5A	; 1E2048
;; $AE,$14,$4C,$C9,$9A,$97,$20,$8A,$02,$52,$60,$C4,$25,$75	; 1E4096

;FCon1E8:	.DB	$00,$00,$00,$00,$00,$20,$BC,$BE,$19,$40	; 1E8
;FCon1E16:	.DB	$00,$00,$00,$04,$BF,$C9,$1B,$8E,$34,$40	; 1E16
;FCon1E32:	.DB	$9E,$B5,$70,$2B,$A8,$AD,$C5,$9D,$69,$40	; 1E32
;FCon1E64:	.DB	$D5,$A6,$CF,$FF,$49,$1F,$78,$C2,$D3,$40	; 1E64
;FCon1E128:	.DB	$DF,$8C,$E9,$80,$C9,$47,$BA,$93,$A8,$41	; 1E128
;FCon1E256:	.DB	$8C,$DE,$F9,$9D,$FB,$EB,$7E,$AA,$51,$43	; 1E256
;FCon1E512:	.DB	$C2,$91,$0E,$A6,$AE,$A0,$19,$E3,$A3,$46	; 1E512
;FCon1E1024:	.DB	$0F,$0C,$75,$81,$86,$75,$76,$C9,$48,$4D	; 1E1024
;FCon1E2048:	.DB	$D7,$5D,$3D,$C5,$5D,$3B,$8B,$9E,$92,$5A	; 1E2048	
;FCon1E4096:	.DB	$79,$97,$20,$8A,$02,$52,$60,$C4,$25,$75	; 1E4096	

;;	.DB	$00, $00, $00, $A1, $ED, $CC, $CE, $1B, $C2, $D3, $00	; +1E24
;;	.DB	$00, $00, $80, $09, $B5, $1E, $38, $FD, $D2, $EA, $FF	; -1E23
;;	.DB	$00, $00, $40, $B2, $BA, $C9, $E0, $19, $1E, $02, $00	; +1E22
;;	.DB	$00, $00, $60, $21, $3A, $52, $36, $CA, $C9, $FF, $FF	; -1E21
;;	.DB	$00, $00, $10, $63, $2D, $5E, $C7, $6B, $05, $00, $00	; +1E20
;;CONSTDECTBL:
;;	.DB	$00, $00, $18, $76, $FB, $DC, $38, $75, $FF, $FF, $FF	; -1E19
;;CONSTDECTBL1:
;;	.DB	$00, $00, $64, $A7, $B3, $B6, $E0, $0D, $00, $00, $00	; +1E18
;;	.DB	$00, $00, $76, $A2, $87, $BA, $9C, $FE, $FF, $FF, $FF	; -1E17	
;;	.DB	$00, $00, $C1, $6F, $F2, $86, $23, $00, $00, $00, $00	; +1E16
;;	.DB	$00, $80, $39, $5B, $81, $72, $FC, $FF, $FF, $FF, $FF	; -1E15
;;	.DB	$00, $40, $7A, $10, $F3, $5A, $00, $00, $00, $00, $00	; +1E14
;;	.DB	$00, $60, $8D, $B1, $E7, $F6, $FF, $FF, $FF, $FF, $FF	; -1E13
;;	.DB	$00, $10, $A5, $D4, $E8, $00, $00, $00, $00, $00, $00	; +1E12 
;;	.DB	$00, $18, $89, $B7, $E8, $FF, $FF, $FF, $FF, $FF, $FF	; -1E11
;;	.DB	$00, $E4, $0B, $54, $02, $00, $00, $00, $00, $00, $00	; +1E10
;;	.DB	$00, $36, $65, $C4, $FF, $FF, $FF, $FF, $FF, $FF, $FF	; -1E9	
;;	.DB	$00, $E1, $F5, $05, $00, $00, $00, $00, $00, $00, $00	; +1E8
;;	.DB	$80, $69, $67, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF	; -1E7
;;	.DB	$40, $42, $0F, $00, $00, $00, $00, $00, $00, $00, $00	; +1E6
;;	.DB	$60, $79, $FE, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF	; -1E5
;;	.DB	$10, $27, $00, $00, $00, $00, $00, $00, $00, $00, $00	; +1E4
;;	.DB	$18, $FC, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF	; -1E3
;;	.DB	$64, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00	; +1E2	
;;	.DB	$F6, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF	; -1E1
;;	.DB	$01, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00	; +1E0

;-------------------------------------------------------------
; _feADD, _feSUB - IMPLEMENTAZIONE ADD - SUB
;-------------------------------------------------------------

; _feSUB: esegue sottrazione tra ARG e FAC e pone il risultato in FAC
; In:	FAC, ARG
; Out:	FAC = ARG - FAC
;	CF = 1 se overflow/invalid
; Uso:	A,X,Y,FPWTmp,FACXM,ARGXM
_feSUB:
	LDA	FACSGN		; Cambia di segno a FAC
	EOR	#$FF
	STA	FACSGN

; _feADD: esegue somma di FAC e ARG e pone il risultato in FAC
; In:	FAC, ARG
; Out:	FAC = ARG + FAC
;	CF = 1 se overflow/invalid
; Uso:	A,X,Y,FPWTmp,FACXM,ARGXM
_feADD:
	jsr	addtst		; test FAC ed ARG e setta confronto segni

	; per eseguire somma/sottrazione e' necessario che
	; FAC ed ARG abbiano lo stesso esponente. Occorre quindi
	; denormalizzare FAC se Exp(ARG) > Exp(FAC), oppure ARG
	; se Exp(FAC) > Exp(ARG)
?15:	LDX	#ARG		; X -> ARG (ptr acc# da denormalizzare)
	ldy	FACEXT		; se si denormalizza ARG vengono usati
	sty	ARGEXT		; bit di guardia di ARG
	ldy	#0
	SEC
	ACC16			; calcola N = Exp(ARG) - Exp(FAC)
	lda	ARGExp		; C = N = Exp(ARG) - Exp(FAC)
	sbc	FACExp
	BEQ	?30		; N = 0 => somma mantisse 
				; A = 0 = bit di guardia, CF = 1
	BCC	?18		; N < 0 => denorm. ARG -> aumenta Exp(ARG) 
	
	; N > 0 => denormalizza FAC -> aumenta Exp(FAC)
	; a questo punto CF = 1
	sta	FPWTmp		; salva N (> 0)	
	LDA	ARGExp
	STA	FACExp		; imposta Exp(FAC) = Exp(ARG)
	LDX	ARGSGN		; segno di FAC = segno di ARG
	STX	FACSGN		; segno operazione = segno acc. Exp maggiore
	tya			; A = B = 0 (C = 0)
	SBC	FPWTmp		; cambia segno ad N 
	sty	ARGEXT		; azzera bit di guardia di ARG
	LDX	#FAC		; X = puntatore a FAC
	bra	?20		; denormalizza FAC

?18:	; azzera bit di guardia di FAC - segno operazione = segno FAC
	sty	FACEXT		; denormalizza ARG

	; X -> puntatore (- 1) acc# (FAC/ARG) da denormalizzare
	; A =  -N, numero di shift (negativo) -- ACC16
	; Y = 0
	; Se N < MAXMANTSHIFT la mantissa viene azzerata senza eseguire shift
	; dunque deve essere  MAXMANTSHIFT <= N <= FFFF
?20:	cmp	#MAXMANTSHIFT
	bcs	?23		; shift mantissa (denormalizza)
	STY	<0,X		; azzera bit di guardia 
	STZ	<1,X		; azzera mantissa X (ACC/MEM16)
	STZ	<3,X
	STZ	<5,X
	STZ	<7,X
	ACC08
	lda	FACEXT		; A = bit di guardia
	BRA	?30		; esegue somma/sottrazione
	
	; a questo punto A = -N => numero di shift mantissa (divisioni x 2)
	; il numero N e' contenuto solo in A (B = $FF) e si imposta ACC08
?23:	ACC08	
	CMP	#$F9		; test N < -7
	BPL	?25		; N >= -7, shift bit x bit (CF = 1)
	JSR	_RShiftXB	; N < -7, shifta byte x byte (CF = 0)
	BRA	?30		; esegue somma/sottrazione
?25:	TAY			; Y = -N
	LDA	FACEXT		; A = bit di guardia
	JSR	_RShiftXN	; shift bit x bit (CF = 0)

	; ora gli esponenti di FAC ed ARG sono uguali
	; CF = 0 se FAC o ARG denormalizzato
	; CF = 1 se FAC e ARG hanno lo stesso esponente
	; A = bits di guardia (= 0 se FAC e ARG stesso esponente)
?30:	ACC08	
	BIT	FACSCMP		; se FAC ed ARG hanno segni discordi
	BMI	_subm		; esegue sottrazione mantisse
	
	; segni concordi, addiziona mantisse con CF
	clc
	ADC	ARGEXT
	STA	FACEXT
	ACC16
	LDA	FAC+1
	ADC	ARG+1
	STA	FAC+1
	LDA	FAC+3
	ADC	ARG+3
	STA	FAC+3
	LDA	FAC+5
	ADC	ARG+5
	STA	FAC+5
	LDA	FAC+7
	ADC	ARG+7
	STA	FAC+7	
	ACC08
	BCC	_Normalize	; OK, no overflow

	; Incrementa esponente di FAC e shifta a destra la mantissa
	; per impostare il primo bit della mantissa ad 1 (normalizza).
	; Il bit meno significativo viene ruotato nei bits di guardia
	; in caso di overflow imposta FAC = INF ed esce con CF = 1
	; in caso di risultato corretto esce con CF = 0

_IncEXP:
	ACC16
	lda	FACExp
	inc	a		; incrementa esponente
	sta	FACExp
	cmp	#EXPINF		; test overflow
	bcc	?04		; OK
	jmp	_feLDINF1	; overflow => FAC = =/- INF	
?04:	SEC			; imposta MSB bit = 1
	ROR	FAC+7		; shift a destra della mantissa
	ROR	FAC+5
	ROR	FAC+3
	ROR	FAC+1
	ACC08
	ROR	FACEXT		; salva LSB nei bits di guardia
	jmp	_feXAM		; OK -- return flag

	; segni discordi => sub mantisse	
_subm:
	php			; salva CF
	LDY	#FAC
	CPX	#ARG
	BEQ	?36		; FAC(Y) - ARG(X)
	LDY	#ARG		; ARG(Y) - FAC(X)
	; X = puntatore mantissa 1
	; Y = puntatore mantissa 2
	; FAC = ACC(Y) - ACC(X)
	; A = bit di guardia
?36:	plp
	bcs	?36b
	sec
	bcs	?36c
?36b:	clc
?36c:
	SEC			; -A + ARGEXT
	EOR	#$FF
	ADC	ARGEXT
	STA	FACEXT
	ACC16
	LDA	DP02ADDR+1,Y
	SBC	<1,X
	STA	FAC+1	
	LDA	DP02ADDR+3,Y
	SBC	<3,X
	STA	FAC+3
	LDA	DP02ADDR+5,Y
	SBC	<5,X
	STA	FAC+5
	LDA	DP02ADDR+7,Y
	SBC	<7,X
	STA	FAC+7
	ACC08
	BCS	_Normalize	; OK => normalizza FAC
	JSR	_NegateFAC	; CF = 0 => complementa FAC
				; in quanto il risultato cambia segno
	; ????
	;beq	_IncEXP		; MSB = 0 => incrementa exp e normalizza

; Normalizza FAC
; In:	FAC
; Out:	FAC normalizzato oppure denormalizzato
; Uso:	A,X,Y,FPWTmp
; Nota:	Esegue N shift della mantissa a sinistra e 
;	decrementa esponente di N volte fino ad avere
;	la mantissa con MSB = 1 oppure fino ad avere
;	esponente nullo (numero denormalizzato)
_Normalize:
	ACC16
	lda	FACExp		; C = FACExp
	beq	?12		; esponente nullo => fine
	sec
	ldy	#9		; max. cicli byte-shift	
?02:	LDX	FAC+8
	BNE	?08		; shift bit x bit
	sbc	#8		; possibili 8 shift ?
	bcc	?04		; no => shift bit x bit	
	LDX	FAC+7		; left shift byte x byte
	STX	FAC+8	
	LDX	FAC+6
	STX	FAC+7
	LDX	FAC+5
	STX	FAC+6
	LDX	FAC+4
	STX	FAC+5
	LDX	FAC+3
	STX	FAC+4
	LDX	FAC+2
	STX	FAC+3
	LDX	FAC+1
	STX	FAC+2
	LDX	FACEXT
	STX	FAC+1
	ldx	#0
	STX	FACEXT		; azzera bit di guardia
	dey
	bne	?02		; loop
	
	; a questo punto la mantissa e' azzerata e ZF = 1 => FAC = 0
	stz	FACExp		; mantissa ed esponente azzerati => FAC = 0
	ACC08
	stz	FACSGN
	clc
	clv			; esce con ZF = 1, CF = 0, VF = 0, NF = 0
	rts

?04:	; shift bit a bit: ripristina C (esponente) -- CF = 1
	LONGA	on		; qui ACC16
	adc	#8
	
?06:	; shift 1 bit a sinistra della mantissa FAC
	; C = FACExp (> 0)
	LONGA	on		; qui ACC16
	;cmp	#0
	cmp	#1
	beq	?10		; esponente azzerato => fine
	dec	a		; decrementa esponente
	ACC08
	ASL	FACEXT		; shift a sinistra di 1 bit
	ACC16
	ROL	FAC+1
	ROL	FAC+3
	ROL	FAC+5
	ROL	FAC+7
?08:	bpl	?06		; MSB = 0 => continua shift
?10:	cmp	#EXPINF		; test overflow
	bcs	?14		; overflow
	sta	FACExp		; salva nuovo esponente
?12:	ACC08
	jmp	_feXAM
?14:	jmp	_feLDINF1

; Arrotonda FAC secondo i bit di guardia
; Puo' generare overflow
_Round:
	jsr	_feXAM
	bcs	?03		; FAC non valido
	BEQ	?01		; FAC = 0 -> esce
	ASL	FACEXT		; bit di guardia = 0
?01:	stz	FACEXT
	BCC	?03		; non necessita di arrotondamento
	JSR	_IncFACM	; incrementa mantissa
	bne	?02		; no overflow -- OK
	jsr	_IncEXP		; riporto MSB, incrementa esponente
	stz	FACEXT
	rts			; flag come ritornato da _IncEXP
?02:	clc
?03:	RTS

; arrotanda FAC e in caso di eccezione scarta un indirizzo di ritorno
_RoundSkp:
	JSR	_Round
	BCC	?01
	PLA
	PLA
?01:	RTS
		
; Complemento a 2 di FAC
; In:	FAC
; Out:	FAC 2's
;	ZF = 0 (non-zero), risultato OK
;	ZF = 1 (zero), OVERFLOW Mantissa
; Uso:	A
; Note:
_NegateFAC:
	LDA	FACSGN
	EOR	#$FF
	STA	FACSGN

; Complemento a 2 MANTISSA FAC
; In:	FAC
; Out:	MANTISSA FAC 2's
;	ZF = 0 (non-zero), risultato OK
;	ZF = 1 (zero), OVERFLOW Mantissa
; Uso:	A, X
; Note:
_NegateFACM:
	CPU16
	ldx	#$FFFF
	txa
	eor	FAC+1
	STA	FAC+1
	txa
	eor	FAC+3
	STA	FAC+3
	txa
	eor	FAC+5
	STA	FAC+5
	txa
	eor	FAC+7
	STA	FAC+7
	CPU08	
	txa
	eor	FACEXT
	STA	FACEXT
	INC	FACEXT
	BNE	_RTS2
	
; Incrementa MANTISSA FAC
; In:	FAC
; Out:	MANTISSA FAC + 1
;	ZF = 0 (non-zero), risultato OK
;	ZF = 1 (zero), OVERFLOW Mantissa
; Uso:	A
; Note:
_IncFACM:
	ACC16
	INC	FAC+1
	BNE	?02
	INC	FAC+3
	BNE	?02
	INC	FAC+5
	BNE	?02
	INC	FAC+7
?02:	ACC08
_RTS2:	RTS

; Esegue shift a destra di 8 bits della mantissa temporanea FOP
; In:	A = -N (numero di bit residui da shiftare)
; Out:	A = bits di guardia
;	Y = 0
;	CF = 0
; Uso:	A,X,Y
; Note:	Chiamata solo per shift a destra di 1 byte
_RShiftFOP:
	LDX	#(FOP-1)

; Esegue shift a destra di 8 bits della mantissa indicizzata da X
; In:	A = -N (numero di bit residui da shiftare)
;	X = puntatore - 1 alla mantissa
; Uso:	A,X,Y
; Note:	Chiamata solo per shift a destra di 1 byte
_RShiftX8:
	LDY	<1,X		; shifta a destra di 8 bit
	STY	FACEXT		; utilizzando i bits di guardia
	LDY	<2,X
	STY	<1,X
	LDY	<3,X
	STY	<2,X
	LDY	<4,X
	STY	<3,X
	LDY	<5,X
	STY	<4,X
	LDY	<6,X
	STY	<5,X
	LDY	<7,X
	STY	<6,X
	LDY	<8,X
	STY	<7,X	
	LDY	#0		; byte MSB = 0
	STY	<8,X
	
	; ora shifta bit residui

; Esegue shift a destra di N bits della mantissa indicizzata da X
; In:	A = -N (numero di bit da shiftare negativo)
;	X = puntatore - 1 alla mantissa
;	CF = 0 
; Out:	A = bits di guardia
;	Y = 0
;	CF = 0
; Uso:	A,X,Y
; Note:	main entry per shift a destra
_RShiftXB:
	ADC	#$08		; numero residuo di bits
	BMI	_RShiftX8	; CF = 0, N > 8, shifta byte per byte
	BEQ	_RShiftX8	; CF = 1, N = 8, shifta byte per byte
	
	; se A = F8 (-8) arriva qui con A = 9 e CF = 0
	; ae arriva qui allora N < 8, CF = 1 -- shift bit a bit
	; ripristina A
	SBC	#$08		; se N < 8 => CF = 0, se N >= 0 => CF = 1
	TAY			; shifta Y bits a destra
	LDA	FACEXT
	BCS	_RTS3		; fine shift
	
; Esegue shift a destra di N (<8) bits della mantissa indicizzata da X
; In:	Y = -N (numero di bit da shiftare negativo)
;	X = puntatore - 1 alla mantissa
;	A = bits di guardia
; Out:	A = bits di guardia
;	Y = 0
;	CF = 0
; Uso:	A,X,Y
; Note:	Usare solo per shift a destra < 8 bits 
_RShiftXN:
	xba			; B = bit di guardia
	ACC16
?01:	lsr	<7,x		; MSB = 0
	ROR	<5,X
	ROR	<3,X
	ROR	<1,X	
	ROR	A		; aggiorna bit di guardia
	INY
	BNE	?01		; bit shift loop
	ACC08
	xba			; A = bit di guardia
_RTS3:	CLC
	RTS

;-------------------------------------------------------------
; IMPLEMENTAZIONE _feMUL
;-------------------------------------------------------------


; _feMULM: esegue prodotto di FAC e MEM e pone il risultato in FAC
; In:	CY -> puntatore alla memoria
;	FAC
; Out:	FAC = MEM * FAC
;	FPUST, per le eccezioni
; Uso:	A,X,Y,FOP
; Note:	Testare lo status in FPUST
_feMULM:
	JSR	_MovMem2A	; carica ARG da memoria
	 
; _feMUL: esegue prodotto di FAC e ARG e pone il risultato in FAC
; In:	FAC, ARG
; Out:	FAC = ARG * FAC
;	FPUST, per le eccezioni
; Uso:	A,X,Y,FOP
; Note:	Testare lo status in FPUST
_feMUL:
	JSR	multst		; test operandi FAC e ARG
?15:	SEC			; depolarizza exp(FAC) - 1
	ACC16
	LDA	FACExp
	SBC	#EXPBIAS
	STA	FACExp
	ACC08
	ldx	#$80		; flag MULT
	JSR	_AddExponent
	ACC16
	STZ	FOP		; clear area temporanea del risultato	
	STZ	FOP+2
	STZ	FOP+4
	STZ	FOP+6
	ACC08
	STZ	FOP+8	
	LDA	FACEXT		; moltiplica ogni byte di FAC
	JSR	_MultA		; per la mantissa di ARG
	LDA	FAC+1
	JSR	_MultA
	LDA	FAC+2
	JSR	_MultA
	LDA	FAC+3
	JSR	_MultA
	LDA	FAC+4
	JSR	_MultA
	LDA	FAC+5
	JSR	_MultA
	LDA	FAC+6
	JSR	_MultA
	LDA	FAC+7
	JSR	_MultA
	LDA	FAC+8
	JSR	_MultB

_CopyFOP:
	ACC16
	LDA	FOP		; copia il risultato da POP a FAC
	STA	FAC+1
	LDA	FOP+2
	STA	FAC+3
	LDA	FOP+4
	STA	FAC+5
	LDA	FOP+6
	STA	FAC+7
	ACC08
	lda	FACUndf		; underflow ?
	beq	?10		; NO -- normalizza
	ldx	#FAC
	CMP	#$F9		; test N < -7
	BPL	?04		; N >= -7, shift bit x bit (CF = 1)
	JSR	_RShiftXB	; N < -7, shifta byte x byte (CF = 0)
	;BRA	?10		; FAC denormalizzato con exp = 0
	bra	?06
?04:	TAY			; Y = -N
	LDA	FACEXT		; A = bit di guardia
	JSR	_RShiftXN	; shift bit x bit (CF = 0)
?06:	jmp	_feXAM	
?10:	JMP	_Normalize	; normalizza FAC

; moltiplica byte x mantissa
; In:	A = byte
;	ARG
; Out:	FOP = A * ARG
; Uso:	A,X,Y,FOP
_MultA:
	BNE	_MultB
	JMP	_RShiftFOP	; se A = 0 shift a destra di 8 bit di FOP
_MultB:
	LSR	A
	ORA	#$80
?01:	TAY
	ACC16
	BCC	?02
	CLC
	LDA	FOP
	ADC	ARG+1
	STA	FOP
	LDA	FOP+2
	ADC	ARG+3
	STA	FOP+2
	LDA	FOP+4
	ADC	ARG+5
	STA	FOP+4
	LDA	FOP+6
	ADC	ARG+7
	STA	FOP+6
?02:	ROR	FOP+6
	ROR	FOP+4
	ROR	FOP+2
	ROR	FOP
	ACC08
	ROR	FACEXT
	TYA
	LSR	A
	BNE	?01
	RTS

; Imposta l'esponente di FAC per FMUL/FDIV
; In:	FAC (con esponente depolarizzato), ARG
;	Se chiamata da FDIV l'esponente di FAC deve
;	essere cambiato di segno
;	ACC16
; Out:	exp(FAC) = exp(FAC) + exp(ARG)
;	sgn(FAC) corretto
; Uso:	A,X
; Note:	Puo' generare overflow/underflow.
;	In tal caso viene scartato direttamente
;	l'indirizzo di ritorno e FMUL/FDIV terminano
;	in modo prematuro.
;
;	NOTA -- si assume valido esponente polarizzato range $0000 - $7FFE
;	I valori ammessi per l'esponente depolarizzato sono:
;	exp+ -> $0000 - $3FFF (0,MAXPEXP)
;	exp- -> $C001 - $FFFF (MINNEXP, -1) -- NO: C002..$FFFF
;	
;	quindi la somma (signed) degli esponenti puo' assumere i
;	valori seguenti:
;	
;	(exp+) + (exp+) -> $00000 - $07FFE -> puo' causare overflow
;	(exp+) + (exp-) -> $0C001 - $0FFFF - $10000 - $13FFE
;	(exp-) + (exp+) -> $0C001 - $0FFFF - $10000 - $13FFE
;	(exp-) + (exp-) -> $18002 - $1FFFE -> puo' causare underflow
;
;	Il nuovo esponente polarizzato si calcola ignorando il carry
;	dalla somma signed precedente ed aggiungendo il bias $3FFF:
;	(exp+) + (exp+) -> $03FFF - $0BFFD -> puo' causare overflow (CF = 0)
;	(exp+) + (exp-) -> $00000 - $07FFD -> sempre corretto (CF = 0)
;	(exp-) + (exp+) -> $00000 - $07FFD -> sempre corretto (CF = 0)
;	(exp-) + (exp-) -> $0C001 - $0FFFF -> range $8002..$C000 (CF = 0)
;	(exp-) + (exp-) -> $10000 - $13FFD -> range $C001..$FFFE (CF = 1)
;
;	per operazione MULT occorre incrementare di 1 esponente polarizzato
;
;	si puo' verificare OVERFLOW nel primo caso (exp >= EXPINF)
;	si verifica UNDERFLOW nel quarto caso (exp in $C001..$FFFF)
;	OVERFLOW va testato dopo operazione MULT/DIV e normalizzazione, dato
;	che lo shift a sinistra della mantissa causa il decremento di exp.
;	e quindi si potrebbe ottenere un numero finito normalizzato. Lo shift
;	ruota la massimo 72 bit (compresi gli 8 bit di guardia) quindi se exp
;	supera di 80 bit il max. siamo sicuramente in condizione di overflow.
;	quindi si ha sicuramente OVERFLOW se exp >= $7FFE + $50 = $804E
;	la condizone di UNDERFLOW e' piu' complicata: si puo' assumere che
;	il numero venga azzerato fino a quando exp < -80 ovvero exp < $FFB0
;	se exp >= FFB0 si puo' tentare di denormalizzare il risultato con
;	una serie di shift a destra in modo da incrementare exp fino alla
; 	condizione exp = 0 ed ottenere un underflow graduale

_AddExponent:
	stx	FACMlt		; flag MULT
	stz	FACUndf		; azzera shift underflow
	LDX	FACSCMP		; MULT/DIV: sgn(FAC) = confronto segni
	STX	FACSGN
	ACC16
	SEC			; depolarizza exp(ARG)
	LDA	ARGExp
	SBC	#EXPBIAS
	clc
	adc	FACExp		; C = nuovo esponente depolarizzato di FAC
	clc			; ignora carry
	ldx	FACMlt
	bpl	?02
	sec			; MULT richiede incremento esponente
?02:	adc	#EXPBIAS	; polarizza exp FAC
	sta	FACExp
	bcs	?08		; OK
	cmp	#EXPINF
	bcc	?08		; OK
	cmp	#$C000
	bcs	?04		; test underflow
	cmp	#$804E		; overflow immediato ?
	bcc	?08		; NO -- dopo normalizzazione
	jmp	_ldinf0		; load INF ed esce
?04:	cmp	#$FFB0		; underflow immediato ?
	bcs	?06		; NO -- dopo MULT/DIV
	jmp	_ldz1		; UNDERFLOW immediato: FAC = 0
?06:	tax			; C low = A => numero shift destra
	dex
	stx	FACUndf
	stz	FACExp		; underflow graduale -- denormalizza
?08:	ACC08
_RTS5:	rts
	
; _feMUL10: Funzione veloce che moltiplica FAC per 10
; In:	FAC
; Out:	FAC = FAC*10
;	CF = 1 se overflow
; Uso: 	A,X,Y
_feMUL10:
	JSR	_feXAM		; esamina FAC
	bcs	_RTS5		; FAC non valido (C = 1)
	beq	_RTS5		; FAC = 0 -- esce (C = 0)
	JSR	_RoundSkp	; arrotonda FAC ed esce in caso di errore
	JSR	_MovF2A		; copia FAC in ARG
	ACC16
	lda	FACExp
	inc	a
	inc	a		; FAC = FAC * 4
	sta	FACExp
	CMP	#EXPINF		; test overflow
	ACC08
	bcs	?20		; overflow
	JSR	_feADD		; FAC = FAC + (FAC*4) = 5*FAC
	bcs	_RTS5		; errore
	ACC16
	lda	FACExp
	inc	a		; FAC = 2 * (5 * FAC) = 10 * FAC
	sta	FACExp
	CMP	#EXPINF		; test overflow
	ACC08
	bcs	?20		; overflow
	jmp	_Normalize
?20:	jmp	_feLDINF1	; FAC = INF con segno di FAC		

;-------------------------------------------------------------
; IMPLEMENTAZIONE _feDIV
;-------------------------------------------------------------

; _feDIV10: esegue divisione di FAC per 10 e pone il risultato in FAC
; In:	FAC
; Out:	FAC = FAC/10
;	FPUST, per le eccezioni
; Uso:	A,X,Y,FOP
; Note:	Testare lo status in FPUST
_feDIV10:
	LDA	#.HIGH.FCon1E1
	xba
	LDA	#.LOW.FCon1E1		; LOAD = 10.0
	LDY	#.SEG.FCon1E1

; _feDIVRM: esegue FAC / MEM -> FAC
; In:	CY -> MEM
;	FAC valido
; Out:	FAC = FAC / MEM
;	FPUST, per le eccezioni
; Uso:	C,X,Y,FOP, ARG
; Note:	Testare lo status in FPUST
_feDIVRM:
	STA	PTR1			; salva puntatore mem
	xba
	sta	PTR1+1
	STY	PTR1+2
	JSR	_RoundSkp		; arrotonda FAC, esce se errore
	JSR	_MovF2A			; copia FAC in ARG
	JSR	_MovMem2Fa		; FAC = MEM

; _feDIV: esegue divisione ARG / FAC e pone il risultato in FAC
; In:	FAC, ARG
; Out:	FAC = ARG/FAC
;	FPUST, per le eccezioni
; Uso:	A,X,Y,FOP
; Note:	Testare lo status in FPUST
_feDIV:
	JSR	divtst		; test operandi FAC ed ARG
?12:	JSR	_RoundSkp	; arrotanda FAC ed esce in caso di eccezione
	ACC16
	LDA	FACExp		; depolarizza esponente
	SEC			; e gli cambia segno
	SBC	#EXPBIAS
	EOR	#$FFFF
	inc	a
	sta	FACExp
	ACC08
	ldx	#$00		; flag DIV
	JSR	_AddExponent

__fdiv__:
	ldx	#8
	LDA	#$01
?01:	LDY	ARG+8
	CPY	FAC+8
	BNE	?02	
	LDY	ARG+7
	CPY	FAC+7
	BNE	?02
	LDY	ARG+6
	CPY	FAC+6
	BNE	?02
	LDY	ARG+5
	CPY	FAC+5
	BNE	?02
	LDY	ARG+4
	CPY	FAC+4
	BNE	?02
	LDY	ARG+3
	CPY	FAC+3
	BNE	?02
	LDY	ARG+2
	CPY	FAC+2
	BNE	?02
	LDY	ARG+1
	CPY	FAC+1
?02:	
?02b:	PHP
	ROL	A
	BCC	?03
	dex
	BMI	?07
	STA	<FOP,X
	BEQ	?06	
	LDA	#$01
?03:	PLP
	BCS	?05
?04:	ACC16	
	ASL	ARG+1
	ROL	ARG+3
	ROL	ARG+5
	ROL	ARG+7
	ACC08
	BCS	?02b
	BMI	?01
	BPL	?02b
?05:	TAY
	ACC16
	LDA	ARG+1
	SBC	FAC+1
	STA	ARG+1
	LDA	ARG+3
	SBC	FAC+3
	STA	ARG+3
	LDA	ARG+5
	SBC	FAC+5
	STA	ARG+5
	LDA	ARG+7
	SBC	FAC+7
	STA	ARG+7
	ACC08
	TYA
	BRA	?04
?06:	LDA	#$40
	BNE	?03
?07:	ASL	A
	ASL	A
	ASL	A
	ASL	A
	ASL	A
	ASL	A
	STA	FACEXT
	PLP
	JMP	_CopyFOP

;-------------------------------------------------------------
; Test operandi FAC e ARG per operazioni ADD, MULT, DIV
;-------------------------------------------------------------

; test preventivo su FAC ed ARG prima di _feADD
addtst:
	jsr	_fe2TST		; test FAC ed ARG e setta confronto segni
	bpl	?05		; FAC valido
	ldx	FACSGN		; esce con segno di FAC
	bvc	_ldnan0		; FAC = NAN => RESULT = NAN (con segno di FAC)
	BIT	ARGXM		; FAC = INF, necessario testare ARG
	bmi	?03
	jmp	_ldinf0		; ARG valido -> (INF + X) -> FAC = INF
?03:	bvc	_ldnan0		; ARG = NAN -> FAC = NAN
	BIT	FACSCMP		; FAC = INF e ARG = INF: cfr. segni
	BPL	_ldinf0		; +INF+INF o -INF-INF -> FAC = INF
	bmi	_ldnan0		; +INF-INF o -INF+INF -> FAC = NAN
?05:	BIT	ARGXM		; FAC valido -- test ARG
	BPL	?10		; ARG valido
	LDX	ARGSGN		; esce con segno di ARG
	BVC	_ldnan0		; ARG = NAN -> (X + NAN) -> FAC = NAN
	bvs	_ldinf0		; ARG = INF -> (X + INF) -> FAC = INF
?10:	bvs	_skpxam		; ARG = 0 => esce con FAC inalterato
	bit	FACXM		; test FAC = 0
	bvc	_RTSA		; esegue ADD
	jsr	_MovA2F		; FAC = 0 + ARG = ARG	
	
_skpxam:
	pla
	pla
	jmp	_feXAM

; test preventivo su FAC ed ARG prima di _feMUL
multst:
	JSR	_fe2TST		; test operandi FAC e ARG
	BPL	?05		; FAC valido -- testare ARG
	bvc	_ldnan1		; FAC = NAN => RESULT = NAN
	BIT	ARGXM		; FAC = INF -- test ARG
	BPL	?03		; ARG valido
	BVS	_ldinf1		; ARG = INF -> (INF * INF) => FAC = INF
	BVC	_ldnan1		; ARG = NAN -> (INF * NAN) => FAC = NAN
?03:	bvc	_ldinf1		; ARG <> 0  -> (INF * X) -> FAC = INF
	bvs	_ldnan1		; ARG = 0   -> (INF * 0) -> FAC = NAN
?05:	BIT	ARGXM		; FAC valido -- test ARG
	BPL	?10		; ARG valido
	BVC	_ldnan1		; ARG = NAN -> (X * NAN) -> FAC = NAN
	bit	FACXM		; ARG = INF -> necessario testare FAC
	bvc	_ldinf1		; FAC <> 0  -> (X * INF) -> FAC = INF
	bvs	_ldnan1		; FAC = 0   -> (0 * INF) -> FAC = NAN
?10:	bvs	_ldz1		; VF = 1 -> ARG = 0 -> (X * 0) -> FAC = 0
	bit	FACXM		; test flag zero FAC
	bvs	_ldz1		; VF = 1 -> FAC = 0 -> (0 * X) -> FAC = 0
_RTSA:
	rts			; OK -- esegue MULT

; test preventivo su FAC ed ARG prima di _feDIV
divtst:
	JSR	_fe2TST		; test operandi FAC ed ARG
	BPL	?05		; FAC valido
	bvc	_ldnan1		; FAC = NAN => RESULT = NAN
	BIT	ARGXM		; FAC = INF -- test ARG
	bmi	_ldnan1		; ARG = NAN/INF -> (NANINF / INF) -> FAC = NAN
	bpl	_ldz1		; ARG = X -> (X / INF) -> FAC = ZERO
?05:	bit	ARGXM		; FAC valido -- test ARG
	bpl	?10		; ARG valido
	bvc	_ldnan1		; ARG = NAN -> (NAN / X) -> FAC = NAN
	bit	FACXM		; ARG = INF -- testare FAC = 0
	bvc	_ldinf1		; FAC <> 0  -> (INF / X) -> FAC = INF
	bvs	_ldinfz		; FAC = 0 -> (INF / 0) -> FAC = INF e ZF = 1
?10:	bit	FACXM		; FAC ed ARG validi -- testare FAC = 0
	bvc	?14		; FAC non nullo
	bit	ARGXM		; FAC = 0 -- test ARG
	bvc	_ldinfz		; ARG <> 0 -> (X / 0) -> FAC = INF, ZF = 1
	bvs	_ldnanz		; ARG = 0 -> (0 / 0) -> FAC = NAN, ZF = 1
?14:	bit	ARGXM		; FAC <> 0 -- test ARG = 0
	bvs	_ldz1		; ARG = 0 -> (0 / X) -> FAC = 0
	rts

_ldnan1:
	ldx	FACSCMP		; segno risultato
	stx	FACSGN
_ldnan0:
	ply			; scarta indirizzo di ritorno
	ply
	bra	_feLDNAN1	; FAC = +/- NAN

_ldnanz:
	ldx	FACSCMP		; segno risultato
	ply			; scarta indirizzo di ritorno
	ply
	bra	_feLDNANZ	; FAC = +/- NAN, ZF = 1
	
_ldinf1:
	ldx	FACSCMP		; segno risultato
	stx	FACSGN
_ldinf0:
	ply			; scarta indirizzo di ritorno
	ply
	bra	_feLDINF1	; FAC = +/- INF

_ldinfz:
	ldx	FACSCMP		; segno risultato
	ply			; scarta indirizzo di ritorno
	ply
	bra	_feLDINFZ	; FAC = +/- INF, ZF = 1

_ldz1:
	ply			; scarta indirizzo di ritorno
	ply
	bra	_feLDZ		; FAC = +ZERO
	
;-------------------------------------------------------------
; Load FAC/ARG con valori speciali
;-------------------------------------------------------------

; _feLDINFZ: Imposta FAC = +/-INF e ZF
; In:	X = segno
; Out:	FAC = +/-INF
;	Flag come da _feXAM + ZF
; Uso:	A,Y,X
; Note:	FACSGN settato, FACEXT azzerato
_feLDINFZ:
	STX	FACSGN		; imposta segno FAC

; _feLDINF1Z: Imposta FAC = +/-INF e ZF
; In:	FACSGN = segno
; Out:	FAC = +/-INF
;	Flag come da _feXAM + ZF
; Uso:	A,Y,X
; Note:	FACSGN settato, FACEXT azzerato
;***************************************
_feLDINF1Z:
	ldy	#0		; ZF = 1, NF = 0
	beq	_fldinf
	
; _feLDINF: Imposta FAC = +/-INF
; In:	X = segno
; Out:	FAC = +/-INF
;	Flag come da _feXAM
; Uso:	A,Y,X
; Note:	FACSGN settato, FACEXT azzerato
_feLDINF:
	STX	FACSGN		; imposta segno FAC

; _feLDINF1: Imposta FAC = +/-INF
; In:	FACSGN = segno
; Out:	FAC = +/-INF
;	Flag come da _feXAM
; Uso:	A,Y,X
; Note:	FACSGN settato, FACEXT azzerato
_feLDINF1:
	ldy	#1		; ZF = 0, NF = 0

; ingresso per settare +/- INF e ZF
_fldinf:
	sep	#PVFLAG		; V = 1 => segnala INF
	ACC16
	lda	#MANTINF
	bra	_fldnv

; _feLDNANZ: Imposta FAC = +/-NAN e ZF = 1
; In:	X = segno
; Out:	FAC = +/-NAN
;	CF = 1, VF = 0, ZF = 1
; Uso:	A,Y,X
; Note:	FACSGN settato, FACEXT azzerato
_feLDNANZ:
	stx	FACSGN
	ldy	#0		; ZF = 1, NF = 0
	beq	_feLDNAN2

; _feLDNAN: Imposta FAC = +/-NAN
; In:	X = segno
; Out:	FAC = +/-NAN
;	CF = 1, VF = 0, ZF = 0
; Uso:	A,Y,X
; Note:	FACSGN settato, FACEXT azzerato
_feLDNAN:
	stx	FACSGN
	
; _feLDNAN1: Imposta FAC = +/-NAN
; In:	FACSgn
; Out:	FAC = +/-NAN
;	CF = 1, VF = 0, ZF = 0
; Uso:	A,Y,X
; Note:	FACSGN settato, FACEXT azzerato
;****************************************
_feLDNAN1:
	ldy	#1		; ZF = 0, NF = 0
_feLDNAN2:
	clv			; V = 0 => segnala NAN
	ACC16
	lda	#MANTNAN

; ingresso con ACC16
_fldnv:
	LONGA	on
	sta	FAC+7
	stz	FAC+5
	stz	FAC+3
	stz	FAC+1
	lda	#EXPINF
	sta	FACExp
	ACC08
	stz	FACEXT
	sec			; segnala errore
	tya			; imposta ZF, NF = 0
	php
	ldx	FACSGN
	bpl	?10
	lda	$01,s		; imposta NF
	ora	#$80
	sta	$01,s
?10:	plp
	rts

; _feLDZ - load ZERO in FAC
; Out flag : CF = VF = NF = 0, ZF = 1
_feLDZ:
	ACC16
	lda	#0		; ZF = 1, NF = 0
	sta	FAC+1
	sta	FAC+3
	sta	FAC+5
	sta	FAC+7
	sta	FACExp
	ACC08
	sta	FACSGN
	sta	FACEXT
	clc
	clv
	rts

;-------------------------------------------------------------
; ESAMINA REGISTRI FAC E ARG
;----------------------------------- -------------------------

; Esamina FAC ed ARG per operazioni con 2 operandi
; Lo status viene riportato nei bit 7 e 6 di FACXM e ARGXM
; secondo il seguente schema:
;	FACXM(7) -> FAC non valido (NAN o INF)
;	FACXM(6) -> FAC = INF (se bit 7 = 1)
;		 -> FAC = 0   (se bit 7 = 0)
;	ARGXM(7) -> ARG non valido (NAN o INF)
;	ARGXM(6) -> ARG = INF (se bit 7 = 1)
;		 -> ARG = 0   (se bit 7 = 0)
; Inoltre viene correttamente impostato il flag di
; confronto dei segni FACSCMP.
; In:	FAC, ARG
; Out:	FACXM, ARGXM
;	FLAG N, V come da 'bit FACXM'
;	CF = 1 se FAC non valido (NAN o INF)
; Uso:	A,X,FACXM,ARGXM
_fe2TST:
	LDA	ARGSGN		; imposta il flag confronto segni
	EOR	FACSGN
	STA	FACSCMP		; negativo se segni discordi
	jsr	_feXAMARG	; esamina ARG (A = 0)
	bcc	?02		; ARG valido
	lda	#$80		; bit 7 -> non valido
	bvc	?04		; NAN
	ora	#$40		; flag INF
	bra	?04
?02:	bne	?04
	lda	#$40		; flag ZERO
?04:	sta	ARGXM
	jsr	_feXAM		; esamina FAC (A = 0)
	bcc	?06		; FaC valido
	lda	#$80		; bit 7 -> non valido
	bvc	?08		; NAN
	ora	#$40		; flag INF
	bra	?08
?06:	bne	?08
	lda	#$40		; flag ZERO
?08:	sta	FACXM
	bit	FACXM		; ritorna flag C, N, V
	clc			; valido
	bpl	?18
	sec			; non valido
?18:	rts

; _feXAM e _feXAMARG impostano i flag nel seguente modo
;
;	CF = 0 => registro valido
;	NF = 1 => segno registro
;	ZF = 1 => se registro nullo e valido
;	VF = 1 => denormale
;
;	CF = 1 => registro non valido
;	NF = 1 => segno registro
;	VF = 0 => NAN se registro non valido
;	VF = 1 => INF se registro non valido
;	ZF = 0 => ignorare
	
; _feXAMARG: Esamina registro ARG
; In:
; Out:	P = ARG Status (C, N, V, Z)
;	X -> indice a ARG-1
;	A = 0
; Usa:	A,X
_feXAMARG:
	LDX	#ARGSGN
	BRA	_FXAM

; _feXAM: Esamina registro FAC
; In:
; Out:	P = FAC Status (C, N, V, Z)
;	X -> indice a FAC-1
;	A = 0
; Usa:	A,X
_feXAM:
	LDX	#FACSGN

; _FXAM: Esamina registro FAC/ARG
; In:	X -> indice a FAC-1 o ARG-1 (segno)
; Out:	P = FAC/ARG Status (C, N, V, Z)
;	A = 0
;	X -> indice a FAC o ARG
; Usa:	A,X
_FXAM:
	clv			; setta preventivamente V = 0
	ACC16
	LDA	<10,X		; test EXP
	beq	?04		; exp = 0 -- denormal o ZERO
	CMP	#EXPINF		; test INF/NAN
	; se CF = 0 => EXP valido -- numero valido non nullo
	; qui ZF = 0 e CF = 0 da confronto precedente
	bcc	?08		; C = V = Z = 0 => imposta N
	; se CF = 1 allora registro contiene INF o NAN
	lda	<8,x		; test mantissa NAN/INF	
	CMP	#MANTINF
	bne	?02		; NAN => V = 0
	sep	#PVFLAG		; INF => V = 1
?02:	sec			; CF = 1 => non valido
	dec	a		; imposta ZF = 0 (A >= EXPINF)	
	bcs	?08		; C, Z, V settati -- imposta N
	; ZERO o DENORMAL -- esamina mantissa
?04:	lda	<2,x		; imposta ZF
	ora	<4,x
	ora	<6,x
	ora	<8,x		; ZF = 1 => FAC/ARG = 0
	clc			; valido
	beq	?08		; ZERO => C = V = 0, Z = 1
	sep	#PVFLAG		; denormal => C = Z = 0, V = 1	
?08:	ACC08
	php			; salva status: V, Z, C
	lda	$01,s		; clear NF nello stack
	and	#$7F
	sta	$01,s
	lda	<0,x		; segno
	and	#$80		; maschera bit 7
	ora	$01,s		; imposta NF nello stack
	sta	$01,s
	lda	#0
	plp			; ripristina flag
	rts
	
;----------------------------------------------------------
; implementazione _feCMP, _feCMPM, _feSGN, _feCHS, _feABS
;----------------------------------------------------------

; _feCMP: Confronta FAC con ARG
; In:	FAC, ARG (supposti validi)
; Out:	A =  1 se FAC > ARG (ZF = 0, NF == 0)
;	A =  0 se FAC = ARG (ZF = 1)
;	A = -1 se FAC < ARG (ZF = 0, NF == 1)
; Uso:	A,X
; Note:	|INF| < |NAN|
_feCMP:
	jsr	_feXAMARG	; test ARG = 0
	BEQ	_feSGN		; ARG = 0 -> ritorna sgn(FAC)
	LDA	ARGSGN
	EOR	FACSGN
	BMI	_feSGN		; Segni discordi: ritorna sgn(FAC)
	ACC16			; CONFRONTA ESPONENTI
	lda	ARGExp
	cmp	FACExp
	BCC	_FSGN3		; FAC > ARG
	BNE	_FSGN3		; FAC < ARG (CF = 1)
	
	; gli esponenti sono uguali - confronto mantissa byte a byte
	LDA	ARG+7		; MSB mantissa ARG
	CMP	FAC+7
	BNE	_FSGN3
	LDA	ARG+5
	CMP	FAC+5
	BNE	_FSGN3
	LDA	ARG+3
	CMP	FAC+3
	BNE	_FSGN3
	ACC08
	LDA	ARG+2
	CMP	FAC+2
	BNE	_FSGN3
	LDA	#$7F		; bit di guardia
	CMP	FACEXT		; CF settato
	LDA	ARG+1
	SBC	FAC+1
	BNE	_FSGN3
	RTS			; FAC = ARG
	
; _feSGN: funzione che ritorna il segno di FAC
; In:	FAC (supposto valido)
; Out:	A =  1 se FAC > 0 (ZF = 0, NF == 0)
;	A =  0 se FAC = 0 (ZF = 1)
;	A = -1 se FAC < 0 (ZF = 0, NF == 1)
; Uso:	A, X
; Note:	NAN e INF assunti come validi
_feSGN:
	CPU08			; necessario !!!
	jsr	_feXAM		; test FAC = 0
	bne	_FSGN1
	lda	#0
	rts
_FSGN1:				; test segno FAC
	LDA	FACSGN
_FSGN2:				; test segno A
	ROL	A
	LDA	#$FF
	BCS	_RTS7
	LDA	#$01
_RTS7:
	RTS	
_FSGN3:
	CPU08			; necessario
	LDA	FACSGN		; segno FAC
	BCC	_FSGN2		; FAC > Float MEM (o ARG)
	EOR	#$FF		; inverte segno
	BRA	_FSGN2		; FAC < Float MEM (o ARG)			

	
; _feCMPM: Confronta FAC con MEM
; In:	CY -> puntatore memoria MEM
; Out:	A =  1 se FAC > MEM (ZF = 0, NF == 0)
;	A =  0 se FAC = MEM (ZF = 1)
;	A = -1 se FAC < MEM (ZF = 0, NF == 1)
; Uso:	A, B,PTR1,Y,X
; Note:	Nessuna eccezione se FAC e/o Float MEM non valid1
_feCMPM:
	STA	PTR1		; puntatore memoria
	xba
	STA	PTR1+1
	STY	PTR1+2
	LDY	#$08
	CPU16
	lda	[PTR1],y	; EXP
	tax			; salva esponente in X
	and	#$7FFF		; maschera segno
	dey
	dey
?01:	ora	[PTR1],y	; test zero
	dey
	dey
	bpl	?01
	tay
	BEQ	_feSGN		; Float MEM = 0: ritorna sgn(FAC)
	txa			; segno
	xba			; A = segno
	ACC08
	EOR	FACSGN
	BMI	_feSGN		; Segni discordi: ritorna sgn(FAC)
	ACC16
	txa
	and	#$7FFF		; esponente
	cmp	FACExp
	BCC	_FSGN3		; FAC > MEM
	BNE	_FSGN3		; FAC < MEM (CF = 1)
	; gli esponenti sono uguali -- compare mantisse
	INDEX08
	ldy	#6
	lda	[PTR1],y	; MSB mantissa Float MEM
	CMP	FAC+7
	BNE	_FSGN3
	dey
	dey
	lda	[PTR1],y
	CMP	FAC+5
	BNE	_FSGN3
	dey
	dey
	lda	[PTR1],y
	CMP	FAC+3
	BNE	_FSGN3
	dey
	CPU08
	lda	[PTR1],y
	CMP	FAC+2
	BNE	_FSGN3
	dey
	LDA	#$7F		; bit di guardia
	CMP	FACEXT		; CF settato
	lda	[PTR1],y
	SBC	FAC+1
	BNE	_FSGN3
	RTS			; FAC = Float MEM

; _feCHS: cambia segno a FAC
; In:	FAC supposto valido
; Out:	FAC = -FAC
; Uso:	A
; Note: INF e NAN assunti come validi
_feCHS:
	jsr	_feXAM
	BEQ	?01
	LDA	FACSGN
	EOR	#$FF
	STA	FACSGN
?01:	RTS

; _feABS: rende assoluto FAC
; In:	FAC supposto valido
; Out:	FAC = |FAC|
; Uso:
; Note: Nessuna eccezione se FAC non valido
_feABS:
	STZ	FACSGN
	RTS

;----------------------------------------------------------
; Funzioni move memoria/fac/arg
;----------------------------------------------------------

; _MovRF2Tmp: Arrotonda FAC e lo copia nel reg. temporaneo
; In:	FAC valido
; Out:	FAC arrotondato copiato nel reg. temporaneo
; Note: FACEXT azzerato
_MovRF2Tmp:	
	JSR	_Round
	STZ	FACEXT
	LDX	#(FACSIZE+1)	; 12 bytes
?01:	lda	<FACSGN,x
	sta	<FACTmp,x
	dex
	bpl	?01
	rts

; _MovTmp2A: Carica ARG da registro FAC temporaneo
; In:	FACTmp valido
; Out:	ARG caricato da memoria
; Uso:	A, X
; Note:	ARGSGN settato, ARGEXT azzerato
_MovTmp2A:
	LDX	#(FACSIZE+1)
?01:	lda	<FACTmp,x
	sta	<ARGSGN,x
	dex
	bpl	?01
	STZ	ARGEXT
	rts
	
; _MovF2Mem: Copia FAC in memoria
; In:	CY -> ptr memoria
; Out:	FAC copiato in memoria
; Uso:	C,Y,PTR1
; Note: FACEXT azzerato
_MovF2Mem:	
	STA	PTR1
	xba
	STA	PTR1+1
	STY	PTR1+2
	BRA	_FSTMEM

; _MovRF2Mem: Arrotonda FAC e lo copia in memoria
; In:	CY -> ptr memoria
; Out:	FAC arrotondato copiato in memoria
; Uso:	C,Y,PTR1
; Note: FACEXT azzerato
;	Carica anche INF / NAN
_MovRF2Mem:	
	STA	PTR1
	xba
	STA	PTR1+1
	STY	PTR1+2
	JSR	_Round
_FSTMEM:
	LDY	#0
	ACC16
	LDA	FAC+1
	STA	[PTR1],Y
	iny
	iny
	LDA	FAC+3
	STA	[PTR1],Y
	iny
	iny
	LDA	FAC+5
	STA	[PTR1],Y
	iny
	iny
	LDA	FAC+7
	STA	[PTR1],Y
	iny
	iny
	ACC08
	LDA	FACSGN
	AND	#$80
	xba
	lda	#0
	ACC16
	ora	FACExp
	STA	[PTR1],Y
	ACC08
	ldy	#0
	STY	FACEXT
	RTS

; _MovMem2F: Carica FAC da memoria
; In:	CY -> ptr memoria
; Out:	FAC caricato da memoria
; Uso:	C,Y,PTR1
; Note:	FACSGN settato, FACEXT azzerato
_MovMem2F:
	STA	PTR1
	xba
	sta	PTR1+1
	STY	PTR1+2
_MovMem2Fa:
	LDY	#0
	ACC16
	LDA	[PTR1],Y
	STA	FAC+1
	iny
	iny
	LDA	[PTR1],Y
	STA	FAC+3
	iny
	iny
	LDA	[PTR1],Y
	STA	FAC+5
	iny
	iny
	LDA	[PTR1],Y
	STA	FAC+7
	iny
	iny
	LDA	[PTR1],Y
	xba
	tay			; Y = segno
	xba
	and	#$7FFF
	sta	FACExp
	STY	FACSGN
	ACC08
	ldy	#0
	STY	FACEXT
	RTS

; _MovMem2A: Carica ARG da memoria
; In:	CY -> ptr memoria
; Out:	ARG caricato da memoria
; Uso:	C,Y,PTR1
; Note:	ARGSGN settato, ARGEXT azzerato
_MovMem2A:
	STA	PTR1
	xba
	sta	PTR1+1
	STY	PTR1+2
	LDY	#0
	ACC16
	LDA	[PTR1],Y
	STA	ARG+1
	iny
	iny
	LDA	[PTR1],Y
	STA	ARG+3
	iny
	iny
	LDA	[PTR1],Y
	STA	ARG+5
	iny
	iny
	LDA	[PTR1],Y
	STA	ARG+7
	iny
	iny
	LDA	[PTR1],Y
	xba
	tay			; Y = segno
	xba
	and	#$7FFF
	sta	ARGExp	
	STY	ARGSGN
	ACC08
	ldy	#0
	STY	ARGEXT
	RTS

; _MovA2F:  Copia ARG in FAC
; In:	ARG
; Out:	ARG -> FAC
; Uso:	A,X
; Note:	FACSGN settato, FACEXT azzerato
_MovA2F:
	LDA	ARGSGN
	
; Copia ARG in FAC e setta il segno in A
_MovA2FS:
	STA	FACSGN
	LDX	#FACSIZE
?01:	LDA	<ARG,X
	STA	<FAC,X
	DEX
	BNE	?01
	STX	FACEXT
	RTS

; _MovRndF2A: Arrotonda FAC e lo copia in ARG
; In:	FAC
; Out:	FAC arrotondato -> ARG
; Uso:	A,X,Y
; Note:	ARGSGN settato, FACEXT e ARGEXT azzerati
;	PUO' GENERARE ECCEZIONI
_MovRndF2A:
	JSR	_Round		; arrotonda FAC: pu causare eccezioni

; _MovF2A: Copia FAC in ARG
; In:	FAC
; Out:	FAC -> ARG
; Uso:	A,X,Y
; Note:	ARGSGN settato, FACEXT e ARGEXT azzerati
_MovF2A:	
	LDA	FACSGN
	STA	ARGSGN
	LDX	#FACSIZE
?01:	LDA	<FAC,X
	STA	<ARG,X
	DEX
	BNE	?01
	STX	FACEXT
	STX	ARGEXT
_RTS6c:	clc
_RTS6:	RTS

;-------------------------------------------------------------
; Calcola potenza di 10: FAC = FAC*(10^C)
;-------------------------------------------------------------

; In	- C -> potenza di 10 (signed)
;	- FAC valido
;
; Out	- FAC * (10 ^ FPExp)
; USO: FPWTmp7, FPWTmp8, FPExp
_fePOW10:
	ACC16
	sta	FPExp
	ldx	#0
	bit	FPExp
	bpl	?00		; C positivo
	txa			; C = 0
	dex			; C negativo
	sec
	sbc	FPExp		; complementa
	sta	FPExp
?00:	stx	FPWTmp8		; flag segno C
	cmp	#4096		; limite max
	ACC08
	bcc	?04		; M < 4096
	; M = 4096
?01:	LDA	#.HIGH.FCon1E4096
	xba
	LDA	#.LOW.FCon1E4096
	LDY	#.SEG.FCon1E4096
	bit	FPWTmp8
	bmi	?02		; div
	JSR	_feMULM		; FAC = FAC*10^4096
	BCS	_RTS6		; eccezione -> esce
	BCC	?03
?02:	JSR	_feDIVRM	; FAC = FAC/10^4096
	BCS	_RTS6		; eccezione -> esce
?03:	jsr	_Round		; ****
	bcs	_RTS6		; ****
	ACC16
	SEC			; M = M - 4096
	lda	FPExp
	sbc	#4096
	sta	FPExp
	ACC08
?04:	LDA	FPExp		; ora M < 4096
	ORA	FPExp+1
	BEQ	_RTS6c		; se M = 0 esce con C = 0
	jsr	_MovRF2Tmp	; round FAC -> registro temporaneo	
?04a:	BCS	_RTS6		; eccezione -> esce
	LDA	FPExp
	AND	#7		; calcola offset costanti 1e0 - 1e7
	STA	FPWTmp8+1
	ASL	A		; moltiplica x 10
	ASL	A
	CLC
	ADC	FPWTmp8+1
	ASL	A
	CLC
	ADC	#.LOW.FCon1E0
	xba
	LDA	#.HIGH.FCon1E0
	BCC	?05
	INC	A
?05:	xba	
	LDY	#.SEG.FCon1E0
	JSR	_MovMem2F	; FAC = 1e0..1e7
	ACC16
	lda	FPExp		; divide FPExp x 8
	LSR	A
	LSR	A
	LSR	A
	STA	FPExp
	LDA	#FCon1E8
	STA	FPWTmp7		; indirizzo 1E8
	ACC08
	BRA	?11
?08:	LSR	FPExp+1		; divide x 2
	ROR	FPExp
	BCC	?10
	LDA	FPWTmp7+1	; FAC = FAC * (1E8..1E4096)
	xba
	LDA	FPWTmp7
	LDY	#.SEG.FCon1E0
	JSR	_feMULM
	BCS	?04a		; eccezione -> esce
	
	jsr	_Round		; ****
	BCS	?04a		; ****
	
?10:	CLC
	LDA	FPWTmp7
	ADC	#10
	STA	FPWTmp7
	BCC	?11
	INC	FPWTmp7+1
?11:	LDA	FPExp
	ORA	FPExp+1
	BNE	?08
	jsr	_MovTmp2A	; FAC temporaneo -> ARG	
	bit	FPWTmp8		; segno
	bmi	?12
	jsr	_feMUL
	bra	?14
?12:	jsr	_feDIV
?14:	jmp	_Round

;-------------------------------------------------------------
; Scala FAC in modo che sia 1E18 <= FAC <= MAX UINT
;-------------------------------------------------------------

; _feSCALE10 - scala FAC e calcola esponente decimale
; In	- FAC positivo
; Out	- 1E18  <= FAC <= MAX UINT
;	  XVDec -> esponente decimale (signed)
;	  Se FAC >= 1E19 XVDec va incrementato
; NOTA - ARG, ACM, IARG distrutti
_feSCALE10:
	; si determina una stima per difetto dell'esponente decimale.
	; Per il calcolo approssimato si esegue la moltiplicazione (signed)
	; di [LOG10(2) * $10000] per esponente di FAC
	ACC16
	sec			; depolarizzazione esponente
	lda	FACExp
	sbc	#EXPBIAS
	sta	ACM		; ACM, ACM+1 -> esponente
	lda	#LOG2H		; LOG10(2) * $10000 
	sta	IARG
	ACC08
	jsr	_iSMult16	; signed mult 16 x 16
	
	; la stima dell'esponente si trova nei 16 bit alti del risultato
	ACC16
	lda	ACM+2
	sta	XVDec
	
	; si calcola ora lo scalamento di FAC per fare in modo che sia
	; compreso tra 1E18 ed 1E19
	sec
	lda	#MAXDIGITS-1
	sbc	XVDec
	
	; C = potenza di 10 per scalare FAC
	ACC08
	jsr	_fePOW10	; scala FAC e arrotonda
	lda	#.HIGH.FCon1E19
	xba
	lda	#.LOW.FCon1E19	; confronta FAC con 1E19
	ldy	#.SEG.FCon1E19
	jsr	_feCMPM
	bmi	?40		; FAC < 1E19 => test FAC >= 1E18
	ACC16
	lda	FACExp		; situazione in cui ci sono
	cmp	#BIASQWORD	; 20 cifre significative
	ACC08
	beq	?50		; 1E19 <= FAC <= MAX UINT (20 digit)
	jsr	_feDIV10	; FAC > MAX UINT => FAC = FAC/10
	jsr	_Round
	ACC16
	inc	XVDec		; incrementa esp. decimale
	ACC08
	rts
?40:	lda	#.HIGH.FCon1E18
	xba
	lda	#.LOW.FCon1E18	; confronta FAC con 1E18
	ldy	#.SEG.FCon1E18
	jsr	_feCMPM
	bpl	?50		; FAC > 1E18
	beq	?50		; FAC = 1E18
	jsr	_feMUL10	; FAC = FAC * 10
	jsr	_Round
	ACC16
	dec	XVDec		; decrementa esp. decimale
	ACC08
?50:	rts
	
;-------------------------------------------------------------
; CONVERSIONE DA FLOAT POINT NUMBER A INTEGER 64 BIT
;-------------------------------------------------------------

; Converte FAC in UNSIGNED INTEGER 64 bit
; In:	FAC
; Out:	INTEGER con MSB in IARG+7, LSB in IARG
;	Y = 0
;	CF = 1 in caso di errore (overflow)
; Uso:	A,X,Y - FAC distrutto
; Note:	La conversione avviene mediante shift a destra fino
;	a quando la parte frazionaria e' fuori mantissa
;	L'esponente deve essere compreso tra $00 e $3F
_feFAC2I:
	ACC16	
	STZ	IARG		; azzera risultato
	STZ	IARG+2
	STZ	IARG+4
	STZ	IARG+6
	lda	FACExp
	beq	?10		; result = 0 -- OK (CF = 0)
	cmp	#EXPBIAS	; EXP < 0 => result = 0 (CF = 0)
	bcc	?10
	cmp	#BIASQWORD+1
	bcs	?20		; EXP > $3F => overflow (CF = 1)
	SEC			; depolarizza esponente
	SBC	#EXPBIAS
	ACC08			; B = 0, A = 00..3F
	SBC	#FACMBITS	; A = numero shift a destra (negativo)
	inc	a
	beq	?05		; no shift -- copia FAC in IARG
	LDX	#FAC		; puntatore FAC
	CMP	#$F9		; numero di shift a destra
	BPL	?02		; shift bit x bit
	; qui CF = 0
	JSR	_RShiftXB	; shift byte x byte			
	BRA	?05
?02:	TAY
	BEQ	?05		; nessuno shift da effettuare
	JSR	_RShiftXN
?05:	ACC16
	lda	FACM
	sta	IARG
	lda	FACM+2
	sta	IARG+2
	lda	FACM+4
	sta	IARG+4
	lda	FACM+6
	sta	IARG+6
?10:	ACC08
	CLC
	RTS
?20:	ACC08
	SEC
	RTS

;-------------------------------------------------------------
; CONVERSIONE DA STRINGA A FLOATING POINT NUMBER
;-------------------------------------------------------------

_Str2Fl:
	CPU08
	rep	#(PNFLAG.OR.PVFLAG.OR.PCFLAG.OR.PZFLAG)
	php
	phb			; salva DBR
	phd			; salva DPR
	pea	#DP02ADDR	; imposta DPR a pag 2
	pld
	ldy	#0
	phy
	plb			; imposta DBR su banco 0
	
	; relativo stack: 01 -> DPR, 03 -> DBR, 04 -> P

	ACC16
	sta	PTR1		; long ptr stringa
	stz	FPExp
	ACC08
	stx	PTR1+2	
	jsr	_feLDZ		; azzera FAC
	stz	FPFlag
	stz	FPDCnt
	LDY	#$FF
?02:	INY
	CPY	#MAXDECSTR
	bcc	?02a
	jmp	?15		; fine stringa
?02a:	LDA	[PTR1],Y	; elimina spazi iniziali
	bne	?02b
	jmp	?15		; fine stringa
?02b:	CMP	#' '
	BEQ	?02		; scarta spazio
	CMP	#'+'
	BEQ	?03		; scarta segno +
	CMP	#'-'
	BNE	?04
	lda	#$80
	tsb	FPFLAG		; FPFLAG[7] = segno - mantissa
?03:	INY			; next char
	CPY	#MAXDECSTR
	BEQ	?15
?04:	LDA	[PTR1],Y	; carica digit
	BEQ	?15		; fine stringa	
	SEC			; next digit decimale
	SBC	#('0'+10)
	CLC
	ADC	#10
	BCC	?06		; no digit
	tax			; X = digit
	lda	#$20
	bit	FPFLAG		; test bit 5
	bne	?05		; processa digit esponente
	lda	#$10
	tsb	FPFLAG		; FPFLAG[4] -> flag digit mantissa
	txa			; A = digit
	JSR	_AddDigit	; aggiunge digit a FAC
	bcc	?03		; ok, next char
	bcs	?12		; errore overflow, fine processo
?05:	; processa digit esponente
	lda	#$04
	tsb	FPFLAG		; FPFLAG[2] -> flag digit esponente
	txa			; A = digit	
	JSR	_AddExpDigit
	BCC	?03		; ok, next exp digit
	BCS	?12		; overflow esponente, fine processo
?06:	; no digit: test per dot decimale o esponente
	ADC	#'0'
	CMP	#'.'
	BNE	?07
	; char corrente '.' -- se non vi sono digit precedenti -> errore
	lda	#$10
	bit	FPFLAG		; test bit 4
	BEQ	?20		; non vi sono digit precedenti -> errore
	BIT	FPFLAG		; test dot gia' presente
	BVS	?20		; dot gia' processato -> errore
	lda	#$40
	tsb	FPFLAG		; set bit 6 -> dot
	bra	?03		; next char
?07:	CMP	#'E'
	BEQ	?08		; -> esponente
	CMP	#'e'
	BNE	?20		; carattere illegale -> errore
	; processa esponente decimale
?08:	lda	#$10
	bit	FPFLAG		; test bit 4
	BEQ	?20		; non vi sono digit precedenti -> errore
	lda	#$20
	tsb	FPFLAG		; FPFLAG[5] -> flag esponente 
	INY			; next char
	LDA	[PTR1],y
	BEQ	?15		; fine stringa
	CMP	#'+'
	BEQ	?03		; scarta segno +
	CMP	#'-'
	BNE	?04		; processa stesso char
	lda	#$08
	tsb	FPFLAG		; FPFLAG[3] = segno - esponente
	BRA	?03
	
?12:	; processa errore di overflow
	STY	FPIndx		; salva indice stringa
	ldx	FPFLAG		; segno attuale per INF
	JSR	_feLDINF	; FAC = +/- INF
	BRA	?99		; esce
	
	; entry fine stringa
?15:	lda	#$02	
	tsb	FPFLAG		; FPFLAG[1] -> flag fine stringa
	
	; entry per fine prematura processo scansione
?20:	STY	FPIndx		; salva indice Y
	lda	#$10
	bit	FPFLAG		; test bit 4
	bne	?22		; OK mantissa presente
?21:	JSR	_feLDNAN	; numero non valido -> invalid
	BRA	?99		; esce
	
?22:	lda	#$20
	bit	FPFLAG		; test bit 5
	beq	?25		; OK - no forma exp
	lda	#$04
	bit	FPFLAG		; test bit 2
	beq	?21		; errore -- forma exp ma mancano digit exp

?25:	; sintatticamente la conversione sembra corretta
	; si verificano ora le condizioni di overflow
	ACC16
	lda	FPExp
	cmp	#EXP10LIM
	ACC08
	bcs	?12		; overflow
	SEC
	LDA	#0		; cambia segno al numero di digit decimali
	SBC	FPDCNT
	STA	FPWTmp5		; salva -N (cifre dopo il punto decimale)
	LDA	#0
	SBC	#0
	STA	FPWTmp5+1
?27:	lda	#$08
	bit	FPFLAG		; test bit 3
	ACC16
	beq	?30		; exp positivo
	SEC
	lda	#0
	sbc	FPExp
	sta	FPExp		; esponente negativo, cambia segno
?30:	CLC
	lda	FPExp
	adc	FPWTmp5		; E = E + (-N)	
	ACC08
	JSR	_fePOW10
	bcs	?12		; overflow
	ldx	FPFLAG
	stx	FACSGN
	jsr	_feXAM		; get flag FAC
?99:	php			; salva flag
	pla			; A = flag
	and	#$C3		; maschera on N,V,C,Z
	ora	$04,s		; imposta N,V,C,Z nello stack
	sta	$04,s
	ACC16
	lda	PTR1
	ACC08
	ldx	PTR1+2		; CX => long ptr stringa
	ldy	FPIndx		; Y = indice primo chr dove si arresta conv.
	pld			; restore DPR
	plb			; restore DBR
	plp			; restore flag conversione
	RTS		

; esegue FAC = A + (FAC * 10)
_AddDigit:	
	PHY			; salva Y
	PHA			; salva A
	BIT	FPFLAG		; FPFLAG[6] -> dot decimale
	BVC	?01
	INC	FPDCNT		; incrementa contatore digit
?01:	JSR	_feMUL10	; FAC = FAC * 10
	bcs	?04		; errore
	JSR	_MovRndF2A	; copia FAC arrotondato in ARG
	bcs	?04		; errore
	PLA			; ripristina A
	JSR	_Byte2FAC	; converte byte in float
	bcs	?02
	JSR	_feADD		; FAC = (FAC * 10) + A
?02:	PLY			; ripristina Y
	RTS
?04:	pla
	ply
	rts
	
; Aggiunge un digit all'esponente FPExp
; In	- A = digit
;	- FPExp = esponente
;
; Out	- FPExp = (FPExp * 10) + A
; In caso di overflow -> CF = 1	
_AddExpDigit:
	xba
	lda	#0
	xba			; B = 0
	ACC16
	PHA			; salva C
	LDA	FPExp		; salva FPExp
	STA	FPWTmp5
	asl	a		; FPExp * 2
	bcs	?01
	asl	a		; FPExp * 4
	bcs	?01
	adc	FPWTmp5		; FPExp * 5
	bcs	?01
	asl	a		; FPExp * 10
	sta	FPExp
?01:	pla			; ripristina C
	bcs	?02
	adc	FPExp		; FPExp * 10 + A
	sta	FPExp
?02:	ACC08
	rts

; converte byte in floating point
; In:	A = byte
; Out:	FAC
; Uso:	A,X,Y
_Byte2FAC:
	STA	FAC+8
	STZ	FAC+7
	STZ	FACEXT
	STZ	FACSGN
	ACC16	
	STZ	FAC+5
	STZ	FAC+3
	STZ	FAC+1
	LDA	#BIASBYTE
	STA	FACExp
	ACC08
	JMP	_Normalize

;-------------------------------------------------------------
; CONVERSIONE DA FLOAT POINT NUMBER A STRINGA DECIMALE
;-------------------------------------------------------------

; _feFAC2S - converte FAC in stringa decimale
; In	- FAC caricato o da operazione precedente
;	  A<7> -> 0 (utilizzato per segno FAC)
; 	  A<6> -> formato G				$40
; 	  A<5> -> formato F (se <6> = 0)		$20
; 	  A<4> -> formato alternativo #			$10
; 	  A<3> -> CAPS formato (G, F, E)		$08
; 	  A<2> -> formato a/A				$04
; 	  A<1> -> blank se positivo			$02
; 	  A<0> -> segno '+'/blank se positivo		$01
;	  X -> precisione richiesta
;	  DPR -> DP02ADDR (pagina 02)
;	  DBR -> banco 0
;
; Out	- XCVTStr -> stringa decimale formattata
;	  A = Y = lunghezza stringa
;	  X = puntatore stringa
_feFAC2S:
	and	#$7F		; <7> -> segno FAC = 0
	sta	XVFlag		; salva flag
	bit	#$04
	beq	?00
	jmp	aform		; formato a/A	
?00:	; X = precisione
	cpx	#XCVTMAXF+1	; limite preventivo alla precisione
	bcc	?01
	ldx	#XCVTMAXF
?01:	bit 	XVFlag		; <6> -> VF test richiesta formato G
	bvc	?01b		; no G
	txy
	beq	?01c		; formato G -> se prec. = 0 -> prec = 1
	bne	?01z		; store prec. formato G
?01b:	lda	#$20		; richiesto formato E ?
	bit	XVFlag
	bne	?01z		; NO -- store prec
?01c:	inx			; formato E incrementa precisione	
				; dato che ha sempre un digit prima del dot
?01z:	stx	FmtPrec		; precisione richiesta (provvisoria)
	; la precisione per il formato F puo' essere controllata solo
	; dopo che e' stato determinato il numero di decimali
	bit	FACSGN		; testo segno FAC
	bpl	?02		; positivo
	lda	#$80		; <7> -> segno FAC = 1
	tsb	XVFlag		; imposta segno negativo
?02:	stz	FACSGN		; FAC = ABS(FAC)
	jsr	_feXAM		; esamina FAC
	beq	?06		; zero
	bcs	?03		; NAN/INF
	bvs	?06		; denormal => round to zero
	bvc	?16		; normale e valido
?03:	php			; salva V
	jsr	storesgn
	tyx			; X = indice stringa XCVTStr
	ldy	#0
	lda	#$08		; test CAPS
	bit	XVFlag
	bne	?04		; CAPS ON -> maiuscolo
	ldy	#$20		; converte in minuscolo
?04:	sty	FPTmp1
	plp			; ripristina V
	bvc	?04a		; NAN
	lda	#'F'		; store INF/inf
	sta	FPTmp2
	lda	#'N'
	xba
	lda	#'I'
	bra	?05
?04a:	lda	#'N'		; store NAN/nan
	sta	FPTmp2
	lda	#'A'
	xba
	lda	#'N'
?05:	ora	FPTmp1
	sta	<XCVTStr,x
	inx
	xba
	ora	FPTmp1
	sta	<XCVTStr,x
	inx	
	lda	FPTmp2
	ora	FPTmp1
	sta	<XCVTStr,x
	inx
	txy			; Y = lunghezza stringa
	jmp	?100		; termina stringa ed esce
	
	; zero o arrotondato a zero
?06:	lda	#$80		; <7> -> segno FAC = 0
	trb	XVFlag		; ZERO solo POSITIVO
	bit	XVFlag
	bvc	?07		; no formato G
	lda	#$20		; forza formato F se G true
	tsb	XVFlag
?07:	ldx	#MAXINTDGTS
	cpx	FmtPrec
	bcc	?07a
	beq	?07a
	ldx	FmtPrec		; numero di '0'
?07a:	stz	FPUStr+1,x	; terminatore stringa
	dex
	lda	#'0'		; stringa di '0'
?08:	sta	FPUStr+1,x
	dex
	bpl	?08
	stz	XVDec		; numero decimali
	stz	XVDec+1
	jmp	?90		; converte	
	
	; numero float normale -- si scala FAC in modo che sia:
	; 1E18 <= FAC <= MAX UINT (19/20 cifre significative)
?16:	jsr	_feSCALE10	
	jsr	_feFAC2I	; converte in intero tra 1E18 e MAX UINT
	ACC16			; copia IARG in FOP
	lda	IARG
	sta	FOP
	lda	IARG+2
	sta	FOP+2
	lda	IARG+4
	sta	FOP+4
	lda	IARG+6
	sta	FOP+6
	ACC08
	
	; a questo punto 1E18 <= IARG <= MAX UINT e si converte intero
	; in stringa decimale con 19/20 digits significativi
	; il punto decimale implicito si trova dopo il secondo digit
	jsr	_UI2Str		; punto decimale dopo secondo digit
	; A = lunghezza stringa (19 o 20)
	; Y = ptr primo digit
	cmp	#MAXDIGITS
	beq	?52		; 19 digit significativi
	ACC16			; 20 digit significativi
	inc	XVDec		; incrementa esponente decimale
	ACC08			; e il punto decimale sta dopo primo digit
	bra	?56
?52:	ldx	#0
?54:	lda	<FPUStr+2,x	; trasla indietro stringa di 19 digit
	beq	?55		; terminatore #0	
	sta	<FPUStr+1,x
	inx
	bra	?54
?55:	lda	#'0'		; aggiunge uno zero per avere 20 cifre
	sta	<FPUStr+1,x
	stz	<FPUStr+2,x	; termina stringa	
?56:	; a questo punto la conversione ha prodotto una stringa decimale base
	; di lunghezza fissa pari a 20 caratteri.
	; in base alla precisione e al formato richiesti occorre arrotondare
	; opportunamente il numero e decidere il formato corretto
	lda	FmtPrec		; estende FmtPrec a 16 bit
	sta	FPWTmp
	stz	FPWTmp+1
	bit 	XVFlag		; <6> -> VF test richiesta formato G
	bvc	?70		; no formato G
	jsr	testg
	bcs	?80		; imposta formato E -- round con FmtPrec
	bcc	?72		; test max esponente positivo formato F
?70:	lda	#$20		; test formato F
	bit	XVFlag
	beq	?80		; NO -- richiesto formato E, round con FmtPrec
	ACC16			; calcola digit round
	clc
	lda	XVDec		; somma signed
	adc	FPWTmp
	inc	a		; se negativo round to zero
	sta	FPWTmp
	ACC08
	bpl	?72		; check formato F
	jmp	?06		; Prec negtiva => round to zero
?72:	ACC16			; test esponente + formato F
	clc			; OK --
	lda	XVDec
	bmi	?74		; exp negativo -- ok
	cmp	#MAXFDEC	; forza formato E
?74:	ACC08			; se esponente maggiore di un limite fisso
	bcc	?80		; OK
	lda	#$20		; clear flag formato F
	trb	XVFlag		; e forza formato F se Exp >= MAXFDEC
	
?80:	; indice digit da arrotondare (X = 0 possibile solo per formato F)
	; per come e' stato costruito FPWTmp, esso e' a 8 bit
	ldx	FPWTmp		; 8 bit
	cpx	#MAXINTDGTS	; round solo se necessario
	bcs	?90		; no rounding
	; round alla cifra di indice X
	ldy	#'0'
	lda	<FPUStr+1,x
	stz	<FPUStr+1,x	; tronca stringa alla precisione richiesta
	cmp	#'5'
	bcc	?90		; no round
?82:	dex			; passa al digit precedente
	bmi	?88		; oltre primo digit
	lda	<FPUStr+1,x	; test digit precedente
	inc	a		; round
	cmp	#'9'+1
	bcc	?84		; fine rounding
	sty	<FPUStr+1,x	; zero finale
	bcs	?82
?84:	sta	<FPUStr+1,x	; salva digit arrotondato
	bcc	?90		; fine rounding
?88:	; il rounding ha generato un riporto
	ACC16
	inc	XVDec		; incrementa esponente decimale
	ACC08
	lda	#'1'
	sta	<FPUStr+1	; store '1'
	bit 	XVFlag		; <6> -> VF test richiesta formato G
	bvc	?89		; no formato G
	jsr	testg		; exp cambiato => testare limiti per F	
?89:	lda	#$20		; test formato F
	bit	XVFlag
	beq	?90
	; nel formato F puo' accadere che l'indice di rounding sia zero
	; in questo caso l'indice va incrementato e la stringa terminata
	ldx	FPWTmp
	stz	<FPUStr+2,x	; termina sulla precisione richiesta
?90:	jsr	storesgn
	sty	FPIndx		; store indice primo digit
	ldx	#0
	lda	#$20
	bit	XVFlag
	beq	?92		; formato E
	jsr	fform		; formato F
	bra	?94
?92:	jsr	eform
?94:	tyx
?100:	stz	<XCVTStr,x	; termina stringa
	tya
	ldx	#XCVTStr
	rts

; memorizza segno secondo i criteri di formattazione
storesgn:
	ldy	#0		; indice stringa XCVTStr
	lda	XVFlag		; test segno
	bpl	?02		; positivo
	lda	#'-'		; store '-'
	bne	?06
?02:	lsr	a		; CF -> flag segno positivo
	bcc	?08		; no segno se positivo
	ldx	#'+'		; assume '+'
	lsr	a		; CF -> flag blank
	bcc	?04		; store '+'
	ldx	#' '		; store blank
?04:	txa
?06:	sta	!DP02ADDR+XCVTStr,y
	iny
?08:	rts

; testa formato G/g per scegliere F se Exp >= FmtPrec
; Out	- CF = 1 => formato E
;	  CF = 0 => formato F
testg:
	lda	#$20		; <5> -> clear flag F
	trb	XVFlag		; imposta formato E
	ACC16			; formato G sceglie automaticamente tra E e F
	lda	XVDec
	bmi	?60		; esponente decimale negativo
	cmp	FPWTmp		; 16 bit compare
	bra	?62		; C = 1 esponente >= precisione -> formato E
				; C = 0 esponente < precisione -> formato F
?60:	eor	#$FFFF		; esponente negativo
	inc	a		; complementa a 2
	cmp	#MAXFEXP	; esponente <= - max exp. neg. formato F ? 
?62:	ACC08
	bcs	?64		; imposta formato E -- round con FmtPrec
				; Exp < -MAXFEXP oppure Exp >= FmtPrec
	; _MAXFEXP <= Exp < FmtPrec => sgeglie formato F
	lda	#$20		; <5> -> flag F
	tsb	XVFlag		; imposta formato F
?64:	rts

; converte numero float secondo formato f,F
; In	- X = 0 (indice FPUStr)
;	  Y = indice corrente XCVTStr
; NOTA - causa limiti imposti a FmtPrec sicuramente XVDec a 8 bit (signed)
fform:
	lda	XVDec
	inc	a
	lda	#MAXINTDGTS		; padding formato G con exp. negativo	
	sta	FPTmp4			; padding formato G con exp. positivo	
	stz	FPTmp2
	stz	FPTmp1			; counter digit frazionari
	ldx	XVDec			; 8 bit
	bpl	?06			; esp > 0 -> parte integrale
	lda	#$80
	sta	FPTmp2			; flag solo parte frazionaria
	lda	#MAXINTDGTS		; padding formato G con exp. negativo
	sta	FPTmp4
	lda	#'0'
	sta	!DP02ADDR+XCVTStr,y	; inizia con '0.'
	iny
	lda	#'.'
	sta	!DP02ADDR+XCVTStr,y
	iny
	lda	#'0'
?02:	inx				; inc. esponente negativo
	beq	?04			; fine '0' iniziali
	sta	!DP02ADDR+XCVTStr,y	; store '0' dopo '.'
	inc	FPTmp1			; update cnt digit frazionari
	iny
	bne	?02
?04:	dex
?06:	inx
	stx	XVDec
	; si emette parte integrale o frazionaria da stringa arrotondata
	ldx	#0
?08:	lda	<FPUStr+1,x
	beq	?20			; fine stringa
	sta	!DP02ADDR+XCVTStr,y
	iny
	inx
	bit	FPTmp2
	bpl	?09			; parte intera
	inc	FPTmp1			; counter digit frazionari
	bra	?08			; continua parte frazionaria
?09:	dec	XVDec			; se XVDec (8 bit) = 0 -> '.'
	bne	?08			; emette digit fino al '.'
	lda	#'.'
	sta	!DP02ADDR+XCVTStr,y	; store '.'
	iny
	lda	#$40			; flag '.' nel mezzo
	tsb	FPTmp2
?10:	lda	<FPUStr+1,x
	beq	?20			; fine stringa
	sta	!DP02ADDR+XCVTStr,y
	inc	FPTmp1			; counter digit frazionari
	iny
	inx
	bne	?10
?20:	; a questo punto sono state emesse tutte le cifre significative
	; dalla stringa decimale arrotondata
	bit	FPTmp2
	bmi	?30			; forma 0.0000ffff
	bvs	?30			; forma xxxx.ffff
	; sono state emesse solo cifre integrali e l'esponente non e' nullo
	; occorre emettere gli zeri fino ad annullare l'esponente
	ldx	XVDec
	lda	#'0'
?22:	sta	!DP02ADDR+XCVTStr,y
	iny
	dex
	bne	?22
	lda	#'.'
	sta	!DP02ADDR+XCVTStr,y	; store '.'
	iny
?30:	; a questo punto la stringa decimale FPUStr+1 arrotondata e' stata
	; formattata in XCVTStr secondo le specifiche di precisione richieste
	; nel caso del formato F sono state emesse FPTmp1 cifre frazionarie
	; quindi occorre paddare la stringa con (FmtPrec - FPTmp1) '0' finali
	; con il formato G sono state emesse MIN(FmtPrec, MAXINTDGTS) cifre
	; totali, quindi occorre paddare la stringa con (FmtPrec - MAXINTDGTS)
	; '0' finali.
	stz	FPTmp3			; counter padding '0' finali
	sec
	lda	FmtPrec			; precisione richiesta
	bit	XVFlag
	bvc	?34			; no formato G specificato
	ldx	FPTmp4			; valore per formato G
	stx	FPTmp1
?34:	sbc	FPTmp1
	beq	?40			; FmtPrec - FPTmp1 = 0 => no padding
	bcc	?40			; FmtPrec - FPTmp1 < 0 => no padding
	tax				; X => padding -- qui anche CF = 1
	sty	FPTmp1			; lunghezza attuale stringa
	lda	#XCVTMAXF		; max. len
	sbc	FPTmp1			; A = bytes disponibili
	beq	?40			; no bytes disponibili
	bcc	?40			; no bytes disponibili
	sta	FPTmp1			; # bytes disponibili
	cpx	FPTmp1			; determina padding disponibile
	bcc	?36			; X = padding
	ldx	FPTmp1			; max. padding possibile
?36:	stx	FPTmp3
?40:	; a questo punto FPTmp3 contiene il numero di padding ed Y 
	; la lunghezza attuale della stringa ed il prox. indice disponibile
	; se ultimo carattere emesso e' '.' e non ci sono altri digit da
	; emettere, il '.' finale va trimmato a meno che non sia stato
	; specificato il formato alternativo
	lda	#$10			; test formato alternativo
	bit	XVFlag
	bne	?44			; formato alt => no trim
	dey				; indice last char
	lda	!DP02ADDR+XCVTStr,y	; last char
	cmp	#'.'			; last = '.' ?
	bne	?42			; no -- trimma se formato G
	ldx	FPTmp3			; seguono '0' finali ?
	beq	?50			; no -- trim '.' ed esce
?42:	iny				; ripristina indice Y
	; si trimmano gli '0' finali se formato G/g e no alt. form.
	jsr	trimtrail
	bcs	?50			; trim -> fine
?44:	; a questo punto padding della stringa con '0' finali
	ldx	FPTmp3
	beq	?50			; no padding
	lda	#'0'
?46:	sta	!DP02ADDR+XCVTStr,y	; store '0'
	iny
	dex
	bne	?46
?50:	rts

; converte numero float secondo formato e,E
; In	- X = 0 (indice FPUStr+1)
;	  Y = indice corrente XCVTStr (destinazione)
eform:
	lda	<FPUStr+1,x		
	sta	!DP02ADDR+XCVTStr,y	; store primo digit
	inx
	iny
	lda	#'.'			; dopo il primo digit segue il '.'
	xba				; B = '.'
	lda	<FPUStr+1,x		; segue secondo digit ?
	bne	?02			; si, secondo digit dopo '.'
	
	; se non ci sono altri digit dopo il '.' allora non
	; viene emesso il '.' a meno che non sia specificato alt. form.
	lda	#$10			; test formato alt #
	bit	XVFlag
	beq	?50			; no alt form # -> emette esponente
	xba
	sta	!DP02ADDR+XCVTStr,y	; store '.'
	iny
	bra	?50			; emette esponente
?02:	inx	
	xba				; A = '.', B = secondo digit
	sta	!DP02ADDR+XCVTStr,y	; store '.'
	iny
	xba				; A = secondo digit
?04:	sta	!DP02ADDR+XCVTStr,y	; store secondo digit e seguenti
	iny
	lda	<FPUStr+1,x
	beq	?05			; fine stringa digit
	inx
	bne	?04
	
?05:	; copiata la stringa di cifre significative -- ora si trimmano gli
	; '0' finali se formato G/g e no alt. form.
	jsr	trimtrail		; se trim non effettua padding
	bcs	?50			; trim -> emette esponente
	
	; padding della stringa con '0' finali -- nel formato E vengono
	; emessi al max. MAXINTDGTS digit significativi e la stringa
	; XCVTStr ha posto per XCVTMAXE char complessivi prima dell'esponente
	lda	FmtPrec
	cmp	#XCVTMAXE+1
	bcc	?05a
	lda	#XCVTMAXE		; al massimo XCVTMAXE digit
?05a:	sec
	sbc	#MAXINTDGTS		; padding
	beq	?50			; no padding
	bcc	?50			; no padding
	tax				; X = numero padding
	lda	#'0'
?06:	sta	!DP02ADDR+XCVTStr,y
	iny
	dex
	bne	?06
	
?50:	; emette esponente decimale
	ldx	#'E'
	lda	#$08			; test CAPS ON
	bit	XVFlag
	bne	?52			; CAPS ON
	ldx	#'e'
?52:	txa
	sta	!DP02ADDR+XCVTStr,y
	iny
	ldx	#'+'			; assume esponente positivo
	ACC16
	lda	XVDec
	bpl	?54
	ldx	#'-'			; esponente positivo
	eor	#$FFFF			; complementa esponente
	inc	a
?54:	sta	FOP			; prepara per conversione
	stz	FOP+2
	stz	FOP+4
	stz	FOP+6
	ACC08
	txa
	sta	!DP02ADDR+XCVTStr,y	; segno esponente
	iny
	phy
	jsr	_UI2Str			; X = ptr ultimo digit
	ply
	dex				; esponente sempre a 4 digit				
	dex
	dex				; ptr al primo di 4 digits
	ACC16
	lda	<0,x
	sta	!DP02ADDR+XCVTStr,y	; prima coppia digit esponente
	inx
	inx
	iny
	iny
	lda	<0,x
	sta	!DP02ADDR+XCVTStr,y	; seconda coppia digit esponente
	ACC08
	iny
	iny				; Y = lunghezza stringa
	rts
	
; trim '0' finali della stringa  -- solo se formato G/g e no alt. form.
; In	- Y = indice attuale stringa destinazione
;	  FPIndx = indice primo digit
; Out	- Y = nuovo indice attuale stringa dest
;	  CF = 1 se stringa trimmata, altrimenti CF = 0
trimtrail:
	bit	XVFlag			; <6> -> gormato G/g
	bvc	?10			; no trim: esce con C = 0
	lda	#$10			; test formato alt #
	bit	XVFlag
	bne	?10			; alt form: no trim, esce con C = 0
?02:	dey				; ultimo digit valido
	cpy	FPIndx			; indice sul primo digit ?
	beq	?08			; SI -- non rimuove mai
	lda	!DP02ADDR+XCVTStr,y
	cmp	#'0'
	beq	?02			; loop digit precedente
	cmp	#'.'			; Trim eventuale '.'
	beq	?09
?08:	iny				; indice disponibile successivo
?09:	sec				; trim
	rts	
?10:	clc				; no trim
	rts

; converte float in formato a/A
aform:
	stx	FmtPrec			; se = 0 stampa mantissa ordinaria
	ldx	#$06			; valore da aggiungere per digit A..F
	bit	#$08
	bne	?02			; HI CAPS
	ldx	#$26			; valore da aggiungere per digit a..f
?02:	stx	FPTmp1
	lda	FACSGN
	and	#$80			; segno FAC
	ora	XVFlag
	sta	XVFlag
	jsr	storesgn		; store segno in XCVTStr
	lda	#'$'
	STA	!DP02ADDR+XCVTStr,Y
	INY	
	ldx	#$07			; loop 8 bytes
?10:	lda	<FACM,x
	jsr	Byte2Hex
	STA	!DP02ADDR+XCVTStr,Y	; nibble H
	INY
	xba				; nibble L
	STA	!DP02ADDR+XCVTStr,Y
	INY
	DEX
	BPL	?10
	ldx	#'p'
	lda	#$08
	bit	XVFlag
	beq	?14
	ldx	#'P'
?14:	txa
	STA	!DP02ADDR+XCVTStr,Y
	INY
	stz	FPTmp2
	stz	FPTmp3
	ACC16
	lda	FACExp
	sta	XVDec
	cmp	#EXPINF
	ACC08
	bcs	?26	
	lda	XVFlag
	bit	#$10
	beq	?20
	sec
	lda	#$80
	sta	FPTmp2
?20:	ACC16
	lda	FACExp
	bcc	?22
	ldx	#0
	sbc	#EXPBIAS
	bcs	?21			; positivo		
	eor	#$FFFF
	inc	a
	dex				; negativo
?21:	stx	FPTmp3
?22:	sta	XVDec
	ACC08
	bit	FPTmp2
	bpl	?26
	lda	#'+'
	bit	FPTmp3
	bpl	?24
	lda	#'-'
?24:	STA	!DP02ADDR+XCVTStr,Y
	INY
?26:	ldx	#$01
?28:	lda	<XVDec,x
	jsr	Byte2Hex
	STA	!DP02ADDR+XCVTStr,Y	; nibble H
	INY
	xba				; nibble L
	STA	!DP02ADDR+XCVTStr,Y
	INY
	DEX
	BPL	?28
	lda	#$00
	STA	!DP02ADDR+XCVTStr,Y
	tya
	ldx	#XCVTStr
	rts

;-------------------------------------------------------------
; COSTANTI IN VIRGOLA MOBILE
;-------------------------------------------------------------

;FCon05:	.BYTE	$3F,$FE,$80,$00,$00,$00,$00,$00,$00,$00	; 0.5
;FConM05:	.BYTE	$BF,$FE,$80,$00,$00,$00,$00,$00,$00,$00	; -0.5
FCon1E18	.DB	$00,$00,$40,$76,$3A,$6B,$0B,$DE,$3A,$40	; 1E18
FCon1E19	.DB	$00,$00,$E8,$89,$04,$23,$C7,$8A,$3E,$40	; 1E19

;FConINF:	.BYTE	$7F,$FF,$80,$00,$00,$00,$00,$00,$00,$00	; +INF
;FConNAN:	.BYTE	$7F,$FF,$FF,$00,$00,$00,$00,$00,$00,$00	; +NAN

FCon1E0:	.DB	$00,$00,$00,$00,$00,$00,$00,$80,$FF,$3F	; 1
FCon1E1:	.DB	$00,$00,$00,$00,$00,$00,$00,$A0,$02,$40	; 10
FCon1E2:	.DB	$00,$00,$00,$00,$00,$00,$00,$C8,$05,$40	; 100
FCon1E3:	.DB	$00,$00,$00,$00,$00,$00,$00,$FA,$08,$40 ; 1E3
FCon1E4:	.DB	$00,$00,$00,$00,$00,$00,$40,$9C,$0C,$40	; 1E4
FCon1E5:	.DB	$00,$00,$00,$00,$00,$00,$50,$C3,$0F,$40	; 1E5
FCon1E6:	.DB	$00,$00,$00,$00,$00,$00,$24,$F4,$12,$40	; 1E6
FCon1E7:	.DB	$00,$00,$00,$00,$00,$80,$96,$98,$16,$40	; 1E7
FCon1E8:	.DB	$00,$00,$00,$00,$00,$20,$BC,$BE,$19,$40	; 1E8
FCon1E16:	.DB	$00,$00,$00,$04,$BF,$C9,$1B,$8E,$34,$40	; 1E16
FCon1E32:	.DB	$9E,$B5,$70,$2B,$A8,$AD,$C5,$9D,$69,$40	; 1E32
FCon1E64:	.DB	$D5,$A6,$CF,$FF,$49,$1F,$78,$C2,$D3,$40	; 1E64
FCon1E128:	.DB	$DF,$8C,$E9,$80,$C9,$47,$BA,$93,$A8,$41	; 1E128
FCon1E256:	.DB	$8C,$DE,$F9,$9D,$FB,$EB,$7E,$AA,$51,$43	; 1E256
FCon1E512:	.DB	$C2,$91,$0E,$A6,$AE,$A0,$19,$E3,$A3,$46	; 1E512
FCon1E1024:	.DB	$0F,$0C,$75,$81,$86,$75,$76,$C9,$48,$4D	; 1E1024
FCon1E2048:	.DB	$D7,$5D,$3D,$C5,$5D,$3B,$8B,$9E,$92,$5A	; 1E2048	
FCon1E4096:	.DB	$79,$97,$20,$8A,$02,$52,$60,$C4,$25,$75	; 1E4096	

; -----------------------------------------------------
;static  const   extend  e128  = {0x8CE0, 0x80E9, 0x47C9, 0x93BA, 0x41A8}; +1
;static  const   extend  e256  = {0xDE8E, 0x9DF9, 0xEBFB, 0xAA7E, 0x4351}; +2
;static  const   extend  e512  = {0x91C7, 0xA60E, 0xA0AE, 0xE319, 0x46A3}; +5
;static  const   extend  e1024 = {0x0C17, 0x8175, 0x7586, 0xC976, 0x4D48}; +8
;static  const   extend  e2048 = {0x5DE5, 0xC53D, 0x3B5D, 0x9E8B, 0x5A92}; +14
;static  const   extend  e4096 = {0x979B, 0x8A20, 0x5202, 0xC460, 0x7525}; +34

