;----------------------------------------------------------
; INTP.ASM
; PROGETTO: B1601
;
; Processore numerico - Integer
;----------------------------------------------------------

	.INCLUDE inc\global.inc

;----------------------------------------------------------
; variabili in Direct-Page 02
;----------------------------------------------------------
	
	.INCLUDE inc\dirp02.inc

; max. unsigned:  18446744073709551615
; max. signed  :   9223372036854775807
; min. signed  :  -9223372036854775808

;----------------------------------------------------------
; segmento codice banco $F8
;----------------------------------------------------------

	.CODEF8
	.GLOBAL _iUMult8, _iUMult16, _iUMult32, _iUMult64
	.GLOBAL _iSMult8, _iSMult16, _iSMult32, _iSMult64
	.GLOBAL _iUDiv8, _iUDiv16, _iUDiv32, _iUDiv64, Byte2Hex
	.GLOBAL _iSDiv8, _iSDiv16, _iSDiv32, _iSDiv64	
	.GLOBAL _Str2Hex, _Str2Int, _Int2Str, _UI2Str, _iMovACM2A
	.PUBLIC fidiv, fimlt

	.LONGA	off
	.LONGI	off

INTGSIZE	.EQU	8	; # bytes interi a 64 bytes
MAXINTSTR	.EQU	127	; max. lughezza stringa dec/hex


; _lstrtoint(lpStr, bSiz, bFlag, lpRes)
;
; convert decimal/hexadecimal string lpStr to integer
;
; entry
; 	lpStr	= long pointer to string
;	bSiz	= size of integer (1,2,3,4,8) - size=3 valid for hex only
;	bFlag	= <7>: wanted signed integer
;		  <6>: default to decimal string (autodetect '$' for hex)
;	lpRes	= long pointer to dest. buffer to store result
;
; exit
;	C,X	= long pointer to first invalid char. (not digit)
;	Y	= <7>: sign of result (only if bit 6 is set)
;		  <6>: set if result is signed integer
;
;	P:	= CF & VF flag's report any error condition
;		  CF = 0 & VF = 0 -> no error
;		  CF = 0 & VF = 1 -> mismatch type (signed/unsigned)
;		  CF = 1 & VF = 0 -> no conversion (invalid string)
;		  CF = 1 & VF = 1 -> overflow error
;
;
M	.SET	8	; param's bytes count
N	.SET	13	; bytes pushed on stack after param's
lpRes	.SET	N+1
bFlag	.SET	N+4
bSiz	.SET	N+5
lpStr	.SET	N+6
CReg	.SET	1
YReg	.SET	3
XReg	.SET	5
PReg	.SET	10

;----------------------
_lstrtoint:
	.PUBLIC _lstrtoint
;----------------------

	.LONGA	off
	.LONGI	off

	php			; save register's size and CF&VF exit value's
	phb			; save dbr
	phd			; save dpr
	CPU16
	phx			; X exit value
	phy			; Y exit value
	pha			; C exit value
	lda	#DP02ADDR	; set working dpr
	tcd
	CPU08
	lda	PReg,s
	and	#~(PCFLAG+PVFLAG)
	sta	PReg,s		; clear CF & VF
	lda	bSiz,s
	sta	FPTmp1		; integer size
	lda	bFlag,s
	sta	FPTmp2		; conversion flag
	tax
	asl	a		; test bit 6
	bpl	?20		; convert hex. string
	lda	lpStr+2,s
	pha
	plb
	ldy	#0
	lda	(lpStr,s),y	; check first char
	cmp	#'$'		; hex. string?
	bne	?10		; no
	ACC16
	lda	lpStr,s		; bump string pointer
	inc	a
	sta	lpStr,s
	ACC08
	bra	?20		; convert hex. string
?10:	ldy	FPTmp1
	cpy	#3		; decimal conversion refuse pointer size
	beq	?20		; force hex.
?15:	txa
	and	#$80		; wanted signed flag
	ora	FPTmp1		; add size
	tax
	lda	lpStr+2,s
	tay
	lda	lpStr+1,s
	xba
	lda	lpStr,s
	jsr	_Str2Int	; decimal string
	bra	?25
?20:	ldx	FPTmp1
	lda	lpStr+2,s
	tay
	lda	lpStr+1,s
	xba
	lda	lpStr,s
	jsr	_Str2Hex	; hex string
?25:	lda	PReg,s		; set status result
	bcc	?26		; no error
	ora	#PCFLAG		; set CF on exit status
?26:	bvc	?27
	ora	#PVFLAG		; set VF on exit status
?27:	sta	PReg,s	
	tax
	ACC16CLC
	tya			; remainder string ptr
	adc	lpStr,s
	sta	CReg,s
	ACC08
	lda	lpStr+2,s
	bcc	?28
	inc	a
?28:	sta	XReg,s
	lda	#0
	sta	XReg+1,s
	sta	YReg+1,s
	lda	ACMSgn
	sta	YReg,s
	txa			; status
	lsr	a		; CF check
	bcs	?40		; error, so no store result
	lda	bSiz,s
	sta	FPTmp1		; size
	lda	lpRes+2,s
	pha
	plb
	ldy	#0
	tyx
?30:	lda	ACM,x
	sta	(lpRes,s),y
	iny
	inx
	cpx	FPTmp1
	bcc	?30
?40:	CPU16CLC
	tsc			; epilogue code
	adc	#N
	tax			; source address for move
	adc	#M
	tay			; destination address for move
	lda	#N-1		; bytes to move - 1
	mvp	#0, #0		; move previous
	tya			; new stack pointer
	tcs
	pla			; return C
	ply			; return Y
	plx			; return X
	pld			; restore dpr
	plb			; restore dbr
	plp			; restore status
	rtl

;----------------------------------------------------------
; estensione segno accumulatori
;----------------------------------------------------------

; _iCWD16 - estende ACM a WORD
_iCWD16:
	ldx	ACMSize
	cpx	#$02		; ACM WORD ?
	bcs	?06		; si -- non deve estendere
	ldy	#0
	bit	ACMSgn
	bvc	?04		; unsigned => estende con 00
	dex			; indice MSB BYTE
	bit	ACM,x
	bpl	?02		; signed positivo => estende con 00
	dey			; signed negativo => estende con FF
?02:	inx			; indice MSB WORD	
?04:	sty	ACM,x
	inx			; size = 2 (WORD)
	stx	ACMSize		; update size
?06:	rts

; _iCWD32 - estende ACM a LONG
_iCWD32:
	jsr	_iCWD16		; assicura ACM esteso a WORD
	ldx	ACMSize
	cpx	#$04		; ACM LONG ?
	bcs	?06		; si -- non deve estendere
	ldy	#0
	INDEX16
	bit	ACMSgn
	bvc	?04		; unsigned => estende con 0000
	dex			; indice MSB WORD
	bit	ACM,x
	bpl	?02		; signed positivo => estende con 0000
	dey			; signed negativo => estende con FFFF
?02:	inx			; indice MSB LONG	
?04:	sty	ACM,x		; estende
	INDEX08
	inx
	inx			; size = 4 (LONG)
	stx	ACMSize		; update size
?06:	rts

; _iCWD64 - estende ACM a QUAD
_iCWD64:
	jsr	_iCWD32		; assicura ACM esteso a LONG
	ldx	ACMSize
	cpx	#$08		; ACM QUAD ?
	bcs	?06		; si -- non deve estendere
	ldy	#0
	INDEX16
	bit	ACMSgn
	bvc	?04		; unsigned => estende con 0000
	dex			; indice MSB LONG
	bit	ACM,x
	bpl	?02		; signed positivo => estende con 0000
	dey			; signed negativo => estende con FFFF
?02:	inx			; indice MSB QUAD	
?04:	sty	ACM,x		; estende
	sty	ACM+2,x
	INDEX08
	ldx	#$08		; size = 8 (QUAD)
	stx	ACMSize		; update size
?06:	rts

; _iCWDARG16 - estende IARG a WORD
_iCWDARG16:
	ldx	IARGSize
	cpx	#$02		; IARG WORD ?
	bcs	?06		; si -- non deve estendere
	ldy	#0
	bit	IARGSgn
	bvc	?04		; unsigned => estende con 00
	dex			; indice MSB BYTE
	bit	IARG,x
	bpl	?02		; signed positivo => estende con 00
	dey			; signed negativo => estende con FF
?02:	inx			; indice MSB WORD	
?04:	sty	IARG,x
	inx			; size = 2 (WORD)
	stx	IARGSize	; update size
?06:	rts

; _iCWDARG32 - estende IARG a LONG
_iCWDARG32:
	jsr	_iCWDARG16	; assicura IARG esteso a WORD
	ldx	IARGSize
	cpx	#$04		; IARG LONG ?
	bcs	?06		; si -- non deve estendere
	ldy	#0
	INDEX16
	bit	IARGSgn
	bvc	?04		; unsigned => estende con 0000
	dex			; indice MSB WORD
	bit	IARG,x
	bpl	?02		; signed positivo => estende con 0000
	dey			; signed negativo => estende con FFFF
?02:	inx			; indice MSB LONG	
?04:	sty	IARG,x		; estende
	INDEX08
	inx
	inx			; size = 4 (LONG)
	stx	IARGSize	; update size
?06:	rts

; _iCWDARG64 - estende IARG a QUAD
_iCWDARG64:
	jsr	_iCWDARG32	; assicura IARG esteso a LONG
	ldx	IARGSize
	cpx	#$08		; IARG QUAD ?
	bcs	?06		; si -- non deve estendere
	ldy	#0
	INDEX16
	bit	IARGSgn
	bvc	?04		; unsigned => estende con 0000
	dex			; indice MSB LONG
	bit	IARG,x
	bpl	?02		; signed positivo => estende con 0000
	dey			; signed negativo => estende con FFFF
?02:	inx			; indice MSB QUAD	
?04:	sty	IARG,x		; estende
	sty	IARG+2,x
	INDEX08
	ldx	#$08		; size = 8 (QUAD)
	stx	IARGSize	; update size
?06:	rts

; _iCWD2 - estensione segno operandi ACM e IARG
_iCWD2:
	lda	IARGSize
	cmp	ACMSize
	beq	?10		; no estensione
	bcs	?02		; CF = 1 => estende ACM
	lda	ACMSize
?02:	php			; salva CF
	ldx	#$02
?04:	cmp	>CWDTBL,x	; X = indice CWD
	beq	?06
	dex
	bpl	?04
	plp			; non dovrebbe accadere
	clv			; VF = 0
	sec			; CF = 1
	rts
?06:	txa
	asl	a
	plp			; ripristina CF
	bcs	?08		; CF = 1 => CWD ACM
	adc	#$06		; CF = 0 => CWD IARG
?08:	tax			; indice funzione
	jsr	(CWDJMP,x)	; estensione segno ACM/IARG
?10:	lda	ACMSize
	eor	IARGSize
	sta	ACMCmps		; set flag compare segno (7) e tipo (6)
	clv
	clc
	rts
	
; tabella per estensione segno
CWDTBL:
	.DB	$02, $04, $08

; tabella funzioni CWD ACM
CWDJMP:
	.DW	_iCWD16, _iCWD32, _iCWD64
	
; tabella funzioni CWD IARG
CWDJMP2:
	.DW	_iCWDARG16, _iCWDARG32, _iCWDARG64

;----------------------------------------------------------
; implementazione MULT unsigned integer
;----------------------------------------------------------

; _iUMult8: moltiplicazione integer 8 bit unsigned
; In:	ACM: unsigned integer 1
;	IARG: unsigned integer 2
; Out:	ACM..ACM+1 -> risultato integer unsigned (16 bit)
;	X = 0
;	Y = minima size
;	CF = 0
; Uso:	A,X,Y,ACM,IARG
_iUMult8:
	lda	#0		; azzera parte alta del risultato
	LDX	#9		; ciclo 9 bit
	CLC
?01:	ror	a		; ACM + 1
	ROR	ACM
	BCC	?02
	CLC
	adc	IARG
?02:	DEX
	BNE	?01
	sta	ACM+1
	ldy	#$02
	sty	ACMSize		; ACM WORD
	ora	#$00
	bne	?03		; ACM+1 non ZERO
	dey			; ACM+1 = 0 => min size = BYTE
?03:	sty	ACMMinSize
	clc
	RTS

; _iUMult16: moltiplicazione integer 16 bit unsigned
; In:	ACM, ACM+1: unsigned integer 1
;	IARG, IARG+1: unsigned integer 2
; Out:	ACM..ACM+3 -> risultato integer unsigned (32 bit)
;	X = 0
;	Y = minima size
;	CF = 0
; Uso:	A,X,Y,ACM,IARG
_iUMult16:
	ACC16		
	lda	#0		; azzera parte alta del risultato
	LDX	#17		; ciclo 17 bit
	CLC
?01:	ror	a		: ACM + 2
	ROR	ACM
	BCC	?02
	CLC
	adc	IARG
?02:	DEX
	BNE	?01
	sta	ACM+2
	ldy	#$04
	sty	ACMSize		; ACM LONG
	ora	#$0000
	bne	?03		; WORD ACM+2 NON NULLA
	dey
	dey			; MIN SIZE = WORD
?03:	sty	ACMMinSize
	ACC08	
	clc
	RTS

; _iUMult32: moltiplicazione integer 32 bit unsigned
; In:	ACM..ACM+3: unsigned integer 1
;	IARG..IARG+3: unsigned integer 2
; Out:	ACM..ACM+7 -> risultato integer unsigned (64 bit)
;	X = 0
;	Y = minima size
;	CF = 0
; Uso:	A,X,Y,ACM,IARG
_iUMult32:
	ACC16
	STZ	ACM+4		; azzera parte alta del risultato
	STZ	ACM+6
	LDX	#33		; ciclo 33 bit
	CLC
?01:	ROR	ACM+6
	ROR	ACM+4
	ROR	ACM+2
	ROR	ACM
	BCC	?02
	CLC
	LDA	IARG
	ADC	ACM+4
	STA	ACM+4
	LDA	IARG+2
	ADC	ACM+6
	STA	ACM+6
?02:	DEX
	BNE	?01
	ldy	#$08
	sty	ACMSize		; ACM QUAD
	lda	ACM+6
	ora	ACM+4
	bne	?03		; LONG ACM+4 NON ZERO
	ldy	#$04		; MIN SIZE = LONG
?03:	sty	ACMMinSize
	ACC08	
	clc
	RTS

; _iUMult64: moltiplicazione integer 64 bit unsigned
; In:	ACM..ACM+7: unsigned integer 1
;	IARG..IARG+7: unsigned integer 2
; Out:	ACM..ACM+7 -> risultato integer unsigned (128 bit LOW)
; 	FOP..FOP+7 -> risultato integer unsigned (128 bit HIGH) (OVERFLOW)
;	X = 0
;	CF = 0 -> risultato OK
;	CF = 1 -> unsigned overflow
; Uso:	A,X,Y,ACM,IARG,FOP
_iUMult64:
	ldy	#$08
	sty	ACMMinSize
	sty	ACMSize
	ACC16
	stz	FOP		; azzera parte alta del risultato a 128 bit
	stz	FOP+2		; la parte bassa (64 bit) in ACM
	stz	FOP+4
	stz	FOP+6
	LDX	#65		; ciclo 65 bit
	CLC
?01:	ROR	FOP+6
	ROR	FOP+4
	ROR	FOP+2
	ROR	FOP
	ROR	ACM+6
	ROR	ACM+4
	ROR	ACM+2
	ROR	ACM
	BCC	?02
	CLC
	LDA	IARG
	ADC	FOP
	STA	FOP
	LDA	IARG+2
	ADC	FOP+2
	STA	FOP+2
	LDA	IARG+4
	ADC	FOP+4
	STA	FOP+4
	LDA	IARG+6
	ADC	FOP+6
	STA	FOP+6
?02:	DEX
	BNE	?01
	sec			; flag overflow
	lda	FOP		; test overflow
	ora	FOP+2
	ora	FOP+4
	ora	FOP+6
	bne	?04		; overflow -> CF = 1
	clc
?04:	ACC08
	RTS

;----------------------------------------------------------
; 2's complement 
;----------------------------------------------------------

; complento a 2 di IARG
_iNegIARG
	ldx	#IARG
	bra	_iNegX

; complento a 2 di ACM
_iNegACM:
	ldx	#ACM
	
; complemento a 2 accumulatore X (ACM, IARG, FOP)
_iNegX:
	sec
_iNegXnc:
	phy			; salva Y
	ldy	#0
	ACC16
	tya			; A = 0
	sbc	<0,x
	sta	<0,x
	tya
	sbc	<2,x
	sta	<2,x
	tya
	sbc	<4,x
	sta	<4,x
	tya
	sbc	<6,x
	sta	<6,x
	ACC08
	ply
	rts
	
;----------------------------------------------------------
; implementazione SMULT signed integer
;----------------------------------------------------------

; _iSMult8: moltiplicazione integer 8 bit signed
; In:	ACM: signed integer 1
;	IARG: signed integer 2
; Out:	ACM..ACM+1 -> risultato integer signed (16 bit)
;	X = 0
;	CF = 0
; Uso:	A,X,Y,ACM,IARG
_iSMult8:
	ldx	#0
	LDA	ACM
	EOR	IARG		; segno risultato
	and	#$80		; bit 7 => segno
	ora	#$40		; bit 6 => signed int
	sta	ACMSgn		; salva segno
	BIT	IARG		; test segno IARG
	BPL	?01
	SEC			; complementa IARG
	txa
	SBC	IARG
	STA	IARG
?01:	BIT	ACM		; test segno ACM
	BPL	?02
	SEC			; complementa ACM
	txa
	SBC	ACM
	STA	ACM
?02:	JSR	_iUMult8	; moltiplicazione unsigned (X = 0)
	cpy	#$02		; min size WORD ?
	beq	?02b		; si
	; se ACM <= 7F allora min size = BYTE
	lda	ACM
	cmp	#$80
	bcc	?02b
	bne	?02a		; ACM > 80 => WORD
	; ACM = 80 -- se risultato negativo => BYTE
	bit	ACMSgn
	bmi	?02c		; ACM BYTE negativo
?02a:	iny			; ACM WORD	
?02b:	bit	ACMSgn		; Flag N = segno risultato
	BPL	?03		; risultato positivo
?02c:	ACC16
	txa
	sec			; risultato negativo: complementa ACM
	sbc	ACM
	sta	ACM
	ACC08
?03:	sty	ACMMinSize
	clc
	RTS
	
; _iSMult16: moltiplicazione integer 16 bit signed
; In:	ACM, ACM+1: signed integer 1
;	IARG, IARG+1: signed integer 2
; Out:	ACM..ACM+3 -> risultato integer signed (32 bit)
;	X = 0
;	CF = 0
; Uso:	A,X,Y,ACM,IARG
_iSMult16:
	ldx	#0
	LDA	ACM+1
	EOR	IARG+1		; segno risultato
	and	#$80		; bit 7 => segno
	ora	#$40		; bit 6 => signed int
	sta	ACMSgn		; salva segno
	ACC16
	BIT	IARG		; test segno IARG
	BPL	?01
	sec			; complementa IARG
	txa
	sbc	IARG
	sta	IARG
?01:	BIT	ACM		; test segno ACM
	BPL	?02
	sec			; complementa ACM
	txa
	sbc	ACM
	sta	ACM
?02:	ACC08	
	JSR	_iUMult16	; moltiplicazione unsigned (X = 0)
	cpy	#$04		; min size LONG ?
	beq	?02b		; si
	; se ACM <= 7FFF allora min size = WORD
	ACC16
	lda	ACM
	cmp	#$8000
	ACC08
	bcc	?02b		; ACM < 8000 => WORD
	bne	?02a		; ACM > 8000 => LONG
	; ACM = 8000 -- se risultato negativo => WORD
	bit	ACMSgn
	bmi	?02c		; ACM WORD negativo
?02a:	iny			; ACM LONG
	iny
?02b:	bit	ACMSgn		; Flag N = segno risultato
	BPL	?03		; risultato positivo
?02c:	ACC16
	txa
	sec			; risultato negativo: complementa ACM
	sbc	ACM
	sta	ACM
	TXA			; A = 0
	sbc	ACM+2
	sta	ACM+2
	ACC08
?03:	sty	ACMMinSize
	clc
	RTS

; _iSMult32: moltiplicazione integer 32 bit signed
; In:	ACM..ACM+3: signed integer 1
;	IARG..IARG+3: signed integer 2
; Out:	ACM..ACM+7 -> risultato integer signed (64 bit)
;	X = 0
;	CF = 0
; Uso:	A,X,Y,ACM,IARG
_iSMult32:
	ldx	#0
	LDA	ACM+3
	EOR	IARG+3		; segno risultato
	and	#$80		; bit 7 => segno
	ora	#$40		; bit 6 => signed int
	sta	ACMSgn		; salva segno
	ACC16
	BIT	IARG+2		; test segno IARG
	BPL	?01
	sec			; complementa IARG
	txa
	sbc	IARG
	sta	IARG
	txa
	sbc	IARG+2
	sta	IARG+2
?01:	BIT	ACM+2		; test segno ACM
	BPL	?02
	sec			; complementa ACM
	txa
	sbc	ACM
	sta	ACM
	txa
	sbc	ACM+2
	sta	ACM+2
?02:	ACC08	
	JSR	_iUMult32	; moltiplicazione unsigned
	cpy	#$08		; min size QUAD ?
	beq	?02b		; si
	; se ACM <= 7FFFFFFF allora min size = LONG
	ACC16
	lda	ACM+2
	cmp	#$8000
	ACC08
	bcc	?02b		; ACM < 80000000 => LONG
	bne	?02a		; ACM > 80000000 => QUAD
	ACC16
	lda	ACM
	;cmp	#$0000
	ACC08
	bne	?02a		; ACM > 80000000 => QUAD
	; ACM = 80000000 -- se risultato negativo => LONG
	bit	ACMSgn
	bmi	?02c		; ACM LONG negativo
?02a:	ldy	#$08		; ACM QUAD
?02b:	bit	ACMSgn		; Flag N = segno risultato
	BPL	?03		; risultato positivo
?02c:	JSR	_iNegACM	; risultato negativo: complementa ACM
	ldx	#0		; X = 0
?03:	sty	ACMMinSize
	clc
	rts
	
; _iSMult64: moltiplicazione integer 64 bit signed
; In:	ACM..ACM+7: signed integer 1
;	IARG..IARG+7: signed integer 2
; Out:	ACM..ACM+7 -> risultato integer signed (128 bit LOW)
;	FOP..FOP+7 -> risultato integer signed (128 bit HIGH)
;
;	CF = 0 -> risultato OK
;	CF = 1 -> signed overflow
; Uso:	A,X,Y,ACM,IARG,FOP
_iSMult64:
	LDA	ACM+7
	EOR	IARG+7		; segno risultato
	and	#$80		; bit 7 => segno
	ora	#$40		; bit 6 => signed int
	sta	ACMSgn		; salva segno
	BIT	IARG+7		; test segno IARG
	BPL	?01
	JSR	_iNegIARG	; complementa IARG
?01:	BIT	ACM+7		; test segno ACM
	BPL	?02
	JSR	_iNegACM	; complementa ACM
?02:	JSR	_iUMult64	; moltiplicazione unsigned
	bcs	?10		; overflow (risultato a 128 bit)
	; risultato in 64 bit -- se MSB = 0 risultato ok -- qui CF = 0
	ACC16
	lda	ACM+6
	bpl	?08		; OK -- CF = 0
	cmp	#$8000		; qui imposta CF = 1
	bne	?08		; ACM > 8000000000000000 => overflow
	ldx	ACMSgn
	bpl	?08		; positivo => overflow
	lda	ACM+4
	ora	ACM+2
	ora	ACM+0
	bne	?08		; ACM > 8000000000000000 => overflow
	; ACM = 8000000000000000 negativo => OK
	clc
?08:	ACC08
?10:	bit	ACMSgn
	bpl	?12
	php			; salva CF
	jsr	_iNegACM	; complementa 
	ldx	#FOP
	jsr	_iNegXnc
	plp
?12:	rts

;----------------------------------------------------------
; implementazione DIV unsigned integer
;----------------------------------------------------------

; _iUDiv8: divisione integer 8 bit unsigned
; In:	ACM: unsigned integer 1
;	IARG: unsigned integer 2
; Out:	ACM  -> integer unsigned ACM / IARG
;	IARG -> integer unsigned ACM MOD IARG
;	X = minima size quoziente
;	Y = minima size remainder
;	CF = 1 se IARG = 0 altrimenti CF = 0
; Uso:	A,X,Y,ACM,IARG,FOP
_iUDiv8:
	lda	IARG
	bne	?02
	sec			; division by sero
	rts
?02:	stz	FOP		; azzera rem
	ldx	#8		; loop 8 bit
	lda	ACM		; quoziente
?04:	rol	a
	rol	FOP
	tay
	sec
	lda	FOP
	sbc	IARG
	bcc	?06
	sta	FOP
?06:	tya
	dex
	bne	?04
	rol	a
	sta	ACM		; quot
	lda	FOP
	sta	IARG
	ldy	#1
	tyx
	stx	ACMMinSize
	sty	IARGMinSize	
	clc
	rts

; _iUDiv16: divisione integer 16 bit unsigned
; In:	ACM: unsigned integer 1
;	IARG: unsigned integer 2
; Out:	ACM  -> integer unsigned ACM / IARG
;	IARG -> integer unsigned ACM MOD IARG
;	X = minima size quoziente
;	Y = minima size remainder
;	CF = 1 se IARG = 0 altrimenti CF = 0
; Uso:	A,X,Y,ACM,IARG,FOP
_iUDiv16:
	ACC16
	lda	IARG
	bne	?02
	ACC08
	sec			; division by sero
	rts
?02:	ldx	#16		; loop 16 bit
	CPU16
	stz	FOP		; azzera rem
	lda	ACM		; quoziente
?04:	rol	a
	rol	FOP
	tay
	sec
	lda	FOP
	sbc	IARG
	bcc	?06
	sta	FOP
?06:	tya
	dex
	bne	?04
	rol	a
	sta	ACM		; quoziente
	lda	FOP
	sta	IARG		; remainder
	CPU08
	ldy	#2
	tyx
	xba			; A = hi rem
	bne	?08		; rem 16 bit
	dey			; rem 8 bit
?08:	lda	ACM+1		; A = hi quot
	bne	?10		; quot 16 bit
	dex			; quot 8 bit
?10:	clc
	stx	ACMMinSize
	sty	IARGMinSize	
	rts

; _iUDiv32: divisione integer 32 bit unsigned
; In:	ACM: unsigned integer 1
;	IARG: unsigned integer 2
; Out:	ACM  -> integer unsigned ACM / IARG
;	IARG -> integer unsigned ACM MOD IARG
;	X = minima size quoziente
;	Y = minima size remainder
;	CF = 1 se IARG = 0 altrimenti CF = 0
; Uso:	A,X,Y,ACM,IARG,FOP
_iUDiv32:
	ACC16
	lda	IARG
	ora	IARG+2
	bne	?02
	ACC08
	sec			; division by sero
	rts
?02:	ldx	#32		; loop 32 bit
	CPU16
	stz	FOP		; azzera rem
	stz	FOP+2
?04:	rol	ACM		; quot
	rol	ACM+2
	rol	FOP
	rol	FOP+2
	sec
	lda	FOP
	sbc	IARG
	tay
	lda	FOP+2
	sbc	IARG+2
	bcc	?06
	sty	FOP
	sta	FOP+2
?06:	dex
	bne	?04
	INDEX08
	ldy	#4
	tyx
	rol	ACM
	rol	ACM+2		; quoziente
	lda	FOP
	sta	IARG		; remainder
	lda	FOP+2
	sta	IARG+2		; C = hi rem
	bne	?08		; rem 32 bit
	ldy	#2		; rem 16 bit
?08:	lda	ACM+2		; C = hi quot
	bne	?10		; quot 32 bit
	ldx	#2		; quot 16 bit
?10:	CPU08	
	stx	ACMMinSize
	sty	IARGMinSize		
	clc
	rts

; _iUDiv64: divisione integer 64 bit unsigned
; In:	ACM: unsigned integer 1
;	IARG: unsigned integer 2
; Out:	ACM  -> integer unsigned ACM / IARG
;	IARG -> integer unsigned ACM MOD IARG
;	X = minima size quoziente
;	Y = minima size remainder
;	CF = 1 se IARG = 0 altrimenti CF = 0
; Uso:	A,X,Y,ACM,IARG,FOP
_iUDiv64:
	ACC16
	lda	IARG
	ora	IARG+2
	ora	IARG+4
	ora	IARG+6	
	bne	?02
	ACC08
	sec			; division by sero
	rts
?02:	ldx	#64		; loop 32 bit
	CPU16
	stz	FOP		; azzera rem
	stz	FOP+2
	stz	FOP+4
	stz	FOP+6
	pha			; 2 word temp.
	pha
?04:	rol	ACM		; quot
	rol	ACM+2
	rol	ACM+4
	rol	ACM+6
	rol	FOP
	rol	FOP+2
	rol	FOP+4
	rol	FOP+6
	sec
	lda	FOP
	sbc	IARG
	sta	$01,s
	lda	FOP+2
	sbc	IARG+2
	sta	$03,s
	lda	FOP+4
	sbc	IARG+4
	tay
	lda	FOP+6
	sbc	IARG+6
	bcc	?06
	sty	FOP+4
	sta	FOP+6
	lda	$01,s
	sta	FOP
	lda	$03,s
	sta	FOP+2
?06:	dex
	bne	?04
	INDEX08
	ldy	#8
	tyx
	rol	ACM
	rol	ACM+2		; quoziente
	rol	ACM+4
	rol	ACM+6
	lda	FOP
	sta	IARG		; remainder
	lda	FOP+2
	sta	IARG+2
	lda	FOP+4
	sta	IARG+4
	lda	FOP+6
	sta	IARG+6		; C = hi rem
	ora	IARG+4
	bne	?08		; rem 64 bit	
	ldy	#4		; rem 32 bit
?08:	lda	ACM+6		; C = hi quot
	ora	ACM+4
	bne	?10		; quot 64 bit
	ldx	#4		; quot 32 bit
?10:	pla			; scarta 2 word temp.
	pla
	CPU08	
	stx	ACMMinSize
	sty	IARGMinSize		
	clc
	rts

;----------------------------------------------------------
; implementazione SDIV signed integer
;----------------------------------------------------------

; _iSDiv8: divisione integer 8 bit signed
; In:	ACM: signed integer 1
;	IARG: signed integer 2
; Out:	ACM  -> integer signed ACM / IARG
;	IARG -> integer signed ACM MOD IARG
;	X = minima size quoziente
;	Y = minima size remainder
;	CF = 1 se IARG = 0 altrimenti CF = 0
;	VF = 1 se ACM overflow (quoziente)
; Uso:	A,X,Y,ACM,IARG,FOP
_iSDiv8:
	lda	IARG
	bne	?02
	sec			; division by sero
	rts
?02:	ldx	#0
	EOR	ACM		; segno risultato
	and	#$80		; bit 7 => segno
	ora	#$40		; bit 6 => signed int
	sta	ACMSgn		; salva segno quot.
	LDA	ACM
	and	#$80		; bit 7 => segno remainder = segno dividendo
	ora	#$40		; bit 6 => signed int
	sta	IARGSgn		; salva segno remainder
	BIT	IARG		; test segno IARG
	BPL	?04
	SEC			; complementa IARG
	txa
	SBC	IARG
	STA	IARG
?04:	BIT	ACM		; test segno ACM
	BPL	?06
	SEC			; complementa ACM
	txa
	SBC	ACM
	STA	ACM
?06:	JSR	_iUDiv8
	bit	ACMSgn
	bpl	?08
	sec			; quot. negativo
	lda	#0
	sbc	ACM
	sta	ACM
?08:	bit	IARGSgn
	bpl	?10
	sec			; remainder negativo
	lda	#0
	sbc	IARG
	sta	IARG
?10:	clc
	clv			; remainder mai provoca overflow
	lda	ACM		; confronta segno quoziente
	eor	ACMSgn		; con segno aspettato
	bpl	?12		; segni concordi -- OK
	sep	#PVFLAG		; segnni discordi => overflow
?12:	RTS

; _iSDiv16: divisione integer 16 bit signed
; In:	ACM: signed integer 1
;	IARG: signed integer 2
; Out:	ACM  -> integer signed ACM / IARG
;	IARG -> integer signed ACM MOD IARG
;	X = minima size quoziente
;	Y = minima size remainder
;	CF = 1 se IARG = 0 altrimenti CF = 0
;	VF = 1 se ACM overflow (quoziente)
; Uso:	A,X,Y,ACM,IARG,FOP
_iSDiv16:
	lda	IARG
	ora	IARG+1
	bne	?02
	sec			; division by sero
	rts
?02:	ldx	#0
	lda	IARG+1
	EOR	ACM+1		; segno risultato
	and	#$80		; bit 7 => segno
	ora	#$40		; bit 6 => signed int
	sta	ACMSgn		; salva segno quot.
	LDA	ACM+1
	and	#$80		; bit 7 => segno remainder = segno dividendo
	ora	#$40		; bit 6 => signed int
	sta	IARGSgn		; salva segno remainder
	BPL	?04
	ACC16
	SEC			; complementa ACM
	txa
	SBC	ACM
	STA	ACM
	ACC08
?04:	BIT	IARG+1		; test segno IARG
	BPL	?06
	ACC16
	SEC			; complementa IARG
	txa
	SBC	IARG
	STA	IARG
	ACC08
?06:	JSR	_iUDiv16
	; Y = minima size remainder -- aggiusta IARG (remainder)
	ldx	#IARG
	jsr	post16
	sty	IARGMinSize
	ldy	ACMMinSize
	; Y = minima size quot. -- aggiusta ACM (quot.)
	ldx	#ACM
	jsr	post16
	sty	ACMMinSize
	tyx
	ldy	IARGMinSize
	clc
	clv			; remainder mai provoca overflow
	lda	ACM+1		; confronta segno quoziente
	eor	ACMSgn		; con segno aspettato
	bpl	?12		; segni concordi -- OK
	sep	#PVFLAG		; segnni discordi => overflow
?12:	RTS

; post16 - aggiusta risultato per _iSDiv16
; In	Y = minima size
;	X = ptr ACM/IARG
; Out:	Y = minima size
;	ACM/IARG eventualmente complementato
post16:
	cpy	#$02		; min size WORD ?
	beq	?02b		; si
	; se ACM/IARG <= 7F allora min size = BYTE
	lda	<0,x
	cmp	#$80
	bcc	?02b
	bne	?02a		; ACM/IARG > 80 => WORD
	; ACM/IARG = 80 -- se risultato negativo => BYTE
	bit	<9,x
	bmi	?02c		; ACM/IARG BYTE negativo
?02a:	iny			; ACM/IARG WORD	
?02b:	bit	<9,x		; Flag N = segno risultato
	BPL	?03		; risultato positivo
?02c:	ACC16
	lda	#0
	sec			; risultato negativo: complementa ACM/IARG
	sbc	<0,x
	sta	<0,x
	ACC08
?03:	rts

; _iSDiv32: divisione integer 32 bit signed
; In:	ACM: signed integer 1
;	IARG: signed integer 2
; Out:	ACM  -> integer signed ACM / IARG
;	IARG -> integer signed ACM MOD IARG
;	X = minima size quoziente
;	Y = minima size remainder
;	CF = 1 se IARG = 0 altrimenti CF = 0
;	VF = 1 se ACM overflow (quoziente)
; Uso:	A,X,Y,ACM,IARG,FOP
_iSDiv32:
	ACC16
	lda	IARG
	ora	IARG+2
	ACC08
	bne	?02
	sec			; division by sero
	rts
?02:	ldx	#0
	lda	IARG+3
	EOR	ACM+3		; segno risultato
	and	#$80		; bit 7 => segno
	ora	#$40		; bit 6 => signed int
	sta	ACMSgn		; salva segno quot.
	LDA	ACM+3
	and	#$80		; bit 7 => segno remainder = segno dividendo
	ora	#$40		; bit 6 => signed int
	sta	IARGSgn		; salva segno remainder
	BPL	?04
	ACC16
	SEC			; complementa ACM
	txa
	SBC	ACM
	STA	ACM
	txa
	SBC	ACM+2
	STA	ACM+2
	ACC08
?04:	BIT	IARG+3		; test segno IARG
	BPL	?06
	ACC16
	SEC			; complementa IARG
	txa
	SBC	IARG
	STA	IARG
	txa
	SBC	IARG+2
	STA	IARG+2	
	ACC08
?06:	JSR	_iUDiv32
	; Y = minima size remainder -- aggiusta IARG (remainder)
	ldx	#IARG
	jsr	post32
	sty	IARGMinSize
	ldy	ACMMinSize
	; Y = minima size quot. -- aggiusta ACM (quot.)
	ldx	#ACM
	jsr	post32
	sty	ACMMinSize
	tyx
	ldy	IARGMinSize
	clc
	clv			; remainder mai provoca overflow
	lda	ACM+3		; confronta segno quoziente
	eor	ACMSgn		; con segno aspettato
	bpl	?12		; segni concordi -- OK
	sep	#PVFLAG		; segnni discordi => overflow
?12:	RTS

; post32 - aggiusta risultato per _iSDiv32
; In	Y = minima size
;	X = ptr ACM/IARG
; Out:	Y = minima size
;	ACM/IARG eventualmente complementato
post32:
	cpy	#$04		; min size LONG ?
	beq	?02b		; si
	; se ACM/IARG <= 7FFF allora min size = WORD
	ACC16
	lda	<0,x
	cmp	#$8000
	ACC08
	bcc	?02b
	bne	?02a		; ACM/IARG > 8000 => LONG
	; ACM/IARG = 8000 -- se risultato negativo => BYTE
	bit	<9,x
	bmi	?02c		; ACM/IARG WORD negativo
?02a:	iny			; ACM/IARG LONG
	iny
?02b:	bit	<9,x		; Flag N = segno risultato
	BPL	?03		; risultato positivo
?02c:	ACC16
	lda	#0
	sec			; risultato negativo: complementa ACM/IARG
	sbc	<0,x
	sta	<0,x
	lda	#0
	sbc	<2,x
	sta	<2,x
	ACC08
?03:	rts

; _iSDiv64: divisione integer 64 bit signed
; In:	ACM: signed integer 1
;	IARG: signed integer 2
; Out:	ACM  -> integer signed ACM / IARG
;	IARG -> integer signed ACM MOD IARG
;	X = minima size quoziente
;	Y = minima size remainder
;	CF = 1 se IARG = 0 altrimenti CF = 0
;	VF = 1 se ACM overflow (quoziente)
; Uso:	A,X,Y,ACM,IARG,FOP
_iSDiv64:
	ACC16
	lda	IARG
	ora	IARG+2
	ora	IARG+4
	ora	IARG+6	
	ACC08
	bne	?02
	sec			; division by sero
	rts
?02:	lda	IARG+7
	EOR	ACM+7		; segno risultato
	and	#$80		; bit 7 => segno
	ora	#$40		; bit 6 => signed int
	sta	ACMSgn		; salva segno quot.
	LDA	ACM+7
	and	#$80		; bit 7 => segno remainder = segno dividendo
	ora	#$40		; bit 6 => signed int
	sta	IARGSgn		; salva segno remainder
	BPL	?04
	jsr	_iNegACM	; complementa ACM
?04:	BIT	IARG+7		; test segno IARG
	BPL	?06
	jsr	_iNegIARG	; complementa IARG
?06:	JSR	_iUDiv64
	; Y = minima size remainder -- aggiusta IARG (remainder)
	ldx	#IARG
	jsr	post64
	sty	IARGMinSize
	ldy	ACMMinSize
	; Y = minima size quot. -- aggiusta ACM (quot.)
	ldx	#ACM
	jsr	post64
	sty	ACMMinSize
	tyx
	ldy	IARGMinSize
	clc
	clv			; remainder mai provoca overflow
	lda	ACM+7		; confronta segno quoziente
	eor	ACMSgn		; con segno aspettato
	bpl	?12		; segni concordi -- OK
	sep	#PVFLAG		; segnni discordi => overflow
?12:	RTS

; post64 - aggiusta risultato per _iSDiv64
; In	Y = minima size
;	X = ptr ACM/IARG
; Out:	Y = minima size
;	ACM/IARG eventualmente complementato
post64:
	cpy	#$08		; min size QUAD ?
	beq	?02b		; si
	; se ACM/IARG <= 7FFFFFFF allora min size = LONG
	ACC16
	lda	<2,x
	cmp	#$8000
	ACC08
	bcc	?02b		; ACM/IARG < 80000000 => LONG
	bne	?02a		; ACM/IARG > 80000000 => QUAD
	ACC16
	lda	ACM
	ACC08
	bne	?02a		; ACM/IARG > 80000000 => QUAD
	; ACM/IARG = 80000000 -- se risultato negativo => LONG
	bit	<9,x
	bmi	?02c		; ACM/IARG LONG negativo
?02a:	ldy	#8		; ACM/IARG QUAD
?02b:	bit	<9,x		; Flag N = segno risultato
	BPL	?03		; risultato positivo
?02c:	jsr	_iNegX		; risultato negativo: complementa ACM/IARG
?03:	rts

;----------------------------------------------------------
; Funzioni 'move'
;----------------------------------------------------------

; _iMovACM2A - copia ACM (in size e tipo) in IARG
_iMovACM2A:
	lda	ACMSgn
	sta	IARGSgn
	ldx	ACMSize
	stx	IARGSize
	dex
?01:	lda	ACM,x
	sta	IARG,x
	dex
	bpl	?01
	rts
	
;----------------------------------------------------------
; Conversioni Stringa (decimale / hex) - Integer
;----------------------------------------------------------

; _Str2Int - converte stringa decimale in intero
; In	- C = offset stringa decimale
;	  Y = banco stringa
;	  X<7> = bit signed (richiesto signed int)
;	  X<6:0> = dimensione richiesta => 1,2,4,8 
;	  DPR = DP02ADDR
;
; Out	- ACM => intero 1,2,3,4,8 bytes
;	  ACMSgn<7> = segno (solo signed)
;	  ACMSgn<6> = signed int
;	  Y => indice dove si arresta la conversione
;	  CF = 0, VF = 0 OK
;	  CF = 0, VF = 1 mismatch type
;	  CF = 1, VF = 1 se overflow
;	  CF = 1, VF = 0 se stringa non valida
_Str2Int:
	jsr	_pres2i		; prepara var. conversione
	lda	ACMSize		; interi a 3 bytes non accettati
	cmp	#$03
	bne	?01
	lda	#$04
?01:	sta	ACMSize
	LDY	#-1
?02:	INY
	CPY	#MAXINTSTR	; max. dimensione stringa hex/dec
	bcs	?11		; esce con CF = 1 e con VF = 0
	lda	[FPLPtr],y	; load char
	beq	?10		; fine stringa => esce con CF = 1 e VF = 0
	CMP	#' '
	BEQ	?02		; scarta spazi iniziali
	CMP	#$08
	BEQ	?02		; scarta TAB iniziali
	CMP	#'+'		; segno +
	BEQ	?04		; cerca primo digit decimale
	CMP	#'-'
	BNE	?08		; test digit decimale
	LDA	#$80
	TSB	ACMSgn		; intero negativo
	lda	#$40
	STA	FPFlag		; FPFlag<6> => intero signed
?04:	INY			; cerca digit decimale dopo '+' o '-'
	CPY	#MAXINTSTR	; max. dimensione stringa hex/dec
	bcs	?11		; esce con CF = 1 e con VF = 0
	lda	[FPLPtr],y	; load char
	beq	?10		; fine stringa => esce con CF = 1 e VF = 0
	CMP	#' '
	BEQ	?04		; scarta spazi dopo '+' o '-'
	CMP	#$08
	BEQ	?02		; scarta TAB dopo '+' o '-'
	bne	?08		; test digit decimale
?06:	lda	[FPLPtr],y	; loop scansione digit decimale
	beq	?10		; fine stringa
?08:	SEC			; next digit decimale
	SBC	#('0'+10)
	CLC
	ADC	#10
	BCC	?10		; no digit decimale => fine scansione
	PHA
	JSR	_iUMult10	; ACM * 10 -> ACM
	PLA
	bcs	?30		; overflow => esce con CF = 1, VF = 1
	JSR	_iUAdd8		; ACM + A -> ACM
	bcs	?30		; overflow => esce con CF = 1, VF = 1
	lda	#$80	
	tsb	FPFlag		; FPFlag<7> -> flag digit decimale
	INY			; next char
	CPY	#MAXINTSTR	; max. dimensione stringa hex/dec
	bcc	?06		; loop scansione digit decimale

?10:	; a questo punto scansione terminata o per fine stringa o per
	; primo carattere non digit decimale all'indice attuale
	sec			; assume CF = 1, VF = 0
?11:	clv
	lda	FPFlag
	bpl	?40		; CF = 1 e VF = 0 => stringa vuota
				; o nessun digit decimale valido

	; si testa se ACM contiene un numero
	; compatibile con la dimensione richiesta
	jsr	_minsize	; X = minima dimensione - 1	
	cpx	ACMSize		; 1,2,3,4,8 => CF = 1 se overflow
	bcs	?30		; overflow => CF = 1, VF = 1
	; qui ora CF = 0
	bit	ACMSgn		; bit 6 => richiesto tipi signed
	bvs	?13		; richiesto signed
	bit	FPFlag		; test segno '-'
	bra	?40		; unsigned => OK => CF = 0, VF = 0
				; se VF = 1 => signed => mismatch
				
?13:	; richiesto tipo signed
	lda	FPFlag		; FPFlag<6> = segno
	asl	a		; bit 7 = segno, CF = 1 (FPFlag<7> = 1)
	tsb	ACMSgn		; imposta segno
	ldx	ACMSize
	dex			; indice MSB
	lda	ACM,x		; test MSB ACM
	bpl	?18		; OK -- valore abs. < 8000...00
	
	; se MSB = 1 e tutti i restanti bit sono nulli il signed int
	; e' valido e pari al minimo negativo. Qui ancora CF = 1
	bit	ACMSgn		; signed positivo deve avere MSB = 0
	bpl	?30		; overflow => CF = 1, VF = 1	
	; intero negativo
	cmp	#$80		; al minimo deve essere 80 00 00 ... 00
	bne	?30		; overflow => CF = 1, VF = 1
	; qui ancora CF = 1
	dex
?15:	lda	ACM,x
	bne	?30		; overflow => CF = 1, VF = 1
	dex
	bpl	?15		; testa tutti i bytes (= 00)
	
?18:	; OK -- adesso signed int in ACM compatibile con tipo richiesto
	ACC16
	lda	ACM		; test ACM = 0
	ora	ACM+2
	ora	ACM+4
	ora	ACM+6
	ACC08
	bne	?19		; non nullo
	lda	#$80
	trb	ACMSgn		; azzera segno se nullo
	bra	?20
?19:	bit	ACMSgn		; test segno
	bpl	?20		; positivo
	jsr	_iNegACM	; complemento a 2 di ACM	
?20:	clv			; OK
	clc
	bcc	?40
?30:	sep	#PVFLAG		; VF = 1 => overflow					
?40:	rts
		
; _Str2Hex - converte stringa hex. in unsigned intero
; In	- C = offset stringa hex.
;	  Y = banco stringa
;	  X = dimensione richiesta => 1,2,3,4,8 
;	  DPR = DP02ADDR
;
; Out	- ACM => intero 1,2,3,4,8 bytes
;	  Y => indice dove si arresta la conversione
;	  CF = 1, VF = 1 se overflow
;	  CF = 1, VF = 0 se stringa non valida
_Str2Hex:
	jsr	_pres2i		; prepara var. conversione
	stz	ACMSgn		; HEX => solo unsigned
	ldy	#0		; indice stringa
?01:	lda	[FPLPtr],y	; load char
	beq	?20		; fine stringa => esce con CF = 1 e VF = 0
	cmp	#' '		; scarta spazi iniziali
	beq	?02
	cmp	#$08		; scarta 'TAB' iniziali
	bne	?04
?02:	iny			; next char
	cpy	#MAXINTSTR	; max. dimensione stringa hex/dec
	bcc	?01
	bcs	?25		; esce con CF = 1 e con VF = 0
?04:	CMP	#'a'		; loop test digit esadecimali
	BCC	?12
	SBC	#$20		; caps
?12:	SEC
	SBC	#('0'+10)
	CLC
	ADC	#10
	BCS	?13		; ok, digit hex
	SBC	#(6+16)
	CLC
	ADC	#6
	BCC	?20		; no digit esadecimale => fine scansione
	ADC	#9		; digit hex
?13:	and	#$0F		; maschera digit hex	
	PHA			; salva digit
	lda	#$80
	sta	FPFlag		; segnala hex digit valido
	ACC16			; ACM = ACM * 16
	ldx	#$04		; 4 shift
	lda	ACM
?15:	asl	a
	rol	ACM+2
	rol	ACM+4
	rol	ACM+6
	bcs	?17		; overflow
	dex
	bne	?15
?17:	sta	ACM
	ACC08
	pla			; digit hex
	ora	ACM		; add digit
	sta	ACM
	bcs	?24		; CF = 1, VF = 1 => overflow su 64 bit
	iny			; next char
	cpy	#MAXINTSTR	; max. dimensione stringa hex/dec
	bcs	?20		; fine scansione
	lda	[FPLPtr],y	; load char
	bne	?04		; loop
?20:	; a questo punto scansione terminata o per fine stringa o per
	; primo carattere non hex all'indice attuale
	sec			; assume CF = 1, VF = 0
	clv
	lda	FPFlag
	beq	?25		; CF = 1 e VF = 0 => stringa vuota
				; o nessun digit hex valido 
	; si testa se ACM contiene un numero
	; compatibile con la dimensione richiesta
	jsr	_minsize	; X = minima dimensione - 1	
	clv			; assume no overflow
	cpx	ACMSize		; 1,2,3,4,8 => CF = 1 se overflow
	bcc	?25		; OK => CF = 0, VF = 0
?24:	sep	#PVFLAG		; VF = 1 => overflow	
?25:	rts			; CF = 1 se errore
	
; routine di preparazione a conversione stringa -> intero
_pres2i:
	sta	FPLPtr		; set long pointer
	xba
	sta	FPLPtr+1
	sty	FPLPtr+2
	txa
	and	#$7F		; maschera off tipo
	bne	?01
	inc	a		; minima dimensione: byte
?01:	cmp	#$05
	bcc	?02		; valori leciti: 1,2,3,4,8		
	lda	#$08		; max. dimensione: 8 bytes
?02:	sta	ACMSize		; tipo intero richiesto
	txa
	and	#$80		; bit 7: tipo signed
	lsr	a		; bit 6: tipo signed
	sta	ACMSgn
	ACC16			; azzera ACM
	stz	ACM
	stz	ACM+2
	stz	ACM+4
	stz	ACM+6
	ACC08
	stz	FPFlag		; flag conversione
	rts

; calcola minima dimensione ACM
; Out X = minima dimensione ACM - 1 (0,1,2,3,7)
_minsize:
	ACC16
	ldx	#$07		; si assume intero 64 bit
	lda	ACM+6
	ora	ACM+4
	ACC08
	bne	?02		; X = 07 => intero 64 bit
	ldx	#$03
	lda	ACM+3
	bne	?02		; X = 03 => intero 32 bit
	dex
	lda	ACM+2
	bne	?02		; X = 02 => intero 24 bit
	dex
	lda	ACM+1
	bne	?02		; X = 01 => intero 16 bit
	dex			; X = 00 => intero  8 bit
?02:	rts
	
; _iUMult10 - Moltiplica unsigned ACM (64 bit) x 10
; In:	ACM -> unsigned integer 64 bit
; Out:	ACM <- ACM * 10 (unsigned 64 bit)
;	CF -> unsigned overflow flag
; Uso:	A,X,ACM,FOP
_iUMult10:
	LDX	#INTGSIZE-1
?01:	LDA	ACM,X		; copia ACM -> FOP
	STA	FOP,X
	DEX
	BPL	?01
	JSR	?10		; ACM * 2 -> ACM
	bcs	?22
	JSR	?10		; ACM * 4 -> ACM
	bcs	?22
	JSR	_iUAdd64	; ACM * 5 -> ACM
	bcs	?22
				; ACM * 10 -> ACM

?10:	; moltiplica x 2
	ACC16
	ASL	ACM
	ROL	ACM+2
	ROL	ACM+4
	ROL	ACM+6
?20:	ACC08	
?22:	RTS			; CF = 1 => overflow

; _iUAdd8 - Somma unsigned ACM (64 bit) e Accmulatore (8 bit)
; In:	ACM -> unsigned integer 64 bit
;	A   -> unsigned byte
; Out:	ACM <- ACM + A (unsigned 64 bit)
;	CF = 1 +> overflow
; Uso:	A,X,ACM,FOP
_iUAdd8:
	LONG_OFF
	LDX	#(INTGSIZE-1)	; azzera FOP+1..FOP+7
?01:	STZ	FOP,X
	DEX
	BNE	?01
	STA	FOP		; byte in A
	
; _iUAdd64 - Somma unsigned ACM e FOP (64 bit)
; In:	ACM -> unsigned integer 64 bit
;	FOP -> unsigned integer 64 bit
; Out:	ACM <- ACM + FOP  (unsigned 64 bit)
;	CF = 1 => unsigned overflow
;	VF = 1 +> signed overflow
; Uso:	A,ACM,FOP
_iUAdd64:
	rep	#(PMFLAG+PCFLAG)	; ACC16 + CLC
	LDA	ACM
	ADC	FOP
	STA	ACM
	LDA	ACM+2
	ADC	FOP+2
	STA	ACM+2
	LDA	ACM+4
	ADC	FOP+4
	STA	ACM+4
	LDA	ACM+6
	ADC	FOP+6
	STA	ACM+6
	ACC08
	RTS

;----------------------------------------------------------
; Conversioni Integer-Stringa (decimale / hex)
;----------------------------------------------------------
	
; _Int2Str: converte numero intero in stringa decimale/hex
; In	- ACM => intero max. 64 bit
;	  ACMSize => dimensione intero (1, 2, 3, 4, 8 bytes)
;	  ACMSgn => <7>:segno, <6>:tipo signed
;	  X => precisione richiesta
;	  A => flag conversione: 
;		<7> 1 => DEC, 0 => HEX
;		<6> 0 => LOWCAPS, 1 => HICAPS (HEX only - <7> = 0)
;		<6> 1 => group thousand       (DEC only - <7> = 1)
;		<5> flag long pointer (forza hex a 6 digit)
; 	  	<1> => blank se positivo (DEC signed only)
; 	  	<0> => segno '+'/blank se positivo (DEC signed only)
;	  DPR -> impostato a DP02ADDR
;	  DBR -> impostato su banco 0
;	  CPU -> 8 bit
;
; Out:	- X => puntatore stringa in pagina 02
;	  A = Y => lunghezza stringa
_Int2Str:
	txy			; precisione minima = 1
	bne	?02
	inx
?02:	cpx	#XCVTMAXI	; max. numero char stringa integer
	bcc	?03
	ldx	#XCVTMAXI
?03:	bit	#$20		; test long pointer
	beq	?04		; standard integer (1,2,4,8)
	ldx	#6		; precisione fissa a 6 digit
	ldy	#3		; dimensione long pointer = 3 bytes
	and	#01100000B	; maschera off bit inutilizzati - forza HEX
	bne	?06
?04:	ldy	ACMSize		; standard integer
	cpy	#3		; se size = 3 imposta size = 4
	bne	?06
	iny
?06:	stx	FmtPrec		; salva precisione
	sta	XVFlag		; salva flag
	tyx			; minima dimensione = byte
	bne	?07
	iny
?07:	cpy	#5
	bcc	?08		; Y < 5 => OK (size = 1,2,3,4)
	ldy	#8		; MAX: 8 bytes
?08:	sty	ACMSize		; salva size corretta integer
	tax			; test bit 7
	bmi	?20		; <7> = 1 => DEC
	
	; conversione in stringa HEX -- ignora ACMSgn
	ldx	#$06		; valore da aggiungere per digit A..F
	asl	a		; NF => HI CAPS, bit 6 => long ptr
	sta	XVFlag		; <6> => long pointer
	bmi	?10		; HI CAPS
	ldx	#$26		; valore da aggiungere per digit a..f
?10:	stx	FPTmp1
	tyx
	dex			; X = MSB integer (0,1,3,7)	
	LDY	#1		; indice stringa destinazione (FPUStr+1)
?12:	LDA	<ACM,X		; converte MSB
	JSR	Byte2Hex	; A = nibble H
	STA	!DP02ADDR+FPUStr,Y
	INY
	xba			; nibble L
	STA	!DP02ADDR+FPUStr,Y
	INY
	DEX
	BPL	?12
	tyx
	stz	FPUStr,x	; terminatore #0 stringa
	; a questo punto la stringa HEX e' convertita in ACMSize * 2 digit
	ldx	#FPUStr+1	; puntatore stringa pagina 02
	bit	XVFlag		; test long pointer ?
	bvc	?14		; no
	; long pointer => stringa completa a 6 digit
	ldy	FmtPrec
	tya			; A = Y = lunghezza stringa
	rts			; X = inizio stringa pagina 02
?14:	jsr	_Int2End	; A = len -- Y = first -- X = last
	stz	XVFlag		; per stringa HEX ignora restanti flag	
	stz	ACMSgn		; HEX ignora segno
	bra	?30		; padding finale
	
?20:	; conversione in stringa decimale -- Y = size (1,2,4,8)
	tyx
	dex			; X = MSB integer (0,1,3,7)
	lda	#$80		; clear segno
	trb	ACMSgn
	bit	ACMSgn		; signed ?
	bvc	?22		; NO
	bit	<ACM,x		; test segno
	bpl	?22		; positivo
	tsb	ACMSgn		; imposta segno negativo	
?22:	cpy	#8
	beq	?26		; non occorre estensione
	sty	FPTmp1		; calcola numero byte estensione
	lda	#8
	sec
	sbc	FPTmp1
	tay			; Y = numero di bytes da estendere (7,6,4)
	lda	#0		; estende con $00 se positivo/unsigned
	bit	ACMSgn
	bpl	?24		; positivo
	lda	#$FF		; estende negativo
?24:	inx			; next byte da estendere
	sta	<ACM,x
	dey
	bne	?24
?26:	ACC16			; copia ACM in FOP (signed 64 bytes)
	lda	ACM
	sta	FOP
	lda	ACM+2
	sta	FOP+2
	lda	ACM+4
	sta	FOP+4
	lda	ACM+6
	sta	FOP+6
	ACC08
	bit	ACMSgn
	bpl	?28		; positivo
	ldx	#FOP
	jsr	_iNegX		; negativo => complementa a 2
?28:	jsr	_UI2Str		; converte in stringa decimale

?30:	; a questo punto la stringa convertita si trova in FPUStr+1
	; A = len -- Y = ptr al primo digit non '0' -- X = ptr last digit
	jsr	_thgroup	; copia in XCVTStr/group thousand
	; A = len -- Y = ptr first digit -- X = ptr last digit
	tyx			; X = puntatore stringa in pagina 02
	tay			; Y = lunghezza attuale stringa 
	sta	FPTmp4		; lunghezza attuale stringa
	lda	FmtPrec		; precisione richiesta
	sec
	sbc	FPTmp4		; lunghezza padding
	beq	?50		; no padding
	bcc	?50		; no padding
	
	; padding della stringa con '0' iniziali
	tay			; counter padding
	lda	#'0'
?32:	dex			; aggiorna ptr a digit precedente
	sta	<0,x
	dey
	bne	?32
	ldy	FmtPrec		; Y = lunghezza stringa
	
	; memorizza eventuale segno ('+', '-', o ' ')
	; X = ptr stringa -- Y = lunghezza stringa
?50:	bit	ACMSgn		; signed ?
	bvc	?60		; NO -- esce
	bpl	?52		; signed positivo
	lda	#'-'		; signed negativo => store '-'
	bne	?56
?52:	lda	XVFlag		; test store segno
	lsr	a		; CF -> flag segno positivo
	bcc	?60		; no store segno se positivo
	stx	FPTmp1		; salva ptr stringa
	ldx	#'+'		; assume '+'
	lsr	a		; CF -> flag blank
	bcc	?54		; store '+'
	ldx	#' '		; store blank
?54:	txa			; A = segno
	ldx	FPTmp1		; X = ptr stringa
?56:	dex			; ptr al segno
	sta	<0,x
	iny			; incrementa lunghezza
?60:	tya			; A = Y = lunghezza stringa	
	rts			; X = puntatore stringa

; _UI2Str: converte intero senza segno in stringa decimale a 20 digits
; In:	- FOP -> unsigned integer 64 bit
;	  DPR -> impostato a DP02ADDR
;	  CPU -> 8 bit
;
; Out:	- FPUStr+1 -> stringa decimale 20 cifre
;	- A -> lunghezza stringa significativa (X - Y + 1)
;	- Y -> ptr in pag02 al primo digit diverso ad '0'
;	- X -> ptr in pag02 ultimo digit 
; NOTA	il numero intero viene esteso a 9 bytes e si applica il metodo
;	delle sottrazioni ripetute per determinare ciascun digit
_UI2Str:
	LDY	#$00
	STY	FOP+8		; MSB = 0 (9 bytes)
	STY	FPTmp2		; indice stringa
	LDX	#(FPSTRSIZE - 1)
?01:	STZ	FPUStr,X	; clear stringa destinazione
	DEX
	BPL	?01
	TYX
	phb			; imposta DBR al PBR corrente
	phk			; per accedere alle costanti
	plb
	LDY	#$80		; contatore SBC
?02:	rep	#(PMFLAG.OR.PCFLAG)
	.LONGA	on		; ACC16 + CLC
	LDA	FOP		; divisione mediante sottrazioni ripetute
	ADC	!CONSTDECTBL,x
	STA	FOP
	LDA	FOP+2
	ADC	!CONSTDECTBL+2,x
	STA	FOP+2
	LDA	FOP+4
	ADC	!CONSTDECTBL+4,x
	STA	FOP+4
	LDA	FOP+6
	ADC	!CONSTDECTBL+6,x
	STA	FOP+6
	ACC08			; ripristina acc/mem 8 bit
	LDA	FOP+8
	ADC	!CONSTDECTBL+8,x
	STA	FOP+8
	INY			; incrementa contatore SBC
	BCS	?03		; nuova SBC se X < 0
	BPL	?02		; resto >= 10, nuova SBC
	BMI	?04		; resto < 10 - store digit
?03:	BMI	?02		; nuova SBC se X < 0
?04:	TYA			; fine SBC
	BCC	?05		; positivo
	EOR	#$FF		; negativo
	ADC	#10
?05:	ADC	#('0' - 1)	; digit
	TAY
	TXA
	CLC
	ADC	#DECTBLLEN	; indice tabella divisioni
	STA	FPTmp1
	LDX	FPTmp2
	INX
	TYA
	AND	#$7F
	STA	FPUStr,x	; salva digit
?06:	STX	FPTmp2		; indice stringa
	LDX	FPTmp1
	TYA
	EOR	#$FF		; inverte contatore SBC
	AND	#$80
	TAY
	CPX	#DECTBLSIZE
	BNE	?02		; ricava digit successivo
	plb			; ripristina DBR	
	LDX	#FPUStr+1	; posiziona puntatori start-end
	
_Int2End:
	; posiziona X sulla prima cifra diversa da '0'
	; la stringa e' terminata sicuramente con #0
	stx	FPTmp2
?10:	LDA	<0,X		; start stringa
	beq	?11		; fine
	CMP	#'0'
	BNE	?12		; primo digit non '0'
	INX
	bne	?10		; loop
?11:	DEX			; ultimo digit
?12:	txy			; Y = indice primo digit significativo
	ldx	FPTmp2			
?13:	lda	<0,x		; si posiziona su ultimo digit
	beq	?14
	inx
	bne	?13
?14:	dex			; X = last digit
	txa
	sty	FPTmp1
	sec
	sbc	FPTmp1
	inc	a		; A = lunghezza stringa significativa
	rts

; formatta stringa minima raggruppando le migliaia
; i digit vengono spostati verso la fine di XCVTStr
_thgroup:
	sty	FPTmp1		; indice primo digit significativo
	txy			; Y => ptr ultimo digit
	ldx	#XCVTStrEnd
	stz	<0,x		; terminatore #0
	dex			; indice ultimo digit
?02:	lda	#3		; counter gruppi digits
?04:	xba			; B = counter
	lda	!DP02ADDR,y
	sta	<0,x		; copia digit
	xba			; A = counter
	dey
	cpy	FPTmp1
	bcc	_Int2End	; fine loop
	dex
	dec	a
	bne	?04
	bit	XVFlag		; test group thousand
	bvc	?02		; no group -- loop
	lda	#','		; separatore migliaia
	sta	<0,x
	dex
	bra	?02		; loop

; Byte2Hex: converte byte in digit HEX
; In:	- A = byte
;	  FPTmp1 -> valore da aggiungere per digit a..f/A..F
;
; Out:	- BA - Digit HEX (A->H, B->L)
Byte2Hex:
	pha		; salva byte
	JSR	?01	; converte digit L
	xba		; B -> Digit L
	pla		; ripristina byte
	LSR	A	; A/16 -> A 
	LSR	A
	LSR	A
	LSR	A
?01:	AND	#$0F	; maschera nibble L
	CMP	#10
	BCC	?02
	ADC	FPTmp1
?02:	ADC	#'0'
	RTS

; long fast unsigned division 16 bit
;
;	entry:	C = dividend 16 bit
;		X = divisor low
;		Y = divisor high
;
;	exit:	C = quotient
;		X = remainder low
;		Y = remainder high
;
;	use:	all
;
;	note:	no check for null divisor
;		long subroutine (call with jsl)
;
dvend	.EQU	DUMMY100
dvsor	.EQU	DUMMY100+2
fidiv:
	phd			; save dp
	pea	#P0MAT
	pld			; set dp
	stx	dvsor		; set divisor
	sty	dvsor+1
	ldx	#16		; bit counter
	ldy	#0		; partial remainder
	CPU16
	sta	dvend		; set dividend
	tya			; C=remainder
?10:	rol	dvend		; partial quotient
	rol	a
	sec
	tay			; save remainder
	sbc	dvsor
	bcs	?20		; ok
	tya			; restore old remainder
?20:	dex
	bne	?10		; loop
	rol	dvend		; adjust final quotient	
	sta	dvsor		; save remainder
	lda	dvend		; C=quotient
	CPU08
	ldx	dvsor		; X=remainder low
	ldy	dvsor+1		; Y=remainder high
	pld			; restore dp
	rtl

; long fast unsigned division 16 bit
;
;	entry:	C = dividend 16 bit
;		X = divisor low
;		Y = divisor high
;
;	exit:	C = quotient
;		X = remainder low
;		Y = remainder high
;
;	use:	all
;
;	note:	no check for null divisor
;		long subroutine (call with jsl)
;
;dvsor	.EQU	DUMMY100
quot	.EQU	DUMMY100
fidiv2:
	phd			; save dp
	pea	#P0MAT
	pld			; set dp
	stx	dvsor		; set divisor
	sty	dvsor+1
	ldx	#1		; bit counter
	CPU16
	tay			; Y=dividend
	stz	quot		; init quotient
	lda	dvsor		; C=divisor
?10:	asl	a		; shift divisor: get leftmost bit
	bcs	?20		; go to division
	inx
	cpx	#17		; test all divisor bit's
	bne	?10
?20:	ror	a		; put shifted-out bit back
	sta	dvsor
?30:	tya			; get dividend
	sec
	sbc	dvsor
	bcc	?40		; can't subctract, retain old dividend
	tay			; Y=new dividend
?40:	rol	quot		; shift carry into quotient (1 if division)
	lsr	dvsor		; shift right divisor for next subtract
	dex
	bne	?30
	sty	dvsor		; store remainder
	lda	quot		; C=quotient
	CPU08
	ldx	dvsor		; X=remainder low
	ldy	dvsor+1		; Y=remainder high
	pld			; restore dp
	rtl

; long fast unsigned multiplication 16 bit
;
;	entry:	C = multiplicand 1 16 bit
;		X = multiplicand 2 low byte
;		Y = multiplicand 2 high byte
;
;	exit:	C = result
;		Y = result low byte
;
;	use:	all
;
;	note:	16 bit result only, no overflow detected
;		long subroutine (call with jsl)
;
mcand2	.EQU	DUMMY100
fimlt:
	phd			; save dp
	pea	#P0MAT
	pld			; set dp
	stx	mcand2
	sty	mcand2+1
	ldy	#0		; partial result
	CPU16
?10:	tax			; if mcand1 = 0...
	beq	?30		; ...done
	lsr	a		; get right bit
	bcc	?20		; if clear, no addition to partial result...
	clc
	tax
	tya			; ...else add mcand2 to partial result
	adc	mcand2
	tay			; Y=partial result
	txa
?20:	asl	mcand2		; shift mcand2 for next time
	bra	?10
?30:	tya			; C=result
	CPU08
	pld			; restore dp
	rtl

test1:
	jsl	fidiv
	brk
	brk
	
test3:
	jsl	fimlt
	brk
	brk

test2:
	jsl	fidiv2
	brk
	brk
	
;----------------------------------------------------------------------------
; COSTANTI
;----------------------------------------------------------------------------
	
; Tabella potenze di 10 in ordine decrescente da -1E19 a 1E00,
; con segni alterni, a 9 bytes
CONSTDECTBL:
	.DB	$00, $00, $18, $76, $FB, $DC, $38, $75, $FF	; -1E19
CONSTDECTBL1:
	.DB	$00, $00, $64, $A7, $B3, $B6, $E0, $0D, $00	; +1E18
	.DB	$00, $00, $76, $A2, $87, $BA, $9C, $FE, $FF	; -1E17	
	.DB	$00, $00, $C1, $6F, $F2, $86, $23, $00, $00	; +1E16
	.DB	$00, $80, $39, $5B, $81, $72, $FC, $FF, $FF	; -1E15
	.DB	$00, $40, $7A, $10, $F3, $5A, $00, $00, $00	; +1E14
	.DB	$00, $60, $8D, $B1, $E7, $F6, $FF, $FF, $FF	; -1E13
	.DB	$00, $10, $A5, $D4, $E8, $00, $00, $00, $00	; +1E12 
	.DB	$00, $18, $89, $B7, $E8, $FF, $FF, $FF, $FF	; -1E11
	.DB	$00, $E4, $0B, $54, $02, $00, $00, $00, $00	; +1E10
	.DB	$00, $36, $65, $C4, $FF, $FF, $FF, $FF, $FF	; -1E9	
	.DB	$00, $E1, $F5, $05, $00, $00, $00, $00, $00	; +1E8
	.DB	$80, $69, $67, $FF, $FF, $FF, $FF, $FF, $FF	; -1E7
	.DB	$40, $42, $0F, $00, $00, $00, $00, $00, $00	; +1E6
	.DB	$60, $79, $FE, $FF, $FF, $FF, $FF, $FF, $FF	; -1E5
	.DB	$10, $27, $00, $00, $00, $00, $00, $00, $00	; +1E4
	.DB	$18, $FC, $FF, $FF, $FF, $FF, $FF, $FF, $FF	; -1E3
	.DB	$64, $00, $00, $00, $00, $00, $00, $00, $00	; +1E2	
	.DB	$F6, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF	; -1E1
	.DB	$01, $00, $00, $00, $00, $00, $00, $00, $00	; +1E0

DECTBLSIZE:	.EQU ($ - CONSTDECTBL)
DECTBLLEN:	.EQU (CONSTDECTBL1 - CONSTDECTBL)
