; RESET.ASM
; PROGETTO: B1601
; Compilatore Avocet X65816

; RESET

_RTC_INC_	.SET	1
_KFR_INC_	.SET	1
_ACIA_INC_	.SET	1
_DMA_INC_	.SET	1
_ATA_INC_	.SET	1
_VBB_INC_	.SET	1
_KBD_INC_	.SET	1

	.INCLUDE inc\global.inc
	.INCLUDE inc\dirp00.inc
	.INCLUDE inc\dirp01.inc
	;.INCLUDE INC\SP.INC

.LIST on
	
	.CODEF8		
	.GLOBAL SysStart, LF8Tst
	.EXTERN VDCSetup, VDCREG16, fdinit, vdinit
	.EXTERN initata, CheckVol, _ScnInit

	.EXTERN _KbdCnt, _KbdToggle, _KbdSt, _PS2Ctl, _KbdITail
	.EXTERN _KbdIHead, _KbdShift, _KbdFlag, _LCDFlag

	.EXTERN LCDSetup, GetBufKey
	.EXTERN TORAM, intsr

; valore contatore T1 VIA 0 per IRQ con periodo di TJIFFY ms
VIA0T1CNT	.SET	((TJIFFY * 1000 * PHI2) - 2)

; valore contatore T1 VIA 1 per PBt -> 1KHZ
VIA1T1CNT	.SET	((500 * PHI2) - 2)

;VIA0INT		.EQU	($80.OR.CA2IFRB.OR.CB2IFRB.OR.T1IFRB)
VIA0INT		.EQU	($80.OR.CA2IFRB.OR.T1IFRB)

VIA1INT		.EQU	($80.OR.CA2IFRB.OR.CB2IFRB)

BITCR2		.EQU	$FC04
BITCR2ON	.EQU	$FC05

KBDTMO		.EQU	2000	; timeout tastiera in ms
	
F8TMO		.EQU	500	; timeout <F8> = 500ms

;--------------------------------------------------------------------
; SYSTEM BOOTSTRAP 
;--------------------------------------------------------------------
SysStart:
	; setup iniziale chips I/O
	CPU08
	;ldx	#RTCCTRLA	;RTC OFF -- reset RTC
	;stx	RTCALE
	;stz	RTCDATA

	nop
	nop
	nop
	
	; setup iniziale CTC
	lda	#00110000B		; CTC counter 0 in modo 0 - 2 bytes
	sta	CTC0+CTCCTRL
	lda	#01110000B		; CTC counter 1 in modo 0 - 2 bytes
	sta	CTC0+CTCCTRL
	lda	#10110000B		; CTC counter 2 in modo 0 - 2 bytes
	sta	CTC0+CTCCTRL
	
	; setup VIA 0 & 1
	ldx	#$7F
	stx	VIA0+VIAIER		; disabilita interrupt VIA 0
	stx	VIA0+VIAIFR		; ed azzera tutti i flag	
	stx	VIA1+VIAIER		; disabilita interrupt VIA 1
	stx	VIA1+VIAIFR		; ed azzera tutti i flag	
	lda	#$FE			; VIA 0 PA0 -> XM16 -> LOW
	sta	VIA0+VIAPRA
	lda	#$FF			; VIA 0 -> wait disabilitati
	sta	VIA0+VIAPRB
	sta	VIA1+VIAPRA		; VIA 1 PORT A uscite alte
	sta	VIA1+VIAPRB		; VIA 1 PORT B uscite alte
	sta	VIA0+VIADDRA		; VIA 0 PORT A in output
	sta	VIA1+VIADDRA		; VIA 1 PORT A in output
	lda	#10111111B		; VIA 0 PB6 in input (1KHZ)
	sta	VIA0+VIADDRB
	lda	#10101111B		; VIA 0 PB6, PB4 in input
	sta	VIA1+VIADDRB
	; S.R. disabilitato, latch disabilitato, T1 free-run
	; T2 one shot - PB7 disabilitato - T1 & T2 count PHI2
	lda	#$40				
	sta	VIA0+VIAACR	
	; S.R. disabilitato, latch disabilitato, T1 free-run
	; T2 one shot - PB7 abilitato - T1 count PHI2
	; T2 count PB6 (1KHz) - counter risoluzione  1 ms
	lda	#$E0				
	sta	VIA1+VIAACR	
	; CA2, CA1, CB2 fronte negativo, CB1 fronte positivo
	lda	#00110010B
	sta	VIA0+VIAPCR
	; CA2, CB2 fronte negativo, CA1 e CB1 fronte positivo
	lda	#00110011B
	sta	VIA1+VIAPCR
	lda	#.LOW.VIA1T1CNT		; imposta VIA 1 T1
	sta	VIA1+VIAT1CL		; PB7 -> 1KHz
	lda	#.HIGH.VIA1T1CNT
	sta	VIA1+VIAT1CH
	lda	#$FF			; VIA 1 T2 init a $FFFF
	sta	VIA1+VIAT2CL		; per conteggio iniziale in ms
	sta	VIA1+VIAT2CH

.IF	PHI2 = 4
	lda	#$04			; abilita WAIT ACIA se PHI2 = 4MHz
	trb	VIA0+VIAPRB
.ENDIF

	; inizializzazione registri MOS8563 - VDC
	;lda	#$08
	;trb	VIA1+VIAPRB		; /VDCS0 - write VDC con PHI0
	;tsb	VIA1+VIAPRB		; /VDCS0 - write VDC con PHI0
	lda	#$08			; VSYNC negativi su porta VGA
	trb	VIA1+VIAPRA
	;lda	#$20			; abilita WAIT VDC
	;trb	VIA0+VIAPRB
	;tsb	VIA0+VIAPRB
	
	;lda	#$83			; wait DMA+FDC+CTC
	;trb	VIA0+VIAPRB		; DMA+FDC FAIL WAIT

	lda	#$08			; wait ATA 0
	tsb	VIA0+VIAPRB		; OK
	;lda	#$10			; wait ATA 1
	;tsb	VIA0+VIAPRB		; OK
	;lda	#$80			; wait CTC
	;tsb	VIA0+VIAPRB		; OK
	;lda	#$01			; wait DMA
	;tsb	VIA0+VIAPRB		; OK
	;lda	#$02			; wait FDC
	;tsb	VIA0+VIAPRB		; OK
	
	lda	#$02			; imposta dot clock
	trb	VIA1+VIAPRA		; DOTCLOCK 16MHZ - PAL RGB 
	ldx	#0			; indice per setup 16MHZ

?00a:	LDA	VDCREG16,X
	BMI	?00b
	tay
	INX
	LDA	VDCREG16,X
	INX
	STY	VDCAddr
	STA	VDCData
	BPL	?00a
?00b:

	; setup PIA 0
	stz	PIA0+PIACRA		; IRQ disabilitati
	stz	PIA0+PIACRB		; accesso DDRA,DDRB
	lda	#$FF			; porta A output
	sta	PIA0+PIADDRA
	lda	#00001111B
	sta	PIA0+PIADDRB		; porta B<7:4> input
	lda	#00111100B		; accesso a PRA e PRB
	sta	PIA0+PIACRA		; CA2/CB2 in modo output H
	sta	PIA0+PIACRB
	stz	PIA0+PIAPRA
	stz	PIA0+PIAPRB

	; clear cmos user ram banco 0
	ldx	#RTCCTRLA		; accesso CMOS RAM banco 0
	stx	RTCALE
	lda	#00010000B
	trb	RTCDATA			; banco 0
	ldx	#RTCURAM0		; accesso  user ram banco 0
	ldy	#(RTCURAM0LAST - RTCURAM0)
?01:	stx	RTCALE			; azzera cmos user ram 0
	stz	RTCDATA
	inx
	dey
	bpl	?01
	ldx	#RTCURAM0
	stx	RTCALE			; $40

	; setup PIA 1 - LCD
	stz	PIA1+PIACRA		; IRQ disabilitati
	stz	PIA1+PIACRB		; accesso DDRA,DDRB
	ldy	#$FF			; porta A output
	sty	PIA1+PIADDRA
	stz	PIA1+PIADDRB		; porta B input
	lda	#0000100B		; accesso a PRA
	sta	PIA1+PIACRA
	ldy	#0000010B		; linea RW high - E, RS low
	sty	PIA1+PIAPRA
	ldy	#0
?02:	sty	PIA1+PIADDRB		; test PIA LCD presente
	cpy	PIA1+PIADDRB
	bne	?03
	iny
	bne	?02
?03:	stz	PIA1+PIADDRB		; porta B input
	sta	PIA1+PIACRB		; accesso a PRB
	bne	?04			; LCD non presente
	lda	#$80			; flag LCD presente -> $40
	sta	RTCDATA
?04:	inx				; $41
	stx	RTCALE

	; test & setup ACIA
	lda	#$7F			; cancella IER1/IER2
	sta	ACIA+ACIAIER1
	sta	ACIA+ACIAIER2	
	lda	ACIA+ACIAISR1		; legge registri di stato
	lda	ACIA+ACIAISR2		; per cancellare flag
	lda	ACIA+ACIACSR1		; legge registri control status
	lda	ACIA+ACIACSR2 
	lda	ACIA+ACIARDR1		; legge registri RX data
	lda	ACIA+ACIARDR2		; per cancellare flag
	lda	#01001110B		; 38400 - 1 stop bit - no echo - ACR	
	sta	ACIA+ACIACR1		; imposta reg. controllo CR
	sta	ACIA+ACIACR2
	lda	#11100111B		; odd parity - 8 bit - RTS/DTR -> H
	sta	ACIA+ACIAFR1		; imposta registro di formato FR
	sta	ACIA+ACIAFR2
	stz	ACIA+ACIAACR1		; parity in status - normal TX
	stz	ACIA+ACIAACR2		; imposta registri aux. controllo
	ldy	#$80			; flag ACIA canale 1
	lda	ACIA+ACIACSR1
	and	#00100000B		; maschera bit CTS1 LVL
	sta	RTCDATA			; salva
	lda	#00100000B		; inverte CTS1
	trb	VIA1+VIAPRA
	lda	ACIA+ACIACSR1		; legge livello CTS1
	and	#00100000B		; maschera bit CTS1 LVL
	eor	RTCDATA			; confronta con lettura precedente
	bne	?06			; OK - CTS1 invertito
	ldy	#0			; ACIA canale 1 BAD
?06:	sty	RTCDATA
	inx				; $42
	stx	RTCALE
	ldy	#$40			; flag ACIA canale 2
	lda	ACIA+ACIACSR2
	and	#00100000B		; maschera bit CTS2 LVL
	sta	RTCDATA			; salva
	lda	#01000000B		; inverte CTS2
	trb	VIA1+VIAPRA
	lda	ACIA+ACIACSR2		; legge livello CTS2
	and	#00100000B		; maschera bit CTS2 LVL
	eor	RTCDATA			; confronta con lettura precedente
	bne	?08			; OK - CTS2 invertito
	ldy	#0			; ACIA canale 2 BAD
?08:	stz	RTCDATA
	dex				; $41
	stx	RTCALE
	tya
	tsb	RTCDATA			; set flag ACIA canale 2
	inx				; $42
	stx	RTCALE
	lda	ACIA+ACIAISR1		; legge registri di stato
	lda	ACIA+ACIAISR2		; per cancellare flag
	lda	ACIA+ACIACSR1		; legge registri control status
	lda	ACIA+ACIACSR2 
	lda	ACIA+ACIARDR1		; legge registri RX data
	lda	ACIA+ACIARDR2		; per cancellare flag
	
	; test & setup DMA - non necessario il wait a 4MHz
	ldy	#0			; flag DMA
	sta	DMAWMCLR		; master clear
	nop
	sta	DMAWCLRFF		; clear FF
	nop
	lda	#00000001B		; M-to-M chan.0&1 - contr. enabled
	sta	DMAWCMD			; registro di comando
	nop
	lda	#$FF			; maschera tutti i bit
	sta	DMAMASK
	nop
	lda	#10001000B		; modo read mem chan 0
	sta	DMAMODE			; block mode
	nop
	lda	#10000101B		; modo write mem chan 1
	sta	DMAMODE			; block mode
	nop
	lda	#01001010B		; modo read mem chan 2
	sta	DMAMODE			; single transf.
	nop
	lda	#01001011B		; modo read mem chan 3
	sta	DMAMODE			; single transf.
	nop
	lda	DMASR			; clr status reg.
	nop
	lda	DMARCNT			; clear mode counter
	nop
	nop
	lda	DMAMODE			; verifica MODE REG.CH0
	cmp	#10001011B
	bne	?10			; errore
	lda	DMAMODE			; verifica MODE REG.CH1
	cmp	#10000111B
	bne	?10			; errore
	lda	DMAMODE			; verifica MODE REG.CH2
	cmp	#01001011B
	bne	?10			; errore
	lda	DMAMODE			; verifica MODE REG.CH3
	cmp	#01001011B
	bne	?10			; errore
	lda	DMARCMD			; verifica registro di comando
	cmp	#00000001B
	bne	?10
	lda	DMASR			; clr status reg.
	nop
?09:	lda	#$FF			; !!!! FAIL SOME TIMES
	sta	DMAMASK
	nop
	lda	DMAMASK			; verifica maschera
	cmp	#$FF
	;bne	?09
	bne	?10
	ldy	#$04			; flag DMA OK
?10:	sty	RTCDATA			; $42 -> flag DMA

	ldy	#$4E
	sty	RTCALE			; $4E

	; check video board
	lda	#00111100B		; CA2,CB2 HIGH, PRA, PRB
	sta	!PIAVBB+PIACRA
	sta	!PIAVBB+PIACRB
	ldx	#$FF
	stx	PIAVBB+PIAPRA		; porta A tutte high
	stx	PIAVBB+PIAPRB		; porta B tutte high
	lda	#00111000B		; CA2,CB2 HIGH, DDRA, DDRB
	sta	!PIAVBB+PIACRA
	sta	!PIAVBB+PIACRB
	stx	PIAVBB+PIADDRA		; pota A tutte out
	stx	PIAVBB+PIADDRB		; pota B tutte out
	lda	#00111110B		; CA2 HIGH (FH -), PRA, CA1 fronte +
	sta	!PIAVBB+PIACRA		; no IRQ
	lda	#00111000B		; CB2 LOW (FV +), PRA, CA1 non usato
	sta	!PIAVBB+PIACRB		; no IRQ
	ldx	#$80			; PB7 HIGH -> display off
?12:	stx	PIAVBB+PIAPRB		; test porta B
	cpx	PIAVBB+PIAPRB
	beq	?12a
	jmp	?20a			; video board non presente
?12a:	inx
	bne	?12
	lda	#$80			; flag video board
	sta	!RTCDATA		; -> $4E
	
	; HD6445: registri R12 e R13 sono read/write
	lda	#$0D
	sta	!CRTAddr
	ldx	#0
?13:	stx	CRTData
	cpx	CRTData
	bne	?13a			; R6545
	inx
	bne	?13
	lda	#$C0			; flag video board + HD6445
	sta	!RTCDATA		; -> $4E
	
	; inizializza registri R6545/HD6445 (CRTC)
?13a:	ldx	#0
?13b:	LDA	>CRTCREG,X
	BMI	?13c
	tay
	INX
	LDA	>CRTCREG,X
	INX
	STY	CRTAddr
	STA	!CRTData
	BPL	?13b
	
?13c:	lda	#$C0			; palette address = 0, SLW = 1, VGA
	sta	!PIAVBB+PIAPRA
	
	; test VIDEO RAM
	ldx	#0
	txy
	sta	!CREMEON		; abilita memoria video
	INDEX16
?14:	lda	#$55
	sta	>VBBCHARRAM,x
	cmp	>VBBCHARRAM,x
	bne	?16			; Y =  -> fail char. ram
	lda	#$AA
	sta	>VBBCHARRAM,x
	cmp	>VBBCHARRAM,x
	bne	?16			; Y = 0 -> fail char. ram
	lda	#$20
	sta	>VBBCHARRAM,x	
	inx
	cpx	#$0800
	bne	?14
	tyx
?14a:	lda	#$55
	sta	>VBBATTRRAM,x
	cmp	>VBBATTRRAM,x
	bne	?14b
	lda	#$AA
	sta	>VBBATTRRAM,x
	cmp	>VBBATTRRAM,x
	bne	?14b
	lda	#$00
	sta	>VBBATTRRAM,x
	inx
	cpx	#$0800
	bne	?14a
	tyx
	beq	?14c
?14b:	iny				; Y = 1 -> fail attr. ram
	bne	?16
?14c:	lda	#$55
	sta	>VBBPALRAM,x
	cmp	>VBBPALRAM,x
	bne	?15
	lda	#$AA
	sta	>VBBPALRAM,x
	cmp	>VBBPALRAM,x
	bne	?15
	lda	#$F0
	sta	>VBBPALRAM,x
	inx
	cpx	#$0400
	bne	?14c
	clc				; RAM ok
	beq	?16a
?15:	iny				; Y = 2 -> fail palette ram
?16:	sec				; CF = 1 -> ram fail	
?16a:	txa				; C -> fail address
	INDEX08
	bcc	?16d
	ldx	#$50
	stx	RTCALE
	sta	RTCDATA			; $50-$51-$52 -> fail address
	xba
	inx
	stx	RTCALE
	cpy	#0
	beq	?16c
	clc
	dey
	bne	?16b
	adc	#$08
	bra	?16c
?16b:	adc	#$10		
?16c:	sta	RTCDATA
	inx
	stx	RTCALE
	lda	#$01
	sta	RTCDATA
	bra	?20b
?16d:	ldx	#$4F
	stx	RTCALE
	lda	#$80			; $4F -> flag video ram OK
	sta	!RTCDATA
	lda	#$80
	trb	!PIAVBB+PIAPRB
	
	lda	#$08
	sta	>$010000
	sta	>$01004f
	sta	>$010780
	sta	>$0107CF
	lda	#$0F
	sta	!URLVBB
	lda	#$20
	sta	>$010F81
	;lda	#$04
	;trb	!PIAVBB+PIAPRB
	
?20b:	sta	!CREMEOFF		; abilita memoria normale

?20a:	ldx	#$43			; X -> $43
	stx	RTCALE

	; full test ram banco 0
	sta	CRHIMON			; abilita ram in $FE00 - $FFFF
	INDEX16
	ldy	#0			; start banco 0
?20:	lda	!$0000,y
	xba				; salva MEM in B
	lda	#$55			; pattern test
	sta	!$0000,y
	cmp	!$0000,y
	bne	?28			; bad ram
	lda	#$AA
	sta	!$0000,y
	cmp	!$0000,y
	bne	?28			; bad ram
	xba				; ripristina mem
	sta	!$0000,y
	iny
	cpy	#RAM0TOP
	bcc	?20			; loop
	ldy	#RAM0SYS		; seconda parte
?24:	lda	!$0000,y
	xba				; salva MEM in B
	lda	#$55			; pattern test
	sta	!$0000,y
	cmp	!$0000,y
	bne	?28			; bad ram
	lda	#$AA
	sta	!$0000,y
	cmp	!$0000,y
	bne	?28			; bad ram
	xba				; ripristina mem
	sta	!$0000,y
	iny
	bne	?24			; loop fino a fine banco
	ACC16
	dey
	tya				; last addr -> A/B
	ldy	#$80
	bne	?30			; OK
?28:	ACC16
	tya				; bad addr -> A/B
	ldy	#$00
?30:	CPU08	
	sty	RTCDATA			; $43 -> flag bad ram
	inx
	stx	RTCALE
	sta	RTCDATA			; $44 -> bad addr L
	inx
	stx	RTCALE
	xba
	sta	RTCDATA			; $45 -> bad addr H
	inx				; X -> $46
	txy				; salva X in Y
	
	; test cold/warm reset
	ldx	#$6F
?31:	lda	!intsr,x
	cmp	>intsr,x
	bne	?31a
	dex
	bpl	?31
	ldx	#$43
	stx	RTCALE
	lda	#$40
	tsb	RTCDATA
?31a:	
	; azzeramento ram banco 0 - solo per COLD RESET
	INDEX16
	lda	PIA0+PIAPRB		; test bit /FSR (PB4)
	bit	#00010000B
	bne	?40			; /FSR = 1 -> WARM RESET
	ldx	#0
?32:	stz	!0000,x
	inx
	cpx	#RAM0TOP
	bcc	?32			; loop
	ldx	#RAM0SYS		; seconda parte
?34:	stz	!0000,x
	inx
	bne	?34
	
	; copia segmento di sistema da flash a RAM	
?40:	;ldx	#$0BFF
?42:	;lda	>TORAM,x
	;sta	!TORAM,x
	;dex
	;bpl	?42
	;ldx	#$01FF			; copia da F8FE00 a FE00 - FFFF
?44:	;lda	>IntSr,x
	;sta	!IntSr,x
	;dex
	;bpl	?44

	; copia con mvn
	CPU16
	phy
	lda	#$0BFF
	ldx	#!TORAM
	txy
	mvn	#^TORAM, #0
	lda	#$01FF
	ldx	#!intsr
	txy
	mvn	#^intsr, #0
	ply
	
	; setup RTC DS1687
	CPU08
	ldx	#RTCCTRLA	; test primo setup RTC
	stx	RTCALE
	lda	RTCDATA
	bit	#00100000B	; test DV1
	beq	?45		; DV1 = 0 -> oscillatore RTC off
	jmp	?46
?45:	ldx	#RTCCTRLB	; primo setup RTC
	stx	RTCALE
	lda	#00001110B	; SET = 0, no IRQ, SQW OUT, binary, formato 24H
	sta	RTCDATA
	dex			; CTRL REG. A
	stx	RTCALE
	lda	#00110101B	; oscillatore on, banco 1, sqw = 2048HZ
	sta	RTCDATA
	ldx	#RTCEXTCTRLB
	stx	RTCALE
	lda	#10000000B	; abilita VBAUX
	sta	RTCDATA
	dex			; EXT. CTRL. REG. 4A
	stx	RTCALE
	stz	RTCDATA		; abilita /PWR - azzera flag
	ldx	#RTCCTRLB	; stop update
	stx	RTCALE
	lda	#$80
	tsb	RTCDATA
	stz	RTCALE		; registro secondi
	stz	RTCDATA		; SECS = 0
	ldx	#RTCMIN
	stx	RTCALE
	stz	RTCDATA		; MIN = 0
	ldx	#RTCHOURS
	stx	RTCALE
	stz	RTCDATA		; HOURS = 0
	ldx	#RTCDAY
	stx	RTCALE
	lda	#1		; DOMENICA
	sta	RTCDATA		; DAY = domenica
	inx			; registro data
	stx	RTCALE
	sta	RTCDATA		; DATA = 1
	inx			; registro mese
	stx	RTCALE
	sta	RTCDATA		; mese = 1
	inx			; registro anno
	stx	RTCALE
	lda	#12		; anno = 2012
	sta	RTCDATA
	ldx	#RTCCENTURY
	stx	RTCALE
	lda	#20		; anno 2012
	sta	RTCDATA		; setup -> ore 00.00.00 del 01/01/2012 - domenica
	ldx	#RTCALMSECS
	stx	RTCALE
	lda	#$C0
	sta	RTCDATA
	ldx	#RTCALMMIN
	stx	RTCALE
	sta	RTCDATA
	ldx	#RTCALMHOURS
	stx	RTCALE
	sta	RTCDATA
	ldx	#RTCALMDATE
	stx	RTCALE
	sta	RTCDATA
	ldx	#RTCCTRLB
	stx	RTCALE
	lda	#$80		; start RTC
	trb	RTCDATA
	ldx	#RTCRAM0E
	stx	RTCALE
	lda	#$FF
	sta	RTCDATA		; flag time non valido
?46:	ldx	#RTCALMSECS
	stx	RTCALE		; set alarm at 02:00:00
	stz	RTCDATA
	ldx	#RTCALMMIN
	stx	RTCALE
	stz	RTCDATA
	ldx	#RTCALMHOURS
	stx	RTCALE
	lda	#2
	sta	RTCDATA
	ldx	#RTCCTRLB	; set RTC alarm for DST
	stx	RTCALE
	lda	#$20
	tsb	RTCDATA
	ldx	#RTCCTRLA
	stx	RTCALE
	lda	#00010000B
	tsb	RTCDATA		; banco 1
	ldx	#RTCRAM0E	; test time valido
	stx	RTCALE
	lda	RTCDATA		; bit 7 = 1 -> time valido
	and	#$80
	eor	#$80
	ldx	#RTCSTATUS2	; test batteria
	stx	RTCALE
	bit	RTCDATA
	bpl	?48		; batteria scarica
	ora	#RTC_VBAT	; batteria OK
?48:	ldx	#RTCEXTCTRLA	; test VBAUX
	stx	RTCALE
	bit	RTCDATA
	bpl	?49		; batteria scarica
	ora	#RTC_VBAUX	; VBAUX OK
?49:	xba
	ldx	#RTCEXTCTRLB
	stx	RTCALE
	lda	#$40		; E32K va azzerato dopo power-up		
	trb	RTCDATA

	lda	#$01		; abilita KSE		
	tsb	RTCDATA
	ldx	#RTCEXTCTRLB
	stx	RTCALE
	lda	#$08		; PAB = 0		
	trb	RTCDATA
	
	ldx	#RTCCTRLA
	stx	RTCALE
	lda	#00010000B
	trb	RTCDATA		; banco 0
	sty	RTCALE		; $46
	xba
	sta	RTCDATA
	tyx			; $46
	dey
	dey
	dey			; $43 -> flag RAM
	sty	RTCALE

	; errore fatale se ram fail in banco 0
	lda	RTCDATA			; flag ram
	bne	?55			; OK
	lda	#10110000B		; CTC counter 2 in modo 0 - 2 bytes
	sta	CTC0+CTCCTRL
	lda	#01110110B		; CTC counter 1 in modo 3 - 2 bytes
	sta	CTC0+CTCCTRL
	lda	#<400			; beep 200ms - pausa 200ms
	sta	CTC0+CTCCNT1
	lda	#>400
	sta	CTC0+CTCCNT1
	lda	#<1600			; 4 beep
	sta	CTC0+CTCCNT2
	lda	#>1600
	sta	CTC0+CTCCNT2
	lda	#$08			; beep ... beep...
	tsb	PIA0+PIACRB
	trb	PIA0+PIACRA
	ldx	#$3D
	stx	RTCALE
	stz	RTCDATA			; $3D -> flag ram x log
	iny
	sty	RTCALE			; $3E-$3F -> bad address
	lda	RTCDATA
	inx
	stx	RTCALE
	sta	RTCDATA
	iny
	sty	RTCALE			; $3E-$3F -> bad address
	lda	RTCDATA
	inx
	stx	RTCALE	
	sta	RTCDATA		
?52:	nop				; loop infinito
	nop				; ERRORE FATALE - BAD RAM BANCO 0
	jmp	?52			; 4 beep da 200ms/200ms

	; copia flag da ram cmos a ram banco 0
?55:	ldx	#RTCURAM0
	stx	RTCALE			; $40
	lda	RTCDATA			; flag LCD
	jsr	LCDSetup		; setup LCD
	ldx	#RTCURAM0+1
	stx	RTCALE			; $41
	lda	RTCDATA
	sta	sppost
	inx				; $42
	stx	RTCALE
	lda	RTCDATA
	sta	fdcctl
	inx
	stx	RTCALE			; $43
	lda	RTCDATA
	sta	Bnk0Flag
	inx
	inx
	inx
	stx	RTCALE			; $46
	lda	RTCDATA
	sta	RTCFlag
	ldx	#$4E			; $4E -> flag video board
	stx	RTCALE
	lda	!RTCDATA
	sta	!DP01ADDR+VBBFlag
	inx
	stx	RTCALE			; $4F -> flag video RAM
	lda	!RTCDATA
	sta	!DP01ADDR+VBBRam

	;stz	!DP01ADDR+VBBFlag
	;stz	!DP01ADDR+VBBRam
	lda	#$04
	trb	!PIAVBB+PIAPRB
	
	; seguito startup
	jsr	VDCSetup		; inizializza charset VDC
	lda	#TXTD_SCN
	sta	DflTxtOut
	stz	DflTxtIn
	jsr	_ScnInit		; cancella schermo	
	jsr	EnableInt		; abilita IRQ e NMI
	lda	#$01			; video VDC ON
	trb	VIA1+VIAPRANH
	jsr	BootBeep
	jsr	BootMsg
	jsr	CheckKbd		; test keyboard
	lda	RTCFlag
	bmi	?60
	SCNPRINT
	.DB	'ERROR: invalid CMOS time & date'
	.DB	$0D, $00
?60:	bit	#$60			; test batteria
	bne	?62
	SCNPRINT
	.DB	'ERROR: invalid CMOS data - replace battery'
	.DB	$0D, $00
?62:	lda	#$04	
	bit	fdcctl
	bne	?64
	SCNPRINT
	.DB	'ERROR: DMA not found or fail'
	.DB	$0D, $00
?64:	lda	sppost
	and	#$C0
	cmp	#$C0
	beq	?66
	SCNPRINT
	.DB	'ERROR: Serial controller 65C52 not found or fail'
	.DB	$0D, $00

?66:	;bit	_LCDFlag
	;bmi	?68
	;SCNPRINT
	;.DB	'ERROR: LCD controller not found'
	;.DB	$0D, $00

?68:	
	lda	#01001110B		; 38400 - 1 stop bit - no echo - ACR	
	sta	ACIA+ACIACR1		; imposta reg. controllo CR
	sta	ACIA+ACIACR2
	lda	#11100100B		; odd parity - 8 bit - RTS/DTR -> L
	sta	ACIA+ACIAFR1		; imposta registro di formato FR
	sta	ACIA+ACIAFR2
	sta	<ACIAfr_1
	sta	<ACIAfr_2
	lda	#$C0
	sta	<ACIAhsk_1
	sta	<ACIAhsk_2
	lda	#$F9
	sta	ACIA+ACIAIER1
	cli			; abilita INT
	lda	#$40
	tsb	BiosEnt		; abilita <F8> al boot
	jsr	QuickMT		; test veloce memoria
	lda	#$04
	bit	fdcctl
	beq	?80		; salta test FDC
?70:	jsr	fdinit
?80:	jsr	vdinit		; init ram disk	
	jsr	initata		; scanning bus ATA
	;jsr	CheckVol
?80a:	lda	#$40		; disabilita <F8>
	trb	BiosEnt
	SCNGETPOS
	phx			; salva posizione corrente cursore
	phy
	ldx	!(DP01ADDR + SMAddrL)	; set posizione <F8>
	ldy	!(DP01ADDR + SMAddrL +1)
	SCNSETPOS
	SCNPRINT	; cancella linea <F8>
	.DB	KB_ESC, 'q', $00
	ply			; restore posizione cursore
	plx
	SCNSETPOS
	
	jsl	OSINIT

	;;; FOR NOW: simply launch system monitor after boot & test
	.EXTERN dummydir
	jsl	dummydir
	jsr	BootBeep
	jml	SYSMON
	
BootBeep:
	lda	#10110000B	; CTC 2 in modo 0 - 2 bytes
	sta	CTC0+CTCCTRL
	lda	#<300
	sta	CTC0+CTCCNT2
	lda	#>300
	sta	CTC0+CTCCNT2
	lda	#$08
	trb	PIA0+PIACRB
	trb	PIA0+PIACRA
	rts
	
; abilita IRQ e NMI
EnableInt:
	.LONGA	off
	.LONGI	off

	lda	#VIA1INT		; abilita NMI CA2, CB2
	sta	VIA1+VIAIER
	lda	#VIA0INT		; abilita INT 2 CA2, CA1
	sta	VIA0+VIAIER
	lda	#.LOW.VIA0T1CNT		; imposta VIA 0 T1
	sta	VIA0+VIAT1CL
	lda	#.HIGH.VIA0T1CNT	
	sta	VIA0+VIAT1CH
	rts

CheckKbd:	
	stz	_KbdCnt
	stz	_KbdToggle
	stz	_KbdSt
	stz	_PS2Ctl
	stz	_KbdITail
	stz	_KbdIHead
	stz	_KbdShift
	stz	_KbdFlag
	lda	#$20			; imposta T2 su PB6 - 1ms
	tsb	VIA0+VIAACR
	lda	#(.LOW.KBDTMO)		; imposta timeout T2
	ldx	#(.HIGH.KBDTMO)
	sta	VIA0+VIAT2CL
	stx	VIA0+VIAT2CH
?10:	bit	KBSTATUS		; test controller PS/2
	bvc	?12			; controller ready
	lda	#T2IFRB
 	bit	VIA0+VIAIFR		; test T2 flag
 	beq	?10			; attende timeout o controller ready
 	SCNPRINT
 	.DB	'ERROR: controller PS/2 fail', $0D, $00
 	rts
?12:	ldx	KBFR+3			; status dopo reset
	stx	_KbdSt
	bne	?14			; status kbd ok
	SCNPRINT
	.DB	'ERROR: keyboard not found or fail', $0D, $00
	rts
?14:	lda	#$E1			; comando set LOCK
	sta	KBFR
	lda	#NUMLOCKB		; imposta toggle NUM LOCK
	sta	KBFR+1
	sta	KBDRQ			; richiesta servizio al controller
?16:	bit	KBSTATUS		; test controller PS/2
	bmi	?16			; attende risposta
	lda	KBFR+3
	beq	?20			; errore
	lda	#NUMLOCKB		; imposta toggle NUM LOCK
	sta	!_KbdToggle
?20:	lda	#$C1			; comando start scanning
	sta	KBFR
	sta	KBDRQ			; richiesta servizio al controller
?22:	bit	KBSTATUS
	bmi	?22			; attende risposta
	rts

;----------------------------------------------------------
; funzioni test memoria utilizzate in fase di boot

; test RAM veloce (in fase di boot)
QuickMT:
	phd
	pea	#DP01ADDR
	pld
	lda	#$01		
	sta	SMTmpK		; banco start = $01
	lda	#$FF
	sta	!MemTop		; imposta MemTop = $FFFF
	sta	!MemTop+1
	stz	!MemTop+2	
	sta	CRXMEOFF	; disabilita X mem
	sta	CREMEOFF	; disabilita E mem
	sta	CRXFEOFF	; disabilita F mem
	bit	!BiosEnt	; test <F8> solo nel caso che non sia stato
	bmi	?01		; forzato accesso al bios setup
	SCNGETPOS
	stx	SMAddrL		; salva pos. corrente
	sty	SMAddrH
	SCNPRINT
	.DB	'Press <F8> for enter BIOS setup...', $0D, $00
	lda	#$20			; imposta T2 su PB6 - 1ms
	tsb	VIA0+VIAACR
	lda	#(.LOW.F8TMO)		; imposta timeout T2
	ldx	#(.HIGH.F8TMO)
	sta	VIA0+VIAT2CL
	stx	VIA0+VIAT2CH
	lda	#T2IFRB
?00:	bit	VIA0+VIAIFR		; test T2 flag
 	beq	?00			; attende timeout

?01:	SCN_CR
	stz	KbdCnt		; svuota buffer tastiera
	SCNPRINT
	.DB	'Quick memory test: $', $00
	SCNGETPOS
	stx	SMAuxL
	sty	SMAuxH
?02:	ldx	SMAuxL		; loop banco
	ldy	SMAuxH
	SCNSETPOS
	lda	SMTmpK		; print banco
	jsr	_ScnHex
	SCNGETPOS	; pos. address
	stx	SMXPos
	sty	SMYPos
	stz	SMTmpL		; azzera ptr
	stz	SMTmpH
?03:	jsr	F8Tst		; loop test
	jsr	MEMTst		; test mem
	bne	?10		; bad ram
	lda	#$80
	sta	SMTmpH
	jsr	F8Tst
	jsr	MEMTst
	bne	?10
	lda	#$40
	sta	SMTmpH
	jsr	F8Tst
	jsr	MEMTst
	lda	#$80
	sta	SMTmpH
	jsr	F8Tst
	jsr	MEMTst
	lda	#$C0
	sta	SMTmpH
	jsr	F8Tst
	jsr	MEMTst
	lda	#$FF
	sta	SMTmpL
	sta	SMTmpH
	sta	!MemTop		; imposta MemTop = $FFFF
	sta	!MemTop+1
	lda	SMTmpK
	sta	!MemTop+2
	jsr	F8Tst
	jsr	MEMTst
	bne	?10
	inc	SMTmpK
	lda	SMTmpK
	cmp	#$F8
	bcc	?02		; loop
?10:	SCN_CR
	pld
	rts
	
F8Tst:
	bit	!BiosEnt
	bmi	?01		; salta test <F8> se gia' premuto
	bvc	?01		; bit 6 - abilita test F8 solo al boot 
	lda	KbdCnt		; char disponibili nel buffer tastiera ?
	beq	?01		; no
	jsr	GetBufKey	; Y -> flag - A -> codice
	tax			; X = codice
	tya			; A = flag
	asl	a		; C = bit 7, N = bit 6
	bmi	?01		; ignora rilascio tasti
	bcc	?01		; ignora tasti ASCII
	cpx	#KB_F8		; test F8
	bne	?01		; scarta
	lda	#$80
	tsb	!BiosEnt	; flag ingresso al setup bios
	ldx	SMAddrL		; set posizione
	ldy	SMAddrH
	SCNSETPOS
	SCNPRINT
	.DB	'<F8> detected - entering BIOS setup after boot', $00
?01:	rts

; versione long
LF8Tst:
	pha
	phx
	phy
	php
	phd
	pea	#DP01ADDR
	pld
	CPU08
	SCNGETPOS
	phx
	phy
	jsr	F8Tst
	ply
	plx
	SCNSETPOS
	pld
	plp
	ply
	plx
	pla
	rts

MEMTst:
	lda	[SMTmpL]
	xba			; salva dato in B
	lda	#$55
	sta	[SMTmpL]
	cmp	[SMTmpL]
	bne	?02
	lda	#$AA
	sta	[SMTmpL]
	cmp	[SMTmpL]
?02:	php			; salva Z
	xba			; ripristina dato
	sta	[SMTmpL]
	plp
	bne	?04
	ldx	SMXPos
	ldy	SMYPos
	SCNSETPOS	; set pos address
	lda	SMTmpL
	ldx	SMTmpH
	jsr	_Scn2Hex
	lda	#$00		; Z = 1
	rts
?04:	ldx	SMAuxL		; set pos banco
	ldy	SMAuxH
	SCNSETPOS
	lda	!MemTop+2	; print banco
	jsr	_ScnHex
	lda	#$01		; Z = 0
	rts

; stampa a video word A(lo)-X(hi)
_Scn2Hex:
	pha
	txa
	jsr	_ScnHex
	pla

; _ScnHex - stampa a video byte HEX
; In	- A = byte
; Out	- nessuno
_ScnHex:
	phx			; salva x
	jsr	Byte2Hex	; X,A = HEX
	TXTCHAROUT	; stampa hi digit
	txa
	plx			; ripristina x
	TXTCHAROUT	; stampa low gigit		
	rts	

; Byte2Hex - converte byte in HEX
; In	- A = byte
; Out:	- X = low digit
;	  A = hi digit	
Byte2Hex:
	pha			; salva A
	jsr	?01		; converte parte bassa
	tax			; x = low digit
	pla
	lsr	a		; parte alta
	lsr	a
	lsr	a
	lsr	a
?01:	and	#$0F		; maschera nibble
	cmp	#10
	bcc	?02
	adc	#6
?02:	adc	#'0'
	rts

;----------------------------------------------------------

	
;----------------------------------------------------------

; init CRTC - DOT 25.175MHz, CCLK = 3.146875MHz, FH (-) = 31.469KHz
; FV (+) = 70Hz - 449 raster lines -- HD6445
CRTCREG:
	.DB	$00, $63, $01, $50, $02, $5A, $03, $D4
	.DB	$04, $1B, $05, $01, $06, $19, $07, $1B
	.DB	$08, $00, $09, $0F, $0A, $20, $0B, $0F
	.DB	$0C, $00, $0D, $00, $0E, $00, $0F, $00
	.DB	$FF
	.DB	$1E, $00, $1F, $00, $20, $00, $FF
	
BootMsg:
	SCNPRINT
	.DB	'Machine 65C816 (native mode) model B16/01 - '
	.DB	'(c) 2012, Dream SpA.', $0D, $00
	SCNPRINT
	.DB	'BIOS bootstrap B16 rev. 1.0 (2013/06/05) - VIDEO RGB ', $00
	bit	!DP01ADDR+VBBRam
	bpl	?10
	SCNPRINT
	.DB	'VGA compatible ', $00
	bit	!DP01ADDR+VBBFlag
	bvs	?05
	SCNPRINT
	.DB	'R6545EAP', $00
	bra	?20
?05:	SCNPRINT
	.DB	'HD6445', $00
	bra	?20
?10:	SCNPRINT
	.DB	'PAL MOS8563', $00
?20:	SCNPRINT
	.DB	$0D, $0D, $00
	rts
	
