;----------------------------------------------------------
; VDC.ASM
; PROGETTO: B1601
;
; Gestione video RGB - MOS8563 / R6545EAP / HD6445
;----------------------------------------------------------

_VBB_INC_	.SET	1
_KBD_INC_	.SET	1
_SCN_INC_	.SET	1

	.INCLUDE inc\global.inc
	.INCLUDE inc\dirp00.inc
	.INCLUDE inc\dirp01.inc

CHARWIDTH	.EQU	$10	; ampiezza max. carattere
CGAWIDTH	.EQU	$08
EGAWIDTH	.EQU	$0E
VGAWIDTH	.EQU	$10

CURSLINE	.EQU	$07
DEFCURS		.EQU	$60
DEFATTR		.EQU	$07
DEFCURS2	.EQU	$00	; cursore fisso HD6445
DEFATTR2	.EQU	$00	; palette di default
	

	.CODEF8
	
	.GLOBAL VDCSetup, VDCREG16, cinit
	.GLOBAL _ScnCharOut, _ScnCharIn, _ScnInit, GetSetPos, GetBufKey
	
	.EXTERN VGA8x8L, VGA8x8H
	
	.LONGA	off
	.LONGI	off
	
;--------------------------------------------------------------------

; Setup VDC
; USA A,B,X,Y
VDCSetup:
	php			; salva status
	phd			; salva DP
	phb			; salva registro DBR
	CPU08			; imposta registri a 8 bit
	lda	#>DP01ADDR	; imposta nuova DP
	xba			; DP Hi
	lda	#0
	tcd
	pha			; imposta DBR = 0
	plb
	jsr	SetVDCFont	
	plb			; ripristina DBR
	pld			; ripristina DP
	plp			; ripristina status
	rts


GetBufKey:
	php
	phd
	pea	#DP01ADDR
	pld
	CPU08
	jsr	_GetBufKey
	pld
	plp
	rts

COP_KeybGet:
	.GLOBAL COP_KeybGet

	phd
	pea	#DP01ADDR
	pld
	sec			; no char
	lda	KbdCnt		; char disponibili nel buffer tastiera ?
	beq	?10		; no
	jsr	_GetBufKey	; preserve CF
	tax			; code
	tya			; flag
	bit	#$40		; test bit <6>
	bne	?10		; rilascio - ignora
	clc			; OK -- tasto disponibile
?10:	pld			; restore DP
	bcc	?12
	ldx	#$00
?12:	sta	STKCR+1,s	; flag control key
	txa
	sta	STKCR,s		; key code
	clc
	rtl

COP_ScnCtl:
	.GLOBAL COP_ScnCtl

	ACC16			; retrieve function number
	lda	STKPCL,s	; pointer to byte after signature
	sta	COPPtr
	inc	a		; update return address
	sta	STKPCL,s
	ACC08			; A,M -> 8 bit
	lda	STKPBR,s	; bank where was executed cop instruction
	sta	COPPtr+2	
	lda	[COPPtr]	; byte after signature
	pea	#DP01ADDR
	pld
	tax
	beq	?38		; X = 0 -> init screen
	dex
	beq	?36		; X = 1 -> clear screen
	dex
	beq	?42		; X = 2 -> get cursor position
	dex
	beq	?44		; X = 3 -> set cursor position
	dex
	beq	?46		; X = 4 -> get screen org
	dex
	beq	?48		; X = 5 -> get keyboard flag
	dex
	beq	?50		; X = 6 -> clear keyboard buffer & ctrl break
	dex
	beq	?52		; X = 7 -> get ctrl break flag
	dex
	beq	?60		; X = 8 -> fill keyboard buffer	
	clc
	rtl
?36:	jsr	WndClr
	bra	?40
?38:	jsr	cinit	
?40:	clc
	rtl
?42:	sec			; get pos
	jsr	GetSetPos
	lda	#0
?43:	sta	STKXR+1,s
	sta	STKYR+1,s	
	txa
	sta	STKXR,s
	tya
	sta	STKYR,s
	clc
	rtl
?44:	lda	STKXR,s
	tax
	lda	STKYR,s
	tay
	clc			; set pos
	jsr	GetSetPos
	clc
	rtl
?46:	jsr	GetWndOrg
	sta	STKCR,s
?47:	lda	#0
	sta	STKCR+1,s
	bra	?43
?48:	sei	
	lda	KbdFlag
	ldx	KbdToggle
	ldy	KbdShift
	cli
	bra	?47
?50:	sei
	stz	KbdCnt		; clear keyboard buffer
	stz	KbdITail
	stz	KbdIHead
	stz	!CtrlBrk	; clear ctrl break/alt sysreq flags
	cli
	clc
	rtl
?52:	lda	!CtrlBrk
	and	#$80		; check bit 7
	beq	?54
	trb	!CtrlBrk	; clear flag
	sei
	stz	KbdCnt		; clear keyboard buffer
	stz	KbdITail
	stz	KbdIHead
	cli
?54:	sta	STKCR,s		; A = $80 or $00
	lda	#0
	sta	STKCR+1,s
	clc
	rtl
?60:	lda	STKCR,s		; CX -> pointer
	sta	ScnPrm
	lda	STKCR+1,s
	sta	ScnPrm+1
	lda	STKXR,s
	sta	ScnPrm+2
	ldy	#0
	txy
	sei	
?62:	lda	[ScnPrm],y
	beq	?64
	sta	<KbdBuf+1,x	; key code
	stz	<KbdBuf,x	; key pressed
	inx
	inx
	iny
	bne	?62
?64:	stx	<KbdCnt
	stx	<KbdITail
	stz	<KbdIHead
	lda	#$80		; disable auto insert when fill buffer 
	trb	ScnAutoIns
	clc
	rtl
	
;--------------------------------------------------------------------

; inizializza screen editor
cinit:
	ldx	#SCNCLRLEN		; warm reset: azzera variabili
?01:	stz	ScnLinTmp,x
	dex
	bpl	?01
?02:	lda	#$18
	sta	ScnMaxRow
	lda	#$4F
	sta	ScnMaxCols
	lda	#DEFATTR
	bit	VBBRam
	bpl	?02a
	lda	#DEFATTR2
?02a:	sta	ScnAttr
	sta	ScnAttr2
	lda	#$40
	ldx	#$48
	bit	VBBRam
	bpl	?02b
	lda	#$00
	ldx	#$08
?02b:	sta	ScnChBase
	stx	ScnAttBase
	lda	#DEFCURS
	bit	VBBRam
	bpl	?02c
	lda	#DEFCURS2	
?02c:	sta	ScnCursMode
	lda	#$40
	sta	ScnScroll
	lda	#$80
	sta	ScnAutoIns
	lda	#$01		; long puntatore video RAM VB
	sta	ScnPtr+2
	sta	ScnAtPtr+2
	sta	ScnPtr1+2
	sta	ScnPtr2+2	
	;lda	#TXTD_SCN
	;sta	!DflTxtOut
	;stz	!DflTxtIn
	;lda	#HISTSTART
	;sta	HistEnd+1
	;sta	HistCur+1
	;stz	HistEnd
	;stz	HistCur
	;jsr	_Test
	jsr	SetDefTabs
	jsr	SetMaxWnd

; Cancella finestra corrente
WndClr:
	jsr	WndHome
?01:	jsr	WndGetAddrX
	jsr	ClrRow
	cpx	ScnBottom
	inx
	bcc	?01
	
; Posizione puntatore al margine sinistro superiore
WndHome:
	ldx	ScnTop
	stx	ScnRow
	stx	ScnRowStart
	
; Posiziona puntatore al margine sinistro
WndLeft:
	ldy	ScnLeft
	sty	ScnCol
	sty	ScnColStart
	
; Ricava indirizzo fisico riga corrente
WndGetAddr:
	ldx	ScnRow
	
; Ricava indirizzo fisico riga X
WndGetAddrX:
	lda	>SCRNADDRL,x		; forza ABS LONG
	sta	ScnPtr
	lda	>SCRNADDRH,x
	ora	ScnChBase
	sta	ScnPtr+1
	
WndGetAddr2:
	lda	ScnPtr
	sta	ScnAtPtr
	lda	ScnPtr+1
	and	#$07
	ora	ScnAttBase
	sta	ScnAtPtr+1
	rts

WndEnd:
	ldx	ScnBottom
	stx	ScnRow
	stx	ScnRowStart
	bra	WndLeft
	
WndNewLine:
	bit	ScnFlag			; test input line
	bpl	?00
	clc
	bvs	WndGetAddr		; mai scroll per input mono-linea
	ldx	ScnRow
	cpx	ScnBottom
	bcc	?02			; non occorre scroll
	ldy	ScnInpRow
	cpy	ScnTop
	bne	?01
	ldy	ScnLstRow
	cpy	ScnBottom
	bcc	?01			; scroll ok
	clc
	bcc	WndGetAddr
?00:	ldx	ScnRow
	cpx	ScnBottom
	bcc	?02			; non occorre scroll
	bit	ScnScroll
	bpl	?01
	lda	ScnTop
	sta	ScnRow
	bcs	WndGetAddr
?01:	jsr	WndScroll
	clc
?02:	inc	ScnRow			; incrementa riga	
	bra	WndGetAddr

; funzione CLR (SHIFT+PRTSCN)
ScnClr:
	bit	ScnFlag			; se in modo normale
	bpl	WndClr			; cancella schermo
	bra	_InpClr

; funzione HOME
ScnHome:
	bit	ScnFlag			; se in modo normale
	bpl	?00			; va a prima posizione schermo
	ldx	ScnInpRow		; altrimenti imposta cursore a
	stx	ScnRow			; prima posizione riga di input
	ldy	ScnInpCol
	sty	ScnCol
	bra	WndGetAddrX
?00:	lda	ScnLstChr
	cmp	#SCN_HOME
	bne	WndHome
	jsr	SetMaxWnd
?01:	jmp	WndHome

ScnEnd:
	bit	ScnFlag			; se in modo normale
	bpl	WndEnd			; va a altima posizione schermo
	ldx	ScnLstRow		; altrimenti sposta cursore ad ultima
	stx	ScnRow			; posizione riga di input
	ldy	ScnLstCol
	sty	ScnCol
	jmp	WndGetAddrX

_InpClr:
	jsr	ScnHome			; posiziona cursore a prima posizione riga di input
	ldx	ScnRow
	ldy	ScnCol
	jsr	ClrRowY			; cancella linea input fino alla fine
	ldx	ScnRow			; cancella resto delle linee fino alla posizione
	cpx	ScnLstRow
	bcs	?02
?01:	inx
	stx	ScnRow
	ldy	ScnLeft			; ultima della riga di input
	jsr	ClrRowY
	ldx	ScnRow
	cpx	ScnLstRow
	bcc	?01
?02:	ldx	ScnInpRow
	ldy	ScnInpCol
	stx	ScnLstRow
	sty	ScnLstCol
	bra	ScnHome

;--------------------------------------------------------------------

; inizializza video
_ScnInit:
	pha
	phx
	phy
	php			; salva status
	phd			; salva DP
	phb			; salva registro DBR
	CPU08			; imposta registri a 8 bit
	pea	#DP01ADDR	; imposta nuova DP
	pld
	ldx	#0		; 
	phx			; imposta DBR = 0
	plb
	jsr	cinit
	plb
	pld
	plp			; rispristina status
	ply
	plx
	pla
	clc			; no error
	rts
	
; input mode - caratteri di controllo
_ScnCtrl:
	ldx	#$80		; control
	stx	ScnCntrl
	ldx	ScnLstChr
	cpx	#SCN_PRTSCN
	beq	_ScnPut2	; passa a procedura PRINT
	cmp	#KB_SHIFTPRT	; SHIFT + PRINT SCRN
	bne	?01
	lda	#SCN_CLR	; cancella schermo
	bra	_ScnPut2
?01:	ldx	#0		; NOTA
	cmp	#KB_SHIFTINS
	beq	?02
	ldx	#0		; NOTA
	cmp	#KB_SHIFTDEL
	bne	?04
?02:	lda	#SCN_PRTSCN	; simula	
	sta	ScnLstChr
	txa
	bra	_ScnPut2
?04:	cmp	#KB_PRTSCN	; test tasti cursore e speciali
	bcc	_ScnWait
	cmp	#(KB_BACKSPACE + 1)
	bcs	_ScnWait
	sbc	#(KB_PRTSCN - 1)
	tax
	lda	>KBCONV,x	; converte tasti $83..90 in SCN_*
	bra	_ScnPut2

; input mode - stampa carattere ASCII
_ScnPut:
	stz	ScnCntrl	; flag carattere ASCII/CONTROL 
	ldx	ScnLstChr
	cpx	#SCN_PRTSCN
	beq	_ScnPut2	; passa a procedura PRINT
	cmp	#' '		; stampa diretta ASCII >= $32
	bcs	_ScnPut2
	cmp	#KB_TAB		; tasto TAB
	beq	_ScnPut2
	cmp	#KB_LF		; tasto CTRL + J (line feed)
	beq	_ScnPut2
	cmp	#KB_BELL	; tasto CTRL + G
	beq	_ScnPut2
	cmp	#KB_ESC		; tasto ESC
	bne	_ScnWait
_ScnPut2:
	jsr	_ScnCharOut	; stampa carattere
_ScnWait:
	jsr	VDCCursOn
?01:	lda	KbdCnt		; char disponibili nel buffer tastiera ?
	beq	?01		; no - attendi tasto
	sty	ScnTmpx
	jsr	_GetBufKey	; Y -> flag - A -> codice
	tax			; X = codice
	tya			; A = flag
	ldy	ScnTmpx
	asl	a		; C = bit 7, N = bit 6
	bmi	?01		; ignora rilascio tasti
	php			; salva C
	phx			; salva codice
	jsr	VDCCursOff
	pla			; A = codice
	plp			; C = 1 se carattere di controllo
	bcs	_ScnCtrl
	cmp	#KB_CR
	bne	_ScnPut		; stampa carattere se non CR
	sta	ScnCR
	jsr	FindEndRow
	stx	ScnLinTmp
	jsr	WndEscJ2
	ldy	ScnLeft
	lda	ScnRowStart
	bmi	?04
	cmp	ScnRow
	bcc	?03
	ldy	ScnColStart
	cmp	ScnLinTmp
	bne	?02
	cpy	ScnInput
	beq	?03
?02:	bcs	CheckCR
?03:	sta	ScnRow
?04:	sty	ScnCol
	bra	_ScnLine
	
_ScnCharIn:
	stz	ScnFlag
	lda	#$40
	tsb	ScnAutoIns		; bit 6: modo input
	lda	ScnCR
	beq	_ScnWait
	bpl	_ScnLine
CheckCR:
	stz	ScnCR
	lda	#KB_CR
	ldx	#TXTD_SCN
	cpx	!DflTxtIn
	beq	?01
	cpx	!DflTxtOut
	beq	?02
?01:	jsr	_ScnCharOut
?02:	lda	#KB_CR
	bne	_ScnLinX
			
_ScnLine:
	jsr	WndGetAddr
	jsr	GetVDCChar
	sta	ScnCurChr
	ldy	ScnRow
	cpy	ScnLinTmp
	bcc	?01
	ldy	ScnCol
	cpy	ScnInput
	bcc	?01
	ror	ScnCR
	bmi	_ScnLinX
?01:	jsr	MoveRight

_ScnLinX:
	sta	ScnCurChr
	clc
	rts

;--------------------------------------------------------------------

; NOTA: va chiamata con DP impostato su DIRP01
_GetBufKey:
	php
	sei				; disabilita interrupt
	ldx	KbdIHead		; puntatore testa buffer
	ldy	KbdBuf,x		; flag
	inx
	lda	KbdBuf,x		; codice tasto
	inx
	cpx	#KBDBUFLEN
	bcc	?01
	ldx	#0
?01:	stx	KbdIHead
	dec	KbdCnt
	dec	KbdCnt	
	plp
	rts


ScnProcPrnt:
	rts
	
; processa sequenza SCN_COL <A = FOREGROUND COLOR>
ScnProcCol:
	dec	a		; color = color - 1
	cmp	#$10		; test default
	bcc	?02		; set color
	lda	ScnDefCol	; imposta foreground di default
?02:	sta	ScnSaveX	; nuovo colore
	lda	ScnAttr
	and	#$F0
	ora	ScnSaveX
	sta	ScnAttr
	rts 

; processa sequenza SCN_BKGCOL <A = BACKGROUND COLOR>
ScnProcBkgCol:
	dec	a		; color = color - 1
	cmp	#$10		; test default
	bcc	?02		; set color
	lda	ScnDefBkgCol	; imposta background di default
?02:	sta	ScnSaveX	; nuovo colore
	ldx	#$1A		; attuale bkg color
	jsr	GetVDCReg
	and	#$F0		; maschera colore sfondo
	ora	ScnSaveX	; imposta nuovo colore	
	jmp	SetVDCReg

; processa sequenza SCN_ESC <A = ESC CODE>
ScnProcEsc:
	stz	ScnCurChr	; invalida byte corrente
	cmp	#SCN_ESC
	beq	WndEscO		; ESC + ESC annulla ESC
?01:	tax
	bmi	_RTS0
	cmp	#'@'
	beq	?03
	cmp	#'a'
	bcc	_RTS0
	cmp	#('z' + 1)
	bcs	_RTS0
	sec
	sbc	#$20
?03:	sec
	sbc	#$40
	cmp	#$1B
	bcs	_RTS0
	asl	a
	tax
	jmp	(ESCVCTRS,x)

; CR o SHIFT CR
ScnOutCR:
	jsr	FindEndRow
	inx
	jsr	TabSetupX
	ldy	ScnLeft
	sty	ScnCol
	jsr	WndNewLine
	
; ESC-O
WndEscO:
	lda	ScnAttr		; azzera reverse, underline, blink
	bit	<VBBRam
	bpl	?01
	and	#$1F
	bra	?02
?01:	and	#$8F
?02:	sta	ScnAttr
	stz	ScnInsert
_RTS0:	rts
	
ScnOutChr:
	bit	ScnFlag		; ignora tasto PAUSE 
	bmi	?02		; in modo line input
	bit	ScnAutoIns	; ignora tasto PAUSE 
	bvs	?02		; in modo full editor
?01:	lda	#PAUSETGB	; attesa durante PAUSE			
	bit	KbdToggle
	bne	?01
?02:	stz	ScnCR
	lda	ScnCurChr	; byte da inviare a schermo
	ldy	ScnCol		; colonna corrente
	ldx	ScnLstChr	; se ultimo byte = NULL
	beq	?10		; salta test sequenza escape
	cpx	#SCN_ESC	; se byte < SCN_ESC
	bcc	?10		; salta test sequenza escape
	cpx	#SCN_PASS	; se byte < SCN_PASS
	beq	?04		; byte = SCN_PASS
	bcc	?06		; byte < SCN_PASS esegue sequenza escape
	bcs	?10		; byte > SCN_PASS salta test sequenza escape
?04:	bit	ScnFlag		; ignora sequenze SCN_PASS
	bmi	?10		; in modo input line	
	bit	ScnAutoIns	; ignora sequenze SCN_PASS
	bvs	?10		; in modo full editor
	stz	ScnCurChr	; invalida byte corrente
	bra	ScnOut		; stampa codice 00..1F come ASCII
?06:	xba			; salva byte in B
	txa
	sbc	#(SCN_ESC - 1)	; qui C = 0 !
	asl	a
	tax			; indice funzione sequenza escape
	xba			; ripristina A
	stz	ScnCurChr	; invalida byte corrente
	jmp	(SCNESCSEQ,x)	; funzione di escape
?10:	cmp	#' '		; byte attuale ASCII ?
	bcs	ScnOut		; si - output a schermo
	cmp	#SCN_ESC	; codice escape ?
	bcs	?16		; si - esce
	cmp	#SCN_ALTFNT
	bcc	?20		; codice controllo
	sbc	#SCN_ALTFNT	; attributo
	cmp	#$04		; attributo OFF -> C = 1
	and	#$03
	tax
	bit	<VBBRam
	bpl	?10a
	
	; no alternate font attribute per video board
	; blink e underline invertiti
	lda	>MSKROW2,x
	beq	?16		; ignora se A = $00
	bne	?10b
?10a:	lda	>MSKROW,x
?10b:	bcs	?12		; si
	tsb	ScnAttr		; attributo ON
	rts
?12:	trb	ScnAttr		; attributo OFF
?16:	rts	
?20:	dec	a		; codice controllo
	asl	a
	tax			; indice funzione controllo
	jmp	(CTRLVCTRS,x)
	
; Output a schermo e posizionamento cursore
ScnOut:
?01:	ldx	ScnInsert
	beq	?02
	dec	ScnInsert
?02:	bit	ScnAutoIns
	bvc	?10			; modo out - stampa carattere
	bpl	?03			; no auto insert			
	pha
	jsr	WndMakeSpace		; solo se in modo input
	stz	ScnInsert
	pla
?03:	bit	ScnFlag
	bpl	?10			; modo input normale
	ldx	ScnRow
	ldy	ScnCol			; colonna in ultima posizione ?
	cpy	ScnRight
	bcc	?10			; no, stampa car.
	bit	ScnFlag
	bvs	?06			; input riga singola - non stampa	
	cpx	ScnBottom		; ultima riga schermo ?
	bcc	?10			; no - stampa car.
	ldx	ScnInpRow
	cpx	ScnTop
	bne	?10
?06:	clc
	rts
?10:	jsr	PutChar			; stampa carattere
	bit	ScnFlag
	bpl	CheckCurs
	ldx	ScnRow
	ldy	ScnCol
	cpx	ScnLstRow
	bne	?11
	cpy	ScnLstCol
?11:	php
	jsr	CheckCurs
	plp
	bne	?15
	ldx	ScnRow			; aggiorna ultima posizione cursore
	ldy	ScnCol
	stx	ScnLstRow
	sty	ScnLstCol
?15:	rts
	
CheckCurs:
	cpy	ScnRight
	bcc	?01			; SncCol < ScnRight
	ldx	ScnRow
	cpx	ScnBottom
	bcc	?01			; ScnRow < ScnBottom
	bit	ScnScroll
	bmi	?03
?01:	jsr	WndGetAddr
	jsr	MoveRight
	bcc	?03
	jsr	TabCheck
	bcs	?02
	sec
	bit	ScnScroll
	bvs	?03
	jsr	InsertRow
?02:	clc
?03:	rts

; Inserisce nuova riga
InsertRow:
	ldx	ScnRowStart
	bmi	?01
	cpx	ScnRow
	bcc	?01
	inc	ScnRowStart
?01:	ldx	ScnBottom
?02:	jsr	WndGetAddrX
	ldy	ScnLeft
	cpx	ScnRow
	beq	?03
	dex
	jsr	TabCheckX
	inx
	jsr	TabSetup2
	dex
	jsr	MoveRow
	bra	?02
?03:	jsr	ClrRow
	jmp	_Tab2Check
	
; Scrolla finestra
WndScroll:
	ldx	ScnTop
PP01:	inx
	jsr	TabCheckX
	bcc	PP02
	cpx	ScnBottom
	bcc	PP01
	ldx	ScnTop
	inx
	jsr	TabSetupX
PP02:	dec	ScnInpRow		; update riga di start input line
	dec	ScnRow
	bit	ScnRowStart
	bmi	PP03
	dec	ScnRowStart
PP03:	ldx	ScnTop
	cpx	ScnSaveRow
	bcs	PP04
	dec	ScnSaveRow
PP04:	jsr	DeleteRow
	ldx	ScnTop
	jsr	TabCheckX
	php
	jsr	TabSetupX
	plp
	bcc	PP05
	bit	ScnScroll
	bmi	WndScroll
PP05:	rts

; Copia riga corrente nella riga X
MoveRow:
	stx	ScnSaveX
	bit	<VBBRam
	bpl	?10			; VDC
	lda	>SCRNADDRL,x		; forza ABS LONG
	sta	ScnPtr1
	sta	ScnPtr2
	lda	>SCRNADDRH,x
	sta	ScnPtr1+1
	and	#$07
	ora	ScnAttBase
	sta	ScnPtr2+1
	ldx	CREMEOFF		; salva bit corrente
	phx
	sta	!CREMEON		; abilita memoria video
?04:	lda	[ScnPtr1],y
	sta	[ScnPtr],y
	lda	[ScnPtr2],y
	sta	[ScnAtPtr],y
	cpy	ScnRight
	iny
	bcc	?04
	plx
	sta	!CREMEOFF,x		; ripristina bit corrente
	bra	?20
?10:	sty	ScnSaveY
	ldx	#$18
	jsr	GetVDCReg
	ora	#$80
	jsr	SetVDCReg
	jsr	SetVRam
	ldx	ScnSaveX
	lda	>SCRNADDRL,x		; forza ABS LONG
	sta	ScnTmpL
	lda	>SCRNADDRH,x
	ora	ScnChBase
	sta	ScnTmpH
	ldx	#$20
	clc
	tya
	adc	ScnTmpL
	sta	ScnTmpL
	lda	#$00
	adc	ScnTmpH
	sta	ScnTmpH
	jsr	SetVDCReg
	inx
	lda	ScnTmpL
	jsr	SetVDCReg
	lda	ScnRight
	inc	a
	sec
	sbc	ScnSaveY
	sta	ScnSaveY
	ldx	#$1E
	jsr	SetVDCReg
	jsr	SetARam
	ldx	#$20
	lda	ScnTmpH
	and	#$07
	ora	ScnAttBase
	jsr	SetVDCReg
	inx
	lda	ScnTmpL
	jsr	SetVDCReg
	lda	ScnSaveY
	ldx	#$1E
	jsr	SetVDCReg
?20:	ldx	ScnSaveX
	rts

; Elimina riga X
DeleteRow:
	jsr	WndGetAddrX
	ldy	ScnLeft
	cpx	ScnBottom
	bcs	ClrRow
	inx
	jsr	TabCheckX
	dex
	jsr	TabSetup2
	inx
	jsr	MoveRow
	bra	DeleteRow
	
; Cancella linea X
ClrRow:
	ldy	ScnLeft
	jsr	TabSetupX
	
; Cancella linea X a partire da colonna Y
ClrRowY:
	jsr	WndGetAddrX
	stx	ScnSaveX
	bit	<VBBRam
	bpl	?00			; VDC
	ldx	CREMEOFF		; salva bit corrente
	phx
	sta	!CREMEON		; abilita memoria video
	dey
?00a:	iny	
	lda	#' '
	sta	[ScnPtr],y
	lda	ScnAttr
	and	#$1F
	sta	[ScnAtPtr],y
	cpy	ScnRight
	bne	?00a
	plx
	sta	!CREMEOFF,x		; ripristina bit corrente
	ldx	ScnSaveX
	rts
?00:	sty	ScnSaveY
	ldx	#$18
	jsr	GetVDCReg
	and	#$7F
	jsr	SetVDCReg
	ldx	#$12
	clc
	tya
	adc	ScnPtr
	sta	ScnTmpL
	lda	#0
	adc	ScnPtr+1
	sta	ScnTmpH
	jsr	SetVDCReg
	inx
	lda	ScnTmpL
	jsr	SetVDCReg
	lda	#' '
	jsr	SetVDCReg31
	sec
	lda	ScnRight
	sbc	ScnSaveY
	pha
	beq	?01
	tax
	sec
	adc	ScnTmpL
	sta	ScnTmpL
	lda	#$00
	adc	ScnTmpH
	sta	ScnTmpH
	txa
	jsr	CopyVDC
?01:	ldx	#$12
	clc
	tya
	adc	ScnAtPtr
	pha
	lda	#0
	adc	ScnAtPtr+1
	jsr	SetVDCReg
	inx
	pla
	jsr	SetVDCReg
	lda	ScnTmpH
	and	#$07
	ora	ScnAttBase
	sta	ScnTmpH
	lda	ScnAttr
	and	#$8F
	jsr	SetVDCReg31
	pla
	beq	?02
	jsr	CopyVDC
?02:	ldx	ScnSaveX
	ldy	ScnRight
	rts
	
; Copia in video ram 1 byte
CopyVDC1:
	lda	#$01
	
; Copia in video ram A bytes
CopyVDC:	
	ldx	#$1E
	jsr	SetVDCReg
?01:	bit	VDCStatus
	bpl	?01
	ldx	#$12
	jsr	GetVDCReg
	cmp	ScnTmpH
	bcc	CopyVDC1
	ldx	#$13
	jsr	GetVDCReg
	cmp	ScnTmpL
	bcc	CopyVDC1
	rts


;--------------------------------------------------------------------

; tasto insert
KeybInsert:
	bit	ScnAutoIns
	bmi	RTS11
	jmp	WndMakeSpace
		
; Muove cursore a destra
CsrRight:
	bit	ScnFlag
	bpl	?00			; modo normale
	ldy	ScnCol			; test: cursore ad ultima posizione ?
	cpy	ScnLstCol
	bcc	?00			; no
	ldy	ScnRow
	cpy	ScnLstRow
	bcs	RTS11			; si
?00:	jsr	MoveRight
	bcs	_CsrCheck
RTS11:
	rts
	
; Muove cursore in basso
CsrDown:
	bit	ScnFlag			; se in modo input
	bmi	CsrDown2
	jsr	WndNewLine
	
_CsrCheck:
	jsr	TabCheck
	bcs	_CsrClc
	sec
	ror	ScnRowStart
_CsrClc:
	clc
_CsrRts:
	rts
	
; Muove cursore in alto
CsrUp:	
	bit	ScnFlag			; se in modo input
	bmi	CsrUp2
	ldx	ScnTop
	cpx	ScnRow
	bcs	_CsrRts
_CsrSet:	
	jsr	_CsrCheck
_CsrSet2:	
	dec	ScnRow
	jmp	WndGetAddr
	
; Muove cursore a sinistra
CsrLeft:
	jsr	MoveLeft
	bcs	_CsrRts
	bne	_CsrClc
	inc	ScnRow
	bne	_CsrSet

; CURSORE DOWN modo input
CsrDown2:
	ldx	ScnRow
	cpx	ScnLstRow
	bcs	_CsrRts
	inc	ScnRow
	ldy	ScnCol
	ldx	ScnRow
	cpx	ScnLstRow
	bcc	_Check4
	cpy	ScnLstCol
	bcc	_Check4
	ldy	ScnLstCol
	
_Check4:
	sty	ScnCol
	clc	
	jmp	WndGetAddr
	
; CURSORE UP modo input
CsrUp2:
	ldx	ScnInpRow
	cpx	ScnRow
	bcs	_CsrRts
	dec	ScnRow
	ldy	ScnCol
	ldx	ScnInpRow
	cpx	ScnRow
	bcc	_Check4
	cpy	ScnInpCol
	bcs	_Check4
	ldy	ScnInpCol
	bra	_Check4
	
; TAB
CsrTab:
	bit	ScnFlag			; in modo input line
	bmi	?04			; non esegue nulla
	ldy	ScnCol
?01:	iny
	cpy	ScnRight
	bcs	?02
	jsr	FindTab
	beq	?01
	bne	?03
?02:	ldy	ScnRight
?03:	sty	ScnCol
?04:	rts

CsrShTab:
	bit	ScnFlag			; in modo input line
	bmi	?04			; non esegue nulla
	ldy	ScnCol
?01:	cpy	ScnLeft
	beq	?03
	dey
	jsr	FindTab
	beq	?01
?03:	sty	ScnCol
?04:	rts
	
TabToggle:
	ldy	ScnCol
	jsr	FindTab
	eor	ScnTmpL
	sta	ScnMapTabs1,x
	rts
	
FindTab:
	tya
	and	#$07
	tax
	lda	>MSKROW,x		; forza ABS LONG
	sta	ScnTmpL
	tya
	lsr	a
	lsr	a
	lsr	a
	tax
	lda	ScnMapTabs1,x
	bit	ScnTmpL
	rts
		
LineFeed:
	bit	ScnFlag			; in modo input line
	bmi	?01			; non esegue nulla
	lda	ScnCol
	pha
	jsr	FindEndRow
	jsr	WndNewLine
	pla
	sta	ScnCol
?01:	rts

SolidCurs:
	lda	ScnCursMode
	and	#$E0
	bra	_SetVDCCurs

ULineCurs:
	lda	ScnCursMode
	and	#$E0
	ora	#CURSLINE
	bra	_SetVDCCurs
	
FixedCurs:
	lda	#$80
	trb	ScnAutoIns
	lda	ScnCursMode
	and	#$1F
	
_SetVDCCurs:
	sta	ScnCursMode
	jmp	VDCCursor

FlashCurs:
	lda	#$80
	tsb	ScnAutoIns
	lda	ScnCursMode
	and	#$1F
	ora	#DEFCURS
	bne	_SetVDCCurs
	
ScreenRev:
	ldx	#$18
	jsr	GetVDCReg
	ora	#$40
	bne	_ScnSet
	
ScreenNorm:
	ldx	#$18
	jsr	GetVDCReg
	and	#$BF
	
_ScnSet:
	jmp	SetVDCReg

UpdLast:
	ldy	ScnLstCol
	lda	ScnRow
	cmp	ScnInpRow
	bne	?05
	cpy	ScnInpCol
	beq	?11
?05:	dey
	bpl	?10
	dec	ScnLstRow
	ldy	ScnRight
?10:	sty	ScnLstCol
?11:	rts

MoveRCurs:
	jsr	CheckCurs
	ldx	ScnRow			; aggiorna ultima posizione cursore
	ldy	ScnCol
	stx	ScnLstRow
	sty	ScnLstCol
	rts

; tasto DELETE
KeyDel:
	bit	ScnFlag
	bpl	?30
	lda	ScnRow			; non esegue nulla se in ultima posizione			
	cmp	ScnLstRow
	bne	?01
	lda	ScnCol
	cmp	ScnLstCol
	beq	?30
?01:	jsr	SaveCursPos
	jsr	KeyDel1	
?30:	rts

; Crea spazio nella finestra
WndMakeSpace:
	bit	ScnFlag
	bpl	?00
	ldx	ScnRow			; non apre spazio se stampa avviene 
	cpx	ScnLstRow		; nella posizione corrente
	bne	?05
	ldy	ScnCol
	cpy	ScnLstCol
	beq	?10
?05:	bit	ScnFlag
	bvc	?20			; input multi-linea	
	ldy	ScnLstCol		; non apre spazio se cursore
	cpy	ScnRight		; in ultima posizione utile
	bcc	?25
?10:	rts
?20:	ldy	ScnLstCol		; test ultima posizione utile multi-linea
	cpy	ScnRight
	bcc	?25
	ldy	ScnInpRow
	cpy	ScnTop
	bne	?25
	ldy	ScnLstRow
	cpy	ScnBottom
	bcs	?10
?25:	jsr	SaveCursPos
	jsr	FindEndRow2
	jsr	MoveRCurs
	bra	?02

?00:	jsr	SaveCursPos
	jsr	FindEndRow
	cpx	ScnSaveRow
	bne	?01
	cpy	ScnSaveCol
?01:	bcc	?03
	jsr	CheckCurs
	bcs	CsrRest
?02:	jsr	MoveLeft
	jsr	GetVDCChar
	jsr	MoveRight
	jsr	PutChar2
	jsr	MoveLeft
	ldx	ScnRow
	cpx	ScnSaveRow
	bne	?02
	cpy	ScnSaveCol
	bne	?02
	jsr	PutBlank
?03:	inc	ScnInsert
	bne	CsrRest
	dec	ScnInsert
?04:	bra	CsrRest

; BACKSPACE
KeyBack:
	bit	ScnFlag
	bpl	?10
	lda	ScnRow
	cmp	ScnInpRow
	bne	?10
	lda	ScnCol
	cmp	ScnInpCol
	beq	_RTSZ
?10:	jsr	CsrLeft
	jsr	SaveCursPos
	bcs	CsrRest
KeyDel1:
	bit	ScnFlag
	bpl	?11
	ldx	ScnRow
	cpx	ScnLstRow
	bcc	KeyDel2
	cpy	ScnLstCol
	bcc	KeyDel2
	bcs	?12
?11:	cpy	ScnRight
	bcc	KeyDel2
	ldx	ScnRow
	inx
	jsr	TabCheckX
	bcs	KeyDel2
?12:	jsr	PutBlank
	bit	ScnFlag
	bpl	CsrRest
	jsr	UpdLast
	
CsrRest:
	lda	ScnSaveRow
	sta	ScnRow
	lda	ScnSaveCol
	sta	ScnCol
	jmp	WndGetAddr
	
KeyDel2:
	jsr	MoveRight
	jsr	GetVDCChar
	jsr	MoveLeft
	jsr	PutChar2
	jsr	MoveRight
	bra	KeyDel1
					
;------------------------------------------------------------

; ESC-Z - cancella tab
ClearTabs:	
	lda	#0
	bra	_SetTabs
	
; ESC-Y - set default tab
SetDefTabs:
	lda	#$80
	ldx	#$09
_SetTabs:
?01:	sta	ScnMapTabs1,x
	dex
	bpl	?01
_RTSZ:
	rts
	
; ESC-T - finestra TOP,LEFT
WndEscT:
	clc
	
	.DB	$24
	
; ESC-B - finestra BOTTOM, RIGHT
WndEscB:
	sec
	ldx	ScnCol
	lda	ScnRow
	
SetWndL:
	bcc	SetWnd3
SetWndR:	
	sta	ScnBottom
	stx	ScnRight
	bra	_SetWnd2
SetWnd3:	
	sta	ScnTop
	stx	ScnLeft
_SetWnd2:
	ldx	#3
?01:	stz	ScnMapTabs2,x
	dex
	bpl	?01
	rts
	
SetMaxWnd:
	lda	ScnMaxRow
	ldx	ScnMaxCols
	jsr	SetWndR
	stz	ScnLeft
	stz	ScnTop
	rts

; ESC-Q - cancella fino a fine linea
WndEscQ:
	jsr	SaveCursPos
?01:	jsr	ClrRowY
	inc	ScnRow
	jsr	WndGetAddr
	ldy	ScnLeft
	jsr	TabCheck
	bcs	?01
	bra	CsrRest

; ESC-P - erase begin
WndEscP:
	jsr	SaveCursPos
?01:	jsr	PutBlank
	cpy	ScnLeft
	bne	?02
	jsr	TabCheck
	bcc	CsrRest
?02:	jsr	MoveLeft
	bcc	?01

; ESC-@ - cancella resto dello schermo
WndEscAt:
	jsr	SaveCursPos
?01:	jsr	ClrRowY
	inc	ScnRow
	jsr	WndGetAddr
	ldy	ScnLeft
	jsr	TabCheck
	bcs	?01
	lda	ScnRow
	cmp	ScnBottom
	bcc	?01
	beq	?01
	jmp	CsrRest
	
; ESC-V - scroll up
WndEscV:
	jsr	SaveCursPos
	phx
	jsr	WndScroll
	pla
	sta	ScnSaveRow
	jmp	CsrRest
	
; ESC-W - scroll Down
WndEscW:
	jsr	SaveCursPos
	jsr	TabCheck
	bcs	?01
	sec
	ror	ScnRowStart
?01:	lda	ScnTop
	sta	ScnRow
	jsr	InsertRow
	jsr	TabSetupX
	jmp	CsrRest
		
; ESC-K - fine riga
WndEscK:
	jsr	FindEndRow
	jmp	CheckCurs	

WindowOrg:
	ldy	ScnCol
	ldx	ScnRow
	stx	ScnTop
	sty	ScnLeft
	sta	ScnBottom
	jmp	_SetWnd2

TabCheck:
	ldx	ScnRow
TabCheckX:
	jsr	MaskRow
	and	ScnMapTabs2,x
	cmp	#$01
	bra	_TabExit
TabSetup:	
	ldx	ScnRow
TabSetup2:
	bcs	_Tab2Check
TabSetupX:	
	jsr	MaskRow
	eor	#$FF
	and	ScnMapTabs2,x
_Tab2Set:
	sta	ScnMapTabs2,x
_TabExit:	
	ldx	ScnTmpL
	rts
_Tab2Check:
	bit	ScnScroll
	bvs	TabCheckX
	jsr	MaskRow
	ora	ScnMapTabs2,x
	bne	_Tab2Set
	
MaskRow:
	stx	ScnTmpL
	txa
	and	#$07
	tax
	lda	>MSKROW,x		; forza ABS LONG
	pha
	lda	ScnTmpL
	lsr	a
	lsr	a
	lsr	a
	tax
	pla
	rts

; ESC-J
WndEscJ:
	ldy	ScnLeft
	sty	ScnCol
	
WndEscJ2:
	jsr	TabCheck
	bcc	?02
	dec	ScnRow
	bpl	WndEscJ2
	inc	ScnRow
?02:	jmp	WndGetAddr

; ESC-I - insert line
WndEscI:
	jsr	InsertRow
	jsr	WndLeft
	inx
	jsr	TabCheckX
	php
	jsr	TabSetup
	plp
	bcs	?01
	sec
	ror	ScnRowStart
?01:	rts

; ESC-D - delete line
WndEscD:
	jsr	WndEscJ2
	lda	ScnTop
	pha
	lda	ScnRow
	sta	ScnTop
	lda	ScnScroll
	pha
	lda	#$80
	sta	ScnScroll
	jsr	PP02
	pla
	sta	ScnScroll
	lda	ScnTop
	sta	ScnRow
	pla
	sta	ScnTop
	sec
	ror	ScnRowStart
	jmp	WndLeft

FindEndRow2:
	ldx	ScnLstRow		; riga ultima posizione di input
	stx	ScnRow			; imposta come riga corrente
	ldy	ScnLstCol
	sty	ScnCol
	jmp	WndGetAddr

_Trim:
?01:	jsr	GetVDCChar
	ldx	ScnRow
	cmp	#' '
	bne	?04
	lda	ScnRow
	cmp	ScnInpRow
	bne	?02
	cpy	ScnInpCol
	beq	?03
?02:	jsr	MoveLeft
	bra	?01
?03:	sty	ScnColStart		; forza campo input vuoto
?04:	rts

FindEndRow3:
	ldx	ScnLstRow		; riga ultima posizione di input
	stx	ScnRow			; imposta come riga corrente
	ldy	ScnLstCol
	sty	ScnCol
	sty	ScnColStart		; copia di ScnLstCol
	cpx	ScnInpRow
	bne	?20
	cpy	ScnInpCol
	beq	_FindEnd		; campo input vuoto
?20:	jsr	MoveLeft		; cursore ad ultima posizione utile
	jsr	WndGetAddr
	lda	#$04			; test bit 2
	bit	ScnFlag
	bne	_FindEnd
	jsr	_Trim
	bra	_FindEnd
		
; Cerca fine della riga
FindEndRow:
	bit	ScnFlag
	bpl	?00			; modo normale
	ldx	ScnLstRow		; riga ultima posizione di input
	stx	ScnRow			; imposta come riga corrente
	ldy	ScnLstCol
	sty	ScnCol
	cpx	ScnInpRow
	bne	?20
	cpy	ScnInpCol
	beq	?03			; campo input vuoto
?20:	bit	ScnFlag
	bvs	?00a
	cpy	ScnLeft
	bne	?00a
	dec	ScnRow
	ldy	ScnRight
	bra	?00a
?00:	inc	ScnRow
	jsr	TabCheck
	bcs	?00
	dec	ScnRow
?00a:	jsr	WndGetAddr
	ldy	ScnRight
	sty	ScnCol
?01:	jsr	GetVDCChar
	ldx	ScnRow
	cmp	#' '
	bne	?03
	cpy	ScnLeft
	bne	?02
	jsr	TabCheck
	bcc	?03
?02:	jsr	MoveLeft
	bcc	?01
?03:	
_FindEnd:
	sty	ScnInput
	rts
	
; Muove cursore a destra - update ScnCol
; Out:	C = 0 se ScnRow non cambiato
;	C = 1 se ScnRow cambiato
MoveRight:
	bit	ScnFlag
	bpl	?00			; modo normale
	ldy	ScnCol			; test: cursore ad ultima posizione ?
	cpy	ScnRight
	bcc	?00			; no
	bit	ScnFlag
	bvs	?15			; input mono-linea - esce
	ldy	ScnInpRow		; ultima riga ?
	cpy	ScnTop
	bne	?00			; no
	ldy	ScnRow
	cpy	ScnBottom
	bcc	?00
?15:	ldy	ScnCol	
	clc				; non aggiorna ScnCol
	rts
?00:	pha
	ldy	ScnCol
	cpy	ScnRight
	bcc	?01
	jsr	WndNewLine
	ldy	ScnLeft
	dey
	sec
?01:	iny
	sty	ScnCol
	pla
	rts
	
; Muove cursore a sinistra
MoveLeft:
	bit	ScnFlag
	bpl	?00			; modo normale
	ldy	ScnInpRow		; modo input line
	cpy	ScnRow			; riga attuale > riga start input
	bcc	?00			; cursore possibile a sinistra
	; riga attuale = riga start input: cursore limitato
	; a sinistra alla posizione ScnInpCol
	ldy	ScnInpCol
	cpy	ScnCol
	bcs	?02			; cursore a posizione ScnInpCol
?00:	ldy	ScnCol
	dey
	bmi	?01
	cpy	ScnLeft
	bcs	?02
?01:	ldy	ScnTop
	cpy	ScnRow
	bcs	?03
	dec	ScnRow
	pha
	jsr	WndGetAddr
	pla
	ldy	ScnRight
?02:	sty	ScnCol
	cpy	ScnRight
	clc
?03:	rts

; Salva posizione cursore
SaveCursPos:
	ldy	ScnCol
	sty	ScnSaveCol
	ldx	ScnRow
	stx	ScnSaveRow
	rts
	
; Get limiti finestra
GetWndOrg:
	sec
	lda	ScnBottom
	sbc	ScnTop
	tay
	sec
	lda	ScnRight
	sbc	ScnLeft
	tax
	lda	ScnMaxCols
	rts
	
; Get/Set posizione cursore
GetSetPos:
	bcs	?05		; get cursor pos
	txa
	adc	ScnTop
	bcs	?03
	cmp	ScnBottom
	beq	?01
	bcs	?03
?01:	pha
	clc
	tya
	adc	ScnLeft
	bcs	?02
	cmp	ScnRight
	beq	?04
	bcc	?04
?02:	pla
?03:	rts
?04:	sta	ScnCol
	sta	ScnColStart
	pla
	sta	ScnRow
	sta	ScnRowStart
	jsr	WndGetAddr
	jsr	SetVDCCurs
?05:	lda	ScnRow
	sbc	ScnTop
	tax
	sec
	lda	ScnCol
	sbc	ScnLeft
	tay
	clc
	rts

; Stampa spazio
PutBlank:
	lda	ScnAttr
	bit	<VBBRam
	bpl	?10
	and	#$1F
	bra	?12
?10:	and	#$8F
?12:	tax
	lda	#' '
	bra	PutCharAttr
	
; Stampa carattere con attributo di default
PutChar:	
	ldx	ScnAttr
	bra	PutCharAttr
	
; Stampa carattere con attributo alternativo
PutChar2:
	ldx	ScnAttr2
	
PutCharAttr:
	tay
	jsr	WndGetAddr2
	tya
	ldy	ScnCol
	bit	<VBBRam
	bpl	?10
	stx	ScnTmpx
	ldx	CREMEOFF		; salva bit corrente
	phx
	sta	!CREMEON		; abilita memoria video
	sta	[ScnPtr],y
	lda	ScnTmpx
	sta	[ScnAtPtr],y
	plx
	sta	!CREMEOFF,x		; ripristina bit corrente
	rts	
?10:	pha
	phx
	jsr	SetARam
	pla
	jsr	SetVDCReg31
	jsr	SetVRam
	pla
	jmp	SetVDCReg31
	
; Get carattare e attributo
GetVDCChar:
	ldy	ScnCol
	bit	<VBBRam
	bpl	?10
	ldx	CREMEOFF		; salva bit corrente
	phx
	sta	!CREMEON		; abilita memoria video
	lda	[ScnAtPtr],y
	sta	ScnAttr2
	lda	[ScnPtr],y
	plx
	sta	!CREMEOFF,x		; ripristina bit corrente
	rts	
?10:	jsr	SetARam
	jsr	GetVDCReg31
	sta	ScnAttr2
	jsr	SetVRam
	jmp	GetVDCReg31
		
; Cursore VDC ON
VDCCursOn:
	jsr	WndGetAddr2
	ldy	ScnCol
	bit	<VBBRam
	bpl	?10
	ldx	CREMEOFF		; salva bit corrente
	phx
	sta	!CREMEON		; abilita memoria video
	lda	[ScnAtPtr],y
	sta	ScnSaveAttr
	and	#$E0
	sta	ScnTmpH
	lda	ScnAttr
	and	#$1F
	ora	ScnTmpH
	sta	[ScnAtPtr],y	
	plx
	sta	!CREMEOFF,x		; ripristina bit corrente
	bra	VDCCursor		
?10:	jsr	SetARam
	jsr	GetVDCReg31
	sta	ScnSaveAttr
	and	#$F0
	sta	ScnTmpH
	jsr	SetARam
	lda	ScnAttr
	and	#$0F
	ora	ScnTmpH
	jsr	SetVDCReg31
	
VDCCursor:
	ldx	#$0A
	lda	ScnCursMode
	bit	<VBBRam
	bmi	?10
	jmp	SetVDCReg
?10:	stx	CRTAddr
	sta	CRTData
	lda	#$04
	tsb	!PIAVBB+PIAPRB	
	rts	

; Cursore VDC OFF
VDCCursOff:
	bit	<VBBRam
	bpl	?10
	lda	ScnSaveAttr
	ldx	CREMEOFF		; salva bit corrente
	phx
	sta	!CREMEON		; abilita memoria video
	sta	[ScnAtPtr],y
	plx
	sta	!CREMEOFF,x		; ripristina bit corrente
	bra	CursOff2		
?10:	jsr	SetARam
	lda	ScnSaveAttr
	jsr	SetVDCReg31
CursOff2:
	ldx	#$0A
	lda	#$20
	bit	<VBBRam
	bpl	SetVDCReg
	stx	CRTAddr
	sta	CRTData
	lda	#$04
	trb	!PIAVBB+PIAPRB
	rts	

; stampa a schermo carattere in A
_ScnCharOut:
	sta	ScnCurChr
	jsr	ScnOutChr
	lda	ScnCurChr
	sta	ScnLstChr	
	
; Imposta indirizzo cursore VDC
SetVDCCurs:
	ldx	#$0E
	clc
	lda	ScnPtr
	adc	ScnCol
	pha
	lda	ScnPtr+1
	adc	#0
	bit	<VBBRam
	bpl	?10
	stx	CRTAddr
	sta	CRTData
	inx
	pla
	stx	CRTAddr
	sta	CRTData
	rts
?10:	jsr	SetVDCReg
	inx
	pla
	bra	SetVDCReg

	
; Imposta RAM ATTRIBUTI alla riga corrente e colonna Y
SetARam:
	ldx	#$12
	clc
	tya
	adc	ScnAtPtr
	pha
	lda	#0
	adc	ScnAtPtr+1
	bra	_SetVRam2

; Imposta RAM VIDEO alla riga corrente e colonna Y		
SetVRam:
	ldx	#$12
	clc
	tya
	adc	ScnPtr
	pha
	lda	#0
	adc	ScnPtr+1
_SetVRam2:
	jsr	SetVDCReg
	pla
	inx
	bra	SetVDCReg

; Chiamare con M,X=8 bit e DBR = 0
SetVDCReg31:
	ldx	#$1F
SetVDCReg:
	stx	VDCAddr
?01:	bit	VDCStatus
	bpl	?01
	sta	VDCData
	rts

; Chiamare con M,X=8 bit e DBR = 0	
GetVDCReg31:
	ldx	#$1F
GetVDCReg:
	stx	VDCAddr
?01:	bit	VDCStatus
	bpl	?01
	lda	VDCData
	rts

;------------------------------------------------------------
		

; copia font nella memoria del VDC
; Chiamare con M,X=8 bit e DBR = 0
SetVDCFont:
	.LONGA	off
	.LONGI	off

	ldx	#$12		; imposta Hi addr memoria VDC
	lda	#$0
	jsr	SetVDCReg
	inx
	lda	#0		; Lo addr
	jsr	SetVDCReg
	lda	#^VGA8x8L	; segmento font
	sta	ScnPrm+2 
	lda	#$04		; 1K
	ldx	#>VGA8x8L	; carica font VGA 8x8 L
	ldy	#CGAWIDTH
	jsr	CopyFont
	lda	#$04		; 1K
	ldx	#>VGA8x8H	; carica font VGA 8x8 H
	ldy	#CGAWIDTH
	jsr	CopyFont   
	lda	#$04		; 1K
	ldx	#>VGA8x8L	; carica font VGA 8x8 L
	ldy	#CGAWIDTH
	jsr	CopyFont  
	lda	#$04		; 1K
	ldx	#>VGA8x8H	; carica font VGA 8x8 H 
	ldy	#CGAWIDTH

; copia un set font nella memoria del VDC
; In:	- X = ptr. Hi blocco font
;	  Y = numero linee scansione font
;	  A = numero pagine da 256b
; Chiamare con M,X=8 bit e DBR = 0
CopyFont:
	.LONGA	off
	.LONGI	off
	
	stx	ScnPrm+1		; salva ptr Hi blocco font
	stz	ScnPrm			; ptr Lo = 0
	sty	ScnSaveY		; linee scansione font
	clc
	adc	ScnPrm+1		; fine font attuale (Hi)
	sta	ScnSaveX
	lda	#CHARWIDTH
	sec
	sbc	ScnSaveY		; linee residue
	sta	ScnTmpL
	ldy	#0
?01:	lda	[ScnPrm],y		; load byte font
	jsr	SetVDCReg31		; copia in video ram
	iny
	cpy	ScnSaveY		; loop N linee scansione
	bcc	?01
	ldy	ScnTmpL			; linee residue
	beq	?03			; no linee residue
	lda	#0
?02:	jsr	SetVDCReg31		; azzera linee residue
	dey
	bne	?02
?03:	lda	ScnPrm			; aggiorna long ptr
	clc
	adc	ScnSaveY		; aggiunge numero linee
	sta	ScnPrm
	bcc	?01			; loop
	inc	ScnPrm+1
	lda	ScnPrm+1
	cmp	ScnSaveX
	bcc	?01			; loop
	rts

HistUp:
HistDown:
BellSnd:
	rts
	
;--------------------------------------------------------------------
			
; tabella indirizzi base video ram
SCRNADDRL:
	.DB	$00, $50, $A0, $F0, $40, $90, $E0, $30
	.DB	$80, $D0, $20, $70, $C0, $10, $60, $B0
	.DB	$00, $50, $A0, $F0, $40, $90, $E0, $30
	.DB	$80
	
SCRNADDRH:
	.DB	$00, $00, $00, $00, $01, $01, $01, $02
	.DB	$02, $02, $03, $03, $03, $04, $04, $04
	.DB	$05, $05, $05, $05, $06, $06, $06, $07
	.DB	$07

;--------------------------------------------------------------------

MSKROW:
	.DB	$80, $40, $20, $10, $08, $04, $02, $01	

; maschera attributi video board
MSKROW2:
	.DB	$00, $80, $20, $40	

;--------------------------------------------------------------------

; funzioni sequenze di escape: SCN_ESC, SCN_COL, SCN_BKGCOL, SCN_PRTSCN
SCNESCSEQ:
	.DW	ScnProcEsc,	ScnProcCol,	ScnProcBkgCol,	ScnProcPrnt
	
; funzioni codici di controllo $01..$12
CTRLVCTRS:
	.DW	CsrUp,		CsrRight,	CsrDown,	CsrLeft 
	.DW	ScnHome,	ScnEnd, 	BellSnd, 	KeyBack
	.DW	CsrTab, 	LineFeed, 	CsrShTab,	ScnClr  
	.DW	ScnOutCR,	KeybInsert,	KeyDel,		ScnOutCR 
	.DW	HistUp,		HistDown
	
	;.DW	FixedCurs, FlashCurs, , 
	;.DW	, BellSnd

; tabella comandi dopo tasto ESCAPE (@..Z)
ESCVCTRS:
	DW	WndEscAt, 	FlashCurs, 	WndEscB, 	FixedCurs
	DW	WndEscD, 	_RTS0,		 _RTS0, 	TabToggle
	DW	_RTS0, 		WndEscI, 	WndEscJ, 	WndEscK
	DW	_RTS0, 		_RTS0, 		_RTS0, 		WndEscO
	DW	WndEscP, 	WndEscQ, 	_RTS0,		_RTS0
	DW	WndEscT, 	_RTS0, 		WndEscV, 	WndEscW
	DW	SetMaxWnd, 	SetDefTabs, 	ClearTabs

;--------------------------------------------------------------------
; tabella conversione da codice tasto a codice schermo ($82..$90)

KBCONV:
	.DB	SCN_PRTSCN
	.DB	SCN_CSRUP,	SCN_HOME,	SCN_INSERT,	SCN_CSRRIGHT
	.DB	SCN_PGUP,	SCN_SHTAB,	SCN_PGDOWN,	SCN_CSRDOWN
	.DB	SCN_END,	SCN_SHCR,	SCN_DELETE,	SCN_CSRLEFT
	.DB	SCN_BS
	

;----------------------------------------------------------------------------
; Costanti inizializzazione registri VDC
;----------------------------------------------------------------------------

; DOT CLOCK 16MHZ - FH = 16KHz FV = 50HZ (FH +, FV +)
VDCREG16:
		.BYTE	$00, $7f, $01, $50, $02, $66, $03, $44 ; invece di 49
		.BYTE	$04, $26, $05, $00, $06, $19, $07, $20
		.BYTE	$08, $00, $09, $07, $0A, $20, $0B, $07
		.BYTE	$0C, $40, $0D, $00, $0E, $00, $0F, $00
		.BYTE	$14, $48, $15, $00, $17, $08, $18, $20
		.BYTE	$19, $47, $1A, $F0, $1B, $00, $1C, $10
		.BYTE	$1D, $07, $22, $7D, $23, $64, $24, $05,
		.BYTE	$16, $78, $FF
