;;
;; Copyright (c) 2015 Marco Granati <mg@unet.bz>
;;
;; Permission to use, copy, modify, and distribute this software for any
;; purpose with or without fee is hereby granted, provided that the above
;; copyright notice and this permission notice appear in all copies.
;;
;; THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
;; WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
;; MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
;; ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
;; WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
;; ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
;; OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
;;
;; File: fdir.asm

;----------------------------------------------------------
; FAT.ASM
; PROGETTO: B1601
;
; Gestione FAT file system
;----------------------------------------------------------


_ATA_INC_	.SET	1
_FSYS_INC_	.SET	1

	.INCLUDE inc\global.inc
	;.INCLUDE inc\sys_fs2.inc

.LIST on

	.CODEF9
	;.GLOBAL _chkfat
	;.EXTERN _ATARead
	
	.LONGA	off
	.LONGI	off


LSTDRIVE .EQU	$05
MFATPATH .EQU	77

	.GLOBAL _truenam
_truenam:
	;phd
	;phb
	;pea	#DP05ADDR
	;pld
	sta	LPtr1
	xba
	sta	LPtr1+1
	stx	LPtr1+2
	sty	fexpfg
	;tya
	;and	#$7F
	;sta	FDefDrv
	
	ldx	#0
	txy
?1000:	lda	[LPtr1],y
	sta	$200000,x
	cmp	#0
	beq	?1001
	inx
	iny
	bne	?1000
?1001:	lda	#$00
	xba
	lda	#$00
	ldx	#$20
	
	;jsr	_ftrim
	sta	LPtr1
	xba
	sta	LPtr1+1
	stx	LPtr1+2
	jsr	?02
	;jsr	_frest
	ldx	FDirIdx
	inx
	stz	fpaths,x
	bcs	?1002
	bit	devfg
	bmi	?1002
	ldx	lstidx
	dex
	stx	FEndDir
	beq	?1002
	dex
	bit	fexpfg			; check the directory length
	bmi	?1001a			; if file name request
	ldx	FDirIdx
?1001a:	cpx	#$40
	bcc	?1002
	lda	#EINVPATH
?1002:	;tay
	;ldx	#$00
	;lda	#$05
	;xba
	;lda	#FPathStr
	;plb
	;pld
	rts

?02:
	stz	haswild
	stz	devfg
	lda	fdefdrv
	clc
	adc	#'A'
	sta	FPathStr
	lda	#':'
	sta	FPathStr+1
	stz	fpaths
	lda	#$FF
	sta	FDirIdx			; empty string
	lda	[LPtr1]			; first char
	beq	?14			; null string -> error
	xba				; B = first char
	ldy	#1
	lda	[LPtr1],y		; 2nd char
	cmp	#':'			; check 'X:' at starting string
	bne	?10			; no drive specified - use default 
	xba				; A = drive letter
	cmp	#'a'
	bcc	?04
	cmp	#'z'+1
	bcs	?08			; invalid drive
	and	#$DF			; up case letter drive
?04:	sbc	#'A'-1			; here always CF = 0
	bcc	?06			; invalid drive number
	cmp	#LSTDRIVE+1		; drive number <= LAST DRIVE ?
	bcs	?08			; invalid drive
	iny				; bump pointer (3nd char, Y = 2)
	bcc	?12			; store drive number
?06:	sec				; error flag
?08:	lda	#ENODEV			; invalid drive error
	rts
?10:	lda	fdefdrv			; use default drive
	clc
	dey				; pointer = 0
?12:	sta	fdrive			; store drive number
	adc	#'A'
	sta	FPathStr
	lda	[LPtr1],y		; first or 3nd char (Y = 0 or Y = 2)
	bne	?16			; can't be NULL
?14:	lda	#EINVPATH		; invalid path format
	sec
	rts
?16:	cmp	#'/'			; string start with root dir. ?
	beq	?18			; absolute path
	cmp	#'\'
	bne	?20			; relative path
?18:	iny				; pointer to char after '/' Y=3 or 1
	lda	[LPtr1],y		; skip consecutive '/' or '\'
	cmp	#'/'
	beq	?18
	cmp	#'\'
	beq	?18
	ldx	#0			; index of fpaths
	beq	?22			; store '/'
	
?20:	; copy in fpaths the current directory of the drive fdrive
	jsr	?250
	
; if src start with "path"	Y= 0
; if src start with "/path"	Y= 1
; if src start with "X:path" 	Y= 2
; if src start with "X:/path" 	Y= 3
?22:	clc
	CPU16				; adjust pointer
	tya				; Y can be 0,1,2 or 3
	adc	LPtr1			; now LPtr1 point to first char
	sta	LPtr1			; of the path
	CPU08
	bcc	?24
	inc	LPtr1+2
?24:	lda	#'/'			; the last '/' of path 
	sta	fpaths,x
	stx	FDirIdx			; current index
	lda	[LPtr1]
	bne	?25			; not only root directory in source
	bit	fexpfg			; filename ?
	bmi	?14			; yes -- error
	clc				; root directory ending scan
	rts
	
?25:	; now search the last subcomponent - search last '/' or last '\'
	ldy	#0			; scan string from beginning
	tyx				; sub-component lenght
?26:	lda	[LPtr1],y
	beq	?28			; end string
	iny
	bne	?26			; loop -- find end of string
	beq	?14			; error -- string too long 
?28:	inx	
	dey				; scan source for '/' or '\'
	bmi	?30			; reached string beginning
	lda	[LPtr1],y
	cmp	#'/'
	beq	?30
	cmp	#'\'
	bne	?28			; scan source string
?30:	dex				; last sub-component lenght
	beq	?14			; string ending with '/' - error
	sty	lstidx			; pointer to last '/'
	iny
	beq	?60			; exist last sub-component only
	
	; sub-components scan - Y point always at first char after '/'
	ldy	#0			; start with source string begin
?40:	cpy	lstidx
	bcs	?58			; end (remain last sub-component)
	lda	[LPtr1],y		; skip consecutive '/'
	iny
	cmp	#'/'
	beq	?40
	cmp	#'\'
	beq	?40
?44:	cmp	#'.'			; check './'
	bne	?50			; parse sub-component
	lda	[LPtr1],y		; next char
	iny
	cmp	#'/'
	beq	?40			; skip './' entry
	cmp	#'\'
	beq	?40
	cmp	#'.'			; check '../' entry
	bne	?46			; malformed path
	lda	[LPtr1],y		; next char	
	iny
	cmp	#'/'
	beq	?48			; handle '../' entry
	cmp	#'\'
	beq	?48			; handle '../' entry
?46:	jmp	?14			; error - malformed path
?48:	jsr	?200			; handle '../'entry
	bra	?40
?50:	stz	wildfg			; no wildcards allowed
	dey				; point to first char of the sub-comp
	jsr	?100			; parse sub-component
	bra	?40			; next su-component
?58:	ldy	lstidx			; this point to last '/'
	iny				; point to first char after '/'
?60:	lda	#$80
	sta	wildfg
	ldx	FDirIdx
	inx
	stx	lstidx			; point to last sub-component
	jsr	?220			; parse last sub-component
	clc
	rts

	; terminate sub-component with '/'
?90:	lda	#'/'			; store '/'
?92:	stz	storfg			; don't store in tmpfcb	
	jsr	?130			; store char A
?94:	jsr	?360			; check device name
	clc				; no error 	
	rts
		
?100:	; parse sub-component - Y point to first char of the sub-component
	lda	#$80
	sta	storfg			; store name part in tmpfcb
	stz	dotfg			; dot flag
	stz	cntx			; tmpfcb current index
	lda	#' '			; fill an empty tmpfcb
	ldx	#7
?101:	sta	tmpfcb,x
	dex
	bpl	?101
	lda	#8			; max. name lenght
?102:	sta	maxcnt			; max lenght name/ext
	stz	cnt			; chars counter
?104:	lda	[LPtr1],y		; scan string
	beq	?94			; end string
	iny
	cmp	#'/'
	beq	?92			; end sub-component
	cmp	#'\'
	beq	?90			; end sub-component
	cmp	#'.'
	bne	?106			; no dot char
	bit	dotfg			; bit 7 mean dot already scanned
	bpl	?105			; ok -- first dot
	jmp	?125			; multiple dot - error
?105:	ldx	#$80
	stx	dotfg			; signal dot already scanned
	stz	storfg			; don't store extension in tmpfcb
	ldx	cnt			; sub-component cannot start with dot
	beq	?125			; start with dot - error\
	tax
	lda	[LPtr1],y		; check char after dot
	beq	?94			; ignore trailing dot
	iny
	cmp	#'/'
	beq	?92			; end sub-component
	cmp	#'\'
	beq	?90			; end sub-component
	dey
	txa
	jsr	?130			; store dot
	lda	#3			; max. ext lenght
	bra	?102			; scan ext
?106:	bit	wildfg			; after a '*' expect the '.' or
	bvs	?125			; '/' or '\' or NULL
	cmp	#'?'
	bne	?108
	bit	wildfg			; bit 7 mean '?' allowed
	bpl	?125			; wildcards not allowed - error
	ldx	#$80
	stx	haswild			; flag path contain wild chars
	bra	?117			; store '?'
?108:	cmp	#'*'
	bne	?116
	bit	wildfg
	bpl	?125			; wildcards not allowed
	ldx	#$80
	stx	haswild			; flag path contain wild chars
	sec
	lda	maxcnt
	sbc	cnt			; how much char ?
	bcc	?125			; error
	beq	?104
	sta	cnt1
	lda	#'?'			; convert in right numbers of '?'
?114:	jsr	?130
	dec	cnt1
	bne	?114
	jsr	?350			; ignore all after '*'
	bra	?104			; loop
?116:	cmp	#$7F			; only standard ASCII
	bcs	?126
	cmp	#' '
	bcc	?125
?117:	ldx	cnt			; test max. 8 chars for fname
	cpx	maxcnt			; 3 chars for ext
	bcs	?126			; fname or ext too long - error
	inx				; update counter
	stx	cnt
	ldx	#NDCHCNT		; ready to store char in fpaths
?118:	cmp	>NDIRCHRS,x		; test for illegals chars
	beq	?125			; illegal char - error
	dex
	bpl	?118
	cmp	#'a'			; up case char
	bcc	?120
	cmp	#'z'+1
	bcs	?120
	and	#$DF			; up-case
?120:	jsr	?130			; store
	jmp	?104			; loop
?125:	sec				; error
?126:	pla				; skip return
	pla
	lda	#EINVPATH
	rts

?130:	; store char in fpaths and update index
	; store the name part only in tmpfcb for check device name
	; full path 79 chars max - subctract 2 bytes for drive letter -> 77
	bit	storfg
	bpl	?132			; not store char in tmpfcb
	ldx	cntx			; index
	cpx	#8			; max. 8 chars
	bcs	?132
	sta	tmpfcb,x		; store
	inx
	stx	cntx
?132:	ldx	FDirIdx
	inx				; update index
	cpx	#MFATPATH		; check index range (0..76)
	bcs	?134			; no room to store - error
	stx	FDirIdx			; here CF = 0
	sta	fpaths,x		; store char
	rts				; CF = 0
?134:	pla				; here CF = 1
	pla				; skip return
	bra	?126
	
?200:	; handle '../' entry
	ldx	FDirIdx			; current index
	beq	?125			; already in root - error
	dex
?202:	lda	fpaths,x
	cmp	#'/'
	beq	?204
	dex
	bne	?202
?204:	;txa
	;beq	?125
	;dex
	stx	FDirIdx
?206:	rts
 
?220:	; parse the last sub-component -- Y = actual pointer to source
	lda	[LPtr1],y		; check first char
	cmp	#'.'			; begin with '.' ?
	bne	?240			; no -- parse
	bit	fexpfg			; is a file name ?
	bmi	?125			; yes -- error
	iny
	ldx	FDirIdx			; actual pointer to path
	lda	[LPtr1],y		; check 2nd char
	bne	?222			; not a '.' entry
	txa
	beq	?206			; root directory -- ok
	stz	cnt			; mean to handle '.' entry
	bra	?224
?222:	cmp	#'.'			; '..' entry ?
	bne	?125			; no -- error
	iny
	lda	[LPtr1],y		; check 3nd char
	bne	?125			; will be 0 -- error
	txa
	beq	?125			; already in root -- error
	lda	#$80
	sta	cnt			; mean to handle '..' entry
?224:	dex				; for now the end of path
	stx	FDirIdx			; pointer to last char of path
	inx
?226:	dex				; find previous sub-component
	lda	fpaths,x
	cmp	#'/'
	bne	?226
	txy
	inx
	stx	lstidx			; this become the last sub-component
	bit	cnt			; handle '.' entry ?
	bpl	?230			; yes -- end parse
	tyx
	beq	?229			; root directory
	dey				; before the final '/'
?228:	dex				; find previous sub-component
	lda	fpaths,x
	cmp	#'/'
	bne	?228
	inx
	stx	lstidx			; this become the last sub-component
?229:	sty	FDirIdx			; pointer to last path char
?230:	rts		
?240:	jmp	?100			; parse normal
	
?250:	; copy in fpaths the current directory of the drive fdrive
	tya				; save Y in B (Y = 0 or Y = 2)
	xba
	ldx	fdrive
	lda	>CDPTRL,x		; pointer of the current directory
	sta	LPtr2
	lda	>CDPTRH,x
	sta	LPtr2+1
	lda	#^DEFDIR0
	sta	LPtr2+2
	ldy	CDLen,x			; Y = len - 1
	tyx				; X = index fpaths
	beq	?254			; root directory
	inx				; index next char
?252:	lda	[LPtr2],y		; copy directory
	sta	FSWP0+fpaths,y
	dey
	bpl	?252
?254:	xba				; restore Y
	tay
	rts

?350:	; search final '/', or '\', or end of string, or '.'
	lda	[LPtr1],y
	beq	?352
	cmp	#'/'
	beq	?352
	cmp	#'\'
	beq	?352
	cmp	#'.'
	beq	?352
	iny
	bra	?350
?352:	rts

?360:	; check if file name = device name (ignore extension)
	ACC16
	lda	#DEVSTR			; pointer to device name array
	sta	LPtr3
	ACC08
	lda	#^DEVSTR
	sta	LPtr3+2
	stz	devidx			; device name index
	phy				; save Y
?362:	ldx	#7			; device name 8 chars
	txy
?364:	lda	tmpfcb,x		; compare tmpfcb with device name
	cmp	[LPtr3],y
	bne	?370			; unmatch
	dex
	dey
	bpl	?364			; loop
	inx
	iny				; copy device name in path
	lda	#'/'
	sta	fpaths
	inx
?366:	lda	[LPtr3],y
	cmp	#' '			; first blank terminate string
	beq	?368
	sta	fpaths,x
	inx
	iny
	cpy	#8
	bcc	?366			; loop 8 chars
?368:	dex				; update index
	stx	FDirIdx
	ply				; recover Y
	pla				; skip 2 return address
	pla
	pla
	pla
	lda	#$80
	sta	devfg			; set device name flag
	clc
	rts				; terminate parsing and exit
?370:	lda	#8			; update array pointer
	clc
	adc	LPtr3
	sta	LPtr3
	bcc	?372
	inc	LPtr3+1
?372:	inc	devidx			; update device name array index
	lda	[LPtr3]
	bne	?362			; loop next device name
	ply				; recover Y
	rts

	
CDPTRL:
	.DB	<DEFDIR0, <DEFDIR1, <DEFDIR2, <DEFDIR3
	
CDPTRH:
	.DB	>DEFDIR0, >DEFDIR1, >DEFDIR2, >DEFDIR3

NDIRCHRS:
	.DB	'"[]:|<>+=;, '
NDCHCNT .EQU	$ - NDIRCHRS - 1

DEVSTR:
	.DB	'KEYBD$  '	; Keyboard
	.DB	'SCREEN$ '	; Display
	.DB	'CON     '	; Keyboard and display
	.DB	'PRN     '	; System list device, usually a parallel port
	.DB	'LST     '	; System list device, usually a parallel port
	.DB	'LPT1    '	; First parallel printer port
	.DB	'LPT2    '	; Second parallel printer port
	.DB	'LPT3    '	; Third parallel printer port
	.DB	'AUX     '	; Auxiliary device, usually a serial port
	.DB	'COM1    '	; First serial communications port
	.DB	'COM2    '	; Second serial communications port
	.DB	'COM3    '	; Third serial communications port
	.DB	'COM4    '	; Fourth serial communications port
	.DB	'NUL     '	; Bit-bucket device
	.DB	'$IDLE$  '	; Bit-bucket device
	.DB	'CLOCK$  '	; System real-time clock
	.DB	'CLOCK   '	; System real-time clock
	.DB	'CONFIG$ '
	.DB	'CONSOLE$'
	.DB	0

; --- TEST ---
	.GLOBAL dummydir
dummydir:
	phd
	pea	#FSWP0
	pld
	ldx	#0
	stx	fdefdrv
?01:	lda	>TEST1,x
	beq	?02
	sta	>DEFDIR0,x
	inx
	bne	?01
?02:	dex	
	stx	CDLen
	ldx	#0
?03:	lda	>TEST2,x
	beq	?04
	sta	>DEFDIR1,x
	inx
	bne	?03
?04:	dex	
	stx	CDLen+1
	ldx	#0
?05:	lda	>TEST3,x
	beq	?06
	sta	>DEFDIR2,x
	inx
	bne	?05
?06:	dex	
	stx	CDLen+2
	ldx	#0
?07:	lda	>TEST4,x
	beq	?08
	sta	>DEFDIR3,x
	inx
	bne	?07
?08:	dex	
	stx	CDLen+3
	ldx	#0
	pld
	rtl
	
TEST1:
	.DB	'/', 0
TEST2:
	.DB	'/PATH1/PATH2', 0
TEST3:
	.DB	'/PATH1', 0
TEST4:
	.DB	'/PATH1/PATH2/PATH3', 0
TEST5:
	.DB	'/PATH1/PATH2/PATH3/PATH4', 0
TEST6:
	.DB	'/PATH1/PATH2/PATH3/PATH4/PATH5', 0

