;----------------------------------------------------------
; SYSF9.ASM
; PROGETTO: B1601
;
; System Functions bank $F9
;----------------------------------------------------------

_ATA_INC_	.SET	1
;;_FAT_INC_	.SET	1
_FSYS_INC_	.SET	1


	.INCLUDE inc\global.inc
	.INCLUDE inc\dirp00.inc

	.CODEF9
	.GLOBAL COP_truenam
	.EXTERN _truenam
	
	.LONGA	off
	.LONGI	off

STKCNT		.SET	$04
STKYR		.SET	$09
STKXR		.SET	$0B
STKCR		.SET	$0D
STKSR		.SET	$0F
STKPCL		.SET	$10
STKPBR		.SET	$12
STKPRMS		.SET	$13

; COP_setbrk	set break level of a process
;
;	in:	C  = pages number to increase or decrease
;		     if C = 0 return current break level
;		CF = 0 -> increase pages, 1 -> decrease pages
;	out:	C  = previous break level if no error (CF = 0)
;		C  = maximum available pages or max. pages to decrease

COP_setbrk:
	
	.GLOBAL COP_setbrk

	ldy	#ENOMEM			; error code (if any)
	CPU16
	ldx	pbrklv			; current break level
	lda	STKCR,s
	beq	?10			; return current break level
	bcs	?04			; decrease brk level
	adc	pbrklv			; increase # pages
	bcs	?02			; error
	cmp	pbrkmax			; compare with max
	beq	?08			; ok, at max. limit
	bcc	?08			; ok
?02:	lda	pbrkmax			; return error code Y (CF = 1)
	sbc	pbrklv			; return max availables pages
	bra	?14
?04:	txa				; # pages
	sbc	STKCR,s			; decrease
	bcc	?12			; error
	cmp	pbrkmin
	bcc	?12			; error
?08:	sta	pbrklv			; set new break level
?10:	clc				; ok, no error
	txa				; previous (or current) break level...
	bra	?14			; ...return to caller
?12:	txa				; current break level
	sec
	sbc	pbrkmin			; max. deallocable pages
	iny				; error code: EINVMEM
?14:	sta	STKCR,s			; return C to caller
	CPU08
	tya				; error code, if any
	rtl
		
;==========================================================

COP_truenam:

FileFlag	.SET	STKPRMS
DestStr		.SET	FileFlag + 1
SrcStr		.SET	DestStr + 3

	lda	FileFlag,s	; File Flag
	tay			; Y = FileFlag
	lda	SrcStr+2,s	; bank of SrcStr
	tax			; X = bank of SrcStr
	ACC16			; A/M -> 16 bit
	lda	#FSWP0		; DPR = $0500
	tcd			; set new DP
	lda	SrcStr,s	; address of SrcStr
	ACC08
	jsr	_truenam	; call local function
	xba			; B = error if one
	;bcc	?02		; ok - no error
	;sta	STKYR,s		; return error in Y
	;lda	#0
	;sta	STKYR+1,s
	;lda	STKSR,s		; saved P in stack
	;ora 	#PCFLAG		; set carry in saved P
	;sta	STKSR,s
?02:	lda	DestStr,s	; set dest. string pointer
	sta	LPtr1
	lda	DestStr+1,s
	sta	LPtr1+1
	lda	DestStr+2,s
	sta	LPtr1+2
	ldx	#0
	txy
?04:	lda	FPathStr,x
	sta	[LPtr1],y
	beq	?06
	inx
	iny
	bne	?04
?06:	xba			; A = error if one	
	rtl
	
