

_CBM_INC_	.EQU	1

	.INCLUDE inc\global.inc
	;.INCLUDE inc\dirp01.inc
	.INCLUDE inc\dpcbm.inc

TTNUMSTR	.EQU	MNUMSTR

	.CODEFE
	.LONGA off
	.LONGI off

	.EXTERN cbm_chrget, cbm_chrgot, cbm_err, vpmerr
	.GLOBAL XBBD4, XBBA2, XBC5B, XBA8C, XBB12, XBA2B, XB853, XB86A
	.GLOBAL XBAFE, XBAE2, XBCF3P, XBCF3, XBBA2T,XBDDD, XE26B, XE264
	.GLOBAL XE2B4, XE30E, XBFED, XBF7B, XBF71, XB9EA, XBC49, XBB0F
	.GLOBAL XB9BC, XBBC7, XBBA2T, XB9E0, FCON05, XB867, FCON10
	.GLOBAL XBBA2L, XBA8CK, XBBA2K, XLN10, XBC0C, XB9BC, XBA28
	
;---------------------------------------------------------------------------
; move FAC #2 routines
;---------------------------------------------------------------------------

; move float number at address AY to FAC #2
; address is in current data bank
XBA8C:
	sta	<longp
	sty	<longp+1
	ldy	#4
	lda	(longp),y
	sta	<argm+3
	dey
	lda	(longp),y
	sta	<argm+2
	dey
	lda	(longp),y
	sta	<argm+1
        dey
        lda	(longp),y
        sta	<argsgn
        eor	<facsgn
        sta	<arisgn
        lda	<argsgn
        ora	#$80
        sta	<argm
        dey
        lda	(longp),y
        sta	<argexp
        lda	<facexp
        rts

; move float number at address AY in current program bank to FAC #2
XBA8CK:
	sta	longp
	sty	longp+1
	ldx	#^XBA8CK
	bra	XBA8CK2

; move float number at address AYX to FAC #2
XBA8CL:
	sta	<longp
	sty	<longp+1

XBA8CK2:	
	stx	<longp+2
	ldy	#4
	lda	[longp],y
	sta	<argm+3
	dey
	lda	[longp],y
	sta	<argm+2
	dey
	lda	[longp],y
	sta	<argm+1
        dey
        lda	[longp],y
        sta	<argsgn
        eor	<facsgn
        sta	<arisgn
        lda	<argsgn
        ora	#$80
        sta	<argm
        dey
        lda	[longp],y
        sta	<argexp
        lda	<facexp
XB848:
        rts

;---------------------------------------------------------------------------
; subctraction implementation
;---------------------------------------------------------------------------

XB849:	; compute FAC #1 + 0.5
	lda	#<FCON05
	ldy	#>FCON05
	bra	XB867		; add costant stored in current program bank 
	
XB850:	; compute [float at address AYK] - FAC #1
	jsr	XBA8CK		; move float at AYK address to FAC #2

XB853:	; compute FAC #2 - FAC #1
	lda	<facsgn
	eor	#$FF
	sta	<facsgn
	eor	<argsgn
	sta	<arisgn
	lda	<facexp
	bra	XB86A

;---------------------------------------------------------------------------
; addition implementation
;---------------------------------------------------------------------------

XB862:
	jsr	XB999		; shift right mantissa
	bcc	XB8A3		; always return CF = 0

; add float at address AYK to FAC #1
XB867:
	jsr	XBA8CK		; move float in mem. to FAC #2

; add FAC #1 to FAC #2 - in input A = FAC #1 exponent	
XB86A:
	bne	?02
	jmp	XBBFC		; move FAC #2 to FAC #1
?02:
	ldx	<facbits
	stx	<argbits
	ldx	#argexp
	lda	<argexp
XB877:
	tay
	beq	XB848		; exit (FAC #2 = 0)
	sec
	sbc	<facexp
	beq	XB8A3		; same exponent
	bcc	?02
	sty	<facexp
	ldy	<argsgn
	sty	<facsgn
	eor	#$FF
	adc	#$00
	ldy	#$00
	sty	<argbits
	ldx	#facexp
	bne	?04
?02:	ldy	#$00
	sty	<facbits
?04:	cmp	#$F9
	bmi	XB862
	tay
	lda	<facbits
	lsr	<$01,x
	jsr	XB9B0
XB8A3:
	bit	<arisgn
	bpl	XB8FE		; add mantissa
	ldy	#facexp
	cpx	#argexp
	beq	?02
	ldy	#argexp
?02:	sec
	eor	#$FF
	adc	<argbits
	sta	<facbits
	phb			; save data bank
	lda	#0		; set data bank = 0
	pha			; need this because don't exist DP,y 
	plb
	lda	!CBMP0+$04,y
	sbc	<$04,x
	sta	<facm+3
	lda	!CBMP0+$03,y
	sbc	<$03,x
	sta	<facm+2
	lda	!CBMP0+$02,y
	sbc	<$02,x
	sta	<facm+1
	lda	!CBMP0+$01,y
	sbc	<$01,x
	sta	<facm
	plb			; restore data bank

XB8D2:
	bcs	XB8D7
	jsr	XB947
	
XB8D7:
	ldy	#$00
	tya
	clc
?02:	ldx	<facm
        bne	XB929
	ldx	<facm+1
	stx	<facm
	ldx	<facm+2
	stx	<facm+1
	ldx	<facm+3
	stx	<facm+2
	ldx	<facbits
	stx	<facm+3
	sty	<facbits
	adc	#$08
	cmp	#$20
	bne	?02

XB8F7:	; clear FAC #1
        lda     #$00
XB8F9:	; set FAC #1 exponent
	sta	<facexp
XB8FB:	; set FAC #1 sign
	sta	<facsgn
	rts

XB8FE:	; add mantissa of FAC #2 to mantissa of FAC #1
	adc	<argbits
	sta	<facbits
	lda	<facm+3
	adc	<argm+3
	sta	<facm+3
	lda	<facm+2
	adc	<argm+2
	sta	<facm+2
	lda	<facm+1
	adc	<argm+1
	sta	<facm+1
	lda	<facm
	adc	<argm
	sta	<facm
	bra	XB936		; normalize

XB91D:	; shift left mantissa bit by bit
	adc	#$01
	asl	<facbits
	rol	<facm+3
	rol	<facm+2
	rol	<facm+1
	rol	<facm

XB929:	; shift left mantissa if need -- A = exponent
	bpl	XB91D
	sec
	sbc	<facexp
	bcs	XB8F7		; underflow -> clear FAC #1
	eor	#$FF		; 2's complement
	adc	#$01
	sta	facexp

XB936:	; normalize FAC #1 if carry
	bcc	XB946		; no carry: exit

XB938:	; increment FAC #1 exponent
	inc	<facexp
	beq	XB97E		;OVERFLOW
	ror	<facm
	ror	<facm+1
	ror	<facm+2
	ror	<facm+3
	ror	<facbits
XB946:	rts

XB947:	; FAC #1 2's complement
	lda	<facsgn
	eor	#$FF
	sta	<facsgn

XB94D:	; mantissa 2's complement
	lda	<facm
	eor	#$FF
	sta	<facm
	lda	<facm+1
	eor	#$FF
	sta	<facm+1
	lda	<facm+2
	eor	#$FF
	sta	<facm+2
	lda	<facm+3
	eor	#$FF
	sta	<facm+3
	lda	<facbits
	eor	#$FF
	sta	<facbits
	inc	<facbits
	bne	XB97D		; exit

XB96F:	; increment mantissa
	inc	<facm+3
	bne	XB97D		; exit
	inc	<facm+2
	bne	XB97D		; exit
	inc	<facm+1
	bne	XB97D		; exit
	inc	<facm
XB97D:	rts

XB97E:	; overflow error
	bit	<basic
	bmi	?10
	ldx	<runf
	beq	?10
	lda	<s2fptr		; error from conversion routine ?
	bpl	?08		; no - handle runtime error
	sta	<s2fer		; setup conversion error flag
	ldy	#$00
	INDEX16
	ldx	<s2fstk		; recover stack pointer
	txs
	lda	<vbnk		; setup right data bank
	pha
	plb
	dey
	sty	FAC1TMP
	sty	FAC1TMP+2
	INDEX08
	sty	FAC1TMP+4
	rts
?08:	ldx	#$09		; pascal: floating point overflow
	jmp	vpmerr	
?10:	ldx	#$0F		; overflow
	jmp	cbm_err

XB983:	; shift right temp. mantissa by 8 bits 
	ldx	#factmp-1

XB985:	; shift right 8 bits mantissa pointed by X
	; A = negative of shift count * 8
	ldy	<$04,x
	sty	<facbits
	ldy	<$03,x
	sty	<$04,x
	ldy	<$02,x
	sty	<$03,x
	ldy	<$01,x
	sty	<$02,x
	ldy	facov
	sty	<$01,x

XB999:	; shift right mantissa
	adc	#$08
	bmi	XB985		; shift 8 bits
	beq	XB985		; shift 8 bits
	sbc	#$08
	tay			; Y = number of negative right shift
	lda	<facbits
	bcs	XB9BA		; no shift

XB9A6:
	asl	<$01,x
	bcc	?02
	inc	<$01,x
?02:	ror	<$01,x
        ror	<$01,x

XB9B0:
	ror	<$02,x
	ror	<$03,x
	ror	<$04,x
	ror	a
	iny
	bne	XB9A6
XB9BA:
	clc
	rts

;---------------------------------------------------------------------------
; LN() implementation
;---------------------------------------------------------------------------

; compute LN(FAC #1)
XB9EA:
	jsr	XBC2B		; check if FAC #1 is zero or negative
	beq	?02		; error
        bpl	XB9F4
?02:	bit	<basic
	bmi	?04
	ldx	<runf
	beq	?04
	ldx	#$0C		; pascal error: complex log or square root
	jmp	vpmerr	
?04:	LDX	#$0E		; error: illegal quantity
	JMP	cbm_err
XB9F4:
	lda	<facexp		; here always CF = 0
	sbc	#$7F		; depolarize
	pha
	lda	#$80		; reduce FAC #1
	sta	<facexp
	lda	#<XB9D6		; 0.5 * SQRT(2)
	ldy	#>XB9D6
	jsr	XB867		; add to FAC #1
	lda	#<XB9DB		; SQRT(2)
	ldy	#>XB9DB
	ldx	#^XB9F4		; current program bank
	jsr	XBB0F		; divide by SQRT(2)
	lda	#<XB9BC		; 1.0
	ldy	#>XB9BC
	jsr	XB850		; compute 1.0 - [FAC #1]
	lda	#<XB9C1		; polynomial table
	ldy	#>XB9C1
	jsr	XE043		; compute polynomial
	lda     #<XB9E0
	ldy     #>XB9E0
	jsr	XB867		; add -0.5 to FAC #1
	pla
	jsr	XBD7E		; add exponent to FAC #1
	lda	#<XB9E5		; LN(2)
	ldy	#>XB9E5
	ldx	#^XB9F4		; current program bank
				; mult LN(2)
	
;---------------------------------------------------------------------------
; multiplication implementation
;---------------------------------------------------------------------------

; compute [float at address AYX] * [FAC #1]
XBA28:
	jsr	XBA8CL		; move float from long address to FAC #2

; compute [FAC #2] * [FAC #1]
XBA2B:	; A = FAC #1 exponent
	beq	XBA8B		; exit if FAC #1 = 0
	jsr	XBAB7		; add the 2 exponents
	stz	<factmp		; clear temp. mantissa
	stz	<factmp+1
	stz	<factmp+2
	stz	<factmp+3
	lda	<facbits		; mult. byte by byte
	jsr	XBA59
        lda	<facm+3
	jsr	XBA59
	lda	<facm+2
	jsr	XBA59
	lda	<facm+1
	jsr	XBA59
	lda	<facm
	jsr	XBA5E
	jmp	XBB8F		; copy temp. mantissa to FAC #1

XBA59:	; mult byte A with FAC #2 mantissa and put result in temp. mantissa LA07B
	bne	XBA5E
	jmp	XB983		; shift right temp. mantissa	
XBA5E:
	lsr	a
	ora	#$80
?02:	tay
	bcc	?04
	clc
	lda	<factmp+3
	adc	<argm+3
	sta	<factmp+3
	lda	<factmp+2
	adc	<argm+2
	sta	<factmp+2
 	lda	<factmp+1
 	adc	<argm+1
 	sta	<factmp+1
	lda	<factmp
	adc	<argm
	sta	<factmp
?04:	ror	<factmp
	ror	<factmp+1
	ror	<factmp+2
	ror	<factmp+3
	ror	<facbits
	tya
	lsr	a
	bne	?02
XBA8B:	rts

XBAB7:	; add exponents
	lda	<argexp

XBAB9:
	beq	XBADA		; clear FAC #1 and exit
	clc
	adc	<facexp
	bcc	?02
	bmi	XBADF
	clc
	bra	?04
?02:	bpl     XBADA
?04:	adc	#$80
	sta	<facexp
	bne	?06
        jmp	XB8FB
?06:	lda	<arisgn
	sta	<facsgn
	rts

XBAD4:
	lda	<facsgn
	eor	#$FF
	bmi	XBADF
XBADA:	; skip return address and clear FAC #1
	pla
	pla
	jmp	XB8F7
	
XBADF:	; overflow
	jmp	XB97E

XBAE2:	; compute (FAC #1) * 10
	jsr	XBC0C		; round FAC #1 and move it to FAC #2
	tax
	beq	XBAF8
	clc
	adc	#$02		; mult * 4
	bcs	XBADF		; overflow
XBAED:	ldx	#$00
	stx	<arisgn
	jsr	XB877		; add itself
	inc	<facexp		; mult * 2
	beq	XBADF		; overflow
XBAF8:	rts

;---------------------------------------------------------------------------
; division implementation
;---------------------------------------------------------------------------

; compute [FAC #1] / 10	
XBAFE:
	jsr	XBC0C		; round FAC #1 and move it to FAC #2
	lda	#<FCON10
	ldy	#>FCON10
	ldx	#0		; comparison sign

; compute [FAC #2] / [float at AY address (in current program bank)] 	
XBB07:
	stx	<arisgn		; X = comparison sign
	jsr	XBBA2K		; move from addr. AY (program bank) to FAC #1 
	bra	XBB12
	
; compute [float at AYX address] / [FAC #1]		
XBB0F:
	jsr	XBA8CL		; move from address AYX to FAC #2
	
; compute [FAC #2] / [FAC #1]
XBB12:	; A = FAC #1 exponent
	beq	?16		; division by zero error
	jsr	XBC1B		; round FAC #1
	lda	#$00
	sec
	sbc	<facexp		; 2's complement
	sta	<facexp
        jsr	XBAB7		; add exponents
        inc	<facexp
        beq	XBADF		; overflow
      	;ldx	#$04		; here different !
      	ldx	#$FF		; here different !        
        lda	#$01
?02:	ldy	<argm
	cpy	<facm
	bne	?04
	ldy	<argm+1
	cpy	<facm+1
	bne	?04
	ldy	<argm+2
	cpy	<facm+2
	bne	?04
	ldy	<argm+3
	cpy	<facm+3
?04:	php
	rol	a
	bcc	?06
	inx
	cpx	#$04
	bcs	?14
	;dex			; here different !
	;bmi	?14		; no store !
	sta	<factmp,x
	cpx	#$03
	beq	?12
	lda	#$01
?06:	plp
	bcs	?10
?08:	asl	<argm+3
	rol	<argm+2
	rol	<argm+1
	rol	<argm
	bcs	?04
	bmi	?02
	bpl	?04
?10:	tay
	lda	<argm+3
	sbc	<facm+3
	sta	<argm+3
	lda	<argm+2
	sbc	<facm+2
	sta	<argm+2
	lda	<argm+1
	sbc	<facm+1
	sta	<argm+1
	lda	<argm
	sbc	<facm
	sta	<argm
	tya
	bra	?08
?12:	lda	#$40
        bne	?06
?14:	asl	a
	asl	a
	asl	a
	asl	a
	asl	a
	asl	a
	sta	<facbits
	plp
	bra	XBB8F
?16:	bit	<basic
	bmi	?18
	ldx	<runf
	beq	?18
	ldx	#$12		; pascal: division by zero
	jmp	vpmerr
?18:	ldx	#$14		; division by zero
	jmp	cbm_err

XBB8F:	; copy mantissa
	lda	<factmp
	sta	<facm
	lda	<factmp+1
	sta	<facm+1
	lda	<factmp+2
	sta	<facm+2
	lda	<factmp+3
	sta	<facm+3
	jmp	XB8D7		; normalize FAC #1

;---------------------------------------------------------------------------
; move FAC #1 routines
;---------------------------------------------------------------------------

; move float number at address AY in current data bank to FAC #1
XBBA2:
	sta	<longp
	sty	<longp+1
	phb
	plx
	bra	XBBA2X
	
; move float number at address AYX to FAC #1
XBBA2L:
	sta	<longp
	sty	<longp+1
	bra	XBBA2X

; move float number at address AY in data bank that hold FAC1TMP to FAC #1
XBBA2T:
	sta	<longp
	sty	<longp+1
	ldx	<vbnk
	bra	XBBA2X

; move float number at address AY in current program bank to FAC #1
XBBA2K:
	sta	<longp
	sty	<longp+1
	ldx	#^XBBA2K
XBBA2X:	
	stx	<longp+2
	ldy	#4
	lda	[longp],y
	sta	<facm+3
	dey
	lda	[longp],y
	sta	<facm+2
	dey
	lda	[longp],y
	sta	<facm+1
        dey
        lda	[longp],y
        sta	<facsgn
 	ora	#$80
        sta	<facm
        dey
        lda	[longp],y
        sta	<facexp
        sty	<facbits
        rts

; round FAC #1 and move to FAC1TMP
XBBC7:
	ldx	#<FAC1TMP
	ldy	#>FAC1TMP
	lda	<vbnk		; bank that hold FAC1TMP/FAC2TMP
	bra	XBBD4X

; round FAC #1 and move to FAC2TMP	
XBBCA:
	ldx	#<FAC2TMP
	ldy	#>FAC2TMP
	lda	<vbnk		; bank that hold FAC1TMP/FAC2TMP
	bra	XBBD4X	

; round FAC #1 and move to FAC3TMP	
XBBX3:
	ldx	#<FAC3TMP
	ldy	#>FAC3TMP
	lda	<vbnk		; bank that hold FAC1TMP/FAC2TMP
	bra	XBBD4X	

; round FAC #1 and move to forpnt and bank that hold basic variables
XBBD0:
	ldx	<forpnt
	ldy	<forpnt+1

; round FAC #1 and move to XY addr, in data bank that hold basic variables	
XBBD4V:
	lda	<vbnk
	bra	XBBD4X	
	
; round FAC #1 and move to XY address in current data bank	
XBBD4:
	phb			; A = current data bank
	pla

XBBD4L:	
XBBD4X:
	stx	<longp
	sty	<longp+1
	sta	<longp+2
	jsr	XBC1B		; round FAC #1
	ldy	#$04
	lda	<facm+3
	sta	[longp],y
	dey
	lda	<facm+2
	sta	[longp],y
	dey
	lda	<facm+1
	sta	[longp],y
	dey
	lda	<facsgn
	ora	#$7F
	and	<facm
	sta	[longp],y
	dey
	lda	<facexp
	sta	[longp],y
	sty	<facbits
	rts

XBBFC:	; move FAC #2 to FAC #1
	lda	<argsgn
XBBFE:	; set FAC #1 sign and move abs FAC #2 to FAC #1
	sta	<facsgn
	ldx	#$05
?02:	lda	<argexp-1,x
	sta	<facexp-1,x
	dex
	bne	?02
	stx	<facbits
        rts

XBC0C:	; round FAC #1 and move it to FAC #2
	jsr	XBC1B

XBC0F:	; move FAC #1 to FAC #2 without before rounding FAC #1
	ldx	#$06
?02:	lda	<facexp-1,x
	sta	<argexp-1,x
	dex
	bne	?02
	stx	<facbits
XBC1A:	rts

XBC1B:	; round FAC #1
	lda	<facexp
	beq	XBC1A
	asl	<facbits
	bcc	XBC1A

XBC23:	; increment mantissa and normalize
	jsr	XB96F
	bne	XBC1A
	jmp	XB938

;---------------------------------------------------------------------------
; sgn/abs function's
;---------------------------------------------------------------------------

XBC2B:	; get sign of FAC #1
	lda	<facexp
	beq	XBC38
XBC2F:	lda	<facsgn
XBC31:	rol	a
	lda	#$FF
        bcs	XBC38
        lda	#$01
XBC38:	rts

XBC39:	; sign function (return a float)
	jsr	XBC2B

XBC3C:	; convert a signed byte in A to float format
	sta	<facm
	stz	<facm+1
	ldx	#$88		; exponent for a byte
XBC44:	lda	<facm
	eor	#$FF
	rol	a
XBC49:	lda	#$00		; CF = 1 positive, CF = 0 negative
	sta	<facm+3
	sta	<facm+2
XBC4F:	stx	<facexp
	sta	<facbits
	sta	<facsgn
	jmp	XB8D2		; normalize FAC #1

XBC58:	; absolute value
	stz	<facsgn
	rts

;---------------------------------------------------------------------------
; comparison function's
;---------------------------------------------------------------------------

; compare float at address AY in current data bank with FAC #1
XBC5B:
	sta	<longp
XBC5D:
	sty	<longp+1
	phb
	plx
XBC5DX:	stx	<longp+2
	ldy	#$00
	lda	[longp],y
	iny
	tax
	beq	XBC2B
	lda	[longp],y
	eor	<facsgn
	bmi	XBC2F
	cpx	<facexp
	bne	XBC92
	lda	[longp],y
	ora	#$80
	cmp	<facm
	bne	XBC92
	iny
	lda	[longp],y
	cmp	<facm+1
	bne	XBC92
	iny
	lda	[longp],y
	cmp	<facm+2
	bne	XBC92
	iny
	lda	#$7F
	cmp	<facbits
	lda	[longp],y
	sbc	<facm+3
	beq	XBCBA
XBC92:	lda	<facsgn
	bcc	XBC31
        eor	#$FF
        bra	XBC31

; compare float at address AYK with FAC #1
XBC5BK:
	sta	<longp
	sty	<longp+1
	ldx	#^XBC5BK
	bra	XBC5DX

; compare float at FAC1/2/3TMP with FAC #1
XBC5BT:
	sta	<longp
	sty	<longp+1
	ldx	<vbnk
	bra	XBC5DX
	
;---------------------------------------------------------------------------
; extraction of the integer part of FAC #1
;---------------------------------------------------------------------------

; convert float FAC #1 in 4-bytes signed integer 
XBC9B:
	lda	<facexp
	beq	XBCE9
	sec
	sbc	#$A0
	bit	<facsgn
	bpl	?02
	tax
	lda	#$FF
	sta	<facov
	jsr	XB94D
	txa
?02:	ldx	#facexp
	cmp	#$F9
	bpl	XBCBB
	jsr	XB999
	sty	<facov
	;stz	<facov
XBCBA:	rts
XBCBB:	tay
	lda	<facsgn
	and	#$80
	lsr	<facm
	ora	<facm
	sta	<facm
	jsr	XB9B0
	sty	<facov
	;stz	<facov
	rts

XBCCC:	; basic int() function
	lda	<facexp
	cmp	#$A0
	bcs	XBCF2
	jsr	XBC9B
	sty	<facbits
	lda	<facsgn
	sty	<facsgn
	eor	#$80
	rol	a
	lda	#$A0
	sta	<facexp
	lda	<facm+3
	sta	<faclsb
	jmp	XB8D2		; normalize

XBCE9:	; clear FAC #1 mantissa	
	sta	<facm
	sta	<facm+1
	sta	<facm+2
	sta	<facm+3
	tay
XBCF2:	rts

;---------------------------------------------------------------------------
; conversion decimal string to float
;---------------------------------------------------------------------------

; conversion routine in pascal mode - return float in FAC1TMP and FAC #1
XBCF3P:
	ldx	#$80		; trap overflow run time error
	stx	<s2fptr		; this avoid run time error in conversion
	jsr	XBCF3		; call conversion routine
	; here return after an overflow error too
	stz	<skpbk		; from now skip blank while scan string
	stz	<s2fptr		; re-enable overflow error
	lda	<s2fer		; if not zero error pending exit with A <> 0
	bne	XBCF2
	jmp	cbm_chrgot	; return last char scanned (must be zero)
	
; conversion routine different from the one of cbm basic
XBCF3:
	INDEX16
	tsx			; save current stack pointer
	stx	<s2fstk		; for error recover if pascal mode
	INDEX08
	ldx	#(fbufpt2-argbits)	; clear working area
?02:	stz	<argbits,x
	dex
	bpl	?02
	stz	<skpbk		; skip blank at string beginning 
	jsr	cbm_chrgot	; get first char. not blank	
	bcc	?14		; first char is digit: after don't skip blank
	cmp	#'+'		; at beginning only '+' or '-' allowed
	beq	?10		; next char (still skip blanks)
	cmp	#'-'
	bne	?36		; end conversion: exit with float = 0
	ldx	#$80
	stx	<sgnfg		; set flag minus sign
?10:	jsr	cbm_chrget	; next char after sign: expected a digit
	bcs	?35a		; error: no digit or end of string
?14:	ldx	#$80
	stx	<skpbk		; from now don't skip blank 
?16:	jsr	XBD6A		; add digit to partial FAC #1
?18:	jsr	cbm_chrget	; next char
	bcc	?16		; is a digit
	cmp	#'.'		; is decimal dot ?
	beq	?35		; set dot flag
	cmp	#'E'		; exponential form ?
	beq	?22
	cmp	#'e'
	bne	?36		; end conversion: setup float (no exponent)
?22:	jsr	cbm_chrget	; next char: expected a digit or a sign
	bcc	?32		; if digit add to partial exponent value
	cmp	#'+'
	beq	?30		; get next exponent digit
	bit	<basic
	bpl	?24		; token only in basic mode
	cmp	#$AA		; token '+' in basic mode
	beq	?30		; get next exponent digit
?24:	cmp	#'-'
	beq	?28		; set exponent sign flag
	bit	<basic
	bpl	?34		; end: setup float with exponent
	cmp	#$AB		; token '-' in basic mode
	bne	?34		; end: setup float with exponent
?28:	ror	<expsgn		; here CF = 1 so bit 7 = 1
?30:	jsr	cbm_chrget		; next exponent digit
	bcs	?34		; no digit -- end of exponent scan
?32:	jsr	XBD91		; evaluate partial exponent
	bra	?30		; next digit
?34:	bit	<expsgn		; evaluate full exponent value
	bpl	?36		; positive exponent
	lda	#0
	sec
	sbc	<expval		; negative exponent
	bra	?38
?35:	ror	<dotfg		; here CF = 1 - set dot flag
	bit	<dotfg		; check if already dot flag
	bvs	?35a		; more than one only decimal dot
	jsr	cbm_chrget	; after decimal dot expected one digit
	bcc	?16		; ok, add digit to float and continue scan
?35a:	ldx	#$80		; 2 dot or no digit after dot or after sign
	stx	<s2fer		; set conversion error
?36:	lda	<expval		; exponent value
?38:	sec			; compute true exponent
	sbc	<dccnt		; subtract decimal place number
	sta	<expval
	beq	?44		; no adjustment
	bpl	?42		; mult * 10 loop
?40:	jsr	XBAFE		; div / 10 loop
	inc	<expval
	bne	?40
	beq	?44
?42:	jsr	XBAE2		; mult * 10 loop
	dec	<expval
	bne	?42
?44:	lda	<sgnfg
	bpl	?46		; positive float
	jsr	XBFB4		; negate float
?46:	stz	<skpbk		; from now skip blank while scan string
	bit	<basic
	bmi	XBDB0		; finish here in basic mode
	jmp	XBBC7		; round FAC #1 and move to FAC1TMP	

XBD6A:	; accumulate current digit in A into FAC #1
	pha
	bit	<dotfg
	bpl	?02
	inc	<dccnt		; increment decimal digit count
?02:	jsr	XBAE2		; [FAC #1] * 10
	pla
	sec
	sbc	#$30

XBD7E:	; add a byte value to FAC #1
	pha
	jsr	XBC0C		; round FAC #1 and move to FAC #2
	pla
	jsr	XBC3C		; convert byte A in float in FAC #1
	lda	<argsgn
	eor	<facsgn
	sta	<arisgn
	ldx	<facexp
	jmp	XB86A		; add FAC #1 and FAC #2

XBD91:	; compute partial exponent
	sbc	#$2F		; here come with CF = 0
	sta	<tmpb1		; save digit
	lda	<expval		; current exponent value
	cmp	#$0A
	bcc	?02		; exponent < 10 -> can mult *10
	lda	#$64		; max. exp. = +/-100
	bit	<expsgn
	bmi	?04		; min. negative exponent = -100
	jmp	XB97E		; overflow if exponent positive
?02:	asl	a		; mult. partial exponent *10
	asl	a
	clc
	adc	<expval
	asl	a
	clc
	adc	<tmpb1		; add current digit
?04:	sta	<expval		; store exponent
XBDB0:	rts

;---------------------------------------------------------------------------
; conversion float to decimal string
;---------------------------------------------------------------------------

; final string is TTNUMSTR in variables/p-code bank
XBDDD:
	ldy	#$01		; index to final string
XBDDF:
	phb			; save current data bank
	lda	<vbnk
	pha
	plb
	lda	#' '
	bit	<facsgn
	bpl	?02
	lda	#'-'
?02:	sta	!TTNUMSTR-1,y
	stz	<facsgn
	sty	<decidx
	iny
	lda	#$30
	ldx	<facexp
	bne	?04
	jmp	?58
?04:	lda     #$00
	cpx	#$80
	beq	?06
	bcs	?08
?06:	lda	#<XBDBD
	ldy	#>XBDBD
	ldx	#^XBDDD
	jsr	XBA28		; mult
	lda	#$F7
?08:	sta	<dccnt
?10:	lda	#<XBDB8		; manage float so 1e8 <= x <= 1e9
	ldy	#>XBDB8
	jsr	XBC5BK
	beq	?20
	bpl	?16
?12:	lda	#<XBDB3
	ldy	#>XBDB3
	jsr	XBC5BK
	beq	?14
	bpl	?18
?14:	jsr	XBAE2		; mult * 10
	dec	<dccnt
	bne	?12
?16:	jsr	XBAFE		; div by 10
	inc	<dccnt
	bne	?10
?18:	jsr	XB849		; round to +0.5
?20:	jsr	XBC9B		; convert to integer 32 bits
	ldx	#$01
	lda	<dccnt
	clc
	adc	#$0A
	bmi	?22
	cmp	#$0B
	bcs	?24
	adc	#$FF
	tax
	lda	#$02
?22:	sec
?24:	sbc	#$02
	sta	<expval
	stx	<dccnt
	txa
	beq	?26		; decimal form
	bpl	?30		; exponential form
?26:	ldy	<decidx
	lda	#'0'		; store '0.' or '0.0'
	iny
	sta	!TTNUMSTR-1,y
	lda	#$2E
	iny
	sta	!TTNUMSTR-1,y
	txa
	beq	?28
	lda	#$30
	iny
	sta	!TTNUMSTR-1,y
?28:	sty	<decidx
?30:	ldy	#$00
	ldx	#$80
?32:	phb
	phk
	plb
?34:	lda	<facm+3
	clc
	adc	!XBF16+3,y
	sta	<facm+3
	lda	<facm+2
	adc	!XBF16+2,y
	sta	<facm+2
	lda	<facm+1
	adc	!XBF16+1,y
	sta	<facm+1
	lda	<facm
	adc	!XBF16,y
	sta	<facm
	inx
	bcs	?36
	bpl	?34
	bmi	?38
?36:	bmi	?34
?38:	txa
	bcc	?40
	eor	#$FF
	adc	#$0A
?40:	adc	#$2F
	iny
	iny
	iny
	iny
	sty	<decidx2
	ldy	<decidx
	iny
	tax
	and	#$7F
	plb
	sta	!TTNUMSTR-1,y
	dec	<dccnt
	bne	?42
	lda	#$2E
	iny
	sta	!TTNUMSTR-1,y
?42:	sty	<decidx
	ldy	<decidx2
	txa
	eor	#$FF
	and	#$80
	tax
	cpy	#$24
	beq	?44
        cpy	#$3C
        bne	?32
?44:	ldy	<decidx
?46:	lda	!TTNUMSTR-1,y
	dey
	cmp	#$30
	beq	?46
	cmp	#$2E
	beq	?48
        iny
?48:	lda	#$2B
	ldx	<expval
	beq	?60
	bpl	?50
	lda	#$00
	sec
	sbc	<expval
	tax
	lda	#$2D
?50:	sta	!TTNUMSTR+1,y
	lda	#$45
	sta	!TTNUMSTR,y
	txa
	ldx	#$2F
	sec
?52:	inx
	sbc	#$0A
	bcs	?52
	adc	#$3A
	sta	!TTNUMSTR+3,y
	txa
	sta	!TTNUMSTR+2,y
	lda	#$00
	sta	!TTNUMSTR+4,y
	beq	?62
?58:	sta	!TTNUMSTR-1,y
?60:	lda     #$00
	sta	!TTNUMSTR,y
?62:	plb			; restore data bank	
	lda	#<TTNUMSTR
	ldy	#>TTNUMSTR
	rts

;---------------------------------------------------------------------------
; sqrt() function implementation - sqrt(x) = exp(ln(x) * 0.5)
;---------------------------------------------------------------------------

; compute SQRT([FAC #1])
XBF71:
	jsr	XBC0C		; round FAC #1 and move to FAC #2
	lda	#<FCON05
	ldy	#>FCON05
	jsr	XBBA2K		; move AYK to FAC #1

;---------------------------------------------------------------------------
; power() function implementation - power(x,y) = x^y = exp(ln(x) * y)
;---------------------------------------------------------------------------

; compute [FAC #2] ^ [FAC #1] - A = FAC #1 exponent
XBF7B:
	beq	XBFED		; if null go to exp(0)
	lda	<argexp
	bne	?02
	jmp	XB8F9
?02:	jsr	XBBX3		; round FAC #1 and move to FAC3TMP
        lda	<argsgn
        bpl	?04
        jsr	XBCCC		; to int
	lda	#<FAC3TMP
	ldy	#>FAC3TMP
        jsr	XBC5BT		; compare in temp. fac bank
        bne	?04
        tya
        ldy	<faclsb
?04:	jsr	XBBFE		; copy FAC #1 to #FAC #2
	phy
	jsr	XB9EA		; compute ln()
	lda	#<FAC3TMP
	ldy	#>FAC3TMP
	ldx	<vbnk		; bank that old FAC3TMP
	jsr	XBA28		; mult with FAC3TMP
	jsr	XBFED		; compute exp()
	pla
	lsr	a
	bcc	XBFBE		; if even

XBFB4:	; change sign
	lda	<facexp
	beq	XBFBE
	lda	<facsgn
	eor	#$FF
	sta	<facsgn
XBFBE:	rts

;---------------------------------------------------------------------------
; exp() function implementation
;---------------------------------------------------------------------------

; compute exp([FAC #1])
XBFED:
	lda	#<XBFBF		; 1/LN(2)
	ldy	#>XBFBF
	ldx	#^XBFBF		; current program bank
	jsr	XBA28		; mult 1/LN(2)
	lda	<facbits
	adc	#$50
	bcc	?02
	jsr	XBC23		; increment mantissa
?02:	sta	<argbits
	jsr	XBC0F		; copy FAC # 1 to FAC #2 (no rounding before)
	lda	<facexp
	cmp	#$88
	bcc	?06
?04:	jsr	XBAD4
?06:	jsr	XBCCC		; compute integer part
	lda	<faclsb
	clc
	adc	#$81
	beq	?04
	sec
	sbc	#$01
	pha
	ldx	#$05		; exchange FAC #1 and FAC #2
?08:	lda	<argexp,x
	ldy	<facexp,x
	sta	<facexp,x
	sty	<argexp,x
	dex
	bpl	?08
	lda	<argbits
        sta	<facbits
        jsr	XB853		; [FAC #2] - [FAC #1]
        jsr	XBFB4		; negate FAC #1
        lda	#<XBFC4		; compute exp() polynomial
        ldy	#>XBFC4
        jsr	XE059
	stz	<arisgn
	pla
	jmp	XBAB9		; add exponent
	
;---------------------------------------------------------------------------
; series evaluation implementation
;---------------------------------------------------------------------------

XE043:
	sta	<fbufpt
	sty	<fbufpt+1
	jsr	XBBCA		; round FAC #1 and move it to FAC2TMP
	lda	#<FAC2TMP
	ldy	#>FAC2TMP
	ldx	<vbnk		; bank that old FAC2TMP
	jsr	XBA28		; compute X^2
	jsr	XE05D		; compute P(X^2)
	lda	#<FAC2TMP
	ldy	#>FAC2TMP
	ldx	<vbnk		; bank that old FAC2TMP
	jmp	XBA28		; compute X*P(X^2)
	
XE059:
	sta	<fbufpt
	sty	<fbufpt+1
XE05D:
	jsr	XBBC7		; round FAC #1 and move it to FAC1TMP
	lda	#^XE043
        sta	<fbufpt+2	; polynomial coefficient in program bank
        lda	[fbufpt],y
        sta	<sercnt		; number of coefficients
        lda	<fbufpt
        inc	a
        bne	?02
        inc	<fbufpt+1
?02:	sta	<fbufpt
	ldy	<fbufpt+1
	ldx	<fbufpt+2
?04:	jsr	XBA28		; [FAC #1] * coeff[n]
	lda	<fbufpt
	ldy	<fbufpt+1
	clc
	adc	#$05
	bcc	?06
	iny
?06:	sta	<fbufpt
	sty	<fbufpt+1
	jsr	XB867		; [FAC #1] + coeff[n+1]
	lda	#<FAC1TMP
	ldy	#>FAC1TMP
	ldx	<vbnk		; bank that old FAC1TMP
	dec	<sercnt
	bne	?04
XE0X:	rts

;---------------------------------------------------------------------------
; arctan() function implementation
;---------------------------------------------------------------------------

XE30E:
	lda	<facsgn
	pha
	bpl	?02
	jsr	XBFB4		; change sign
?02:	lda	<facexp
	pha
	cmp	#$81
	bcc	?04		; x <= 1
	lda	#<XB9BC		; 1.0
	ldy	#>XB9BC
	ldx	#^XE30E
	jsr	XBB0F		; x = 1/x
?04:	lda	#<XE33E		; polynomial table
	ldy	#>XE33E
	jsr	XE043
	pla
	cmp	#$81
	bcc	?06
	lda	#<XE2E0		; pi / 2
	ldy	#>XE2E0
	jsr	XB850		; pi/2 - [FAC 31]
?06:	pla
	bpl	XE0X		; exit
	jmp	XBFB4		; change sign

;---------------------------------------------------------------------------
; cos() function implementation -- cos(x) = sin(x + pi/2)
;---------------------------------------------------------------------------

; compute cos([FAC #1])
XE264:
	lda	#<XE2E0		; PI/2
	ldy	#>XE2E0
	jsr	XB867

;---------------------------------------------------------------------------
; sin() function implementation
;---------------------------------------------------------------------------

; compute sin([FAC #1])
XE26B:
	jsr	XBC0C		; round FAC #1 and move to FAC #2
	lda	#<XE2E5		; 2 * PI
	ldy	#>XE2E5
	ldx	<argsgn
	jsr	XBB07		; divide by 2*pi (reduction angle)
	jsr	XBC0C		; round FAC #1 and move to FAC #2
	jsr	XBCCC		; to int
	stz	<arisgn
	jsr	XB853		; now argument is reduced to 2 * pi max.
	lda	#<XE2EA		; 0.25
	ldy	#>XE2EA
	jsr	XB850		; 0.25 - [FAC #1]
	lda	<facsgn
	pha
	bpl	XE29D
	jsr	XB849		; add 0.5
	lda	<facsgn
	bmi	XE2A0
	lda	<cprmsk
	eor	#$FF
	sta	<cprmsk
XE29D:
	jsr	XBFB4		; change sign
XE2A0:
	lda	#<XE2EA		; 0.25
	ldy	#>XE2EA
	jsr	XB867		; add 0.25
	pla
	bpl	?02
	jsr	XBFB4		; change sign
?02:	lda	#<XE2EF
	ldy	#>XE2EF
	jmp	XE043		; compute sin() polynomial

;---------------------------------------------------------------------------
; tan() function implementation -- tan(x) = sin(x) / cos(x)
;---------------------------------------------------------------------------

; compute tan([FAC #1])
XE2B4:
	jsr	XBBCA		; move FAC #1 rounded to FAC1TMP
	stz	<cprmsk
	jsr	XE26B		; compute sin()
	jsr	XBBX3		; move FAC #1 rounded to FAC3TMP
	lda	#<FAC2TMP
	ldy	#>FAC2TMP
	jsr	XBBA2T
	stz	<facsgn
	lda	<cprmsk
	jsr	?02
	lda	#<FAC3TMP
	ldy	#>FAC3TMP
	ldx	<vbnk
	jmp	XBB0F		; div
?02	pha
	bra	XE29D

;---------------------------------------------------------------------------
; some floating point costants
;---------------------------------------------------------------------------

XB9BC:	.DB	$81,$00,$00,$00,$00	; 1.0
FCON10:	.DB	$84,$20,$00,$00,$00	; 10.0
FCON05:	.DB	$80,$00,$00,$00,$00	; 0.5

XB9C1:	.DB	$03			; LN polynomial table degree 4
	.DB	$7F,$5E,$56,$CB,$79	; B9C2
	.DB	$80,$13,$9B,$0B,$64	; B9C7
	.DB	$80,$76,$38,$93,$16	; B9CC
	.DB	$82,$38,$AA,$3B,$20	; B9D1

XB9D6:	.DB	$80,$35,$04,$F3,$34	; 0.5 * SQRT(2)
XB9DB:	.DB	$81,$35,$04,$F3,$34	; SQRT(2)
XB9E0:	.DB	$80,$80,$00,$00,$00	; -0.5
XB9E5:	.DB	$80,$31,$72,$17,$F8	; LN(2)
XBFBF:	.DB	$81,$38,$AA,$3B,$29	; 1/LN(2)
XLN10	.DB	$82,$13,$5D,$8D,$DE	; LN(10)

XBDB3:	.DB	$9B,$3E,$BC,$1F,$FD	; used by float to string conversion
XBDB8:	.DB	$9E,$6E,$6B,$27,$FD	; 1E8
XBDBD:	.DB	$9E,$6E,$6B,$28,$00	; 1E9

XBF16:	.DB	$FA,$0A,$1F,$00		; -100000000
	.DB	$00,$98,$96,$80		;   10000000
	.DB	$FF,$F0,$BD,$C0		;   -1000000
	.DB	$00,$01,$86,$A0		;     100000
	.DB	$FF,$FF,$D8,$F0		;     -10000
	.DB	$00,$00,$03,$E8		;       1000
	.DB	$FF,$FF,$FF,$9C		;       -100
	.DB	$00,$00,$00,$0A		;         10
	.DB	$FF,$FF,$FF,$FF		;         -1

XBFC4:	.DB	$07			; EXP polynomial table degree 8
	.DB	$71,$34,$58,$3E,$56
	.DB	$74,$16,$7E,$B3,$1B
	.DB	$77,$2F,$EE,$E3,$85
	.DB	$7A,$1D,$84,$1C,$2A
	.DB	$7C,$63,$59,$58,$0A
	.DB	$7E,$75,$FD,$E7,$C6
	.DB	$80,$31,$72,$18,$10
	.DB	$81,$00,$00,$00,$00

XE2E0	.DB	$81,$49,$0F,$DA,$A2	; pi * 0.5
XE2E5	.DB	$83,$49,$0F,$DA,$A2	; pi * 2
XE2EA	.DB	$7F,$00,$00,$00,$00	; 0.25

XE2EF	.DB	$05			; SIN polynomial table degree 6
	.DB	$84,$E6,$1A,$2D,$1B
	.DB	$86,$28,$07,$FB,$F8
	.DB	$87,$99,$68,$89,$01
	.DB	$87,$23,$35,$DF,$E1
	.DB	$86,$A5,$5D,$E7,$28
	.DB	$83,$49,$0F,$DA,$A2

XE33E:	.DB	$0B			; ARCTAN polynomial table degree 12
	.DB	$76,$B3,$83,$BD,$D3
	.DB	$79,$1E,$F4,$A6,$F5
	.DB	$7B,$83,$FC,$B0,$10
	.DB	$7C,$0C,$1F,$67,$CA
	.DB	$7C,$DE,$53,$CB,$C1
	.DB	$7D,$14,$64,$70,$4C
	.DB	$7D,$B7,$EA,$51,$7A
	.DB	$7D,$63,$30,$88,$7E
	.DB	$7E,$92,$44,$99,$3A
	.DB	$7E,$4C,$CC,$91,$C7
	.DB	$7F,$AA,$AA,$AA,$13
	.DB	$81,$00,$00,$00,$00
