
_CBM_INC_	.EQU	1

	.INCLUDE inc\global.inc
	.INCLUDE inc\dirp00.inc
	.LIST on
	.INCLUDE inc\dpcbm.inc

	.CODEFE
	.LONGA off
	.LONGI off

	.EXTERN cbm_new2, cbm_res, cbm_rdy
	.EXTERN vlsnopn, vsndcmd, vunlsnopn, viec8lsn, viec8tlk
	.EXTERN viec8put, viec8get, v8unlsn, v8untlk, v8close
	.EXTERN vopnlst

;---------------------------------------------------------------------------
; serial comm device
;---------------------------------------------------------------------------

; A = device #
seropen:
	lda	#$05
	sec
	rts

serclose:
	rts

;---------------------------------------------------------------------------

iecopen:
	cmp	#$08
	bcc	?er5
	bit	pcdsk
	bmi	?pcc		; compiler in memory mode
	bit	fpcflag
	bpl	?real		; old style: always on disk
	lda	sacur
	and	#$0F
	cmp	#4
	beq	?obj		; new style: obj. file in memory
?real:	jmp	?dsk		; open real disk
?er5:	lda	#$05
	sec
	rts
?pcc:	lda	sacur		; pascal compiler
	and	#$0F
	cmp	#$0F
	beq	?end0
	cmp	#$04		; obj. file?
	bne	?tst		; no
?obj:	stz	iecwp		; setup buffer pointer for write obj. file
	stz	iecwp+1
	lda	jbnk		; obj. code in j-bank
	sta	iecwp+2
?end0:	clc
?end:	rts
?tst:	cmp	#$03		; read main source file?
	bne	?inc		; no
	ACC16
	lda	txtbeg		; pointer to main text buffer
	sta	iectp
	ldy	tbnk		; bank 
	sty	iectp+2
	lda	[iectp]		; check end of text
	ACC08
	beq	?er4		; empty buffer
	stz	ieceof		; clear eof flag
	stz	iecfg		; clear internal eof flag
	stz	iecndx		; clear index
	clc
	rts
?inc	cmp	#$05		; an include file?
	beq	?inc2		; yes
	lda	#$06		; 'not input file' error
	sec
	rts
?er4:	lda	#$04		; 'file not found' error ($04)
	sec
	rts
?inc2:	stz	iecrp		; clear buffer pointer
	stz	iecrp+1
	lda	dbnk
	sta	iecrp+2
	;stz	iecalt		; include file flag
	stz	ieceof2		; include fuile eof flag
	stz	iecndx2		; buffer index
	stz	iecndx+2
	
	; open include file
	phx
	lda	fnadr2		; set fname pointer
	pha
	pei	(fnadr)		; address of cmnd string
	lda	#$0E
	pha			; chnl
	CBMFSCMD		; send command
	plx
	bcs	?er4		; if error
	phx
	lda	iecrp+2		; bank of buffer
	pha
	pei	(iecrp)		; address of buffer
	pea	#$FFFE		; buffer size
	lda	#$0E		; chnl
	pha
	CBMFSRD			; read buffer
	php
	sta	longp		; size
	xba
	sta	longp+1
	lda	#$0E
	CBMFSCLS		; close chnl
	plp
	plx
	bcs	?er4		; error
	INDEX16
	ldy	longp
	lda	#0
	sta	[iecrp],y
	INDEX08
	clc
	rts

; real disk open
?dsk:
	phx
	lda	sacur
	and	#$0F
	tax			; x = sa
	ldy	fnlen
	bne	?sz		; string not empty
	cpx	#$0F
	beq	?ret		; command without string
	lda	#<GFNAME	; set dummy string pointer
	sta	fnadr
	lda	#>GFNAME
	sta	fnadr+1
	lda	tbnk
	sta	fnadr+2
?sz:	lda	#0
	sta	[fnadr],y	; terminate string
	lda	fnadr+2		; param 1: command string
	pha
	pei	(fnadr)
	phx			; channel
	CBMFSCMD		; send command (ignore error)
?ret:	plx
	bcs	?ext
	cpx	#$0F
	beq	?ext
	jsl	vopnlst
?ext:	clc
	rts
	
iecclose:
	lda	facur
	cmp	#$08
	bcc	?end		; no disk device
	lda	sacur
	and	#$0F
	cmp	#$0F
	beq	?clc		; ignore close command channel
	bit	pcdsk
	bpl	?dsk		; real disk
	cmp	#$05		; ignore close file #2,#3,#4 
	bcc	?end
	stz	iecndx2		; clear include file index
	stz	iecndx2+1
	stz	ieceof2		; clear include file eof flag	
?clc:	clc
?end:	rts
?dsk:	bit	fpcflag
	bpl	?dsk2		; old style: always on disk
	cmp	#4
	beq	?clc		; obj file new style: in memory
?dsk2:	jsl	v8close		; close file on real disk
	rts
	
; A=dev#, sacur=SA#
ieclsn:
	stz	kstat
	cmp	#$08
	bcc	?end
	clc
	bit	pcdsk
	bmi	?end
	lda	sacur
	and	#$0F
	bit	fpcflag
	bpl	?dsk
	cmp	#4
	bne	?dsk
	clc
	rts
?dsk:	jsl	viec8lsn
	bcc	?end
	lda	#$80
	sta	kstat
?end:	rts

iecunlsn:
	lda	dflto
	cmp	#$08
	bcc	?end2
	bit	pcdsk
	bmi	?end
	bit	fpcflag
	bpl	?dsk
	lda	sacur
	cmp	#4
	beq	?end
?dsk:	jsl	v8unlsn
?end:	clc	
?end2:	rts

; A=dev#, sacur=SA#
iectlk:
	stz	kstat
	cmp	#$08
	bcc	?end
	clc
	lda	sacur
	bit	pcdsk
	bmi	?tlk
	lda	sacur
	jsl	viec8tlk
	bcs	?er
	bvc	?end
	lda	#$40
	bra	?er2
?er:	lda	#$80
?er2:	sta	kstat	
?end:	rts
?tlk:	and	#$0F
	cmp	#$0F
	stz	iecalt		; if = 0 get from cmd. chnl
	beq	?end2
	sec
	ror	iecalt		; <7>: get from main text buffer
	cmp	#$05		; include file?
	bne	?end2		; no
	lsr	iecalt		; <6>: get from include file
?end2:	clc
	rts

iecuntlk:
	lda	dfltn
	cmp	#$08
	bcc	?end2
	bit	pcdsk
	bmi	?end
	jsl	v8untlk
?end:	clc	
?end2:	rts

; A=data
iecout:
	sta	iecbuf
	lda	dflto
	cmp	#$08
	bcc	?no
	lda	iecbuf
	bit	pcdsk
	bmi	?wr
	bit	fpcflag
	bmi	?wr
	jsl	viec8put
	bcc	?end2
	lda	#$80
	sta	kstat
	lda	iecbuf
	rts
?no:	lda	iecbuf
	rts
?wr:	sta	[iecwp]		; put to buffer obj. file
	inc	iecwp		; update buffer pointer
	bne	?end
	inc	iecwp+1
	bne	?end
	inc	iecwp+2
?end:	clc
?end2:	rts
	
iecin:
	lda	dfltn
	cmp	#$08
	bcc	?no
	bit	pcdsk
	bmi	?rdt
	jsl	viec8get
	bcs	?er
	bvc	?xt		; no eof
	sta	iecbuf
	lda	#$40
	sta	kstat
	lda	iecbuf
?xt:	rts
?er:	lda	#$80
	sta	kstat
?no:	lda	#$0D	
	rts

; get byte from main text buffer 
?rdt:
	lda	iecalt
	beq	?ext		; cmd chnl
	cmp	#$40
	beq	?rda		; read include file
	phx
	phy
	phb
	bit	ieceof		; <6>: eof flag
	bvc	?go		; no eof
	lda	#$0D		; return CR if eof
	ldy	#$40
	sty	kstat		; I/O status = eof
	bra	?end		; exit
?go:	lda	svbnk		; local read buffer in real v-bank
	pha
	plb			; set data bank
	bit	iecfg		; <7>: flag buffer not empty
	bmi	?get		; buffer ready
	jsr	?ldt		; fill local read buffer
?get:	ldy	iecndx		; current buffer index
	lda	$FF00,y		; get byte from local buffer
	iny
	sty	iecndx		; save new index
	cmp	#$0A		; last byte of buffer?
	bne	?end		; no -- return byte
	bit	iecfg		; <6>: eof flag (VF)
	stz	iecfg		; clear flag: next time must fill buffer
	bvc	?end		; no eof
	ldy	#$40
	sty	ieceof		; internal flag: end of file
	;sty	kstat		; I/O status = eof
?end:	plb
	ply
	plx
?ext:	clc
	rts

?rda:	phy
	bit	ieceof2		; <6>: eof flag
	bvc	?go2		; no eof
	lda	#$40
	sta	kstat
	lda	#$0D		; return CR if eof
	bra	?end2		; exit
?go2:	INDEX16
	ldy	iecndx2		; index
	lda	[iecrp],y
	sta	iecbuf
	iny
	sty	iecndx2
	lda	[iecrp],y
	INDEX08
	bne	?ret
	lda	#$40
	sta	ieceof2
?ret:	lda	iecbuf
?end2:	ply
	clc
	rts

; fill local buffer from main text buffer
?ldt:	ACC16
	ldy	#$02
	lda	[iectp],y
	sta	psrline		; store current line number
	ACC08
	ldx	#$FF
	iny
?llp:	iny
	inx
	lda	[iectp],y	; copy text line in local buffer
	sta	!$FF00,x
	bne	?llp
	lda	#$0D
	sta	!$FF00,x
	lda	#$0A
	sta	!$FF01,x
	ldy	#$80		; flag buffer is filled 
	ACC16
	lda	[iectp]		; update pointer to next text line
	sta	iectp
	lda	[iectp]
	ACC08
	bne	?ok		; no eof
	ldy	#$C0		; flag filled buffer + end of file marker
?ok:	stz	iecndx		; clear current index
	sty	iecfg
	rts	

;---------------------------------------------------------------------------
; virtual serial bus device
; device #4,#5: printer port's
; device #6,#7: not present
; device #8: all drive's
;
; disk unit:
;		#0..#7: physical drive's
;		#8,#10: ram buffer (compiler only)
;		#9,#11: text buffer (read only, compiler only) 
;---------------------------------------------------------------------------

;---------------------------------------------------------------------------
; open virtual iec device
;---------------------------------------------------------------------------

; open virtual iec device
; A = device #, X = index to logical file table
; output: CF = 1 if error, A = error code
; implementation note---
; for disk device (device #8) secondary address sacur have special meaning:
; 	sacur<7>: 1 if write only file, 0 if read only file
;	sacur<6>: 1 if read/write file
; after openning, secondary address have in bit <3:0> the disk unit number
; pascal compiler open at least 3 files: file #1 for chann. command,
; file #3 (read only) for pascal source, file #4 (write only) for obj. code
; file #2 reserved for printer/terminal listing when compiling
; if source file contain an include directive (#filename) then open file #5
; for read include file.

;---------------------------------------------------------------------------
; close channel with iec device
;---------------------------------------------------------------------------
	
;---------------------------------------------------------------------------
; logical file operations and input/output wrapper's
;---------------------------------------------------------------------------

; wrapper for output routine
; before call this, user must call _chkout routine
; A = byte to send to device
_chrout:
	xba			; B = byte to send 
	lda	dflto
	beq	?04		; 0 -> keyboard, not out device
	cmp	#$03
	bcc	?06		; 1, 2 -> serial port
	bne	?02		; 4..MAXVIEC
	xba
	SCNCHAROUT		; 3 -> screen output
	rts
?02:	cmp	#MAXVIEC+1
	bcc	?08		; 4..MAXVIEV -> virtual serial bus
?04:	jmp	SetErr09	; illegal device number
?06:	xba			; output serial/parallel port	
	DEVCHAROUT
	rts
?08:	xba	
	jmp	iecout		; virtual iec output

; wrapper for get routine
; before call this user must call _chkin routine
_getin:
	lda	dfltn
	bne	_chrin1
	KBGETIN			; get from keyboard
	xba
	sta	keyctl		; store control
	xba			; key code
	clc
	rts
	
; wrapper for input routine
; before call this user must call _chkin routine
 _chrin:
	lda	dfltn
	bne	_chrin1	
	KBCHARIN		; input from keyboard (editor)
	rts
_chrin1:
	cmp	#$03
	bcc	?01		; 1,2 -> serial ports
	bne	?02
?01:	DEVCHARIN		; input from screen (editor) or serial port		
	rts
?02:	cmp	#MAXVIEC+1
	bcc	?06		; 8..15 -> virtual serial bus
?04:	jmp	SetErr09	; illegal device number
?06:	lda	kstat		; virtual iec device
	bne	?08		; end of file or error
	jmp	iecin		; virtual serial bus input
?08:	lda	#$0D		; return a CR
	clc
	rts

; wrapper for open routine
; before call this user must set: lacur, facur, sacur, fnlen, fnadr, fnadr2
_open:
	ldx	lacur
	jsr	lfsrch
	beq	?12		; file open
	ldx	ldtnd
	cpx	#MAXLF
	bcs	?11		; too many files
	inc	ldtnd
	;stx	lxcur
	lda	lacur
	sta	latb,x
	lda	sacur
	sta	satb,x
	lda	facur
	sta	fatb,x
	beq	?10		; 0 -> keyboard: OK
	cmp	#$03
	beq	?10		; 3 -> screen: OK
	bcc	?15		; 1,2 -> serial ports
	cmp	#MAXVIEC+1
	bcc	?07		; 4..MAXVIEC -> virtual serial bus
?05:	lda	fatb,x		; invalidate device #
	ora	#$80
	sta	fatb,x
	jmp	SetErr09	; illegal device number
?07:	jsr	iecopen		; A = error code if any error
	bcs	?17		; ok
?10:	clc			; no error
?10a:	rts
?11:	jmp	SetErr01	; too many files
?12:	jmp	SetErr02	; file open
?15:	jsr	seropen		; open serial port
	bcc	?10a		; A = error code if any error		
?17:	pha			; save error code
	;ldx	lxcur
	lda	fatb,x		; invalidate device #
	ora	#$80
	sta	fatb,x
	pla
?20:	jmp	SetErr		; set error code

; wrapper for set file for input routine
; before call this user must set X = logical file 
_chkin:
	jsr	lfsrch
	bne	?11		; file not open
	jsr	lfget
	beq	?10a		; 0 -> keyboard - ok
	bmi	?05		; device not present
	cmp	#$04
	bcc	?10a		; 1,2,3 - ok
	cmp	#MAXVIEC+1
	bcc	?10		; 6..MAXVIEC -> virtual serial bus ok
?05:	jmp	SetErr05	; error: device not present
?10:	tax
	jsr	iectlk
	bcs	?05
	txa
?10a:	sta	dfltn		; ok - setup input device
	clc
	rts
?11:	jmp	SetErr03	; error: file not open
?12:	jmp	SetErr06	; error: not input file

; wrapper for set file for output routine
; before call this user must set X = logical file 
_chkout:
	jsr	lfsrch
	bne	?11		; file not open
	jsr	lfget
	beq	?12		; 0 -> keyboard - not output device
	bmi	?05		; device not present
	cmp	#$04
	bcc	?10a		; 1,2,3 - ok
	cmp	#MAXVIEC+1
	bcc	?10		; 4..MAXVIEC -> virtual serial bus ok
?05:	jmp	SetErr05	; error: device not present
?10:	tax	
	jsr	ieclsn
	bcs	?05
	txa
?10a:	sta	dflto		; ok - set output device
	clc
	rts
?11:	jmp	SetErr03	; file not open		
?12:	jmp	SetErr07	; error: not output file

; wrapper for close all opened files
_clall:
	jsr	_clrch
?02:	ldx	ldtnd
	beq	?04		; no more files to close
	lda	latb,x		; logical file number
	jsr	_close		; close file
	bra	?02		; loop next file
?04:	rts

; wrapper for restore default i/o devices
_clrch:
	ldx	#$03		; default output device
	cpx	dflto
	bcs	?10
	jsr	iecunlsn
?10:	cpx	dfltn
	bcs	?20
	jsr	iecuntlk
?20:	stx	dflto		; default output device
	stz	dfltn		; default input device
	clc
	rts

; wrapper for close a logical file
; before call this user must set A = logical file to be closed
_close:
	jsr	lfsrchx
	bne	?12		; exit without error (no file found)
	jsr	lfget		; get parameters for logical file
	phx			; save index to logical file table
	lda	facur		; device #
	bmi	?10		; illegal device - delete file
	beq	?10		; no action - delete file
	cmp	#3
	beq	?10		; no action - delete file
	bcs	?02
	jsr	serclose	; close on device 1 & 2
	bra	?10		; delete file
?02:	cmp	#MAXVIEC+1
	bcs	?10		; no action - delete file
	jsr	iecclose	; close on devices 4..MAXVIEC
?10:	plx			; index of file to be deleted
	dec	ldtnd		; update number of logical files
	cpx	ldtnd		; if index is for the last entry, done
	beq	?12		; otherwise move files on table
	txy			; Y = index to entry be removed
	ldx	ldtnd
	lda	latb,x
	tyx
	sta	latb,x
	ldx	ldtnd
	lda	fatb,x
	tyx
	sta	fatb,x
	ldx	ldtnd
	lda	satb,x
	tyx
	sta	satb,x
?12:	clc
	rts
	
; search logical file X in table 'latb'
lfsrch:
	stz	kstat
	txa			; file number
lfsrchx:
	ldx	ldtnd
?01:	dex
	bmi	?02
	cmp	latb,x
	bne	?01
?02:	rts

; get parameters of logical file 
lfget:
	;stx	lxcur
	lda	latb,x
	sta	lacur
	lda	satb,x
	sta	sacur
	lda	fatb,x
	sta	facur
	rts

;---------------------------------------------------------------------------
; kernal error's
;---------------------------------------------------------------------------

SetErr01:			; too many files
	lda	#1
	.DB	$2C
SetErr02:			; file open
	lda	#2
	.DB	$2C
SetErr03:			; file not open
	lda	#3
	.DB	$2C
SetErr04:			; file not found
	lda	#4
	.DB	$2C
SetErr05:			; device not presnt
	lda	#5
	.DB	$2C
SetErr06:			; not input file
	lda	#6
	.DB	$2C
SetErr07:			; not output file
	lda	#7
	.DB	$2C
SetErr08:			; missing file name
	lda	#8
	.DB	$2C
SetErr09:			; illegal device number
	lda	#9
	.DB	$2C
SetErr10:			; out of memory
	lda	#$10
SetErr:
	.EXTERN L0FAA

	pha
	jsr	FCLRCH		; restore default I/O
	bit	runf		; check if running pascal virtual machine
	bmi	?20
	bvs	?20
	ldy	#$00
	bit	msgflg		; <6> -> print kernal msg
	bvc	?10		; no print
	jsr	kprint		; print msg
	lda	$01,s		; error code
	cmp	#$0A
	bcc	?08
	ldy	#$FF		; partial remainder
	sec
?02:	iny
	sbc	#$0A
	bcs	?02
	adc	#$0A
	xba
	tya
	ora	#$30		; print 0..9
	jsr	FCHROUT
	xba
?08:	ora	#$30		; print 0..9
	jsr	FCHROUT
?10:	pla
	sec			; error
	rts
	
?20:	pla	
	cmp	#$2B
	bne	?22
	lda	#0
	bra	?24
?22:	cmp	#$10
	bne	?24
	lda	#$0A
?24:	tax
	lda	>CVTTBL,x
	;sta	iecerr
	tax
	sec
	jmp	L0FAA
	rts

CVTTBL:
	.DB	$14, $10, $16, $15, $17, $18, $0D, $0E, $19, $1A, $01
	

sysmsg:
SYSMSGTBL:
	.DC	$0D, 'I/O error '

SYSMSG1		.EQU	($ - SYSMSGTBL)

	.DC	$0D, 'searching '

SYSMSG2		.EQU	($ - SYSMSGTBL)

	.DC	$0D, 'loading'

SYSMSG3		.EQU	($ - SYSMSGTBL)

	.DC	$0D, 'saving '

SYSMSG4		.EQU	($ - SYSMSGTBL)

	.DC	$0D, 'verifying'
				
SYSMSG5		.EQU	($ - SYSMSGTBL)

	.DC	$0D, 'found '

SYSMSG6		.EQU	($ - SYSMSGTBL)

	.DB	$0D, 'ok', $8D

SYSMSG7		.EQU	($ - SYSMSGTBL)

	.DC	'for '

	
sysprint:
	bit	msgflg		; <7> -> print msg
	bpl	nopr
	
kprint:
	phb
	phk
	plb			; set data bank = program bank
?02:	lda	sysmsg,y
	php
	and	#$7F
	jsr	FCHROUT
	iny
	plp
	bpl	?02
	plb
nopr:	clc
	rts
	
;---------------------------------------------------------------------------
; kernal miscellaneous
;---------------------------------------------------------------------------
	
_setmsg:
	sta	msgflg
	rts

_memtop:
	bcc	?02
	ldx	topmem
	ldy	topmem+1
	rts
?02:	stx	topmem
	sty	topmem+1
	rts

_membot:
	bcc	?02
	ldx	botmem
	ldy	botmem+1
	rts
?02:	stx	botmem
	sty	botmem+1
	rts

_scnkey:
	SCNKEYFLG
	sta	keyfg
	stx	keytg
	sty	keysh
	rts
		
_readst:
	lda	kstat
	rts

_setlfs:
	sta	lacur
	stx	facur
	sty	sacur
	rts
	
_setnam:
	sta	fnlen
	stx	fnadr
	sty	fnadr+1
	rts

_load:
	rts
	
_save:
	rts

; set jiffy clock
; C = 16 bit low, XY = 16 bit high
_settim:
	sei
	phd
	pea	#0
	pld
	sta	<JiffyClk
	xba
	sta	<JiffyClk+1
	stx	<JiffyClk+2
	sty	<JiffyClk+3
	pld
	cli
	rts

; get jiffy clock
; C = 16 bit low, XY = 16 bit high	
_rdtim:
	sei
	phd
	pea	#0
	pld
	lda	<JiffyClk+1
	xba
	lda	<JiffyClk
	ldx	<JiffyClk+2
	ldy	<JiffyClk+3
	pld
	cli
	rts
	
_chkstop:
	SCNKEYBRK
	cmp	#$80		; set ZF if = $80 (ctrl break detected)
	bne	?02
	php
	jsr	_clrch		; restore default devices
	plp
?02:	rts

_scrorg:
	SCNGETORG
	rts

_scrplot:
	bcc	?02		; set pos
	SCNGETPOS
	rts
?02:	SCNSETPOS
	rts
	
_iobase:
	ldx	#$00
	ldy	#$FD
	rts
	
_cinit:
	SCNINIT
	rts

; cold start ram init (Y = $80 if basic, $00 if pascal)	
_ramtas:
	lda	>TXTBNK		; current data bank
	pha
	plb			; set current data bank
	ACC16
	lda	>CBMDP		; set current direct page
	tcd
	ldx	#0		; clear page 0
?02:	stz	<$00,x
	;stz	!cbmwork,x
	inx
	inx
	bne	?02
	phb
	plx
	stx	tbnk		; +0: text bank
	inx
	stx	vbnk		; +1: var/pcode bank
	inx
	stx	xbnk		; +2: exchange bank
	inx
	stx	cbnk		; +3: compiler/tmp bank
	inx
	stx	jbnk		; +4: object code bank for compiler (3 bank)
	inx
	inx
	inx
	stx	dbnk		; +7: ram disk
	sty	basic		; setup basic flag
	ldx	vbnk		; clear working area in var/p-code bank
	jsr	?30
	ldx	xbnk		; clear working area in exchange bank
	jsr	?30	
	ldx	cbnk		; clear working area in compiler/tmp bank
	jsr	?30
	ldy	#0		; set up bank 0
	phy
	plb
	ldy	!Bnk0Flag	; bit 6 mean warm reset
	sty	tmpval+1	; high in 16 bits!
	lda	>TOPVAR
	sta	vartop		; setup top mem. basic var/pcode/ex bank
	ldx	tbnk		; set up current working bank
	phx
	plb
	ldy	#$00
	bit	tmpval		; flag warm reset in tmpval + 1
	bvs	?04		; was warm reset
	jsr	?32		; clear working area of text-bank
	bra	?14
?04:	lda	!XBVSGN		; check valid signature for text in x-bank
	cmp	#VALIDSGN
	bne	?06		; not valid
	ldx	#$80		; bit 7 -> flag valid source text in x-bank
	lda	!XTOP2		; set the end of text pointer
	bra	?08	
?06:	stz	!XBVSGN		; clear signature
	stz	!XTOP2
	tya			; A = 0
	tyx			; X = 0
?08:	stx	vxflag		; set flag
	sta	xtop		; top of text end on x-bank
	tyx			; clear working area
?12:	stz	!$FF00,x
	inx
	inx
	cpx	#$F8
	bcc	?12
	lda	!TXTVSGN
	cmp	#VALIDSGN
	beq	?14		; possible valid source text in buffer
	stz	!TXTVSGN
	stz	!TXTEND2
?14:	lda	#$0101
	sta	!cbmwork	; used by editor
	lda	#cbmwork	; set top mem
	sta	topmem
	stz	longp
	ldx	xbnk
	stx	longp+2
	tya
	ACC08
	sta	[longp]		; first byte always null
	ACC16
	lda	!TXTEND2
	sta	tmpval		; save end of text to recover	
	lda	!TXTVSGN
	cmp	#VALIDSGN
	CPU08
	bne	?16
	lda	#$40		; bit 6 -> possible valid source text
	tsb	vxflag
?16:	ldx	#3
	stx	dflto		; default output device
	lda	#$0A
	sta	wauto
	lda	#$80
	sta	autof
	lda	#$40
	tsb	basic		; editor/emulator mode flag
	rts

?30:	phx			; clear working area bank = X
	plb
?32:	ldx	#0		; clear working area in bank
?34:	stz	!$FF00,x
	inx
	inx
	bne	?34
	rts
	
_ikeybuf:
	phb			; insert string in keyboard input buffer
	plx			; X = data bank, C = address
	SCNKEYBUF
	rts

; cold start CBM emulator
; In	- Y = $00 -> pascal mode
;	  Y = $80 -> basic mode
_cold:
	php			; save caller context
	phb
	phd			; status, data bank and direct page
	CPU08
	jsr	RAMTAS		; init memory
	ACC16
	tsc
	sta	curstk		; current operative stack
	ACC08
	jsr	_basinit
	jsr	CINIT
	lda	vxflag		; save recovery flag
	sta	tmpb2
	jsr	cbm_new2	; this clear recovery flag
	bit	tmpb2
	bvc	?20
	ACC16CLC		; attempt to recover a source text
	lda	txtbeg		; attempt to relink
	sta	longp
	ACC08
	ldy	#$03		; search end of line
?04:	iny
	lda	(longp),y
	bne	?04
	iny
	ACC16CLC
	tya
	adc	longp
	sta	tlnptr		; possible first link
?06:	sta	longp		; check all link
	lda	(longp)
	beq	?10		; end of text
	ACC08
	ldy	#$03		; search end of line
?08:	iny
	lda	(longp),y
	bne	?08
	iny
	ACC16CLC
	tya
	adc	longp		; compare with stored link
	cmp	(longp)
	beq	?06		; check next link
	bne	?15		; mismatch: invalid source text
?10:	lda	longp
	inc	a
	inc	a
	cmp	tmpval		; compare with saved end of text
	bne	?15		; failed recovery
	sta	txtend
	sta	!TXTEND2	; valid signature
	lda	tlnptr		; setup first link
	sta	(txtbeg)
	lda	#VALIDSGN
	sta	!TXTVSGN
?15:	ACC08	
?20:	jmp	cbm_rdy	
	
_mon:
	lda	#$FF	
	jsl	MONITOR
	ACC16
	lda	>CBMDP		; set current direct page
	tcd
	ACC08
	lda	tbnk
	pha
	plb
_warm:
	jsr	cbm_res
	jmp	cbm_rdy
	
; init basic memory
_basinit:
	sec
	jsr	MEMBOT		; get bottom of memory
	stx	txtbeg
	sty	txtbeg+1
	sec
	jsr	MEMTOP		; get top of memory
	stx	txttop
	sty	txttop+1
	stx	freetop
	sty	freetop+1
	bit	basic
	bmi	?02
	lda	#$80
	sta	skpbk
	sta	w2sf
?02: 	ldx	#$1B
	stx	tmppt
	lda	#0
	sta	facov
	sta	prompt
	sta	(txtbeg)
	inc	txtbeg
	bne	?20
	inc	txtbeg+1
?20:	rts

	.CBMJMP

	.LONGA off
	.LONGI off

	.ORG	$00

; $FF00 - cold start
	jmp	_cold
; $FF03 - warm start
	jmp	_warm

	.ORG	$30
; jump table for pascal compiler
	
	.EXTERN L0836, L083C, L083F, L0842, L0845, L084B, L084E, L0851
	.EXTERN L0854, L0857
	
; $FF30 ($0836)
	jmp	L0836
; $FF33 ($083C)
	jmp	L083C
; $FF36 ($083F)
	jmp	L083F
; $FF39 ($0842)
	jmp	L0842
; $FF3C ($0845)
	jmp	L0845
; $FF3F ($084B)
	jmp	L084B
; $FF42 ($084E)
	jmp	L084E
; $FF45 ($0851)
	jmp	L0851
; $FF48 ($0854)
	jmp	L0854
; $FF4B ($0857)
	jmp	L0857

	
	.ORG	$7A

TOPVAR:		.DW	$FF00	; top of memory reserved to var/pcode
TOPMRD:		.DW	$FFE0	; top of memory reserved to ram disk
CBMDP:		.DW	$7F00	; direct page used by CBM emulator		
TXTBNK:		.DB	$10	; bank that hold text buffer
	
; $FF81 - CINIT
	jmp	_cinit
; $FF84 - IOINIT (no op)
	nop
	clc
	rts
; $FF87 - RAMTAS
	jmp	_ramtas
; $FF8A - RESTOR (no op)
	nop
	clc
	rts
; $FF8D - VECTOR (no op)
	nop
	clc
	rts
; $FF90 - SETMSG
	jmp	_setmsg
; $FF93 - SECOND (no op)
	nop
	clc
	rts
; $FF96 - TKSA (no op)
	nop
	clc
	rts
; $FF99 - MEMTOP
	jmp	_memtop
; $FF9C - MEMBOT
	jmp	_membot
; $FF9F - SCNKEY
	jmp	_scnkey
; $FFA2 - SETTMO (no op)
	nop
	clc
	rts
; $FFA5 - ACPTR
	jmp	iecin
; $FFA8 - CIOUT
	jmp	iecout
; $FFAB - UNTLK (no op)
	nop
	clc
	rts
; $FFAE - UNLSN (no op)
	nop
	clc
	rts
; $FFB1 - LISTEN (no op)
	nop
	clc
	rts
; $FFB4 - TALK (no op)
	nop
	clc
	rts
; $FFB7 - READST
	jmp	_readst
; $FFBA - SETLFS
	jmp	_setlfs
; $FFBD - SETNAM
	jmp	_setnam
; $FFC0 - FOPEN
	jmp	_open
; $FFC3 - FCLOSE
	jmp	_close
; $FFC6 - FSETIN
	jmp	_chkin
; $FFC9 - FSETOUT
	jmp	_chkout
; $FFCC - FCLRCH
	jmp	_clrch
; $FFCF - FCHRIN
	jmp	_chrin
; $FFD2 - FCHROUT
	jmp	_chrout
; $FFD5 - FLOAD
	jmp	_load
; $FFD8 - FSAVE
	jmp	_save
; $FFDB - SETTIM
	jmp	_settim
; $FFDE - RDTIM
	jmp	_rdtim
; $FFE1 - CHKSTOP
	jmp	_chkstop
; $FFE4 -  FGETIN
	jmp	_getin
; $FFE7 - FCLALL
	jmp	_clall
; $FFEA - UDTIM (no op)
	nop
	clc
	rts
; $FFED - SCRORG
	jmp	_scrorg
; $FFF0 - SCRPLOT
	jmp	_scrplot
; $FFF3 - GETIOBASE
	jmp	_iobase
; $FFF6 - IKEYBUF
	jmp	_ikeybuf
; $FFF9 - GOMON
	jmp	_mon
	