
_CBM_INC_	.EQU	1

	.INCLUDE inc\global.inc
	.INCLUDE inc\dirp00.inc
	.INCLUDE inc\dpcbm.inc

MAXERR		.EQU	$2F

	.CODEFE
	.LONGA off
	.LONGI off

	.GLOBAL cbm_new2, cbm_res, cbm_rdy, cbm_err, cbm_chrget, cbm_chrgot

;---------------------------------------------------------------------------
; prompt for user action
;---------------------------------------------------------------------------
		
cbm_yn:
	jsr	FCLRCH
	SCNPRINT
	.DB	'are you sure ?', $00
	jsr	FCHRIN		; read a key
	pha
?02:	cmp	#$0D
	beq	?04
	jsr	FCHRIN
	bne	?02
?04:	pla
	cmp	#'a'
	bcc	?06
	cmp	#'z'+1
	bcs	?06
	and	#$DF
?06:	cmp	#'Y'
_?99:	rts

;---------------------------------------------------------------------------
; 'quit' command basic/pascal mode
;---------------------------------------------------------------------------

cbm_quit:
	jsr	FCLALL		; close all open files
	ACC16
	lda	curstk
	tcs
	ACC08
	pld			; restore caller context
	plb
	plp
	rtl
	
;---------------------------------------------------------------------------
; 'renum' command basic/pascal mode
;---------------------------------------------------------------------------

; renum [new [, inc [, old ]]]

newlin	.EQU	tmpwrk
inclin	.EQU	tmpwrk+2
oldptr	.EQU	fbufpt

cbm_renum:
	ldy	#$01
	lda	(txtbeg)
	ora	(txtbeg),y
	beq	_?99		; no source program
	ldx	#$0A
	stx	newlin		; default new line = 10
	stz	newlin+1
	stx	inclin		; default line increment = 10
	stz	inclin+1
	lda	txtbeg		; default old line = 0
	ldx	txtbeg+1
	sta	oldptr		; start renumber from beginning
	stx	oldptr+1
	jsr	cbm_chrgot
	beq	?10		; no params: use default
	bcs	?04		; no digit: use default newlin
	jsr	cbm_getwd	; get [newlin]
	lda	lineno
	sta	newlin
	lda	lineno+1
	sta	newlin+1
	ora	newlin
	beq	?06		; error: newlin can't be zero
?04:	jsr	cbm_chrgot
	beq	?10		; no further params
	jsr	_chkcm		; check comma
	bcs	?08		; no digit: use default increment
	jsr	cbm_getwd	; get [inclin]
	lda	lineno
	ldx	lineno+1
	sta	inclin
	stx	inclin+1
	bne	?06		; check if inclin = 0 or > 255
	tax
	bne	?08
?06:	jmp	cbm_e0e		; illegal quantity error
?08:	jsr	cbm_chrgot
	beq	?10		; use default old line = 0
	jsr	_chkcm		; check comma
	jsr	cbm_getwd	; get [old line]
	jsr	cbm_linsrch	; search old line = linno
	lda	tlnptr
	ldx	tlnptr+1
	sta	oldptr		; oldptr point to text with line > old line
	stx	oldptr+1
	lda	newlin
	ldx	newlin+1
	sta	lineno
	stx	lineno+1
	jsr	cbm_linsrch	; search new line = linno
	ACC16
	sec
	lda	tlnptr		; will be ptr(new line) >= ptr(old line)
	sbc	oldptr
	ACC08
	bcc	?06		; error: can't be new line < old line
?10:	; now can renumber source text starting from oldptr
	; try a fake renumber to check overflow condition
	ldy	#$02		; index to line number
	CPU16CLC
	lda	newlin
	sta	lineno
	lda	oldptr		; this is the new number line newlin
?12:	sta	tlnptr
	lda	(tlnptr)
	beq	?14
	tax
	lda	lineno
	adc	inclin
	sta	lineno
	bcs	?30		; error
	txa
	bcc	?12
?14:	; now we can renumber
	CPU08
	bit	basic
	bmi	?20		; renumber basic program more complex
	CPU16CLC
	lda	newlin
	sta	lineno
	lda	oldptr
?16:	sta	tlnptr
	lda	lineno
	sta	(tlnptr),y	; line number
	lda	(tlnptr)
	beq	?18		; end
	tax
	lda	lineno
	adc	inclin
	sta	lineno
	bcs	?30		; error
	txa
	bcc	?16
?18:	CPU08
	rts

?20:	; basic renumber

?30:	CPU08
	ldx	#$26		; line number too large error
	jmp	cbm_err
	
;---------------------------------------------------------------------------
; some check and error routines and entry
;---------------------------------------------------------------------------

; check ")"
_chkrp:
	lda	#')'
	bra	_chkskp
; check "("
_chklp:
	lda	#'('
	bra	_chkskp
; check ","
_chkcm:
	lda	#','
; check char and skip
_chkskp:
	cmp	(txtp)
	bne	cbm_e0b
	jmp	cbm_chrget
	
; file routines wrappers used from basic
cbm_open:
	jsr	FOPEN
	bcs	cbm_eio
	rts
cbm_out:
	jsr	FCHROUT
	bcs	cbm_eio
	rts
cbm_in:
	jsr	FCHRIN
	bcs	cbm_eio
	rts

cbm_eio:
	tax
	bne	cbm_err		; i/o error
cbm_e1e:
	ldx	#$1E		; break
	bra	cbm_err
; check if direct mode only
cbm_dir:
	bit	runf
	bmi	?02
	jmp	cbm_chrgot	; get again text char
?02:	ldx	#$22		; direct mode only
	bra	cbm_err
cbm_e28:	
	ldx	#$28		; unimplemented command
	bra	cbm_err
cbm_e10:
	ldx	#$10		; out of memory
	bra	cbm_err
cbm_e0b:
	ldx	#$0B		; syntax
	bra	cbm_err
cbm_e23:
	ldx	#$23		; integer overflow
	bra	cbm_err
cbm_e0e:
	ldx	#$0E		; illegal quantity
	
; handle error basic/editor
; (C64-A434 C128-4D3C)
cbm_err:
	stx	errno
	txa
	beq	cbm_rdy		; no error -> ready
	bmi	cbm_rdy		; no error -> ready
	cpx	#MAXERR
	bcc	?02
	ldx	#MAXERR
?02:	bit	runf
	bpl	?20		; no basic run mode
	nop
	nop
?20:	dex			; error index
	ACC16
	lda	curstk		; start stack
	tcs
	lda	#BASERM		; address of error strings
	sta	longp
	ACC08
	stz	prompt
	phk
	pla
	sta	longp+2		; find error string
?22:	dex
	bmi	?28		; found
?24:	lda	[longp]
	tay
	inc	longp
	bne	?26
	inc	longp+1
?26:	tya
	bpl	?24
	bmi	?22
?28:	jsr	FCLRCH		; restore default i/o devices	
	SCNPRINT		; print CR + '?'
	.DB	$0D, '?', $00	
	jsr	cbm_prn		; print error string
	SCNPRINT		; print ' error'
	.DB	' error', $00
	
; entry point after basic break
; (C64-A46C C128-4DAF)
cbm_brk:
	bit	basic
	bpl	cbm_rdy
	bit	runf
	bpl	cbm_rdy		; not in run mode
	SCNPRINT		; print ' in '
	.DB	' in ', $00
	jsr	cbm_prline	; print current line number
	
; basic or pascal prompt
; (C64-A474 C128-4DB7)
cbm_rdy:
	SCNPRINT		; print prompt ('ready.')
	.DB	$0D, 'ready.', $0D, $00
	lda	#$80		; message flag
	jsr	SETMSG
	stz	runf		; clear run flag
	
; warm start basic or pascal editor
; (C64-A480 C128-4DC3)
cbm_main:
	lda	>CRFWEOFF
	tax
	sta	>CRFWEON	; enable write in bank $FE RAM
	lda	tbnk		; the source and dest. bank
	sta	?55+2		; store source bank for mvp istruction
	sta	?55+1		; store dest. bank for mvp istruction
	sta	?22+2		; store source bank for mvn istruction
	sta	?22+1		; store dest. bank for mvn istruction	
	sta	>CRFWEOFF,x	; restore writing in bank $FE
	jsr	cbm_gline	; wait for text (input from keyboard)
	stx	txtp
	sty	txtp+1
	stz	skpbk		; skip beginning blanks
	jsr	cbm_chrget	; get char
	tax
	beq	cbm_main	; empty line
	bcc	?10		; decimal digit -> insert text line
	bit	basic
	bpl	?01
	jsr	cbm_tokn	; tokeinize basic statement 
	jmp	cbm_exec	; execute basic statement
?01:	ldx	#0		; pointer to commands table
	stx	tcnt		; index of command
?02:	ldy	txtp		; starting index to input buffer
?03:	lda	!TXTBUF-4,y	; Y is reference to 0
	eor	>PCMDT,x
	beq	?05		; ok partial - continue scanning
	cmp	#$80
	beq	?06		; match -- command found
	inc	tcnt		; update index counter
?04:	inx
	lda	>PCMDT-1,x	; search end of string
	bpl	?04
	lda	>PCMDT,x
	bne	?02		; continue till end of table
	jmp	cbm_e0b		; syntax error
?05:	inx
	iny
	bne	?03		; continue scanning
?06:	sty	txtp		; update text pointer
	lda	tcnt
	asl	a		; vector index
	tax
	lda	>PCMDV,x
	ora	>PCMDV+1,x
	bne	?08
	jmp	cbm_e28		; unimplemented command
?08:	jsr	cbm_chrget
	jsr	(PCMDV,x)
	jmp	cbm_rdy		; prompt
?10:	jsr	cbm_getwd	; convert in integer (line number)
	bit	basic		; if in 'basic' mode tokeinize
	bpl	?12
	jsr	cbm_tokn	; tokeinize basic statement
	bra	?18		; return in Y number of bytes to store
?12:	ldx	txtp		; 'pascal' mode
	ldy	#0		; txtp point to next char after last digit
?13:	lda	!TXTBUF-4,x	; skip first blank if present
	cmp	#' '
	bne	?14
	inx
?14:	lda	!TXTBUF-4,x	; move bytes
	beq	?16
	sta	!TXTBUF,y
	inx
	iny
	bne	?14
?16:	sta	!TXTBUF,y
	iny			; +5 bytes for link, line no. and terminator
	iny
	iny
	iny
	iny
?18:	sty	txtlen		; number of bytes of new line
	stz	txtlen+1
	lda	!TXTBUF		; don't insert an empty line
	bne	?19
	jmp	cbm_main
?19:	ldx	txtend+1	; check memory room
	inx
	inx
	cpx	txttop+1	; top of memory for text buffer
	bcc	?20
	SCNPRINT		; print a warning message
	.DB	$0D, 'warning: low free memory.', $0D, $00
	
?20:	jsr	cbm_linsrch	; search line number in current text
	bcc	?50		; line no. not found -> insert new line

	; delete the current text line pointed by tlnptr
	CPU16CLC
	lda	(tlnptr)	; link to next line
	tax			; source of move
	lda	txtend
	sbc	(tlnptr)	; number of bytes to move - 1
	ldy	tlnptr		; dest. of move
?22:	mvn	#0,#0		; move next
	CPU08
	jsr	cbm_link	; link whole text
	; now can insert new line with same line number	
?50:	;;bit	basic
	;;bpl	?52
	;;lda	!TXTBUF		; basic: don't insert an empty line
	;;bne	?52
	;;jmp	cbm_main
?52:	ACC16CLC
	lda	txtend
	adc	txtlen		; new end of text
	sta	tmpval
	cmp	txttop		; compare with end of text buffer
	ACC08
	bcc	?54
	jmp	cbm_e10		; out of memory
?54:	; tlnptr = start of text to move
	; tmpval = new end of text
	; txtend = end of text to move
	CPU16CLC
	lda	txtend
	tax			; source of move
	dex			; one less (txtend point to one above)
	sbc	tlnptr		; A = no. bytes to move - 1
	ldy	tmpval		; dest. of move
	sty	txtend		; new end of text
	dey			; one less (txtend point to one above)
?55:	mvp	#0,#0		; move previous
	ldx	lineno
	stx	TXTBUF-2	; store line number
	CPU08
	ldy	txtlen		; number of bytes to copy
	dey
?56:	lda	!TXTBUF-4,y
	sta	(tlnptr),y
	dey
	bpl	?56
	jsr	cbm_link	; link whole text
	bit	autof		; handle auto
	bpl	?68		; no auto line number
	lda	!TXTBUF		; don't number new line if no text
	beq	?68
	ACC16CLC
	lda	lineno		; add auto increment
	adc	wauto
	sta	tmpval		; for conversion integer to string
	ACC08
	bcs	?70		; error (line number too large)
	jsr	_w2sb		; convert in string in NUMSTR+1
	lda	#>NUMSTR+1	; C = address
	xba
	lda	#<NUMSTR+1
	jsr	IKEYBUF		; insert string in keyboard input buffer
?68:	jmp	cbm_main
?70:	ldx	#$26
	jmp	cbm_err

cbm_tokn:
	rts
cbm_exec:
	rts
	
;---------------------------------------------------------------------------
; chrget/chrgot routine
;---------------------------------------------------------------------------

; return CF = 0 if decimal digit, otherwise CF = 1
; return ZF = 1 if char = 0 or char = ':'
cbm_chrget:
	inc	txtp		; current text pointer
	bne	?02
	inc	txtp+1
?02:
cbm_chrgot:
	lda	(txtp)
	cmp	#$3A
	bcs	?06		; ':'
	bit	skpbk		; skip blank?
	bmi	?04		; no
	cmp	#' '		; skip beginning blanks
	beq	cbm_chrget
?04:	sec
	sbc	#$30
	sec
	sbc	#$D0
?06:	rts

; link all text lines from beginning
; (C64-A533 C128-4F4F)
cbm_link:
	ACC16CLC
	lda	txtbeg		; start of text
?02:	sta	txtend		; end of text
	lda	(txtend)
	beq	?10
	ACC08
	ldy	#$03		; search end of line
?04:	iny
	lda	(txtend),y
	bne	?04
	iny
	ACC16CLC
	tya
	adc	txtend
	sta	(txtend)
	bcc	?02
?10:	lda	txtend	
	inc	a		; end of text + 1
	inc	a
	sta	txtend
	sta	!TXTEND2	; save end of text
	lda	#VALIDSGN
	sta	!TXTVSGN	; valid signature
	lda	(txtbeg)	; test if empty source text
	bne	?12
	sta	!TXTEND2	; invalid signature
	sta	!TXTVSGN
?12:	ACC08
	rts
	
; call full editor to get a line of text (until 'return')
; (C64-A560 C128-4F93)
cbm_gline:
	ldx	#$00		; index of text
?02:	KBCHARIN		; input from keyboard/editor
	cmp	#$0D		; intercept carriage return
	beq	?04
	sta	!TXTBUF,x	; store
	inx
	cpx	#TBUFMAX
	bcc	?02
	ldx	#$17		; error: string too long
	jmp	cbm_err
?04:	dex			; trim text (skip final blanks)
	bmi	?06
	lda	!TXTBUF,x
	cmp	#' '
	beq	?04
?06:	inx
	txa
	bne	?08		; line will contain at least one blank
	inx
?08:	stz	TXTBUF,x	; terminator
	SCN_CR
	ldx	#<TXTBUF-1	; return in XY pointer to buffer - 1
	ldy	#>TXTBUF-1	
	rts
	
; search text line from beginning
; (C64-A613 C128-5064)
; return: CF = 0, ZF = 1 -> end of text
;	  CF = 1, ZF = 1 -> match
;	  tlnptr point to text line	  
cbm_linsrch:
	lda	txtbeg
	ldx	txtbeg+1
cbm_linsrch2:
	xba
	txa
	xba
	ACC16
?02:	sta	tlnptr
	lda	(tlnptr)	; link to next line
	beq	?04		; end of text
	ldy	#2
	lda	lineno
	cmp	(tlnptr),y
	bcc	?06		; lineno < line
	beq	?06		; lineno = line (CF = 1)
	lda	(tlnptr)
	bcs	?02		; next line
?04:	clc
?06:	ACC08
	rts

; print line number
cbm_prline:
	lda	curline
	ldx	curline+1
; print integer
cbm_prwd:
	jsr	cbm_w2s
_prlin:
	lda	#<NUMSTR+1
	sta	longp
	lda	#>NUMSTR+1
	sta	longp+1
cbm_sprz:
	ldy	#0
?02:	lda	(longp),y
	beq	?04
	jsr	cbm_out
	iny
	bne	?02
?04:	rts

cbm_prz:
	ldy	#0
?02:	lda	[longp],y
	beq	?04
	jsr	cbm_out
	iny
	bne	?02
?04:	rts
	
; print from long pointer
cbm_prn:
	ldy	#0
?02:	lda	[longp],y
	tax
	and	#$7F
	jsr	cbm_out
	iny
	txa
	bpl	?02
	rts
	
; get word from string (C64-A96B C128-50A0)
; called after cbm_chrget if digit
; on entry: A = digit, CF = 0
; return integer in lineno - use tempval
cbm_getwd:
	ldx	#0
	stx	lineno		; clear word
	stx	lineno+1
	bcs	?06		; end with null integer
	ldx	#$80
	stx	skpbk		; don't skip blank
	stz	tmpval+1	; partial high
?02:	sbc	#$2F		; A = 0..9
	sta	tmpval
	ACC16
	lda	lineno
	asl	a
	bcs	?04		; overflow
	asl	a
	bcs	?04		; overflow
	adc	lineno
	asl	a
	bcs	?04		; overflow
	adc	tmpval
	sta	lineno
?04:	ACC08
	bcs	?08		; overflow
	jsr	cbm_chrget	; next digit
	bcc	?02
	stz	skpbk		; restore skipping beginning blank
?06:	rts
?08:	jmp	cbm_e23		; integer overflow

; convert integer tmpval in string at NUMSTR+1 and add a final blank
_w2sb:
	jsr	cbm_w2s1	; convert in string in NUMSTR+1
	ldx	#0
?02:	inx	
	lda	!NUMSTR,x	; find final 0
	bne	?02
	lda	#' '
	sta	!NUMSTR,x	; add blank
	inx
	stz	!NUMSTR,x	; add terminator
	rts

; convert integer AX in string NUMSTR terminated by #0
; if w2sf = $00 NUMSTR+1 is aligned to left
; if w2sf = $80 NUMSTR+1 is aligned to right padded with '0'
; if w2sf = $C0 NUMSTR+1 is aligned to right padded with ' '
cbm_w2s:
	sta	tmpval
	stx	tmpval+1
cbm_w2s1:	
	ldy	#0		; string index
	ldx	#8		; power of ten table access index
?02:	sty	tcnt		; save string index	
	ldy	#0		; partial quotient
	ACC16
	lda	tmpval
	sec
?03:	sbc	>POW10T,x
	bcc	?04		; stop subctract
	iny			; update quotient
	sta	tmpval		; store remainder
	bra	?03		; loop
?04:	ACC08			; here always CF = 0
	tya			; quotient
	ldy	tcnt		; current string index
	adc	#'0'
	sta	!NUMSTR+1,y
	iny			; update string index
	dex
	dex			; update power ten table index
	bpl	?02		; division loop
	tyx
	stz	NUMSTR+1,x	; string terminator
	ldx	#0
	bit	w2sf		; conversion flag
	bpl	?10		; left alignement
	bvc	?06		; right alignement with '0' - exit
	lda	#' '		; right alignement with ' '		
?05:	ldy	!NUMSTR+1,x	; scan string for non significative digit '0'
	cpy	#'0'
	bne	?06		; not digit '0' - exit
	sta	!NUMSTR+1,x
	inx
	cpx	#4		; at least leave the last digit '0'
	bcc	?05
?06:	rts
?10:	txy			; Y = 0
	lda	!NUMSTR+1
	cmp	#'0'
	bne	?06		; all digits are significative
	inx			; X = 1
?12:	lda	!NUMSTR+1,x	; scan string for non significative digit '0'
	cmp	#'0'
	bne	?16		; not digit '0' - store
	inx
	cpx	#4		; at least leave the last digit '0'
	bcc	?12
?14:	lda	!NUMSTR+1,x
?16:	sta	NUMSTR+1,y	; move digits
	beq	?06
	iny
	inx
	bra	?14

;---------------------------------------------------------------------------
; 'xput/xget/xexx/xclr' command's (basic/pascal)
;---------------------------------------------------------------------------
	
cbm_xput:
	beq	?01
	jmp	er0b
?01:	ACC16
	lda	(txtbeg)
	ACC08
	beq	er29
	lda	>CRFWEOFF
	tax
	sta	>CRFWEON	; enable write in bank $FE RAM
	lda	tbnk		; the source bank
	sta	>?10+2		; store source bank for mvn istruction
	lda	xbnk
	sta	>?10+1		; store dest. bank for mvn istruction
	sta	>CRFWEOFF,x	; disable writing in bank $FE
	CPU16CLC
	lda	txtend		; # number of bytes - 1
	sbc	txtbeg
	ldx	txtbeg
	txy
	phb	
?10:	mvn	#0, #0
	plb
	lda	#VALIDSGN
	sta	!XBVSGN		; valid signature
	lda	txtend
	sta	xtop
	sta	!XTOP2		; save
	CPU08
	lda	#$80
	sta	vxflag		; valid text in x-bank
	rts

cbm_xget:
	bne	er0b
	bit	vxflag
	bpl	er2a		; exchange bank is empty
	lda	>CRFWEOFF
	tax
	sta	>CRFWEON	; enable write in bank $FE RAM
	lda	xbnk		; the source bank
	sta	>?10+2		; store source bank for mvn istruction
	lda	tbnk
	sta	>?10+1		; store dest. bank for mvn istruction
	sta	>CRFWEOFF,x	; disable writing in bank $FE
	CPU16CLC
	lda	#VALIDSGN
	sta	!TXTVSGN	; valid signature
	lda	xtop	
	sta	txtend		; # number of bytes
	sta	!TXTEND2	; save end of text
	sbc	txtbeg	
	ldx	txtbeg
	txy
	phb
?10:	mvn	#0, #0
	plb	
	CPU08
	rts
	
er29:
	ldx	#$29		; no source program
	jmp	cbm_err
er0b:
	jmp	cbm_e0b		; syntax

er2a:
	ldx	#$2A		; exchange bank empty
	jmp	cbm_err
	
cbm_xclr:
	bne	er0b
	jsr	cbm_yn
	bne	?10
	stz	longp
	stz	longp+1
	lda	xbnk
	sta	longp+2
	ldy	#0
	tya
	sta	[longp]
	iny
	sta	[longp],y
	iny
	sta	[longp],y
	ACC16
	stz	!XBVSGN		; invalid signature
	stz	!XTOP2
	stz	xtop
	ACC08
	lda	#$80
	trb	vxflag
?10:	rts
	
cbm_xexx:
	bne	er0b
	ACC16
	lda	(txtbeg)
	ACC08
	beq	er29
	bit	vxflag
	bpl	er2a		; exchange bank is empty
	lda	>CRFWEOFF
	tax
	sta	>CRFWEON	; enable write in bank $FE RAM
	lda	tbnk		; the source bank
	sta	>?10+2		; store source bank for mvn istruction
	lda	cbnk
	sta	>?10+1		; store dest. bank for mvn istruction
	lda	xbnk		; the source bank
	sta	>?20+2		; store source bank for mvn istruction
	lda	tbnk
	sta	>?20+1		; store dest. bank for mvn istruction
	lda	cbnk		; the source bank
	sta	>?30+2		; store source bank for mvn istruction
	lda	xbnk
	sta	>?30+1		; store dest. bank for mvn istruction	
	sta	>CRFWEOFF,x	; disable writing in bank $FE
	phb
	CPU16CLC
	lda	txtend		; # number of bytes
	sbc	txtbeg
	sta	tmpval		; save for later use
	ldx	txtbeg
	txy	
?10:	mvn	#0, #0		; move t-bank to c-bank (tmp)
	clc
	lda	xtop
	sbc	txtbeg
	ldx	txtbeg
	txy
?20:	mvn	#0, #0		; move x-bank to t-bank
	ldx	txtbeg
	txy
	lda	tmpval		; # number of bytes
?30:	mvn	#0, #0		; move c-bank (tmp) to x-bank
	plb
	lda	txtend		; exchange end of text
	ldx	xtop
	stx	txtend
	sta	xtop
	sta	!XTOP2
	stx	TXTEND2
	CPU08
_?31:	rts
	
;---------------------------------------------------------------------------
; 'list/del' command's (basic/pascal)
;---------------------------------------------------------------------------

cbm_del:
	bne	?04
	jmp	cbm_e0b
?04:	jsr	_dlparm		; get param's
	jsr	_nxtln		; search first line that match
	bcc	_?31		; no match - exit
	ACC16
	lda	tlnptr		; save ptr to first line to delete
	sta	longp
	ACC08
	lda	>CRFWEOFF
	tax
	sta	>CRFWEON	; enable write in bank $FE RAM
	lda	tbnk		; the source and dest. bank
	sta	>?10+2		; store source bank for mvn istruction
	sta	>?10+1		; store dest. bank for mvn istruction
	sta	>CRFWEOFF,x	; disable writing in bank $FE	
?06:	jsr	_nxtln		; search next line that match
	bcs	?06		; match
	; now tlnptr is the line that follow the last to delete
	CPU16CLC
	ldy	longp		; destination of the block move
	ldx	tlnptr		; source of the block move
	lda	txtend
	sbc	tlnptr		; number of bytes - 1
	phb
?10:	mvn	#0, #0		; move block backward
	plb
	CPU08
	jsr	cbm_link	; re-link whole text

cbm_lst:
	jsr	_dlparm		; get param's
	lda	#$0D
	jsr	cbm_out
?02:	jsr	_nxtln
	bcc	?04		; end list
	jsr	_lnlst
	jsr	CHKSTOP
	bne	?02
?04:	rts
	
; get next text line from tlnptr
_nxtln:
	ACC16CLC
	lda	(tlnptr)	; next link
	sta	tlnptr		; new link
	lda	(tlnptr)	; link to next line
	beq	?02		; exit with CF = 0
	ldy	#2
	lda	(tlnptr),y	; line number
	sta	tmpval		; save
	lda	lineno
	cmp	tmpval		; return CF = 0 if lineno < line
?02:	ACC08
	rts

; list one text line pointed by tlnptr - line number in tmpval
_lnlst:
	jsr	_w2sb		; integer to string
	jsr	_prlin		; print line number
	ldy	#4
?02:	lda	(tlnptr),y
	beq	?08
	bit	basic
	bmi	?10
?07:	jsr	cbm_out
	iny
	bne	?02
?08:	lda	#$0D
	jmp	cbm_out

?10:	and	#$7F		; list basic token
	bra	?07
	
;---------------------------------------------------------------------------
; get param's for list/delete
;---------------------------------------------------------------------------

_dlparm:
	bcc	?02		; digit
	tax
	beq	?02		; nothing
	cmp	#'-'
	bne	_?0		; syntax error
?02:	jsr	cbm_getwd
	jsr	cbm_linsrch	; set pointer tlnptr
	jsr	cbm_chrgot
	beq	?04
	cmp	#'-'
	bne	_?0		; syntax error
	jsr	cbm_chrget
	jsr	cbm_getwd	; final line number
	bne	_?0		; error
	tax
	bne	_?0		; error
?04:	ACC16
	lda	lineno
	bne	?06
	dec	a
	sta	lineno		; set to $FFFF
?06:	lda	tlnptr		; save line pointer
	sta	!TMPPTR		; for easy loop
	lda	#TMPPTR
	sta	tlnptr
	ACC08
	rts
	
;---------------------------------------------------------------------------
; 'restore' command (basic)
;---------------------------------------------------------------------------
	
cbm_rst:
	bne	_?0
	sec
	lda	txtbeg
	sbc	#$01
	ldy	txtbeg
	bcs	?02
	dey
?02:	sta	datptr
	sty	datptr+1
	rts

;---------------------------------------------------------------------------
; 'auto' command (basic/pascal)
;---------------------------------------------------------------------------

cbm_auto:
	jsr	cbm_dir		; check if in direct mode
	tax
	beq	?10		; disable auto
	bcs	_?0		; error if no digit
	jsr	cbm_getwd	; integer in lineno
	ACC16
	lda	lineno
	sta	wauto
	ACC08
	beq	?10		; integer = 0 -> disable auto
	lda	#$80
?10:	sta	autof		; enable auto number
	rts
_?0:	jmp	cbm_e0b		; syntax

;---------------------------------------------------------------------------
; 'monitor' command (basic/pascal)
;---------------------------------------------------------------------------

cbm_mon:
	jsr	cbm_dir		; check if in direct mode
	bne	_?0
	jmp	GOMON

;---------------------------------------------------------------------------
; 'new' command (basic/pascal)
;---------------------------------------------------------------------------

cbm_new:
	jsr	cbm_dir		; check if in direct mode
	bne	_?0
	jsr	cbm_yn
	bne	_?1
cbm_new2:
	ldy	#0
	ACC16
	tya			; clear text buffer
	sta	(txtbeg)
	lda	txtbeg
	inc	a
	inc	a
	sta	txtend		; update end pointer
	sta	!TXTEND2	; save end of text
	stz	!TXTVSGN	; invalid signature
	ACC08
	lda	#$40
	trb	vxflag
	jsr	cbm_setp	; set charget pointer
	lda	#0

;---------------------------------------------------------------------------
; 'clr' command (basic)
;---------------------------------------------------------------------------
	
cbm_clr:
	bne	_?0
	jsr	FCLALL
	lda	txttop
	ldy	txttop+1
	sta	freetop
	sty	freetop+1
	lda	varbeg
	ldy	varbeg+1
	sta	arytab
	sty	arytab+1
	sta	strend
	sty	strend+1
	jsr	cbm_rst
	
; reset stack
cbm_res:
	ldx	#$1B
	stx	tmppt
	stz	facov
	stz	runf
	stz	subflg
	stz	prompt
	CPU16
	pla			; return address
	ldx	curstk		; set default stack ptr
	txs
	pha			; restore return address
	CPU08
_?1:	rts
	
; set text pointer for charget	
cbm_setp:
	clc
	lda	txtbeg
	adc	#$FF
	sta	txtp
	lda	txtbeg+1
	adc	#$FF
	sta	txtp+1
	rts

;---------------------------------------------------------------------------
; 'pc' command - start pascal compiler
;---------------------------------------------------------------------------

_dotfg		.EQU	tmpb0	; flag dot for file name parsing
_maxcnt		.EQU	tmpb1	; max. chars number for file name parsing
_cnt		.EQU	tmpb2	; current count of chars while parsing
_fnamp		.EQU	tlnptr	; pointer to file name
_fextp		.EQU	tmpval	; pointer to extension
_optfg		.EQU	tmpwrk		; options flag
_opt2fg		.EQU	tmpwrk+1	; options flag
_savey		.EQU	tmpwrk+2	; string index
_save2		.EQU	tmpwrk+3	; string index

; load text from disk (channel = tmpb0, A)
bufload:
	stz	tmpwrk
	sta	tmpb0
	jsr	dsksnd
	bcc	?get
	rts
?get:	lda	cbnk
	sta	fbufpt2
	ACC16
	stz	fbufpt
	stz	tmpval		; index
	stz	lineno
	ACC08
	lda	fbufpt2		; bank of buffer
	pha
	pei	(fbufpt)	; address of buffer
	pea	#$FFFE		; buffer size
	lda	tmpb0		; chnl
	pha
	cmp	#1
	bne	?rd
	inc	a		; A = 2
	sta	tmpval		; load: skip start address
	lda	#$80
	sta	tmpwrk		; program flag
?rd:	CBMFSRD			; read buffer
	php
	sta	txtp		; size
	xba
	sta	txtp+1
	lda	tmpb0
	CBMFSCLS		; close chnl
	plp
	bcc	?ok
	jmp	dskerr
?ok:	ACC16
	lda	txtp
	bne	?ok2
	jmp	?nop
?ok2:	lda	txtbeg
	sta	tlnptr
	ACC08
	bit	tmpwrk
	bpl	?txt
	jmp	?pgm		; program
?txt:	INDEX16
?lp:	ldy	tmpval
	cpy	txtp
	bcs	?eof		; end of file	
	ldy	#2
	ACC16CLC
	lda	lineno
	adc	#5
	sta	lineno
	sta	(tlnptr),y
	ACC08
	iny
	iny
?lp0:	tyx
	ldy	tmpval
?lp1:	lda	[fbufpt],y
	iny
	cmp	#$0D
	beq	?lp1
	cmp	#$0A
	beq	?lp4
	sty	tmpval
	txy
	sta	(tlnptr),y
	iny
	bra	?lp0
?lp4:	sty	tmpval	
	txy	
	cpy	#4
	bne	?lp6
	lda	#' '
	sta	(tlnptr),y
	iny
?lp6:	lda	#0
	sta	(tlnptr),y
	iny
	ACC16CLC
	tya
	adc	tlnptr
	cmp	txttop
	bcs	?end		; out of memory
	sta	(tlnptr)
	sta	tlnptr
	ACC08
	bra	?lp
?eof:	clc
?end:	CPU08	
	php	
	CPU16
	lda	#0
	sta	(tlnptr)
	sta	lineno
	lda	tlnptr
	inc	a
	inc	a
	sta	txtend
	sta	!TXTEND2	; save end of text
	lda	#VALIDSGN
	sta	!TXTVSGN	; valid signature
	lda	(txtbeg)	; test if empty source text
	bne	?end2
	sta	!TXTEND2	; invalid signature
	sta	!TXTVSGN
?end2:	CPU08	
	plp
	bcs	?mem
	rts	
	
?nop:	CPU08
	ldx	#$2F		; empty disk file
	jmp	cbm_err
?mem:
	ldx	#$10
	jmp	cbm_err
	
?pgm:	rts


; save text editor buffer to compiler/tmp bank (no link, no line number) 
txtsave:
	lda	cbnk
	sta	fbufpt2
	stz	fbufpt
	stz	fbufpt+1
	stz	tmpval		; index
	stz	tmpval+1
	INDEX16
?lp:	ldy	#4
?lp1:	lda	(tlnptr),y
	beq	?eol
	tyx
	ldy	tmpval
	sta	[fbufpt],y
	iny
	sty	tmpval
	txy
	iny
	bra	?lp1
?eol:	lda	#$0D
	ldy	tmpval
	sta	[fbufpt],y
	iny
	lda	#$0A
	sta	[fbufpt],y
	iny
	sty	tmpval
	ACC16
	lda	(tlnptr)	; next link
	sta	tlnptr		; new link
	lda	(tlnptr)	; link to next line
	ACC08
	bne	?lp
	CPU08
	rts

; rename file on disk
; rename "filename", Dn TO "newname"
cbm_rename:
	jsr	cbm_fname		; Y = length
	sty	<_savey
	ACC16
	lda	#TXTBUF+$C0
	sta	<_fextp
	ACC08
	iny
?nam1:	lda	(_fnamp),y
	sta	(_fextp),y
	dey
	bpl	?nam1
	stz	<_cnt
	jsr	cbm_chkdr		; require Dn
	stx	truedsk			; save true disk
	stx	<_save2
	cmp	#'t'
	beq	?ok
	cmp	#'T'
	bne	?er
?ok:	ldy	#1
	lda	(txtp),y
	cmp	#'o'
	beq	?ok2
	cmp	#'O'
	beq	?ok2
?er:	jmp	cbm_e0b
?ok2:	jsr	cbm_chrget
	jsr	cbm_chrget
	cmp	#'"'
	bne	?er
	jsr	cbm_fname
	sty	<_cnt
	jsr	cbm_chrgot
	bne	?er
	ldx	#'R'
	bra	cbmdsk10

; copy disk files
; copy Dn TO Dm
; copy "source_name", Dn TO Dm (same name)
; copy "source_name", Dn TO "dest_name", Dm
; copy "source_name", Dn TO "dest_name" (same drive)
cbm_copy:
	jsr	cbm_chrgot
	cmp	#'"'
	beq	?nam
	jsr	get2dsk
	lda	#'C'
	jmp	cbm_ddup2
?nam:	jsr	cbm_fname
	sty	<_savey
	ACC16
	lda	#TXTBUF+$C0
	sta	<_fextp
	ACC08
	iny
?nam1:	lda	(_fnamp),y
	sta	(_fextp),y
	dey
	bpl	?nam1
	stz	<_cnt
	jsr	cbm_chkdr		; require Dn
	stx	truedsk			; save source disk
	stx	<_save2
	beq	?er
	cmp	#'t'
	beq	?ok
	cmp	#'T'
	bne	?er
?ok:	ldy	#1
	lda	(txtp),y
	cmp	#'o'
	beq	?ok2
	cmp	#'O'
	beq	?ok2
?er:	jmp	cbm_e0b
?ok2:	jsr	cbm_chrget
	jsr	cbm_chrget
	cmp	#'"'
	beq	?nam2
	jsr	cbm_chkdr2		; require Dm
	stx	<_save2			; dest. drive
	cpx	truedsk
	beq	?er2	
	jsr	cbm_chrgot
	beq	?ok3
?er2:	jmp	cbm_e0e	
?nam2:	jsr	cbm_fname
	sty	<_cnt
	jsr	cbm_chrgot
	beq	?ok3
	jsr	cbm_chkdr1		; require Dm
	stx	<_save2			; dest. drive
	;cpx	truedsk
	;beq	?er2	
	jsr	cbm_chrgot
	bne	?er
?ok3:	ldx	#'C'

cbmdsk10:
	ACC16
	lda	#TXTBUF
	sta	txtp
	ACC08
	txa
	sta	(txtp)
	ldy	#1
	lda	<_save2
	ora	#'0'
	sta	(txtp),y
	iny
	lda	#':'
	sta	(txtp),y
	iny
	ldx	<_cnt			; dest name
	beq	?ok4
	stz	tmpb0
?lp1:	tyx	
	ldy	tmpb0
	lda	(_fnamp),y
	beq	?lp2
	txy
	sta	(txtp),y
	iny
	inc	tmpb0
	bra	?lp1
?lp2:	txy
	bra	?ok5
?ok4:	lda	#'*'
	sta	(txtp),y
	iny
?ok5:	lda	#'='
	sta	(txtp),y
	iny
	lda	truedsk
	ora	#'0'
	sta	(txtp),y
	iny
	lda	#':'
	sta	(txtp),y
	iny	
	stz	tmpb0
?lp3:	tyx	
	ldy	tmpb0
	lda	(_fextp),y
	beq	?lp4
	txy
	sta	(txtp),y
	iny
	inc	tmpb0
	bra	?lp3
?lp4:	txy
	sta	(txtp),y
	jmp	dskcmd

; duplicate disk
; ddup Dn TO Dm (n not same m)
cbm_ddup:
	jsr	get2dsk
	lda	#'D'
cbm_ddup2:
	sta	(txtp)
	ldy	#1
	lda	<_cnt			; dest
	ora	#'0'
	sta	(txtp),y
	iny
	lda	#'='
	sta	(txtp),y
	iny	
	lda	truedsk			; source
	ora	#'0'
	sta	(txtp),y
	bra	cbm_dsk2		

; validate disk bam
; chkdsk Dn [,V]
cbm_chkdsk:
	lda	#'F'			; check only
	sta	<_cnt	
	jsr	cbm_chrgot
	jsr	cbm_chkdr2		; require Dn
	stx	truedsk			; save true disk	
	beq	?go			; no pattern
	cmp	#','
	beq	?fg
?er:	jmp	cbm_e0b			; syntax
?fg:	jsr	cbm_chrget
	cmp	#'v'
	beq	?ok
	cmp	#'V'			; validate bam
	bne	?er
?ok:	lda	#'V'	
	sta	<_cnt
	jsr	cbm_chrget
	bne	?er
?go:	ACC16
	lda	#TXTBUF
	sta	txtp
	ACC08
	lda	<_cnt
	bra	cbm_dsk1
	
; init disk
; dinit Dn
cbm_dinit:
	jsr	cbm_chrgot
	jsr	cbm_chkdr2		; require Dn
	stx	truedsk			; save true disk	
	beq	?go			; no pattern
	jmp	cbm_e0b			; syntax
?go:	ACC16
	lda	#TXTBUF
	sta	txtp
	ACC08
	lda	#'I'
cbm_dsk1:
	sta	(txtp)
	ldy	#1
	lda	<truedsk
	ora	#'0'
	sta	(txtp),y
cbm_dsk2:
	iny
	lda	#0
	sta	(txtp),y
	jmp	dskcmd

; remove disk file
; rm "pattern", Dn
cbm_rm
	jsr	cbm_fname		; Y = length
	sty	<_cnt
	jsr	cbm_chkdr		; require Dn
	stx	truedsk			; save true disk
	bne	?er
?lp1:	ACC16
	lda	<_fnamp
	dec	a
	dec	a
	dec	a
	sta	txtp
	ACC08
	lda	#'S'
	sta	(txtp)
	ldy	#1
	lda	<truedsk
	ora	#'0'
	sta	(txtp),y
	iny
	lda	#':'
	sta	(txtp),y
	jmp	dskcmd
?er:	jmp	cbm_e0b			; syntax

; load text file
; load "nomefile", Dn
cbm_load:
	jsr	cbm_fname		; Y = length
	sty	<_cnt
	jsr	cbm_chkdr		; require Dn
	stx	truedsk			; save true disk
	bne	?er
	ACC16
	lda	<_fnamp
	dec	a
	dec	a
	sta	txtp
	ACC08
	lda	<truedsk
	ora	#'0'
	sta	(txtp)
	ldy	#1
	lda	#':'
	sta	(txtp),y
	ldy	<_cnt
	iny
	iny
	ldx	#3
?lp:	lda	>?str,x
	sta	(txtp),y
	iny
	dex
	bpl	?lp
	lda	#0
	sta	(txtp),y
	lda	#$02			; chnl = 2
	jmp	bufload	
?er:	jmp	cbm_e0b			; syntax	
?str:	.DB	'R,S,'

; save text file
; save "nomefile", Dn [,O]
cbm_save:
	jsr	cbm_fname		; Y = length
	sty	<_cnt
	jsr	cbm_chkdr		; require Dn
	stx	truedsk			; save true disk
	stz	<_optfg
	beq	?ok
	jsr	cbm_mtopt
	cmp	#'O'
	bne	?er
	lda	#$80
	sta	<_optfg
	jsr	cbm_chrget
	beq	?ok
?er:	jmp	cbm_e0b			; syntax	
?ok:	ACC16
	lda	<_fnamp
	dec	a
	dec	a
	dec	a
	sta	txtp
	ACC08
	lda	#'@'
	sta	(txtp)
	ldy	#1
	lda	<truedsk
	ora	#'0'
	sta	(txtp),y
	iny
	lda	#':'
	sta	(txtp),y
	ldy	<_cnt
	iny
	iny
	iny
	ldx	#3
?lp:	lda	>?str,x
	sta	(txtp),y
	iny
	dex
	bpl	?lp
	lda	#0
	sta	(txtp),y
	bit	<_optfg
	ACC16
	bmi	?noo
	inc	txtp
?noo:	lda	txtbeg
	sta	tlnptr
	lda	(tlnptr)
	ACC08
	bne	?ok2
	jmp	er29		; no source file in memory
?ok2:	
	lda	#2		; chnl = 2
	jsr	dsksnd
	bcc	?sav
	rts

?sav:	jsr	txtsave
	lda	fbufpt+2
	pha
	pei	(fbufpt)	; buffer pointer 
	pei	(tmpval)	; size
	lda	#2		; chnl = 2
	pha
	CBMFSWR			; write
	php
	lda	#2		; close
	CBMFSCLS
	plp
	bcc	?end
	jmp	dskerr
?end:	rts

?str:	.DB	'W,S,'

; print disk directory
; dir Dn [, "pattern"]
cbm_lsdir:
VARSIZ	.SET	256		; mult. of 32 !!!

	jsr	cbm_chrgot
	jsr	cbm_chkdr2		; require Dn
	stx	truedsk			; save true disk	
	stz	<_cnt
	beq	?go			; no pattern
	cmp	#','
	beq	?nam
?er:	jmp	cbm_e0b			; syntax
?nam:	jsr	cbm_chrget
	jsr	cbm_fname
	sty	<_cnt
	jsr	cbm_chrgot
	bne	?er
	ACC16
	lda	<_fnamp
	dec	a
	dec	a
	dec	a
	sta	txtp
	ACC08
	bra	?g02
?go:	ACC16
	lda	#TXTBUF
	sta	txtp
	ACC08
?g02:	lda	#'$'
	sta	(txtp)
	ldy	#1
	lda	<truedsk
	ora	#'0'
	sta	(txtp),y
	iny
	lda	<_cnt
	bne	?go3
	sta	(txtp),y
	bra	?go4
?go3:	lda	#':'
	sta	(txtp),y
	lda	#0
?go4:	jsr	dsksnd
	bcc	?dir
	rts

?dir:
atbuf	.SET	txtp
atend	.SET	tlnptr
atstart	.SET	tmpval
atdir	.SET	tmpb2
atptr	.SET	fbufpt

	ACC16			; make room in stack
	tsc
	sec
	sbc	#VARSIZ
	tcs
	inc	a		; buffer pointer
	sta	<atbuf
	stz	<atend		; buffer count #
	ACC08
	stz	<atdir
	stz	<atptr+2
	lda	#6		; offset # blocks header
	sta	<atstart
	stz	<atstart+1
	SCN_CR
?10:	jsr	?100		; load buffer
	bcs	?91
	beq	?90		; no data: end of load
?14:	ldy	<atstart	
	phy
?14a:	lda	[atptr],y
	cmp	#' '
	bne	?14b
	iny
	bra	?14a
?14b:	sty	<atstart
	ply
	
	ACC16CLC
	lda	<atptr
	adc	<atstart
	ldx	#0
	phx			; bank of string (stack)
	pha			; address of string
	;;ldy	<atstart
	dey
	dey
	lda	[atptr],y	; blocks #
	pha
	ACC08
	phk			; bank of format
	pea	#!?200		; address of format
	ldx	#9		; # params
	phx
	BPRINTF
	lda	#4		; just header need offset = 6
	sta	<atstart
	ACC16CLC
	lda	<atptr
	adc	#32
	sta	<atptr
	cmp	<atend
	ACC08
	bcc	?14		; next line in buffer
	bit	<atdir		; bit 7 set if end
	bpl	?10		; loop
?90:	ACC16CLC
	tsc			; clean stack
	adc	#VARSIZ
	tcs
	ACC08
	lda	#0
	CBMFSCLS
?91:	rts

?100:	lda	#0		; load buffer
	pha			; bank of buffer
	pei	(atbuf)		; address of buffer
	pea	#VARSIZ		; size of buffer
	lda	#$00
	pha			; chnl 0
	CBMFSRD			; read	
	bcc	?104
	pla
	pla
	ACC16CLC
	tsc			; clean stack
	adc	#VARSIZ
	tcs
	ACC08
	lda	#0
	CBMFSCLS	
	jmp	dskerr
?104:	ACC16
	pha
	pla
	beq	?110		; end of data
	cmp	#VARSIZ
	bcs	?106
	ldx	#$80
	stx	<atdir		; EOF flag
?106:	clc
	adc	<atbuf
	sta	<atend		; end buffer
	lda	<atbuf
	sta	<atptr
?110:	ACC08
	clc
	rts
	
?200:
	.DB	'% 4hu %s', $0D, 0

; format disk
; format "diskname" ,Dn [,Iid] [,Q]
cbm_fmt:
	jsr	cbm_fname		; Y = length
	sty	<_cnt
	jsr	cbm_chkdr		; require Dn
	stx	truedsk			; save true disk	
	stz	<_optfg
	beq	?lp1			; no options
?lp:	jsr	?fmt			; get options
	bne	?lp
?lp1:	ACC16
	lda	<_fnamp
	dec	a
	dec	a
	dec	a
	sta	txtp
	ACC08
	lda	#'Q'		; quick format?
	bit	<_optfg
	bmi	?set		; yes
	lda	#'N'
?set:	sta	(txtp)
	ldy	#1
	lda	<truedsk
	ora	#'0'
	sta	(txtp),y
	iny
	lda	#':'
	sta	(txtp),y
	bit	<_optfg
	bvc	?go		; no ID
	ldy	<_cnt
	iny
	iny
	iny
	lda	#','
	sta	(txtp),y
	lda	<tmpwrk+2
	iny
	sta	(txtp),y
	lda	<tmpwrk+3
	iny
	sta	(txtp),y
	iny
	lda	#0
	sta	(txtp),y
?go:	bra	dskcmd
	
?fmt:	jsr	cbm_mtopt
	cmp	#'Q'
	bne	?fmt2
	lda	#$80
	tsb	<_optfg		; optfg<7>: 'Q' -> quick format
	bra	?end
?fmt2:	cmp	#'I'
	beq	?fmt4
?fmt3:	jmp	cbm_e0b		; syntax
?fmt4:	lda	#$40
	tsb	<_optfg		; optfg<6>: 'I' -> id code
	ACC16
	lda	txtp
	inc	a
	sta	txtp
	ACC08
	lda	(txtp)
	beq	?fmt3
	jsr	?gid
	sta	<tmpwrk+2
	ldy	#1
	lda	(txtp),y
	beq	?fmt3
	jsr	?gid
	sta	<tmpwrk+3
	ACC16
	lda	txtp
	inc	a
	sta	txtp
	ACC08
?end:	jmp	cbm_chrget
?gid:	cmp	#'0'
	bcc	?gerr
	cmp	#'9'+1
	bcc	?gide
	cmp	#'A'
	bcc	?gerr
	cmp	#'Z'+1
	bcc	?gide
	cmp	#'a'
	bcc	?gerr
	cmp	#'z'+1
	bcs	?gerr
	and	#$DF
?gide:	rts
?gerr:	jmp	cbm_e0e

; send command to cbm fs emulator
dskcmd:
	lda	#15

dsksnd:
	phb			; bank of cmnd string
	pei	(txtp)		; address of cmnd string
	pha			; chnl
	CBMFSCMD		; send command
	bcs	dskerr		; if error
	rts

; print disk error message
dskerr:
VARSIZ	.SET	128
	SCN_CR
	ACC16			; make room in stack
	tsc
	sec
	sbc	#VARSIZ
	tcs
	inc	a		; buffer pointer
	ldx	#0
	phx			; bank of buffer
	pha			; address of buffer
	pea	#VARSIZ		; size of buffer
	ACC08
	lda	#15		; channel 15
	pha
	CBMFSRD			; read
	ACC16
	tsc
	inc	a		; address of buffer
	ACC08
	ldx	#0		; bank of buffer
	SCNSTROUT		; print string
	ACC16CLC
	tsc			; clean stack
	adc	#VARSIZ
	tcs
	ACC08
	sec
	rts

; load a p-code object file and convert in executable file
; fpl "filename", Dn
cbm_fpl:
	.EXTERN pclink

	jsr	fplopts	
	lda	#$0E		; chnl = 14
	jsr	dsksnd		; open file
	bcs	?ret		; error
	
	SCNPRINT
	.DB	'loading...', $0D, 0

	stz	iecwp
	stz	iecwp+1
	lda	jbnk
	sta	iecwp+2
	stz	tmpb0		; eof flag
?lp:	jsr	fplld
	bcs	?err
	bit	tmpb0
	bpl	?lp		; no eof
	lda	#$0E
	CBMFSCLS
	jsr	?msg1
	phb
	jsr	pclink
	plb
	lda	#$80
	sta	pcodef
	bra	fpxsav
?err:	jsr	dskerr
	lda	#$0E
	CBMFSCLS	
?ret:	rts

?msg1:	SCNPRINT
	.DB	'linking...', $0D, 0
	rts

; save exec p-code
fpxsav:
	jsr	?msg2
	lda	vbnk
	sta	longp+2		; pointer to p-code
	stz	longp
	stz	longp+1
	ACC16
	lda	[longp]
	sta	txtp		; size of p-code
	ACC08
	lda	xbnk
	pha			; bank of cmnd string
	pea	#EXEDST		; address of cmnd string
	lda	#$0E
	pha			; chnl
	CBMFSCMD		; send command
	bcs	?err		; if error
	jsr	?sgn		; store signature	
	bcs	?err
	lda	longp+2
	pha
	pei	(longp)
	pei	(txtp)
	lda	#$0E
	pha
	CBMFSWR
	bcs	?err
	lda	#$0E
	CBMFSCLS
	rts
?err:	jsr	dskerr
	lda	#$0E
	CBMFSCLS	
?ret:	rts

?sgn:	ldx	#PCXSSIZ-1
	phb
	lda	xbnk
	pha
	plb
?sgn1:	stz	.ABS.PASSRC,x
	dex
	bpl	?sgn1
	ldx	#PCXHSIZ-1
?sgn2:	lda	>PCXSGN,x
	sta	.ABS.PASSRC,x
	dex
	bpl	?sgn2
	ACC16
	lda	txtp		; p-code size
	sta	!PASSRC+12
	lda	#PCXSSIZ	; header size
	sta	!PASSRC+16
	ACC08
	lda	xbnk
	pha
	pea	#PASSRC
	pea	#PCXSSIZ
	lda	#$0E
	pha
	CBMFSWR
	plb
	rts

?msg2:	phb
	lda	xbnk
	pha
	plb
	lda	fnlen
	sec
	sbc	#4
	sta	fnlen		; skip ',S,W'
	ldy	#0
?lp2:	lda	.ABS.EXEDST,y
	cmp	#'a'
	bcc	?lp3
	cmp	#'z'+1
	bcs	?lp3
	and	#$DF
?lp3:	sta	.ABS.PASSRC,y
	iny
	cpy	fnlen
	bcc	?lp2
	lda	#0
	sta	.ABS.PASSRC,y
	lda	.ABS.PASSRC+1	; drive
	plb
	pha			; drive
	lda	xbnk
	pha
	pea	#PASSRC+3	; string addr
	phk
	pea	#?str
	lda	#8
	pha
	BPRINTF
	rts

?str:	.DB	'saving "%s" to drive %c...', 13, 0

fplld:
	lda	iecwp+2		; bank of buffer
	pha
	pei	(iecwp)		; address of buffer
	pea	#$8000		; buffer size
	lda	#$0E		; chnl
	pha
	CBMFSRD			; read buffer
	php
	sta	txtp		; size
	xba
	sta	txtp+1
	plp
	bcs	?ret
	ACC16CLC
	ldx	#$80		; eof flag
	ldy	iecwp+2
	lda	txtp
	beq	?eof		; eof
	adc	iecwp
	sta	iecwp
	bcc	?tst
	iny
	sty	iecwp+2
?tst:	lda	txtp	
	cmp	#$8000
	bcs	?end
?eof:	stx	tmpb0
?end:	ACC08
	clc
?ret:	rts
	
fplopts:
	jsr	cbm_fname	; Y = length
	sty	<_cnt
	jsr	cbm_chkdr	; require Dn
	stx	truedsk		; save true disk
	ACC16
	lda	<_fnamp
	dec	a
	dec	a
	sta	txtp
	ACC08
	lda	<truedsk	; add disk
	ora	#'0'
	sta	(txtp)
	ldy	#1
	lda	#':'
	sta	(txtp),y
	ldy	<_cnt		; update string size
	iny
	iny
	sty	<_cnt
	lda	xbnk		; prepare files names pointers
	sta	fbufpt+2
	ACC16
	lda	#EXEDST
	sta	fbufpt		; '.PXE' executable file
	ACC08
	lda	#'@'
	sta	[fbufpt]	; overwrite '.PXE' file
	ACC16
	inc	fbufpt
	ACC08
	cpy	#7
	bcc	?tst2		; name cannot terminate with '.OBJ'
	ldx	#3		; check extension '.OBJ'
	dey
?lp:	lda	(txtp),y
	cmp	#'a'		; convert in upper case
	bcc	?cmp
	cmp	#'z'+1
	bcs	?cmp
	and	#$DF
?cmp:	cmp	>?obj2,x
	bne	?tst		; unmatch
	dey
	dex
	bpl	?lp
	iny
	bra	?mv		; move string
?tst:	ldy	<_cnt
?tst2:	cpy	#15
	bcc	?mv
	ldy	#14
?mv:	tyx			; how much char to move
	ldy	#0
?lp1:	lda	(txtp),y	; move string
	sta	[fbufpt],y	; exec file
	iny
	dex
	bne	?lp1
	ldx	#3		; store extension '.PXE'
?lp2:	lda	>?pxe,x
	sta	[fbufpt],y
	iny
	dex
	bpl	?lp2
	sty	fnlen
	ldx	#3
?lp3:	lda	>?rds,x
	ldy	<_cnt
	sta	(txtp),y
	iny
	sty	<_cnt
	ldy	fnlen
	sta	[fbufpt],y
	iny
	sty	fnlen
	dex
	bpl	?lp3
	dey
	lda	#'W'
	sta	[fbufpt],y
	iny
	lda	#0
	sta	[fbufpt],y
	iny			; take in account '@' at beginning
	sty	fnlen
	ldy	<_cnt
	sta	(txtp),y
	rts

?pxe:	.DB	'EXP.'
?obj2:	.DB	'.OBJ'
?rds:	.DB	'R,S,'
	

; load & execute a p-code executable file
; fpx "filename", Dn [ommand line]
; assume default .PXE extension
cbm_fpx:
	jsr	fpxopts	
	stz	pcodef	
	lda	#$0E		; chnl = 14
	jsr	dsksnd		; open file
	bcs	?ret		; error
	jsr	ldsgn		; check signature
	bcs	?err
	bne	?cls		; no exec p-code

	SCNPRINT
	.DB	'loading...', $0D, 0
	
	lda	vbnk
	sta	longp+2
	stz	longp
	stz	longp+1
	pha
	pei	(longp)
	pei	(txtp)
	lda	#$0E
	pha
	CBMFSRD
	bcs	?err
	ACC16
	lda	txtp
	cmp	[longp]
	ACC08
	bne	?cls
	lda	#$80		; ok
	sta	pcodef		
?cls:	lda	#$0E
	CBMFSCLS
	ACC16
	lda	cmdlin
	sta	txtp
	lda	#$FF00
	sta	longp
	ACC08
	lda	vbnk
	sta	longp+2
	ldx	#0
	txy
?lp:	lda	[longp],y
	sta	!$FF00,x
	inx
	iny
	bne	?lp
	jmp	cbm_pcrun
?err:	jsr	dskerr
	lda	#$0E
	CBMFSCLS	
?ret:	rts
	
fpxopts:
	ACC16
	lda	#$FF00
	sta	longp
	ACC08
	lda	vbnk
	sta	longp+2
	ldx	#0
	txy
?lp0:	lda	!$FF00,x
	sta	[longp],y
	inx
	iny
	bne	?lp0
	jsr	cbm_fname	; Y = length
	sty	<_cnt
	jsr	cbm_chkdr	; require Dn
	stx	truedsk		; save true disk
	ACC16
	lda	txtp
	sta	cmdlin		; ptr. to command line
	lda	<_fnamp
	dec	a
	dec	a
	sta	txtp
	ACC08
	lda	<truedsk	; add disk
	ora	#'0'
	sta	(txtp)
	ldy	#1
	lda	#':'
	sta	(txtp),y
	ldy	<_cnt		; update string size
	iny
	iny
	ldx	#7
?lp:	lda	>?pxe,x
	sta	(txtp),y
	iny
	dex
	bpl	?lp
	lda	#0
	sta	(txtp),y	
	rts
	
?pxe:	.DB	'R,S,EXP.'

ldsgn:
	ACC16
	lda	#PASSRC
	sta	longp
	ACC08
	lda	xbnk		; bank of buffer
	sta	longp+2
	pha
	pei	(longp)		; address of buffer
	pea	#PCXSSIZ	; buffer size
	lda	#$0E		; chnl
	pha
	CBMFSRD			; read buffer
	bcs	?ret
	ACC16CLC
	cmp	#PCXSSIZ
	ACC08
	bne	?ret
	ldx	#0
	txy
?lp:	lda	>PCXSGN,x
	cmp	[longp],y
	bne	?end
	iny
	iny
	cpx	#PCXHSIZ
	ACC16
	ldy	#$10
	lda	[longp],y
	cmp	#PCXSSIZ
	bne	?end
	ldy	#$0E
	lda	[longp],y
	bne	?end
	ldy	#$0C
	lda	[longp],y
	sta	txtp
	ldy	#0		; ZF = 1 , signature ok	
?end:	CPU08	
	clc
?ret:	rts
	
; compile pascal source file on disk
; fpc "nomefile[.pas]", Dn [,L][,C][,P][,J][,N]
; fpc "nomefile", Dn, X [,L][,C][,P][,1]
; L = listing * C = compact code * P = list on printer * J = save obj. file
; N = no save exec file
; X option: compile file and write obj. file (old style)
cbm_fpc:
	.EXTERN pccstart

	jsr	?fpc
	jsr	pccstart
	lda	fpcflag
	bpl	?end		; old style compilation: end
	bit	pcodef
	bpl	?end		; compilation error: nothing to save
	asl	a
	bmi	?jsav		; no save exec file
	pha
	jsr	?psav
	pla
?jsav:	asl	a
	bpl	?end		; no save obj. file
	jsr	fpjsave
?end:	rts
	
?psav:	phb
	lda	xbnk
	pha
	plb
	ldy	#0
?ps1:	lda	!EXEDST,y
	beq	?ps2
	iny
	bra	?ps1
?ps2:	sty	fnlen
	plb
	jmp	fpxsav

; compiler options
?fpc:	stz	pcdsk		; compile on disk
	stz	objdsk
	stz	fpcflag
	stz	pcodef
	jsr	cbm_fname	; Y = length
	sty	<_cnt
	jsr	cbm_chkdr	; require Dn
	stx	truedsk		; save true disk
	stz	<_optfg
	stz	<_opt2fg
	beq	?nop		; no options
	jsr	pcopts		; get options
?nop:	ACC16
	lda	<_fnamp
	dec	a
	dec	a
	sta	txtp
	ACC08
	lda	<truedsk	; add disk
	ora	#'0'
	sta	(txtp)
	ldy	#1
	lda	#':'
	sta	(txtp),y
	ldy	<_cnt		; update string size
	iny
	iny
	lda	xbnk		; prepare files names pointers
	sta	longp+2
	sta	fbufpt+2
	sta	iecwp+2
	sta	iecrp+2
	ACC16
	lda	#PASSRC
	sta	longp		; '.PAS' source file 
	lda	#OBJDST
	sta	fbufpt		; '.OBJ' object file
	lda	#EXEDST
	sta	iecwp		; '.PXE' executable file
	lda	#OBJDEL
	sta	iecrp		; for delete obj. file
	ACC08
	lda	#' '
	sta	[longp]	
	lda	#'@'
	sta	[fbufpt]	; overwrite '.OBJ' and '.PXE' files
	sta	[iecwp]
	lda	#'S'
	sta	[iecrp]		; scratch file
	ACC16
	inc	longp
	inc	fbufpt
	inc	iecwp
	inc	iecrp
	ACC08
	lda	<_optfg
	lsr	a
	bcc	?new		; compilation in new style
	cpy	#15		; max. length = 14 (compiler add '.OBJ')
	bcc	?old
	jmp	?err
?old:	lda	#$30		; clear unwanted options
	trb	<_opt2fg
	ldy	#0
?lp10:	lda	(txtp),y	; load string
	beq	?lp12		; store extension
	cmp	#'a'		; convert in upper case
	bcc	?lp11
	cmp	#'z'+1
	bcs	?lp11
	and	#$DF
?lp11:	sta	[longp],y	; source file
	iny
	bra	?lp10
?lp12:	jmp	storepcf	; store compiler flags
?new:	lda	#$40		; clear unwanted options
	trb	<_opt2fg
	lda	#$01
	trb	<_optfg
	lda	<_opt2fg
	asl	a
	ora	#$80
	sta	fpcflag
	cpy	#7
	bcc	?fil		; name cannot terminate with '.PAS'
	ldx	#3		; check extension '.PAS'
	dey
?lp:	lda	(txtp),y
	cmp	#'a'		; convert in upper case
	bcc	?cmp
	cmp	#'z'+1
	bcs	?cmp
	and	#$DF
?cmp:	cmp	>?pas2,x
	bne	?fil		; unmatch
	dey
	dex
	bpl	?lp
	iny
	lda	#0		; terminate string
	sta	(txtp),y	; source file without '.PAS' extension
?fil:	ldy	#0
?lp1:	lda	(txtp),y	; load string
	beq	?ext		; store extension
	cmp	#'a'		; convert in upper case
	bcc	?st
	cmp	#'z'+1
	bcs	?st
	and	#$DF
?st:	sta	[longp],y	; '.PAS' source file
	sta	[fbufpt],y	; '.OBJ' dest. file
	sta	[iecwp],y	; '.PXE' dest. file
	sta	[iecrp],y	; obj. scratch file
	iny
	bra	?lp1
?ext:	lda	#'.'		; store '.'
	sta	[longp],y
	sta	[fbufpt],y
	sta	[iecwp],y
	iny
	sty	<_cnt
	ldx	#2		; store 'PAS'
?lp2:	lda	>?pas,x
	sta	[longp],y
	iny
	dex
	bpl	?lp2
	cpy	#19
	bcs	?err		; error: string too long
	jsr	storepcf	; store compiler flags
	ldx	#2		; store 'OBJ'
	ldy	<_cnt
?lp3:	lda	>?obj,x
	sta	[fbufpt],y
	sta	[iecrp],y
	iny
	dex
	bpl	?lp3
	lda	#0
	sta	[iecrp],y	; 'Sx:yyyy.OBJ'	
	ldx	#2		; store 'PXE'
	ldy	<_cnt
?lp4:	lda	>?pxe,x
	sta	[iecwp],y
	iny
	dex
	bpl	?lp4
	ldx	#3		; store ',S,W'
?lp5:	lda	>?wrs,x
	sta	[fbufpt],y
	sta	[iecwp],y
	iny
	dex
	bpl	?lp5
	lda	#0
	sta	[fbufpt],y
	sta	[iecwp],y
	rts
?err:	ldx	#$2C		; illegal file name
	jmp	cbm_err
	
?pas:	.DB	'SAP.'
?obj:	.DB	'JBO'
?pxe:	.DB	'EXP'
?wrs:	.DB	'W,S,'
?pas2:	.DB	'.PAS'

; save object file
fpjsave:
	lda	iecwp		; store total size in fbufpt
	sta	fbufpt
	stz	longp		; start pointer
	lda	iecwp+1
	sta	fbufpt+1
	stz	longp+1
	lda	iecwp+2
	sec
	sbc	jbnk
	sta	fbufpt+2
	tax
	lda	jbnk
	sta	longp+2
	txa
	ora	fbufpt
	ora	fbufpt+1
	beq	?ret		; empty object code
	jsr	?msg
	ACC08
	lda	xbnk
	pha			; bank of cmnd string
	pea	#OBJDST		; address of cmnd string
	lda	#$0E
	pha			; chnl
	CBMFSCMD		; send command
	bcs	?err		; if error
	ldx	fbufpt+2
	bne	?big		; save big block
?lst:	ACC16			; save block less tha $10000 bytes
	lda	fbufpt		; left size
	sta	txtp
	ACC08
	beq	?end		; nothing to save
	jsr	?jsav
	bcs	?err
	bra	?end
?big:	ACC16
	lda	#$8000		; save 32k block
	sta	txtp
	ACC08
?lp:	jsr	?jsav		; save 32k block
	bcs	?err
	lda	#$80		; update pointer
	sta	longp+1
	jsr	?jsav		; save next 32k block
	bcs	?err
	stz	longp+1		; update pointer
	inc	longp+2
	dec	fbufpt+2	; next 64k block
	bne	?lp
	beq	?lst		; save last block
?end:	lda	#$0E
	CBMFSCLS		; close file
	rts
?err:	jsr	dskerr
	lda	#$0E
	CBMFSCLS	
?ret:	rts

?jsav:	lda	longp+2
	pha
	pei	(longp)
	pei	(txtp)
	lda	#$0E
	pha
	CBMFSWR
	rts

?msg:	phb
	lda	xbnk
	pha
	plb
	ldy	#0
?lp2:	lda	.ABS.OBJDST,y
	beq	?lp4
	cmp	#'a'
	bcc	?lp3
	cmp	#'z'+1
	bcs	?lp3
	and	#$DF
?lp3:	sta	.ABS.PASSRC,y
	iny
	cpy	#32
	bcc	?lp2
?lp4:	dey
	dey
	dey
	dey
	sta	.ABS.PASSRC,y
	lda	.ABS.PASSRC+1	; drive
	plb
	pha			; drive
	lda	xbnk
	pha
	pea	#PASSRC+3	; string addr
	phk
	pea	#?str
	lda	#8
	pha
	BPRINTF
	rts

?str:	.DB	'saving "%s" to drive %c...', 13, 0
	
; execute compiled p-code
; run [command line]
cbm_pcrun:
	.EXTERN pcexec
	
	stz	pcdsk
	stz	objdsk
	stz	fpcflag
	bit	pcodef
	bpl	?10
	jsr	cbm_chrgot
	jmp	pcexec
?10:	ldx	#$2E
	jmp	cbm_err
	
; 'pc' command -- compile pascal source file from memory
; pc ["filename",Dn][,L][,C][,P]
; add automatic extension '.PXE' to exec p-code if any
cbm_pc:
	stz	<_optfg
	stz	<_opt2fg
	stz	<_cnt
	lda	#$80
	sta	pcdsk		; compile in memory
	stz	truedsk
	stz	objdsk
	stz	fpcflag
	stz	pcodef
	jsr	cbm_chrgot
	beq	?nop		; no options
	cmp	#'"'		; exec file?
	bne	?opt		; no
	jsr	cbm_fname	; Y = length
	sty	<_cnt
	jsr	cbm_chkdr	; require Dn
	stx	truedsk		; save true disk
	php
	ACC16
	lda	<_fnamp
	dec	a
	dec	a
	dec	a
	sta	<_fnamp
	ACC08
	lda	#'@'		; add replace flag
	sta	(_fnamp)
	ldy	#1	
	lda	<truedsk	; add disk
	ora	#'0'
	sta	(_fnamp),y
	iny
	lda	#':'
	sta	(_fnamp),y
	ldy	<_cnt
	iny
	iny
	iny
	sty	<_cnt
	plp
	beq	?nop		; no options	
?opt:	jsr	pcopts		; get all options
	lda	#$01		; clear unwanted options
	trb	<_optfg
	lda	#$7F
	trb	<_opt2fg
?nop:	lda	xbnk		; prepare dummy file name pointer
	sta	longp+2
	ACC16
	lda	#PASSRC
	sta	longp		; dummy source file 
	ACC08
	ldy	#0
	tyx
?lp:	lda	>PCDFCMD,x
	sta	[longp],y	; pc string command
	beq	?nxt
	inx
	iny
	bne	?lp
?nxt:	jsr	storepcf	; store options
	ACC16
	lda	(txtbeg)
	ACC08
	bne	?go
	jmp	er29		; no source file in memory
?go:	ldy	<_cnt
	beq	?pc		; no exec file
	jsr	?set
?pc:	lda	fnlen
	pha
	jsr	pccstart
	pla
	sta	fnlen
	bit	pcodef
	bpl	?ret		; error from compiler
	bit	objdsk
	bvc	?ret		; no save exec file
	jmp	fpxsav

; set exec filename
?set:	cpy	#16		; will need room for extension
	bcc	?set1
	ldx	#$2C		; illegal file name
	jmp	cbm_err
?set1:	lda	#$40
	sta	objdsk		; flag save exec file
	lda	xbnk		; filename pointer
	sta	longp+2
	ACC16
	lda	#EXEDST
	sta	longp
	lda	<_fnamp
	sta	txtp
	ACC08
	tyx
?set2:	lda	(txtp),y
	sta	[longp],y
	dey
	bpl	?set2
	txy
	ldx	#7
?set3:	lda	>?pxe,x
	sta	[longp],y
	iny
	dex
	bpl	?set3
	lda	#0
	sta	[longp],y
	sty	fnlen
?ret:	rts

?pxe:	.DB	'W,S,EXP.'
	

; get file name from command line
cbm_fname:
	jsr	cbm_chrgot
	cmp	#'"'
	beq	cbm_getfn
	jmp	cbm_e0b		; syntax error

; get file name from command line after quote
cbm_getfn:
	ACC16
	lda	txtp
	inc	a
	sta	txtp
	sta	_fnamp		; pointer to file name
	ACC08
	ldy	#$FF
?02:	iny	
	lda	(txtp),y
	beq	cbm_e0bx	; error: syntax
	cmp	#'"'
	bne	?02
	tya
	beq	cbm_e08		; error: missing file name
	lda	#0
	sta	(txtp),y	; terminate string
	tya
	sec
	adc	txtp		; update pointer
	sta	txtp
	bcc	?04
	inc	txtp+1
?04:	cpy	#17		; max length = 16
	bcs	cbm_e2c		; illegal filename
	rts

cbm_e0bx:
	jmp	cbm_e0b
cbm_e08:
	ldx	#$08			; missing file name
	jmp	cbm_err
cbm_e2c:
	ldx	#$2C			; illegal file name
	jmp	cbm_err

; check multi-options
cbm_mtopt:
	jsr	cbm_chrgot
	cmp	#','
	bne	cbm_e0bx
	jsr	cbm_chrget
	beq	cbm_e0bx
	cmp	#'a'
	bcc	?02
	cmp	#'z'+1
	bcs	?02
	and	#$DF
?02:	rts

; check options for fpc/pc command
pcopts:
?lp:	jsr	?opt		; get all options: L,C,P,J,N,1
	bne	?lp
	rts
?opt:	jsr	cbm_mtopt
	cmp	#'X'
	bne	?1op
	lda	#$01
	tsb	<_optfg		; optfg<0>: 'X' -> compile in original mode	
	bra	?eop
?1op:	cmp	#'1'
	bne	?lop
	lda	#$40
	tsb	<_opt2fg	; opt2fg<6>: '1' -> obj. file on drive 1
	bra	?eop
?lop:	cmp	#'L'
	bne	?cop
	lda	#$80
	tsb	<_optfg		; optfg<7>: 'L' -> list compiling
	bra	?eop
?cop:	cmp	#'C'
	bne	?pop
	lda	#$40
	tsb	<_optfg		; optfg<6>: 'C' -> compact code
	bra	?eop
?pop:	cmp	#'P'
	bne	?jop
	lda	#$80
	tsb	<_opt2fg	; opt2fg<7>: 'P' -> list compiling on printer
	bra	?eop
?jop:	cmp	#'J'
	bne	?nop
	lda	#$10
	tsb	<_opt2fg	; opt2fg<4>: 'J' -> save object code on disk
	bra	?eop
?nop:	cmp	#'N'
	bne	cbm_e0bx
	lda	#$20
	tsb	<_opt2fg	; opt2fg<5>: 'N' -> no save exec file on disk
?eop:	jmp	cbm_chrget

; store compiler flag after file name
storepcf:
	stz	objdsk
	bit	<_optfg		; optfg<7>: 'L' option
	bpl	?chc
	jsr	?stl
?chc:	bvc	?chp		; optfg<6>: 'C' option
	jsr	?stc
?chp:	bit	<_opt2fg	; opt2fg<7>: 'P' option
	bpl	?ch1
	jsr	?stp
?ch1:	bvc	?stz		; opt2fg<6>: '1' option
	jsr	?st1
	lda	#$80
	sta	objdsk		; flag option '1'
?stz:	lda	#$00
	sta	[longp],y
	rts

; store single flag
?stl:	ldx	#'L'
	bra	?sto
?stc:	ldx	#'C'
	bra	?sto
?stp:	ldx	#'P'
	bra	?sto
?st1:	ldx	#'1'
?sto:	lda	#','
	sta	[longp],y
	iny
	txa
	sta	[longp],y
	iny
	rts
	
; check drive number
cbm_chkdr:
	jsr	cbm_chrgot
cbm_chkdr1:
	cmp	#','
	bne	_?20
	jsr	cbm_chrget
cbm_chkdr2:	
	cmp	#'D'
	beq	?02
	cmp	#'d'
	bne	_?20
?02:	inc	txtp
	bne	?04
	inc	txtp+1
?04:	lda	(txtp)
	cmp	#'0'
	bcc	?18
	cmp	#'8'
	bcs	?18
	sbc	#$2F
	tax	
	jmp	cbm_chrget
	
?18:	ldx	#$2D			; illegal drive number
	bra	_?22
_?20:	ldx	#$2B			; missing drive number
_?22:	jmp	cbm_err

; handle Dn TO Dm
get2dsk:
	jsr	cbm_chkdr2		; require Dn
	stx	truedsk			; save true disk	
	beq	?er
	cmp	#'t'
	beq	?ok
	cmp	#'T'
	bne	?er
?ok:	ldy	#1
	lda	(txtp),y
	cmp	#'o'
	beq	?ok2
	cmp	#'O'
	bne	?er
?ok2:	jsr	cbm_chrget
	jsr	cbm_chrget
	jsr	cbm_chkdr2		; require Dm
	stx	<_cnt
	bne	?er
	cpx	truedsk
	bne	?go
	jmp	cbm_e0e
?er:	jmp	cbm_e0b			; syntax
?go:	ACC16
	lda	#TXTBUF
	sta	txtp
	ACC08
	rts

qedit:
	.EXTERN qedtent

	ACC16			; set break memory limit
	lda	#$2000
	sta	>pbrkmin
	sta	>pbrklv
	ACC08
	
	lda	#$C0		; CBM pascal mode
	xba			; B = mode
	ldy	tbnk		; A,X,Y = command line pointer
	lda	txtp
	ldx	txtp+1
	jsl	qedtent
	rts

PCDFCMD:
	.DB	' 0:BUFMEM.PAS', 0

; p-code executable signature
PCXSGN:
	.DB	'P-CODEEXEC'
	.DW	$0100		; version 1.0
PCXHSIZ	.EQU	$ - PCXSGN
PCXSSIZ	.EQU	32

test_fl:
	.EXTERN XBCF3,XBBA2T,XBDDD
	
	jsr	XBCF3
	lda	#$0D
	jsr	FCHROUT
	lda	#<FAC1TMP
	ldy	#>FAC1TMP
	jsr	XBBA2T
	jsr	XBDDD
	sta	longp
	sty	longp+1
	lda	vbnk
	sta	longp+2
	jsr	cbm_prz
	lda	#$0D
	jsr	FCHROUT
	
	rts
	
;---------------------------------------------------------------------------
; 'pascal' mode commands table
;---------------------------------------------------------------------------

PCMDT:
	.DC	'xput'		; put source text in x-bank
	.DC	'xget'		; get source text from x-bank
	.DC	'xexx'		; excghange source text with one in in x-bank
	.DC	'xclr'		; clear source text in x-bank
	.DC	'new'		; clear source text in text bank (unrecover.)
	.DC	'auto'
	.DC	'list'
	.DC	'mon'		; system monitor
	.DC	'renum'
	.DC	'del'
	.DC	'quit'
	.DC	'pc'
	.DC	'run'
	.DC	'format'
	.DC	'dir'
	.DC	'dinit'
	.DC	'chkdsk'
	.DC	'ddup'
	.DC	'copy'
	.DC	'rename'
	.DC	'rm'
	.DC	'load'
	.DC	'save'
	.DC	'verify'
	.DC	'fl'
	.DC	'fpc'
	.DC	'fpl'
	.DC	'fpx'
	.DC	'qedit'
	.DB	$00

;---------------------------------------------------------------------------
; 'pascal' mode commands vector's
;---------------------------------------------------------------------------

PCMDV:
	.DW	cbm_xput, cbm_xget, cbm_xexx, cbm_xclr
	.DW	cbm_new, cbm_auto, cbm_lst, cbm_mon
	.DW	cbm_renum, cbm_del, cbm_quit, cbm_pc
	.DW	cbm_pcrun, cbm_fmt, cbm_lsdir, cbm_dinit
	.DW	cbm_chkdsk, cbm_ddup, cbm_copy, cbm_rename
	.DW	cbm_rm, cbm_load, cbm_save, 0
	.DW	test_fl, cbm_fpc, cbm_fpl, cbm_fpx
	.DW	qedit
	
;---------------------------------------------------------------------------
; basic reserved words
;---------------------------------------------------------------------------

BASRW:
	.DC	'END'
	.DC	'FOR'
	.DC	'NEXT'
	.DC	'DATA'
	.DC	'INPUT#'
	.DC	'INPUT'
	.DC	'DIM'
	.DC	'READ'
	.DC	'LET'
	.DC	'GOTO'
	.DC	'RUN'
	.DC	'IF'
	.DC	'RESTORE'
	.DC	'GOSUB'
	.DC	'RETURN'
	.DC	'REM'
	.DC	'STOP'
	.DC	'ON'
	.DC	'WAIT'
	.DC	'LOAD'
	.DC	'SAVE'
	.DC	'VERIFY'
	.DC	'DEF'
	.DC	'POKE'
	.DC	'PRINT#'
	.DC	'PRINT'
	.DC	'CONT'
	.DC	'LIST'
	.DC	'CLR'
	.DC	'CMD'
	.DC	'SYS'
	.DC	'OPEN'
	.DC	'CLOSE'
	.DC	'GET'
	.DC	'NEW'
	.DC	'TAB('
	.DC	'TO'
	.DC	'FN'
	.DC	'SPC('
	.DC	'THEN'
	.DC	'NOT'
	.DC	'STEP'
	.DC	'+'
	.DC	'-'
	.DC	'*'
	.DC	'/'
	.DC	'^'
	.DC	'AND'
	.DC	'ON'
	.DC	'>'
	.DC	'='
	.DC	'<'
	.DC	'SGN'
	.DC	'INT'
	.DC	'ABS'
	.DC	'USR'
	.DC	'FRE'
	.DC	'POS'
	.DC	'SQR'
	.DC	'RND'
	.DC	'LOG'
	.DC	'EXP'
	.DC	'COS'
	.DC	'SIN'
	.DC	'TAN'
	.DC	'ATN'
	.DC	'PEEK'
	.DC	'LEN'
	.DC	'STR$'
	.DC	'VAL'
	.DC	'ASC'
	.DC	'CHR$'
	.DC	'LEFT$'
	.DC	'RIGHT$'
	.DC	'MID$'
	.DC	'GO'
	.DB	$00

;---------------------------------------------------------------------------
; basic error messages
;---------------------------------------------------------------------------

BASERM:
	.DC	'too many files'		; 01
	.DC	'file open'			; 02
	.DC	'file not open'			; 03
	.DC	'file not found'		; 04
	.DC	'device not present'		; 05
	.DC	'not input file'		; 06
	.DC	'not output file'		; 07
	.DC	'missing file name'		; 08
	.DC	'illegal device number'		; 09
	.DC	'next without for'		; 0A
	.DC	'syntax'			; 0B
	.DC	'return without gosub'		; 0C
	.DC	'out of data'			; 0D
	.DC	'illegal quantity'		; 0E
	.DC	'overflow'			; 0F
	.DC	'out of memory'			; 10
	.DC	'undef''d statment'		; 11
	.DC	'bad subscript'			; 12
	.DC	'redim''d array'		; 13
	.DC	'division by zero'		; 14
	.DC	'illegal direct'		; 15
	.DC	'type mismatch'			; 16
	.DC	'string too long'		; 17
	.DC	'file data'			; 18
	.DC	'formula too complex'		; 19
	.DC	'can''t continue'		; 1A
	.DC	'undef''d function'		; 1B
	.DC	'verify'			; 1C
	.DC	'load'				; 1D
	.DC	'break'				; 1E
	.DC	'can''t resume'			; 1F
	.DC	'loop not found'		; 20
	.DC	'loop without do'		; 21
	.DC	'direct mode only'		; 22
	.DC	'integer overflow'		; 23	
	.DC	'bad disk'			; 24
	.DC	'bend not found'		; 25
	.DC	'line number too large'		; 26
	.DC	'unresolved reference'		; 27
	.DC	'unimplemented command'		; 28
	.DC	'no source program'		; 29
	.DC	'empty exchange bank'		; 2A
	.DC	'missing drive number'		; 2B
	.DC	'illegal file name'		; 2C
	.DC	'illegal drive number'		; 2D
	.DC	'no p-code, or invalid p-code'	; 2E
	.DC	'empty disk file'		; 2F

	.DC	'unknow'			; 30
	.DB	$00
	
POW10T:
	.DW	1
	.DW 	10
	.DW	100
	.DW	1000
	.DW	10000
