
_KBD_INC_	.SET	1
_SCN_INC_	.SET	1

	.INCLUDE inc\global.inc
;;	.INCLUDE inc\dirp00.inc
	.INCLUDE inc\dirp01.inc

; encoded addressing mode for 65C816
AIMPL		.EQU	$00	; implied/accumulator
AIMM		.EQU	$01	; # immediate
ADP		.EQU	$02	; DP direct page
AABS		.EQU	$03	; absolute
ALONG		.EQU	$04	; absolute long
ALONGX		.EQU	$05	; absolute long, X
AXIND		.EQU	$06	; (DP,X)
AYIND		.EQU	$07	; (DP),Y
ADPX		.EQU	$08	; DP,X
AABSX		.EQU	$09	; absolute, X
AABSY		.EQU	$0A	; absolute, Y
ABIND		.EQU	$0B	; absolute indirect (abs)
ADPY		.EQU	$0C	; DP,Y
AREL		.EQU	$0D	; relative short
ABXI		.EQU	$0E	; absolute indirect, X (abs,X)
AIND		.EQU	$0F	; (DP)
ASTK		.EQU	$10	; stack relative, S
ALIND		.EQU	$11	; indirect long [DP]
AYLIND		.EQU	$12	; [DP],Y
AYSTK		.EQU	$13	; (rel,S),Y
AMOV		.EQU	$14	; move
A16R		.EQU	$15	; relative 16 bit
AJML		.EQU	$16	; jml [absolute]
A16IMM		.EQU	$17	; # immediate 16 bit

; modified encoding for immediate addressing 8/16 bit
AXIMM		.EQU	($40 + AIMM)	; X/Y immediate
AMIMM		.EQU	($80 + AIMM)	; A/M immediate

; equates from page 0 -- local temporary variables from SMXTmp area
asmpr		.EQU	SMXTmp		; word:	printing mask
asmmode		.EQU	SMXTmp+2	; byte: addessing mode
TSTR		.EQU	SMXTmp		; byte: 3 bytes for store mnemonic
XBUF		.EQU	SMXTmp		; byte: 18 bytes for store command
asmnb		.EQU	SMXTmp+3	; byte: number of bytes of instruction
tmpl		.EQU	SMXTmp+4	; byte: temp
tmph		.EQU	SMXTmp+5	; byte: temp
asmmov		.EQU	SMXTmp+6	; byte: flag move
asmbit		.EQU	SMXTmp+6	; byte: flag rmb/smb/bbr/bbs
asmrel		.EQU	SMXTmp+7	; byte: <7> -> relative, <6> -> rel 16
asmxop		.EQU	SMXTmp+7	; byte: bit number in RMB/SMB/BBR/BBS
asmstf		.EQU	SMXTmp+8	; byte: rep/sep flag
asmcnt		.EQU	SMXTmp+9	; byte: temp. counter
asmtmpL		.EQU	SMXTmp+10	; byte: used for 65C02
asmtmpH		.EQU	SMXTmp+11	; byte: used for 65C02
P0TMP		.EQU	SMXTmp+12	; byte: 14 bytes for assempling mask

	.CODEFF
	.LONGA off
	.LONGI off

	.EXTERN PrintAddr, PrintByte, PrintWord, PrintHex, PrintHex1, GetCurCh
	.EXTERN TmpToAddr, GetParm, CkStop, ErrCls2, DecTmpPtrA, SubTmpAddr
	.EXTERN FF_Byte2Hex

	.GLOBAL Cmd_d, Cmd_a

test:
	nop
	nop
	;CPU08
?02:	lda	#$FF
	tax
	tay
	per	-($+3-?02)
	per	-($+3-?04)
	per	?04
?00:	tax
	tay
	txs
	brl	?02
	brl	?04
	nop
	nop
	nop
	nop
?04:	tax
	pha
	pla

;---------------------------------------------------------------------------
; disassembler
;---------------------------------------------------------------------------
	
Cmd_d:
	bcs	?01
	jsr	TmpToAddr
	jsr	GetParm
	bcc	?02
?01:	lda	#$14
	sta	SMTmpL
	bne	?03
?02:	jsr	SubTmpAddr
	bcc	?20
?03:	TXT_CR
	jsr	CkStop
	beq	?10
	jsr	disx16
	lda	asmnb
	inc	a
	sta	asmnb
	jsr	IncPtr
	lda	asmnb
	jsr	DecTmpPtrA
	bcs	?03
?10:	rts
	
?20:	jmp	ErrCls2	

IncPtr:
	xba
	lda	#0
	xba
	ACC16CLC
	adc	SMAddrL
	sta	SMAddrL
	ACC08
	bcc	?01
	inc	SMAddrK
?01:	rts

; disassemble 65C816 code at address SMAddrL/H/K
disx16:
	TXTPRINT
	.DB	'. ', 0

; entry point for line assembler
disx162:
	jsr	PrintAddr	; print address SMAddrL/H/K + blank
	TXTPRCHAR		; one more blank
	.DB	' '
	lda	#$04		; fetch max. 4 bytes for 65C816
	bit	asmcpu
	bpl	?00
	lda	#$03		; fetch max. 3 bytes for 6502/65C02
?00:	sta	asmcnt
	lda	[SMAddrL]	; fetch op-code
	jsr	getindx		; translate op-code
	pha			; save
	ldy	#0
	ldx	asmnb		; # bytes instruction
	inx
?01:	dex
	bpl	?02		; next byte
	TXTPRINT		; print 3 blank
	.DB	'   ', 0
	bra	?03
?02:	lda	[SMAddrL],y	; next byte
	jsr	PrintByte	; print hex + blank
?03:	iny
	cpy	asmcnt 		; max. 4/3 bytes 
	bcc	?01
	pla			; mnemonic index
	jsr	printm		; print mnemonic + blank
	bit	asmcpu
	bpl	?04		; 65C816
	jmp	?50		; 6502/65C02
?04:	ldx	#9		; number of bit to scan
?05:	cpx	#5
	bne	?08		; don't print byte
	ldy	asmnb
	beq	?08		; single byte
?06:	lda	[SMAddrL],y	; fetch next byte	
	bit	asmrel		; test relative addressing
	bmi	?20		; yes, relative
	jsr	PrintHex
	bit	asmmov
	bpl	?07
	cpy	#$02		; mvn/mvp op-code print ',#$' after dest bank
	bcc	?07
	TXTPRINT
	.DB	',#$', 0
?07:	dey
	bne	?06
?08:	ACC16	
	asl	asmpr
	ACC08
	bcc	?10
	lda	>PRTAB1-1,x
	TXTCHAROUT
	lda	>PRTAB2-1,x
	beq	?10
	TXTCHAROUT
?10:	dex
	bne	?05
	bit	asmstf		; rep/sep op-code ?
	bpl	?18		; no -- end
	ldy	#1		; load the byte after op-code
	lda	[SMAddrL],y
	and	#PMFLAG.OR.PXFLAG
	beq	?18		; no 16 bit flags affected
	asl	a		; bit 7 -> A/M flag
	asl	a		; bit 6 -> X/Y flag
	bvs	?12		; rep op-code
	trb	asmlong		; clear bit 7 and/or bit 6
	rts
?12:	tsb	asmlong		; set bit 7 and/or bit 6
?18:	rts
?20:	sec			; for later adc	(add 1 more to address)
	bvs	?30		; relative 16 bit
?21:	ldx	SMAddrH		; relative 8 bit	
	tay			; A = offset 8 bit
	bpl	?22
	dex			; previous page if offset is negative
?22:	adc	SMAddrL		; add offset + carry
	bcc	?24
	inx
?24:	inc	a		; add one more to final address because
	bne	?26		; relative 8 bit is 2 bytes instruction
	inx	
?26:	bit	asmcpu
	bpl	?40		; print address
	bit	asmbit
	bpl	?40		; print address
	inc	a		; BBR/BBS are 3 bytes
	bne	?40
	inx
	bra	?40		; print address
?30:	dey			; relative 16 bit: here Y = 2 now Y = 1
	ACC16			; add offset 16 bit to current address
	lda	SMAddrL
	adc	[SMAddrL],y		
	inc	a		; add 2 more to final address because
	inc	a		; relative 16 bit is 3 bytes istruction
	ACC08
	xba
	tax			; X = high address
	xba			; A = low  address
?40:	jmp	PrintWord	
?50:	; 6502/65C02
	bit	asmbit		; test SMB/RMB/BBR/BBS
	bpl	?54		; no
	lda	asmxop		; #bit
	ora	#'0'
	TXTCHAROUT
	lda	#','
	TXTCHAROUT
	lda	asmpr
	cmp	#$9D		; relative addressing mode ?
	bne	?54		; no
	ldy	#1		; fetch next byte
	lda	[SMAddrL],y
	jsr	PrintHex1	; stampa '$XX,'
?54:	ldx	#6
?55:	cpx	#3
	bne	?58		; no print byte
	ldy	asmnb
	beq	?58		; single byte
?56:	lda	asmpr
	cmp	#$E8		; relative addressing ?
	lda	[SMAddrL],y
	bcs	?21		; print address
	jsr	PrintHex
	dey
	bne	?56
?58:	asl	asmpr
	bcc	?60
	lda	PRTAB11-1,x
	TXTCHAROUT
	lda	PRTAB21-1,x
	beq	?60
	TXTCHAROUT
?60:	dex
	bne	?55
	rts

; get index mnemonic and addressing mode for op-code Y (65C816)
; return in A the index for access mnemonic table and in asmpr
; the printing mode; in asmnb the number of the bytes of the op-code
getindx:
	tay			; op-code
	bit	asmcpu
	bpl	?02		; 65C816
	jmp	?100		; 6502/C02
?02:	lsr	a
	bcc	?08		; even op-code (A = 00..7F)
	lsr	a
	bcc	?04		; op-code with final pattern '01'
	
	; final pattern '11' -> op-code = X3, X7, XB, XF
	; all are op-code for group I instructions except op-code XB
	; these are op-codes relative to accumulator new addressing
	; mode in 65C816, except pattern XB that i relative to new
	; istructions of 65C816 (all implied)
	; these pattern are translated to 87..8F
	; here value is 00XXXPPP where XXX encode istruction and
	; PPP (where PPP not equal 010 and not equal 110) encode addressing
	; PPP = 010 or PPP = 110 (op-code XB) mean istruction with 1 byte
	nop
	and	#$07		; mask PPP
	adc	#$07		; translate to 08..0F (here CF = 1)
	bra	?06		; value 0A and 0E are implied instructions

?04:	; final pattern '01' -> op-code = X1, X5, X9, XD
	; are all op-codes in group 1 instructions (relative to accumulator)
	; here value is 00XXXYYY where XXX encode the instruction and YYY
	; the addressing mode (the standard addressing mode of 6502 family)
	; all these op-codes are translated to 80..87

	and	#$07		; mask YYY
?06:	ora	#$80		; translate to 80..8F
?08:	tax			; index to access table AMODE
	lda	>AMODE,x	; here X = 00..8F
	sta	asmmode		; save  bit 7 & 6 flag (immediate 16 bit)
	and	#$1F		; mask addressing mode
	stz	asmrel		; clear flag relative address
	stz	asmmov		; clear flag mvn/mvp op-code
	stz	asmstf		; clear flag rep/sep op-code
	cmp	#AREL		; test relative addressing 8 bit
	bne	?10
	ldx	#$80		; flag relative 8 bit
	bra	?12
?10	cmp	#A16R		; test relative addressing 16 bit
	bne	?14
	ldx	#$C0		; flag relative 16 bit
?12:	stx	asmrel
	bra	?20
?14:	cmp	#AMOV
	bne	?16
	ldx	#$80
	stx	asmmov		; flag mvn/mvp op-code
	bra	?20
?16:	cpy	#$C2		; rep # op-code?
	bne	?17
	ldx	#$C0		; flag rep #
	bra	?18
?17:	cpy	#$E2		; sep # op-code?
	bne	?20
	ldx	#$80		; flag sep #
?18:	stx	asmstf
?20:	asl	a
	tax			; index to access printing mode table
	ACC16
	lda	>ENCTAB,x
	sta	asmpr		; save printing mode
	ACC08
	and	#$03
	tax			; number of bytes
	bit	asmmode
	bmi	?24		; test A/M 16 bit
	bvc	?28		; no #immediate 16 bit mode for X/Y
	bit	asmlong		; test bit 6 -> X/Y 16 bit ?
	bvc	?28		; no -- X/Y 8 bit
	bvs	?26		; yes, X/Y #immdediate 16 bit
?24:	bit	asmlong		; test bit 7 -> A/M 16 bit ?
	bpl	?28		; no -- A/M 8 bit
?26:	inx			; add one more byte (#immediate 16 bit)
?28:	stx	asmnb		; number of bytes of instruction
	tya			; A = op-code	
	ldx	#OPTABLEN
?32:	cmp	>OPTAB,x	; translate index op-code
	beq	?34		; found
	dex
	bpl	?32		; loop
	bmi	?36		; not found
?34:	lda	>TRANSL,x
	rts
?36:	and	#$8F
	tax
     	tya
	and	#$9F
	sta	tmpl
	tya
	and	#$1F
	sta	tmph
	tya
	ldy	#$03
	cpx	#$8A
	beq	?44
?38:	lsr	a
	bcc	?44
	lsr	a
	bcc	?40
	cpx	#$0B
	beq	?48
	cpx	#$8B
	beq	?48	
?40:	lsr	a
	ora	#$20
	dey
	bne	?40
	cpx	#$03
	beq	?46
	cpx	#$83
	beq	?46
	ldx	tmph
	cpx	#$12
	beq	?50
	cpx	#$02
	beq	?52
	ldx	tmpl
	cpx	#$1A
	bne	?42
	clc
	adc	#$28
?42:	rts
?44:	dey
	bne	?38
?46:	rts	
?48:	lsr	a
	lsr	a
	ora	#$40
	rts	
?50:	clc
	adc	#$08
	rts
?52:	clc
	adc	#$20
	rts
	;; 6502/65C02
?100:	stz	asmbit			; flag rmb/smb/bbr/bbs
	bvs	?101a			; 65C02
	ldx	#INVLEN
?101c:	cmp	>OPTAB1,x
	beq	?112			; 6502 invalid op-code
	dex
	bpl	?101c
	bra	?103			 
?101a:	ldx	#OPTAB1LEN		; translation for 65C02
?101:	cmp	>OPTAB1,x
	bne	?102
	pha
	lda	>TRANSL1,x
	tay
	pla
	bra	?103
?102:	dex
	bpl	?101
?103:	lsr	a
	bcc	?106			; even op-code
	lsr	a
	bcc	?108			; op-code with final '01' pattern

	; '11' final pattern: X3, X7, XB, XF op-code
	; for 65C02 valid X7 ed XF only -- all invalid for 6502
	
	bit	asmcpu
	bvc	?112			; invalid op-code for 6502
	lsr	a
	bcc	?112			; invalid op-code for 65C02
	
	; BBRX -> 0XXX1111 => 0000XXX1
	; BBSX -> 1XXX1111 => 0001XXX1
	; RMBX -> 0XXX0111 => 0000XXX0
	; SMBX -> 1XXX0111 => 0001XXX0

	ldx	#0			; X = 0 if RMB/SMB	
	pha
	lsr	a			; test bit 0
	and	#$07
	sta	asmxop			; asmxop = 0..7
	pla
	
	; now C = 1 if BBR/BBS - CF = 0 if RMB/SMB
	bcc	?104
	inx				; X = 1 if BBR/BBS
?104:	php				; salva C
	asl	a			; A<5> = 0 per BBR/RMB
	and	#$20			; mask  bit 5
	plp
	bcc	?105
	ora	#$40			; A<6> = 1 if BBR/BBS
		
	; A = 000 00000 if RMB
	; A = 001 00000 if SMB
	; A = 010 00000 if BBR
	; A = 011 00000 if BBS
	
?105:	ora	#$03
	tay				; translate code for 65C02 
	
	; Y = 03 if RMB
	; Y = 23 if SMB
	; Y = 43 if BBR
	; Y = 63 if BBS
	
	lda	#$80
	sta	asmbit			; flag rmb/smb/bbr/bbs
	txa
	ora	#$88			; A = 88..89
	bra	?110			; access table
		
?106:	; final pattern '10010' for 65C02 op-code as LDA(ZP)
	tax
	and	#$0F
	cmp	#$09
	bne	?107
	bit	asmcpu
	bvc	?112			; invalid 6502 opcode
	dey				; translate 65C02 opcode
?107:	txa
	bra	?110 
	
?108:	; '01' final pattern all valid for 65C02 -- $89 is invalid for 6502
	; after 2 lsr -> $89 = $22 -- if 6502 this is invalid
	; for 65C02 this is BIT # op-code, that will be translated to $24 
	cmp	#$22			; opcode $89 ?
	bne	?109			; no
	bit	asmcpu
	bvc	?112			; invalid 6502 opcode	
	ldy	#$24			; translate 65C02 op-code

?109:	;  A = 00XXXYYY where YYY encode addressing mode
	and	#$07			; mask YYY
	ora	#$80			; A = 80..87

?110:	; access addressing mode table
	lsr	a
	tax
	lda	>AMODE1,x
	bcs	?111			; odd -> low
	lsr	a			; even -> high
	lsr	a
	lsr	a
	lsr	a
?111:	and	#$0F
	bne	?114			; valid !
?112:	ldy	#$E3			; invalid opcode
	lda	#$00
?114:	tax
	lda	>ENCTAB1,x
	sta	asmpr			; printing bits
	and	#$03
	sta	asmnb			; # bytes
	cpx	#$0D			; test realtive addressing
	bne	?115a
	bit	asmbit
	bpl	?115a			; no BBR/BBS/RMS/SMB
	inc	asmnb			; BBR/BBS 3 bytes instructions	
?115a:	tya	
	and	#$8F
	sta	tmph
	tax
     	tya
	and	#$9F
	sta	tmpl
	tya
	ldy	#$03
	cpx	#$8A
	beq	?120
?115:	lsr	a
	bcc	?120
	lsr	a
?116:	lsr	a
	ora	#$20
	dey
	bne	?116
	ldx	tmph
	cpx	#$03
	beq	?117
	cpx	#$83
	bne	?118
?117:	clc
	adc	#$0C
	rts
?118:	ldx	tmpl
	cpx	#$1A
	bne	?119
	clc
	adc	#$10
?119:	rts
?120:	dey
	bne	?115
	rts

; print mnemonic of the translated op-code 
printm:
	tax
	bit	asmcpu
	bpl	?06		; 65C816
	lda	>MEMTBLL1,x	; 6502/C02
	sta	tmpl
	lda	>MEMTBLH1,x
	bra	?08
?06:	lda	>MEMTBLL,x
	sta	tmpl
	lda	>MEMTBLH,x
?08:	sta	tmph
	ldx	#3
?10:	lda	#$00
	ldy	#$05
?12:	asl	tmph
	rol	tmpl
	rol	a
	dey
	bne	?12
	adc	#'?'
	TXTCHAROUT		; print mnemonic
	dex
	bne	?10
	TXTPRCHAR		; print blank
	.DB	' '
	rts

;---------------------------------------------------------------------------
; assembler
;---------------------------------------------------------------------------

Cmd_a:
	bcs	?20		; error: missing start address
	jsr	TmpToAddr
?01:	ldx	#0
	stx	P0TMP+1
?02:	jsr	GetCurCh	; next char
	bne	?03
	cpx	#0
	beq	?19		; empty buffer: exit
?03:	cmp	#' '
	beq	?01		; skip starting blank
	jsr	upcase
	sta	TSTR,x		; buffer mnemonic
	inx
	cpx	#3		; must be 3 chars.
	bne	?02
?04:	dex			; compact mnemonic
	bmi	?21
	lda	TSTR,x
	sec
	sbc	#'?'
	ldy	#5
?05:	lsr	a
	ror	P0TMP+1
	ror	P0TMP
	dey
	bne	?05
	beq	?04	
?19:	rts
?20:	jmp	ErrCls2		; error
?21:	lda	P0TMP		; test mnemonic '???'
	ora	P0TMP+1
	beq	?20
	ldx	#2
?22:	jsr	GetCurCh
	beq	?24
	cmp	#' '
	beq	?22		; skip blank
	jsr	upcase
	jsr	chkdgt
	bcs	?23		; no hex digit
	jsr	dgt2hex

	; if 6502/65C02:
	; for BBR/BBS:	SMTmpL/SMTmpH -> absolute address
	;		asmtmpL        -> ZP address
	;		asmtmpH	      -> # bit
	; for SMB/RMB 	SMTmpL	      -> ZP address
	;		SMTmpH        -> # bit
	; others:	SMTmpL	      -> SMTmpL/SMTmpH -> address
	; if 65C816:	SMTmpL/H/K    -> address
	
	bit	asmcpu
	bmi	?22a
	ldy	SMTmpH		; translate
	sty	SMTmpK
	ldy	SMTmpL
	sty	SMTmpH
	sta	SMTmpL
	bra	?23a
?22a:	ldy	asmtmpL		; translate values
	sty	asmtmpH
	ldy	SMTmpH
	sty	asmtmpL
	ldy	SMTmpL
	sty	SMTmpH
	sta	SMTmpL
?23a:	lda	#'0'
	sta	P0TMP,x
	inx
?23:	sta	P0TMP,x
	inx
	cpx	#$0E		; max. chars expected
	bcc	?22
?24:	stx	ScnSaveX	; salva #bytes maschera input	
	stz	ScnTmpL		; op-code iniziale: 00
?25:	stz	ScnTmpH		; indice iniziale maschera
	lda	ScnTmpL		; op-code corrente
	jsr	getindx		; ricava dati op-code
	ldx	asmpr		; salva modo istruzione
	stx	ScnSaveY
	tax				; indice
	bit	asmcpu
	bmi	?25a			; cpu 8 bit	
	lda	>MEMTBLH,x		; test mnemonico H
	jsr	?210
	lda	>MEMTBLL,x		; test mnemonico L
	jsr	?210
	jmp	?300
?25a:	lda	>MEMTBLH1,x		; test mnemonico H
	jsr	?210
	lda	>MEMTBLL1,x		; test mnemonico L
	jsr	?210
	bit	asmbit			; test SMB/RMB/BBR/BBS
	bpl	?29			; no
	ldx	asmpr			; modo ind.
	lda	SMTmpH			; # bit per SMB/RMB
	cpx	#$9D			; relativo ?
	bne	?26			; no
	lda	asmtmpH			; # bit per BBR/BBS
?26:	inc	ScnTmpH			; scarta primo digit della maschera
	ldx	ScnTmpH	
	sta	P0TMP,x
	lda	SMbndx			; # bit op code
	jsr	?210			; check # bit
	lda	#','
	jsr	?210			; check virgola
	ldx	asmpr			; modo ind.
	cpx	#$9D			; relativo ?
	bne	?29			; no
	lda	#'$'
	jsr	?210			; check ZP
	lda	#'0'
	jsr	?210
	jsr	?210
	lda	#','	
	jsr	?210			; check virgola
?29:	ldx	#6
?30:	cpx	#3
	bne	?40
	ldy	asmnb			; numero bytes
	beq	?40
?35:	lda	asmpr
	cmp	#$E8
	lda	#'0'
	bcs	?50
	jsr	?210
	jsr	?210
	dey
	bne	?35
?40:	asl	asmpr
	bcc	?45
	lda	>PRTAB11-1,x
	jsr	?210
	lda	>PRTAB21-1,x
	beq	?45
	jsr	?210
?45:	dex
	bne	?30
	beq	?55
?50:	jsr	?210			; check $XXXX
	jsr	?210
	jsr	?210
	jsr	?210	
?55:	lda	ScnSaveX		; maschera coincide ?
	cmp	ScnTmpH
	bne	?211			; no, prova next op-code
?60:	ldy	asmnb			; numero bytes
	beq	?96
	lda	ScnSaveY
	cmp	#$9D
	bne	?90			; no ind. relativo
	
	; SMAddrL/H = ptr. opcode
	; il salto relativo va calcolato su ptr + #bytes istruzione
	; attualmente #bytes = SAddrL + 1
	; indirizzo del salto relativo in SMTmpL/H
	
?60a:	lda	SMAddrL			; A,X = ptr opcode attuale
	ldx	SMAddrH
	clc
	adc	asmnb
	bcc	?61
	inx
?61:	inc	a
	bne	?62
	inx
?62: 	sta	tmpl			; TmpL/H = ptr next istruzione
	stx	tmph
	sec				; calcolo offset
	lda	SMTmpL
	sbc	tmpl
	sta	asmtmpH			; salva offset low
	lda	SMTmpH
	sbc	tmph
	bcc	?70			; offset negativo
	bne	?215			; errore: offset > 00FF
	ldx	asmtmpH			; offset 1 byte
	bmi	?215			; errore: offset positivo max. = 7F
	bpl	?80			; offset positivo OK
?70:	tay				; offset negativo parte high
	iny				; deve essere FF
	bne	?215			; errore: offset negativo fuori range
	ldx	asmtmpH			; offset negativo
	bpl	?215			; errore: deve essere negativo
?80:	txa
	ldy	asmnb			; # bytes
	bit	asmcpu
	bpl	?94			; no rmb/smb/bbr/bbs for 65C816
	bit	asmbit
	bpl	?94			; no BBR/BBS
	sta	[SMAddrL],y		; BBR/BBS: store offset
	dey	
	lda	asmtmpL			; BBR/BBS: store ZP
	sta	[SMAddrL],y
	bra	?96			; store op-code
?90:	tyx	
	lda	SMTmpL-1,x		; memorizza i bytes
?94:	sta	[SMAddrL],y
	dey
	bne	?90
?96:	lda	ScnTmpL			; store op-code
	sta	[SMAddrL]	
	SCNPRINT
	.DB	KB_CR, SCN_CSRUP	; CR + cursore up     
	.DB	'a ', KB_ESC, 'Q', 0
	jsr	disx162			; disassembla SMAddrL/H
	lda	asmnb			; #bytes
	inc	a			; offset next istruzione
	jsr	IncPtr			; update SMAddrL/H	

	; inserisce ora nel buffer tastiera il seguente comando:
	; 'A YYXXXX '
	; si disabilita temporaneamente auto insert nel
	; caso il comando venisse dato dopo un d
	
	jmp	?500
	
	; check maschera op-code
?210:	phx
	ldx	ScnTmpH
	cmp	P0TMP,x
	beq	?220
	plx
	pla
	pla
?211:	inc	ScnTmpL			; next op-code
	beq	?215
	jmp	?25
?215:	jmp	ErrCls2
?220:	inx
	stx	ScnTmpH
	plx
	rts

;; 65C816 
?300:	ldx	#9
?330:	cpx	#5
	bne	?340	
	ldy	asmnb			; numero bytes
	beq	?340
?335:	lda	#'0'
	bit	asmrel
	bmi	?350		; check XXXX - full hex address 
	jsr	?210		; check XX (a pair of hex digits)
	jsr	?210
	bit	asmmov
	bpl	?337
	cpy	#$02		; mvn/mvp op-code: '#$src,#$dst' syntax 
	bcc	?337
	lda	#','
	jsr	?210		; check virgola
	lda	#'#'
	jsr	?210		; check '#'
	lda	#'$'
	jsr	?210		; check '$'
?337:	dey
	bne	?335
?340:	ACC16	
	asl	asmpr
	ACC08
	bcc	?345
	lda	>PRTAB1-1,x
	jsr	?210
	lda	>PRTAB2-1,x
	beq	?345
	jsr	?210
?345:	dex
	bne	?330
	beq	?355
?350:	jsr	?210			; check $XXXX
	jsr	?210
	jsr	?210
	jsr	?210	
?355:	lda	ScnSaveX		; maschera coincide ?
	cmp	ScnTmpH
	bne	?211			; no, prova next op-code
?360:	ldy	asmnb			; numero bytes
	bne	?361
	jmp	?96		; store op-code
?361:	bit	asmrel
	bmi	?362
	jmp	?90		; store all bytes
?362:	bvs	?363
	jmp	?60a
	
?363:
	; SMAddrL/H = ptr. opcode
	; il salto relativo va calcolato su ptr + #bytes istruzione
	; attualmente #bytes = SAddrL + 1
	; indirizzo del salto relativo in SMTmpL/H

	lda	#0
	xba
	lda	asmnb
	sec
	ACC16
	adc	SMAddrL		; ptr opcode attuale
	sec
	sbc	SMTmpL
	eor	#$FFFF
	inc	a
	sta	SMTmpL		; offset
	ACC08
	ldy	asmnb			; # bytes
	jmp	?90

?500:	ldx	#0
	lda	#'a'
	sta	XBUF+1
	stz	XBUF
	lda	#' '	
	sta	XBUF+3
	stz	XBUF+2
	lda	SMAddrK
	jsr	FF_Byte2Hex
	sta	XBUF+5
	stz	XBUF+4
	stx	XBUF+7
	stz	XBUF+6
	lda	SMAddrH
	jsr	FF_Byte2Hex
	sta	XBUF+9
	stz	XBUF+8
	stx	XBUF+11
	stz	XBUF+10
	lda	SMAddrL
	jsr	FF_Byte2Hex
	sta	XBUF+13
	stz	XBUF+12
	stx	XBUF+15
	stz	XBUF+14
	lda	#' '
	sta	XBUF+17
	stz	XBUF+16
	sei
	ldx	#18
	stx	KbdCnt
	stx	KbdITail
	stz	KbdIHead	
	dex
?501:	lda	XBUF,x
	sta	KbdBuf,x
	dex
	bpl	?501
	cli
	lda	#$80
	trb	ScnAutoIns
	rts 		

; convert A to up case
upcase:
	cmp	#'a'
	bcc	?01
	cmp	#('z'+1)
	bcs	?01
	and	#$DF
?01:	rts

; check A if hex digit
chkdgt:
	cmp	#'A'
	bcc	?01
	cmp	#'G'
	rts
?01:	cmp	#'0'
	bcc	CRTS
	cmp	#('9'+1)
	rts

; return in A the value of the next 2 digits from input buffer
dgt2hex:
	jsr	dgt2nbl		; convert digit in nibble
	sta	tmpl
	jsr	GetCurCh	; next byte
	jsr	upcase
	jsr	chkdgt		; check if digit
	bcc	?01
	dec	SMbndx
	lda	tmpl
	clc
	rts
?01:	pha
	lda	tmpl
	asl	a
	asl	a
	asl	a
	asl	a
	sta	tmpl
	pla
	jsr	dgt2nbl		; convert 2nd digt to nibble  
	ora	tmpl		; concatene value			
CRTS:
	sec
	rts

; convert digiut in A in nibble
dgt2nbl:
	cmp	#('9'+1)
	php
	and	#$0F
	plp
	bcc	?01
	adc	#$08
?01:	rts

;---------------------------------------------------------------------------
; tables used for 65C816
;---------------------------------------------------------------------------

; table of compact mnemonic for 65C816 op-code (low byte)
MEMTBLL:
	;;	BRK  PHP  BPL  CLC  JSR  PLP  BMI  SEC
	.DB	$1C, $8A, $1C, $23, $5D, $8B, $1B, $A1	; 00
	;;	RTI  PHA  BVC  CLI  RTS  PLA  BVS  SEI 
	.DB	$9D, $8A, $1D, $23, $9D, $8B, $1D, $A1	; 08
	;;	BRA  DEY  BCC  TYA  LDY  TAY  BCS  CLV
	.DB	$1C, $29, $19, $AE, $69, $A8, $19, $23	; 10
	;;	CPY  INY  BNE  CLD  CPX  INX  BEQ  SED
	.DB	$24, $53, $1B, $23, $24, $53, $19, $A1	; 18
	;;	TSB  BIT  JMP  JMP  STY  LDY  CPY  CPX
	.DB	$AD, $1A, $5B, $5B, $A5, $69, $24, $24	; 20
	;;	TXA  TXS  TAX  TSX  DEX  PHX  NOP  PLX
	.DB	$AE, $AE, $A8, $AD, $29, $8A, $7C, $8B	; 28
	;;	ASL  ROL  LSR  ROR  STX  LDX  DEC  INC
	.DB	$15, $9C, $6D, $9C, $A5, $69, $29, $53	; 30
	;;	ORA  AND  EOR  ADC  STA  LDA  CMP  SBC
	.DB	$84, $13, $34, $11, $A5, $69, $23, $A0	; 38
	;;	PHD  TCS  PLD  TSC  PHK  TCD  RTL  TDC	
	.DB	$8A, $A9, $8B, $AD, $8A, $A9, $9D, $A9	; 40
	;;	PHB  TXY  PLB  TYX  WAI  STP  XBA  XCE
	.DB	$8A, $AE, $8B, $AE, $C0, $A5, $C8, $C9	; 48
	;;	COP  JSL  WDM  PER  BRL  LDX  REP  SEP
	.DB	$24, $5D, $C1, $89, $1C, $69, $99, $A1	; 50
	;;	INC  DEC  PHY  PLY  TRB  STZ  MVP  MVN
	.DB	$53, $29, $8A, $8B, $AC, $A5, $75, $75	; 58
	;;	PEI  PEA  JML
	.DB	$89, $89, $5B	

; table of compact mnemonic for 65C816 op-code (high byte)
MEMTBLH:
	;;	BRK  PHP  BPL  CLC  JSR  PLP  BMI  SEC
	.DB	$D8, $62, $5A, $48, $26, $62, $94, $88	; 00
	;;	RTI  PHA  BVC  CLI  RTS  PLA  BVS  SEI 
	.DB	$54, $44, $C8, $54, $68, $44, $E8, $94	; 08
	;;	BRA  DEY  BCC  TYA  LDY  TAY  BCS  CLV
	.DB	$C4, $B4, $08, $84, $74, $B4, $28, $6E	; 10
	;;	CPY  INY  BNE  CLD  CPX  INX  BEQ  SED
	.DB	$74, $F4, $CC, $4A, $72, $F2, $A4, $8A	; 18
	;;	TSB  BIT  JMP  JMP  STY  LDY  CPY  CPX
	.DB	$06, $AA, $A2, $A2, $74, $74, $74, $72	; 20
	;;	TXA  TXS  TAX  TSX  DEX  PHX  NOP  PLX
	.DB	$44, $68, $B2, $32, $B2, $72, $22, $72	; 28
	;;	ASL  ROL  LSR  ROR  STX  LDX  DEC  INC
	.DB	$1A, $1A, $26, $26, $72, $72, $88, $C8	; 30
	;;	ORA  AND  EOR  ADC  STA  LDA  CMP  SBC
	.DB	$C4, $CA, $26, $48, $44, $44, $A2, $C8	; 38
	;;	PHD  TCS  PLD  TSC  PHK  TCD  RTL  TDC	
	.DB	$4A, $28, $4A, $08, $58, $0A, $5A, $48	; 40
	;;	PHB  TXY  PLB  TYX  WAI  STP  XBA  XCE
	.DB	$46, $74, $46, $B2, $94, $62, $C4, $0C	; 48
	;;	COP  JSL  WDM  PER  BRL  LDX  REP  SEP
	.DB	$22, $1A, $5C, $A6, $DA, $72, $A2, $A2	; 50
	;;	INC  DEC  PHY  PLY  TRB  STZ  MVP  MVN
	.DB	$C8, $88, $74, $74, $C6, $76, $E2, $DE	; 58
	;;	PEI  PEA  JML
	.DB	$94, $84, $9A

; table of op-code that will be trnslated for access mnemonics table
OPTAB:
	;;	STZ  STZ  STZ  STZ  TRB  TRB  JML  JML
	.DB	$64, $74, $9C, $9E, $14, $1C, $5C, $DC
	;;	JSR  MVP  MVN  PEI  PEA  BIT
	.DB	$FC, $44, $54, $D4, $F4, $89
	
OPTABLEN	.EQU	($ - OPTAB - 1)

; translated index for access mnemonics table
TRANSL:
	.DB	$5D, $5D, $5D, $5D, $5C, $5C, $62, $62
	.DB	$04, $5E, $5F, $60, $61, $21

; table of addressing mode for even op-code
; this table is indexed by value 00..7F
AMODE:
;; 00..0E
;;	BRK		COP #		TSB dp		ASL dp
.DB	AIMPL,		AIMM,		ADP,		ADP	
	
;;	PHP		ASL A		TSB abs		ASL abs
.DB	AIMPL,		AIMPL,		AABS,		AABS

	
;; 10..1E
;;	BPL 		ORA (dp)	TRB dp		ASL dp,x
.DB	AREL,		AIND,		ADP,		ADPX

;;	CLC		INC A		TRB abs		ASL abs,x
.DB	AIMPL,		AIMPL,		AABS,		AABSX

;; 20..2E
;;	JSR abs		JSL long	BIT dp		ROL dp
.DB	AABS,		ALONG,		ADP,		ADP
	
;;	PLP		ROL A		BIT abs		ROL abs
.DB	AIMPL,		AIMPL,		AABS,		AABS


;; 30..3E
;;	BMI		AND (dp)	BIT dp,x	ROL dp,x
.DB	AREL,		AIND,		ADPX,		ADPX

;;	SEC		DEC A		BIT abs,x	ROL abs,x
.DB	AIMPL,		AIMPL,		AABSX,		AABSX


;; 40..4E
;;	RTI		WDM #		MVP		LSR dp
.DB	AIMPL,		AIMM,		AMOV,		ADP

;;	PHA		LSR A		JMP abs		LSR abs
.DB	AIMPL,		AIMPL,		AABS,		AABS


;; 50.5E
;;	BVC		EOR (dp)	MVN		LSR dp,x
.DB	AREL,		AIND,		AMOV,		ADPX

;;	CLI		PHY		JML long	LSR abs,x
.DB	AIMPL,		AIMPL,		ALONG,		AABSX


;; 60..6E
;;	RTS		PER rel16	STZ dp		ROR dp
.DB	AIMPL,		A16R,		ADP,		ADP

;;	PLA		ROR A		JMP (abs)	ROR abs
.DB	AIMPL,		AIMPL,		ABIND,		AABS


;; 70..7E
;;	BVS		ADC (dp)	STZ dp,x	ROR dp,x
.DB	AREL,		AIND,		ADPX,		ADPX

;;	SEI		PLY		JMP (abs,x)	ROR abs,x
.DB	AIMPL,		AIMPL,		ABXI,		AABSX


;; 80..8E
;;	BRA		BRL		STY dp		STX dp
.DB	AREL,		A16R,		ADP,		ADP

;;	DEY		TXA		STY abs		STX abs
.DB	AIMPL,		AIMPL,		AABS,		AABS


;; 90..9E
;;	BCC		STA (dp)	STY dp,x	STX dp,y
.DB	AREL,		AIND,		ADPX,		ADPY

;;	TYA		TXS		STZ abs		STZ abs,x
.DB	AIMPL,		AIMPL,		AABS,		AABSX


;; A0..AE
;;	LDY #		LDX #		LDY dp		LDX dp
.DB	AXIMM,		AXIMM,		ADP,		ADP
	
;;	TAY		TAX		LDY abs		LDX abs
.DB	AIMPL,		AIMPL,		AABS,		AABS


;; B0..BE
;;	BCS		LDA (dp)	LDY dp,x	LDX dp,y
.DB	AREL,		AIND,		ADPX,		ADPY

;;	CLV		TSX		LDY abs,x	LDX abs,y
.DB	AIMPL,		AIMPL,		AABSX,		AABSY


;; C0..CE
;;	CPY #		REP #		CPY dp		DEC dp
.DB	AXIMM,		AIMM,		ADP,		ADP
	
;;	INY		DEX		CPY abs		DEC abs
.DB	AIMPL,		AIMPL,		AABS,		AABS
	
	
;; D0..DE
;;	BNE		CMP (dp)	PEI (dp)	DEC dp,x
.DB	AREL,		AIND,		AIND,		ADPX

;;	CLD		PHX		JML [abs]	DEC abs,x
.DB	AIMPL,		AIMPL,		AJML,		AABSX


;; E0..EE
;;	CPX #		SEP #		CPX dp		INC dp
.DB	AXIMM,		AIMM,		ADP,		ADP

;;	INX		NOP		CPX abs		INC abs
.DB	AIMPL,		AIMPL,		AABS,		AABS


;; F0..FE
;;	BEQ		SBC (dp)	PEA #16		INC dp,x
.DB	AREL,		AIND,		A16IMM,		ADPX,

;;	SED		PLX		JSR (abs,x)	INC abs,x
.DB	AIMPL,		AIMPL,		ABXI,		AABSX

; addressing mode for odd op-code -- note that all op-code <XB> are implied
; op-code <X1>, <X3>, <X5>, <X7>, <X9>, <XD>, <XF> are relative to accumulator
; this table is indexed by value 80..8F
;; X1, X5, X9, XD
;;	(dp,x)		dp		#		abs
.DB	AXIND,		ADP,		AMIMM,		AABS

;; X1, X5, X9, XD
;;	(dp),y		dp,x		abs,y		abs,x
.DB	AYIND,		ADPX,		AABSY,		AABSX

;; X3, X7, XB, XF
;;	rel,s		[dp]		implied		long
.DB	ASTK,		ALIND,		AIMPL,		ALONG

;; X3, X7, XB, XF
;;	(rel,s),y	[dp],y		implied		long,x
.DB	AYSTK,		AYLIND,		AIMPL,		ALONGX


;; table for print symbols for the addressing mode
PRTAB1:
	.DB	',)],,#([$'

PRTAB2:
	.DB	'Y', 0, 0, 'SX$$$', 0

;; table that encode printing symbols and number of bytes for the op-code
;; this table is indexed by a value given by table AMODE
;; last 2 bits give the numbers of bytes 
;; bit <15:5> specify what must be printed (index in array PRTABx)
;; after bit 12 and bit 06 must be printed an hexadecimal value
;; <15>		$	NULL
;; <14>		[	$
;; <13>		(	$
;; <12>		#	$
;; <11>		,	X
;; <10>		,	S
;; <09>		]	NULL
;; <08>		)	NULL
;; <07>		,	Y
;; <06>
;; <05>		
;; <04>
;; <03>
;; <02>
;; <01:00>	number of bytes (0..3)
ENCTAB:
	.DW	$0000, $1001, $8001, $8002, $8003, $8803, $2901, $2181
	.DW	$8801, $8802, $8082, $2102, $8081, $8001, $2902, $2101
	.DW	$8401, $4201, $4281, $2581, $1002, $8002, $4202, $1002

;---------------------------------------------------------------------------
; tables used for 6502/65C02
;---------------------------------------------------------------------------

; compact mnemonics for 6502/65C02
MEMTBLL1:
	.DB	$1C, $8A, $1C, $23, $5D, $8B, $1B, $A1
	.DB	$9D, $8A, $1D, $23, $9D, $8B, $1D, $A1
	.DB	$1C, $29, $19, $AE, $69, $A8, $19, $23
	.DB	$24, $53, $1B, $23, $24, $53, $19, $A1
	.DB	$00, $1A, $5B, $5B, $A5, $69, $24, $24
	.DB	$AE, $AE, $A8, $AD, $29, $8A, $7C, $8B
	.DB	$15, $9C, $6D, $9C, $A5, $69, $29, $53
	.DB	$84, $13, $34, $11, $A5, $69, $23, $A0
	.DB	$53, $29, $8A, $8B, $9B, $A3, $18, $18
	.DB	$A5, $AD, $AC, $00
		
MEMTBLH1:
	.DB	$D8, $62, $5A, $48, $26, $62, $94, $88
	.DB	$54, $44, $C8, $54, $68, $44, $E8, $94
	.DB	$C4, $B4, $08, $84, $74, $B4, $28, $6E
	.DB	$74, $F4, $CC, $4A, $72, $F2, $A4, $8A
	.DB	$00, $AA, $A2, $A2, $74, $74, $74, $72
	.DB	$44, $68, $B2, $32, $B2, $72, $22, $72
	.DB	$1A, $1A, $26, $26, $72, $72, $88, $C8
	.DB	$C4, $CA, $26, $48, $44, $44, $A2, $C8
	.DB	$C8, $88, $74, $74, $86, $86, $E6, $E8
	.DB	$76, $06, $C6, $00

; 6502 invalid opcode	
OPTAB1:
	.DB	$64, $74, $9C, $9E, $04, $0C, $14, $1C
	
OPTAB1LEN	.EQU	($ - OPTAB1 - 1)

	.DB	$80, $34, $1A, $3A, $5A, $7A, $DA, $FA, $3C, $7C

INVLEN		.EQU	($ - OPTAB1 - 1)

; translation table for some 65C02 op-code
TRANSL1:
	.DB	$83, $83, $83, $83, $A3, $A3, $C3, $C3

; encoded addressing mode
;
;	0:	invalid
;	1:	#
;	2:	ZP	(tesrt asmbit)
;	3:	ABS
;	4:	IMPLIED
;	5:	ACCUM
;	6:	(ZP,X)
;	7:	(ZP),Y
;	8:	ZP,X
;	9:	ABS,X
;	A:	ABS,Y
;	B:	(ABS)
;	C:	ZP,Y
;	D:	REL	(test asmbit)
;	E:	(ABS,X)
;	F:	(ZP)

; 6502/65C02 addressing mode table
AMODE1:
	; even op-code
	.DB	$40, $22, $45, $33, $DF, $28, $45, $39	; 00..07 - OP 00..1E 
	.DB	$30, $22, $45, $33, $DF, $88, $45, $99	; 08..0F - OP 20..3E
	.DB	$40, $02, $45, $33, $DF, $08, $44, $09	; 10..17 - OP 40..5E
	.DB	$40, $22, $45, $B3, $DF, $88, $44, $E9	; 18..1F - OP 60..7E
	.DB	$D0, $22, $44, $33, $DF, $8C, $44, $39	; 20..27 - OP 80..9E
	.DB	$11, $22, $44, $33, $DF, $8C, $44, $9A	; 28..2F - OP A0..BE
	.DB	$10, $22, $44, $33, $DF, $08, $44, $09	; 30..37 - OP C0..DE
	.DB	$10, $22, $44, $33, $DF, $08, $44, $09	; 38..3F - OP E0..FE
	
	; odd op-code
	.DB	$62, $13, $78, $A9			; 80..87
	
	.DB	$2D					; 88..89 - RMB/BBR

ENCTAB1:
	.DB	$00, $21, $81, $82, $00, $00, $59, $4D
	.DB	$91, $92, $86, $4A, $85, $9D, $5A, $49

;; table for print symbols for the 6502/65C02 addressing mode
PRTAB11:
	.DB	',),#($'	
PRTAB21:
	.DB	'Y', 0, 'X$$', 0
