;----------------------------------------------------------
; MOND.ASM
; PROGETTO: B1601
;
; Monitor di sistema - funzioni diagnostica ATA/FDC
;----------------------------------------------------------

_ACIA_INC_	.SET	1
_ATA_INC_	.SET	1
_KBD_INC_	.SET	1
_SCN_INC_	.SET	1

	.INCLUDE inc\global.inc
	.INCLUDE inc\dirp00.inc
	.INCLUDE inc\dirp01.inc

	.LIST on

INPUTBUF	.EQU	MONBUF
	
	.CODEFF
	.EXTERN ErrCls2, GetParm, PrintByte, PrintHex, GetParm32
	.EXTERN PrintWord, CkStop, FF_Byte2Hex
	.EXTERN _getopt			; FA/getopt.asm
	
	.GLOBAL Cmd_fddisk, Cmd_fdgetfmt, Cmd_fdres, Cmd_fdinit, Cmd_fdformat
	.GLOBAL Cmd_fdverfmt, Cmd_fdread, Cmd_fdwrite, Cmd_fdverf, Cmd_fdlsys
	.GLOBAL Cmd_fdtread, Cmd_fdtwrite, Cmd_fdtverf, Cmd_fdnew, Cmd_fdfs

	.GLOBAL matcmd, atacmd, Cmd_mkhash

	.LONGA	off
	.LONGI	off

;---------------------------------------------------------------------------
; at '@' commands
;---------------------------------------------------------------------------

; @ commands
matcmd:
	lda	<atnum
	asl	a
	tax
	jsr	(MATVECS,x)
	;SCN_CR
	rts

; '@c "command"' send command to cbm fs emulator
matsnd:
	lda	#15
	sta	<atsa
	
; '@o "file" chnl' - open file
matopn:
	lda	<atipb		; bank of cmnd string
	pha
	pei	(atstr)		; address of cmnd string
	lda	<atsa		; chnl
	pha
	CBMFSCMD		; send command
	bcs	materr		; if error
	rts

; '@' or '@e': print error message
materr:
VARSIZ	.SET	128
	SCN_CR
	ACC16			; make room in stack
	tsc
	sec
	sbc	#VARSIZ
	tcs
	inc	a		; buffer pointer
	ldx	#0
	phx			; bank of buffer
	pha			; address of buffer
	pea	#VARSIZ		; size of buffer
	ACC08
	lda	#15		; channel 15
	pha
	CBMFSRD			; read
	ACC16
	tsc
	inc	a		; address of buffer
	ACC08
	ldx	#0		; bank of buffer
	SCNSTROUT		; print string
	ACC16CLC
	tsc			; clean stack
	adc	#VARSIZ
	tcs
	ACC08
	rts

; '@d "$[drive[:pattern[=type]]]"'
; load and print directory
matdir:
VARSIZ	.SET	128		; mult. of 32 !!!
	lda	<atipb		; bank of cmnd string
	pha
	pei	(atstr)		; address of cmnd string
	lda	#$00		; chnl = 0
	pha
	CBMFSCMD		; send command
	bcs	materr		; if error
	ACC16			; make room in stack
	tsc
	sec
	sbc	#VARSIZ
	tcs
	inc	a		; buffer pointer
	sta	<atbuf
	stz	<atend		; buffer count #
	ACC08
	stz	<atdir
	lda	#6		; offset # blocks header
	sta	<atstart
	stz	<atstart+1
	SCN_CR
?10:	jsr	?100		; load buffer			
	beq	?90		; no data: end of load
?14:	ldy	<atstart	
	phy
?14a:	lda	(atptr),y
	cmp	#' '
	bne	?14b
	iny
	bra	?14a
?14b:	sty	<atstart
	ply
	
	ACC16CLC
	lda	<atptr
	adc	<atstart
	ldx	#0
	phx			; bank of string (stack)
	pha			; address of string
	;;ldy	<atstart
	dey
	dey
	lda	(atptr),y	; blocks #
	pha
	ACC08
	phk			; bank of format
	pea	#!?200		; address of format
	ldx	#9		; # params
	phx
	BPRINTF
	lda	#4		; just header need offset = 6
	sta	<atstart
	ACC16CLC
	lda	<atptr
	adc	#32
	sta	<atptr
	cmp	<atend
	ACC08
	bcc	?14		; next line in buffer
	bit	<atdir		; bit 7 set if end
	bpl	?10		; loop
?90:	ACC16CLC
	tsc			; clean stack
	adc	#VARSIZ
	tcs
	ACC08
	lda	#0
	CBMFSCLS
	rts

?100:	lda	#0		; load buffer
	pha			; bank of buffer
	pei	(atbuf)		; address of buffer
	pea	#VARSIZ		; size of buffer
	lda	#$00
	pha			; chnl 0
	CBMFSRD			; read	
	bcc	?104
	pla
	pla
	ACC16CLC
	tsc			; clean stack
	adc	#VARSIZ
	tcs
	ACC08
	lda	#0
	CBMFSCLS	
	jmp	materr
?104:	ACC16
	pha
	pla
	beq	?110		; end of data
	cmp	#VARSIZ
	bcs	?106
	ldx	#$80
	stx	<atdir		; EOF flag
?106:	clc
	adc	<atbuf
	sta	<atend		; end buffer
	lda	<atbuf
	sta	<atptr
?110:	ACC08	
	rts
	
?200:
	.DB	'% 4hu %s', $0D, 0

; '@l "file" bnk [start]' load file (chnl 0)	
matload:
	stz	<atsa
	bra	matrd1
	
matver:
	rts

; '@r "file" bnk [start]' open file for read (chnl 5)
matrd:
	lda	#5
	sta	<atsa
matrd1:
	SCN_CR	
	lda	<atipb		; bank of cmnd string
	pha
	pei	(atstr)		; address of cmnd string
	lda	<atsa		; chnl = 15
	pha
	CBMFSCMD		; send command
	bcc	?02
?01:	jmp	materr		; if error
?02:	stz	atlp
	stz	atlp+1
	lda	<atbnk
	sta	<atlp+2
	INDEX16
	ldy	#0
	lda	#$EA
?03:	sta	[atlp],y
	iny
	bne	?03
	INDEX08
	bit	<atflag
	ACC16
	bpl	?04		; no start address
	lda	<atstart
	sta	<atlp
	sec
	lda	#$FFF0
	sbc	<atstart
	sta	<atsiz
	bra	?06
?04:	lda	#$FFF0
	sta	<atsiz
?06:	ACC08
	lda	<atlp+2
	pha
	pei	(atlp)
	pei	(atsiz)
	lda	<atsa
	pha
	CBMFSRD			; read	
	php
	ACC16
	pha
	ACC08
	lda	<atsa
	CBMFSCLS
	;SCN_CR
	ACC16
	pla
	ACC08
	xba
	tax			; HI
	xba			; LOW
	jsr	PrintWord
	;SCN_CR
	plp
	bcs	?01
	rts

; '@g chnl bnk [start]' - read in max. 256 bytes
matget:
	ACC16
	lda	#256
	sta	<atsiz
	stz	atlp
	ACC08
	lda	<atbnk
	sta	<atlp+2
	lda	<atlp+2
	pha
	pei	(atlp)
	pei	(atsiz)
	lda	<atsa
	pha
	CBMFSRD			; read
	php
	xba
	tax			; HI
	xba			; LOW
	jsr	PrintWord
	;SCN_CR
	plp
	bcc	?02
	rts
?02:	jmp	materr		; if error

; '@p chnl bnk [start]' - write out max. 256 bytes
matput:
	ACC16
	lda	#256
	sta	<atsiz
	stz	atlp
	ACC08
	lda	<atbnk
	sta	<atlp+2
	lda	<atlp+2
	pha
	pei	(atlp)
	pei	(atsiz)
	lda	<atsa
	pha
	CBMFSWR			; write
	php
	xba
	tax			; HI
	xba			; LOW
	jsr	PrintWord
	;SCN_CR
	plp
	bcc	?02
	rts
?02:	jmp	materr		; if error

; '@s "file" bnk start end' save file chnl=1
matsave:
	lda	#1
	sta	<atsa
	bra	matwr1

; '@w "file" bnk start end'
matwr:
	lda	#5
	sta	<atsa

matwr1:
	SCN_CR	
	lda	<atipb		; bank of cmnd string
	pha
	pei	(atstr)		; address of cmnd string
	lda	<atsa		; chnl = 15
	pha
	CBMFSCMD		; send command
	bcc	?02
?01:	jmp	materr		; if error
?02:	stz	atlp
	stz	atlp+1
	lda	<atbnk
	sta	<atlp+2
	ACC16
	lda	<atstart
	sta	<atlp
	sec
	lda	<atend
	sbc	<atstart
	sta	<atsiz
	ACC08
	lda	<atlp+2
	pha
	pei	(atlp)
	pei	(atsiz)
	lda	<atsa
	pha
	CBMFSWR			; write
	php
	ACC16
	pha
	ACC08
	lda	<atsa
	CBMFSCLS
	;SCN_CR
	ACC16
	pla
	ACC08
	xba
	tax			; HI
	xba			; LOW
	jsr	PrintWord
	;SCN_CR
	plp
	bcs	?01
	rts

; '@z' - close all
matclsall:
	lda	#15
	CBMFSCLS
	rts

; '@x chnl' - close chnl
matclose:
	lda	<atsa
	CBMFSCLS
	rts

MATVECS:
	.DW	materr, matclsall, matclose, matget, matput
	.DW	matdir, matsnd, matload, matsave, matver
	.DW	matrd, matwr, matopn

;---------------------------------------------------------------------------
	
; test hash
HASH	.EQU	SMXTmp
FCBS	.EQU	SMXTmp+2

Cmd_mkhash:
	SCNPRCHAR
	.DB	KB_CR

	ldx	#$0A
?02:	lda	>TESTSTR,x
	sta	FCBS,x
	dex
	bpl	?02
	ldx	#FCBS
	jsr	_mkhash
	lda	HASH
	ldx	HASH+1
	jsr	PrintWord
	SCNPRCHAR
	.DB	KB_CR
	rts	
	
_mkhash:
	stz	HASH
	stz	HASH+1
	lda	<0,x
	beq	?20
	cmp	#$E5
	beq	?20
	and	#$7F
	sta	HASH+1
	ldy	#$0A
?04:	ACC16
	lda	HASH
	asl	a
	adc	#$0000
	sta	HASH
	ACC08
	inx
	lda	<0,x
	and	#$7F
	eor	HASH
	sta	HASH
	dey
	bne	?04
	ACC16
	lda	HASH
	bne	?08
	inc	a
	sta	HASH
?08:	ACC08
?20:	rts

TESTSTR:
	.DB	'..         '
	
; # fdlsys [drive = 0]
; load rom.bin from floppy and store in bank $E0..$E7
Cmd_fdlsys:
	stz	SMFflag
	lda	#$00
	bcs	?04		; use default drive #0
	lda	SMTmpK
	ora	SMTmpH
	beq	?02
	jmp	CmdErr
?02:	lda	SMTmpL
	cmp	#$04
	bcc	?04
	jmp	CmdErr
?04:	sta	SMTmp3		; drive
	tax			; X = drive
	FDCGETFMT		; get disk format
	bcc	?06
	jmp	drs0		; error
?06:	cpy	#$02		; required format = $02
	beq	?08
	SCNPRINT		; error 
	.DB	$0D, KB_ESC, 'q', $00
	SCNPRINT
	.DB	'::ERROR - disk format is not 02, but ', $00
	tya
	jmp	PrintHex
?08:	lda	SMTmp3		; drive
	pha
	lda	#$00
	pha			; track = 0
	pha			; buffer = 0
	pha			; flag = dos format
	FDCTKRD			; read whole track 0
	bcc	?10
	jmp	fdcr		; error
?10:	INDEX16
	ldy	#$2600		; start of root directory
	sty	SMTmpL
	INDEX08
	lda	#$02
	sta	SMTmpK
?12:	lda	[SMTmpL]	; scan root directory
	bne	?16
?14:	SCNPRINT		; error -- end of root directory 
	.DB	$0D, KB_ESC, 'q', $00
	SCNPRINT
	.DB	'::ERROR - file ROM.BIN not found', $00
	rts
?16:	ldx	#0		; search 'rom.bin'
	txy
?16l:	lda	[SMTmpL],y
	cmp	>SYNAM,x
	beq	?17
	ACC16CLC
	lda	SMTmpL
	adc	#$0020
	sta	SMTmpL
	cmp	#$4200		; end of root directory?
	ACC08
	bcc	?12		; loop scan
	bcs	?14		; end of root directory
?17:	iny
	inx
	cpx	#$0B
	bcc	?16l
	lda	[SMTmpL],y	; name ok -- check record
	cmp	#$20		; attribute
	beq	?20
?18:	SCNPRINT		; error -- entry not valid 
	.DB	$0D, KB_ESC, 'q', $00
	SCNPRINT
	.DB	'::ERROR - invalid ROM.BIN entry', $00
	rts
?20:	ldy	#$1A		; check cluster
	lda	[SMTmpL],y
	cmp	#$02
	bne	?18		; will be cluster #2
	iny
	lda	[SMTmpL],y
	bne	?18
	iny
	iny
	iny
	ACC16			; test size
	lda	[SMTmpL],y	; size H
	sta	SMdwTmp1+2
	dey
	dey
	lda	[SMTmpL],y	; size L
	sta	SMdwTmp1
	ACC08
	bne	?18		; size L must be 0
	lda	SMdwTmp1+3
	bne	?18		; must be 0
	lda	SMdwTmp1+2
	cmp	#$08
	bne	?18		; must be 0
	; now check FAT 1 -- ROM.BIN must be in sqeuential clusters
	; starting from cluster #2 - last cluster $0402
	ldy	#1
	CPU16
	lda	#$0200		; start of FAT #1
	sta	SMTmpL
	lda	[SMTmpL]	
	cmp	#$FFF0
	bne	?28
	lda	[SMTmpL],y	; must be $FFFF
	inc	a
	bne	?28
	iny
	iny
	sty	SMdwTmp2	; next expected cluster
?22:	lda	[SMTmpL],y
	and	#$0FFF		; mask 12 bit low
	cmp	SMdwTmp2	; even cluster
	bne	?28		; unmatch
	iny			; 12 bit high
	cmp	#$0401
	bne	?24
	lda	#$0FFF
	sta	SMdwTmp2	; mark last cluster
	bra	?26
?24:	inc	SMdwTmp2
?26:	lda	[SMTmpL],y
	lsr	a
	lsr	a
	lsr	a
	lsr	a		; odd cluster
	iny
	iny			; next FAT entry
	cmp	SMdwTmp2	; even cluster
	bne	?28
	inc	SMdwTmp2
	cmp	#$0FFF
	bne	?22		; loop
?28:	CPU08
	beq	?30		; ok -- check FAT done
	SCNPRINT		; error -- invalid FAT 
	.DB	$0D, KB_ESC, 'q', $00
	SCNPRINT
	.DB	'::ERROR - invalid FAT', $00
	rts
?30:	SCNPRINT
	.DB	$0D, KB_ESC, 'q', $00
	SCNPRINT
	.DB	'::load "ROM.BIN" from bank $E0 to bank $E7', $00
	lda	#$E0
	sta	SMdwTmp3+2
	lda	#1
	sta	SMTmp3+1	; track = 1
	ldy	#0
	CPU16
	lda	#$4200		; start of cluster #2
	sta	SMTmpL
	stz	SMdwTmp3
?34:	lda	[SMTmpL],y	; copy the last 3 sectors of track 0, head 1
	sta	[SMdwTmp3],y
	iny
	iny
	cpy	#$0600
	bcc	?34
	sty	SMdwTmp3	; update dest pointer
	sty	SMdwTmp1	; count moved bytes 
	stz	SMdwTmp1+2
	stz	SMTmpL		; buffer pointer
	CPU08
?36:	lda	SMTmp3		; loop track 1..28
	pha			; drive
	lda	SMTmp3+1
	pha			; track
	pea	#0		; buffer = 0, flag = 0
	FDCTKRD			; read whole track
	bcc	?38
	jmp	fdcr		; error
?38:	jsr	?100		; move bytes
?42:	ldx	SMTmp3+1
	inx
	stx	SMTmp3+1
	cpx	#29
	bcc	?36		; loop track 1..28
	lda	SMTmp3
	pha			; drive
	phx			; track 29
	lda	#0
	pha			; head = 0
	inc	a
	pha			; secror = 1
	lda	#13
	pha			; read 13 sectors
	pea	#0		; buffer = 0, flag = 0
	FDCREAD
	bcc	?44
	jmp	fdcr
?44:	jsr	?100		; move bytes
	SCNPRCHAR
	.DB	KB_CR
	lda	SMdwTmp1+2
	jsr	PrintHex	; number of bytes
	lda	SMdwTmp1
	ldx	SMdwTmp1+1
	jsr	PrintWord	; number of bytes
	lda	SMdwTmp3+2
	jsr	PrintHex	; final address +1
	lda	SMdwTmp3
	ldx	SMdwTmp3+1
	jsr	PrintWord
	lda	SMdwTmp1
	ora	SMdwTmp1+1	; must be null
	bne	?46
	lda	SMdwTmp3
	ora	SMdwTmp3+1	; must be null
	bne	?46
	lda	SMdwTmp1+2
	cmp	#$08		; must be = 8
	bne	?46
	lda	SMdwTmp3+2
	cmp	#$E8		; must be = E8
	beq	?48
?46:	SCNPRINT
	.DB	' -- ERROR -- flash cannot be updated', $00
	rts
?48:	lda	#$80
	sta	SMFflag
	SCNPRINT
	.DB	' OK: flash can be updated', $00
	rts	
?100:	ldy	#0	
	CPU16
	sta	SMdwTmp2	; number of bytes
?200:	lda	[SMTmpL],y	; copy 36 sectors
	sta	[SMdwTmp3],y
	iny
	iny
	cpy	SMdwTmp2
	bcc	?200
	lda	SMdwTmp1
	clc
	adc	SMdwTmp2	; update count of moved bytes
	sta	SMdwTmp1
	lda	SMdwTmp1+2
	adc	#$0000
	sta	SMdwTmp1+2	
	tya
	adc	SMdwTmp3	; update dest pointer
	sta	SMdwTmp3
	CPU08
	bcc	?202
	inc	SMdwTmp3+2
?202:	rts

SYNAM:
	.DB	'ROM     BIN'
	

; # fdnew fmt0 [fmt1 = $80]
Cmd_fdnew:
	bcc	?00
	jmp	CmdErr		; no parametri
?00:	lda	SMTmpK
	ora	SMTmpH
	beq	?01
	jmp	CmdErr
?01:	lda	SMTmpL
	pha			; format #0
	jsr	GetParm		; format #1
	bcc	?02
	lda	#$80
	sta	SMTmpL
?02:	plx			; X = format #0
	ldy	SMTmpL		; Y = format #1
	FDNEWRD
	bra	drs

; # fdgetfmt [0=default|1] - get current disk format
Cmd_fdgetfmt:
	beq	?01
	lda	SMTmpK
	ora	SMTmpH
	bne	CmdErr
?01:	ldx	SMTmpL
	cmp	#$04
	bcs	CmdErr
	FDCGETFMT
	;FDCGETST
drs0:	php	
	SCNPRINT	; clear result line 
	.DB	$0D, KB_ESC, 'q', $00
	plp
	bcc	?02
	SCNPRINT
	.DB	'::error code -> ', $00
	bra	?04
?02:	SCNPRINT
	.DB	'::OK, ', $00
?04:	tya
	jmp	PrintHex
	
; # fdres  - reset FDC controller
Cmd_fdres:
	bne	CmdErr
	FDCRESET
	bra	drs

; # fddisk [0=default|1] - check drive for disk inserted
Cmd_fddisk:
	beq	?01
	lda	SMTmpK
	ora	SMTmpH
	bne	CmdErr
?01:	ldx	SMTmpL
	cpx	#$04
	bcs	CmdErr
	FDCTST
drs:	php	
	SCNPRINT	; clear result line 
	.DB	$0D, KB_ESC, 'q', $00
	plp
	bcc	?02
	SCNPRINT
	.DB	'::error code -> ', $00
	tya
	jmp	PrintHex
?02:	SCNPRINT
	.DB	'::OK', $00
	rts

CmdErr:	
	jmp	ErrCls2

; # fdinit - reset FDC controller and check drives
Cmd_fdinit:
	bne	CmdErr
	lda	#$40
	trb	!BiosEnt
	lda	#$04
	bit	!fdcctl
	beq	?10		; skip test FDC
	SCNPRINT	; clear result line 
	.DB	$0D, KB_ESC, 'q', $00
	FDCINIT
?10:	rts

; # fdformat  drive flag/disk_fmt [fill = $00]
Cmd_fdformat:
	bcs	CmdErr		; no parametri
	lda	SMTmpL
	sta	SMTmp2		; drive
	jsr	GetParm		; parametro 2 - flag
	bcs	CmdErr
	lda	SMTmpL
	sta	SMTmp2+1	; flag
	jsr	GetParm		; parametro 3 - fill byte
	bcc	?04
	stz	SMTmpL		; default fill byte = $00
?04:	lda	SMTmp2
	pha
	pha			; drive
	lda	SMTmp2+1
	pha			; flag
	lda	SMTmpL
	pha			; fill byte
	phk			; bank of callback
	pea	#_FmtNotify	; address of callback
	FDCFORMAT
	pla
	bcs	drs
	SCNPRINT
	.DB	$0D, '::make file system', $00
	;lda	SMTmp2
	pha			; drive
	lda	#0
	pha			; buffer
	pea	#0		; ID
	pha			; name = null
	pea	#0
	FDCMKFS
	jmp	drs
	

; # fdverfmt  drive [default = 0]
Cmd_fdverfmt:
	beq	?01
	lda	SMTmpK
	ora	SMTmpH
	bne	CmdErr
?01:	lda	SMTmpL
	pha			; drive
	phk			; bank of callback
	pea	#_VFmtNotify	; address of callback
	FDCVERFMT
	jmp	drs0
	
; funzione notify callback durante fdformat (LONG)
; In	- A = drive
;	  X = head
;	  Y = track
;	  B = sector/track
;	  CF = 0 prima chiamata
_FmtNotify:
	phd
	pea	#DP01ADDR
	pld
	bcs	?10		; chiamate successive
	SCNPRINT
	.DB	$0D, '::format diskette on drive #', $00
	ora	#'0'
	SCNCHAROUT
	SCNPRINT
	.DB	' (#50T, #', $00
	xba			; A = sector/track
	phx
	phy
	jsr	PrintHex
	SCNPRINT
	.DB	'S/T) - Track: #', $00
	SCNGETPOS
	stx	SMAuxL
	sty	SMAuxH
	pla			; track
	jsr	PrintHex
	SCNPRINT
	.DB	', Side: #', $00
	SCNGETPOS
	stx	SMTmp2
	sty	SMTmp2+1
	bra	?20
?10:	phx
	phy
	ldx	SMAuxL
	ldy	SMAuxH
	SCNSETPOS
	pla
	jsr	PrintHex
	ldx	SMTmp2
	ldy	SMTmp2+1
	SCNSETPOS
?20:	pla
	jsr	PrintHex
	pld
	rtl

; funzione notify callback durante fdverfmt (LONG)
; In	- A = drive
;	  X = head
;	  Y = track
;	  B = format
;	  CF = 0 prima chiamata
_VFmtNotify:
	phd
	pea	#DP01ADDR
	pld
	bcs	?10		; chiamate successive
	SCNPRINT
	.DB	$0D, '::verify format diskette on drive #', $00
	ora	#'0'
	SCNCHAROUT
	SCNPRINT
	.DB	' (format #', $00
	xba			; A = format
	phx
	phy
	jsr	PrintHex
	SCNPRINT
	.DB	') - Track: #', $00
	SCNGETPOS
	stx	SMAuxL
	sty	SMAuxH
	pla			; track
	jsr	PrintHex
	SCNPRINT
	.DB	', Head: #', $00
	SCNGETPOS
	stx	SMTmp2
	sty	SMTmp2+1
	pla
	jsr	PrintHex
	pld
	rtl
?10:	phx
	phy
	ldx	SMAuxL
	ldy	SMAuxH
	SCNSETPOS
	pla
	jsr	PrintHex
	ldx	SMTmp2
	ldy	SMTmp2+1
	SCNSETPOS
	pla
	jsr	PrintHex
	pld
	rtl

; # fdtwrite drive [track=0 [buffer=0 [flag=0]]]  
Cmd_fdtwrite:
	bcc	?02
	jmp	CmdErr3		; no parametri
?02:	ldx	#2
	bra	fdtrk
	
; # fdtread drive [track=0 [buffer=0 [flag=0]]]  
Cmd_fdtread:
	bcc	?02
	jmp	CmdErr3		; no parametri
?02:	ldx	#0
	bra	fdtrk

; # fdtverf drive [track=0 [buffer=0 [flag=0]]]  
Cmd_fdtverf:
	bcc	?02
	jmp	CmdErr3		; no parametri
?02:	ldx	#1

fdtrk:
	lda	SMTmpL
	pha			; drive
	lda	#0
	pha			; track
	pha			; buffer
	pha			; flag
	phx			; op
	jsr	GetParm		; parametro 2 - track
	bcs	?10
	lda	SMTmpL
	sta	$04,s		; track
	jsr	GetParm		; parametro 3 - buffer
	bcs	?10
	lda	SMTmpL
	sta	$03,s		; buffer
	jsr	GetParm		; parametro 4 - flag
	bcs	?10
	lda	SMTmpL
	sta	$02,s		; flag
?10:	plx			; op
	beq	?30		; read
	dex
	beq	?20		; verf
	FDCTKWR
	bra	fdcr
?20:	FDCTKVERF
	bra	fdcr
?30:	FDCTKRD
	bra	fdcr
	
; # fdwrite drive [track=0 [head=0 [sect=1 [sectnum=1 [buffer=0 [flag=0]]]]]]  
Cmd_fdwrite:
	bcc	?02
	jmp	CmdErr3		; no parametri
?02:	jsr	GetFDCParm
	FDCWRITE
	bra	fdcr
	
; # fdverf drive [track=0 [head=0 [sect=1 [sectnum=1 [buffer=0 [flag=0]]]]]]  
Cmd_fdverf:
	bcc	?02
	jmp	CmdErr3		; no parametri
?02:	jsr	GetFDCParm
	FDCVERF
	bra	fdcr

; # fdread drive [track=0 [head=0 [sect=1 [sectnum=1 [buffer=0 [flag=0]]]]]]  
Cmd_fdread:
	bcc	?02
	jmp	CmdErr3		; no parametri
?02:	jsr	GetFDCParm
	FDCREAD
	
fdcr:
	php	
	SCNPRINT	; clear result line 
	.DB	$0D, KB_ESC, 'q', $00
	plp
	bcc	?02
	SCNPRINT
	.DB	'::error code -> ', $00
	pha
	tya
	jsr	PrintByte
	pla
	bra	?04
?02:	SCNPRINT
	.DB	'::OK, ', $00
?04:	txy
	xba
	tax
	xba
	jsr	PrintWord
	tya
	SCNPRCHAR
	.DB	' '
	jmp	PrintHex

; # fdfs [drive = 0] {buffer = 0, ID = 0, name = NULL}
Cmd_fdfs:
	bne	?02
	stz	SMTmpL
?02:	lda	SMTmpL
	pha			; drive
	lda	#$00
	pha			; buffer
	pea	#0		; ID
	pha			; name = null
	pea	#0
	FDCMKFS
	jmp	drs

; ricava parametri per funzioni fdread/fdwrite
GetFDCParm:
	plx			; return L
	pla			; return H
	inx			; scarta stack - necessario per  
	bne	?01		; chiamare GetParm al giusto livello di stack
	inc	a		; X,A -> indirizzo di ritorno
?01:	stx	SMTmp2
	sta	SMTmp2+1
	lda	SMTmpL		; drive
	pha
	lda	#0		; default params
	pha			; track = 0
	pha			; head = 0
	ldx	#1
	phx			; start sector = 1
	phx			; sect. number = 1
	pha			; # buffer = 0
	pha			; flag = 0
	jsr	GetParm		; parametro 2 - track
	bcs	?20
	lda	SMTmpL
	sta	$06,s		; track
	jsr	GetParm		; parametro 3 - head
	bcs	?20
	lda	SMTmpL
	sta	$05,s		; head
	jsr	GetParm		; parametro 4 - sector
	bcs	?20
	lda	SMTmpL
	beq	?02
	sta	$04,s		; sector
?02:	jsr	GetParm		; sector number
	bcs	?20	
	lda	SMTmpL
	beq	?03
	sta	$03,s		; sector number
?03:	jsr	GetParm
	bcs	?20
	lda	SMTmpL
	sta	$02,s		; buffer
	jsr	GetParm
	bcs	?20
	lda	SMTmpL
	sta	$01,s		; flag
?20:	jmp	(DP01ADDR+SMTmp2)	; return

	
;---------------------------------
atacmd:
	lda	<atnum
	asl	a
	tax
	jmp	(ATACT,x)
	
ATACT:
	.DW	Cmd_atard, Cmd_ataverf, Cmd_atawr, Cmd_atares
	.DW	Cmd_ataid, Cmd_atambr, Cmd_atapbr
	
Cmd_ataid:
	ldx	SMTmpL
	lda	#1
	bra	atactl

Cmd_atambr:
	ldx	SMTmpL
	lda	#2
	bra	atactl

Cmd_atapbr:
	ldx	SMTmpL
	lda	#3
	bra	atactl

Cmd_atares:
	ldx	SMTmpL
	lda	#0
atactl:
	ATACTL
	bra	ATAClean
	
; test lettura device ATA
; atard <80 (flag verifica)> + device <LBA=0> <NUMSECT=64> <BUFFER=030000>
Cmd_ataverf:
	jsr	GetATAParm
	ATAVERF
	bra	ATAClean
	
Cmd_atard:
	jsr	GetATAParm
	ATAREAD

ATAClean:
	bcs	?02
	SCNPRINT	
	.DB	$0D, '::OK - no error', $00
	rts
?02:	SCNPRINT
	.DB	$0D, '::error code -> ', $00
	tya
	jsr	PrintByte
	txa
	jmp	PrintHex

; test scrittura su device ATA
; atawrite <80 (flag verifica)> + device <LBA=0> <NUMSECT=64> <BUFFER=0>	
Cmd_atawr:
	jsr	GetATAParm
	ATAWRITE
	bra	ATAClean

CmdErr3:
	jmp	ErrCls2

; ricava parametri per funzioni ATA read/write
GetATAParm:
	plx			; return L
	pla			; return H
	inx			; scarta stack - necessario per  
	bne	?01		; chiamare GetParm al giusto livello di stack
	inc	a		; X,A -> indirizzo di ritorno
?01:	stx	SMTmp2
	sta	SMTmp2+1
	ACC16
	tsc			; stack frame
	sec
	sbc	#9		; crea parametri stack
	tcs
	inc	a
	sta	SMSizeL		; salva stack frame
	ACC08
	lda	SMTmpL		; parametro 1 - device + flag verifica
	tax
	and	#$01		; maschera device
	sta	$09,s		; device
	txa
	and	#$80		; maschera flag
	sta	$01,s		; flag
	lda	#0
	sta	$02,s		; lpBuf default=$030000
	sta	$03,s
	lda	#3
	sta	$04,s
	lda	#64		; numero settori di default (64)
	sta	$05,s
	lda	#0
	sta	$06,s		; LBA di default (0)
	sta	$07,s
	sta	$08,s
	jsr	GetParm32	; parametro 2 - LBA
	bcs	?18		; fine - OK
	lda	SMTmpL
	sta	$06,s
	lda	SMTmpH
	sta	$07,s
	lda	SMTmpK
	sta	$08,s
	jsr	GetParm		; parametro 3 - numero settori
	bcs	?18		; fine - OK
	lda	SMTmpL
	sta	$05,s
	jsr	GetParm		; parametro 4 - buffer
	bcs	?18		; fine - OK
	lda	SMTmpL
	sta	$02,s
	lda	SMTmpH
	sta	$03,s
	lda	SMTmpK
	;lda	#0
	sta	$04,s	
?18:	lda	SMSizeH		; C = stack frame
	xba
	lda	SMSizeL
	jmp	(DP01ADDR+SMTmp2)	; return

; #sptest -p<port> -b -h<handshake> -r -e -t -u 
; -p: port 0 or 1 (default: 0)
; -b: baud rate = 19,200 (default: 38,400)
; -h: handshke level = 0,1,2 (defalt: 2)
;	0=none, 1=software, 2=hardware
; -r: RS485 (default: RS232)
; -e: enable echo in rx mode (default mode: rx)
; -t: enable tx mode (-e ignored)
; -u: RS232 uplink (RS485 term.)
Cmd_sptst:
	.EXTERN lspset, lspget, lspput, lspres
	.PUBLIC Cmd_sptst

	SCN_CR
	stz	SMTmp2		; port 0
	stz	SMTmp2+3	; no echo, rx mode
	lda	#2
	sta	SMTmp2+1	; hardware handshake
	lda	#11010100B
	sta	SMTmp2+2
	lda	#$80		; flag
	pha
	ldx	cmdlin
	ACC16CLC
	txa
	adc	#INPUTBUF
	ldx	#^INPUTBUF
	phx			; command line
	pha
	ACC08
	phk			; option string
	pea	#!?100		
	pea	#0		; result
	pea	#0
?10:	jsl	_getopt		; get opttion's loop
	bcs	?26		; error
	tax			; option char
	beq	?26		; end of command line
	bmi	?24		; no option argument
	cmp	#'p'
	bne	?12
	lda	$01,s
	and	#1
	sta	SMTmp2		; port
	bra	?10
?12:	cmp	#'h'
	bne	?14
	lda	$01,s
	and	#3
	cmp	#3
	bcc	?13
	lda	#2
?13:	sta	SMTmp2+1	; handshake
	bra	?10
?14:	cmp	#'b'
	bne	?16
	lda	#$10
	trb	SMTmp2+2	; 19200
	bra	?10
?16:	cmp	#'r'
	bne	?18
	lda	#$02
	tsb	SMTmp2+2	; RS485
	bra	?10
?18:	cmp	#'u'
	bne	?20
	lda	#$01
	tsb	SMTmp2+2	; RS485 term/RS232 uplink cable
	bra	?10	
?20:	cmp	#'e'
	bne	?22
	lda	#$80
	tsb	SMTmp2+3	; rx+echo mode
	bra	?10
?22:	cmp	#'t'
	bne	?24
	lda	#$40
	tsb	SMTmp2+3	; tx mode
	bra	?10
?24:	sec
?26:	php			; clean stack
	plx			; save carry
	ACC16CLC
	tsc
	adc	#11
	tcs
	ACC08
	txa
	lsr	a		; test carry
	bcc	?28		; ok
	jmp	ErrCls2
?28:	lda	SMTmp2+1
	bne	?30
	lda	#$C0
	trb	SMTmp2+2
	bra	?34
?30:	cmp	#1
	bne	?32
	lda	#$C0
	trb	SMTmp2+2
	lda	#$80
	tsb	SMTmp2+2
	bra	?34
?32:	lda	#$C0
	tsb	SMTmp2+2
?34:	ldx	SMTmp2		; X=port
	lda	SMTmp2+2	; A=mode
	jsl	lspset
	lda	SMTmp2
	asl	a
	asl	a
	sta	SMTmp2+1
	tsc
	sta	SMTmp2+4
	xba
	sta	SMTmp2+5
	bit	SMTmp2+3	; check tx/rx mode
	bvs	?40		; tx mode
	jmp	?300
	
?40:	stz	SMTmpL
	stz	SMTmpH
?41:	ldx	SMTmp2+1
	bit	!splin,x
	bpl	?42		; on line	
	jsr	CkStop
	bne	?41
	beq	?90		; stop
?42:	lda	#$0D
	jsr	?200
?45:	jsr	CkStop		; loop TX
	beq	?90		; stop
	lda	SMTmpH
	jsr	FF_Byte2Hex
	phx
	jsr	?200		; send
	pla
	jsr	?200		; send
	lda	SMTmpL
	jsr	FF_Byte2Hex
	phx
	jsr	?200
	pla
	jsr	?200
	lda	#' '
	jsr	?200
	lda	#$40
	sta	SMTmpK
?47:	lda	SMTmpK
	jsr	?200
	inc	SMTmpK
	lda	SMTmpK
	cmp	#$7E
	bcc	?47
	lda	#$0D
	jsr	?200
	ACC16
	inc	SMTmpL
	ACC08
	bra	?45
	
?90:	lda	#$FF		; stop: CTRL BREAK
?91:	SCN_CR
	jsr	PrintByte
	SCN_CR
?99:	ldx	SMTmp2
	jsl	lspres
	lda	SMTmp2+5
	xba
	lda	SMTmp2+4
	tcs
	rts
	
?200:	ldx	SMTmp2
?210:	jsl	lspput
	bcc	?215
	iny
	bne	?210
	lda	#$80		; remote off-line
	bra	?91
	
?215:	bit	SMTmp2+3	
	bpl	?250
	jsl	lspget
	bcs	?220
	TXTCHAROUT
	rts
?220:	tay
	bne	?91
?250:	rts

	
?100:	.DB	'p%b h%r e t u ', 0

?300:	ldx	SMTmp2+1
	bit	!splin,x
	bpl	?320		; on line	
	jsr	CkStop
	bne	?300
	beq	?340
?320:	jsr	CkStop
	beq	?340
	ldx	SMTmp2
	jsl	lspget
	bcs	?330
	cmp	#$0A
	beq	?324
	cmp	#$0D
	beq	?324
	cmp	#$09
	beq	?324
	cmp	#$20
	bcc	?320	
?324:	TXTCHAROUT
	bit	SMTmp2+3	
	bpl	?320	
?325a:
	ldx	SMTmp2
?325:	jsl	lspput
	bcc	?320
	iny
	bne	?325
	lda	#$80
	bra	?350
?330:	tay
	beq	?320
	bra	?350
?340:	lda	#$FF
?350:	SCN_CR
	jsr	PrintByte
	ldx	SMTmp2
	jsl	lspres
	lda	SMTmp2+5
	xba
	lda	SMTmp2+4
	tcs
	rts

ATACPYSTR1:
	.DB	'read  %02bX sect. from %08X to %08X (Total %08X, dev. #%01bX)', $00

ATACPYSTR2:
	.DB	'write %02bX sect. from %08X to %08X (Total %08X, dev. #%01bX)', $00
	