;----------------------------------------------------------
; MONITOR.ASM
; PROGETTO: B1601
;
; Monitor di sistema
;----------------------------------------------------------

_RTC_INC_	.SET	1
_SCN_INC_	.SET	1
_KBD_INC_	.SET	1

	.INCLUDE inc\global.inc
	.INCLUDE inc\dirp00.inc
	.INCLUDE inc\dirp01.inc

.LIST on

	.EXTERN qedtent

	.MONSEG
	.LONGA	off
	.LONGI	off

; $FF0000 - standard entry monitor
	jmp	_SysMon

; $FF0003 - entry monitor after reset
	jmp	_mon0
	
; $FF0006 - entry monitor after brk
	jmp	_SysBreak
	
; $FF0009 - entry monitor after sys request
	lda	#$FF
	jmp	_SysBreak2
	
	.CODEFF
	
SMTMP2		.EQU	(DP01ADDR + SMTmp2)
SMADDRL		.EQU	(DP01ADDR + SMAddrL)

INPUTBUF	.EQU	MONBUF
INPBUFLEN	.EQU	$A2

	.LONGA	off
	.LONGI	off
	
	.GLOBAL _SysMon, _SysBreak
	.GLOBAL ErrCls2, GetParm, PrintByte, PrintHex, GetParm32, CkStop
	.GLOBAL PrintWord, PrintAddr, PrintHex, TmpToAddr, GetParm, DecTmpPtrA
	.GLOBAL SubTmpAddr, PrintHex1, GetCurCh, FF_Byte2Hex

	.EXTERN matcmd, atacmd, Cmd_d, Cmd_a
	
	.EXTERN Cmd_fddisk, Cmd_fdgetfmt, Cmd_fdres, Cmd_fdinit, Cmd_fdformat
	.EXTERN Cmd_fdverfmt, Cmd_fdread, Cmd_fdwrite, Cmd_fdverf, Cmd_fdnew
	.EXTERN Cmd_fdtread, Cmd_fdtwrite, Cmd_fdtverf, Cmd_fdfs, Cmd_fdlsys
	.EXTERN Cmd_mkhash, Cmd_sptst

	
; BRK entry
; descrizione stack:
;
;	KR		-> SP + 13
;	PCH		-> SP + 12
;	PCL		-> SP + 11
;	SR		-> SP + 10
;	A		-> SP + 8
;	X		-> SP + 6
;	Y		-> SP + 4
;	DPR		-> SP + 2
;	DBR		-> SP + 1

_SysBreak:
	lda	#0
_SysBreak2:
	tay			; save context
	CPU16
	lda	#DP01ADDR	; imposta nuova DP
	tcd
	CPU08
	pla			; DBR
	sta	SMbr
	CPU16
	pla			; DPR
	sta	SMdp
	pla
	sta	SMyr
	pla
	sta	SMxr
	pla
	sta	SMac
	CPU08
	pla
	sta	SMsr
	pla
	sta	SMpc		; PCL
	pla
	sta	SMpc+1		; PCH
	pla
	sta	SMkr		; PBR (KR)
	CPU16
	tsx
	stx	SMsp
	CPU08
	tya
	bne	?02
	;SCNINIT
	SCNPRINT
	.DB	KB_CR, 'Break', 0
	bra	?04
?02:	SCNPRINT
	.DB	KB_CR, 'System Request', 0
?04:	stz	SMctx
	cli
	bra	_SysMon2	
	
; entry monitor con inizializzazione schermo
_SysMonClr:
	SCNINIT

_mon0:
	CPU08
	lda	#0
	
; entry principale per monitor -- called from user program/reset
_SysMon:
	tay			; save context
	CPU16
	lda	#DP01ADDR	; imposta nuova DP
	tcd
	sta	SMdp
	stz	SMac
	stz	SMxr
	stz	SMyr
	tsx
	stx	SMsp
	lda	#_SysMon
	sta	SMpc
	CPU08	
	lda	#0
	pha
	plb
	sta	SMbr
	phk
	pla
	sta	SMkr
	php
	pla
	sta	SMsr
	sta	CREMEOFF
	sta	CRXMEOFF
	sta	CRXFEOFF
	tya
	sta	SMctx		; save context
	beq	?02
	ACC16
	pla
	inc	a
	sta	SMrsm		; save resume address
	ACC08
	pla
	sta	SMrsm+2
	
?02:	SCNPRINT
		
	.DB	KB_CR, 'Monitor v1.2', 0
	
_SysMon2:
	cld
	stz	SMdumb
	jsr	PrintReg

GetCmd:	
	SCN_CR
	stz	SMesc
	ldx	#0
	stx	SMbndx
	dex
?01:	inx			; ciclo input
	cpx	#INPBUFLEN
	bcs	SMError
	KBCHARIN	; input tastiera
	sta	INPUTBUF,x
	cmp	#KB_CR
	bne	?01
	lda	#0
	sta	INPUTBUF,x
?02:	jsr	GetCurCh	; get char da buffer
	beq	GetCmd		; fine linea
	cmp	#' '
	beq	?02		; skip spazi
	cmp	#'#'
	bne	?02w
	dec	SMesc
?02w:	jsr	pfxcmd		; check prefix command
	ldx	SMbndx		; salva indice corrente
	dex
	stx	SMAuxH
	ldy	#0		; indice comando
	tyx			; indice tabella comandi
	INDEX16
?02a:	lda	SMAuxH		; ripristina indice buffer
	sta	SMbndx
?02b:	phx
	INDEX08
	jsr	GetCurCh	; get char
	INDEX16
	plx
	;beq	SMError		; ERRORE	
	eor	CMDTBL,x	; cerca comando interno
	beq	?10		; test carattere ok
	cmp	#$80		; comando trovato - fine
	beq	?11
	iny			; next command
?09:	inx
	lda	CMDTBL-1,x	; cerca fine stringa
	bpl	?09
	lda	CMDTBL,x	; test fine tabella comandi
	bne	?02a		; continua scan
	INDEX08
	beq	SMError		; comando interno non trovato	
?10:	inx
	bne	?02b		; continua scan stringa attuale
?11:	INDEX08	
	jsr	ExecCmd
	bra	GetCmd
	
ErrCls4:
	pla
	pla
ErrCls2:
	pla
	pla
		
SMError:
	SCNPRINT
	
	.DB	SCN_CSRRIGHT, '?', 0
	
	bra	GetCmd

; set program counter
_setpc:
	bcs	?02
	lda	SMTmpK
	sta	SMkr
	lda	SMTmpH
	sta	SMpc+1
	lda	SMTmpL
	sta	SMpc
?02:	lda	SMkr
	cmp	#$08			; test bank
	bcc	ErrCls2
	rts

GetParm32:
	lda	#$80
	sta	SMFlag32
	bra	GetParm2
	
GetParm0:
	dec	SMbndx
			
GetParm:
	stz	SMFlag32

GetParm2:
	lda	SMbndx
	sta	cmdlin		; save start of command line
	stz	SMTmpL
	stz	SMTmpH
	stz	SMTmpK
	stz	SMTmpKK
	stz	SMnprm
?01:	jsr	GetCurCh
	beq	?11
	cmp	#' '
	beq	?01
?03:	cmp	#' '
	beq	?10
	cmp	#','
	beq	?10
	cmp	#'0'
	bcc	ErrCls4
	cmp	#'a'
	bcc	?05
	cmp	#('z' + 1)
	bcs	?05
	sec
	sbc	#$20
?05:	cmp	#'G'
	bcs	ErrCls4
	cmp	#':'
	bcc	?07
	cmp	#'A'
	bcc	ErrCls4
	sbc	#$08
?07:	sbc	#$2F
	asl	a
	asl	a
	asl	a
	asl	a
	phx
	ldx	#4
?08:	asl	a
	rol	SMTmpL
	rol	SMTmpH
	rol	SMTmpK
	bit	SMFlag32	; test valore 32 bit
	bpl	?09
	rol	SMTmpKK
?09:	dex
	bne	?08
	plx
	inc	SMnprm
	jsr	GetCurCh
	bne	?03
?10:	clc
	lda	SMnprm
?11:	rts
			
ExecCmd:
	bit	SMesc
	bpl	?01
	ldx	SMbndx
	stx	cmdlin		; save start of command line
	lda	>INPUTBUF,x
	beq	?02
	cmp	#' '
	beq	?02
	jmp	ErrCls2
?01:	jsr	GetParm
?02:	php
	pha
	tya
	asl	a
	tax
	pla
	plp
	jmp	(CMDVCTRS,x)

;---------------------------------------------------------------------------
; prefix commands
;---------------------------------------------------------------------------

; handle prefix command's
; A = byte from input buffer
pfxcmd:
	ldx	#PFXLEN
?03:	cmp	>PFXTBL,x
	beq	?04
	dex
	bpl	?03
	rts			; return to standard command
?04:	pla			; pop stack return address 
	pla
	txa
	asl	a
	tax
	jsr	(PFXVCTRS,x)	; execute prefix command
	jmp	GetCmd		; command loop

; prefix '@': cbm disk command
pfx_at:
	stz	<atflag
	lda	#>INPUTBUF
	sta	<atstr+1	; hi ptr command string
	lda	#^INPUTBUF
	sta	<atipb		; bank of cmnd string
?01:	jsr	GetCurCh2	; get next byte
	beq	?04		; just '@': like '@e'
	cmp	#' '		; skip blanks
	beq	?01
	ldx	#PATLEN
?02:	cmp	>PATTBL,x
	beq	?06
	dex
	bpl	?02
	jmp	?15
?04:	ldx	#0		; '@e' command
	lda	#'E'
?06:	sta	<atcmd
	stx	<atnum
	txa
	beq	?08		; @e
	cmp	#'Z'		; @z close all
	bne	?9a		; get string for command
?08:	jsr	GetCurCh	; no params for '@e' & '@z' command
	bne	?09
	jmp	?22		; ok
?09:	cmp	#' '
	beq	?08
	bne	?15		; error
?9a:	lda	<atcmd
	cmp	#'G'		; get
	beq	?9c
	cmp	#'P'		; put
	beq	?9c
	cmp	#'X'		; close want one param
	bne	?10
	jmp	?40		; X want one param
?9c:	jmp	?30		; G&P want 2/3 param
?10:	jsr	GetCurCh	; parse command string
	beq	?15		; error
	cmp	#' '
	beq	?10
	cmp	#'"'		; will start with a quotes mark
	bne	?15		; error
	ldx	SMbndx		; save pointer to start string
	stx	<atstr
?12:	lda	INPUTBUF,x	; search final quote mark
	beq	?15		; error
	inx
	cmp	#'"'
	bne	?12
	stx	SMbndx		; store index to next char
	dex
	lda	#0		; terminate command string
	sta	INPUTBUF,x
?14:	ldx	<atnum
	cpx	#PATLD		; O,L,S,V,R,W need more params
	bcc	?22
	jsr	GetCurCh
	beq	?15		; at least need bank/chnl
	jsr	GetParm
	bcs	?15
	lda	SMTmpL
	sta	<atbnk		; bank for L,S,V,R,W - chn for O
	ldy	<atcmd
	cpy	#'O'
	bne	?14a
	sta	<atsa
?14a:	jsr	GetParm
	bcc	?16
	lda	<atcmd
	cmp	#'W'
	beq	?15
	cmp	#'S'
	bne	?22		; L,V,R without start address or O
?15:	jmp	ErrCls2		; S,W need start address
?16:	ACC16
	lda	SMTmpL
	sta	<atstart
	ACC08
	lda	#$80
	sta	<atflag		; flag start address
	jsr	GetParm		; end address
	lda	<atcmd
	bcc	?18
	cmp	#'S'
	beq	?15		; S,W need end address
	cmp	#'W'
	beq	?15
	bra	?22
?18:	cmp	#'W'
	beq	?20
	cmp	#'S'
	bne	?15		; L,V,R want just start address
?20:	ACC16
	lda	SMTmpL
	inc	a
	sta	<atend
	cmp	<atstart
	ACC08
	bcc	?15		; end+1 will be > start
	beq	?15
?22:	jmp	matcmd
?30:	jsr	GetParm		; G&P
	bcs	?15
	lda	SMTmpL
	sta	<atsa
	jsr	GetParm
	bcs	?15
	lda	SMTmpL
	sta	<atbnk
	stz	<atstart
	stz	<atstart+1
	jsr	GetParm
	bcc	?22
	ACC16
	lda	SMTmpL
	sta	<atstart
	ACC08
	bra	?22
?40:	jsr	GetParm		; X (close)
	bcs	?15
	lda	SMTmpL
	sta	<atsa
	bra	?22

; prefix '|': ata test
pfx_bar:
?01:	jsr	GetCurCh	; get next byte
	beq	?04		; error
	cmp	#' '		; skip blanks
	beq	?01
	ldx	#PBARLEN
?02:	cmp	>PBARTBL,x
	beq	?06
	dex
	bpl	?02
?04:	jmp	ErrCls2
?06:	stx	<atnum
	jsr	GetParm		; get first param
	bcs	?04
	jmp	atacmd

; prefixes table
PFXTBL:
	.DB	'@|'
	
PFXLEN		.EQU	($ - PFXTBL - 1)

; prefix '@' commands table 
PATTBL:
	.DB	'EZXGPDC'
PATLD		.EQU	($ - PATTBL)
	.DB	'LSVRWO'

PATLEN		.EQU	($ - PATTBL - 1)

; prefix '|' commands table 
PBARTBL:
	.DB	'rvwcimp'

PBARLEN		.EQU	($ - PBARTBL - 1)

; prefix commands vectors
PFXVCTRS:
	.DW	pfx_at, pfx_bar

	
;---------------------------------------------------------------------------
; keywords table
;---------------------------------------------------------------------------

CMDTBL:
	.DC	'dumbon'
	.DC	'dumboff'
	
	.DC	'cbmfs'
	.DC	'sbrkp'
	.DC	'sbrkm'

	.DC	'edit'
	.DC	'mkhash'
	.DC	'quit'
	.DC	'cbmpas'	; CBM quick pascal
	.DC	'xmtest'
	.DC	'beep'
	
	; FDC diagnostic -- implementation in mond.asm
	.DC	'fddisk'	; invoca FDCTST
	.DC	'fdres'		; reset FDC controller UM8388
	.DC	'fdread'	; read disk sector's
	.DC	'fdinit'	; init drive
	.DC	'fdformat'	; format whole disk (low level)
	.DC	'fdwrite'	; write disk sector's
	.DC	'fdgetfmt'	; get current disk format
	.DC	'fdverfmt'	; verify disk format
	.DC	'fdverf'	; verify read
	.DC	'fdtread'	; read whole track
	.DC	'fdtwrite'	; write whole track
	.DC	'fdtverf'	; verify whole track
	.DC	'fdnew'		; new ram disk's
	.DC	'fdfs'		; new file system
	.DC	'fdlsys'	; load rom.bin

	.DC	'flash'		; update flash from file (fdlsys)
	.DC	'mflash'	; update flash from memory
	
	.DC	'cop'
	.DC	'true'
	.DC	'vdc'		; cambia dot clock VDC
	
	; assembler/disassembler mode
	.DC	'p816'		; set 65C816 mode (default mode)
	.DC	'pc02'		; set 65C02 mode
	.DC	'p02'		; set 6502 mode
	.DC	'am8'
	.DC	'am16'
	.DC	'xy8'
	.DC	'xy16'

	; memory bank clear/move
	.DC	'kz'		; clear whole memory bank
	.DC	'kf'		; fill whole memory bank	
	.DC	'kF'		; fill whole memory bank with pattern	
	.DC	'kmv'		; move whole memory bank	
	
	.DC	'crs'		; show CR
	.DC	'cre'		; enable EM
	.DC	'crx'		; enable XM
	.DC	'crf'		; enable FM
	.DC	'mx'		; display XM
	.DC	'xs'		; show XM in sectors	
	.DC	'x>'		; set extended mem
	.DC	'xmp'		; set extended mem page
	.DC	'rd'		; read single mem.
	.DC	'wr'		; write single mem
	.DC	'kmt'		; full memory bank test
	.DC	'xmt'		; eXtended memory test
	
	.DC	'te'		; show RTC internal extended ram
	.DC	'e>'		; set RTC internal extended ram
	.DC	'tu'
	.DC	'ts'
	.DC	'u>'
	.DC	'tc'
	.DC	'c>'
	.DC	'gt'		; get rtc time
	.DC	'gd'		; get rtc date
	.DC	'st'		; set rtc time
	.DC	'sd'		; set rtc date
	
	.DC	'#test'
	.DC	'#strcpy'
	.DC	'#fdisk'
	.DC	'#sptest'

	.DC	'm'		; display mem
	.DC	'>'		; set mem
	.DC	';'		; set registri
	.DC	'r'		; show registri
	.DC	'z'		; fill zero
	.DC	'f'		; fill byte
	.DC	'F'		; fill con byte auto-inc
	.DC	'd'		; disassemble line (masmx.asm)
	.DC	'a'		; assemble line (masmx.asm)
	.DC	'.'		; assemble line (masmx.asm)
	.DC	'j'		; jmp to soubroutine (terminate with rtl)
	.DC	'g'		; jmp to soubroutine (terminate with brk)
	.DB	0
	
CMDVCTRS:
	.DW	Cmd_dumbon, Cmd_dumboff
	
	.DW	testcbm
	.DW	Cmd_sbrkp
	.DW	Cmd_sbrkm
	
	.DW	Cmd_edit
	.DW	Cmd_mkhash
	.DW	Cmd_quit, Cmd_cbmpas, Cmd_xmtest
	.DW	Cmd_beep
	
	; FDC diagnostic -- implementation in mond.asm
	.DW	Cmd_fddisk, Cmd_fdres, Cmd_fdread, Cmd_fdinit
	.DW	Cmd_fdformat, Cmd_fdwrite, Cmd_fdgetfmt, Cmd_fdverfmt
	.DW	Cmd_fdverf, Cmd_fdtread, Cmd_fdtwrite, Cmd_fdtverf 
	.DW	Cmd_fdnew, Cmd_fdfs, Cmd_fdlsys
	
	.DW	Cmd_flash, Cmd_mflash
	
	.DW	Cmd_cop, Cmd_true, Cmd_vdc

	; assembler/disassembler mode
	.DW	Cmd_p816, Cmd_pc02, Cmd_p02, Cmd_am8, Cmd_am16, Cmd_xy8
	.DW	Cmd_xy16
	
	; memory bank clear/move
	.DW	Cmd_kz, Cmd_kf, Cmd_kF, Cmd_km
	
	.DW	Cmd_crs, Cmd_cre, Cmd_crx, Cmd_crf
	.DW	Cmd_mx, Cmd_xs, Cmd_SetXMem, Cmd_SetXMPage
	.DW	Cmd_rd, Cmd_wr, Cmd_kmt, Cmd_xmt
	
	.DW	Cmd_te, Cmd_stxm, Cmd_tu, Cmd_ts, Cmd_stum, Cmd_tc, Cmd_stcm
	.DW	Cmd_gt, Cmd_gd, Cmd_st, Cmd_sd

	.DW	Cmd_test, Cmd_strcpy, Cmd_fdisk, Cmd_sptst

	.DW	Cmd_m, Cmd_SetMem, Cmd_SetReg, PrintReg
	.DW	Cmd_z, Cmd_f, Cmd_F, Cmd_d, Cmd_a, Cmd_a
	.DW	Cmd_j, Cmd_g

; ---- TEST CBM
getstr:	
	SCN_CR
	ldx	#0
	dex
?01:	inx			; ciclo input
	cpx	#INPBUFLEN
	bcs	?02
	KBCHARIN	; input tastiera
	sta	>INPUTBUF,x
	cmp	#KB_CR
	bne	?01
?02:	lda	#KB_CR
	sta	>INPUTBUF,x
	rts

testcbm:
	bne	?02
	lda	#15
	sta	SMTmpL
?02:	lda	SMTmpL
	cmp	#$FF
	bne	?02a
	jsr	PrintCR
	bra	cbmer
?02a:	and	#$0F
	cmp	#$0F
	beq	?03
	ora	#$80
?03:	sta	SMTmpL

	SCNPRINT
	.DB	$0D, 'Type command string:', 0
	jsr	getstr
	SCN_CR
	lda	#^INPUTBUF
	pha
	pea	#!INPUTBUF
	lda	SMTmpL
	pha
	CBMFSCMD

;;	bcs	?04
;;	ldy	#0
;;?04:	tya
;;	jmp	PrintByte

cbmer:
	ACC16
	tsc
	sec
	sbc	#128
	tcs
	inc	a
	ldx	#0
	phx
	pha
	pea	#128
	ACC08
	lda	#15
	pha
	CBMFSRD
	ACC16
	tsc
	inc	a
	ACC08
	ldx	#0
	SCNSTROUT
	ACC16CLC
	tsc
	adc	#128
	tcs
	ACC08
	jmp	PrintCR
	
	
; --------
Cmd_sbrkp:
	bne	?01
	stz	SMTmpL
	stz	SMTmpH
	stz	SMdwTmp3
?01:	clc
	bra	_sbrk

Cmd_sbrkm:
	bne	?01
	stz	SMTmpL
	stz	SMTmpH
?01:	sec
	lda	#$80
	sta	SMdwTmp3
	
_sbrk:
	php
	jsr	PrintCR
	plp
	lda	SMTmpH
	xba
	lda	SMTmpL
	SETBRK
	bcs	?10
	xba
	tax			; HI
	xba			; LOW
	jsr	PrintWord
	lda	SMTmpL
	ora	SMTmpH
	beq	?06
	lda	#0
	xba
	lda	#0
	SETBRK
	xba
	tax			; HI
	xba			; LOW
	jsr	PrintWord	
?06:	jmp	PrintCR
?10:	SCNPRINT
	.DB	$0D, ':: Error -> ', 0
	pha
	tya
	jsr	PrintByte
	jsr	PrintBlank
	pla
	xba
	tax
	xba
	jsr	PrintWord	
	jmp	PrintCR	

Cmd_edit:
	;phb
	;phd
	;pea	#$4000
	;lda	#$40
	;pha
	jsl	qedtent
	;pla
	;pla
	;pla
	;pld
	;plb
	rts
	
Cmd_beep:
	bcc	?01
	lda	#10110000B	; CTC 2 in modo 0 - 2 bytes
	sta	CTC0+CTCCTRL
	rts
?01:	lda	#10110000B	; CTC 2 in modo 0 - 2 bytes
	sta	CTC0+CTCCTRL
	lda	SMTmpL
	ora	SMTmpH
	beq	?02
	lda	SMTmpL
	sta	CTC0+CTCCNT2
	lda	SMTmpH
	sta	CTC0+CTCCNT2
	lda	#$08
	trb	PIA0+PIACRB
	trb	PIA0+PIACRA
?02:	rts

Cmd_p816:
	lda	#0
	bra	_pset
	
Cmd_pc02:
	lda	#$C0
	bra	_pset
	
Cmd_p02:
	lda	#$80

_pset:
	sta	asmcpu
	SCNPRINT
	.DB	$0D, ':: Current assembler mode -> ', 0
	lda	asmcpu
	bne	?02
	SCNPRINT
	.DB	'65C816', 0
	rts
?02:	bit	asmcpu
	bvc	?04
	SCNPRINT
	.DB	'65C02', 0
	rts
?04:
	SCNPRINT
	.DB	'6502', 0
	rts

Cmd_am8:
	lda	#$80
	trb	asmlong
	bra	_amx
	
Cmd_am16:
	lda	#$80
	tsb	asmlong
_amx:
	SCNPRINT
	.DB	$0D, ':: Accumulator/Memory 65C816 mode -> ', 0
	bit	asmlong
	bpl	?02
	SCNPRINT
	.DB	'16 bit', 0
	rts
?02:	SCNPRINT
	.DB	'8 bit', 0
	rts

Cmd_xy8:
	lda	#$40
	trb	asmlong
	bra	_xy

Cmd_j:
	pla
	pla
	jsr	_setpc
	jsl	_ldregs
	CPU16
	sta	SMac
	stx	SMxr
	sty	SMyr
	CPU08
	php
	pla
	sta	SMsr
	jmp	_SysMon2
	
Cmd_g:
	pla
	pla
	jsr	_setpc
	
_ldregs:
	lda	SMkr
	pha
	ACC16
	lda	SMpc
	pha
	ldx	SMsr
	phx
	CPU16
	lda	SMac
	ldx	SMxr
	ldy	SMyr
	CPU08
	rti
	
Cmd_xy16:
	lda	#$40
	tsb	asmlong
_xy:
	SCNPRINT
	.DB	$0D, ':: X&Y registers 65C816 mode -> ', 0
	bit	asmlong
	bvc	?02
	SCNPRINT
	.DB	'16 bit', 0
	rts
?02:	SCNPRINT
	.DB	'8 bit', 0
	rts

Cmd_xmtest:
	bne	?01
	stz	SMTmpL
	stz	SMTmpH
?01:	ACC16CLC		; A/M 16 bit + CLC
	lda	SMTmpL		; LBA
?02:	ror	a		; divide by 16 to get xmem bank
	ror	a
	ror	a
	ror	a
	ACC08
	;sta	SMTmpK		; ram disk bank
	xba			; B = bank, A = modulus
	ror	a		; shift in last carry
	lsr	a		; calc the modulo
	lsr	a
	lsr	a		; MSB of xmem
	clc
	adc	#$20		; add the physical start of xmem
	pha
	xba			; return in A the ram disk bank
	pha
	TXT_CR
	pla
	jsr	PrintByte
	plx
	lda	#0
	jsr	PrintWord
	rts

Cmd_quit:
	lda	SMctx
	bne	?02
	jmp	CmdErr3
?02:	SCN_CR	
	jml	[DP01ADDR+SMrsm]
	
Cmd_cbmpas:
	lda	SMctx
	beq	?02
	jmp	CmdErr3
?02:	ldy	#0
	jsl	CBMCOLD
	stz	SMctx
	jmp	PrintReg
	
Cmd_cop:
?00:	KBGETIN
	cmp	#$00
	beq	?00
	xba
	tax
	xba
	SCN_CR
	jsr	PrintWord
	SCN_CR
	lda	DP01ADDR+KbdFlag
	jsr	PrintByte
	lda	DP01ADDR+KbdToggle
	jmp	PrintByte
	
	bne	?01
	jmp	CmdErr3
?01:	lda	SMTmpK
	;ora	SMTmpH
	beq	?02
	jmp	CmdErr3
?02:	;ldx	SMTmpL
	;pea	$0000
	;pea	$0001
	;pea	$0002
	;cop	$13
	jmp	?13
	
	lda	#18
	sta	SMdwTmp3
	stz	SMdwTmp3+1
	asl	a
	sta	SMdwTmp2
	stz	SMdwTmp2+1
	lda	SMTmpH
	xba
	lda	SMTmpL
	ldx	#16
	CPU16
	stz	SMdwTmp1	; azzera rem
?04:	rol	a
	rol	SMdwTmp1
	tay
	sec
	lda	SMdwTmp1
	sbc	SMdwTmp2
	bcc	?06
	sta	SMdwTmp1
?06:	tya
	dex
	bne	?04
	rol	a
	CPU08
	sta	SMXPos2
	ldx	#0
	sec
	lda	SMdwTmp1
	sbc	SMdwTmp3
	bcs	?08
	adc	SMdwTmp3
	bra	?09
?08:	inx
?09:	stx	SMYPos2
	inc	a
	sta	SMXPos3
	
	lda	SMXPos2
	asl	a
	clc
	adc	SMYPos2
	sta	SMTmpK
	lda	#0
	ldx	#9
	clc
?10:	ror	a
	ror	SMTmpK
	bcc	?12
	clc
	adc	SMdwTmp3
?12:	dex
	bne	?10
	ldx	SMXPos3
	stx	SMdwTmp1
	stz	SMdwTmp1+1
	clc
	xba
	lda	SMTmpK
	ACC16
	adc	SMdwTmp1
	dec	a
	sta	SMdwTmp1
	ACC08
	jsr	PrintCR
	lda	SMTmpH
	jsr	PrintHex
	lda	SMTmpL
	jsr	PrintHex
	jsr	PrintCR
	lda	SMXPos2
	jsr	PrintByte
	lda	SMYPos2
	jsr	PrintByte
	lda	SMXPos3
	jsr	PrintByte
	jsr	PrintCR
	lda	SMdwTmp1+1
	jsr	PrintHex
	lda	SMdwTmp1
	jsr	PrintHex
	rts
	
?13:
	FDCGETFMT
	bcc	?16
	SCNPRINT
	.DB	$0D, '::error code -> ', $00
	tya
	jsr	PrintByte
	txa
	jmp	PrintHex

?16:	tya
	SCN_CR
	jmp	PrintHex
	
	SCN_CR
	ACC16
	lda	#passtr1
	ACC08
	ldx	#^passtr1
	SCNPASSTR
	SCN_CR
	CPU16
	lda	#bufstr1
	ldx	#^bufstr1
	ldy	#blen
	SCNBUFOUT
	CPU08
?100:	rts
	
	SCNPRCHAR
	.DB	'V'
	SCNPRCHAR
	.DB	$0D	
	lda	SMTmpL
	cop	$FF
	SCNPRCHAR
	.DB	$0D	
	rts

passtr1:
	.db	plen
	.db	'Pascal String Test'
plen	.EQU	($ - passtr1 - 1)

bufstr1:
	.db	'Buffer Out Test'
blen	.EQU	($ - bufstr1)
	
Cmd_true:
	bcs	?10
	lda	SMTmpK
	ora	SMTmpH
	beq	?12
?10:	jmp	CmdErr3
?12:	lda	SMTmpL
	and	#$7F
	cmp	#$06
	bcs	?10
	sta	$0566
	lda	SMTmpL
	and	#$80
	sta	SMTmp2
?14:	jsr	GetCurCh
	ldx	SMbndx
	cmp	#$00
	beq	?16
	cmp	#' '
	;beq	?14
	dex
?16:	CPU16
	clc
	txa
	adc	#INPUTBUF
	INDEX08
	ldx	#^INPUTBUF	
	phx
	pha
	ldx	#$40
	lda	#$0380
	sta	SMTmpL
	stx	SMTmpK
	phx
	;pha
	pei	(SMTmpL)
	ldy	SMTmp2
	phy
	CPU08
	TRUENAM
	;sta	SMTmpL
	;xba
	;sta	SMTmpH
	;stx	SMTmpK
	bcc	?1000
	tya
	SCNPRINT
	.DB	$0D, '::error code -> ', $00
	jsr	PrintByte
?1000:	TXT_CR
	lda	SMTmpH
	xba
	lda	SMTmpL
	ldx	SMTmpK
	SCNSTROUT
	;jsr	PrintCR
	rts

Cmd_dumbon:
	.EXTERN lspset
	lda	SMTmpL
	and	#1
	tax
	lda	#11010100B
	jsl	lspset
	lda	SMTmpL
	and	#1
	inx
	stx	.ABS.DflTxtOut
	ldx	#$80
	stx	SMdumb
	rts

Cmd_dumboff:
	.EXTERN lspres
	ldx	.ABS.DflTxtOut
	dex
	jsl	lspres
	ldx	#TXTD_SCN
	stx	.ABS.DflTxtOut
	stz	SMdumb
	rts

;----------------------------------------------------------
; comando vdc 0|1 - 0 -> 16MHz, 1 -> 20MHz 

	.EXTERN VDCX20, VDCREG16
	
Cmd_vdc:
	bne	?01
	jmp	CmdErr3
?01:	lda	SMTmpK
	ora	SMTmpH
	beq	?02
	jmp	CmdErr3
?02:	ldx	SMTmpL
	cpx	#$02
	bcc	?03
	jmp	CmdErr3
?03:	lda	VIA1+VIAPRANH		; bit 1 -> dot clock
	and	#$02			; maschera bit 1
	beq	?04			; dot clock = 16MHz
	cpx	#$01
	beq	?20			; gia' impostato su 20MHz
	trb	VIA1+VIAPRANH		; DOTCLOCK 16MHZ - PAL RGB 
	ldx	#0			; indice per setup 16MHZ
	beq	?08
?04:	txa
	beq	?20			; gia' impostato su 16MHz
	lda	#$02
	trb	VIA1+VIAPRANH		; DOTCLOCK 20MHZ - VGA		
	ldx	#0			; indice per setup 20MHZ
?08:	lda	#$01			; video VDC OFF
	tsb	VIA1+VIAPRANH
?10:	LDA	>VDCREG16,X
	BMI	?12
	tay
	INX
	LDA	>VDCREG16,X
	INX
	STY	VDCAddr
	STA	VDCData
	BRA	?10
?12:	lda	#$01			; video VDC ON
	trb	VIA1+VIAPRANH
?20:	rts

	
;----------------------------------------------------------
; diagnostica floppy disk

	
; fdtest [0|1] - controlla presenza/cambio disco nel drive
Cmd_fdtest:
	beq	CmdErr3
	lda	SMTmpK
	ora	SMTmpH
	bne	CmdErr3
	ldx	SMTmpL
	cpx	#$02
	bcs	CmdErr3
	FDCTST
drs:	php
	SCNPRINT
	.DB	$0D, '::error code -> ', $00
	lda	!fdcerr
	jsr	PrintHex
	SCNPRINT
	.DB	'  -  CF -> ', $00
	plp
	lda	#'0'
	bcc	?03
	lda	#'1'
?03:	SCNCHAROUT
	rts

CmdErr3:	
	jmp	ErrCls2


; fdread drive+flag fmt buffer track [head sect sectnum vervbuf]  
;Cmd_fdread:
	bcs	CmdErr3		; no parametri
	jsr	GetFDCParm
	bcs	FdcClean
	FDCREAD
	jsr	drs
	clc
FdcClean:
	php
	plx
	ACC16
	tsc
	clc
	adc	#FDPBSIZE
	tcs
	ACC08
	phx
	plp
	bcs	CmdErr3
	rts

;Cmd_fdwrite:
	bcs	CmdErr3		; no parametri
	jsr	GetFDCParm
	bcs	FdcClean
	FDCWRITE
	jsr	drs
	clc
	bcc	FdcClean
	
	
;----------------------------------------------------------
; comando m

Cmd_xmt:
	beq	?00c		; no params - full test
	lda	SMTmpK
	ora	SMTmpH
	bne	?00a		; max . $1F
	lda	SMTmpL		; banco X mem in test
	cmp	#$20
	bcc	?00b		; OK
?00a:	jmp	ErrCls2		; errore - banco > $1F
?00b:	lda	#$01		; un banco (64k)
	bne	?00d
?00c:	lda	#$20		; numero banchi full test (2Mb)
	stz	SMTmpL		; banco start = $00 per full test
?00d:	sta	SMTmpH		; numero banchi da 64k
	stz	!CtrlBrk	; clear CTRL BREAK flag
	ldx	CRXME		; salva impostazione X mem
	phx
	lda	PIA0+PIAPRA	; salva banco X mem
	pha	
	sta	CRXMEON		; abilita X mem
	lda	SMTmpL		; calcola pagina X mem
	asl	a		; moltiplica x 8
	asl	a
	asl	a
	sta	PIA0+PIAPRA	; pagina fisica di start
	SCN_CR
	lda	SMTmpH
	cmp	#$01
	beq	?00e		; testa un banco
	SCNPRINT
	.DB	'::Full eXtended memory test: $', 0
	bra	?00f
?00e:	SCNPRINT
	.DB	'::eXtended memory bank test: $', 0
?00f:	SCNGETPOS
	stx	SMAuxL
	sty	SMAuxH
?01:	INDEX08	
	ldx	SMAuxL		; pos. banco
	ldy	SMAuxH
	SCNSETPOS
	lda	SMTmpL		; print banco
	jsr	PrintHex
	SCNGETPOS	; pos. address
	stx	SMXPos
	sty	SMYPos
	lda	#$08		; 8 cicli per banco
	sta	SMTmpK
	INDEX16
?02:	ldy	#$0000
	jsr	CkStop
	beq	?10	
?03:	lda	$012000,y	; finestra $2000 - $3FFF
	xba
	lda	#$55
	sta	$012000,y
	cmp	$012000,y
	bne	?05
	lda	#$AA
	sta	$012000,y
	cmp	$012000,y
?05:	php
	xba
	sta	$012000,y
	sty	SMSizeL
	plp
	bne	?09
	lda	SMSizeL		; stampa solo indirizzi di pagina
	bne	?08
	jsr	XmtPrint	
	INDEX16
?08:	ldy	SMSizeL
	iny
	cpy	#$2000		; 8k
	bcc	?03
	inc	PIA0+PIAPRA	; banco successivo
	dec	SMTmpK		; loop 64k
	bne	?02
	inc	SMTmpL		; banco successivo
	dec	SMTmpH
	bne	?01		; loop banchi
	dec	PIA0+PIAPRA	
	jsr	XmtPrint
	SCNPRINT	
	.DB	'- OK', 0	
	bra	?10
?09:	jsr	XmtPrint	
	SCNPRINT
	.DB	'- BAD RAM', 0
?10:	INDEX08
	pla
	sta	PIA0+PIAPRA	; ripristina banco X mem
	plx			; ripristina bit CRX
	sta	CRXME,x
	rts

XmtPrint:	
	INDEX08
	ldx	SMXPos
	ldy	SMYPos
	SCNSETPOS
	lda	PIA0+PIAPRA
	asl	a
	asl	a
	asl	a
	asl	a
	asl	a
	ora	SMSizeH		; indirizzo fisico (Hi)
	tax	
	lda	SMSizeL
	jmp	PrintWord
	
Cmd_kmt:
	beq	?00c		; no params - full test
	lda	SMTmpK
	ora	SMTmpH
	bne	?00a		; max . $F7
	lda	SMTmpL		; banco std mem in test
	beq	?00a		; no test in banco 0 !
	cmp	#$F8
	bcc	?00b		; OK
?00a:	jmp	ErrCls2		; errore - banco > $F7 oppure banco 0
?00b:	lda	#$01		; un banco (64k)
	bne	?00d
?00c:	lda	#$F7		; numero banchi full test (eccetto 0 e F8/FF)
	ldx	#$01		
	stx	SMTmpL		; banco start = $01 per full test
?00d:	sta	SMTmpH		; numero banchi da 64k
	stz	!CtrlBrk	; clear CTRL BREAK flag
	SCN_CR
	lda	SMTmpH
	cmp	#$01
	beq	?00e		; testa un banco
	SCNPRINT
	.DB	'::Full memory test: $', 0
	bra	?00f
?00e:	SCNPRINT
	.DB	'::Memory bank test: $', 0
?00f:	SCNGETPOS
	stx	SMAuxL
	sty	SMAuxH
	ldx	CRXME		; salva impostazione X mem
	phx
	ldx	CREME		; salva impostazione E mem
	phx
	ldx	CRXFE		; salva impostazione flash mem
	phx
	sta	CRXMEOFF	; disabilita X mem
	sta	CREMEOFF	; disabilita E mem
	sta	CRXFEOFF	; disabilita F mem
	phb			; salva PBR
?01:	INDEX08
	ldx	SMAuxL		; pos. banco
	ldy	SMAuxH
	SCNSETPOS
	lda	SMTmpL		; print banco
	jsr	PrintHex
	SCNGETPOS	; pos. address
	stx	SMXPos
	sty	SMYPos
	INDEX16
	lda	SMTmpL		; imposta PBR corrente
	pha
	plb
	ldy	#$0000
	jsr	CkStop
	beq	?10
?02:	lda	!$0000,y
	xba
	lda	#$55
	sta	!$0000,y
	cmp	!$0000,y
	bne	?05
	lda	#$AA
	sta	!$0000,y
	cmp	!$0000,y
?05:	php
	xba
	sta	!$0000,y
	sty	SMSizeL
	plp
	bne	?09
	lda	SMSizeL
	bne	?08
	jsr	MemPrint
	INDEX16
?08:	ldy	SMSizeL
	iny
	bne	?02
	inc	SMTmpL		; banco successivo
	dec	SMTmpH
	bne	?01		; loop banchi
	jsr	MemPrint
	SCNPRINT	
	.DB	'- OK', 0
	bra	?10
?09:	jsr	MemPrint
	SCNPRINT
	.DB	'- BAD RAM', 0
	
?10:	INDEX08
	plb			; ripristina banco
	plx
	sta	CRXFE		; ripristina impostazione F mem
	plx
	sta	CREME		; ripristina impostazione E mem
	plx
	sta	CRXME		; ripristina impostazione M mem
	rts

MemPrint:
	INDEX08
	ldx	SMXPos
	ldy	SMYPos
	SCNSETPOS
	lda	SMSizeL
	ldx	SMSizeH
	jmp	PrintWord
		
; r -> show registri CPU
PrintReg:
	CPU16
	tsx
	inx
	inx
	stx	SMsp
	CPU08
	SCNPRINT
	
	.DB	KB_CR, '  KR  PC  BR  DP  SR  AC   XR   YR   SP', KB_CR
	.DB	'; ', KB_ESC, 'Q', 0
	
	lda	SMkr		; stampa PBR (K)
	jsr	PrintByte
	lda	SMpc		; stampa PCL
	ldx	SMpc+1		; stampa PCH
	jsr	PrintWord
	lda	SMbr		; stampa DBR (B)
	jsr	PrintByte
	lda	SMdp		; stampa DPL
	ldx	SMdp+1		; stampa DPH
	jsr	PrintWord
	lda	SMsr		; stampa SR
	jsr	PrintByte
	lda	SMac		; stampa AL	
	ldx	SMac+1		; stampa AH
	jsr	PrintWord
	lda	SMxr		; stampa XL	
	ldx	SMxr+1		; stampa XH
	jsr	PrintWord
	lda	SMyr		; stampa XL	
	ldx	SMyr+1		; stampa YH
	jsr	PrintWord
	lda	SMsp		; stampa SPL
	ldx	SMsp+1		; stampa SPH
	jmp	PrintWord

; comando ';' -> set registri (escluso SP)
Cmd_SetReg:
	bcs	?10
	lda	SMTmpL
	sta	SMkr
	jsr	GetParm
	bcs	?10
	lda	SMTmpL		; pcl
	ldy	SMTmpH		; pch
	sta	SMpc
	sty	SMpc+1
	jsr	GetParm
	bcs	?10
	lda	SMTmpL
	sta	SMbr
	jsr	GetParm
	bcs	?10
	lda	SMTmpL		; dpl
	ldy	SMTmpH		; dph
	sta	SMdp
	sty	SMdp+1
	jsr	GetParm
	bcs	?10
	lda	SMTmpL
	sta	SMsr
	ldy	#0		; legge 3 param. successivi (A, X, Y)
?01:	jsr	GetParm		; non si imposta SP
	bcs	?10
	ACC16
	lda	SMTmpL
	sta	DP01ADDR+SMac,y
	ACC08
	iny
	iny
	cpy	#6
	bcc	?01
?10:	rts
	
; cre [0|1] -> Expanded Memory $010000-$011FFF off/on
Cmd_cre:
	beq	Cmd_crs		; no paramteri - show
	lda	SMTmpL
	and	#$01
	tax
	sta	CREME,x
	bra	Cmd_crs

; crx [0|1] -> eXtended Memory $012000-$013FFF off/on
Cmd_crx:
	beq	Cmd_crs		; no paramteri - show
	lda	SMTmpL
	and	#$01
	tax
	sta	CRXME,x
	bra	Cmd_crs
	
; crf [0|1] -> Flash Memory $F00000-$F0FFFF off/on
Cmd_crf:
	beq	Cmd_crs		; no paramteri - show
	lda	SMTmpL
	and	#$01
	tax
	sta	CRXFE,x

; crs -> show stato registro di controllo accesso memoria
Cmd_crs:
	ldx	#0
?01:	lda	CRSTR,x		; copia stringa nel buffer
	sta	INPUTBUF,x
	beq	?01a
	inx
	bne	?01
?01a:	ldx	#23		; flag EM
	lda	#'0'
	ldy	CREME
	beq	?02
	inc	a
?02:	sta	INPUTBUF,x
	ldx	#47		; flag XM
	lda	#'0'
	ldy	CRXME
	beq	?03
	inc	a
?03:	sta	INPUTBUF,x
	ldx	#71		; flag FM
	lda	#'0'
	ldy	CRXFE
	beq	?04
	inc	a
?04:	sta	INPUTBUF,x
	ACC16
	lda	#INPUTBUF
	ldx	#.SEG.INPUTBUF
	SCNSTROUT
	CPU08
	rts

; xmp [page] -> set page extended memory
Cmd_SetXMPage:
	beq	?10		; no paramteri - show
	ACC16
	lda	SMTmpH
	ACC08
	bne	CmdErr
	lda	SMTmpL
	sta	PIA0+PIAPRA
?10:	SCNPRINT
	.DB	$0D, ':: Current XM Page -> $', 0
	
	lda	PIA0+PIAPRA
	jsr	PrintHex
	rts

; m [start][stop] -> visualizza memoria standard
Cmd_m:
	bcs	?01
	jsr	TmpToAddr
	jsr	GetParm
	bcc	?02
?01:	lda	#11		; numero righe x 16 bytes
	sta	SMTmpL
	bne	?03
?02:	jsr	SubTmpAddr
	bcc	CmdErr		; end address > start address - errore	
	lsr	a		; calcola numero righe (x 16 bytes)
	ror	SMTmpH	
	ror	SMTmpL
	lsr	a
	ror	SMTmpH	
	ror	SMTmpL
	lsr	a
	ror	SMTmpH	
	ror	SMTmpL
	lsr	a
	ror	SMTmpH	
	ror	SMTmpL
	sta	SMTmpK
?03:	jsr	CkStop
	beq	?04
	jsr	DispMem
	rep	#(PMFLAG.OR.PCFLAG)	; 16 bit + clc
	.LONGA	on
	lda	#16
	.LONGA	off
	jsr	IncPtrA
	jsr	DecTmpPtr
	bcs	?03
	lda	SMdumb
	beq	?04
	TXT_CR
?04:	rts
				
CmdErr:
	jmp	ErrCls2

; rd addr -> read single memory addr.
Cmd_rd:
	beq	CmdErr		; no params
	jsr	TmpToAddr
	SCNPRINT
	.DB	KB_ESC, 'O', SCN_CSRUP, $0D, 'rd ', 0
	jsr	PrintAddr
	jsr	PrintBlank
	lda	[SMAddrL]
	jmp	PrintHex

; wr addr data -> write single memory addr.
Cmd_wr:
	beq	CmdErr		; no params
	bcs	CmdErr
	jsr	TmpToAddr
	jsr	GetParm
	bcs	CmdErr		; manca data	
	lda	SMTmpL
	sta	[SMAddrL]
	SCNPRINT
	.DB	KB_ESC, 'O', SCN_CSRUP, $0D, 'wr ', 0
	jsr	PrintAddr
	jsr	PrintBlank
	lda	SMTmpL
	jmp	PrintHex

; xs [sector]
Cmd_xs:
	bne	?02
	stz	SMTmpL
	stz	SMTmpH
?02:	ACC16
	lda	SMTmpL
	and	#$0FFF
	asl	a
	ACC08
	xba
	sta	SMAddrK
	xba
	sta	SMAddrH
	stz	SMAddrL
	;stz	SMTmpL
	stz	SMTmpH
	bra	__?01
	
; mx [start][stop] -> visualizza memoria estesa (max. 1FFFFF)
Cmd_mx:
	bcs	__?01
	jsr	TmpToAddr
	lda	SMAddrK
	cmp	#$20
	bcs	CmdErr		; max. 1FFFFF
	jsr	GetParm
	bcc	__?02
__?01:	lda	#11		; numero di righe di default (righe x 16 bytes)
	sta	SMTmpL
	bne	__?03
__?02:	lda	SMTmpK		; max. possibile 1FFFFF
	cmp	#$20
	bcs	CmdErr		; errore
	jsr	SubTmpAddr
	bcc	CmdErr		; end address > start address - errore	
	lsr	a		; calcola numero righe (x 16 bytes)
	ror	SMTmpH	
	ror	SMTmpL
	lsr	a
	ror	SMTmpH	
	ror	SMTmpL
	lsr	a
	ror	SMTmpH	
	ror	SMTmpL
	lsr	a
	ror	SMTmpH	
	ror	SMTmpL
	sta	SMTmpK
__?03:	lda	SMAddrK
	cmp	#$20		; MAX 1FFFFF
	bcs	?04
	jsr	CkStop
	beq	?04
	jsr	DispXMem
	rep	#(PMFLAG.OR.PCFLAG)	; 16 bit + clc
	.LONGA	on
	lda	#16
	.LONGA	off
	jsr	IncPtrA
	lda	SMAddrK
	cmp	#$20		; MAX 1FFFFF
	bcs	?04
	jsr	DecTmpPtr
	bcs	__?03
?04:	rts
				

; >addr data, data, data,... -> set standard memory
Cmd_SetMem:
	bcs	?02
	jsr	TmpToAddr
	ldy	#0
?01:	jsr	GetParm
	bcs	?02
	lda	SMTmpL
	sta	[SMAddrL],y
	iny
	cpy	#16
	bcc	?01
?02:	SCNPRINT
	.DB	KB_ESC, 'O', SCN_CSRUP, 0

; display 1 riga di memoria
DispMem:
	TXT_CR
	TXTPRCHAR
	.DB	'>'
	jsr	PrintAddr
	ldy	#0
	beq	?02
?01:	jsr	PrintBlank
?02:	lda	[SMAddrL],y	; fetch byte
	jsr	PrintHex
	iny
	cpy	#16
	bcc	?01
	lda	SMdumb
	bne	?03a
	SCNPRINT
	.DB	' ', SCN_RVSON, ':', 0
	bra	?03b
?03a:	TXTPRINT
	.DB	' :', 0
?03b:	ldy	#0
?03:	lda	[SMAddrL],y	; fetch byte
	cmp	#$80
	bcs	?04
	cmp	#' '
	bcs	?06
?04:	lda	#'.'
?06:	TXTCHAROUT
	iny
	cpy	#16
	bcc	?03
	rts

; # km <src bank> <dest bank>(src bank = $01..$FF, dest bank = $01..$F7)
; move whole memory bank - src bank and dest bank must be not the same
Cmd_km:
	bne	?01
?00:	jmp	CmdErr2
?01:	lda	SMTmpK
	ora	SMTmpH
	bne	?00
	lda	SMTmpL
	beq	?00
	sta	SMTmp2
	jsr	GetParm
	bcs	?00
	lda	SMTmpK
	ora	SMTmpH
	bne	?00
	lda	SMTmpL
	beq	?00
	cmp	#$F8
	bcs	?00
	cmp	SMTmp2
	beq	?00
	stz	SMAddrL
	stz	SMAddrH
	sta	SMAddrK
	ldx	.ABS.CRFWEOFF
	sta	!CRFWEON	; enable write in bank $F8 RAM
	sta	?10+1		; store dest bank for mvn istruction
	lda	SMTmp2
	sta	?10+2		; store source bank for mvn istruction	
	sta	!CRFWEOFF,x	; disable writing in bank $F8
	phb
	ldx	#0
	CPU16
	lda	#$FFFF
	txy
?10:	mvn	#0, #0
	CPU08
	plb
	rts	

; # kF <bank> (bank = $01..$F7)
; fill whole memory bank with incr/decr pattern
Cmd_kF:
	bne	?01
?00:	jmp	CmdErr2
?01:	lda	SMTmpK
	ora	SMTmpH
	bne	?00
	lda	SMTmpL
	beq	?00
	cmp	#$F8
	bcs	?00
	sta	SMAddrK
	stz	SMAddrL
	stz	SMAddrH
	lda	#0
	sta	SMTmp2
	tay
	INDEX16
?02:	sta	[SMAddrL],y
	bit	SMTmp2
	bmi	?04
	inc	a
	bne	?06
	dec	a
	sta	SMTmp2
	bra	?06
?04:	dec	a
	bne	?06
	stz	SMTmp2
	iny
	sta	[SMAddrL],y
?06:	iny
	bne	?02
	CPU08
	rts

; # kz <bank> (bank = $01..$F7)
; clear whole memory bank
Cmd_kz:
	bne	?01
?00:	jmp	CmdErr2
?01:	lda	SMTmpK
	ora	SMTmpH
	bne	?00
	lda	SMTmpL
	beq	?00
	cmp	#$F8
	bcs	?00
	sta	SMTmpK
	stz	SMTmpL
	stz	SMTmpH
	ldy	#0
	CPU16
	tya
?02:	sta	[SMTmpL],y
	iny
	iny
	bne	?02
	CPU08
	rts

; # kf <bank> <byte=0> (bank = $01..$F7)
; fill whole memory bank
Cmd_kf:
	beq	CmdErr2
	lda	SMTmpK
	ora	SMTmpH
	bne	CmdErr2
	lda	SMTmpL
	beq	CmdErr2
	cmp	#$F8
	bcs	CmdErr2
	sta	SMAddrK
	stz	SMAddrL
	stz	SMAddrH
	stz	SMTmpL
	jsr	GetParm
	bcs	?01
	lda	SMTmpK
	ora	SMTmpH
	bne	CmdErr2
?01:	lda	SMTmpL
	xba
	lda	SMTmpL
	ldy	#0
	CPU16
?02:	sta	[SMAddrL],y
	iny
	iny
	bne	?02
	CPU08
	rts
	
Cmd_z:
	jsr	GetStartStop		; indirizzi Start/Stop
	bcs	CmdErr2
	stz	SMTmpL			; fill byte = 0
	stz	SMTmp2			; fill no inc.
	bra	_Fill
	
Cmd_f:
	jsr	GetStartStop		; indirizzi Start/Stop
	bcs	CmdErr2
	jsr	GetParm			; Fill byte
	bcs	CmdErr2
	stz	SMTmp2			; fill no inc.
	bra	_Fill
		
Cmd_F:
	jsr	GetStartStop		; indirizzi Start/Stop
	bcs	CmdErr2
	stz	SMTmpL			; fill byte = 0
	lda	#$80
	sta	SMTmp2			; flag fill-inc
	
	; SMSizeL/H/K  ->  #bytes
	; SMAddrL/H/K  -> indirizzo start
	; SMTmpL       -> fill byte
	; SMXddrL/H/K  -> indirizzo finale
	; SMTmp2       -> flag fill+inc.

_Fill:
?01:	jsr	CkStop
	beq	?10
	lda	SMTmpL			; fill byte
	sta	[SMAddrL]
	bit	SMTmp2
	bpl	?04
	inc	SMTmpL
?04:	jsr	IncPtr
	jsr	DecSize
	bcs	?01
?10:	rts

CmdErr2:
	jmp	ErrCls2

; x>addr data, data, data,... -> set extended memory
Cmd_SetXMem:
	ldx	CRXME		; salva bit CR
	phx
	sta	CRXMEON		; abilita memoria estesa
	bcs	?02
	jsr	TmpToAddr
	lda	SMXAddrK
	cmp	#$20
	bcs	CmdErr2	
	ldy	#0
?01:	jsr	GetParm
	bcs	?02
	jsr	XSetPtrY
	bcs	?02		; fine memoria estesa
	lda	SMTmpL
	sta	[SMXAddrL]
	iny
	cpy	#16
	bcc	?01
?02:	lda	SMXAddrK
	cmp	#$20
	bcc	?03
	rts
?03:	SCNPRINT
	.DB	KB_ESC, 'O', SCN_CSRUP, 0
	
	bra	_xdm

; display 1 riga di memoria estesa
DispXMem:
	ldx	CRXME		; salva bit CR
	phx
	sta	CRXMEON		; abilita memoria estesa
_xdm:
	lda	#$01
	sta	SMXAddrK
	TXT_CR
	TXTPRCHAR		; prompt memoria estesa
	.DB	'x'
	TXTPRCHAR
	.DB	'>'	
	jsr	PrintAddr
	ldy	#0
	beq	?02
?01:	jsr	PrintBlank
?02:	jsr	XSetPtrY
	bcc	?02a
	lda	#$FF			; oltre limite memoria
	bra	?02b
?02a:	lda	[SMXAddrL]
?02b:	jsr	PrintHex
	iny
	cpy	#16
	bcc	?01
	lda	SMdumb
	bne	?03a
	SCNPRINT
	.DB	' ', SCN_RVSON, ':', 0
	bra	?03b
?03a:	TXTPRINT
	.DB	' :', 0
?03b:	ldy	#0
?03:	jsr	XSetPtrY
	bcc	?03c
	lda	#'X'			; indica fine memoria
	bra	?03d
?03c:	lda	[SMXAddrL]
?03d:	cmp	#$80
	bcs	?04
	cmp	#' '
	bcs	?06
?04:	lda	#'.'
?06:	TXTCHAROUT
	iny
	cpy	#16
	bcc	?03
	TXTPRINT
	.DB	SCN_RVSOFF, ' ', 0
	lda	PIA0+PIAPRA
	jsr	PrintHex
	plx
	sta	CRXME,x
	rts

; te -> show RTC internal extended ram (128 bytes)
Cmd_te:
	stz	rtcadr
?02:	jsr	rtcxmem
	lda	rtcadr
	clc
	adc	#16
	sta	rtcadr
	bpl	?02
	rts

; e>addr data, data, data,... -> set RTC extended memory
Cmd_stxm:
	ldx	#RTCCTRLA	; setta banco 1 RTC
	stx	RTCALE
	lda	#$10		; setta banco 1
	tsb	RTCDATA
	bcs	?06
	lda	SMTmpL
	cmp	#$80
	bcc	?02
	jmp	ErrCls2
?02:	sta	rtcadr
	ldy	#0
?04:	jsr	GetParm
	bcs	?06
	tya
	adc	rtcadr
	bmi	?05
	ldx	#RTCEXTRAMADDR
	stx	RTCALE
	sta	RTCDATA
	ldx	#RTCEXTRAMDATA
	stx	RTCALE
	lda	SMTmpL
	sta	RTCDATA		; store byte
?05:	iny
	cpy	#16
	bcc	?04
?06:	lda	rtcadr
	cmp	#$80
	bcc	?08
	rts
?08:	SCNPRINT
	.DB	KB_ESC, 'O', SCN_CSRUP, 0
	bra	rtcxmem2

; show one row of RTC extended ram 
rtcxmem:
	ldx	#RTCCTRLA	; setta banco 1 RTC
	stx	RTCALE
	lda	#$10		; setta banco 1
	tsb	RTCDATA
rtcxmem2:
	TXTPRINT
	.DB	13, 'e>', 0
	lda	rtcadr
	jsr	PrintByte
	ldy	#0
	beq	?02
?01:	jsr	PrintBlank
?02:	ldx	#RTCEXTRAMADDR
	stx	RTCALE
	tya
	clc
	adc	rtcadr
	bpl	?02b
	jsr	PrintBlank
	jsr	PrintBlank
	bra	?02c	
?02b:	sta	RTCDATA
	ldx	#RTCEXTRAMDATA
	stx	RTCALE
	lda	RTCDATA		; fetch byte
	jsr	PrintHex
?02c:	iny
	cpy	#16
	bcc	?01
	lda	SMdumb
	bne	?03a
	SCNPRINT
	.DB	' ', SCN_RVSON, ':', 0
	bra	?03b
?03a:	TXTPRINT
	.DB	' :', 0
?03b:	ldy	#0
?03:	ldx	#RTCEXTRAMADDR
	stx	RTCALE
	tya
	clc
	adc	rtcadr
	bmi	?04
	sta	RTCDATA
	ldx	#RTCEXTRAMDATA
	stx	RTCALE
	lda	RTCDATA		; fetch byte
	cmp	#$80
	bcs	?04
	cmp	#' '
	bcs	?06
?04:	lda	#'.'
?06:	TXTCHAROUT
	iny
	cpy	#16
	bcc	?03
	rts

; ts -> show RTC internal bank 1 ram 40..7F
Cmd_ts:
	lda	#1
	sta	rtcbnk
	bra	_rtcm

; tu -> show RTC internal bank 0 ram 40..7F
Cmd_tu:
	stz	rtcbnk
_rtcm:
	lda	#$40
	sta	rtcadr
?02:	jsr	rtcmem
	lda	rtcadr
	clc
	adc	#16
	sta	rtcadr
	bpl	?02
	rts

; u>addr data, data, data,... -> set RTC user ram 40..7F bank 0
Cmd_stum:
	stz	rtcbnk
	ldx	#RTCCTRLA
	stx	RTCALE
	lda	#$10
	trb	RTCDATA		; set bank 0
	bcs	?06
	lda	SMTmpL
	cmp	#$80
	bcc	?02
?01:	jmp	ErrCls2
?02:	cmp	#$40
	bcc	?01
	sta	rtcadr
	ldy	#0
?04:	jsr	GetParm
	bcs	?06
	tya
	adc	rtcadr
	bmi	?05
	sta	RTCALE
	lda	SMTmpL
	sta	RTCDATA		; store byte
?05:	iny
	cpy	#16
	bcc	?04
?06:	lda	rtcadr
	cmp	#$80
	bcs	?07
	cmp	#$40
	bcs	?08
?07:	rts
?08:	SCNPRINT
	.DB	KB_ESC, 'O', SCN_CSRUP, 0
	bra	rtcmem2

; show one row of RTC ram 40..7F 
rtcmem:
	ldx	#RTCCTRLA
	stx	RTCALE
	lda	#$10
	ldy	rtcbnk
	beq	?02
	tsb	RTCDATA		; set bank 1
	bra	rtcmem2
?02:	trb	RTCDATA		; set bank 0

rtcmem2:
	ldy	rtcbnk
	beq	?00
	TXTPRINT
	.DB	13, ':>', 0
	bra	?00a
?00:	TXTPRINT
	.DB	13, 'u>', 0
?00a:	lda	rtcadr
	jsr	PrintByte
	ldy	#0
	beq	?02
?01:	jsr	PrintBlank
?02:	tya
	clc
	adc	rtcadr
	bpl	?02b
	jsr	PrintBlank
	jsr	PrintBlank
	bra	?02c	
?02b:	sta	RTCALE
	lda	RTCDATA		; fetch byte
	jsr	PrintHex
?02c:	iny
	cpy	#16
	bcc	?01
	lda	SMdumb
	bne	?03a
	SCNPRINT
	.DB	' ', SCN_RVSON, ':', 0
	bra	?03b
?03a:	TXTPRINT
	.DB	' :', 0
?03b:	ldy	#0
?03:	tya
	clc
	adc	rtcadr
	bmi	?04
	sta	RTCALE
	lda	RTCDATA		; fetch byte
	cmp	#$80
	bcs	?04
	cmp	#' '
	bcs	?06
?04:	lda	#'.'
?06:	TXTCHAROUT
	iny
	cpy	#16
	bcc	?03
	rts

; tc -> show RTC internal bank 0&1 ram 0E..3F
Cmd_tc:
	lda	#2
	sta	rtcbnk
	lda	#$0E
	sta	rtcadr
	jsr	rtccm
	inc	rtcadr
	inc	rtcadr
	lda	#16
	sta	rtcbnk	
?02:	jsr	rtccm
	lda	rtcadr
	clc
	adc	#16
	sta	rtcadr
	cmp	#$40
	bcc	?02
	rts

; c>addr data, data, data,... -> set RTC user ram 0E..3F bank 0&1
Cmd_stcm:
	lda	#16
	sta	rtcbnk
	bcs	?06
	lda	SMTmpL
	cmp	#$40
	bcc	?02
?01:	jmp	ErrCls2
?02:	cmp	#$0E
	bcc	?01
	sta	rtcadr
	ldy	#0
?04:	jsr	GetParm
	bcs	?06
	tya
	adc	rtcadr
	cmp	#$40
	bcs	?05
	sta	RTCALE
	lda	SMTmpL
	sta	RTCDATA		; store byte
?05:	iny
	cpy	#16
	bcc	?04
?06:	lda	rtcadr
	cmp	#$40
	bcs	?07
	cmp	#$0E
	bcs	?08
?07:	rts
?08:	SCNPRINT
	.DB	KB_ESC, 'O', SCN_CSRUP, 0

rtccm:
	TXTPRINT
	.DB	13, 'c>', 0
	lda	rtcadr
	jsr	PrintByte
	ldy	#0
	beq	?02
?01:	jsr	PrintBlank
?02:	tya
	clc
	adc	rtcadr
	cmp	#$40
	bcc	?02b
	jsr	PrintBlank
	jsr	PrintBlank
	bra	?02c	
?02b:	sta	RTCALE
	lda	RTCDATA		; fetch byte
	jsr	PrintHex
?02c:	iny
	cpy	rtcbnk
	bcc	?01
	lda	SMdumb
	bne	?03a
	SCNPRINT
	.DB	' ', SCN_RVSON, ':', 0
	bra	?03b
?03a:	TXTPRINT
	.DB	' :', 0
?03b:	ldy	#0
?03:	tya
	clc
	adc	rtcadr
	cmp	#$40
	bcs	?04
	sta	RTCALE
	lda	RTCDATA		; fetch byte
	cmp	#$80
	bcs	?04
	cmp	#' '
	bcs	?06
?04:	lda	#'.'
?06:	TXTCHAROUT
	iny
	cpy	rtcbnk
	bcc	?03
	rts

; get rtc time
Cmd_gt:
	RTCGETT
	xba
	pha			; day of week (1=sunday...)
	xba
	phx			; seconds
	phy			; minutes
	pha			; hours
	phk
	pea	#!?10
	lda	#8
	pha
	BPRINTF
	rts
	
?10:	.DB	13,': current time: %02bu:%02bu:%02bu (day: %bu)', 0

; get rtc date
Cmd_gd:
	RTCGETD
	phx			; day
	phy			; month
	pha			; year
	xba
	pha			; century
	phk
	pea	#!?10
	lda	#8
	pha
	BPRINTF
	rts
	
?10:	.DB	13,': current date: %02bu%02bu/%02bu/%02bu', 0

; set rtc time
; st HHMMSS
Cmd_st:
	ldx	cmdlin
	jsr	asc2bin
	bcs	?05
	sta	brtchour
	jsr	asc2bin
	bcs	?05
	sta	brtcmin
	jsr	asc2bin
	bcc	?10
?05:	jmp	ErrCls2
?10:	sta	brtcsec
	lda	>INPUTBUF,x
	beq	?15
	cmp	#' '
	bne	?05
?15:	ldx	brtcsec
	ldy	brtcmin
	lda	brtchour
	RTCSETT
	bcc	?20
	SCNPRINT
	.DB	13, '::bad time', 0
?20:	rts

; set rtc date
; st CCYYMMDD
Cmd_sd:
	ldx	cmdlin
	jsr	asc2bin
	bcs	?05
	sta	brtcct
	jsr	asc2bin
	bcs	?05
	sta	brtcyear
	jsr	asc2bin
	bcs	?05
	sta	brtcmonth
	jsr	asc2bin	
	bcc	?10
?05:	jmp	ErrCls2
?10:	sta	brtcday
	lda	>INPUTBUF,x
	beq	?15
	cmp	#' '
	bne	?05
?15:	ldx	brtcday
	ldy	brtcmonth
	lda	brtcct
	xba
	lda	brtcyear
	RTCSETD
	bcc	?20
	SCNPRINT
	.DB	13, '::bad date', 0
?20:	rts

asc2bin:
?00:	lda	>INPUTBUF,x
	php
	inx
	plp
	beq	?08
	cmp	#' '
	beq	?00
	ldy	#2		; convert 2 digits
	stz	btmpx		; partial value
?02:	cmp	#'0'		; first char must be a digit
	bcc	?08
	cmp	#'9'+1
	bcs	?10
	sbc	#'0'-1		; convert digit (here always CF = 0)	
	xba			; B = digit
	clc
	lda	btmpx		; partial null?
	beq	?04		; yes, skip mult * 10
	cmp	#26		; this value make overflow
	bcs	?08
	asl	a		; safety multiply * 10
	asl	a
	adc	btmpx
	asl	a		; always carry = 0 here
	sta	btmpx
?04:	xba	
	adc	btmpx
	bcs	?08		; overflow
	sta	btmpx
	lda	>INPUTBUF,x
	inx
	dey
	bne	?02
	dex
?06:	lda	btmpx
	clc
	rts
?08:	sec
?10:	rts

Cmd_fdisk:
	SCN_CR
	ldx	cmdlin
	ACC16CLC
	txa
	adc	#INPUTBUF
	ldx	#^INPUTBUF
	phx
	pha
	ACC08
	cop	$60
	.DB	$00
	rts
	
	.EXTERN _strcpy, _strcat, _getopt, _strlen, _strdel, _strins
	.EXTERN _strcmp, _strncmp, _strcasecmp, _strncasecmp
	.EXTERN _strchr, _strrchr, _strlchr, _strstr

Cmd_strcpy:
	SCN_CR
	ACC16CLC
	ldx	#$20
	phx
	pea	#0		; dst
	ldx	cmdlin
	txa
	adc	#INPUTBUF
	ldx	#^INPUTBUF
	phx
	pha			; src
	jsl	_strcpy
	pha			; size
	ldx	#$20
	phx
	pea	#0
	phk			; dst
	pea	#!?00
	ACC08
	lda	#9
	pha
	BPRINTF
	rts

?00:	.DB	'<%s> %hu', 13, 0

Cmd_test:
s1	.SET	SMTmpL
s2	.SET	SMXTmp+2
k	.SET	SMXTmp
l	.SET	SMXTmp+5
chr	.SET	SMXTmp+7

	SCN_CR
	stz	<chr
	ACC16CLC
	stz	<l
	stz	<k
	ldx	#$20
	stx	<s1+2
	stx	<s2+2
	stz	<s1
	lda	#0
	sta	>$200000
	sta	>$208000	
	lda	#$8000
	sta	<s2
	ldx	cmdlin
	txa
	adc	#INPUTBUF
	ldx	#^INPUTBUF
	ldy	#$C0
	phy			; flag
	phx
	pha			; command line
	phk			; option string
	pea	#!?1000		
	pea	#0		; result
	pea	#0
	CPU08
?10:	jsl	_getopt		; get opttion's loop
	bcs	?20		; error
	tax			; option char
	beq	?20		; end of command line
	bmi	?16		; no option argument
	cmp	#'s'		; -s "string1"
	bne	?11
	lda	<s1+2
	pha
	pei	(s1)
	lda	$04,s
	tax
	lda	$05,s
	tay
	lda	$06,s
	pha
	phy
	phx
	jsl	_strcpy
	bra	?10
?11:	cmp	#'S'		; -S "string2"
	bne	?12
	lda	<s2+2
	pha
	pei	(s2)
	lda	$04,s
	tax
	lda	$05,s
	tay
	lda	$06,s
	pha
	phy
	phx
	jsl	_strcpy
	bra	?10
?12:	cmp	#'z'		; -z: null str1
	bne	?13
	lda	#0
	sta	[s1]
	bra	?10
?13:	cmp	#'Z'		; -Z: null str2
	bne	?14
	lda	#0
	sta	[s2]
	bra	?10
?14:	cmp	#'k'		; -k start
	bne	?15
	lda	$01,s
	sta	<k
	lda	$02,s
	sta	<k+1
	bra	?10
?15:	cmp	#'l'		; -l maxlen
	bne	?15a
	lda	$01,s
	sta	<l
	lda	$02,s
	sta	<l+1
	bra	?10
?15a:	cmp	#'c'		; -c char
	bne	?16
	lda	$01,s
	sta	<chr
	bra	?10
?16:	sec	
?20:	php			; clean stack
	plx			; save carry
	ACC16CLC
	tsc
	adc	#11
	tcs
	ACC08
	txa
	lsr	a		; test carry
	;bcs	?30		; exit
	bcc	?19
	rts
?19: 
	lda	<s1+2
	pha
	pei	(s1)
	jsl	strlen
	ldx	<chr
	phx			; chr
	pei	(l)
	pei	(k)
	ACC16
	pha
	ACC08
	lda	<s1+2
	pha
	pei	(s1)
	phk			; fmt
	pea	#!?01
	lda	#14
	pha
	BPRINTF

	lda	<s2+2
	pha
	pei	(s2)
	jsl	strlen
	ACC16
	pha
	ACC08
	lda	<s2+2
	pha
	pei	(s2)
	phk			; fmt
	pea	#!?00
	lda	#9
	pha
	BPRINTF


	lda	<s1+2		; strstr
	pha
	pei	(s1)
	lda	<s2+2
	pha
	pei	(s2)
	jsl	_strstr
	pea	#0
	xba
	pha
	xba
	pha
	ldx	#0
	bcs	?25a
	inx
?25a:	phx
	phk			; fmt
	pea	#!?03
	lda	#9
	pha
	BPRINTF
	
?30:	rts

?00:	.DB	'<%s> %hu  ', 13, 0
?01:	.DB	'<%s> %hu - %hu - %hu - %bu    <<<<', 13, 0
?02:	.DB	'%bu    ', 13, 0
?03:	.DB	'%bu    %hu   %hu', 13, 0

?1000:	.DB	'k#l#s:S:z Z c!', 0

xxx:
?01:	ldx	cmdlin
	ACC16CLC
	txa
	adc	#INPUTBUF
	ldx	#$E1
	phx
	ldx	#^INPUTBUF
	phx
	pha
	phk
	pea	#!?100
	pha
	pha
	ACC08
?10:	jsl	_getopt
	bcc	?11
	jmp	?20
?11:	tax
	bne	?11a
	jmp	?20
?11a:	bpl	?11b	
	jmp	?18
?11b:	cpy	#' '
	beq	?16
	cpy	#'!'
	beq	?12
	cpy	#'^'
	bne	?14
?12:	tay
	lda	$01,s
	pha
	phy
	phk
	pea	#?60
	lda	#6
	pha
	BPRINTF
	bra	?10
	
?14:	cpy	#':'
	beq	?15
	cpy	#'$'
	beq	?15
	cpy	#'&'
	beq	?14a
	jmp	?200
	
?14a:	tay
	CPU16
	lda	$03,s
	tax
	lda	$01,s
	phx
	pha
	phx
	pha
	CPU08
	phy
	phk
	pea	#?70
	lda	#13
	pha
	BPRINTF
	bra	?10
	
?15:	tay
	lda	$03,s
	tax
	ACC16
	lda	$01,s
	phx
	pha
	ACC08
	phy
	phk
	pea	#?30
	lda	#8
	pha
	BPRINTF
	;bra	?10
	lda	$03,s
	tax
	ACC16
	lda	$01,s
	phx
	pha
	ACC08
	jsl	strlen
	jsr	PrintByte
	SCN_CR
	jmp	?10
	
?16:	pha
	phk
	pea	#?40
	lda	#5
	pha
	BPRINTF
	jmp	?10
?18:	lda	$03,s
	tax
	ACC16
	lda	$01,s
	phx
	pha
	ACC08
	phk
	pea	#?50
	lda	#7
	pha
	BPRINTF
	jmp	?10
?20:	ACC16CLC
	tsc
	adc	#11
	tcs
	ACC08
	rts

?30:	.DB	'option ''-%c'' -- arg: <%s>', 13, 0
?40:	.DB	'option ''-%c'' -- no arg', 13, 0
?50:	.DB	'arg: <%s>', 13, 0
?60:	.DB	'option ''-%c'' -- char: <%c>', 13, 0
?70:	.DB	'option ''-%c'' -- int: <%d>, <%X>', 13, 0
?80:	.DB	'option ''-%c'' -- int: <%bd>, <%bX>', 13, 0
?90:	.DB	'option ''-%c'' -- int: <%hd>, <%hX>', 13, 0
?95:	.DB	'option ''-%c'' -- PTR: <%P>', 13, 0

?100:	.DB	'r C l:s u!p^b$z%x#v*w&y|', 0

?200:	cpy	#'%'
	bne	?210
	tay
	lda	$01,s
	tax
	phx
	pha
	phy
	phk
	pea	#?80
	lda	#7
	pha
	BPRINTF
	jmp	?10

?210:	cpy	#'#'
	bne	?220
	tay
	lda	$02,s
	tax
	lda	$01,s
	phx
	pha
	phx
	pha	
	phy
	phk
	pea	#?90
	lda	#9
	pha
	BPRINTF
	jmp	?10

?220:	tay
	lda	$03,s
	tax
	ACC16
	lda	$01,s
	phx
	pha
	ACC08
	phy
	phk
	pea	#?95
	lda	#8
	pha
	BPRINTF
	jmp	?10

;----------------------------------------------------------
; copia/incremento/decremento puntatori

TmpToAddr:
	
	lda	SMTmpL
	sta	SMAddrL
	lda	SMTmpH
	sta	SMAddrH
	lda	SMTmpK
	sta	SMAddrK
	rts
	
SubTmpAddr:
	ACC16
	sec
	lda	SMTmpL
	sbc	SMAddrL
	sta	SMTmpL
	ACC08
	lda	SMTmpK
	sbc	SMAddrK
	sta	SMTmpK
	rts

DecTmpPtr:
	lda	#1
	
DecTmpPtrA:
	sta	SMAuxL
	stz	SMAuxH
	ACC16
	sec
	lda	SMTmpL
	sbc	SMAuxL
	sta	SMTmpL
	ACC08
	lda	SMTmpK
	sbc	#0
	sta	SMTmpK
	rts

DecPtr:
	ACC16
	sec
	lda	SMAddrL
	sbc	#1
	sta	SMAddrL
	ACC08
	lda	SMAddrK
	sbc	#0
	sta	SMAddrK
	rts

DecSize:
	ACC16
	sec
	lda	SMSizeL
	sbc	#1
	sta	SMSizeL
	ACC08
	lda	SMSizeK
	sbc	#0
	sta	SMSizeK
	rts
		
IncPtr:
	rep	#(PMFLAG.OR.PCFLAG)	; 16 bit + clc
	.LONGA	on
	lda	#1	
IncPtrA:
	adc	SMAddrL
	sta	SMAddrL
	ACC08
	bcc	?01
	inc	SMAddrK
?01:	rts


XSetPtr:
	ACC16
	lda	SMAddrL
	sta	SMXAddrL		; offset
	ACC08
	lda	SMAddrK			; bank	
	bra	_xsptr
	
XSetPtrY:
	rep	#(PMFLAG.OR.PCFLAG)	; A 16 bit + clc
	tya				; YH = 0 !
	adc	SMAddrL
	sta	SMXAddrL		; offset
	ACC08
	lda	SMAddrK			; hi	
	adc	#0			; A = bank
	bcs	_?01
_xsptr:	
	cmp	#$20			; limite max ?
	bcs	_?01			; si - errore
	ldx	SMXAddrH
	stx	SMAuxL
	ldx	#3			; calcola pagina 8k
?01:	rol	SMAuxL
	rol	a
	dex
	bne	?01
	sta	PIA0+PIAPRA		; pagina XM
	lda	SMXAddrH
	and	#$1F
	ora	#$20
	sta	SMXAddrH
	clc				; ptr OK
_?01:	rts

;----------------------------------------------------------
; funzioni elementari di stampa

; PrintAddr - stampa a video address SMAddrL,H,K
PrintAddr:
	ACC16
	lda	SMAddrL
	ldx	SMAddrK
	
; PrintAddr2 - stampa a video address A(offset)-X(bank)
PrintAddr2:
	ACC16
	pha
	ACC08
	txa			; hi byte
	jsr	PrintHex
	pla
	plx

; PrintWord - stampa a video word A(lo)-X(hi)
PrintWord:
	pha
	txa
	jsr	PrintHex
	pla

; PrintByte - stampa a video byte A + spazio
PrintByte:
	jsr	PrintHex

; PrintBlank - stampa a video uno spazio
PrintBlank:
	TXTPRCHAR
	.DB	' '
	rts

; PrintUp - CR + cursore up
PrintUp:
	SCNPRINT
	.DB	KB_CR, SCN_CSRUP, 0
	rts
	
PrintCR:
	TXTPRCHAR
	.DB	KB_CR
	rts
	
PrintBlankCR:
	SCNPRINT
	.DB	KB_CR, KB_ESC, 'Q', ' ', 0
	rts

PrintHex1:
	TXTPRCHAR
	.DB	'$'  
	jsr	PrintHex
	TXTPRCHAR
	.DB	','
	rts
	
; PrintHex - stampa a video byte HEX
; In	- A = byte
; Out	- nessuno
PrintHex:
	phx			; salva x
	jsr	FF_Byte2Hex	; X,A = HEX
	TXTCHAROUT	; stampa hi digit
	txa
	plx			; ripristina x
	TXTCHAROUT	; stampa low digit		
	rts
	
; FF_Byte2Hex - converte byte in HEX
; In	- A = byte
; Out:	- X = low digit
;	  A = hi digit	
FF_Byte2Hex:
	pha			; salva A
	jsr	?01		; converte parte bassa
	tax			; x = low digit
	pla
	lsr	a		; parte alta
	lsr	a
	lsr	a
	lsr	a
?01:	and	#$0F		; maschera nibble
	cmp	#10
	bcc	?02
	adc	#6
?02:	adc	#'0'
_?02:	rts

; ritorna indirizzo start e indirizzo stop
; ritorna C=1 se non ci sono parametri o se Stop < Start
GetStartStop:
	bcs	_?02		; no parametri
	plx			; return L
	pla			; return H
	inx			; scarta stack - necessario per  
	bne	?01		; chiamare GetParm al giusto livello di stack
	inc	a		; X,A -> indirizzo di ritorno
?01:	stx	SMTmp2
	sta	SMTmp2+1
	jsr	TmpToAddr	; salva SMTmpL/H/K in SMAddrL/H/K
	jsr	GetParm
	bcs	?20		; no stop address, esce
	lda	SMTmpL		; SMXAddrL/H/K = indirizzo di stop
	sta	SMXAddrL
	lda	SMTmpH
	sta	SMXAddrH
	lda	SMTmpK
	sta	SMXAddrK
	jsr	SubTmpAddr	; stop - start = #bytes
	lda	SMTmpL		; salva #bytes in SMSizeL/H/K
	sta	SMSizeL
	lda	SMTmpH
	sta	SMSizeH
	lda	SMTmpK
	sta	SMSizeK
	bcc	?19		; errore: stop < start
	clc			; OK
	.DB	$24		; BIT $38
?19:	sec			; errore	
?20:	jmp	(SMTMP2)	; return


; ricava parametri per funzioni fdread/fdwrite
GetFDCParm:
	plx			; return L
	pla			; return H
	inx			; scarta stack - necessario per  
	bne	?01		; chiamare GetParm al giusto livello di stack
	inc	a		; X,A -> indirizzo di ritorno
?01:	stx	SMTmp2
	sta	SMTmp2+1
	ACC16
	tsc			; stack frame
	sec
	sbc	#FDPBSIZE	; crea variabili locali
	tcs
	inc	a
	sta	SMSizeL		; salva stack frame
	ACC08
	lda	SMTmpL		; parametro 1 - drive + flag
	tax
	and	#$01		; maschera drive
	sta	$01,s		; drive
	txa
	and	#$E0		; maschera flag
	sta	$0D,s		; flag
	sta	SMSizeK		; salva flag
	jsr	GetParm		; parametro 2 - formato
	bcs	?20
	lda	SMTmpL
	sta	$06,s		; disk format
	jsr	GetParm		; parametro 3 - buffer
	bcs	?20
	lda	SMTmpL
	sta	$07,s		; buffer ptr
	lda	SMTmpH
	sta	$08,s
	lda	SMTmpK
	sta	$09,s
	jsr	GetParm		; parametro 4 - track
	bcs	?20
	lda	SMTmpL
	sta	$02,s		; track
	
	; i restanti parametri : head, sector, sector number, vbuffer
	; sono opzionali in funzione dei flag passati
	lda	#$00
	sta	$03,s		; head
	sta	$04,s		; sector
	sta	$05,s		; sector num.
	sta	$0A,s		; vbuffer
	sta	$0B,s
	sta	$0C,s
	bit	SMSizeK
	bmi	?18		; MT -> ignora parametri successivi	
	jsr	GetParm		; head opzionale
	bcs	?20	
	lda	SMTmpL
	sta	$03,s		; head
	jsr	GetParm
	bcs	?20
	lda	SMTmpL
	sta	$04,s		; sector
	jsr	GetParm
	bcs	?20
	lda	SMTmpL
	sta	$05,s		; sector num.
?18:	lda	SMSizeH		; C = stack frame
	xba
	lda	SMSizeL
	clc			; OK
	.DB	$24		; BIT $38
?19:	sec			; errore	
?20:	jmp	(SMTMP2)	; return
	
;----------------------------------------------------------
; funzioni riga di comando

;GetPrevCh:
;	dec	SMbndx
	
GetCurCh:
	stx	SMAuxL
	ldx	SMbndx
	lda	INPUTBUF,x
	sec
	beq	?01
	cmp	#':'
	beq	?01
	inc	SMbndx
?01:	php
	ldx	SMAuxL
	plp
	rts

; no case version
GetCurCh2:
	stx	SMAuxL
	ldx	SMbndx
	lda	INPUTBUF,x
	beq	?00
	cmp	#'a'
	bcc	?00
	cmp	#'z'+1
	bcs	?00
	and	#$DF
?00:	sec
	beq	?01
	cmp	#':'
	beq	?01
	inc	SMbndx
?01:	php
	ldx	SMAuxL
	plp
	rts

CkStop:
	phd
	pea	#0
	pld
	lda	CtrlBrk
	stz	CtrlBrk
	pld
	cmp	#$80
	rts

;----------------------------------------------------------
; UPDATE FLASH
;----------------------------------------------------------

;;_FLASHSTART	.EQU	$

; flag settori da programmare
_SCTTBL:
	.DB	$80, $80, $00, $00, $00, $80, $80, $80
_SRCBNK:
	.DB	$F8
_DSTBNK:
	.DB	$F0
	
; erase sector: X -> settore (0..7)
_erase:
	.LONGI	on
	phb
	phk
	plb
	lda	!_SCTTBL,x
	bmi	?02			; erase
	plb
	clc
	sep	#PVFLAG			; V = 1
	rts
?02:	txa
	clc
	adc	!_DSTBNK
	sta	SMAddrK			; banco fisico
	stz	SMAddrL
	stz	SMAddrH
	plb
	ldy	#0
?04:	lda	[SMAddrL],y
	cmp	#$FF			; test erased
	bne	?06			; not erased
	iny
	bne	?04
	clv
	clc
	rts				; sector erased
?06:	ldy	#$0555			; inizia sequenza erase sector
	lda	#$AA
	sta	[SMAddrL],y
	ldy	#$02AA
	lda	#$55
	sta	[SMAddrL],y
	ldy	#$0555
	lda	#$80
	sta	[SMAddrL],y
	lda	#$AA
	sta	[SMAddrL],y
	ldy	#$02AA
	lda	#$55
	sta	[SMAddrL],y
	ldy	#$00			; SA - sector address (in banco)
	lda	#$30			; codice erase
	sta	[SMAddrL]
	jsr	_waitfl			; attende fine operazione
	bcs	?30			; fail
?24:	lda	[SMAddrL],y
	cmp	#$FF			; test erased
	bne	?26			; not erased
	iny
	bne	?24
	clv
	clc
	rts				; sector erased
?26:	sec				; erased fail
?30:	rts
	
; pgm sector: X -> settore (0..7)
_sctrpgm:
	phb
	phk
	plb
	lda	!_SCTTBL,x
	bmi	?02			; erase
	plb
	sep	#PVFLAG			; V = 1
	clc
	rts
?02:	txa
	clc
	adc	!_DSTBNK
	sta	SMAddrK			; banco fisico DST
	stz	SMAddrL
	stz	SMAddrH
	txa
	clc
	adc	SMFsrc
	sta	SMXAddrK		; banco fisico SRC
	stz	SMXAddrL
	stz	SMXAddrH
	plb
	ldy	#0
?04:	lda	[SMXAddrL],y
	nop
	cmp	[SMXAddrL],y
	bne	?04
	sta	SMTmp2
	sty	SMSizeL
	ldy	#$0555			; inizia sequenza pgm
	lda	#$AA
	sta	[SMAddrL],y
	ldy	#$02AA
	lda	#$55
	sta	[SMAddrL],y
	ldy	#$0555
	lda	#$A0
	sta	[SMAddrL],y
	ldy	SMSizeL
	lda	SMTmp2
	sta	[SMAddrL],y		; program byte
	jsr	_waitfl
	sep	#PVFLAG			; V = 1 -> pgm fail
	bcs	?30			; fail
?20:	lda	[SMAddrL],y
	cmp	SMTmp2
	bne	?28
	iny
	bne	?04	
	clv
	clc
	rts
?28:	sec
	clv				; V = 0 -> verf fail	
?30:	rts

; polling toggle bit (DQ6)
_waitfl:
?08:	lda	[SMAddrL],y		; loop toggle bit
	sta	SMAuxL
?10:	lda	[SMAddrL],y		; read toggle bit 
	sta	SMAuxH
	eor	SMAuxL			; confronta
	and	#$40			; bit 6 toggle ?
	beq	?20			; no - operazione terminata
	lda	#00100000B		; test DQ5
	bit	SMAuxH
	bne	?12			; DQ5 = 1 -> read toggle bit
	lda	SMAuxH			; DQ5 = 0 -> loop
	sta	SMAuxL
	bra	?10
?12:	lda	[SMAddrL]		; read toggle bit
	sta	SMAuxL
	lda	[SMAddrL]		; read toggle bit 
	sta	SMAuxH
	eor	SMAuxL
	and	#$40			; bit 6 toggle ?
	beq	?20			; no - operazione terminata
	lda	#$F0			; fail - reset device
	sta	[SMAddrL]
	sec
	rts
?20:	clc
	rts

; update flash from file
Cmd_flash:
	bit	SMFflag
	bmi	?01
	jmp	CmdErr3
?01:	lda	#$E0		; from bank $E0
	bra	_flash
	
; update flash from file
Cmd_mflash:
	lda	#$F8		; from memory

_flash:
	sta	SMFsrc
	CPU08
	pea	#DP01ADDR	; imposta nuova DP
	pld
	lda	#$00
	pha
	plb
	sta	!CRFWEON	; enable write flash
	sta	!CRXFEOFF	; abilita flash banco $F0
	ldx	#$7F
	stx	VIA0+VIAIER	; disabilita interrupt VIA 0
	stx	VIA0+VIAIFR	; ed azzera tutti i flag	
	stx	VIA1+VIAIER	; disabilita interrupt VIA 1
	stx	VIA1+VIAIFR	; ed azzera tutti i flag	
	sei
	INDEX16
	ldx	#$07
_?ff:	jsr	_erase		; erase sector X
	bcs	_fail1		; fail sector
	bvs	?02		; salta settore
	jsr	_sctrpgm
	bcs	_fail2		; fail pgm
	bvs	?02		; salta settore
	jsr	_okbeep
	jsr	_delay
?02:	dex
	bpl	_?ff
	lda	#$80
	trb	VIA0+VIAPRA	; reset
?03:	nop
	bra	?03

_fail1:	
	lda	#10110000B	; CTC 2 in modo 0 - 2 bytes
	sta	CTC0+CTCCTRL
	lda	#<2000
	sta	CTC0+CTCCNT2
	lda	#>2000
	sta	CTC0+CTCCNT2
	lda	#$08
	trb	PIA0+PIACRB
	trb	PIA0+PIACRA
	;bra	_?ff
	bra	_fail3
	
_fail2:
	bvc	?10
	lda	#10110000B		; CTC counter 2 in modo 0 - 2 bytes
	sta	CTC0+CTCCTRL
	lda	#01110110B		; CTC counter 1 in modo 3 - 2 bytes
	sta	CTC0+CTCCTRL
	lda	#<400			; beep 200ms - pausa 200ms
	sta	CTC0+CTCCNT1
	lda	#>400
	sta	CTC0+CTCCNT1
	lda	#<1600			; 4 beep
	sta	CTC0+CTCCNT2
	lda	#>1600
	sta	CTC0+CTCCNT2
	bra	?20
?10:	lda	#<3200			; 4 beep
	sta	CTC0+CTCCNT2
	lda	#>3200
	sta	CTC0+CTCCNT2
	
?20:	lda	#$08			; beep ... beep...
	tsb	PIA0+PIACRB
	trb	PIA0+PIACRA
	;bra	_?ff
_fail3:
	bra	_fail3
	
_okbeep:
	lda	#10110000B	; CTC 2 in modo 0 - 2 bytes
	sta	CTC0+CTCCTRL
	lda	#<150
	sta	CTC0+CTCCNT2
	lda	#>150
	sta	CTC0+CTCCNT2
	lda	#$08
	trb	PIA0+PIACRB
	trb	PIA0+PIACRA
	rts
	
_delay:
	lda	#<300			; timeout
	sta	VIA0+VIAT2CL
	lda	#>300
	sta	VIA0+VIAT2CH
?02:	lda	#T2IFRB
	bit	VIA0+VIAIFR		; test timeout
	beq	?02			; loop
	rts

;;_startpgm:
;;	jmp	_flash
	
;;_FLASHEND	.EQU	$
;;_FLASHCNT	.EQU	($ - _FLASHSTART)

;----------------------------------------------------------
; stringhe

CRSTR:
	.DB	$0D, '::EM $010000-$011FFF->0 * XM $012000-$013FFF->0'
	.DB	' * FM $F00000-$F7FFFF->0', 0
