
# make file for B1601.prj -- borland version
# BIOS per board 65C816 B16/01

# Macro definitions

ASM=X65816.EXE
LINK=link658.exe
HFORM=hexform.exe -FILL(00)
TEMP=C:\ADC\Tools\temp
AFLAGSCMN=-q -ns -ld,lst
AFLAGSF8=-q -ns -v_BANKF8_ -ld,lst\F8
AFLAGSF9=-q -ns -v_BANKF9_ -ld,lst\F9
AFLAGSFA=-q -ns -v_BANKFA_ -ld,lst\FA
AFLAGSFB=-q -ns -v_BANKFB_ -ld,lst\FB
AFLAGSFC=-q -ns -v_BANKFC_ -ld,lst\FC
AFLAGSFD=-q -ns -v_BANKFD_ -ld,lst\FD
AFLAGSFE=-q -ns -v_BANKFE_ -ld,lst\FE
AFLAGSFF=-q -ns -v_BANKFF_ -ld,lst\FF



# target ROM: 512 Kb flash rom F80000 - FFFFFF
TGTROM = bin\rom.bin

########################################

# dipendenze file HEX dai files OBJ
F8DEP =	obj\F8\start.obj obj\F8\ata.obj obj\F8\lcd.obj obj\F8\reset.obj \
	obj\F8\intp.obj obj\F8\fpuemu.obj obj\F8\systble.obj obj\F8\fdc.obj \
	obj\F8\vdc.obj obj\F8\bios.obj obj\F8\vprint.obj obj\F8\rtc.obj \
	obj\F8\fpu.obj obj\F8\sp.obj

# F9.hex deps.
F9DEP =	obj\F9\start.obj obj\F9\fscbm.obj obj\F9\biosmem.obj  \
	obj\F9\fdir.obj obj\F9\sysf9.obj obj\F9\fsint.obj \
	obj\F9\fatdir.obj obj\F9\fatsys.obj obj\F9\utils.obj obj\F9\toscmd.obj
		
# FA.hex deps.
FADEP =	obj\FA\slib.obj obj\FA\getopt.obj obj\FA\string.obj
		
# FB.hex deps.
FBDEP =	obj\FB\dummy.obj

# FC.hex deps.
FCDEP =	obj\FC\dummy.obj

# FD.hex deps.
FDDEP =	obj\FD\qedt.obj

# FE.hex deps.
FEDEP =	obj\FE\main.obj obj\FE\float.obj obj\FE\kcbm.obj obj\FE\pcode.obj \
	obj\FE\pcstd.obj obj\FE\pcerr.obj obj\FE\pcc.obj

# FF.hex deps.
FFDEP =	obj\FF\font.obj obj\FF\monitor.obj obj\FF\mond.obj obj\FF\masmx.obj


# Common DEPS
CMNDEP	= 

DEPS =	$(F8DEP) \
	$(F9DEP) \
	$(FADEP) \
	$(FBDEP) \
	$(FCDEP) \
	$(FDDEP) \
	$(FEDEP) \
	$(FFDEP) \
	$(CMNDEP)
	
########################################

# target
all: dir rombin

# Dependency rules
dir:
	-@if not exist "obj" mkdir "obj"
	-@if not exist "obj\cmn" mkdir "obj\cmn"
	-@if not exist "obj\F8" mkdir "obj\F8"
	-@if not exist "obj\F9" mkdir "obj\F9"
	-@if not exist "obj\FA" mkdir "obj\FA"
	-@if not exist "obj\FB" mkdir "obj\FB"
	-@if not exist "obj\FC" mkdir "obj\FC"
	-@if not exist "obj\FD" mkdir "obj\FD"
	-@if not exist "obj\FE" mkdir "obj\FE"
	-@if not exist "obj\FF" mkdir "obj\FF"
	-@if not exist "bin" mkdir "bin"
	-@if not exist "bin\hex" mkdir "bin\hex"
	-@if not exist "lst" mkdir "lst"
	-@if not exist "lst\F8" mkdir "lst\F8"
	-@if not exist "lst\F9" mkdir "lst\F9"
	-@if not exist "lst\FA" mkdir "lst\FA"
	-@if not exist "lst\FB" mkdir "lst\FB"
	-@if not exist "lst\FC" mkdir "lst\FC"
	-@if not exist "lst\FD" mkdir "lst\FD"
	-@if not exist "lst\FE" mkdir "lst\FE"
	-@if not exist "lst\FF" mkdir "lst\FF"
	

rombin: $(TGTROM)

bin\rom.bin: bin\hex\b1601.s28
	$(HFORM) bin\rom.bin = bin\hex\b1601.s28 -RANGE(F80000, FFFFFF) -FILL(EA)

########################################

bin\hex\b1601.s28: $(DEPS) link.txt
	$(LINK) link.txt

########################################

# assemblaggio moduli comuni	
	

########################################

# assemblaggio moduli per F8.HEX
obj\F8\start.obj: src\F8\start.asm inc\global.inc
	$(ASM) $(AFLAGSF8) src\F8\start.asm obj\F8\start.obj

obj\F8\systble.obj: src\F8\systble.asm inc\global.inc
	$(ASM) $(AFLAGSF8) src\F8\systble.asm obj\F8\systble.obj

obj\F8\bios.obj: src\F8\bios.asm inc\global.inc
	$(ASM) $(AFLAGSF8) src\F8\bios.asm obj\F8\bios.obj

obj\F8\sp.obj: src\F8\sp.asm inc\global.inc inc\dirp00.inc inc\macro.inc inc\sp.inc
	$(ASM) $(AFLAGSF8) src\F8\sp.asm obj\F8\sp.obj

obj\F8\lcd.obj: src\F8\lcd.asm inc\global.inc
	$(ASM) $(AFLAGSF8) src\F8\lcd.asm obj\F8\lcd.obj

obj\F8\reset.obj: src\F8\reset.asm inc\global.inc
	$(ASM) $(AFLAGSF8) src\F8\reset.asm obj\F8\reset.obj

obj\F8\vprint.obj: src\F8\vprint.asm inc\global.inc
	$(ASM) $(AFLAGSF8) src\F8\vprint.asm obj\F8\vprint.obj

obj\F8\intp.obj: src\F8\intp.asm inc\global.inc
	$(ASM) $(AFLAGSF8) src\F8\intp.asm obj\F8\intp.obj

obj\F8\fpuemu.obj: src\F8\fpuemu.asm inc\global.inc
	$(ASM) $(AFLAGSF8) src\F8\fpuemu.asm obj\F8\fpuemu.obj

obj\F8\fpu.obj: src\F8\fpu.asm inc\global.inc inc\dpfpu.inc
	$(ASM) $(AFLAGSF8) src\F8\fpu.asm obj\F8\fpu.obj

obj\F8\ata.obj: src\F8\ata.asm inc\global.inc
	$(ASM) $(AFLAGSF8) src\F8\ata.asm obj\F8\ata.obj

obj\F8\fdc.obj: src\F8\fdc.asm inc\global.inc
	$(ASM) $(AFLAGSF8) src\F8\fdc.asm obj\F8\fdc.obj

obj\F8\vdc.obj: src\F8\vdc.asm inc\global.inc
	$(ASM) $(AFLAGSF8) src\F8\vdc.asm obj\F8\vdc.obj

obj\F8\rtc.obj: src\F8\rtc.asm inc\global.inc
	$(ASM) $(AFLAGSF8) src\F8\rtc.asm obj\F8\rtc.obj

########################################

# assemblaggio moduli per F9.HEX

obj\F9\start.obj: src\F9\start.asm inc\global.inc
	$(ASM) $(AFLAGSF9) src\F9\start.asm obj\F9\start.obj

obj\F9\fsint.obj: src\F9\fsint.asm inc\global.inc src\F9\fstmp.inc
	$(ASM) $(AFLAGSF9) src\F9\fsint.asm obj\F9\fsint.obj

obj\F9\toscmd.obj: src\F9\toscmd.asm inc\global.inc src\F9\fstmp.inc
	$(ASM) $(AFLAGSF9) src\F9\toscmd.asm obj\F9\toscmd.obj

obj\F9\fatdir.obj: src\F9\fatdir.asm inc\global.inc
	$(ASM) $(AFLAGSF9) src\F9\fatdir.asm obj\F9\fatdir.obj

obj\F9\fatsys.obj: src\F9\fatsys.asm inc\global.inc
	$(ASM) $(AFLAGSF9) src\F9\fatsys.asm obj\F9\fatsys.obj

obj\F9\utils.obj: src\F9\utils.asm inc\global.inc
	$(ASM) $(AFLAGSF9) src\F9\utils.asm obj\F9\utils.obj

obj\F9\fscbm.obj: src\F9\fscbm.asm inc\global.inc
	$(ASM) $(AFLAGSF9) src\F9\fscbm.asm obj\F9\fscbm.obj

obj\F9\sysf9.obj: src\F9\sysf9.asm inc\global.inc
	$(ASM) $(AFLAGSF9) src\F9\sysf9.asm obj\F9\sysf9.obj

obj\F9\biosmem.obj: src\F9\biosmem.asm inc\global.inc
	$(ASM) $(AFLAGSF9) src\F9\biosmem.asm obj\F9\biosmem.obj

obj\F9\fdir.obj: src\F9\fdir.asm inc\global.inc
	$(ASM) $(AFLAGSF9) src\F9\fdir.asm obj\F9\fdir.obj

########################################

# assemblaggio moduli per FA.HEX
obj\FA\slib.obj: src\FA\slib.asm inc\global.inc
	$(ASM) $(AFLAGSFA) src\FA\slib.asm obj\FA\slib.obj
obj\FA\getopt.obj: src\FA\getopt.asm inc\global.inc
	$(ASM) $(AFLAGSFA) src\FA\getopt.asm obj\FA\getopt.obj
obj\FA\string.obj: src\FA\string.asm inc\global.inc
	$(ASM) $(AFLAGSFA) src\FA\string.asm obj\FA\string.obj

########################################

# assemblaggio moduli per FB.HEX
obj\FB\dummy.obj: src\FB\dummy.asm inc\global.inc
	$(ASM) $(AFLAGSFB) src\FB\dummy.asm obj\FB\dummy.obj

########################################

# assemblaggio moduli per FC.HEX
obj\FC\dummy.obj: src\FC\dummy.asm inc\global.inc
	$(ASM) $(AFLAGSFC) src\FC\dummy.asm obj\FC\dummy.obj

########################################

# assemblaggio moduli per FD.HEX
obj\FD\qedt.obj: src\FD\qedt.asm inc\global.inc
	$(ASM) $(AFLAGSFD) src\FD\qedt.asm obj\FD\qedt.obj

########################################

# assemblaggio moduli per FE.HEX
obj\FE\main.obj: src\FE\main.asm inc\global.inc
	$(ASM) $(AFLAGSFE) src\FE\main.asm obj\FE\main.obj

obj\FE\float.obj: src\FE\float.asm inc\global.inc
	$(ASM) $(AFLAGSFE) src\FE\float.asm obj\FE\float.obj

obj\FE\pcode.obj: src\FE\pcode.asm inc\global.inc
	$(ASM) $(AFLAGSFE) src\FE\pcode.asm obj\FE\pcode.obj

obj\FE\pcstd.obj: src\FE\pcstd.asm inc\global.inc
	$(ASM) $(AFLAGSFE) src\FE\pcstd.asm obj\FE\pcstd.obj

obj\FE\pcerr.obj: src\FE\pcerr.asm inc\global.inc
	$(ASM) $(AFLAGSFE) src\FE\pcerr.asm obj\FE\pcerr.obj

#obj\FE\pcc.obj: src\FE\pcc.asm inc\global.inc
#	$(ASM) $(AFLAGSFE) src\FE\pcc.asm obj\FE\pcc.obj

obj\FE\kcbm.obj: src\FE\kcbm.asm inc\global.inc
	$(ASM) $(AFLAGSFE) src\FE\kcbm.asm obj\FE\kcbm.obj
	

########################################

# assemblaggio moduli per FF.HEX
obj\FF\monitor.obj: src\FF\monitor.asm inc\global.inc
	$(ASM) $(AFLAGSFF) src\FF\monitor.asm obj\FF\monitor.obj

obj\FF\masmx.obj: src\FF\masmx.asm inc\global.inc
	$(ASM) $(AFLAGSFF) src\FF\masmx.asm obj\FF\masmx.obj

obj\FF\mond.obj: src\FF\mond.asm inc\global.inc
	$(ASM) $(AFLAGSFF) src\FF\mond.asm obj\FF\mond.obj

obj\FF\font.obj: src\FF\font.asm inc\global.inc
	$(ASM) $(AFLAGSFF) src\FF\font.asm obj\FF\font.obj
