
; chnl 15 always open
; chnl 0 only load
; chnl 1 only save
; chnl 2..14 available
; 8 internal file descriptors (logical index)
; 8 double-buffer 512b
;
; buffer DMA
; #00..#23 - sys drive 0 (#14..#23 16 sec free if cbm)
; #24..#47 - sys drive 1 (#38..#47 16 sec free if cbm)
; #48..#6B - cache drive 0 (#5C..#6B 16 sec free if cbm)
; #6C..#7F - write cache drive 0 (20 sec)
; #80..#BF - free 64 sec used by virtual iec (8 buffer x 4k)
; #C0..#D3 - write cache drive 1 (20 sec)
; #D4..#DB - 8 sec double-buffer cbm
; #DC..#FF - cache drive 1 (#F0..#FF 16 sec free if cbm)

_SCN_INC_	.SET	1

	.INCLUDE inc\global.inc
	.INCLUDE inc\dirp00.inc

.LIST on

	.INCLUDE inc\dpcbmfs.inc

	.CODEF9
	.LONGA off
	.LONGI off

	.EXTERN gctime16

;---------------------------------------------------------------------------
; System interface
;---------------------------------------------------------------------------

; virtual iec interface

; open procedure
;	call vlsnopn (A=sa)
;	call vsndcmd (A=byte)
;	call vunlsnopn
; vlsnopn - listen for open
; first call when send command or open file
; A=sa
vlsnopn:
	.GLOBAL vlsnopn

	phd
	pea	#CBMFSP0
	pld			; set dp to emulator
	phb			; save current dbr
	ldx	#0
	phx
	plb			; set dbr=0
	and	#$0F
	sta	!vopnsa		; save SA
	stz	vcmdix		; clear command string index
	plb
	pld
	rtl
	
; vsndcmd: send cmd byte (A)
vsndcmd:
	.GLOBAL vsndcmd

	phx
	phd
	pea	#CBMFSP0
	pld			; set dp to emulator
	phb			; save current dbr
	ldx	#0
	phx
	plb			; set dbr=0
	ldx	vcmdix
	cpx	#cmdlen
	bcs	?end		; string too long, no store
	sta	!vieccmd,x	; store
	inx
	stx	vcmdix		; update string index
?end:	plb
	pld
	plx
	rtl

; vunlsnopn - ulisten after open command
; CF=1 if error
vunlsnopn:
	.GLOBAL vunlsnopn

	phd
	pea	#CBMFSP0
	pld			; set dp to emulator
	phb			; save current dbr
	ldx	#0
	phx
	plb			; set dbr=0
	lda	!vopnsa		; open SA
	jsr	vopen		; exec open cmd
	plb
	pld
	rtl
	
; vopen: local for open
; A=sa, X=0
vopen:
	sta	chnl		; channel for exec command
	cmp	#$0F
	bne	?trp
	dex			; accept null string in cmd channel
?trp:	stx	cmdtrap
	lda	#<vieccmd	; set pointer of command string
	sta	tlp
	lda	#>vieccmd
	sta	tlp+1
	stz	tlp+2		; cmd. string in bank 0
	ldx	vcmdix
	stz	!vieccmd,x	; terminate command string
	jsr	parsex		; parse & execute command string
	stz	vcmdix		; clear command buffer index
	bcs	?end		; error
	ldx	chnl
	cpx	#$0F
	bne	?dat		; data channel
	clc
	rts
?dat:	lda	lindx,x
	and	#$07
	asl	a
	tax			; double index #
	ACC16CLC		; CF=0, no error
	stz	!vixtab,x
	stz	!vsiztab,x
	stz	!vftab,x	; pre-read flag & eof
	ACC08
?end:	rts

; call after open (X = sa)
vopnlst:
	.GLOBAL vopnlst
	phx
	phd
	pea	#CBMFSP0
	pld			; set dp to emulator
	phb			; save current dbr
	lda	#0
	pha
	plb			; set dbr=0
?dat:	lda	lindx,x
	and	#$07
	asl	a
	tax			; double index #
	ACC16CLC		; CF=0, no error
	stz	!vixtab,x
	stz	!vsiztab,x
	stz	!vftab,x	; pre-read flag & eof
	ACC08
	plb
	pld
	plx
	rtl

; A,X,Y=long pointer to command string
; B=sa
viec8open:
	phd			; save current dp
	pea	#CBMFSP0
	pld			; set dp to emulator
	sta	tlp		; set command string ptr
	stx	tlp+1
	sty	tlp+2
	xba			; channel #
	and	#$0F
	sta	chnl
	phb			; save current dbr
	ldx	#0
	phx
	plb			; set dbr=0
	cmp	#$0F
	bne	?trp
	dex			; accept null string in cmd channel
?trp:	stx	cmdtrap
	jsr	parsex		; parse & execute command string
	bcs	?end		; error
	ldx	chnl
	cpx	#$0F
	bne	?dat		; data channel
	stz	vcmdix		; clear command buffer index
	clc
	beq	?end
?dat:	lda	lindx,x
	and	#$07
	asl	a
	tax			; double index #
	ACC16CLC
	stz	!vixtab,x
	stz	!vsiztab,x
	stz	!vftab,x	; pre-read flag & eof
	ACC08
?end:	plb			; restore dbr
	pld			; restore dp
	rtl			; return CF=1 if error

; listen command
; A=sa
viec8lsn:
	.GLOBAL viec8lsn

	phx			; save X, Y
	phy
	phd			; save current dp
	pea	#CBMFSP0
	pld			; set dp to cbmfs emulator
	phb			; save dbr
	ldx	#0
	phx
	plb			; set dbr = 0
	sta	chnl		; save sa	
	and	#$0F
	tax			; X=sa
	
	stz	!vopnsa

	bit	viecfg		; already active?
	bpl	?tst		; no
	cpx	sa
	bne	?bad
	
	ldy	#$FF
	sty	.ABS.vopnsa
	bra	?dat

?bad:	lda	#badlsn		; invalid listen command
	jsr	viecerr		; set error
	bra	?end		; exit with CF=1
?tst:	jsr	vtstwr		; test if write channel
	bcs	?end		; error
	cpx	#$0F
	bne	?dat		; data channel
	stz	vcmdix		; clear index
	clc
	bra	?end		; exit
?dat:	ldx	vbufnum
	
	clc
	bit	!vopnsa
	bmi	?end

	ACC16CLC
	lda	>viecdma,x
	sta	vieclp
	ldy	#DMABNK+1	; bank $80..$BF
	sty	vieclp+2
	lda	vixtab,x	; get current index
	sta	viecndx		
	lda	#VIECMAX	; max. size of buffer
	sta	viecsiz
	ACC08
?end:	lda	chnl
	plb
	pld
	ply
	plx
	rtl

; talk command
; A=sa
viec8tlk:
	.GLOBAL viec8tlk

	phx			; save X, Y
	phy
	phd			; save current dp
	pea	#CBMFSP0
	pld			; set dp to cbmfs emulator
	phb			; save dbr
	ldx	#0
	phx
	plb			; set dbr = 0
	sta	chnl		; save sa	
	and	#$0F
	tax			; X=sa
	
	stz	!vopnsa

	bit	viecfg		; already active?
	bpl	?tst		; no
	cpx	sa
	bne	?bad
	ldy	#$FF
	sty	.ABS.vopnsa
	bra	?dat

?bad:	lda	#badtlk		; invalid talk command
	jsr	viecerr		; set error
	bra	?end		; exit with CF=1
?tst:	jsr	vtstrd		; test if read channel
	bcs	?end		; error
	cpx	#$0F
	bne	?dat		; data channel
	jsr	fnderr		; find last error
	ldy	#$FF		; store error string
?lp:	iny	
	lda	[tlp],y
	sta	vieccmd,y
	bne	?lp
	lda	#$0D
	sta	vieccmd,y
	iny
	sty	vcmdsiz		; buffer size
	stz	vcmdix		; clear index
	rep	#PCFLAG+PVFLAG	; CF=VF=0: no error, no eof
	bra	?end		; exit
?dat:	ldx	vbufnum
	lda	!vftab+1,x
	sta	veof		; eof flag
	
	bit	!vopnsa
	bmi	?dat2

	ACC16CLC		; CF=0
	lda	>viecdma,x
	sta	vieclp		; set buffer pointer
	ldy	#DMABNK+1
	sty	vieclp+2
	lda	vixtab,x
	sta	viecndx		; current index
	lda	!vsiztab,x
	sta	viecsiz		; current buffer size
	ACC08
?dat2:	bit	veof		; eof?
	bmi	?eof		; yes: exit with CF=0, VF=1
	bit	!vftab,x	; pre-read flag
	bmi	?ok		; already pre-readed
	jsr	vbufrd		; pre-read into buffer
	lda	#$80
	sta	!vftab,x	; set pre-read flag
	bcs	?end		; read error
?ok:	ACC16CV			; CF=0, VF=0
	lda	viecsiz		; buffer is empty?
	ACC08
	bne	?end		; no
	lda	#$C0
	sta	veof		; set eof flag
	sta	!vftab+1,x
?eof:	sep	#PVFLAG		; VF=1: eof
?end:	lda	chnl
	plb
	pld
	ply
	plx
	rtl

; CF=1 if read error
vbufrd:
	ACC16
	lda	vieclp		; set read buffer
	ldy	vieclp+2
	sta	wbuf
	sty	wbuf+2
	lda	#VIECMAX	; buffer max. size
	sta	bsize
	stz	btrf		; clear transferred count
	stz	viecsiz		; empty buffer
	stz	viecndx
	ACC08
	ldy	#0		; pre-read into buffer
	ldx	sa
	stx	chnl
	jsr	fd_rw
	ldx	vbufnum
	ACC16
	lda	#0
	bcs	?st		; error
	lda	btrf		; count of transf. bytes
?st:	sta	viecsiz
	sta	!vsiztab,x
	ACC08
	rts

; A=data
viec8put:
	.GLOBAL viec8put

	phx			; save X, Y
	phy
	phd			; save current dp
	pea	#CBMFSP0
	pld			; set dp to cbmfs emulator
	phb			; save dbr
	ldx	#0
	phx
	plb			; set dbr = 0
	sta	viecbuf		; save data to put
	bit	viecfg		; current sa is active?
	bpl	?ern		; no
	bvc	?ok		; ready to listen
?ern:	lda	#nochnl		; no channel available
	bra	?er
?erl:	ldx	sa		; channel # error
	lda	#longln		; command too long
?er:	jsr	viecerr
	lda	viecbuf
	bra	?end		; return CF=1
?ok:	ldx	sa		; trust on sa channel
	cpx	#$0F
	bne	?dat		; put to data channel
	ldx	vcmdix		; current buffer index
	cpx	#cmdlen
	bcs	?erl		; command line too long	
	sta	!vieccmd,x	; store
	inx
	stx	vcmdix		; update index
	;cmp	#$0D		; terminate command string?
	;bne	?clc		; no, wait terminator
	;stz	!vieccmd-1,x	; terminate string with null
	;lda	#$0F
	;xba			; B=channel 15
	;lda	#<vieccmd	; set pointer to command string
	;ldx	#>vieccmd
	;ldy	#0		; command string in bank 0
	;stz	vcmdix		; clear buffer index
	;jsr	viec8cmd	; exexcute command in channel 15
	;lda	#$0D
	bra	?end		; CF set if error
?dat:	ldx	#0
	INDEX16
	ldy	viecndx		; index into buffer
	cpy	viecsiz
	bcs	?wr		; flush buffer
	sta	[vieclp],y	; store
	iny
	sty	viecndx		; update index
	bra	?xy8		; exit with CF=0
?wr:	ldy	vieclp		; flush buffer on disk
	sty	wbuf		; set buffer pointer
	lda	vieclp+2
	sta	wbuf+2
	ldy	viecsiz
	sty	bsize		; buffer size
	stx	btrf		; clear transferred count
	stx	viecndx		; clear index
	;stx	viecsiz		; clear size
	CPU08
	ldx	sa		; set channel #
	stx	chnl
	ldy	#1		; write op
	jsr	fd_rw
	lda	viecbuf		; data to store
	bcs	?end		; error
	ldy	#1
	INDEX16
	sta	[vieclp]	; store
	sty	viecndx		; next index = 1
?xy8:	INDEX08	
?end:	plb	
	pld
	ply
	plx
	rtl

viec8get:
	.GLOBAL	viec8get

	phx			; save X, Y
	phy
	phd			; save current dp
	pea	#CBMFSP0
	pld			; set dp to cbmfs emulator
	phb			; save dbr
	ldx	#0
	phx
	plb			; set dbr = 0
	bit	viecfg		; current sa is active?
	bpl	?ern		; no
	bvs	?ok		; ready to talk
?ern:	lda	#nochnl		; no channel available
	jsr	viecerr
	lda	#$0D
	bra	?end		; return CF=1
?ok:	ldx	sa		; talk channel
	cpx	#$0F
	bne	?dat		; data channel
	lda	#$0D
	ldy	vcmdsiz		; if buffer is empty...
	beq	?eof		; ... return CR & VF=1 (eof)
	ldx	vcmdix		; index into buffer
	cpx	vcmdsiz		; if buffer is terminated...
	bcc	?get
	clc			; ... return CR & VF=1 (eof)
	bra	?eof
?get:	lda	!vieccmd,x	; get data
	inx
	stx	vcmdix
	cpx	vcmdsiz		; if not last data...
	clv
	bcc	?end		; ...exit with VF=0
	stz	lsterr		; clear last error
	bra	?eof		; return VF=1 (eof)
?dat:	ldx	#0
	INDEX16CLC		; CF=0
	lda	#$0D		; return CR if eof	
	bit	veof		; eof flag ?
	bmi	?end		; exit with CF=0, VF=1
	ldy	viecsiz		; if buffer is empty...
	beq	?eof		; ... return CR & VF=1 (eof)
	ldy	viecndx		; index into buffer	
	lda	[vieclp],y	; get data
	iny
	sty	viecndx		; update index
	cpy	viecsiz
	clv
	bcc	?end		; no eof		
	cpy	#VIECMAX	; partial buffer?
	sta	viecbuf		; save data
	bcc	?eof2		; yes, eof
	INDEX08
	jsr	vbufrd		; pre-read buffer	
	lda	viecbuf		; data
	bcs	?end		; error
	INDEX16CV
	ldy	btrf		; count of transf. bytes
	sty	viecsiz
	;bne	?end		; is not last char
	bra	?end
?eof:	CPU08VF			; eof so set VF = 1
	ldx	#$C0
	stx	veof		; set eof flag
?end:	CPU08
	plb
	pld
	ply
	plx
	rtl
?eof2:	CPU08
	clv
	lda	#$C0
	sta	veof
	lda	viecbuf
	bra	?end

; unlisten
v8unlsn:
	.GLOBAL v8unlsn

	phx
	phd			; save current dp
	pea	#CBMFSP0
	pld			; set dp to cbmfs emulator
	phb			; save dbr
	lda	#0
	pha
	plb			; set dbr = 0
	bit	viecfg		; current sa is active?
	bpl	?end		; no
	bvs	?end		; channel is talking
	lda	sa
	cmp	#$0F
	bne	?clr
	jsr	vopen
	bra	?end2
?clr:	jsr	v8clr
?end:	clc	
?end2:	plb
	pld
	plx
	rtl
	
; untalk
v8untlk:
	.GLOBAL v8untlk

	phx
	phd			; save current dp
	pea	#CBMFSP0
	pld			; set dp to cbmfs emulator
	phb			; save dbr
	lda	#0
	pha
	plb			; set dbr = 0
	bit	viecfg		; current sa is active?
	bpl	?end		; no
	bvc	?end		; channel is listening
	ldx	sa
	cpx	#$0F
	beq	?end
	jsr	v8clr
?end:	plb
	pld
	plx
	clc
	rtl
	
; clear channel
v8clr:
	ldx	vbufnum
	lda	veof
	sta	vftab+1,x
	ACC16
	lda	viecndx
	sta	vixtab,x
	lda	viecsiz
	sta	vsiztab,x
	ACC08
	stz	viecfg
	rts

; A,X,Y=long pointer to command string
; B=sa
viec8cmd:
	sta	tlp		; set pointer to command string
	stx	tlp+1
	sty	tlp+2
	ldx	#0
	xba	
	and	#$0F
	sta	chnl
	cmp	#$0F
	bne	?trp
	dex			; accept null string in cmd channel
?trp:	stx	cmdtrap
	jmp	parsex		; parse & execute command string

; test channel for read
; x = channel #
vtstrd:
	cpx	#$0F
	beq	?ok		; is command channel
	lda	lintab,x	; test if given channel is open
	tay
	cmp	#$FF
	beq	verrnochn	; channel not open
	tya
	bmi	verrbadchn	; channel not open for read
	and	#$07
	asl	a
	sta	vbufnum		; buffer number #
?ok:	stx	sa		; save channel #
	lda	#$C0		; set active talk sa
	sta	viecfg
	clc			; no error
	rts

; test channel for write
; x = channel #
vtstwr:
	cpx	#$0F
	beq	?set		; is command channel
	lda	lintab,x	; test if given channel is open
	tay
	cmp	#$FF
	beq	verrnochn	; channel not open
	tya
	bmi	?ok		; ok is a write channel
	asl	a		; test bit 6 - direct access
	bpl	verrbadchn	; channel not open for write
	tya
?ok:	and	#$07
	asl	a
	sta	vbufnum		; buffer number #
?set:	stx	sa		; save channel #
	lda	#$80		; set active listen sa
	sta	viecfg
	clc			; no error
	rts

verrnochn:
	lda	#filnop
	bra	viecerr
verrbadchn:
	lda	#badchn
viecerr:
	stx	etrk
	stz	esec
	sta	lsterr
	sec
	rts

verrlsn:
	lda	#badlsn
	bra	viecerr

; test channel for close
; A=sa
vtstcls:
	stz	veof		; clear flush buffer flag
	and	#$0F
	tax
	cpx	#$0F
	beq	?end
	bit	viecfg
	bmi	verrlsn
	lda	lintab,x
	cmp	#$FF
	beq	verrnochn
	tay
	and	#$07
	asl	a
	sta	vbufnum
	tya
	bmi	?set
	asl	a
	bpl	?ok
?set:	sta	veof		; set flush buffer flag
?ok:	stx	sa
	bit	veof
	bpl	?end
	ldx	vbufnum
	ACC16CLC		; CF=0
	lda	>viecdma,x
	sta	wbuf		; set buffer pointer
	ldy	#DMABNK+1
	sty	wbuf+2
	lda	!vixtab,x
	sta	bsize		; current index
	stz	btrf		; clear transferred count
	stz	!vixtab,x
	ACC08
	bne	?sa		; ok, will flush buffer
	stz	veof		; nothing to flush
?sa:	ldx	sa
?end:	clc
	rts

; close
A=sa
v8close:
	.GLOBAL v8close

	phd			; save current dp
	pea	#CBMFSP0
	pld			; set dp to cbmfs emulator
	phb			; save dbr
	ldx	#0
	phx
	plb			; set dbr = 0
	jsr	vtstcls
	bcs	?end		; error
	cpx	#$0F
	clc
	beq	?end
	stx	chnl
	bit	veof		; need ro flush buffer?
	bpl	?cls		; no, close file
	ldx	sa		; set channel #
	stx	chnl
	ldy	#1		; write op
	jsr	fd_rw
	ldx	sa		; set channel #
	stx	chnl		; ignore error
?cls:	jsr	fdcls		; close file(s)
	stz	viecfg
	ldx	vbufnum
	ACC16	
	stz	vixtab,x
	stz	vsiztab,x
	stz	vftab,x
	ACC08
?end:	plb
	pld
	rtl

viecdma:
	.DW	$0000, $1000, $2000, $3000
	.DW	$4000, $5000, $6000, $7000
	
;---------------------------------------------------------------------------
; COP_cbmfs_cmd - send command to CBM file system emulator
;
; prototype: COP_cbmfs_cmd(sCmd, bChnl)
;
; Params (4 bytes):
;	sCmd	= command string long pointer
;	bChnl 	= channel number $00..$0F
;			$00 		input only
;			$01 		output only
;			$02..$0E	data channel
;			$0F		command channel
;
; Out:
;	CF = 0 if operation completed successfully
;		A,X,Y preserved
;	CF = 1 if error
;		A, X preserved
;		Y = error code (cbm style)
;	Status register always preserved except carry

; params offset
bChnl	.SET	STKPRMS
sCmd	.SET	STKPRMS + 1

COP_cbmfs_cmd:
	.GLOBAL	COP_cbmfs_cmd

	ACC16
	lda	#CBMFSP0	; set DP -- not need to be saved
	tcd
	lda	sCmd,s		; get command string long pointer
	sta	tlp
	ACC08
	lda	sCmd+2,s
	sta	tlp+2
	lda	bChnl,s
	and	#$0F		; mask
	sta	chnl
	stz	cmdtrap
	jsr	parsex		; parse & execute command string
	rtl			; return CF=1 if error

; internal file system command 
; A,X,Y=long pointer to command string
cbmfs_cmd:
	.PUBLIC cbmfs_cmd

	phd			; save current dp
	pea	#CBMFSP0
	pld			; set dp to emulator
	sta	tlp		; set command string ptr
	stx	tlp+1
	sty	tlp+2
	lda	#$0F		; command to channel 15
	sta	chnl
	phb			; save current dbr
	lda	#0
	pha
	plb			; set dbr=0
	stz	cmdtrap
	jsr	parsex		; parse & execute command string	
	plb			; restore dbr
	pld			; restore dp
	rts			; return CF=1 if error (A=error code)

; internal file system command
; return error string pointer (C=pointer, X=bank)
cbmfs_err:
	.PUBLIC cbmfs_err

	phd			; save current dp
	pea	#CBMFSP0
	pld			; set dp to emulator
	jsr	fnderr
	ldy	#0
?02:	lda	[tlp],y
	beq	?06
	cmp	#'a'
	bcc	?04
	cmp	#'z'+1
	bcs	?04
	and	#$DF
?04:	sta	cmdbuf,y
	iny
	bra	?02
?06:	sta	cmdbuf,y	
	lda	#>cmdbuf
	xba
	lda	#<cmdbuf
	ldx	#0
	plb			; restore dbr
	pld			; restore dp
	rts
	
;---------------------------------------------------------------------------
; COP_cbmfs_rw - read/write on channel (in an open file)
;
; prototype: COP_cbmfs_rw(lpBuf, wSize, bChnl)
;
; Params (6 bytes):
;	lpBuf	= long pointer to buffer
;	wSize 	= size (16 bit) of buffer if read or bytes count to write
;	bChnl	= channel number ($00..$0F)
;
; Out:
;	CF = 0 if operation completed successfully
;		C  = number of bytes transferred
;		X  = unchanged
;		Y  = unchanged
;	CF = 1 if error
;		C  = number of bytes transferred
;		X  = unchanged
;		Y  = error code (cbm-like)
;	Status register always preserved except carry
;
; Note:
;	Write to channel 15 ($0F) is no-op and return C = 0 and carry = 0
;	Use COP_cbmfs_cmd function to send command on channel 15
;	Read on channel 15 ($0F) return last error message
;	and need at least 96 bytes buffer large

; params offset
bChnl	.SET	STKPRMS
wSize	.SET	STKPRMS + 1
lpBuf	.SET	STKPRMS + 3

COP_cbmfs_rw:
	.GLOBAL	COP_cbmfs_rw

	ACC16			; retrieve function number
	lda	STKPCL,s	; pointer to byte after signature
	sta	COPPtr
	inc	a		; update return address
	sta	STKPCL,s
	ACC08			; A,M -> 8 bit
	lda	STKPBR,s	; bank where was executed cop instruction
	sta	COPPtr+2	
	lda	[COPPtr]	; byte after signature (0->read, 1->write)
	tay			; Y = read(0)/write(1)
	ACC16
	lda	#CBMFSP0	; set DP -- not need to be saved
	tcd
	lda	wSize,s		; get buffer size
	sta	bsize
	stz	btrf		; clear transferred count
	lda	lpBuf,s		; dest. buffer poinnter
	sta	wbuf
	ACC08			; A,M -> 8 bit
	lda	lpBuf+2,s
	sta	wbuf+2
	lda	bChnl,s		; get channel
	and	#$0F		; mask
	tax
	stx	chnl
	jsr	fd_rw		; return carry = 1 if error
	tax			; save error code if any
	ACC16
	lda	btrf		; return count of transf. bytes to caller
	sta	STKCR,s
	ACC08
	txa
	rtl	

;---------------------------------------------------------------------------
; COP_cbmfs_close
;
; prototype: COP_cbmfs_close
;
; Params: none in stack
;	A = channel to close ($00..$0F)
;	closing chnl $0F close all open files
;
; Out:
;	CF = 0 if operation completed successfully
;		C  = unchanged
;		X  = unchanged
;		Y  = unchanged
;	CF = 1 if error
;		C  = unchanged
;		X  = unchanged
;		Y  = error code (cbm-like)
;	Status register always preserved except carry
;
COP_cbmfs_close:
	.GLOBAL COP_cbmfs_close

	ACC16
	lda	#CBMFSP0	; set DP -- not need to be saved
	tcd
	ACC08	
	lda	STKCR,s		; get channel
	and	#$0F
	tax
	stx	chnl
	jsr	fdcls
	rtl

;---------------------------------------------------------------------------
; parse command string & execute command
;---------------------------------------------------------------------------

; parse & execute command string
parsex:
	ACC16
	tsc			; save current stack pointer
	sta	!tos
	ACC08
	stz	lsterr
	jsr	cmdset		; trim & up case input string
	ldy	cmdsiz
	beq	?10		; empty command string
	lda	chnl
	cmp	#$0F
	bne	?30		; open command
	ldx	#ncmds-1	; check first letter...
	lda	!cmdbuf		; ...with cmd table
?02:	cmp	>cmdtbl,x
	beq	?04
	dex
	bpl	?02
	jmp	e_badcmd
?04:	stx	cmdnum
	ldy	cmdsiz		; if just one char is an arror !
	dey
	beq	?20		; syntax error
	cpx	#ndcmd		; no check drive for block-op
	bcs	?06
	lda	!cmdbuf+1
	ldy	#0		; check cbm drive (0 or 1)
	cpx	#pcmd-1		; if M command, first drive will be dos drive
	bne	?05
	dey			; check dos drive
?05:	jsr	chkdrv
	sta	drvnum		; save first drive in command string
?06:	cpx	#pcmd		; limit of not parsed cmd
	bcs	?08
	jsr	tagcmd		; full parse command
	ldx	cmdnum
?08:	txa
	asl	a
	tax
	jsr	(cjump,x)
?10:	clc			; return no error
	rts

?20:	jmp	e_badsyn

;---------------------------------------------------------------------------
; open function's
;---------------------------------------------------------------------------

; parse open command on channel 0..14
; covered cases:
;	"*"
;	"dr:*"
;	"#"
;	"$"
;	"$dr"
;	"$dr:pattern=type"
;	"filename,type,mode" (drive #0)
;	"[@]dr:filename,type,mode"
; in:	A = channel #
?30:	tax			; check free chnl
	ldy	lintab,x
	cpy	#$FF
	beq	?31		; ok, chnl is free
	lda	#opnchn
	jmp	chnerr
?31:	ldx	cmdbuf		; first char of cmd string
	stz	drvnum		; set drive 0 as default
	stz	subcmd		; default open file
	tay			; channel
	bne	?36		; not "load" channel (0)
	cpx	#'*'		; load first program on drive 0?
	bne	?36
?32:	lda	#'*'		; file = "*"
	sta	cmdbuf
	stz	cmdbuf+1
	lda	#1
	sta	cmdsiz
	ldx	#<cmdbuf
	stx	filtbl		; file ptr
	lda	#$80
	sta	pattyp
	lda	#0
	lda	drvnum
	sta	fildrv
	lda	#prgtyp
	sta	typflg		; filter prog. type in search
	stz	mode		; read mode
	lda	#1
	sta	f1cnt
	sta	f2cnt
	stz	subcmd		; open file read mode
	jmp	?78
?36:	cpx	#'$'		; open directory ?
	bne	?48
	tya
	bne	?40		; open directory as seq. file
	jsr	prsldd		; parse string for load directory cmd
	lda	#lddir		; load dir
	sta	subcmd
	jmp	?78
?40:	dey			; error if channel = 1
	beq	?44
	jsr	simprs		; simple parser for set drive
	lda	#seqdir
	sta	subcmd		; open directory as seq. file
	jmp	?80		; no pattern here
?44:	jmp	e_badchn
?48:	cpx	#'#'		; open direct access?
	bne	?60
	ldx	cmdsiz
	dex			; #xxx is unsupported
	beq	?52		; ok
?50:	jmp	e_badsyn	
?52:	cpy	#2
	bcc	?44		; can't use ch 0 & 1
	lda	#damode		; open direct access type
	sta	subcmd
	bra	?80		; no pattern for direct access type
?60:	jsr	prsopn		; parse "@dr:filename,type,mode"
	ldx	#0
	stx	mode		; default read mode
	stx	<opntm		; flag type & mode in parameters
	inx
	stx	type		; defaul type: seq
	cpx	f1cnt		; f1cnt now hold # params
	bcs	?64		; no parameter's
	jsr	?100		; at least one param: check for type & mode
	inx
	cpx	f1cnt
	bcs	?64		; only one parameter
	jsr	?100		; set type & mode
?64:	ldy	type
	cpy	#reltyp
	beq	?50		; error (unsupported type)
	cpy	#partyp
	beq	?50		; error (unsupported type)
	ldx	chnl
	cpx	#2
	bcs	?66		; not load / save
	stx	mode		; force read on chn 0 and write on chn 1
	bit	opntm
	bmi	?68		; type from parameter
	lda	#prgtyp		; set default type for load/save
	sta	type
	bra	?68
?66:	bit	opntm
	bmi	?70		; type from param
	lda	#seqtyp		; default type: seq
?68:	sta	type
?70:	ldx	mode
	cpx	#wtmode
	bne	?76
	bit	pattyp		; no wildcards for write
	bpl	?74
?72:	lda	#badfn
	jmp	cmderr
?74:	lda	cmdbuf		; check replace write mode
	cmp	#'@'
	bne	?76
	lda	#$80		; set flag replace mode
	sta	wrop
	ldx	mode
?76	stx	subcmd		; open file sub-command (read, write, append)
	cpx	mdmode		; is like read mode
	bne	?78
	stz	subcmd
?78:	jsr	buildfn		; build table of canonical names
?80:	lda	subcmd
	asl	a
	tax
	jsr	(opncmd,x)	; execute open func.
	clc			; return no error
	rts

; check type & mode
?100:	ldy	filtbl,x	; get ptr
	lda	cmdbuf,y	; get char
	phx
	ldx	#nmodes
?102:	dex
	bmi	?104		; no valid mode
	cmp	>modlst,x
	bne	?102
	stx	mode		; mode found
	lda	#$40
	tsb	<opntm		; set flag mode
?104:	ldx	#ntypes
?106:	dex
	bmi	?108		; no valid type
	cmp	>tplst,x
	bne	?106
	stx	type		; type found
	lda	#$80
	tsb	<opntm		; set flag type
?108:	plx
	rts

;---------------------------------------------------------------------------
; open file for reading subcommand
;---------------------------------------------------------------------------
opnrd:
	jsr	opread		; open an read fd
	jsr	tread		; pre-read in read cache
	stz	trap		; no trap error
	rts

; open a read fd
; common routine for open read & open append
opread:
	jsr	optsch		; init drive and set up search opt.
	jsr	ffst		; look for file entry
	lda	filtrk
	bne	?02		; ok, file found
	lda	#flntfd
	jmp	cmderr		; file not found
?02:	lda	pattyp
	and	#typmsk		; type from file
	ldx	type		; del. type is invalid !!
	bne	?04		; type from parameter
	sta	type		; type from file
	bra	?06
?04:	cmp	type		; match type from file?
	beq	?06		; yes
	lda	#mistyp		; type mismatch
	jmp	cmderr
?06:	lda	mode
	tax
	cmp	#mdmode
	beq	?08		; open always, even splat file
	lda	#$20		; this is a splat file?
	bit	pattyp
	beq	?08		; no -- open
	lda	#fsplt
	jmp	cmderr		; write file not closed
?08:	cpx	#apmode
	bne	?10
	lda	#$40
	bit	pattyp		; locked file?
	beq	?10		; no
	lda	#flock
	jmp	cmderr		; locked file
?10:	jsr	opnrfd		; open read fd
	lda	#$80
	sta	trap		; trap disk error while open
	rts

;---------------------------------------------------------------------------
; open file for writing subcommand
;---------------------------------------------------------------------------
opnwr:
	jsr	optsch		; init drive and set up search opt.
	jsr	ffst		; look for file entry
	lda	filtrk
	beq	?08		; ok, file not found: can create it
	bit	wrop		; replace file?
	bmi	?02		; yes
	lda	#flexst
	jmp	cmderr		; file exists
?02:	lda	pattyp		; splat file?
	bit	#$20
	beq	?04		; no
	lda	#fsplt
	jmp	cmderr		; write file not closed
?04:	and	#typmsk		; type from file
	ldx	type		; del. type is invalid !!
	bne	?06		; type from parameter
	sta	type		; type from file
	bra	?10
?06:	cmp	type		; match type from file?
	beq	?10		; yes
	lda	#mistyp		; type mismatch
	jmp	cmderr
?08:	stz	wrop		; create file
?10:	jsr	opnwfd		; open file for write
	ldx	drvnum
	stz	drvfg,x
	rts

;---------------------------------------------------------------------------
; open file for append subcommand
;---------------------------------------------------------------------------
opnap:
	jsr	opread		; first of all open an read fd
	stz	wrop		; use as temp. eof flag
	lda	entsec		; set dir to entry
	sta	sector
	ldy	#dirtrk
	sty	track
	lda	[dirp]		; clear flag closed file
	and	#$4F
	sta	[dirp]
	jsr	wrdsec		; update dir on disk
	lda	filtrk
	sta	track		; set up first block
	lda	filsec
	sta	sector
	ACC16
	stz	wcnt		; clear block's counter
	ldx	dblfd
	lda	fdblk,x
	sta	wtmp		; set limit for read block's #
	ACC08
?02:	jsr	wread		; read whole track in write cache
	jsr	setwb		; set cache ptr to right sector
?04:	ACC16	
	lda	wcnt		; update block's counter
	inc	a
	sta	wcnt
	cmp	wtmp		; sanity check
	ACC08
	bcc	?08		; for now is ok
	beq	?06		; reached block's count #
?05:	lda	#bnotm	
	jmp	doserr		; unmatch blocks count
?06:	lda	#$80
	sta	wrop		; signal count match
?08:	ldy	#1
	lda	[wbuf],y	; next sector
	tay
	lda	[wbuf]		; next track
	beq	?10		; end of file?
	sty	sector		; next sector
	cmp	#maxtrk
	bcs	?15		; invalid track in link
	cpy	#numsec
	bcs	?15		; invalid sector in link
	cmp	track		; same track?
	sta	track
	bne	?02		; will read a new track	
	clc
	tya
	ldx	drvnum
	adc	wrtofs,x	; sector in the same track
	sta	wbuf+1
	bra	?04		; next data block	
?10:	bit	wrop		; here block's count should match
	bpl	?05		; unmatch
	cpy	#2		; last block wrong index?
	bcc	?20		; yes
	iny			; bump pointer
	ldx	lindx
	sty	fdptr,x		; start index for append
	lda	sector
	sta	fsec,x		; current file sector
	lda	track
	sta	ftrk,x		; current file track
	ACC16
	lda	wcnt		; append !!
	dec	a		; one less...when close file...
	ldx	dblfd		; one more block will be added
	sta	fdblk,x		; store current block's count
	ACC08
	lda	#$80		; now set fd for write
	ora	lindx
	ldx	chnl
	sta	lintab,x
	ldx	lindx
	stz	trap		; no trap error
	ldx	drvnum
	stz	drvfg,x
	rts

?15:	sta	track		; invalid link
	lda	#invlnk
	jmp	doserr		; invalid file link

?20:	sty	sector		; wrong index in last block
	lda	#badlst
	jmp	doserr

;---------------------------------------------------------------------------
; load directory subcommand
;---------------------------------------------------------------------------
; start directory loading function
loaddir:
	jsr	optsch		; init drive
	jsr	getrfd		; get a free fd
	ldx	chnl
	lda	lintab,x
	ora	#$20		; flag dir. listing
	sta	lintab,x
	jsr	blknb		; clear name buffer
	jsr	sethdp		; set dir header pointer
	jsr	setfdp		; set buffer pointer
	lda	#4		; set ptr to start of disk name
	sta	dirp
	ldy	#22		; offset 26 - copy all till start of name
?02:	lda	[dirp],y
	cmp	#$A0
	bne	?04
	lda	#' '
?04:	sta	nambuf+2,y
	dey
	bpl	?02
	lda	#SCN_RVSON
	sta	!nambuf
	lda	#'"'		; send name in quotes
	sta	!nambuf+1
	sta	!nambuf+18
	lda	#$20
	sta	!nambuf+19
	ldy	#0		; start to fill buffer
	lda	#1		; put sal in buffer
	tax
	sta	[bufp],y
	iny
	lda	#4		; put sah in buffer
	sta	[bufp],y
	iny
	txa			; insert fhoney links (0101)
	sta	[bufp],y
	iny
	sta	[bufp],y
	iny
	lda	drvnum		; put in drive #
	sta	[bufp],y
	iny
	lda	#0
	sta	[bufp],y
	iny
	jsr	movbuf		; get disk name (27 bytes)
	dey			; adjust (-2 bytes)...
	dey			; ...to have 32 bytes with terminator
	lda	#0		; terminator: end of this line
	sta	[bufp],y
	iny			; here will be 32
	phy
	jsr	ffst		; start find dir entry
	ply
	stz	rdlst
	stz	rdeof
	stz	rdidx
	jsr	dlist		; fill buffer with first block
	jmp	savzp		; save zp var's after starting dir search

;---------------------------------------------------------------------------
; open directory as seq. file subcommand
;---------------------------------------------------------------------------
opndir:
	jsr	optsch		; init drive
	jsr	getrfd		; get free fd
	ldx	lindx		; X=fd
	lda	#dirtrk		; open directory
	sta	ftrk,x
	stz	fsec,x
	lda	#2
	sta	fdptr,x		; start of buffer
	rts

;---------------------------------------------------------------------------
; open direct access subcommand
;---------------------------------------------------------------------------
opnblk:
	jsr	getrfd		; get free fd
	ldx	chnl
	lda	lintab,x
	ora	#$40		; direct access flag
	sta	lintab,x
	rts

;---------------------------------------------------------------------------
; scratch command
;---------------------------------------------------------------------------
scratch:
	jsr	fs1set		; set type filter if any
	jsr	alldrs		; set all drives/file ptr's
	jsr	buildfn		; build canonical file names
	jsr	optsch		; init all drive's
	stz	char		; use as counter
	jsr	ffst		; start search
	bmi	?30		; no match files
?15:	stz	image		; flag	
	jsr	tstfd		; is an open file?
	bcc	?20		; yes - don't scratch
	ldx	drvnum
	lda	#$10
	bit	drvfg,x
	bne	?20		; disk write protect on - skip
	lda	[dirp]		; type & flags
	bpl	?20		; not properly closed - skip splat file
	bit	#$40
	bne	?20		; skip locked file
	and	#typmsk		; mask type
	cmp	#reltyp
	beq	?20		; skip rel files
	cmp	#partyp
	beq	?20		; skip part type
	lda	#$80		; candidate to be deleted
	sta	image
?20:	jsr	shownam		; show file name
	bit	image
	bpl	?25
	lda	#0
	sta	[dirp]		; delete entry
	jsr	wrdsec		; update dir on disk
	ldx	entfnd
	lda	filtrk,x	; get first t&s of file
	sta	track
	lda	filsec,x
	sta	sector
	jsr	delfil		; delete file by links
	inc	char		; update counter of scratched files
?25:	jsr	donemsg	
	jsr	ffre		; search next matching file
	bpl	?15		; more files
?30:	ldx	char
	stx	etrk		; report scratched file's #
	stz	esec
	lda	#1
	sta	lsterr		; not a true error
	stz	drvfg		; invalidate all drive's
	stz	drvfg+1
	rts

; delete file by link
; track & sector first t&s of the file
delfil:
	jsr	tread		; read whole track in cache
	jsr	setcp		; set cache ptr to right sector
?02:	jsr	frets		; free current t&s in bam
	ldy	#1
	lda	[bufp],y	; next sector
	tay
	lda	[bufp]		; next track
	beq	?10		; end of file
	sty	sector		; next sector
	cmp	track		; same track?
	sta	track
	bne	delfil		; will read a new track	
	clc
	tya
	ldx	drvnum
	adc	trkofs,x	; sector in the same track
	sta	bufp+1
	bra	?02		; follow link	
?10:	jmp	mapout		; update & write out bam

shownam:
	jsr	movnam
	pei	(wtmp)
	lda	#^nambuf
	pha
	pea	#!nambuf
	lda	drvnum
	pha
	phk
	pea	#!?100
	lda	#10
	pha
	BPRINTF
	rts

?100:	.DB	$0D, 'delete #%bu:%s (%04hu blocks):...', $00

; move directory entry to namebuf
; in:	X=index in file stream
movnamx:
	lda	fildrv,x	; set directory entry
	and	#1
	sta	drvnum
	phx
	jsr	sethdp
	plx
	lda	entsec,x
	clc
	adc	dirp+1
	sta	dirp+1		; set dir. pointer to file entry
	lda	entind,x
	sta	dirp

; move directory entry to namebuf 
movnam:
	jsr	blknb		; blank nambuf
	ldy	#29		;  & adjust spacing
	lda	[dirp],y	; hi blocks #
	sta	wtmp+1
	dey
	lda	[dirp],y	; low blocks #
	sta	wtmp
	ldx	#0		; file name start
	lda	#'"'
	sta	!nambuf
	ldy	#3
?04:	lda	[dirp],y
	and	#$7F
	sta	!nambuf+1,x
	inx
	iny
	cpx	#16
	bcc	?04
	lda	#'"'
	sta	!nambuf+1,x
	inx
	inx
	lda	[dirp]		; set type chars
	bmi	?06
	tay
	lda	#'*'		; file not closed: splat file
	sta	!nambuf+1,x
	tya
?06:	inx
	txy			; Y = nambuf index
	pha
	and	#typmsk
	tax			; X = file type
	lda	>typlst,x
	sta	nambuf+1,y
	iny
	lda	>tp1lst,x
	sta	nambuf+1,y
	iny
	lda	>tp2lst,x
	sta	nambuf+1,y
	iny
	tyx
	pla
	asl	a
	bpl	?08		; file not locked
	lda	#'<'
	sta	!nambuf+1,x	; file locked
?08:	inx
	stz	nambuf+1,x
	rts

;---------------------------------------------------------------------------
; new disk command (format)
;---------------------------------------------------------------------------

; quick format command
quickf:
	jsr	onedrv		; set just one drive/file ptr
	jsr	buildfn		; build canonical file names
	lda	#$C0
	bra	newdsk2
	
; standard cbm format command
newdsk:
	jsr	onedrv		; set just one drive/file ptr
	jsr	buildfn		; build canonical file names
	lda	#$80
newdsk2:
	sta	<qfmt		; assume no ID disk given => quick format
	lda	f1cnt		; saved total count
	cmp	#1
	beq	?06		; just disk name: quick format
	cmp	#2
	beq	?04		; given disk ID in filtab
?02:	jmp	e_badsyn	; error if more data
?04:	ldx	filtbl+1	; pointer to ID string
	jsr	fndlmt		; find string limit
	tya			; string size
	beq	?02		; empty string
	cmp	#3
	bcs	?02		; more than 2 char's
	ldx	filtbl+1
	lda	!cmdbuf,x
	jsr	?50		; check ID char: just alphanumeric
	sta	<idch1
	lda	!cmdbuf+1,x
	jsr	?50
	sta	<idch2
	lda	#$80
	trb	<qfmt		; clear bit 7: given ID in cmd string
?06:	lda	fildrv
	and	#1
	sta	drvnum
	tax
	stz	drvfg,x		; invalid drive
	jsr	dsktst		; check if disk is ready
	lda	#$10
	bit	drvfg,x		; disk write protect on?
	beq	?07		; no
	lda	#wpon
	jmp	cmderr	
?07:	FDCGETFMT		; query disk format
	bcs	?08		; unformatted or not recognized format
	tya			; format in bit 1,0
	cmp	#1
	bne	?08		; not the right format
	jsr	sysrd		; try to read system track
	bcs	?08		; error reading system track
	jsr	hdrtst		; test right dir. format
	bcc	?10		; ok, can be used quick format
	bit	<qfmt
	bmi	?09		; no ID given
	bvc	?20		; cbm standard: go to full format
	bra	?12		; quick format with given ID
?08:	bit	<qfmt		; here quick format not possible
	bpl	?20		; go to full format
?09:	lda	#fmter		; not given disk ID
	jmp	cmderr
?10:	bit	<qfmt
	bmi	?30		; no ID given so quick format
	bvc	?15		; standard cbm format: compare given ID
?12:	lda	<idch1		; quick format with given ID
	sta	!dskid1,x
	lda	<idch2
	sta	!dskid2,x
	bra	?30		; quick format
?15:	lda	<idch1		; now check given ID with disk ID
	cmp	!dskid1,x
	bne	?20		; unmatch: full format
	lda	<idch2
	cmp	!dskid2,x
	beq	?30		; match: quick format
?20:	lda	<idch1		; full format: start low level format
	sta	!dskid1,x	; store given disk ID
	lda	<idch2
	sta	!dskid2,x
	SCN_CR
	jsr	llfmt
	;SCN_CR
	bra	?31		; make empty file system
?30:	lda	drvnum		; quick format
	pha
	phk
	pea	#!?40
	lda	#5
	pha
	BPRINTF
?31:	jsr	sethdp		; make empty file system
	jsr	?60		; clear cache
	jsr	newmap		; create a new bam
	jsr	newhdr		; create a new header
	stz	bmpnt		; ptr to new bam
	inc	dirp+1		; set up bam
	INDEX16
	ldy	#$01FF		; transfer the new bam
?32:	lda	[bmpnt],y
	sta	[dirp],y
	dey
	bpl	?32
	INDEX08
	inc	dirp+1		; set up first dir block
	inc	dirp+1
	lda	#0
	sta	[dirp]		; null link
	ldy	#1
	dec	a
	sta	[dirp],y
	ldy	filtbl
?34:	lda	cmdbuf,y
	beq	?36
	bmi	?35
	iny
	bra	?34
?35:	lda	#0
	sta	cmdbuf,y
?36:	jsr	syswr		; write out system track
	stz	drvfg,x		; invalidate drive
	pei	(wtmp)
	lda	!dskid2,x
	pha
	lda	!dskid1,x
	pha
	lda	#^cmdbuf
	pha
	lda	#>cmdbuf
	pha
	lda	filtbl
	pha
	phk
	pea	#!?42
	lda	#11
	pha
	BPRINTF
	rts

?40:	.DB	$0D, 'Quick format diskette on drive #%bu - cbm 1581 format type', 0
?42:	.DB	$0D, 'Disk name: "%s", ID: "%c%c", total free blocks: %hu', 0

?50:	cmp	#'0'		; check ID
	bcc	?56
	cmp	#'9'+1
	bcc	?54
	cmp	#'A'
	bcc	?56
	cmp	#'Z'+1
	bcs	?56
?54:	rts
?56:	jmp	e_badsyn	; ID error 

?60:	CPU16			; clear system cache
	ldy	#$1400-2	; $1400 words
	lda	#0
?62:	sta	[dirp],y
	dey
	dey
	bpl	?62
	CPU08
	rts

;---------------------------------------------------------------------------
; rename command
;---------------------------------------------------------------------------
rename:
	jsr	alldrs		; set all drives/file ptr's
	jsr	buildfn		; build canonical file names
	lda	fildrv+1
	and	#1
	sta	fildrv+1
	eor	fildrv		; compare drive's #
	beq	?01		; ok, same drive
	lda	#notsam
	jmp	cmderr		; cannot rename across drives
?01:	jsr	lookup		; lookup for both file's
	jsr	chkfs1		; check fs1 and fs2
	ldx	#1		; check file name 2 not open
	jsr	tstopn		; cannot rename an open file
	lda	entsec+1	; set sector of dir entry for file 2
	sta	sector
	jsr	setdptr		; set ptr to dir cache
	lda	entind+1	; set pointer to entry
	sta	dirp
	lda	[dirp]		; get type and flags
	bit	#$40
	bne	?04		; locked file
	ldx	filtbl		; pointer to file 1 name
	ldy	#3		; pointer to file name on dir entry
?02:	lda	!cmdbuf,x	; move new file name
	beq	wrdsec		; end -- write out sector
	sta	[dirp],y
	inx
	iny
	bra	?02

?04:	lda	#flock
	jmp	cmderr
	
; check file 2 stream for existence (all should exist)
chkfs2:
	lda	pattyp+1	; 1st file bears type
	and	#typmsk
	sta	type
	ldx	f2cnt
?10:	dex
	cpx	f1cnt
	bcc	?20		; skip file in fs1 stream
	lda	filtrk,x
	bne	?10		; ok, exist - check next
	lda	#flntfd		; input file not found
	jmp	cmderr
?20:	rts

; check file 1 stream for non-existence (all should not exist)
chkfs1:
	jsr	chkfs2		; check fs 2 stream for existence
?25:	lda	filtrk,x	; check fs1 stream
	beq	?30
	lda	#flexst		; file exist
	jmp	cmderr
?30:	dex			; check next file
	bpl	?25
	rts

;---------------------------------------------------------------------------
; exist command - check file existance
;---------------------------------------------------------------------------
exist:
	jsr	onedrv		; set just one drive/file ptr
	jsr	buildfn		; build canonical file names
	jsr	lookup		; lookup for file
	lda	filtrk
	bne	gtx		; ok
	lda	#flntfd
	jmp	cmderr

;---------------------------------------------------------------------------
; lock command - set lock bit in file type (set read only file)
;---------------------------------------------------------------------------
lock:
	jsr	gettyp		; set dir entry ptr & get file type
	bit	#$40		; test lock bit
	bne	gtx		; already locked, done
	tay			; save type
	jsr	wptst		; check if write protect
	ldx	#0		; check file not open
	jsr	tstopn		; cannot do in an open file
	tya			; restore type
	ora	#$40		; set lock bit
	sta	[dirp]
	
	; write out sector

; write given directory sector on disk
wrdsec:
	lda	#1		; write out just 1 sec
	jmp	wrsys

; find file, set dir pointer, get file type & flag
gettyp:
	jsr	exist		; file exist in dir entry?
	lda	entsec		; set sector of dir entry
	sta	sector
	jsr	setdptr		; set ptr to dir cache
	lda	entind		; set pointer to entry
	sta	dirp
	lda	[dirp]		; get type and flags
gtx:	rts

; abort if disk is write protect
wptst:
	ldx	drvnum
	lda	#$10
	bit	drvfg,x
	beq	gtx		; ok, no write protect
	lda	#wpon		; write protect on
	jmp	drverr

;---------------------------------------------------------------------------
; unlock command - clear lock bit in file type
;---------------------------------------------------------------------------
unlock:
	jsr	gettyp		; set dir entry ptr & get file type
	bit	#$40		; test lock bit
	beq	gtx		; already unlocked, done
	tay			; save type
	jsr	wptst		; check if write protect
	ldx	#0		; check file not open
	jsr	tstopn		; cannot do in an open file
	tya			; restore type
	and	#$BF		; reset lock bit
	sta	[dirp]
	bra	wrdsec		; write out sector

;---------------------------------------------------------------------------
; transfer command (copy file from ibm-dos disk)
;---------------------------------------------------------------------------
transf:
	lda	#$40
	sta	fildrv+1	; source drive is dos drive !
	jsr	alldrs
	lda	fildrv+1	; dos drive will be in command string
	bmi	?02		; no drive in cmd string
	and	#7
	cmp	fildrv		; will be not the same
	bne	?04		; ok
?02:	jmp	e_baddrv
?04:	jsr	buildfn		; build canonical file names
	lda	#$40
	trb	fildrv+1
	rts

;---------------------------------------------------------------------------
; move command (copy file to ibm-dos disk)
;---------------------------------------------------------------------------
move:
	lda	#$40
	sta	fildrv		; dest drive is dos drive !
	jsr	alldrs
	lda	fildrv+1	; cbm drive will be in command string
	bmi	?02		; no drive in cmd string
	lda	fildrv
	and	#7
	cmp	fildrv+1	; will not be the same
	bne	?04		; ok
?02:	jmp	e_baddrv
?04:	jsr	buildfn		; build canonical file names
	lda	#$40
	trb	fildrv
	rts

;---------------------------------------------------------------------------
; append command
;---------------------------------------------------------------------------
append:
	jsr	alldrs		; set all drives/file ptr's
	jsr	buildfn		; build canonical file names
	lda	 #$40
	sta	subcmd		; flag concat
	jsr	lookup		; look up all files
	ldx	fildrv		; test if dest drive is wp on
	lda	#$10
	bit	drvfg,x
	beq	?04
	lda	#wpon
	jmp	cmderr
?04:	lda	filtrk
	bne	?06		; ok, dest file exist
	lda	#flntfd
	jmp	cmderr
?06:	ldx	#0		; dest file will not be open
	jsr	tstopn
	ldx	#1
	jsr	tstdup		; check recursive concat
	jsr	chkfs2		; check if fs2 exist
	jsr	tstfs2		; check not open
	ldx	f2cnt		; fs1 & fs2 seq type only
?08:	dex			; index
	bmi	?14
	lda	pattyp,x
	bit	#$20
	bne	?12		; error: splat file
	and	#typmsk
	cmp	#seqtyp
	bne	?10		; error: mismatch type
	bra	?08
?10:	lda	#mistyp		; file type mismatch
	jmp	cmderr
?12:	lda	#fsplt		; error: write file not closed
	jmp	cmderr	
?14:	lda	pattyp		; dest file is locked?
	bit	#$40
	beq	?16		; no
	lda	#flock		; error: locked file
	jmp	cmderr
?16:	and	#typmsk
	sta	type
	jsr	movdst		; set up dest file name
	jsr	skend		; seek end: prepare for append
	ldx	#1
	jsr	cat		; concat fs2 to fs1
	ldx	fildrv		; invalidate dest drive...
	stz	drvfg,x		; ...so force init next time
	rts

;---------------------------------------------------------------------------
; copy command
;
;	Cddr=sdr		; copy all files from sdr to ddr (not same dr)
;	Cddr:[*]=sdr:[*]	; copy all files from sdr to ddr (not same dr)
;	Cddr:[*]=sdr:fname	; copy sdr:fname to ddr:fname (not same drive)
;	Cddr:dest=[sdr:]fname	; copy sdr:fname to ddr:dest
;	Cddr:dest=[sdr1:]fname1,[sdr2:]fname2,[sdr3:]fname3,[sdr4:]fname4
;---------------------------------------------------------------------------
copy:
	jsr	prscpy		; parse cmd string
	jsr	buildfn		; build canonical file names
	bit	pattyp		; dest file is '*' ?
	bpl	?02
	jmp	cpall		; yes - copy disk-to-disk
?02:	stz	subcmd		; flag copy+cat
	jsr	lookup		; look up all files
	ldx	fildrv		; test if dest drive is wp on
	lda	#$10
	bit	drvfg,x
	beq	?04
	lda	#wpon
	jmp	cmderr
?04:	lda	f2cnt
	cmp	#3		; just copy f2 to f1?
	bcc	?20		; yes
	lda	fildrv+1	; now test if first file of fs2 stream...
	and	#1
	cmp	fildrv		; ...is the same of the file on fs1 stream
	bne	?20		; must create dest file
	lda	entind
	cmp	entind+1
	bne	?20		; must create dest file
	lda	entsec
	cmp	entsec+1
	bne	?20		; must create dest file

	; file1=file2 so append file3,file4... to file1		
	; all files in fs2 stream will exist and will not be open
	ldx	#2
	jsr	tstdup		; check recursive concat
	jsr	chkfs2		; check if fs2 exist
	jsr	tstfs2		; check not open
	lda	type		; this is file1=file2 type
	cmp	#seqtyp		; just seq. tipe can be concat.
	beq	?06
?05:	lda	#mistyp		; file type mismatch
	jmp	cmderr
?06:	jsr	movdst		; set up dest file name
	lda	pattyp		; dest file is locked?
	bit	#$40
	beq	?08		; no
	lda	#flock		; error: locked file
	jmp	cmderr
?08:	bit	#$20		; splat file?
	beq	?10		; no
?09:	lda	#fsplt		; error: write file not closed
	jmp	cmderr	
?10:	jsr	?70		; check all files f3..fn (seq type, no splat)	
	jsr	skend		; seek end: prepare for append
	ldx	#2
	bra	?24

?20:	; file1 should be created, then copy file2 to file1 and concat...
	; ...file3,file4... to file1 (if type is seq)
	jsr	chkfs1		; fs1 should not exist, fs2 all should exist
	jsr	tstfs2		; check fs2 not open
	jsr	movdst		; set up dest file name
	lda	pattyp+1
	bit	#$20		; file1 will not be splat
	bne	?09		; error: source file is splat file
	and	#typmsk	
	cmp	#reltyp
	beq	?05		; skip rel files
	cmp	#partyp
	beq	?05		; skip part type
	jsr	?70		; check all files f3..fn (seq type, no splat)
	jsr	setwrf		; ok, create dest file
	ldx	#1
?24:	jsr	cat		; copy/concat
	ldx	fildrv		; invalidate dest drive...
	stz	drvfg,x		; ...so force init next time
	rts

?70:	; check f3..fn: must be just seq. type and no splat
	ldx	f2cnt
	cpx	#3
	bcc	?74		; skip this test if just 2 files
?72:	dex			; index
	cpx	#2
	bcc	?74
	lda	pattyp,x
	bit	#$20
	bne	?09		; error: splat file
	and	#typmsk
	cmp	#seqtyp
	bne	?05		; error: mismatch type
	bra	?72
?74:	rts

; check file 2 stream for open (all should not be open) (80)
tstfs2:
	ldx	f2cnt
?82:	dex
	cpx	f1cnt
	bcc	?84		; skip file in fs1 stream
	stx	entfnd
	jsr	tstopn
	ldx	entfnd
	bra	?82
?84:	rts

; in fs2 stream will not be th dest file
; in:	X=index of start test
tstdup:
	lda	fildrv,x
	and	#1
	cmp	fildrv
	bne	?06
	lda	filtrk,x
	cmp	filtrk
	bne	?06
	lda	filsec,x
	cmp	filsec
	beq	?10		; match
?06:	inx
	cpx	f2cnt
	bcc	tstdup
	rts
?10:	lda	#badcat		; recursive concat
	jmp	cmderr

; move first file name to namebuf2 (90)
movdst:
	ldx	#0		; file name start
	lda	#'"'
	sta	!nambuf2
	ldy	filtbl
?94:	lda	!cmdbuf,y
	and	#$7F
	sta	!nambuf2+1,x
	inx
	iny
	cpx	#16
	bcc	?94
	lda	#'"'
	sta	!nambuf2+1,x
	stz	!nambuf2+2,x
	rts

; copy disk-to-disk (with pattern, no concat)
cpall:
	lda	#$80
	sta	subcmd		; flag disk-to-disk copy
	lda	fildrv
	and	#1
	sta	fildrv
	sta	fildrv+2	; save dest drive
	lda	fildrv+1
	and	#1
	sta	fildrv+1
	lda	filtbl
	sta	filtbl+2	; save file name 1 ptr
	jsr	optsch		; init all drive's
	stz	tgflg		; search just one drive
	lda	fildrv+1
	sta	drvnum		; search just in src. drive
	sta	fildrv
	lda	filtbl+1
	sta	filtbl
	lda	#1
	sta	f1cnt
	sta	f2cnt		; fake: just one file in stream!
	jsr	ffst		; start search on src drive
	bmi	?20		; no files
?02:	stz	image		; flag
	stz	entfnd		; file is in fs1 stream!
	jsr	tstfd		; is an open file?
	bcc	?04		; yes - don't copy
	ldx	fildrv+2
	lda	#$10
	bit	drvfg,x
	bne	?04		; dest disk write protect on - skip	
	lda	[dirp]		; type & flags
	sta	pattyp+3
	bpl	?04		; not properly closed - skip splat file
	and	#typmsk		; mask type
	cmp	#reltyp
	beq	?04		; skip rel files
	cmp	#partyp
	beq	?04		; skip part type
	lda	#$80		; candidate to be copied
	sta	image
?04:	jsr	?50		; lookup dest drive for file
	ldx	#1		; set up one read file
	stx	f2ptr
	jsr	?30		; create & copy
?10:	jsr	?80		; set back search data for src drive	
	jsr	ffre		; search next matching file
	bpl	?02		; more files
	ldx	fildrv+2	; invalidate dest drive...
	stz	drvfg,x		; ...so force init next time
?20:	rts

	; create dest file and copy one file
?30:	jsr	cpymsg		; show message
	bit	image		; skip?
	bpl	?34		; yes
	jsr	setwrf		; setup write file (create)
	jsr	setrdf		; setup read file
?32:	jsr	bufget		; loop copy (buffered)
	jsr	bufput
	lda	rdeof
	beq	?32		; no eof
	jsr	clswrf		; close dest file
?34:	jmp	donemsg

?50:	jsr	movnam		; fill name buffer with src file
	bit	image
	bpl	?54		; skip this file
	lda	filtrk		; save search data for file name 2
	sta	filtrk+1
	lda	filsec
	sta	filsec+1
	lda	entsec
	sta	entsec+1
	lda	entind
	sta	entind+1
	lda	pattyp
	sta	pattyp+1
	stz	filtrk		; set search data for file name 1
	stz	filsec
	stz	entsec
	stz	entind
	stz	pattyp
	lda	fildrv+2	; restore dest drive
	sta	fildrv
	sta	drvnum
	ldx	filtbl+2	; restore file name 1 ptr
	stx	filtbl
	ldy	#3		; move the entry name to file name 1
?52:	lda	[dirp],y
	sta	!cmdbuf,x
	inx
	iny
	cpy	#19
	bcc	?52
	lda	#1		; now lookup file name on dest drv
	sta	f1cnt
	sta	f2cnt		; fake: just one file in stream!
	jsr	lookup2
	lda	#1		; restore real situation
	sta	f1cnt
	inc	a
	sta	f2cnt
	lda	pattyp+3
	and	#typmsk
	sta	type		; file type for copied file
	lda	filtrk		; check if dest file already exist
	beq	?54		; ok
	stz	image		; can't copy this file
	stz	type
?54:	rts

?80:	stz	filtrk		; set search data for file name 2
	stz	filsec
	stz	entsec
	stz	entind
	lda	fildrv+1
	sta	drvnum		; search in src. drive
	sta	fildrv
	lda	filtbl+1
	sta	filtbl
	lda	#1
	sta	f1cnt
	sta	f2cnt		; fake: just one file in stream!
	rts

; copy/concat
; in:	X=index of first file to concat
cat:
	lda	#$80
	sta	image		; assume all good
?102:	stx	f2ptr		; start file
	jsr	movnamx		; set up file name in nambuf
	jsr	cpymsg		; show message
	jsr	setrdf		; setup read file
?104:	jsr	bufget		; loop copy
	jsr	bufput
	lda	rdeof
	beq	?104		; no eof
	jsr	donemsg
	ldx	f2ptr		; concat more file, if any
	inx
	cpx	f2cnt
	bcc	?102		; append
	;jmp	clswrf

; close write file when finish to copy
clswrf:
	lda	entsec		; set dir. ptr to dest file
	sta	sector
	ldy	#dirtrk
	sty	track
	ldx	wrdrv
	stx	drvnum
	jsr	sethdp
	clc
	adc	sector
	sta	dirp+1		; set dir. pointer to file entry
	lda	entind
	sta	dirp
	lda	[dirp]		; set flag closed file
	ora	#$80
	sta	[dirp]
	ldy	#28		; store block's #
	ACC16
	lda	wcnt
	inc	a		; take in account last block
	sta	[dirp],y
	ACC08
	jsr	mapout		; check&update bam on disk
	lda	sector
	cmp	#4		; dir sec already updated with bam?
	bcc	?02		; yes
	jsr	wrdsec		; update directory
?02:	rts

; setup write file
setwrf:
	lda	fildrv		; drive #
	and	#1
	sta	wrdrv
	sta	drvnum
	stz	sector
	lda	#dirtrk
	sta	track
	jsr	sethdp
	jsr	addfil		; create file in directory
	ldy	filtrk		; take first t&s
	sty	track
	lda	filsec
	sta	sector
	sta	wsec		; current write sector
	sta	wfirst		; this is first sector
	jsr	wread		; pre-read whole track
	jsr	setwb		; set wbuf pointer
	lda	#2
	sta	wridx		; start index
	stz	wcnt		; clear block's count
	stz	wcnt+1
	rts

; setup read file
setrdf:
	ldx	f2ptr		; index=1..n-1
	lda	fildrv,x
	and	#1
	sta	drvnum
	sta	rddrv
	ldy	filtrk,x	; first t&s of file
	sty	track
	lda	filsec,x
	sta	sector
	jsr	tread		; read whole track
	jsr	setcp		; set bufp pointer
	stz	rdlst		; assume full block
	ldy	#1
	lda	[bufp],y
	tay
	lda	[bufp]
	bne	?04
	sty	rdlst		; last byte pointer
?04:	stz	rdeof
	lda	#2
	sta	rdidx
	rts

; seek end: open file and put pointer to last byte of file
; use write cache for append
skend:
	lda	fildrv
	and	#1
	sta	wrdrv		; set up write drv
	sta	drvnum
	lda	entsec		; set dir ptr to entry
	sta	sector
	ldy	#dirtrk
	sty	track
	jsr	sethdp
	clc
	adc	sector
	sta	dirp+1		; set dir. pointer to file entry
	lda	entind
	sta	dirp
	lda	[dirp]		; clear flag closed file
	and	#$7F
	sta	[dirp]
	jsr	wrdsec		; update dir on disk
	lda	filtrk
	sta	track
	lda	filsec
	sta	sector
	stz	wcnt
	stz	wcnt+1
?02:	jsr	wread		; read whole track in write cache
	jsr	setwb		; set cache ptr to right sector
?04:	inc	wcnt
	bne	?06
	inc	wcnt+1
?06:	ldy	#1
	lda	[wbuf],y	; next sector
	tay
	lda	[wbuf]		; next track
	beq	?10		; end of file
	sty	sector		; next sector
	cmp	track		; same track?
	sta	track
	bne	?02		; will read a new track	
	clc
	tya
	ldx	drvnum
	adc	wrtofs,x	; sector in the same track
	sta	wbuf+1
	bra	?04		; follow link	
?10:	iny			; bump pointer	
	sty	wridx		; start index for append
	lda	sector
	sta	wsec		; current write sector
	sta	wfirst		; this is first sector
	ACC16
	dec	wcnt		; append !!
	ACC08
	rts

; show message while copy/concat
cpymsg:
	bit	subcmd
	bpl	?02		; copy/concat
	
	; show msg while disk-to-disk copy
	lda	fildrv		; dest drive
	and	#1
	pha	
	pei	(wtmp)		; block's count #
	lda	#^nambuf
	pha
	pea	#!nambuf
	lda	fildrv+1	; source drive
	and	#1
	pha
	phk
	pea	#!?20
	lda	#11		; params #
	pha
	BPRINTF
	rts

	; show msg while copy/concat
?02:	lda	#^nambuf	; dest file name
	pha
	pea	#!nambuf2
	lda	fildrv		; dest drive
	and	#1
	pha	
	pei	(wtmp)		; block's count #
	lda	#^nambuf
	pha
	pea	#!nambuf
	lda	fildrv+1	; source drive
	and	#1
	pha
	phk			; string bank
	bit	subcmd
	bvs	?04		; always append
	ldx	f2ptr
	cpx	#2
	bcs	?04		; append
	pea	#!?30		; copy
	bra	?06
?04:	pea	#!?40
?06:	lda	#14		; params #
	pha
	BPRINTF
	rts

?20:	.DB	$0D, 'copy #%bu:%s (%04hu blocks) to drive #%bu:...', $00
?30:	.DB	$0D, 'copy #%bu:%s (%04hu blocks) to #%bu:%s...', $00
?40:	.DB	$0D, 'cat  #%bu:%s (%04hu blocks) to #%bu:%s...', $00

donemsg:
	lda	#>?10
	xba
	lda	#<?10
	bit	image
	bpl	?02		; skip
	lda	#>?20
	xba
	lda	#<?20
?02:	ldx	#^?10
	SCNSTROUT
	rts

?10:	.DB	'skip.', 0
?20:	.DB	'done.', 0

;---------------------------------------------------------------------------
; validate/file check command's
;---------------------------------------------------------------------------
; check file system but without change it
fcheck:
	jsr	initd
	ldy	#$00
	bra	vdate1

; check file system and change it
vdate:
	jsr	initd
	ldx	drvnum
	ldy	#$80		; update file system
	lda	drvfg,x
	bit	#$08		; test if new version
	beq	?10		; only check without correct in old version
	bit	#$10		; write protect on?
	beq	vdate1		; no -- proceed
?10:	ldy	#$00		; check only -- no update

vdate1:
	sty	wrop
	lda	drvnum
	pha
	phk
	bit	wrop
	bmi	?02
	pea	#!?60
	bra	?03	
?02:	pea	#!?70
?03:	lda	#5
	pha
	BPRINTF
	jsr	newmap		; set new aux bam
	stz	delind
	ACC16
	lda	#maxblks	; max. available block's
	sta	ntot		; updated in aux bam
	sta	bcnt		; updated in file check
	ACC08
	jsr	srchst		; search first file
	beq	?10		; end search

?04:	jsr	chkfil		; found one - check
	jsr	srre		; next entry
	bne	?04
	jsr	chkdir
?10:	jsr	updbam
	ldx	drvnum
	stz	drvfg,x
	rts

?60:	.DB	$0D, 'check file system on drive #%bu (without changes).', 0
?70:	.DB	$0D, 'validate file system with bam on drive %bu.', 0

;---------------------------------------------------------------------------
; initialize command
;---------------------------------------------------------------------------
initd:
	lda	cmdsiz
	cmp	#3
	bcc	?02
	jmp	e_badsyn
?02:	jsr	simprs	
	ldx	drvnum		; force init
	stz	drvfg,x
	jmp	drvint

;---------------------------------------------------------------------------
; duplicate command
;---------------------------------------------------------------------------
dupd:
	jsr	prsdtd		; check src & dst drive
	lda	fildrv+1
	and	#1
	sta	drvnum
	sta	fildrv+1
	eor	#$01
	sta	char
	jsr	drvint		; init source drive
	jsr	togdrv		; toggle drive
	jsr	dsktst		; check if dest drive is ready
	ldx	drvnum
	lda	#$10		; test if write protect
	bit	drvfg,x
	beq	?04
	lda	#wpon
	jmp	drverr
?04:	SCN_CR
	jsr	llfmt		; format dest. drive
	SCN_CR
	lda	#1
	sta	track		; track counter
	stz	sector
	SCNGETPOS
	stx	wtmp
	sty	wtmp+1
?10:	ldx	wtmp
	ldy	wtmp+1
	SCNSETPOS
	lda	drvnum
	pha			; dest drive
	lda	fildrv+1
	pha			; src drive
	lda	track
	pha
	phk			; bank of format str
	pea	#!?100		; address of format str
	lda	#7		; # params
	pha
	BPRINTF	
	ldx	char		; 0 if drive 1, 1 if drive 0
	lda	trkbuf,x	; A=dma buffer #	
	ldx	fildrv+1	; X=src drive
	jsr	readtk		; read whole track
	ldx	char		; 0 if drive 1, 1 if drive 0
	lda	trkbuf,x	; A=dma buffer #	
	ldx	drvnum		; X=dest drive
	jsr	writetk		; write whole track
	inc	track
	lda	track
	cmp	#maxtrk
	bcc	?10
	SCN_CR
	ldx	drvnum
	stz	drvfg,x		; invalid drive
	jmp	drvint		; init dest drive

?100:	.DB	'copy track #%02bu from drive #%bu to drive #%bu', $00

;---------------------------------------------------------------------------
; block-op commands
;---------------------------------------------------------------------------

; U1 & U2 commands
; U1 is the same of B-R and U2 is the same of B-W
; U1: ch dr trk blk
; U1: ch,dr,trk,blk
; U2: ch dr trk blk
; U2: ch,dr,trk,blk
blku:
	lda	!cmdbuf+1
	dec	a
	cmp	#'0'
	beq	?02
	cmp	#'1'
	bne	e_badcmd2
?02:	and	#$01
	tax			; X=0 => R, X=1 => W
	ldy	#$02		; index next char
	bra	blkprs

e_badcmd2:
	jmp	e_badcmd

e_badsyn2:
	jmp	e_badsyn

; block-op commands
; B-R: ch dr trk blk
; B-R: ch,dr,trk,blk
; B-W: ch dr trk blk
; B-W: ch,dr,trk,blk
; B-A: dr trk blk
; B-A: dr,trk,blk
; B-F: dr trk blk
; B-F: dr,trk,blk
; B-P: ch pos
; B-P: ch,pos
blkb:
	lda	!cmdbuf+1
	cmp	#'-'		; subcommands seperator
	bne	e_badsyn2
	ldx	#ncmds2-1
	lda	!cmdbuf+2
	beq	e_badsyn2	; syntax error if no more char's
?02:	cmp	>cmdstb,x	; match subcommand
	beq	?04
	dex
	bpl	?02
	bmi	e_badcmd2	; error
?04:	ldy	#3		; index next char

; common routine for block-op
; X=0 => R, X=1 => W, X=2 => A, X=3 => F, X=4 => P
blkprs:
	stx	subcmd		; subcommand
	lda	cmdbuf,y	; must be seperator
	cmp	#':'
	bne	e_badsyn2
?02:	iny
	lda	cmdbuf,y
	beq	e_badsyn2	; end of string is an error here
	cmp	#' '		; skip blanks after semicolon
	beq	?02
	ldx	#$FF		; table index
?04:	inx
	cpx	#mxfils-1
	bcs	e_badsyn2	; full param's table
	jsr	asc2bin		; convert ascii to byte and put in table
	dey
?06:	iny	
	lda	cmdbuf,y	; loop for param's parsing
	beq	?08		; end parsing
	cmp	#' '		; skip blank seperator
	beq	?06
	cmp	#','		; skip comma seperator
	beq	?06
	bne	?04		; parse next digit
?08:	inx
	stx	f1cnt		; param's counter
	lda	#4		; 4 param's for R, W (0 & 1)
	ldy	subcmd
	beq	?10
	dey
	beq	?10
	dec	a		; 3 param's for A, F (2 & 3)
	dey
	beq	?10
	dey
	beq	?10
	dec	a		; 2 param's for P (4)
?10:	sta	tmpxxx
	cpx	tmpxxx
	bne	e_badsyn2	; wrong param's count
	ldy	subcmd
	cpy	#4
	bcs	?14		; skip drive check for P subcmd	
	ldx	#1		; for R,W second param is drive number
	cpy	#2
	bcc	?12
	dex			; for A,F first param is drive number
?12:	lda	filsec,x	; check drive number
	cmp	#2
	bcs	e_baddrv
	sta	drvnum
?14:	cpy	#2		; check channel # for R(0),W(1),P(4)
	bcc	?16
	cpy	#4
	bne	?18
?16:	lda	filsec		; channel # is first param
	cmp	#2		; valid channel: 2..14
	bcc	e_badchn
	cmp	#15
	bcs	e_badchn
	sta	chnl
?18:	cpy	#4
	beq	?22		; skip trk & sec check for P subcmd
	ldx	#1		; trk for A, F
	cpy	#2
	bcs	?20
	inx			; trk for R, W
?20:	lda	filsec,x
	sta	track
	beq	e_badts
	cmp	#maxtrk
	bcs	e_badts
	inx			; check sector #
	lda	filsec,x
	sta	sector
	cmp	#numsec
	bcs	e_badts
?22:	tya
	asl	a
	tax
	jmp	(scjmp,x)

e_baddrv:
	lda	#baddrv
	jmp	drverr

e_badchn:
	lda	#badchn
	jmp	chnerr

e_badts:
	lda	#badts
	jmp	doserr

; check drive number in A
; in:	A = digit drive number ('0', '1', ...)
;	Y = 0 if check cbm drive (just 0,1)
;	Y = $FF if check dos drive (0..7)
; out:	A = drive number (0, 1, ...)
chkdrv:
	cmp	#'0'		; drive 0 and 1 always valid
	beq	?02
	cmp	#'1'
	beq	?02
	iny			; not zero if check cbm drive
	bne	e_baddrv	; invalid cbm drive
	cmp	#'8'
	bcs	e_baddrv	; valid dos drive: 0..7
	cmp	#'0'
	bcc	e_baddrv
	sbc	#'0'
	cmp	#MAXDOSDRV
	bcs	e_baddrv	
	rts
?02:	and	#$01
	rts

; convert ascii string to byte
; in:	A = first digit
;	X = table index
;	Y = cmdbuf index
; out:	X = table index
;	Y = index of first not-digit
asc2bin:
	stz	tmpxxx		; partial value
	cmp	#'0'		; first char must be a digit
	bcc	?08
	cmp	#'9'+1
	bcs	?08
?02:	sbc	#'0'-1		; convert digit (here always CF = 0)	
	xba			; B = digit
	clc
	lda	tmpxxx		; partial null?
	beq	?04		; yes, skip mult * 10
	cmp	#26		; this value make overflow
	bcs	?08
	asl	a		; safety multiply * 10
	asl	a
	adc	tmpxxx
	asl	a		; always carry = 0 here
	sta	tmpxxx
?04:	xba	
	adc	tmpxxx
	bcs	?08		; overflow
	sta	tmpxxx
	iny			; next char
	lda	cmdbuf,y
	cmp	#'0'		; continue conversion if next char is a digit
	bcc	?06
	cmp	#'9'+1
	bcc	?02
?06:	lda	tmpxxx		; store value in table
	sta	filsec,x
	rts

?08:	jmp	e_badsyn

; block read
blkrd:
	jsr	tstda		; check direct access fd type
	jsr	dskbuf		; set tlp ptr to buffer return X=drive...
	
	; param's in reverse order
	lda	sector
	pha
	lda	track
	pha
	lda	drvnum
	pha
	lda	chnl
	pha
	lda	#^?01
	pha
	pea	#!?01
	lda	#8		; num params
	pha
	BPRINTF


	jsr	readsec
	lda	sector
	lsr	a
	bcc	?02
	inc	tlp+1		; odd sector
?02:	ldy	#0
?04:	lda	[tlp],y
	sta	[bufp],y
	iny
	bne	?04
	;rts
	lda	pbuf
	pha
	lda	tlp+2
	pha
	pei	(tlp)
	lda	bufp+2
	pha
	pei	(bufp)
	phk
	pea	#!?10
	lda	#11
	pha
	BPRINTF	
	rts
?01:
	.DB	$0D, 'B-R: chnl=%bd, drive=%bd, track=%bd, sector=%bd', 0
?10:	.DB	$0D, 'bufp: %P, tlp: %P, DMA: %bX', 0

; block write
blkwr:
	; param's in reverse order
	lda	sector
	pha
	lda	track
	pha
	lda	drvnum
	pha
	lda	bchn
	pha
	lda	#^?01
	pha
	pea	#!?01
	lda	#8		; num params
	pha
	BPRINTF
	rts
?01:
	.DB	'B-W: chnl=%bd, drive=%bd, track=%bd, sector=%bd', 0

; block allocate sector
blkalc:
	; param's in reverse order
	lda	sector
	pha
	lda	track
	pha
	lda	drvnum
	pha
	lda	#^?01
	pha
	pea	#!?01
	lda	#7		; num params
	pha
	BPRINTF
	rts
?01:
	.DB	'B-A: drive=%bd, track=%bd, sector=%bd', 0

; block free sector
blkfree:
	; param's in reverse order
	lda	sector
	pha
	lda	track
	pha
	lda	drvnum
	pha
	lda	#^?01
	pha
	pea	#!?01
	lda	#7		; num params
	pha
	BPRINTF
	rts
?01:
	.DB	'B-F: drive=%bd, track=%bd, sector=%bd', 0

; block set buffer position
; pos is in filsec+1
blkpos:

	; param's in reverse order
	lda	filsec+1
	pha
	lda	bchn
	pha
	lda	#^?01
	pha
	pea	#!?01
	lda	#6; num params
	pha
	BPRINTF
	rts
?01:
	.DB	'B-P: chnl=%bd, pos=%bu', 0

; check that chnl is open and direct type access
tstda:
	jsr	isopn		; check chn is open
	jsr	fnddafd		; check is direct access type
	bcs	?10
	jmp	setfdp		; set buffer for this fd & return X=lindx
?10:	lda	#mistyp
	jmp	chnerr		; file type mismatch

; set buffer pointer for block-read / block-write
; buffer is after dir. cache of the selected drive
; set tmpxxx to dma buffer #
; set Y=wtmp to phisycal sector
; set pside to side
dskbuf:
	jsr	drvint		; init drive
	ldx	drvnum		; set buffer ptr
	stx	pdrv
	lda	sysbuf,x	; dma # of dir. cache
	clc
	adc	#phisec*2
	inc	a
	adc	lindx
	sta	pbuf
	ldy	#DMABNK		; bank for buffer #00..#7F
	asl	a		; get high pointer
	bcc	?02
	iny			; next bank
?02:	stz	tlp
	sta	tlp+1
	sty	tlp+2
	lda	sector		; 0..39
	lsr	a		; 0..19
	ldy	#0		; side 0
	cmp	#phisec		; 0..9 -> side 0, 10..19 -> side 1
	bcc	?04
	sbc	#phisec
	iny			; side 1
?04:	inc	a		; A = phisycal sec
	sta	psec
	sty	pside
	lda	#1
	sta	pcnt
	rts

;---------------------------------------------------------------------------
; names string utilities
;---------------------------------------------------------------------------

; build canonical file name's table
; check for empty or too long file name
; check for not allowed char's in file name
; convert '*' in right number of '?'
; pad file name with $A0
buildfn:
	ldx	#0
	lda	#<fntab		; set ptr to first file name
	sta	tlp
	lda	#>fntab
	sta	tlp+1
?02:	stx	f1ptr		; table index
	lda	fildrv,x
	sta	tmpxxx		; ibm/dos drive flag (bit 6)
	lda	filtbl,x
	tax			; pointer to string
	jsr	fndlmt		; find string limit
	tya			; string size
	bne	?03
	jmp	e_nofile	; empty: no file given error
?03:	bit	tmpxxx
	bvs	?18		; canonical ibm/dos file name
	cmp	#17
	bcs	?08		; too long: badfn error
	lda	!cmdbuf,x	; check if string start with blank
	cmp	#' '
	beq	?08		; first char is blank: badfn error
	ldy	#0		; store canonical file name
?04:	lda	!cmdbuf,x
	beq	?12		; end of string
	stx	char
	ldx	#nbadch-1	; check forbidden char's in file name
?06:	cmp	>badchr,x
	beq	?08		; bad char: badfn error
	dex
	bpl	?06
	ldx	char
	cmp	#'*'		; special char
	beq	?10		; handle star char
	sta	(tlp),y		; store char
	inx
	iny
	bra	?04		; loop
?08:	lda	#badfn		; badfn error
	jmp	cmderr
?10:	lda	#'?'		; fill residual name with '?'
	bra	?14
?12:	lda	#$A0		; pad name with $A0
?14:	dey
?16:	iny
	cpy	#16
	bcs	?17
	sta	(tlp),y
	bra	?16
?17:	lda	#0		; string terminator
	sta	(tlp),y
	iny			; offset to add for next string	
	clc
	bra	?20
?18:	jsr	dosfn		; handle dos file name
	bcs	?08		; bad dos file name
?20:	lda	tlp		; set new file name pointer
	ldx	f1ptr
	sta	filtbl,x
	tya
	adc	tlp		; here always CF = 0
	sta	tlp		; always stay in the same page !
	inx			; next file name
	cpx	f2cnt
	bcc	?02
	rts

; get canonical name of dos file name
dosfn:
	dex			; store 'X:' at beginning
	dex
	lda	tmpxxx
	and	#7
	clc
	adc	#'A'		; convert in drive letter
	sta	!cmdbuf,x
	lda	#':'
	sta	!cmdbuf+1,x	; check name type A:/xxx...
	lda	#0		; bank of src string
	pha
	lda	#>cmdbuf
	pha			; pointer of source string
	lda	#<cmdbuf
	stx	char
	adc	char		; add offset
	pha
	lda	#0		; bank of dest string
	pha
	pei	(tlp)		; dest string pointer
	lda	#$80
	pha			; fileflag (file)
	TRUENAM			; get canonical name (sys call)
	ldy	#80		; offset to add for next string	
	rts

; find string limit in cmdbuf pointed to by X
; in:	X = string pointer
; out:	X = string pointer
;	Y = string size
fndlmt:
	phx			; save ptr
	ldy	#0		; string size
?02:	lda	!cmdbuf,x
	beq	?06		; end of string
	cmp	#','
	beq	?04		; 'comma' limited
	cmp	#'='
	beq	?04		; 'equal' limited
	iny
	inx
	bra	?02		; loop next char
?04:	stz	!cmdbuf,x	; string limit
?06:	plx			; restore ptr
	rts

;---------------------------------------------------------------------------
; parse command string utilities
;---------------------------------------------------------------------------

; special case: parse command string for copy command
prscpy:
	jsr	prscln		; find ":"
	bne	?20		; ok, found ":"
	jsr	prsdtd		; look for "Cddrv=sdrv"
?10:	ldx	#cmdlen-2
	lda	#'*'		; put "*" at buffer end
	sta	!cmdbuf,x
	stz	!cmdbuf+1,x
	stx	filtbl+1	; file2 ptr -> "*"
	stx	filtbl		; file1 ptr -> "*" 
	lda	#$80
	sta	pattyp+1	; file2 pattern flag	
?14:	ldx	#1		; set up cnt's
	stx	f1cnt
	inx
	stx	f2cnt
	lda	#$80		; file1 pattern flag
	sta	pattyp
	rts
?20:	jsr	tagcmd2		; continue normal parsing
	jsr	alldrs		; put drv's in filtbl
	lda	image		; get parse image
	and	#%01010101	; mask off copy (fs1 & fs2 just one file)
	bne	?30		; concat
	
	; now parse string "ddrv:file1=sdrv:file2"
	ldx	filtbl		; check file1
	lda	!cmdbuf,x
	cmp	#'*'		; file1="*"?
	beq	?22
	cmp	#'='		; file1 = NULL?
	bne	?30		; no, check normal copy

?22:	; now string is the form "ddrv:*=sdrv:file2" or "ddrv:=sdrv:file2"
	; so operation is type DTD with unspecified file1
	lda	fildrv+1	; check drv not equal
	and	#$07
	cmp	fildrv
	beq	e_badsyn	; cannot be equal
	ldx	filtbl+1	; check file2
	lda	!cmdbuf,x
	beq	?10		; file2 = NULL -> file2 = "*"
	cmp	#'*'
	beq	?10		; file2 = "*"
	ldx	#cmdlen-2
	lda	#'*'		; put "*" at buffer end
	sta	!cmdbuf,x
	stz	!cmdbuf+1,x
	stx	filtbl		; file1 ptr -> "*" 	
	bra	?14		; retain file2, file1 pattern flag

?30:	; check for normal copy: no pattern, fs1=1 file, fs2=n files
	lda	image		; chk for normal
	and	#%11011001
	bne	e_badsyn
	stz	pattyp		; clear file1 pattern flag
	rts

; special case: parse string for disk-to-disk operation (DTD)
; i.e.: "Cddrv=sdrv", "Dddrv=sdrv"
prsdtd:
	lda	#'='		; find "="
	jsr	parse
	beq	e_badsyn	; error
	lda	cmdbuf,y	; test src drive
	jsr	tst0v1
	bmi	e_baddrv2	; error
	sta	fildrv+1	; src drive
	dey
	dey			; back to dest drive
	lda	cmdbuf,y
	jsr	tst0v1		; test dest drive
	bmi	e_baddrv2
	cmp	fildrv+1	; cannot be equal
	beq	e_badsyn
	sta	fildrv		; dest drive
	rts

e_baddrv2:
	lda	#baddrv
	bra	cmderr
e_badcmd:
	lda	#badcmd
	bra	cmderr
e_nofile:
	lda	#nofile		; no files
	bra	cmderr
e_badsyn:
	lda	#badsyn		; err: bad syntax
cmderr:
	stz	track		; cmd level err proc
	stz	sector
	jmp	doserr

; tag cmd string,setup cmd.. struc, image & file pntrs
; parse command line for R,S,N,A,T,M,L,K,E
;
; image bits
;            pgdrpgdr
;            fs1 fs2
;   bit reps:  pattern
;              greater than one file 
;              drive:filename 
;              not drive:filename (inverted d bit)
;
;   fs1 only	XX100001
;   fs1 & fs2	XX10XX10
;   fs1		XX10XX00 (fs2 optional)


tagcmd:
	jsr	prscln
	beq	e_nofile	; missing ':' -- error

tagcmd2:
	dey
	dey
	sty	filtbl		; ":"-1 starts fs1
	txa
	bne	e_nofile	; err: "," before ":"

prseq:
	lda	#'='		; search: "="
	jsr	parse
	txa			; ?file count= 1-1?
	beq	?40
	lda	#%01000000	; g1-bit - fs1 count > 1
?40:	ora	#%00100001	; d1,r2-bits - def. drive fs1, fs2 file req.
	sta	image		; fs structure
	inx
	stx	f1cnt		; fs1 file count
	stx	f2cnt		; init for no fs2
	lda	patflg
	beq	?50
	lda	#%10000000	; p1-bit
	tsb	image
	stz	patflg		; clear pattern flag
?50:	tya			; ptr to fs2
	beq	?75		; no '=' -> no fs2
	sta	filtbl,x
	lda	f1cnt		; fs2 is here now,...
	sta	f2ptr		; ...now set f2 ptr
	lda	#$8d		; dummy: find cr-shifted (till end of line)
	jsr	parse		; parse rest of cmd string
	inx			; advance filtbl ptr to end
	stx	f2cnt		; save it
	dex			; restore for test
	lda	patflg		; save last pattern
	beq	?60		; ?any patterns?
	lda	#%00001000	; yes, p2-bit
?60:	cpx	f1cnt		; ?f2cnt=f1cnt+1?
	beq	?70
	ora	#%00000100	; g2-bit
?70:	ora	#%00000011	; d2-bit,r2-bit
	eor	image		; eor clears r2-bit
	sta	image
?75:	lda	image
	ldx	cmdnum
	and	>struct,x	; match cmd template
	bne	e_badsyn
	rts

; parse command string for "open"
prsopn:
	lda	#$80
	sta	tmp0		; accept default drive
	jsr	prscln		; look for ":"
	bne	?02		; found
	tyx			; not found: y=0
	beq	?06		; bra
?02:	txa
	bne	e_badsyn	; comma before ":"
	dey			; back up to ":"
	beq	?06		; 1st char is ":"
        dey
?06:	sty	filtbl		; save filename ptr
	lda	#$8d		; parse cmd string
	jsr	parse
	inx
	stx	f2cnt

; set 1st drive and table pointers
onedrv:
	lda	f2cnt		; save f2cnt
	sta	f1cnt
	lda	#1		; set pointer to first file
	sta	f2cnt
	sta	f2ptr
	
;set up all drives from f2cnt (all files in stream)
alldrs:
	ldy	drvnum		; default drive is last parsed drive 
	ldx	#0		; ...into file entry table...
?10	stx	f1ptr		; ...on sector ptr byte
	lda	fildrv,x	; set bit 6 if dos drive 
	sta	char
	lda	filtbl,x
	jsr	setdrv
	ldx	f1ptr
	sta	filtbl,x	; incr ptr past ":"
				; bits rep drives
	tya
	ora	char		; restore bit 6
	sta	fildrv,x	; bit7: default drive
	inx			; bit0: drive #
	cpx	f2cnt
	bcc	?10
	rts      

; parse string for load directory command
; cover these situations:
; "$"
; "$x"
; "$x:pattern=type"
prsldd:
	lda	#ldcmd		; this is used as index for check image
	sta	cmdnum
	lda	#$80		; load only drive zero
	ldx	cmdsiz
	dex
	beq	?02		; "$" case
	dex			; load by name
	bne	?03
	lda	!cmdbuf+1	; "$x" case
	jsr	tst0v1
	bmi	?03		; x is not a drive number
?02:	sta	fildrv		; specified drive or default drive
	stx	filtbl		; file ptr -- here X = 0
	inx
	stx	f1cnt		; just file 1 stream
	stx	f2cnt
	lda	#$80
	sta	pattyp
	lda	#'*'		; in fact open "$x:*"
	sta	!cmdbuf
	stz	!cmdbuf+1
	stx	cmdsiz
	rts
?03:	jsr	prscln		; "$x:pattern=type" case
	bne	?05		; found ":"
	jsr	cmdrst		; search by name on both drives
	ldy	#3
?05:	dey
	dey
	sty	filtbl
	jsr	prseq		; parse & set tables
	jsr	fs1set
	bra	alldrs      

;---------------------------------------
;  set drive number
;  determines drive # from text or
;  uses default (-d)
;  a: in,out: index, cmdbuf
;  y: in: default drive
;     out: drive number, - if default
;  char<6> set if check dos drive
;---------------------------------------
setdrv:
	tax			; x= cmdbuf index
	lda	#':'
	cmp	!cmdbuf+1,x	; for xxx:file
	beq	?40		;       ^
	cmp	!cmdbuf,x	; for xxx:file
	bne	?50		;        ^
	inx			; found ":", so...
	bra	?50
?22:	and	#1		; convert to numeric
?24:	tay			; set new default drive
	txa			; a=index & xxxxfile
	rts			;               ^
?40:	lda	!cmdbuf,x
	inx			;  xxx:file
	inx			;    --^
	cmp	#'0'		; for xx0:file
	beq	?22		;         ^
	cmp	#'1'		; for xx1:file
	beq	?22		;         ^
	bit	char		; test bit 6
	bvc	?48		; check default cbm drive
	cmp	#'8'
	bcs	?45		; valid dos drive: 0..7
	cmp	#'0'
	bcc	?45
	sbc	#'0'
	cmp	#MAXDOSDRV
	bcc	?24		; dos drive ok	
?45:	jmp	e_baddrv
?48:	bit	tmp0		; for default baddrv error!
	bpl	?45
?50:	tya			; for xxx,file or xx=file
	ora	#$80		;         ^          ^
	and	#$87		; drive= -default
	bra	?24
	
; simple parser - set just the drive number
; called by open directory command
simprs:
	stz	filtbl
	jsr	prscln		; search colon
	beq	?02		; ":" not found, Y = next char
	dey
	dey
	sty	filtbl		; ptr to char before ":"
?02:	stz	image
	ldy	filtbl
?04:	lda	cmdbuf,y
	jsr	tst0v1
	bpl	?20		; ok, found drive #
	iny
	cpy	cmdsiz
	bcs	?10		; end of string
	ldy	cmdsiz
	dey
	bne	?04
?10:	dec	image		; invalidate cmd template
	lda	drvnum		; use default drive
	ora	#$80
?20:	and	#$81
	sta	fildrv
	rts

;test char in accum for "0" or "1"
tst0v1:	cmp	#'0'
	beq	?02
	cmp	#'1'
	beq	?02
	ora	#$80		; use default drive
?02:	and	#$81		; mask dr #
	rts      

; find pos'n of ":"
prscln:
	ldy	#0		; buffer ptr
	tyx			; comma counter
	lda	#':'         

;parse string
;  looks for special chars,
;  returning when var'bl char
;  is found
;   a: var'bl char
;   x: in,out: index, filtbl+1
;   y: in: index, cmdbuf
;     out: new ptr, =0 if none
;         (z=1) if y=0
parse:	
	sta	char		; save var'bl char
?10:	lda	cmdbuf,y	; match char
	beq	?30		; end of string
	iny
	cmp	char
	beq	?35		; found char
	cmp	#'*'		; match pattern chars
	beq	?20
	cmp	#'?'
	bne	?25
?20:	inc	patflg		; set pattern flag
?25:	cmp	#','		; match file separator
	bne	?10		; loop
	sty	filtbl+1,x	; put ptrs in table
	lda	patflg		; save pattern for file
	and	#$7f
	beq	?28
	lda	#$80		; retain pattern presence...
	sta	pattyp,x
	sta	patflg		; ...but clear count
?28:	inx
	cpx	#mxfils
	bcc	?10		; no more than mxfils
	jmp	e_badsyn	; too many files
?30:	ldy	#0		; y=0 (z=1)
?35:	lda	cmdsiz
	sta	filtbl+1,x
	lda	patflg
	and	#$7f
	beq	?40
	lda	#$80
	sta	pattyp,x
?40:	tya			; z is set
	rts

; set ptrs to one file stream & chk type
; for command that allow pattern=type
fs1set:	
	ldx	#0
	lda	f1cnt
	cmp	f2cnt
	beq	?15		; just one file in stream
	dec	f2cnt
	ldx	f2cnt
	lda	filtbl,x
	tax
	lda	!cmdbuf,x
	ldx	#ntypes-1
?10:	cmp	>typlst,x
	beq	?15
	dex
	bne	?10
?15:	stx	typflg
	rts

; copy local cmd string, initialize command tables, ptrs, etc.
; command string, as parameter, is terminated with '0' or CR
cmdset:
	ldy	#0
?02:	lda	[tlp]		; trim left
	beq	?10		; end of cmd
	cmp	#$0D
	beq	?06		; end of cmd
	cmp	#' '		; trim blanks
	bne	?03
	inc	tlp
	bne	?02
	inc	tlp+1
	bne	?02
	beq	?11		; long line
?03:	dey
?04:	iny
	lda	[tlp],y
	beq	?10		; end of cmd
	cmp	#$0D
	bne	?08
?06:	lda	#0		; end of cmd
	bra	?10
?08:	cmp	#'a'		; convert up case
	bcc	?10
	cmp	#'z'+1
	bcs	?10
	and	#$DF
?10:	sta	cmdbuf,y
	tax
	beq	?12
	cpy	#cmdlen
	bcc	?04
?11:	lda	#longln		; long line error
	jmp	cmderr
?12:	sty	cmdsiz		; not counting final '0'
	bit	cmdtrap
	bmi	cmdrst		; cmd. empty string is ok
	tyx
	bne	cmdrst
	lda	#nullln		; empty command string error
	jmp	cmderr
	
; clear vars & tbls
cmdrst:
	ldy	#0
	tya
	sta	type
	sta	mode
	sta	typflg
	sta	f1ptr
	sta	f2ptr
	sta	f1cnt
	sta	f2cnt
	sta	patflg
	sta	lsterr
	sta	tmp0
	sta	tmpxxx
	sta	trap
	sta	wrop
	ldx	#mxfils
?10:	sta	filtbl-1,x
	sta	entsec-1,x
	sta	entind-1,x
	sta	fildrv-1,x
	sta	pattyp-1,x
	sta	filtrk-1,x
	sta	filsec-1,x
	dex
	bne	?10
	rts      

;---------------------------------------------------------------------------
; read/write on fd
;---------------------------------------------------------------------------

; buffered read/write on file
; in:	X = channel
;	Y = op (read/write)
fd_rw:
	ACC16
	tsc			; save current stack pointer
	sta	!tos
	ACC08
	cpx	#$0F
	bne	?08		; file
	tya
	beq	?02		; read on channel 15
	clc			; write on channel 15 is no-op
	rts
?02:	jsr	fmterr		; format error string (bytes # in btrf)
	stz	lsterr	
	ldy	#0
	INDEX16
?04:	lda	cmdbuf,y
	sta	[wbuf],y
	beq	?06		; end of transfer
	iny
	cpy	bsize
	bcc	?04
	dey
	lda	#0		; trunc string
	sta	[wbuf],y
?06:	iny
	sty	btrf
	INDEX08	
	clc
	rts
?08:	stz	lsterr
	stz	wrop
	tya
	beq	?10
	lda	#$80
	sta	wrop
?10:	jsr	fndfd		; check file (read/write)
	jsr	fddrv		; get associate drive #
	lda	lintab,x
	bit	#$20
	beq	?12
	jmp	fdlist		; buffered load dir
?12:	bit	#$40
	beq	?14
	jmp	fdda
?14:	bit	wrop
	bmi	fdwrite
;	bmi	?14
;	jmp	fdread
;?14:	jmp	fdwrite

; read a block of data from file and transfer to destination buffer
; before to call this function these var's should be initialized:
;	lindx	=file descriptor (logical index)
;	bsize	=size of destination buffer
;	wbuf	=long pointer to destination buffer
;
; this function return when:
;	1) destination buffer is full, and/or
;	2) the eof condition is true
;	   in this case the bit 7 of fdst is set
;
; on exit, btrf contain the effective transferred bytes count #
;
fdread:
	stz	btrf		; clear count of readden bytes
	stz	btrf+1
	ldx	lindx		; file descriptor
	bit	fdst,x		; test if eof
	bmi	?40		; yes, eof
	lda	drvnum		; set up read drive #
	sta	rddrv
	ldy	ftrk,x
	sty	track		; set up current file track
	lda	fsec,x
	sta	sector		; setup current file sector
	ldy	fdptr,x
	sty	rdidx		; set file pointer in this blk
	jsr	tread		; read whole track in read cache
	jsr	setcp		; set up bufp pointer
	stz	rdlst		; assume full block (not last blk)
	ldy	#1
	lda	[bufp],y	; read link to next block
	tay			; next sector or last byte ptr
	lda	[bufp]		; next libnk track
	bne	?10		; no end of file
	sty	rdlst		; last byte pointer (this is last blk)
?10:	stz	rdeof		; clear eof flag
?20:	jsr	bufget		; get next byte from disk buffer
	INDEX16
	ldy	btrf		; current dest buffer ptr
	sta	[wbuf],y	; store in dest buffer
	iny
	sty	btrf		; update ptr
	cpy	bsize		; check size of dest buffer
	INDEX08
	bcs	?30		; dest buffer is full
	lda	rdeof		; eof?
	beq	?20		; no -- get next byte
?30:	ldx	lindx
	ldy	track
	sty	ftrk,x		; save current fd
	lda	sector
	sta	fsec,x
	ldy	rdidx
	sty	fdptr,x
	lda	rdeof
	beq	?40		; no eof
	lda	#$80
	ora	fdst,x
	sta	fdst,x		; eof signal
?40:	clc	
	rts

; write a block of data from source buffer to file
; before to call this function these var's should be initialized:
;	lindx	=file descriptor (logical index)
;	bsize	=number of bytes to write
;	wbuf	=long pointer to destination buffer
;
; on exit, btrf contain the effective transferred bytes count #
;
fdwrite:
	stz	rdeof
	ACC16
	stz	btrf		; clear count of written bytes
	lda	bsize		; nothing to write?
	ACC08
	beq	?10		; yes, nothing
	ldx	lindx		; file descriptor
	lda	drvnum		; set up write drive #
	sta	wrdrv
	ldy	ftrk,x
	sty	track		; set up current file track
	lda	fsec,x
	sta	sector		; setup current file sector
	sta	wsec		; current sector to write in cache
	sta 	wfirst		; first sector to write in cache	
	ldy	fdptr,x
	sty	wridx		; set file pointer in this blk	
	ldx	dblfd
	ACC16
	lda	fdblk,x		; set up block's count
	sta	wcnt
	lda	wbuf		; wbuf is used by write cache
	sta	bufp		; bufp is the src. buffer
	ACC08
	lda	wbuf+2
	sta	bufp+2
	jsr	wread		; pre-read track in write cache
	jsr	setwb		; set buffer wbuf to cache
?02:	INDEX16
	ldy	btrf		; transfer src. buffer to cache
	lda	[bufp],y
	iny
	sty	btrf		; bump pointer
	cpy	bsize
	INDEX08
	php
	jsr	bufput		; put in cache	
	plp
	bcc	?02		; loop
	jsr	wrtcache	; flush cache on disk
	ldx	lindx
	lda	track
	sta	ftrk,x
	lda	sector
	sta	fsec,x
	ldy	wridx
	sty	fdptr,x
	ldx	dblfd
	ACC16
	lda	wcnt
	sta	fdblk,x
	ACC08
?10:	clc
	rts

; read a block of data from dir listing and transfer to destination buffer
; before to call this function these var's should be initialized:
;	lindx	=file descriptor (logical index)
;	bsize	=size of destination buffer
;	wbuf	=long pointer to destination buffer
;
; this function return when:
;	1) destination buffer is full, and/or
;	2) the eof condition is true
;	   in this case the bit 7 of fdst is set
;
; on exit, btrf contain the effective transferred bytes count #
;
fdlist:
	jsr	setfdp		; set buffer for this fd & return X=lindx
	stz	btrf		; clear count of readden bytes
	stz	btrf+1
	bit	fdst,x		; test if eof
	bmi	?40		; yes, eof
	ldy	fdptr,x
	sty	rdidx		; set file pointer in this blk
	stz	rdeof		; clear eof flag
	jsr	exxzp		; get zp var's for dir searching	
?20:	jsr	bufget2		; get next byte from list buffer
	INDEX16
	ldy	btrf		; current dest buffer ptr
	sta	[wbuf],y	; store in dest buffer
	iny
	sty	btrf		; update ptr
	cpy	bsize		; check size of dest buffer
	INDEX08
	bcs	?30		; dest buffer is full
	lda	rdeof		; eof?
	beq	?20		; no -- get next byte
?30:	jsr	exxzp		; restore zp var's	
	ldx	lindx
	ldy	rdidx
	sty	fdptr,x
	lda	rdeof
	beq	?40		; no eof
	lda	#$80
	ora	fdst,x
	sta	fdst,x		; eof signal
?40:	clc	
	rts

; close file
; in:	X = channel
; if chnl=15 all open files will be closed
fdcls:
	ACC16
	tsc			; save current stack pointer
	sta	!tos
	ACC08
	txa
	beq	?28		; read only chnl so just free lindx & chnl
	cpx	#$0F
	bne	?20		; close channel 1..14
	ldx	#mxchnls-1	; closing chnl 15 close all open files
?02:	stx	chnl
	jsr	?20		; close chnl X
	ldx	chnl
	dex
	bpl	?02
?04:	clc	
	rts
?20:	lda	lintab,x	; close chnl X
	cmp	#$FF
	beq	?04		; is closed
	bit	#$40		; direct access?
	bne	?26		; yes, just update bam
	and	#$07
	sta	lindx		; associated logical index
	jsr	fddrv		; get associated drive
	jsr	fndwfd		; look for write fd
	bcs	?28		; read fd: just free lindx
	jsr	clswfd
?26:	jsr	bamout	
?28:	jsr	frefd		; free fd
	clc
	rts

; close a write file
;in:	X=lindx
clswfd:
	lda	drvnum		; set up write drive #
	sta	wrdrv
	ldy	ftrk,x
	sty	track		; set up current file track
	lda	fsec,x
	sta	sector		; setup current file sector
	sta	wsec		; current sector to write in cache
	sta 	wfirst		; first sector to write in cache	
	ldy	fdptr,x
	sty	wridx		; set file pointer in this blk	
	ldx	dblfd
	ACC16
	lda	fdblk,x		; set up block's count
	inc	a		; take in count last blk
	sta	wcnt
	CPU08
	jsr	wread		; pre-read track in write cache
	jsr	setwb		; set buffer bufw to cache
	lda	#0		; null link in this block
	sta	[wbuf]		; finalize sector
	ldy	#1
	lda	wridx		; last byte ptr (+1)
	dec	a
	sta	[wbuf],y
	jsr	wrtcache	; write out cache
	ldx	lindx
	lda	dsec,x		; set dir. ptr to file entry
	sta	sector
	ldy	#dirtrk
	sty	track
	jsr	sethdp
	clc
	adc	sector
	sta	dirp+1		; set dir. pointer to file entry
	ldx	lindx
	lda	dind,x
	sta	dirp
	lda	[dirp]		; set flag closed file
	tax
	and	#$4F		; reset replace mode
	ora	#$80
	sta	[dirp]
	ldy	#28		; store block's #
	ACC16
	lda	wcnt
	sta	[dirp],y
	ACC08
	txa
	bit	#$20		; replace flag?
	beq	?10		; no
	ldy	#26
	lda	[dirp],y	; get new start link
	tax			; X=new track
	iny
	lda	[dirp],y
	xba			; B=new sec
	ldy	#1
	lda	[dirp],y	; old start track
	pha
	txa			; new start track
	sta	[dirp],y
	plx			; X=old start track
	iny
	lda	[dirp],y	; old start sec
	xba			; A=new start sec, B=old start sec
	sta	[dirp],y
	xba			; A=old start sec
	ldy	#27
	sta	[dirp],y	; save old start sector
	pha
	dey
	txa
	sta	[dirp],y	; save old start track
	pha
	jsr	wrdsec		; update directory
	pla
	sta	track
	pla
	sta	sector
	jmp	delfil		; delete old file
?10:	jmp	wrdsec

fdda:
	stz	btrf		; clear count of readden bytes
	stz	btrf+1
	ldx	lindx		; file descriptor
	bit	wrop
	;bmi	???
	bit	fdst,x		; test if eof
	bmi	?40		; yes, eof
	ldy	fdptr,x
?10:	ldy	btrf		; current dest buffer ptr
	sta	[wbuf],y	; store in dest buffer
	iny
	sty	btrf		; update ptr
	cpy	bsize		; check size of dest buffer
	INDEX08
	bcs	?30		; dest buffer is full
	tya			; eof?
	;bne	?20		; no -- get next byte
?30:	ldx	lindx
	ldy	track
	sty	ftrk,x		; save current fd
	lda	sector
	sta	fsec,x
	ldy	rdidx
	sty	fdptr,x
	lda	rdeof
	beq	?40		; no eof
	lda	#$80
	ora	fdst,x
	sta	fdst,x		; eof signal
?40:	clc	
	rts

; get next byte from read cache in buffered operation
; read a new whole track in cache if needed
; update pointer and set EOF status in rdeof
; out:	A = byte
;	rdeof not null if EOF
;	rdidx updated
; before to call this function:
;	pre-read whole track in cache
;	set bufp long pointer to cache and sector
;	set rdix=2, rdeof=0, rddrv=drive#
;	rdlst=0 if file have a next block
;	     =last index if this is last block of file
bufget:
	ldy	rdidx		; current buffer pointer
	lda	rdlst
	beq	?02		; full buffer
	cpy	rdlst		; end of buffer?
	bne	?02		; no	
	lda	[bufp],y	; get byte
	bra	?04
?02:	lda	[bufp],y	; get byte
	iny			; bump ptr and set/reset Z
	sty	rdidx
	bne	?05		; exit (no EOF)
?04:	ldy	rdlst
	beq	?06		; read next file block
	sty	rdeof		; EOF
?05:	rts
?06:	sta	data		; save byte
	ldx	rddrv
	stx	drvnum
	ldy	#1		; read link to next block
	lda	[bufp],y
	sta	sector
	tay
	lda	[bufp]		; read link
	cmp	track		; same track?
	sta	track
	beq	?08		; ok, still in cache
	jsr	tread		; read whole track
	ldy	sector
?08:	tya			; set pointer to track/sec cache
	clc
	adc	trkofs,x	; add start of dma buffer
	sta	bufp+1
	stz	rdlst		; assume full buffer
	ldy	#1
	lda	[bufp],y	; next sector
	tay
	lda	[bufp]		; next track
	bne	?10		; is not last block
	sty	rdlst		; is last block
?10:	ldy	#2
	sty	rdidx		; set start pointer for next get
	lda	data		; get byte
	rts			; not EOF

; put byte in write cache in buffered operation
; update buffer pointer, allocate a new t&s if needed
; update t&s link of the file and write out the cache if needed
; in:	A=byte
;	wridx=buffer pointer
;	wrdrv=drive#
;	wfirst=first sector written in this track
;	wsec=current sector written in this track
;	wcnt=current count of file block's
;	rdeof=flag eof when put last byte
;	wbuf=long pointer to cache and sector
; before to call this function will pre-read the track
; of first block of the file (into write cache)
bufput:
	ldy	wridx		; need to allocate a new block?
	bne	?04		; no, store
	
	; this can happen when append data to current file
	; and last byte of last block was $FF
	; need to allocate a new block
	sta	data		; save byte to store
	;lda	wsec		; must save just this sector
	;sta	wfirst		; set first=last sector
	jsr	?08		; update cache and alloc new sector...
	lda	data		; ...return Y=wrdix
?04:	sta	[wbuf],y	; store data at
	lda	rdeof		; test eof
	bne	?06		; eof: this is last byte
	iny			; bump pointer
	sty	wridx
	;beq	?08		; need a new block
	rts
?06:	lda	#0		; null link in this block
	sta	[wbuf]		; finalize sector
	ldy	#1
	lda	wridx		; last byte ptr
	sta	[wbuf],y
	ldx	wrdrv		; restore drive #
	stx	drvnum
	lda	wcache,x	; restore current track
	sta	track
	jsr	wrtcache	; write out cache
	inc	wridx		; bump pointer (can be null!!)
	rts
?08:	ldx	wrdrv		; set drive #
	stx	drvnum
	lda	wcache,x	; restore current t&s
	sta	track
	lda	wsec
	sta	sector
	jsr	nxtts		; alloc a new sector
	ldx	drvnum
	ldy	#1
	lda	sector		; set link to new sector 
	sta	[wbuf],y
	tay			; Y=sector
	lda	track
	sta	[wbuf]
	cmp	wcache,x	; same track?
	beq	?10		; yes
	pha			; save new track
	lda	wcache,x	; set old track
	sta	track
	jsr	wrtcache	; write out cache
	pla
	sta	track		; restore new track
	jsr	wread		; read the new whole track in write cache
	ldy	sector
	sty	wfirst		; set first dirty sec	
?10:	sty	wsec		; update current sector
	clc
	tya
	adc	wrtofs,x	; set pointer to sector
	sta	wbuf+1
	ACC16
	inc	wcnt		; update block's #
	ACC08
	ldy	#2		; set start of pointer
	sty	wridx
	rts

wrtcache:
	ldx	drvnum
	lda	wfirst		; first dirty sec
	lsr	a
	sta	tmpxxx		; dma buffer offset
	tay
	lda	wsec		; last dirty sector of this track
	lsr	a
	cmp	#phisec		; if last is in side 0...
	bcc	?10		; ...write out side 0 only
	cpy	#phisec		; if first is in side 1...
	bcs	?10		; ...write out side 1 only
	lda	wrtbuf,x	; dma buffer #
	jmp	writetk		; write out whole track
?10:	stz	pside		; assume side 0
	inc	a		; A = last phis. sec
	iny			; Y = first phis. sec
	bcc	?15		; write out side 0
	inc	pside		; side 1
	sbc	#phisec
	xba			; B = last phis. sec
	tya
	sec
	sbc	#phisec
	tay			; Y = first phis. sec.
	xba			; A = last phis. sec
?15:	sty	wtmp
	sec
	sbc	wtmp		; last - start + 1...
	inc	a		; ...number's of sec to write out
	xba			; B = sec. count #
	lda	wrtbuf,x
	clc
	adc	tmpxxx		; add sector offset
	xba			; B = dma buffer #, A = sec. count #	
	jmp	writesec

; get next byte from dir listing cache -- special case for loaddir 
; update pointer and set EOF status in rdeof
; out:	A = byte
;	rdeof not null if EOF
;	rdidx updated
; before to call this function:
;	prepare dir listing in cache
;	set bufp long pointer to cache
;	set rdix=0, rdeof=0, rddrv=drive#
;	rdlst=0 if dir.listing have a next block
;	     =last index if this is last block of dir. listing
bufget2:
	ldy	rdidx		; current buffer pointer
	lda	rdlst
	beq	?02		; use full buffer
	cpy	rdlst		; end of buffer?
	bne	?02		; no	
	lda	[bufp],y	; get byte
	bra	?04
?02:	lda	[bufp],y	; get byte
	iny			; bump ptr and set/reset Z
	sty	rdidx
	bne	?05		; exit (no EOF)
?04:	ldy	rdlst
	beq	?06		; read next dir listing block
	sty	rdeof		; EOF
?05:	rts
?06:	sta	data		; save byte
	jsr	dlist		; fill buffer with dir listing
	lda	data		; get byte
	rts

; exchange zero page var's while dir listing
; will be used the next buffer (dir list use just one buffer)
exxzp:
	ldx	#dpsave-1	; exchange page 0 var's for dir. search
	txy
	inc	bufp+1		; next buffer
?02:	lda	[bufp],y
	xba
	lda	zpstart,x
	sta	[bufp],y
	xba
	sta	zpstart,x
	dey
	dex
	bpl	?02
	lda	#$80
	sta	bufp
	ldx	#fntlen-1	; exchange file name table
	txy
?04:	lda	[bufp],y
	xba
	lda	!fntab,x
	sta	[bufp],y
	xba
	sta	!fntab,x
	dey
	dex
	bpl	?04
	stz	bufp		; restore buffer ptr to listing buffer
	dec	bufp+1
	rts

; save page 0 and file name table in next buffer while dir listing
savzp:
	ldx	#dpsave-1	; save page 0 var's for dir. search
	txy
	inc	bufp+1		; next buffer
?02:	lda	zpstart,x
	sta	[bufp],y
	dey
	dex
	bpl	?02
	lda	#$80
	sta	bufp
	ldx	#fntlen-1	; exchange file name table
	txy
?04:	lda	!fntab,x
	sta	[bufp],y
	dey
	dex
	bpl	?04
	stz	bufp		; restore buffer ptr to listing buffer
	dec	bufp+1
	rts

;---------------------------------------------------------------------------
; logical channels helper's
;---------------------------------------------------------------------------

; open a read file
opnrfd:
	jsr	getrfd		; get a free file descriptor for read
	ldx	lindx		; X=fd
	lda	entsec		; store dir entry in fd table
	ldy	entind
	sta	dsec,x
	sty	dind,x
	ldy	filtrk		; store first t&s of file
	sty	track
	lda	filsec
	sta	sector
	sty	ftrk,x
	sta	fsec,x
	lda	#2
	sta	fdptr,x		; start of buffer
	ldy	#28
	ACC16
	lda	[dirp],y	; store file block's count
	ldx	dblfd
	sta	fdblk,x
	ACC08
	rts

; open a write file
; if wrop<7>=0 create file
; if wrop<7>=1 replace file
opnwfd:
	jsr	getwfd		; get a free file descriptor for write
	lda	#$80
	sta	trap		; trap error for free chnl on error
	bit	wrop
	bpl	?04		; create file on dir
	jsr	intts		; get a starting t&s for file
	lda	[dirp]
	ora	#$20		; set replace flag on dir entry
	sta	[dirp]
	ldy	#26		; set replacing link on dir entry
	lda	track
	sta	[dirp],y
	sta	filtrk
	iny
	lda	sector
	sta	filsec
	sta	[dirp],y
	jsr	bamout		; save bam on disk
	lda	entsec
	cmp	#4		; dir entry already sve with bam?
	bcc	?10		; yes
	sta	sector		; set sector of dir. entry
	lda	#dirtrk
	sta	track
	jsr	wrdsec		; save dir sector on disk
	bra	?10
?04:	lda	#dirtrk
	sta	track
	stz	sector
	jsr	sethdp
	jsr	addfil		; create file in directory
?10:	ldx	lindx
	lda	entsec		; store dir entry in fd table
	ldy	entind
	sta	dsec,x
	sty	dind,x
	ldy	filtrk		; store first t&s of file
	sty	track
	lda	filsec
	sta	sector
	sty	ftrk,x
	sta	fsec,x
	lda	#2
	sta	fdptr,x		; start of buffer
	ldx	dblfd
	stz	fdblk,x		; clear block's count
	stz	fdblk+1,x
	stz	trap		; clear trap error
	rts

; allocates a new logical index and associate at given channel
; getwfd allocate a write lindx
; getrfd allocate a read lindx
getwfd:
	sec			; set .c=1 indicate write
	bcs	getlx
getrfd:
	clc			; set .c=0 indicate read
getlx:
	php			; save r/w flag (.c)
	jsr	fndlnx		; get next lindx open
	sta	lindx
	tax
	stz	fdst,x
	stz	dsec,x
	stz	dind,x
	stz	ftrk,x
	stz	fsec,x
	stz	fdptr,x
	stz	fdlst,x
	stz	fdix,x
	asl	a
	sta	dblfd
	txa
	ldx	chnl
	plp
	bcc	?04		; read
	ora	#$80		; set write flag
?04:	sta	lintab,x
	lda	drvnum
	asl	a
	asl	a
	asl	a
	ora	lintab,x
	sta	lintab,x	; save lindx in lintab
	ldx	dblfd
	stz	fdblk,x
	stz	fdblk+1,x
	rts

; free a file descriptor
frefd:
	ldx	chnl
	cmp	#$0F		; free rd/wrt chnls
	beq	?25		; but don't free ch15
	lda	lintab,x
	cmp	#$FF
	beq	?25		; already free
	and	#$07
	sta	lindx
	lda	#$FF
	sta	lintab,x	; mark free in lintab
	ldx	lindx		; release lindx
	stz	fdst,x
	lda	#1
?15:	dex
	bmi	?10
	asl	a
	bne	?15
?10:	tsb	linuse		; 1=free 0=used   
?25:	rts

; find free lindx to use and mark used in linuse
; return lindx in A
fndlnx:
	ldy	#0		; bit counter
	lda	#1		; any bit is a logical index
?10:	bit	linuse		; 1=free 0=used
	bne	?30		; free index
	iny
	asl	a		; shift '1' 8 times
	bne	?10
	lda	#nolinx		; no free lindx available
	jmp	cmderr
?30:	trb	linuse		; mark bit used
	tya			; return lindx in .a
	rts

; check if entry in file table is open and abort if it is
; in:	X = file stream index to check
; A destroyed
tstopn:
	phy
	stx	entfnd		; index 0..n-1
	jsr	tstfd
	bcs	?02
	lda	#filopn
	jmp	cmderr
?02:	ply
	rts

; test if entfnd is active file from lindx tbl
; c=1 file not active
; c=0 file active x=entfnd,y=lindx
; use tmp0 & tmpxxx
tstfd:
	ldx	#0		; start search at top
?20:	stx	tmp0		; save to look on
	lda	lintab,x	; get lindx
	cmp	#$ff
	bne	?40		; allocated so test it
?30:	ldx	tmp0		; not active
	inx
	cpx	#mxchnls	; searched all?
	bcc	?20		; no
	rts			; yes, CF = 1
?40:	stx	tmp0		; save x
	tax
	and	#$07
	tay			; Y = lindx
	txa
	and	#$08		; get drive #
	lsr	a
	lsr	a
	lsr	a
	lsr	a
	sta	tmpxxx
	ldx	entfnd		; index entry found
	lda	fildrv,x
	and	#1
	cmp	tmpxxx		; same drive # ?
	bne	?30		; no
        tyx
        lda	dsec,x		; yes - same dir. entry ?
	ldx	entfnd
	cmp	entsec,x
	bne	?30		; no
	tyx
	lda	dind,x
	ldx	entfnd
	cmp	entind,x
	bne	?30		; no
	clc			; active file so CF = 0
	rts

; return file descriptor of the right type (read or write)
; return X = lindx (fd)
fndfd:
	jsr	isopn		; check if file is open
	bit	lintab,x
	bvc	?08
	jsr	fnddafd		; direct access
	bcc	?20
	lda	#mistyp
	jmp	chnerr
?08:	bit	wrop
	bmi	?10		; write file
	jsr	fndrfd		; check read file
	bcc	?20
	lda	#wrfil		; write file only
	jmp	chnerr
?10:	jsr	fndwfd		; check write file
	bcs	?30		; read file only
?20:	rts
?30:	lda	#rdfil
	jmp	chnerr

; find lindx of read fd
; CF = 0 if chnl is a read channel, A=X = lindx
; CF = 1 if chnl is not a read channel
fndrfd:
	ldx	chnl
	sec
	lda	lintab,x
	bmi	?02
	and	#$07
	sta	lindx
	tax
	asl	a
	sta	dblfd
	txa
	clc
?02:	rts

; find lindx of write fd
; CF = 0 if chnl is a write channel, A=X = lindx
; CF = 1 if chnl is not a write channel
fndwfd:
	ldx	chnl
	lda	lintab,x
	tay
	asl	a
	bcc	?20		; bit 7 = 0, not ok
	bmi	?20		; bit 7 & 6 = 1, not ok
	tya
	and	#$07
	sta	lindx
	tax
	asl	a
	sta	dblfd
	txa
	clc
	rts
?20:	sec
	rts

; find lindx of direct access fd
; CF = 0 if chnl is direct access type, A=X = lindx
; CF = 1 if not
fnddafd:
	ldx	chnl
	lda	lintab,x
	tay
	asl	a
	bcs	?10		; bit 7=1, not ok
	bpl	?20		; bit 6=0, not ok
	tya			; ok, just bit 6=1
	and	#$07
	sta	lindx
	tax
	asl	a
	sta	dblfd
	txa
	clc
?10:	rts
?20:	sec
	rts

; get drive associated with fd
fddrv:
	ldx	chnl
	lda	lintab,x
	cmp	#$FF
	beq	?04
	and	#$08		; drive is in bit 3
	lsr	a
	lsr	a
	lsr	a
	sta	drvnum
?04:	rts

; test if given channel is open
isopn:
	ldx	chnl
	lda	lintab,x
	cmp	#$FF
	beq	?02		; channel not open
	rts
?02:	lda	#filnop
	jmp	chnerr

; get first available channel in range 2..14
; return channel in X and chnl
getfre:
	ldx	#2		; start from chnl 2
?02:	lda	lintab,x
	cmp	#$FF
	beq	?04
	inx
	cpx	#mxchnls
	bcc	?02
	lda	#nochnl		; no channels available
	jmp	cmderr
?04:	stx	chnl
	rts

; set pointer to buffer associated with logical index
; return X = lindx
setfdp:
	lda	lindx
	tax
	clc
	adc	#DMALXBUF	; buffer # for index = 0
	ldy	#DMABNK		; bank for buffer #00..#7F
	asl	a		; get high pointer
	bcc	?02
	iny			; next bank
?02:	stz	bufp		; set buffer pointer
	sta	bufp+1
	sty	bufp+2
	rts

;---------------------------------------------------------------------------
; directory listing
;---------------------------------------------------------------------------

; fill buffer with dir listing
; any list line is 32 bytes long and in cbm basic format
; first 2 bytes is the basic line link
; follow 2 bytes with blocks count of file (like a basic line number)
; follow file name and type
; last byte is null fo terminate basic line
; when listing terminate two null will be appended for terminate basic text
;
; in:	Y=current pointer to dest buffer
; out:	rdlst is ptr to last byte (if not null ending listing)
dlist:	
	lda	#1		; insert fhoney links ($0101)
	sta	[bufp],y
	iny
	sta	[bufp],y
	iny
	jsr	getnam		; get file name and fill name buffer
	bcs	?10		; CF=1 if last entry
	lda	wtmp		; put blocks #
	sta	[bufp],y
	iny
	lda	wtmp+1
	sta	[bufp],y
	iny
	jsr	movbuf		; move 27 bytes from name buffer
	lda	#0		; end of entry
	sta	[bufp],y
	iny
	bne	dlist		; next entry
	bra	?20		; buffer is full
?10:	lda	wtmp		; this is end of listing
	sta	[bufp],y	; send free blocks #
	iny
	lda	wtmp+1
	sta	[bufp],y
	iny
	jsr	movbuf		; move 27 bytes from name buffer
	dey			; -2 bytes for make room for double null
	dey
	lda	#0		; end of listing (000)
	sta	[bufp],y
	iny
	sta	[bufp],y
	iny
	sta	[bufp],y
?20:	sty	rdlst		; set end pointer (not 0 if end)
	rts

; get next file entry from directory
; if listing is complete return with CF=1
getnam:
	phy			; save buffer index
	lda	entfnd
	bpl	?10		; more files
	jsr	blknb		; this is end of listing		
	ldx	#msglen-1
?02:	lda	>fremsg,x
	sta	!nambuf,x
	dex
	bpl	?02
	lda	drvnum
	asl	a
	tax
	lda	ndbf,x		; save free block's count
	sta	wtmp
	lda	ndbf+1,x
	sta	wtmp+1
	ply
	sec			; CF=1 end of listing
	rts

?10:	ldx	#dirlen		; set number blocks
	ldy	#29		;  & adjust spacing
	lda	[dirp],y	; hi blocks #
	sta	wtmp+1
	beq	?12
	ldx	#dirlen-2	; blocks < 256
?12:	dey
	lda	[dirp],y	; low blocks #
	sta	wtmp
	cpx	#dirlen-2
	beq	?14
	cmp	#10
	bcc	?14		; blocks < 10
	dex
	cmp	#100
	bcc	?14		; blocks < 100
	dex
?14:	jsr	blknb		; clear name buffer
	lda	[dirp]		; set type chars
	pha
	asl	a		; (used in bcs for check closed flag)
	bpl	?15		; file not locked
	lda	#'<'
	sta	!nambuf+1,x	; file locked
?15:	pla
	and	#$0f
	txy			; Y = nambuf index
	tax			; X = file type
	lda	>tp2lst,x
	sta	nambuf,y
	dey
	lda	>tp1lst,x
	sta	nambuf,y
	dey
	lda	>typlst,x
	sta	nambuf,y
	dey
	dey
	bcs	?20		; (from asl)
	lda	#'*'		; file not closed: splat file
	sta	nambuf+1,y
?20:	lda	#$A0
	sta	nambuf,y
	tyx			; X = nambuf index
	dex
	ldy	#18		; end of file name
?22:	lda	[dirp],y	; move file name
	sta	!nambuf,x
	dex
	dey
	cpy	#3
	bcs	?22
	lda	#'"'		; send name in quotes
	sta	!nambuf,x    
?30:	inx
	cpx	#$20		; max 32 bytes
	bcs	?35
	lda	!nambuf,x
	cmp	#'"'
	beq	?35
	cmp	#$A0		; stop at first padding byte
	bne	?30
?35:	lda	#'"'
	sta	!nambuf,x
?37:	inx
	cpx	#$20
	bcs	?40
	lda	#$7F		; clear bit of any char
	and	!nambuf,x
	sta	!nambuf,x
	bra	?37
?40:	jsr	fndfil		; put dir ptr to next entry
	ply
	clc			; CF=0 no ending listing
	rts

; move file name to listing buf
movbuf:
	ldx	#0
?02:	lda	!nambuf,x
	sta	[bufp],y
	iny
	inx
	cpx	#nbsiz
	bne	?02
	rts

; blank nambuf
blknb:
	ldy	#nbsiz
	lda	#' '
?02:	sta	nambuf-1,y
	dey
	bne	?02
	rts

;---------------------------------------------------------------------------
; directory search helper's
;---------------------------------------------------------------------------

; lookup all files in stream and fill tbls w/info
lookup:
	jsr	optsch		; init drive(s)
lookup2:
?05:	ldx	drvnum	
	stz	delind,x
	jsr	srchst		; start search
	bne	?25		; valid entry
?10:	bit	tgflg		; end of dir - search both drives?
	bpl	?40		; no, so exit
	bvs	?40		; other drive already searched, so exit
	jsr	togdrv		; toggle drvnum
	bra	?05		; lookup on other drive
?20:	jsr	search		; find valid fn
	beq	?30		; end of directory
?25:	jsr	compar		; compare dir w/ table
	lda	found		; found flag
	bne	?40		; all fn's found
	lda	entfnd
	bmi	?20		; no match, continue searching dir
	bpl	?25		; last match, compare again tables
?30:	lda	found
	beq	?10		; lookup other drive, if need
?40:	rts

; find next file name matching
; any file in stream & return
; with entry found stuffed into tables
; return N=1 if lookup exhausted, otherwise N=0
; ffst start a search
; findfil continue a search
; ffre re-entry a search
ffre:
	jsr	srre		; find file re-entry
	beq	ffend		; end of directory
	bne	ffcp		; found valid entry

ffst0:	
	jsr	togdrv		; toggle drvnum and start again search
				; lookup it in the other drive
ffst:
	ldx	drvnum		; find file start entry
	stz	delind,x
	jsr	srchst
	bne	ffcp		; found valid entry
	sta	found		; found=0 if end of directory      
ffend:	lda	found		; = $FF if lookup completed
	bne	?04		; exit with N=1
	bit	tgflg		; search both drives?
	bpl	?02		; no, so exit with N=1
	bvc	ffst0		; start searching on the other drive
				; if not already searched
?02:	lda	#$FF		; exit with N=1
?04:	rts

fndfil:
	jsr	search		; find file continuous...
	beq	ffend		; end of directory
ffcp:	jsr	compar		; compare file names and fill tables
	ldx	entfnd
	bpl	?30		; file stream tabulated
	lda	found
	beq	fndfil		; continue searching      
	rts			; N=1 - stop search
?30:	lda	typflg
	beq	?40		; no type restriction - exit N=0
	lda	pattyp,x
	and	#typmsk
	cmp	typflg
	bne	fndfil
?40:	rts			; exit N=0

;compare all filenames in stream table
;  with each valid entry in the 
;  directory and matches are tabulated
;  Z=0,N=1 and found=$FF if table exhausted
;  Z=1,N=0 and found=0 if table not exhausted
;  entfnd = index of matching files stream or $FF in no match
;  at first match this function exit
;  if a search involve both drives, first will be processed table for
;  drvnum and after will be processed table for the other drive
compar:
	ldx	#$FF
	stx	entfnd		; set entry not found
	inx
	stx	patflg
	jsr	?90		; check unfound entry in file stream
	beq	?10		; unfound, so will be tabulated
?02:	rts			; all are found
?05:	jsr	?91		; check next entry in file stream
	bne	?02		; all are found
?10:	lda	drvnum		; current drive
	eor	fildrv,x
	lsr	a
	bcs	?05		; drive doesn't match, check next file
?20:	lda	filtbl,x	; good drive match
	tax			; pointer to pattern
	ldy	#3		; offset of entry name in directory sec
?30:	lda	!cmdbuf,x	; compare byte
	beq	?40		; match filename !
	cmp	[dirp],y
	beq	?32		; match byte
	cmp	#'?'		; '?' match any byte
	bne	?05		; no match so check next entry in file stream 
?32:	inx
	iny
	bra	?30
?40:	ldx	f2ptr		; file name match
	stx	entfnd		; save index in file stream	
	lda	pattyp,x	; store info in tables
	and	#$80
	sta	patflg		; pattern flag
	txy
	ldx	drvnum
	lda	index,x
	tyx
	sta	entind,x
	lda	sector
	sta	entsec,x
	lda	[dirp]
	pha
	and	#$40		; mask on lock bit
	sta	tmp0
	pla
	and	#$FF-$20	; mask off bit 5 ($DF)
	bmi	?42		; if is closed
	ora	#$20		; file not closed: set bit 5
?42:	and	#$27		; mask open bit and type
	ora	tmp0		; plus lock bit
	sta	tmp0
	lda	#$80
	and	pattyp,x	; <7>: pattern
	ora	tmp0		; <6>: lock bit, <5>: closed flag
	sta	pattyp,x	; <2:0>: file type
	ldy	#1		; first track & sector of file
	lda	[dirp],y
	sta	filtrk,x
	iny
	lda	[dirp],y
	sta	filsec,x
	
	; restart table check -- in this way exit always with found=0
	; if tables not exhausted 

; check table for unfound files
?90:	lda	#$FF
	sta	found
	lda	f2cnt
	sta	f2ptr
?91:	dec	f2ptr
	bmi	?99		; table exhausted
				; exit with Z=0,N=1 and found=$FF
	ldx	f2ptr
	lda	pattyp,x
	bmi	?95		; wildcards: still must search
	lda	filtrk,x
	bne	?91		; already tabulated so skip
?95:	lda	#0		; exit with Z=1,N=0...
	sta	found		; ... and found=0  
?99:	rts

; search directory 
;  returns with valid entry w/ delind=0
;  or returns w/ 1st deleted entry w/ delind=1 
;  srchst will initiate a search
;  search will continue a search
;  srre will re-entry a search
srchst:
	ldx	drvnum
	ldy	#0		; init deleted sector
	sty	delsec,x
	dey
	sty	entfnd		; = $FF => not found
	lda	#dirtrk		; start search at beginning
	sta	track
	lda	#dirst		; /1st dir blk
srnews:	sta	sector		; search from beginning or from a new sector     
	jsr	setdptr		; set dir buffer ptr
srnext:	lda	[dirp]		; search next entry
	bne	?02		; not empty entry
	lda	delsec,x	; deleted entry found
	bne	search		; deleted entry already found
	lda	sector		; store sector of empty entry
	sta	delsec,x
	lda	dirp		; get current index of entry
	ldy	delind,x	; bit1: want deleted entry
	sta	delind,x	; store index of empty entry
	beq	search		; delind=0 => want valid entry
	rts			; (Z=0)
?02:	lda	#1
	cmp	delind,x	; ?looking for empty entry?
	beq	search		; yes => continue searching
				; no! found not empty entry
	lda	dirp		; found not empty entry
	sta	index,x		; save index
	lda	sector
	sta	dirsec,x	; save sector
	rts			; (Z=0)

; re-entry from a search	
srre:	
	ldx	drvnum		; get last used accessed search
	lda	#dirtrk
	sta	track
	lda	dirsec,x	; found entry sector
	sta	sector
	jsr	setdptr		; set dir buffer ptr
	lda	index,x		; found entry index
	sta	dirp		; set dir buffer low ptr
	
; continue a searching
search:
	ldx	drvnum
	lda	#$FF
	sta	entfnd
	lda	#32		; incr by 32
	clc
	adc	dirp
	sta	dirp		; next entry...
	bcc	srnext		; ...in same sector
	lda	nxtsec		; next dir sector
	bne	srnews		; not last dir sec 	
	rts			; exit with Z = 1

; toggle drive number in drvnum
togdrv:
	lda	drvnum
	eor	#1
	and	#1
	sta	drvnum
	lda	#$40		; set bit 6 for signaling toggle
	tsb	tgflg
	rts

; set tgflg for search option on both drives and init drive's
; read system directory and check integrity of header
optsch:
	lda	#0
	sta	tgflg
	ldx	f2cnt		; scan file stream
?02:	tay			; option search
	dex			; adjust pointer
	bmi	?06		; end scanning
	lda	fildrv,x
	lsr	a		; CF = drive
	tya
	bcs	?04		; drive #1
	ora	#1		; drive #0 (bit 0)
	bra	?02
?04:	ora	#2		; drive #1 (bit 1)
	bra	?02
?06:	cmp	#3
	bne	?08		; just one drive tabulated in file stream
	lda	#$80		; search both drives flag
	sta	tgflg
?08:	lda	fildrv		; set drvnum for first file on stream
	and	#1
	sta	drvnum
	jsr	drvint		; init drive and system track cache
	bit	tgflg
	bpl	?10		; just one drive
	lda	drvnum
	pha			; save
	eor	#$01		; toggle drive #
	sta	drvnum
	jsr	drvint
	pla			; restore drive #
	sta	drvnum
?10:	rts

;---------------------------------------------------------------------------
; track & sector allocation helper's - bam helper's
;---------------------------------------------------------------------------

; add a new file to directory in first available empty entry
; add a new sector to directory chain if no empty entry available
addfil:
;	;jsr	curblk		; last used accessed search
	stz	cmdsiz		; not null if will be allocated new dir sec	
	lda	type
	pha
	lda	fildrv		; use this drive
	and	#1
	tax			; required drive
	eor	drvnum		; compare with last accessed drive
	lsr	a
	bcc	?08		; same drive, use last accessed search
	stx	drvnum		; set current drive
	lda	#1
	sta	delind,x	; look for empty entry
	jsr	srchst
	beq	?15		; all full, alloc new dir sector
	bne	?18		; found one
?08:	lda	delsec,x	; already called srchst here!!
	beq	?10		; deleted entry not located
	cmp	sector		; resident sector?
	beq	?20		; yes
	sta	sector		; sector of empty entry
	jsr	setdptr	
	bra	?20		; use it
?10:	lda	#1		; find empty entry
	sta	delind,x
	jsr	srre		; restart search
	bne	?18		; found one
?15:	jsr	nxdrbk		; all full, alloc new directory sector
	ldx	drvnum
	lda	sector
	sta	delsec,x
	lda	#2
	sta	delind,x
	bra	?21
?18:	ldx	drvnum
?20:	lda	delind,x
	sta	dirp		; low pointer
?21:	pla
	sta	type		; set type
	sta	pattyp
	sta	[dirp]
	jsr	intts		; allocate init t&s for new file
	lda	track
	sta	filtrk		; ...table & entry
	ldy	#1
	sta	[dirp],y
	lda	sector
	sta	filsec		; set sector link in...
	iny
	sta	[dirp],y	; ...table & entry
	iny
	ldx	filtbl
?22:	lda	!cmdbuf,x	; copy file name	
	beq	?24
	sta	[dirp],y
	inx
	iny
	bra	?22
?24:	sta	[dirp],y	; clear # of blocks &...
	iny			; ...& replace links
	cpy	#30
	bcc	?24
	ldx	drvnum
	lda	delsec,x
	sta	entsec
	lda	delind,x
	sta	entind
	stz	delind,x
	stz	delsec,x
	
	; now must save bam, old dir sector, and new dir sec
	; bam is in phis. sec 1 & 2
	; dir sec 3 is in phis. sec. 2
	jsr	mapout		; save bam if dirty
	lda	cmdsiz		; prev. dir sec. if any
	ldy	entsec		; current dir sec
	tax
	beq	?34
	lsr	a		; to phis. sec.
	inc	a
	cmp	#3
	bcc	?34		; saved with bam
	pha			; save old dir psec
	phy			; save current dir sec
	stx	sector		; write out old dir sec
	jsr	wrdsec
	ply
	sty	sector		; restore current dir sec
	pla
?34:	sta	cmdsiz		; restore old dir psec
	tya			; current dir sec
	sty	sector
	lsr	a
	inc	a		; current dir psec
	cmp	#3
	bcc	?36
	cmp	cmdsiz		; compare with prev, if any
	beq	?36		; already saved
	jsr	wrdsec		; write out current dir sec
?36:	lda	filtrk
	sta	track
	lda	filsec
	sta	sector
	;;sta	dind,x
	;;sta	dsec,x
	rts
	
; allocate next directory block on system track
; and mark as used in bam
; dirp, track & sector filled with current values
nxdrbk:
	lda	sector
	sta	cmdsiz		; save current directory block
	stz	dirp		; pointer to start of current sector
	jsr	nxtds		; allocate a new dir block
	ldy	sector
	cpy	#dirst
	bcc	e_dskful0	; must be > dirst
	lda	track		; put link in current block
	sta	[dirp]
	tya			; sector
	ldy	#1
	sta	[dirp],y	; the new allocated sec
	stz	nxtsec		; this is last dir sec
	jsr	sethdp		; preset dir pointer to header
	clc
	adc	sector		; add sector offset
	sta	dirp+1
	ldy	#1
	lda	#$FF		; put next link: $00, $FF
	sta	[dirp],y
	inc	a
	sta	[dirp]
	iny
?02:	sta	[dirp],y	; clear block
	iny
	bne	?02
	lda	#2		; preset pointer to first entry
	sta	dirp
	rts

; set directory pointer for drvnum and sector
; also, set nxtsec for directory search
; preset dir pointer to first entry on sector
; return X = drive #
setdptr:
	ldx	drvnum
	lda	dirofs,x
	ldy	dirbnk,x
	clc
	adc	sector		; add sector offset
	stz	dirp		; set pointer to dir link
	sta	dirp+1
	sty	dirp+2
	ACC16
	lda	[dirp]		; A = nxt track, B = nxt sector
	tax			; X = nxt track
	xba			; B = nxt track, A = nxt sector
	cmp	#$00FF		; last dir. sector?
	ACC08
	beq	?04		; yes, this is final sector
	cpx	#dirtrk		; check system track
	bne	e_dirlnk	; dir error
	dec	a		; adjust sector
?04:	inc	a		; = 0 if link is $FF	
	sta	nxtsec		; next sector (0 if no more sec)
	ldx	drvnum
	lda	#2		; index of first entry
	sta	dirp
	rts

e_dirlnk:
	lda	#dirlnk
	jmp	doserr

e_dskful0:
	ldx	drvnum		; invalidate drive
	stz	drvfg,x

e_dskful:
	lda	#dskful
	jmp	cmderr

; returns next available trk & sec
; given current t & s
;  allocation is from trk 40
;  towards 1 & 80, by full tracks
nxtts:
	;;jsr	gethdr		; ??? set current t&s for file
	lda	#3
	sta	tmp0		; set pass count

; allocate new directory sector 
nxtds:
	jsr	bamtrk
	lda	[bmpnt]		; free blocks count
	bne	?06		; available blocks
	lda	track
	cmp	#dirtrk		; directory full
	beq	e_dskful	
	bcc	?02		; track < dirtrack
	inc	track		; track > dirtrack
	lda	track
	cmp	#maxtrk
	bne	nxtds
	ldx	#dirtrk-1	; track := dirtrack - 1
	stx	track
	stz	sector
	dec	tmp0
	bne	nxtds       
	beq	e_dskful
?02:	lda	track
	cmp	#startrk
	bcc	?03
	dec	track
	bne	nxtds
?03:	ldx	#dirtrk+1	; start again
	stx	track		; track := dirtrack + 1
	stz	sector
	dec	tmp0
	bne	nxtds
	beq	e_dskful
?06:	inc	sector		; increment current sec
	lda	#numsec		; find next sec
	cmp	sector		; is it over?
	bcs	?10		; no..it's ok
	sec
	lda	sector
	sbc	#numsec
	sta	sector
	beq	?10
	dec	sector		; -1
?10:	jsr	getsec
	bne	wused		; ok, this block is free
?12:	stz	sector		; start again with sector = 0
	jsr	getsec
	bne	wused		; ok

e_direrr:
	lda	#direrr
	jmp	doserr

e_direrr0:
	ldx	drvnum
	stz	drvfg,x		; invalidate drive
	bra	e_direrr

; find first track & sector for a new file
intts:
	lda	#1		; set a counter
	sta	tmp0
?s1:	lda	#dirtrk		; track:= dirtrk-tmp0
	sec
	sbc	tmp0
	sta	track
	php
	cmp	#startrk	; ok?
	bcs	?01		; yes - startrk < track
	plp			; discard
	bra	?s2		; track = 0 so start again toward max track
?01:	plp			; check result of sbc
	bcc	?s2		; if track <= 0...
	beq	?s2		; ...start again toward max track
	jsr	bamtrk		; set the bam pntr
	lda	[bmpnt]		; any free block?
	bne	?10		; found free sector
?s2:	lda	#dirtrk		; trk= dirtrk+tmp0
	clc
	adc	tmp0
	sta	track
	inc	tmp0		; next trk
	cmp	#maxtrk
	bcc	?s3		; ok
	lda	#systs		; error, no free sector
	jmp	doserr
?s3:	jsr	bamtrk		; set ptr
	lda	[bmpnt]
	beq	?s1		; not free... try next track
?10:	stz	sector
	jsr	getsec		; get sector
	beq	e_direrr0	; no free sector
	;;jmp	wused

; sector allocation - mark bam for used sector
wused:
	jsr  	bamtrk		; get bam index
	jsr	bambit
	beq	?10		; used, no action
	lda	[bmpnt],y	; get bits
	eor	>bmask,x	; toggle: mark sec used
	sta	[bmpnt],y
	lda	[bmpnt]		; count -1
	dec	a
	sta	[bmpnt]		; save it
	ldx	drvnum
	lda	#$80
	sta	wbam,x		; set it dirty	
	lda	track
	cmp	#dirtrk
	beq	?10
	txa
	asl	a
	tax
	ACC16
	dec	ndbf,x		; update total free block's
	ACC08
?10:	rts

; free a sector - mark bam for free sector
frets:
	jsr	bamtrk		; mrk bam free
	jsr	bambit
	bne	?10		; free already
	lda	[bmpnt],y	; not free, free it
	ora	bmask,x
	sta	[bmpnt],y
	lda	[bmpnt]
	inc	a		; add one to # blocks free
	sta	[bmpnt]
	ldx	drvnum
	lda	#$80
	sta	wbam,x		; set it dirty
	lda	track
	cmp	#dirtrk
	beq	?10
	txa
	asl	a
	tax
	ACC16
	inc	ndbf,x		; update total free block's
	ACC08
?10:	rts

; find a free block in current track
; return Z = 0 if sector is a free block
; use tmp0
getsec:
	jsr	bamtrk		; set bam and block bit ptr
	jsr	avck		; chk bits & count
?10:	lda	sector
	cmp	#numsec
	bcs	?20		; not free blocks in this track
	jsr	bambit		; get block offset
	bne	?30		; ok is free
	inc	sector		; try next block numb.
	bra	?10		; loop
?20:	lda	#0		; nothing free
?30:	rts			; (z=0): free

; write out bam of current drive, if dirty
; use wtmp, wtmp+1, tmp0
mapout:
	ldx	drvnum
	bit	wbam,x		; dirty?
	bpl	?50		; no, no write
	lda	#maxtrk		; verify bam first
	sta	wtmp		; set trk counter
	lda	dirofs,x	; preset bam ptr
	inc	a		; bam 1
	ldy	dirbnk,x
	sta	bmpnt+1
	inc	a
	sta	wtmp+1		; bam 2
	sty	bmpnt+2
?10:	lda	#bindx		; bam offset
?20:	sta	bmpnt		; lsb
	jsr	avck		; check this trk
	dec	wtmp		; do next trk
	beq	?30		; verify done
	clc			; update bam pointer
	lda	bmpnt
	adc	#6		; 6 byte per trk
	bcc	?20		; same bam
	lda	bmpnt+1
	cmp	wtmp+1
	beq	?30		; end check
	inc	bmpnt+1		; do next bam
	bra	?10
?30:	jsr	bamout		; wrt the bams
?40:	ldx	drvnum
	stz	wbam,x		; set it clean now!
?50:	rts

; check if a block is free or not
; in:	bmpnt = bam pointer
;	sector = block number (0..39)
; out:	Z = 0 if blocks is free
;	Y,X = bam byte index and bit index
bambit:
	lda	sector		; get block bit in bam
	lsr	a		; sectr/8
	lsr	a
	lsr	a
	tay
	iny			; adjust it
	lda	sector		; get remainder
	and	#$07
	tax			; bit mask index
	lda	[bmpnt],y
	and	>bmask,x	; = 0 if not free
	rts

; set bam pointer for track and drvnum
bamtrk:
	ldx	drvnum
	lda	dirbnk,x
	sta	bmpnt+2		; set bank pointer
	ldy	dirofs,x	; high pointer
	iny			; set for bam 1
	lda	track
	cmp	#41		; which bam ?
	bcc	?04		; bam1
	sbc	#40		; range 40 trk per bam
	iny			; it's bam2
?04:	sty	bmpnt+1
	asl	a		; trk x6 offset
	sta	bmpnt		; save x2
	asl	a		; x4
	clc			; total=x6
	adc	bmpnt		;
	adc	#bindx-6	; bam offset -1 trk blk
	sta	bmpnt
	rts

; check count of free blocks in track
; use tmp0
avck:
	stz	tmp0		; blk counter
	ldy	#bamsiz-1	; offset of last byte
?10:	ldx	#8		; bit counter
	lda	[bmpnt],y
?20:	asl	a		; used ?
	bcc	?30		; no
	inc	tmp0		; count it
?30:	dex
	bne	?20		; do next bit
	dey			; do next byte
	bne	?10
	lda	[bmpnt]		; stored count of free blocks
	cmp	tmp0
	bne	?40		; counts don't match
        rts
?40:	lda	#bamcnt
	jmp	cmderr

; build bam for an empty new disk
newmap:
	ldx	drvnum		; init buffer for bam1&bam2
	lda	dirofs,x
	ldy	dirbnk,x
	clc
	adc	#numsec		; buffer allocated after dir. cache
	inc	a		; +1
	sta	bmpnt+1		; bmpnt -> bam 1
	sty	bmpnt+2
	inc	a
	sta	tlp+1		; tlp -> bam 2
	sty	tlp+2
	stz	bmpnt
	stz	tlp
	ldy	#0
	tya
?02:	sta	[bmpnt],y	; clear bam1&bam2
	sta	[tlp],y
	iny
	bne	?02
	lda	#dirtrk		; link to bam2
	sta	[bmpnt]		; set trk links
	tya			; Y=0 -- end trk link
	sta	[tlp]		;
	lda	#2		; link to bam2
	iny			; 1
	sta	[bmpnt],y
	lda	#$ff		; sector end link
	sta	[tlp],y
	lda	#dskvern	; disk version number
	iny			; 2
	sta	[bmpnt],y
	sta	[tlp],y
	eor	#$FF		; complement  
        iny			; 3
	sta	[bmpnt],y
	sta	[tlp],y
	lda	!dskid1,x	; ID 1
	iny			; 4
	sta	[bmpnt],y
	sta	[tlp],y
	lda	!dskid2,x	; ID 2
	iny			; 5
	sta	[bmpnt],y
	sta	[tlp],y
	lda	#iobyte		; default i/o byte
	iny			; 6
	sta	[bmpnt],y
	sta	[tlp],y
?04:	ldy	#bindx		; bam offset
?06:	lda	#numsec
	sta	[bmpnt],y	; store free block's in this track
	iny
	ldx	#5		; bytes counter
	lda	#$FF		; all free
?08:	sta	[bmpnt],y	; write out bit map
	iny
	dex
	bne	?08
	tya			; done?
	bne	?06		; no
	lda	bmpnt+1
	cmp	tlp+1		; both bams done?
	beq	?10		; yep...
	inc	bmpnt+1		; do the next bam
	bra	?04		; next bam
?10:	ACC16
	lda	#maxblks	; max. available block's
	sta	wtmp
	ACC08
	dec	bmpnt+1		; back to bam 1
	lda	#dirtrk		; alloc sector for system track
	asl	a		; trk x6 offset
	sta	bmpnt		; save x2
	asl	a		; x4
	clc			; total=x6
	adc	bmpnt		;
	adc	#bindx-6	; bam offset -1 trk blk
	sta	bmpnt		; pointer to bitmap for system track
	stz	sector		; allocate 3 sectors & directory sector
	jsr	?20		; sec. 0
	inc	sector
	jsr	?20		; sec. 1
	inc	sector
	jsr	?20		; sec. 2
	inc	sector		; sec. 3 usually for dir.
?20:	jsr	bambit
	beq	?30		; used, no action
	lda	[bmpnt],y	; get bits
	eor	>bmask,x	; toggle: mark sec used
	sta	[bmpnt],y
	lda	[bmpnt]		; count -1
	dec	a
	sta	[bmpnt]		; save it
?30:	rts

; build a new disk header in system cache
newhdr:
	ldy	#1
	lda	#dirtrk		; directory track
	sta	[dirp]
	lda	#dirst		; link to first dir. block
	sta	[dirp],y
	iny			; 2
	lda	#dskvern
	sta	[dirp],y	; disk version number
	iny
	iny			; 4
	ldx	filtbl		; ptr to disk name
?02:	lda	!cmdbuf,x	; store disk name
	beq	?04
	sta	[dirp],y
	iny
	inx
	bra	?02
?04:	lda	#$A0
	sta	[dirp],y	; 20
	iny
	sta	[dirp],y
	iny			; 22
	ldx	drvnum
	lda	!dskid1,x	; store ID 1
	sta	[dirp],y
	iny			; 23
	lda	!dskid2,x	; store ID 2
	sta	[dirp],y
	iny			; 24
	lda	#$A0
	sta	[dirp],y
	iny			; 25
	lda	#dosvern	; store dos version number
	sta	[dirp],y
	iny			; 26
	lda	#dskvern
	sta	[dirp],y	; disk version number
	iny			; 27
	lda	#$A0
	sta	[dirp],y
	iny			; 28
	lda	#$A0
	sta	[dirp],y
	ldy	#30
	lda	#subvern	; store sub-version
	sta	[dirp],y
	iny			; 31
	eor	#$FF
	sta	[dirp],y
	CPU16
	jsr	gctime16	; compact time&date (ret CPU16)
	ldy	#32
	sta	[dirp],y	; store 32 bit serial
	txa
	iny
	iny
	sta	[dirp],y
	lda	#maxblks
	sta	wtmp
	CPU08	
	rts

;---------------------------------------------------------------------------
; file system check routines
;---------------------------------------------------------------------------

; mark aux bam for used sector
mkbam:
	ldx	drvnum		; set pointer to aux bam
	lda	dirofs,x
	ldy	dirbnk,x
	sty	bmpnt+2	
	clc
	adc	#numsec		; buffer allocated after dir. cache
	inc	a		; +1
	tay
	lda	sector
	cmp	#numsec
	bcs	?04
	lda	track
	beq	?04
	cmp	#maxtrk
	bcs	?04
	cmp	#41		; which bam ?
	bcc	?02		; bam1
	sbc	#40		; range 40 trk per bam
	iny			; it's bam2
?02:	sty	bmpnt+1
	asl	a		; trk x6 offset
	sta	bmpnt		; save x2
	asl	a		; x4
	clc			; total=x6
	adc	bmpnt		;
	adc	#bindx-6	; bam offset -1 trk blk
	sta	bmpnt
	jsr	bambit
	beq	?04		; used, no action
	lda	[bmpnt],y	; get bits
	eor	>bmask,x	; toggle: mark sec used
	sta	[bmpnt],y
	lda	[bmpnt]		; count -1
	dec	a
	sta	[bmpnt]		; save it
	lda	track
	cmp	#dirtrk
	beq	?04
	ACC16
	dec	ntot		; update total free block's
	ACC08
?04:	rts

; check file consistency and update aux bam
; enter with start t&s of the file
chkfil:
	lda	sector		; save dir. sector
	sta	entsec
	lda	[dirp]
	sta	type
	ldy	#1
	lda	[dirp],y
	sta	track		; set up first t&s
	iny
	lda	[dirp],y
	sta	sector	
	lda	#'"'
	sta	!nambuf2
	ldx	#0
	iny
?02:	lda	[dirp],y
	bmi	?04
	sta	!nambuf2+1,x
	iny
	inx
	cpx	#16
	bcc	?02
?04:	lda	#'"'
	sta	!nambuf2+1,x
	stz	!nambuf2+2,x
	ldy	#28		; check block's count
	ACC16
	lda	[dirp],y
	sta	wtmp		; stored file block's count
	stz	wcnt		; clear block's counter
	ACC08
	lda	type
	bmi	?12
	lda	#^nambuf2
	pha
	pea	#!nambuf2
	phk			; splat file msg
	pea	#!?100
	lda	#7
	pha
	BPRINTF
	bit	wrop
	bmi	?08		; ok, delete splat file
	jmp	?90		; skip & exit
?08:	lda	#0		; delete entry
	sta	[dirp]
	lda	entsec
	sta	sector
	jsr	wrdsec		; update dir
	ldx	#^?105
	lda	#>?105
	xba
	lda	#<?105
	SCNSTROUT
?10:	rts
?12:	and	#typmsk
	cmp	#reltyp
	beq	?10		; skip
	cmp	#partyp
	beq	?10		; skip
	lda	track
	beq	?13		; invalid track
	cmp	#maxtrk
	bcs	?13		; invalid track
	lda	sector
	cmp	#numsec
	bcc	?14		; invalid sector?
?13:	jmp	?30
?14:	jsr	tread		; read whole track in cache
	jsr	setcp		; set cache ptr to right sector
?16:	ACC16CLC
	inc	wcnt		; update file block's counter
	dec	bcnt		; update total free block's
	lda	wtmp		; stored block's #
	adc	#32		; add a guard
	cmp	wcnt		; compare with computed block's #
	ACC08
	bcs	?17
	jmp	?50		; hmmm...never reach end of file? 
?17:	jsr	mkbam		; mark aux bam
	ldy	#1
	lda	[bufp],y	; next sector
	tay
	lda	[bufp]		; next track
	beq	?18		; end of file?
	cmp	#maxtrk
	bcs	?17a		; invalid track in link
	cpy	#numsec		; invalid sector in link?
	bcc	?17b	
?17a:	jmp	?40
?17b:	sty	sector		; next sector
	cmp	track		; same track?
	sta	track
	bne	?14		; will read a new track	
	clc
	tya
	ldx	drvnum
	adc	trkofs,x	; sector in the same track
	sta	bufp+1
	;jsr	mkbam		; mark aux bam
	bra	?16		; follow link	
?18:	cpy	#2		; in last block must be >= 2
	bcc	?20
	ACC16
	lda	wtmp		; check block's count
	cmp	wcnt
	ACC08
	beq	?10		; ok, match -- exit
	pei	(wtmp)
	pei	(wcnt)
	lda	#^nambuf2
	pha
	pea	#!nambuf2
	phk			; unmatch msg
	pea	#!?115
	lda	#11
	pha
	BPRINTF
	bit	wrop
	bmi	?19
	jmp	?90		; skip & exit
?19:	ldy	#28		; correct
	ACC16
	lda	wcnt
	sta	[dirp],y
	ACC08
	lda	entsec
	sta	sector
	jsr	wrdsec		; update dir
	ldx	#^?130
	lda	#>?130
	xba
	lda	#<?130
	SCNSTROUT	
	rts
?20:	lda	sector
	pha
	lda	track
	pha
	phy			; last ptr
	lda	#^nambuf2
	pha
	pea	#!nambuf2
	phk			; corrupted last link
	pea	#!?120
	lda	#10
	pha
	BPRINTF
	rts			; no correction possible here
?30:	lda	sector		; invalid start track and/or sector
	pha
	lda	track
	pha 
	lda	#^nambuf2
	pha
	pea	#!nambuf2
	phk
	pea	#!?125
	lda	#9
	pha
	BPRINTF
	bit	wrop
	bpl	?90		; skip
	jmp	?08		; delete entry

?40:	ldx	sector		; invalid link
	phx
	ldx	track
	phx
	phy			; possible invalid sec link
	pha			; possible invalid trk link
	lda	#^nambuf2
	pha
	pea	#!nambuf2
	phk
	pea	#!?135
	lda	#11
	pha
	BPRINTF
	bit	wrop
	bpl	?90		; skip
	jmp	?08		; delete entry

?50:	lda	#^nambuf2	; eof not found...
	pha
	pea	#!nambuf2
	phk
	pea	#!?140
	lda	#7
	pha
	BPRINTF
	bit	wrop
	bpl	?90		; skip
	jmp	?08		; delete entry

?90:	ldx	#^?110		; show 'skip' msg & exit
	lda	#>?110
	xba
	lda	#<?110
	SCNSTROUT
	rts

?100:	.DB	$0D, 'file %s: not closed...', 0
?105:	.DB	'deleted.', 0
?110:	.DB	'skip.', 0
?115:	.DB	$0D, 'file %s: unmatch blocks count (actual %hu vs. %hu)...', 0
?120:	.DB	$0D, 'file %s: last link (t:0,s:%bu) corrupted at t:%bu,s:%bu.', 0
?125:	.DB	$0D, 'file %s: invalid start block (t:%bu,s:%bu)...', 0
?130:	.DB	'correct.', 0
?135:	.DB	$0D, 'file %s: invalid link (t:%bu,s:%bu) at t:%bu,s:%bu...', 0
?140:	.DB	$0D, 'file %s: EOF not found...', 0

; check directory consistence & update aux bam
chkdir:
	lda	#dirtrk
	sta	track
	stz	sector
	jsr	tread		; read whole track in cache
	jsr	setcp		; set cache ptr to right sector
?02:	jsr	mkbam		; mark aux bam
	ldy	#1
	lda	[bufp],y	; next sector
	tay
	lda	[bufp]		; next track
	beq	?04		; end of dir?
	sty	sector		; next sector
	cmp	track		; same track?
	sta	track
	bne	?10		; error!	
	clc
	tya
	ldx	drvnum
	adc	trkofs,x	; sector in the same track
	sta	bufp+1
	bra	?02		; follow link	
?04:	cpy	#$FF		; must be $FF
	beq	?15
?10:	lda	sector
	pha
	phy			; last ptr
	lda	track
	pha
	phk			; unmatch msg
	pea	#!?20
	lda	#7
	pha
	BPRINTF
?15:	rts

?20:	.DB	$0D, 'directory: wrong link (t:%bu,s:%bu) at sector %bu', 0

; report file block's count & update bam if validation
updbam:
	jsr	?30		; for safety check again aux bam free block's
	ACC16
	lda	ntot
	cmp	wtmp
	ACC08
	beq	?06
	pei	(wtmp)
	pei	(ntot)
	phk
	pea	#!?65
	lda	#8
	pha
	BPRINTF
?02:	bit	wrop
	bpl	?04
	lda	#>?70
	xba
	lda	#<?70
	ldx	#^?70
	SCNSTROUT
?04:	rts
?06:	pei	(bcnt)
	phk
	pea	#!?50
	lda	#6
	pha
	BPRINTF
	pei	(ntot)
	phk
	pea	#!?55
	lda	#6
	pha
	BPRINTF
	lda	drvnum
	asl	a
	tax
	lda	ndbf,x
	ldy	ndbf+1,x
	phy
	pha
	phk
	pea	#!?60
	lda	#6
	pha
	BPRINTF
	ACC16
	lda	bcnt
	cmp	ntot
	ACC08
	beq	?08
	pei	(ntot)
	pei	(bcnt)
	phk
	pea	#!?75
	lda	#8
	pha
	BPRINTF
	bra	?02
	
	; ok, bam can be updated
?08:	bit	wrop
	bpl	?10		; no bam update
	jsr	sethdp		; update bam on disk
	inc	dirp+1		; set up bam
	ldx	drvnum		; set pointer to aux bam
	lda	#$80
	sta	wbam,x		; set bam dirty
	lda	dirofs,x
	ldy	dirbnk,x
	sty	bmpnt+2	
	clc
	adc	#numsec		; buffer allocated after dir. cache
	inc	a		; +1
	sta	bmpnt+1
	stz	bmpnt		; ptr to new bam
	INDEX16
	ldy	#$01FF		; transfer the new bam
?09:	lda	[bmpnt],y
	sta	[dirp],y
	dey
	bpl	?09
	INDEX08
	lda	#>?85
	xba
	lda	#<?85
	ldx	#^?85
	SCNSTROUT
	jsr	mapout		; write out map
	lda	#>?80
	xba
	lda	#<?80
	ldx	#^?80
	SCNSTROUT
?10:	rts
?30:	; calc # of blocks free
	stz	wtmp
	stz	wtmp+1
	ldy	#startrk
	dey
?32:	iny
	sty	track
	cpy	#dirtrk
	beq	?32		; skip dir track
	cpy	#maxtrk		; done ?
	bcs	?34		; yes
	jsr	?40		; set up next bam trk
	ldy	track		; retrivie track
	lda	#0
	xba			; B = 0
	lda	[bmpnt]		; A = get blks free
	ACC16CLC
	adc	wtmp		; up data count
	sta	wtmp
	ACC08
	bra	?32
?34:	rts

?40:	ldx	drvnum		; set pointer to aux bam
	lda	dirofs,x
	ldy	dirbnk,x
	sty	bmpnt+2	
	clc
	adc	#numsec		; buffer allocated after dir. cache
	inc	a		; +1
	tay
	lda	track
	cmp	#41		; which bam ?
	bcc	?42		; bam1
	sbc	#40		; range 40 trk per bam
	iny			; it's bam2
?42:	sty	bmpnt+1
	asl	a		; trk x6 offset
	sta	bmpnt		; save x2
	asl	a		; x4
	clc			; total=x6
	adc	bmpnt		;
	adc	#bindx-6	; bam offset -1 trk blk
	sta	bmpnt
	rts

?50:	.DB	$0D, 'total computed free block''s:     % 4hu.', 0
?55:	.DB	$0D, 'total free block''s from new BAM: % 4hu.', 0
?60:	.DB	$0D, 'total free block''s from old BAM: % 4hu.', 0
?65:	.DB	$0D, 'new BAM free block''s unmatch: %hu vs. %hu.', 0
?70:	.DB	$0D, 'BAM on disk cannot be updated.', 0
?75:	.DB	$0D, 'computed free block''s (%hu) unmatch new BAM count (%hu).', 0
?80:	.DB	$0D, 'file system is clean.', 0
?85:	.DB	$0D, 'update BAM on disk...', 0

;---------------------------------------------------------------------------
; drive's initialitation
;---------------------------------------------------------------------------

; check directory header
; X = drive #
; return CF = 0 if ok, otherwise CF = 1
hdrtst:
	jsr	sethdp		; set dir pointer
	lda	[dirp]		; track link
	cmp	#dirtrk
	bne	?02		; error
	ldy	#1
	lda	[dirp],y	; sec link
	cmp	#dirst
	bne	?02		; error
	iny
	lda	[dirp],y	; disk version number
	cmp	#dskvern
	bne	?02		; error
	ldy	#26
	cmp	[dirp],y	; compare with vernum at offset 26
	bne	?02		; error
	dey			; offset 25
	lda	[dirp],y	; dos version number
	cmp	#dosvern
	bne	?02		; error
	ldy	#22
	lda	[dirp],y	; disk ID 1
	sta	!dskid1,x
	iny
	lda	[dirp],y	; disk ID 2
	sta	!dskid2,x
	lda	#$F7
	and	drvfg,x		; clear bit 3 (assume no new version)
	sta	drvfg,x
	ldy	#30
	lda	[dirp],y	; disk sub-version
	beq	?01		; standard version
	cmp	#subvern
	bne	?01
	eor	#$FF		; compliment
	iny			; offset 31
	cmp	[dirp],y	; compare with sub-ver at ofs. 30
	bne	?01		; standard version
	lda	#$08		; set bit 3: new version
	ora	drvfg,x
	sta	drvfg,x
	iny			; offset 32: serial 32 bit
	txa
	asl	a		; * 4 - index double word
	asl	a
	tax
	ACC16
	lda	[dirp],y	; store serial
	sta	!dskser,x
	iny
	iny
	lda	[dirp],y	
	sta	!dskser+2,x
	ACC08
	ldx	drvnum
?01:	inc	dirp+1		; set ptr to bam1
	lda	[dirp]		; track link
	cmp	#dirtrk
	bne	?02		; error
	ldy	#1
	lda	[dirp],y	; sec link
	cmp	#dirst-1	; will be 1 below of dir start
	beq	?04		; ok
?02:	sec			; return disk id mismatch error
?03:	rts
?04:	jsr	chkbam		; check bam 1 header
	bcs	?03		; error
	lda	[dirp],y	; bam 1 iobyte
	bpl	?06
	lda	#$20		; set bit 5 drive flag
	ora	drvfg,x
	sta	drvfg,x
?06:	inc	dirp+1		; set ptr to bam2
	lda	[dirp]		; track link
	bne	?02		; error, will be 0
	ldy	#1
	lda	[dirp],y	; sec link
	cmp	#$FF
	bne	?02		; error, will be $FF
	jsr	chkbam		; check bam 2 header
	bcs	?03		; error
	lda	[dirp],y	; bam 1 iobyte
	bpl	nfcalc
	lda	#$20		; set bit 5 drive flag
	bit	drvfg,x
	beq	?02		; mismatch with bam 1

; calc # of disk blocks free
nfcalc:
	lda	track
	pha
	lda	drvnum
	asl	a
	tax			; index
	stz	ndbf,x
	stz	ndbf+1,x
	stx	tmp0		; save index
	ldy	#startrk
	dey
?02:	iny
	sty	track
	cpy	#dirtrk
	beq	?02		; skip dir track
	cpy	#maxtrk		; done ?
	bcs	?04		; yes
	jsr	bamtrk		; set up next bam trk
	ldy	track		; retrivie track
	lda	#0
	xba			; B = 0
	lda	[bmpnt]		; A = get blks free
	ldx	tmp0		; retrivie index
	ACC16CLC
	adc	ndbf,x		; up data count
	sta	ndbf,x
	ACC08
	bra	?02
?04:	clc
	pla
	sta	track
	ldx	drvnum
	rts			; return with carry = 0

; check bam header
; Y = 1 when called
chkbam:
	iny
	lda	[dirp],y	; bam disk version number
	cmp	#dskvern
	bne	?02		; error
	iny			; offset 3
	eor	#$FF		; complement
	cmp	[dirp],y	; bam1 compl. disk version number
	beq	?04
?02:	sec			; return disk id mismatch error
	rts
?04:	iny			; offset 4
	lda	[dirp],y	; bam disk id 1
	cmp	!dskid1,x
	bne	?02
	iny			; offset 5
	lda	[dirp],y	; bam disk id 2
	cmp	!dskid2,x
	bne	?02
	iny
	clc			; ok
	rts
	
; set pointer to directory header
; return with X = drive
sethdp:
	ldx	drvnum
	lda	dirofs,x
	ldy	dirbnk,x
	stz	dirp		; set pointer to system track cache
	sta	dirp+1
	sty	dirp+2
	rts

; set pointer to track cache & sector
; return with X = drive
setcp:
	ldx	drvnum
	lda	trkofs,x
	ldy	trkbnk,x
	stz	bufp		; set pointer to track cache
	clc
	adc	sector
	sta	bufp+1
	sty	bufp+2
	rts

; set pointer to write cache & sector
; return with X = drive
setwb:
	ldx	drvnum
	lda	wrtofs,x
	ldy	wrtbnk,x
	stz	wbuf		; set pointer to write cache
	clc
	adc	sector
	sta	wbuf+1
	sty	wbuf+2
	rts

; drive initialitation
; check if drive is ready or if disk was changed
; get low level disk format
; read system track (logical track 40) and put in cache
; fill drvfg flag for the given drive
drvint:
	jsr	fmttst		; check low level disk format...
	lda	drvfg,x		; ...if drive is ready
	bmi	?10		; system track already in cache
	lsr	a		; if <0> = 0 => ibm disk
	bcc	?02
	lsr	a		; if <1> = 0 => DD cbm disk
	bcc	?04
	lda	#badfmt		; unsupported HD cbm format
	jmp	drverr
?02:	lda	#ibmfmt		; is ibm format
	jmp	drverr
?04:	jsr	sysrd		; read system track into cache	
	bcs	?06		; error reading system track
	jsr	hdrtst		; check directory header
	bcc	?08		; ok
	lda	#badid		; mismatch header
	bra	drverr
?06:	lda	#syterr
	bra	drverr
?08:	ldx	drvnum		; set good flag for drive
	lda	#$80
	ora	drvfg,x
	sta	drvfg,x
?10:	rts

; test if disk is low-level formatted
; report format in drvfg
; return with X = drive
fmttst:
	jsr	dsktst		; check if disk inside drive
	bit	drvfg,x		; check if already tested
	bvs	?04		; yes, format already recognized
	FDCGETFMT		; query disk format
	bcc	?02		; ok, recognized format
	lda	#badfmt
	bra	drverr
?02:	tya			; format in bit 1,0
	ora	#$40
	ora	drvfg,x
	sta	drvfg,x
?04:	rts

; check if disk is inserted on a drive
; return with X = drive
dsktst:
	ldx	drvnum		; drive 0 or 1
	FDCTST			; check if disk inserted
	bcs	?02		; check if disk was changed
	bit	drvfg,x		; check if disk was inside drive at boot time
	bmi	?08		; no, already init so exit
	bpl	?07		; invalidate all cached data
?02:	cpy	#FDC_CHANGE	; check error code
	beq	?06		; disk changed
?04:	lda	#nodriv		; abort: no disk
	jmp	cmderr
?06:	FDCTST			; check again
	bcs	?04		; fatal error
?07:	stz	drvfg,x		; invalidate drive flags bcs disk changed
	stz	wbam,x
	stz	dirsec,x
	stz	index,x
	stz	delind,x
	stz	delsec,x
	stz	tcache,x
	stz	wcache,x	
	FDCGETST		; get status drive
	bcs	?04
	tya
	asl	a		; test bit 6
	bpl	?08
	lda	#$10
	sta	drvfg,x
?08:	rts

;---------------------------------------------------------------------------
; error procedure's
;---------------------------------------------------------------------------

; main error procedure
; in:	A = error code
;	track & sector
;		t & s = 0 for command error
;		t = drvnum for drive error level
;		t = chnl for channel error level
; abort any procedure and return to caller with error code

chnerr:
	ldx	chnl
	stx	track
	stz	sector
	bra	doserr

drverr:
	ldx	drvnum		; track = drive #
	stx	track
	stz	sector

doserr:
	sta	lsterr		; last error
	ldx	track		; save track & sector for later use
	stx	etrk
	ldx	sector
	stx	esec
	bit	trap		; set flag while open functiom
	bpl	?10
	jsr	frefd		; free fd
	stz	trap
?10:	INDEX16
	ldx	tos
	txs			; recover stack pointer
	INDEX08
	sec			; error code in accum.
	rts

; format error message -- called reading channel 15
fmterr:
	jsr	fnderr		; find error string
	ldx	esec		; push params for _bsprintf
	phx			; sector (1b)
	ldx	etrk
	phx			; track (1b)
	phk			; error string bank (1b)
	pei	(tlp)		; error string ptr (2b)
	lda	lsterr	
	pha			; error code (1b)
	pea	#cmdlen		; size of dest. string (2b)
	lda	#^cmdbuf	; dest string bank (1b)
	pha
	pea	#cmdbuf		; dest string pointer (2b)
	phk			; fmt string bank (1b)
	pea	#erfmt		; fmt string pointer (2b)
	lda	#15
	pha			; # params bytes (1b)
	BSPRINTF
	ACC16
	sta	btrf		; save count of bytes
	ACC08
	rts

; find basic error string
fnderr:
	lda	lsterr
	beq	?00
	cmp	#cbmv2
	bne	?01
?00:	stz	etrk
	stz	esec
?01:	lda	#<ertbl
	sta	tlp
	lda	#>ertbl
	sta	tlp+1
	lda	#^ertbl
	sta	tlp+2
?02:	lda	[tlp]		; check error code
	cmp	lsterr
	beq	?10		; match
	ldy	#1
?04:	lda	[tlp],y
	beq	?06		; end of string
	iny
	bra	?04		; find end of string
?06:	iny
	lda	[tlp],y
	beq	?08		; end of table -- string not found
	clc
	tya
	adc	tlp
	sta	tlp
	bcc	?02		; next string
	inc	tlp+1
	bra	?02
?08:	lda	#<uerr		; unknow error
	sta	tlp
	lda	#>uerr
	sta	tlp+1
	bra	?12
?10:	inc	tlp		; found string
	bne	?12
	inc	tlp+1
?12:	rts

;---------------------------------------------------------------------------
; phisycal access to disk
;---------------------------------------------------------------------------
	
; read system track
; return CF=1 if error
; X=drive #
sysrd:
	stx	pdrv	
	lda	#5		; try to read system track
	sta	tmp0		; set pass count
?02:	phx			; drive #
	lda	#dirtrk-1	; physical system track
	pha
	lda	sysbuf,x	; dma buffer #
	pha
	lda	#1		; cbm format
	pha
	FDCTKRD			; read whole track
	ldx	pdrv
	bcc	?04
	dec	tmp0
	bne	?02		; try again
?04:	rts

; read whole track into drive read cache, if not already in cache
tread:
	ldx	drvnum
	lda	tcache,x	; invalid cache?
	beq	?02		; yes so read track
	cmp	track		; already in cache?
	beq	?04		; yes
	stz	tcache,x	; invalidate cache
?02:	lda	trkbuf,x	; dma buffer #
	jsr	readtk
	;ldx	drvnum
	lda	track
	sta	tcache,x	; validate cache
?04:	rts

; read whole track into drive write cache, if not already in cache
wread:
	ldx	drvnum
	lda	wcache,x	; invalid cache?
	beq	?02		; yes so read track
	cmp	track		; already in cache?
	beq	?04		; yes
	stz	wcache,x	; invalidate cache
?02:	lda	wrtbuf,x	; dma buffer #
	jsr	readtk
	;ldx	drvnum
	lda	track
	sta	wcache,x	; validate cache
?04:	rts

; write out the system track
syswr:
	ldy	#dirtrk
	sty	track
	ldx	drvnum
	lda	sysbuf,x	; dma buffer #

; write out a whole track from dma buffer
; in:	A=dma buffer#
;	X=drive #
;	track=logical track
writetk:
	sta	pbuf		; dma buffer #
	stx	pdrv
	lda	#5		; write out whole track
	sta	tmp0		; set pass count
?02:	phx			; drive #
	lda	track
	dec	a		; phisycal track
	pha
	lda	pbuf
	pha			; dma buffer #
	lda	#$81
	pha			; cbm format
	FDCTKWR
	ldx	pdrv
	bcc	lsp		; ok no error
	dec	tmp0
	bne	?02		; try again
	lda	#wrtrk
	jmp	doserr

; update on disk bam of current drive
; write out logical sector 1 & 2 (phisycal sec 1 & 2)
bamout:
	lda	#2
	sta	pcnt		; number of sector's to write out
	ldx	drvnum		; X = drive #
	lda	sysbuf,x	; dma buffer #
	xba			; B = dma buffer #
	lda	#1		; A = first phisycal sector to write
	ldy	#0		; Y = side 0
	bra	wrsys2

; write given directory sector on disk
; A = number of sec. to write out
wrsys:
	sta	pcnt		; number of sector's to write out
	jsr	lsec2p		; convert logical sec to phis. sec & side

; X=drive #
; Y=side
; A=start phisycal sec
; B=dma buffer #
; tpcnt=count #
wrsys2:
	sta	psec		; first phisycal sector
	xba
	sta	pbuf		; dma buffer #
	stx	pdrv
	sty	pside
	lda	#dirtrk
	sta	track
	
	; prepare stack params for call system function:
	; FDCWRITE(bDrive, bTrk, bHead, bSect, bNum, bBuf, bFlag)
	lda	#5
	sta	tmp0		; set pass count
?02:	phx			; drive #
	lda	track
	dec	a		; phisycal track
	pha
	lda	pside
	pha			; side (head)
	lda	psec
	pha			; phisycal sector
	lda	pcnt
	pha			; sector's count to write out
	lda	pbuf
	pha			; dma buffer
	lda	#$81		; A = 1
	pha			; flag (cbm format, verify)
	FDCWRITE
	ldx	pdrv
	bcc	lsp
	dec	tmp0
	bne	?02		; try again
	stz	drvfg,x		; ...invalidate drive #
	lda	#wrsec		; write error
	jmp	doserr
	
; translate logical sector into phisycal sector & side
; in:	sector = logical sector
; out:	X = drive #
;	A = sector #
;	Y = side #
;	B = dma buffer #
lsec2p:
	ldx	drvnum
	lda	sector		; 0..39
	lsr	a		; 0..19
	tay			; save
	clc			; add base dma buffer
	adc	sysbuf,x		
	xba			; B = dma buffer # that contain phis. sec.
	tya
	ldy	#0		; side 0
	cmp	#phisec		; 0..9 -> side 0, 10..19 -> side 1
	bcc	?02
	sbc	#phisec
	iny			; side 1
?02:	inc	a		; A = phisycal sec
lsp:	rts

; read a whole track into dma buffer
; in:	A=dma buffer#
;	X=drive #
;	track=logical track
readtk:
	sta	pbuf		; dma buffer #
	stx	pdrv
	lda	#5
	sta	tmp0		; set pass count
?02:	phx			; drive #
	lda	track		; physical track
	dec	a
	pha
	lda	pbuf		; dma buffer #
	pha
	lda	#1		; cbm format
	pha
	FDCTKRD			; read whole track
	ldx	pdrv
	bcc	lsp		; ok, no error
	dec	tmp0
	bne	?02		; try again
	lda	#rdtrk		; error reading whole track
	jmp	doserr

; write out sector(s) from dma buffer
; in:	X=drive
;	Y=start phisycal sector
;	A=sector's count #
;	B=dma buffer #
;	pside=side
; use tmp0
writesec:
	sta	pcnt		; count #
	xba
	sta	pbuf		; dma buffer #
	sty	psec
	stx	pdrv
	lda	#5		; set pass count
	sta	tmp0
?02:	phx			; drive #
	lda	track
	dec	a
	pha			; phisycal track
	lda	pside
	pha			; side
	lda	psec
	pha			; start phisycal sector
	lda	pcnt
	pha			; count #: how much sec's
	lda	pbuf
	pha			; dma buffer #
	lda	#$81
	pha			; cbm format
	FDCWRITE
	ldx	pdrv
	bcc	lsp		; ok no error
	dec	tmp0
	bne	?02		; try again
	lda	#wrsec
	jmp	doserr

; read sector(s) into dma buffer
; use tmp0
readsec:
	lda	#5		; set pass count
	sta	tmp0
?02:	lda	pdrv		; drive #
	pha
	lda	track
	dec	a
	pha			; phisycal track
	lda	pside
	pha			; side
	lda	psec
	pha			; start phisycal sector
	lda	pcnt
	pha			; count #: how much sec's
	lda	pbuf
	pha			; dma buffer #
	lda	#1
	pha			; cbm format
	FDCREAD
	ldx	pdrv
	bcc	lsp		; ok no error
	dec	tmp0
	bne	?02		; try again
	lda	#rdsec
	jmp	doserr

;---------------------------------------------------------------------------
; low level format
;---------------------------------------------------------------------------

llfmt:
	jsr	?110
	lda	drvnum
	pha			; drive #
	lda	#$C1
	pha			; flag (notify, verify, cbm fmt)
	lda	#0
	pha			; fill byte
	phk			; adress of callback
	pea	#!?08
	FDCFORMAT
	bcc	?06		; ok
	cpy	#FDC_WP
	bne	?02
	lda	#wpon
	bra	?04
?02:	lda	#fmter
?04:	jmp	drverr
?06:	rts

; callback function while formatting
; In	- A = drive
;	  X = head
;	  Y = track
;	  B = sector/track
;	  CF = 0 when called first time
?08:
	phd			; save DP
	pea	#CBMFSP0	; set new DP
	pld
	phx	
	iny			; show track 1..80
	phy
	bcs	?10
	SCNGETPOS		; first time get position on screen
	stx	wtmp
	sty	wtmp+1
	;;SCN_CR
	;;bra	?20
?10:	ldx	wtmp
	ldy	wtmp+1
	SCNSETPOS
?20:					
				; X = head - param format in stack
				; Y = track - param format in stack
	pha			; A = drive #
	phk			; bank of format str
	pea	#!?100		; address of format str
	lda	#7		; # params
	pha
	BPRINTF
	pld
	rtl

?100:	.DB	'format diskette on drive #%bu (track #%02bu, side #%bu)', $00

?110:	; format msg
	lda	drvnum
	pha
	phk
	pea	#!?120
	lda	#5
	pha
	BPRINTF
	lda	#>?130
	xba
	lda	#<?130
	ldx	#^?130
	SCNSTROUT
	rts

?120:	.DB	$0D, 'Format diskette on drive #%bu - cbm 1581 format type', 0
?130:	.DB	$0D, 'Sides: 2, tracks: 80/side, sectors: 10/track, total: 1600', $0D, 0

;---------------------------------------------------------------------------
; emulator initialitation
;---------------------------------------------------------------------------

; init emulator -- called at boot time
fscbmint:
	.GLOBAL fscbmint
	
	phd			; save DP
	pea	#CBMFSP0	; set DP of cbm f.s.
	pld
	ldx	#0
?02:	stz	<zpstart,x
	stz	CBMFSW_START,x
	inx
	bne	?02
	lda	#$FF
	sta	linuse		; all free
	ldx	#mxchnls-1
?04:	sta	lintab,x	; all free
	dex
	bpl	?04
	lda	#cbmv2		; emulator compatibility
	sta	lsterr
	lda	#DR0SYS
	sta	sysbuf		; drive 0 system track cache
	jsr	?100
	sta	dirofs
	sty	dirbnk
	lda	#DR1SYS
	sta	sysbuf+1	; drive 1 system track cache
	jsr	?100
	sta	dirofs+1
	sty	dirbnk+1
	lda	#DR0CACHE
	sta	trkbuf		; drive 0 track cache
	jsr	?100
	sta	trkofs
	sty	trkbnk
	lda	#DR1CACHE
	sta	trkbuf+1	; drive 1 track cache
	jsr	?100
	sta	trkofs+1
	sty	trkbnk+1
	stz	tcache		; invalidate track cache
	stz	tcache+1
	lda	#DMAFREE0	; drive 0 write cache
	sta	wrtbuf
	jsr	?100
	sta	wrtofs
	sty	wrtbnk
	lda	#DMAFREE1	; drive 1 write cache
	sta	wrtbuf+1
	jsr	?100
	sta	wrtofs+1
	sty	wrtbnk+1
	stz	wcache		; invalidate write cache
	stz	wcache+1
	pld
	rts

; calc effective high pointer
; in:	A = dma buffer
; out:	Y = bank
;	A = high pointer
?100:	ldy	#DMABNK		; bank for buffer #00..#7F
	asl	a		; get high pointer
	bcc	?102
	iny			; next bank
?102:	rts

;---------------------------------------------------------------------------
; tables
;---------------------------------------------------------------------------

; command search table
; Rename Scratch New Exist Lock unlocK Append Transfer Move Quick-format
cmdtbl	.DB	'RSNELKATMQ'	; these call tagcmd routine
pcmd	.EQU	$ - cmdtbl	; limit of no parsed cmds
ldcmd	.EQU	pcmd + 1	; load dir cmd image
; Copy Validate Filecheck Init Duplicate 
	.DB	'CVFID'
ndcmd	.EQU	$ - cmdtbl	; limit for check drive
; Block-op User
	.DB	'BU'
ncmds	.EQU	$ - cmdtbl

; Block-op subcmds: Read, Write, Alloc, Free, Position 
cmdstb	.DB	'RWAFP'
ncmds2	.EQU	$ - cmdstb

; template mask for cmds
struct:
	.DB	%11011101	; Rename
	.DB	%00011100	; Scratch (=type is optional)
	.DB	%10011110	; New
	.DB	%11011110	; Exist
	.DB	%11011110	; Lock
	.DB	%11011110	; unlocK
	.DB	%11011001	; Append
	.DB	%11011101	; Transfer
	.DB	%11011101	; Move
	.DB	%10011110	; QuickF (like New)
	
	.DB	%01010001	; Copy (basic mask)
	.DB	%00011100	; load dir template

modlst	.DB	'RWAM'		; mode table
nmodes	.EQU	$ - modlst
tplst	.DB	'DSPULC'	; file type table
typlst	.DB	'DSPURC'	; del,seq,prog,user,rel,cbm
ntypes	.EQU	$ - typlst
tp1lst	.DB	'EERSEB'
tp2lst	.DB	'LQGRLM'

; cbm file name bad char's
badchr	.DB	':,=$"@'	; char's not allowed in file name
nbadch	.EQU	$ - badchr

fremsg	.DB	'blocks free.'
msglen	.EQU	$-fremsg       

; bit mask
bmask	.DB	$01, $02, $04, $08, $10, $20, $40, $80
wmask	.DW	$0001, $0002, $0004, $0008, $0010, $0020, $0040, $0080
	.DW	$0100, $0200

; command functions table
cjump:
	.DW	rename, scratch, newdsk, exist, lock, unlock
	.DW	append, transf, move, quickf, copy, vdate, fcheck
	.DW	initd, dupd, blkb, blku

; subcommand functions table
scjmp:
	.DW	blkrd, blkwr, blkalc, blkfree, blkpos

; read, write, append, load dir, open dir, open blk
opncmd:
	.DW	opnrd, opnwr, opnap, loaddir, opndir, opnblk

; error msg
erfmt:	.DB	'%02bu,%s,%02bu,%02bu', 0

ertbl:
	.DB	$00,	'Ok', 0						; 00
	.DB	$01,	'Files scratched', 0				; 01
	.DB	rdtrk,	'Track read error', 0				; 20
	.DB	badfmt,	'Bad disk format (or unformatted disk)', 0	; 21
	.DB	wrtrk,	'Track write error', 0				; 22
	.DB	rdsec,	'Read error', 0					; 24
	.DB	wrsec,	'Write error', 0				; 25
	.DB	wpon,	'Write protect on', 0				; 26
	.DB	badid,	'Disk ID mismatch', 0				; 29
	.DB	badsyn,	'General syntax error', 0			; 30
	.DB	badcmd,	'Invalid command', 0				; 31
	.DB	longln,	'Command line too long', 0			; 32
	.DB	badfn,	'Invalid file name', 0				; 33
	.DB	nofile,	'Missing file name', 0				; 34
	.DB	baddrv,	'Illegal drive number', 0			; 35
	.DB	badchn,	'Illegal channel number', 0			; 36
	.DB	nullln, 'Empty command string', 0			; 37
	.DB	notsam,	'Cannot rename across drives', 0		; 39
	.DB	flock,	'Locked file', 0				; 40
	.DB	fsplt,	'Write file not closed', 0			; 41
	.DB	bnotm,	'Unmatch blocks count', 0			; 42
	.DB	invlnk,	'Invalid file link', 0				; 43
	.DB	badlst,	'Wrong index in last block', 0			; 44
	.DB	filopn,	'File open', 0					; 60
	.DB	filnop,	'File not open', 0				; 61
	.DB	flntfd,	'File not found', 0				; 62
	.DB	flexst,	'File exists', 0				; 63
	.DB	mistyp,	'File type mismatch', 0				; 64
	.DB	badts,	'Illegal track or sector', 0			; 55
	.DB	systs,	'Illegal system track or sector', 0		; 67
	.DB	wrfil,	'Write only file', 0				; 68
	.DB	rdfil,	'Read only file', 0				; 69	
	.DB	nochnl,	'No channel available',0			; 70
	.DB	direrr,	'Directory error', 0				; 71
	.DB	dskful,	'Disk full', 0					; 72
	.DB	cbmv2,	'CBM DOS V10 1581 Emulator', 0			; 73
	.DB	nodriv,	'Drive not ready', 0				; 74
	.DB	opnchn,	'Channel is open',0				; 75
	.DB	nolinx,	'No logical index available',0			; 76
	.DB	fmter,	'Format error', 0				; 77
	.DB	ibmfmt,	'IBM formatted disk', 0				; 78
	.DB	syterr,	'System track read error', 0			; 79
	.DB	dirlnk,	'Corrupted directory link', 0			; 80
	.DB	bamcnt,	'Corrupted bam', 0				; 81
	.DB	badcat,	'Recursive concat', 0				; 82
	.DB	badtlk, 'Invalid talk command', 0			; 83
	.DB	badlsn, 'Invalid listen command', 0			; 84
	
	.DB	0	; end of table

uerr:
	.DB	'Unknow error', 0
